(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)

BeginPackage["Genealogies`Continua`",{"Statistics`ContinuousDistributions`",
			"Statistics`DiscreteDistributions`","Statistics`DataManipulation`",
      "Utilities`RandomNumbers`","Genealogies`Genealogies`"}];



<<Statistics`ContinuousDistributions`;







ContinuumVariables::usage=
    "ContinuumVariables lists all the variables that define the simulation \
results. Save['file',ContinuumVariables] saves the results in a large file.  \
These are GlobalContinuumVariables, IndividualContinuumVariables, and \
Individuals (which has arguments pop, box).";

GlobalContinuumVariables::usage=
    "GlobalContinuumVariables lists the global variables, which have the form \
NumberOfIndividuals[pop]";

IndividualContinuumVariables::usage=
    "GlobalContinuumVariables lists the individual variables, which have the \
form NumberOfIndividuals[pop]";



Genotype::usage=
    "Genotype[pop,ind] specifies the genotype of the individual.  Genotype\
\[Rule]f is an option for InitialiseContinuum which specifies the initial \
genotype,f[ind].";



Location::usage="Location[popln,i] gives the locations of individual i.";



Density::usage=
    "Density[popln,i] lists the perceived density around individual i.";



Fecundity::usage="Fecundity[popln,i] gives the fecundity of each individual.";



Mortality::usage="Mortality[popln,i] gives the mortality of each individual.";



BirthTime::usage="BirthTime[popln,i] lists the birth time of individual i.";



DeathTime::usage=
    "DeathTime[popln,i] lists the death time of individual i.  If an \
individual is still alive, DeathTime[popln,i] is \[Infinity].";



Ancestry::usage=
    "Ancestry[popln,i] lists the ancestry of each individual.  For the first \
individuals, Ancestry[] is set to {}.";



Offspring::usage="Offspring[popln,i] gives the offspring of individual i. ";



NumberOfIndividuals::usage=
    "NumberOfIndividuals[popln] is the number of extant individuals";



ExtantIndividuals::usage=
    "ExtantIndividuals[pop] lists the extant individuals.  \
ExtantIndividuals[pop,t] lists those individuals extant at time t.";



T::usage="T[popln] is the current time";



NetFecundity::usage="NetFecundity[popln] is the net fecundity";



NetMortality::usage="NetMortality[popln] is the net mortality";



TotalNumber::usage=
    "TotalNumber[popln] gives the total number of individuals who have ever \
lived.";



Individuals::usage=
    "Individuals[popln,X] lists the codes of the extant individuals in box X";



Box::usage=
    "Box[x,\[CapitalDelta]] gives the box in which x is found.  Boxes are of \
size \[CapitalDelta], and are numbered from {0,0} to {nboxes-1,nboxes-1} in \
two dimensions; similarly in other dimensions. ";



Boxes::usage=
    "Boxes[popln,i] lists the box in which individual i is found.  Boxes are \
of size \[CapitalDelta]. ";



DistanceSquared::usage=
    "DistanceSquared[x,y,R] gives the square of the distance between x and y, \
on a torus of size R. ";



\!\(\(MakeDistances::usage = \
\*"\"\<MakeDistances[y,{\!\(x\_1\),\[Ellipsis]},R,\!\(\[CapitalDelta]\^2\)] \
lists the squared distances from y to each of the neighbours at {\!\(x\_1\),\
\[Ellipsis]}.\>\"";\)\)



MakeDistanceList::usage=
    "MakeDistanceList[popln,R,\[CapitalDelta]] generates a list of all the \
distances between pairs of neighbouring extant individuals. Each distance \
appears only once. ";



InitialiseContinuum::usage=
    "InitialiseContinuum[popln,n,R,\[CapitalDelta],d,U,M,F] sets up a \
population, with uniformly distributed locations for n individuals in d \
dimensions, on a range R.  Box size is \[CapitalDelta].   U[x,x*,g,g*] is a \
function giving the 'density' at x due to an individual at x*, with genotypes \
g, g*, M[d,x,g] is a function giving the mortality as a function of the \
density, location and genotype, and F[d,x,g] is a function giving the \
fecundity as a function of density, location and genotype. Returns the net \
mortality and fecundity.  Genotype->f[ind,x] specifies the genotype; default \
is 0&.";



IterateContinuum::usage=
    "IterateContinuum[popln,R,\[CapitalDelta],U,M,F,D] iterates a population \
on a range R; the number of the individual who is born or dies is returned \
(negative if dead).  Box size is \[CapitalDelta]. The dispersal distribution \
is a random number generated by D[d,x,g], g being the genotype and d the \
local density.  U[x,x*,g,g*] is a function giving the 'density' at x due to \
an individual at x*, with genotypes g, g*,. M[d,x,g] is a function giving the \
mortality as a function of the density, location and genotype. F[d,x,g] does \
the same for fecundity. ";



Birth::usage=
    "Birth[pop,U,M,F,D][R,\[CapitalDelta]] adds a random newborn individual; \
returns the number of the new individual.";



Death::usage=
    "Death[pop,U,M,F][R,\[CapitalDelta]] deletes a random individual; returns \
minus the number of that individual..";



ExtractExtant::usage=
    "ExtractExtant[f,popln] extracts a list of f[popln,i] for those \
individuals who are still alive. ExtractExtant[f,popln,t] extracts a list of \
f[popln,i] for those individuals who are alive at time t";



FindPosition::usage=
    "FindPosition[popln,i] finds the position of this individual in the list \
of extant individuals";



\!\(\(Neighbours::usage = \*"\"\<Neighbours[popln,Box[],nboxes] lists those \
extant individuals in boxes of size \[CapitalDelta] which neighbour the given \
box. These neighbours can be no more than 2\!\(\@d\)\[CapitalDelta] away.  \
Includes the target individual at x.\>\"";\)\)



NeighbourArray::usage=
    "NeighbourArray[2] gives the array of displacements \
{{-1,-1},{-1,0},{-1,1},{0,-1},{0,0},{0,1},{1,-1},{1,0},{1,1}}; similarly in \
other dimensions.";



SampleCovariance::usage=
    "SampleCovariance[popln,R,{Dmax,\[Delta]D}] uses MakeDistanceList[] to \
find the distances between pairs of individuals; returns the number of \
distances in bins of size \[Delta]D. ";



InitialiseCovariance::usage=
    "InitialiseCovariance[{Dmax,\[Delta]D}] returns an empty array suitable \
for accumulating covariances. ";



CovarianceMidPoints::usage=
    "CovarianceMidPoints[{Dmax,\[Delta]D}] gives a list of the midpoints of \
the distance bins.";



\!\(\(SpatialCovariance::usage = \
\*"\"\<SpatialCovariance[hist,nbar,R,{\!\(D\_max\),\[Delta]D},dims] gives a \
list of the covariance in density as a function of distance.  hist gives the \
distribution of distances, in bins of size \[Delta]D, and nbar the mean \
density.\>\"";\)\)





MostRecentCommonAncestor::usage=(MostRecentCommonAncestor::usage)<>
      "Applies to a continuum simulation as well as to a rooted genealogy.";



\!\(\(Ancestors::usage = \((Ancestors::usage)\) <> \
\*"\"\<Ancestors[p,{\!\(i\_1\),\!\(i\_2\),\[Ellipsis]}] lists the ancestors \
of individuals {\!\(i\_1\),\!\(i\_2\),\[Ellipsis]}. Ancestors[p,i] gives the \
ancestor of individual i.\>\"";\)\)



Descendants::usage=(Descendants::usage)<>
      "Descendants[p,i,s] gives the descendants of individual i who are \
members of the set s.";



\!\(\(MakeGenealogy::usage = \
\*"\"\<MakeGenealogy[popln,{\!\(i\_1\),\!\(i\_2\),\[Ellipsis]}] constructs \
the genealogy which relates individuals {\!\(i\_1\),\!\(i\_2\),\[Ellipsis]}.  \
NodeFunction\[Rule]f inserts information f[j,x,g] at each node, j; this must \
return a list.(x is the location, and g the genotype)\>\"";\)\)





\!\(\(SampleIndividuals::usage = \*"\"\<SampleIndividuals[popln,{\!\(x\_1\),\
\[Ellipsis]},n,\!\(\[Sigma]\^2\),R,\[CapitalDelta]] samples n individuals, \
without replacement, from around each of the locations  \!\(x\_i\).  The \
probability of sampling falls as a Gaussian around x, with variance \!\(\
\[Sigma]\^2\).  If \!\(\[Sigma]\^2\) is set to zero, the nearest n \
individuals are sampled.  To save time, only those individuals within \
\[CapitalDelta] of the target point are counted: if there are too few in this \
region, a smaller sample is returned.  Must choose \[CapitalDelta]>3\[Sigma], \
say.\>\"";\)\)



Begin["Genealogies`Continua`Private`"];





GlobalContinuumVariables={NumberOfIndividuals,ExtantIndividuals,T,
      NetFecundity,NetMortality,TotalNumber};

IndividualContinuumVariables={Location,Density,Fecundity,Mortality,BirthTime,
      DeathTime,Ancestry,Offspring,Boxes,Genotype};

ContinuumVariables=
    Join[GlobalContinuumVariables,IndividualContinuumVariables,{Individuals}];



Box[x_,\[CapitalDelta]_]:=Quotient[#,\[CapitalDelta]]&/@x;



\!\(\(DistanceSquared[x_, y_, R_] := 
      Plus @@ \(\((Mod[x - y + R/2, R] - R/2)\)\^2\);\)\)



MakeDistances[xx_,nx_,R_,\[CapitalDelta]\[CapitalDelta]_]:=
	
    Select[DistanceSquared[#,xx,R]&/@nx,(#<\[CapitalDelta]\[CapitalDelta])&];



\!\(\(MakeDistanceList[pop_, R_, \[CapitalDelta]_] := \n\t
      Module[{bx, i, locs = ExtractExtant[Location, pop], inds, nx, 
          n = NumberOfIndividuals[
              pop], \[CapitalDelta]\[CapitalDelta] = \[CapitalDelta]\^2, 
          nb = Quotient[R, \[CapitalDelta]], done = {}, 
          dims}, \n\t\t\ \ dims = 
          Length[First[locs]]; \n\t\t\ \ bx = \(Box[#, \[CapitalDelta]] &\) /@ 
            locs; inds[_] := {}; \n\t\t\ \ Do[
          AppendTo[inds[bx\[LeftDoubleBracket]i\[RightDoubleBracket]], 
            i], {i, n}]; \n\t\t\ \ Table[AppendTo[done, i]; 
          nx = Complement[
              Flatten[\(inds[
                      Mod[bx\[LeftDoubleBracket]i\[RightDoubleBracket] + #, 
                        nb]] &\) /@ NeighbourArray[dims]], 
              done]; \n\t\t\t\@MakeDistances[locs\[LeftDoubleBracket]i\
\[RightDoubleBracket], locs\[LeftDoubleBracket]nx\[RightDoubleBracket], R, \
\[CapitalDelta]\[CapitalDelta]], {i, n}]];\)\)



Options[InitialiseContinuum]={Genotype\[Rule](0&)};

\!\(\(InitialiseContinuum[p_, n_Integer, R_, \[CapitalDelta]_, d_Integer, U_, 
        M_, F_, opts___Rule] := \n\t
      Module[{nb = Quotient[R, \[CapitalDelta]], i, xi, 
          nx, \[CapitalDelta]\[CapitalDelta] = \[CapitalDelta]\^2, dens, 
          nl, \[IndentingNewLine]ff = \(Genotype /. {opts}\) /. 
              Options[InitialiseContinuum]}, \[IndentingNewLine]Individuals[
            p, _] := {}; NumberOfIndividuals[p] = n; TotalNumber[p] = n; 
        T[p] = 0; 
        Do[Location[p, i] = Table[Random[Real, R], {d}], {i, 
            n}]; \ \[IndentingNewLine]ExtantIndividuals[p] = 
          Range[n]; \[IndentingNewLine]Do[\[IndentingNewLine]BirthTime[p, 
              i] = 0; DeathTime[p, 
              i] = \[Infinity]; \[IndentingNewLine]Ancestry[p, i] = {}; 
          Offspring[p, i] = {}; \[IndentingNewLine]Genotype[p, i] = 
            ff[i, Location[p, i]]; \[IndentingNewLine]Boxes[p, i] = 
            Box[Location[p, i], \[CapitalDelta]]; \[IndentingNewLine]AppendTo[
            Individuals[p, Boxes[p, i]], i];, \[IndentingNewLine]{i, 
            n}]; \ \[IndentingNewLine]Do[\[IndentingNewLine]nl = 
            DeleteCases[Neighbours[p, Boxes[p, i], nb], 
              i]; \[IndentingNewLine]\ 
          dens = \(Density[p, i] = 
              Plus @@ MapThread[
                  U[Location[p, i], #1, 
                      Genotype[p, i], #2] &, {\(Location[p, #] &\) /@ 
                      nl, \(Genotype[p, #] &\) /@ 
                      nl}]\); \[IndentingNewLine]Fecundity[p, i] = 
            F[dens, Location[p, i], 
              Genotype[p, i]]; \[IndentingNewLine]Mortality[p, i] = 
            M[dens, Location[p, i], Genotype[p, i]];, {i, 
            n}]; \[IndentingNewLine]NetFecundity[p] = 
          Sum[Fecundity[p, i], {i, n}]; \ \[IndentingNewLine]NetMortality[
            p] = Sum[Mortality[p, i], {i, n}]; \[IndentingNewLine]{\ 
          NetMortality[p], NetFecundity[p]}];\)\)



\!\(\(IterateContinuum[p_, R_, \[CapitalDelta]_, U_, M_, F_, 
        D_] := \n\t\((T[p] += 
          Random[ExponentialDistribution[
              NetMortality[p] + NetFecundity[p]]]; \n\t
        If[Random[] > 
            NetMortality[p]\/\(NetMortality[p] + NetFecundity[p]\), \n\t\
\(Birth[p, U, M, F, D]\)[R, \[CapitalDelta]], \(Death[p, U, M, F]\)[
            R, \[CapitalDelta]]])\);\)\)



\!\(\(\(Birth[p_, U_, M_, F_, Disp_]\)[
        R_, \[CapitalDelta]_] := \[IndentingNewLine]Module[{i, j, k, xi, yi, 
          gi, bx, nb = 
            Quotient[
              R, \[CapitalDelta]], \[CapitalDelta]\[CapitalDelta] = \
\[CapitalDelta]\^2, nx, nn, dens, d, dd, yt = {}, gt = {}, 
          ng}, \ \[IndentingNewLine]NumberOfIndividuals[p] += 1; 
        TotalNumber[p] += 1; nn = TotalNumber[p]; 
        k = RandomListCompiled[
              1, \(Fecundity[p, #] &\) /@ \
ExtantIndividuals[p]\/NetFecundity[p]] // 
            First; \[IndentingNewLine]i = \(ExtantIndividuals[
              p]\)\[LeftDoubleBracket]
            k\[RightDoubleBracket]; \[IndentingNewLine]BirthTime[p, nn] = 
          T[p]; DeathTime[p, nn] = \[Infinity]; 
        ng = \(Genotype[p, nn] = Genotype[p, i]\); \[IndentingNewLine]xi = 
          Location[p, i]; d = Length[xi]; xi += Disp[Density[p, i], xi, ng]; 
        xi = \(Mod[#, R] &\) /@ xi; 
        bx = \(Boxes[p, nn] = Box[xi, \[CapitalDelta]]\); 
        nx = Neighbours[p, bx, nb]; 
        AppendTo[Individuals[p, bx], nn]; \ \ Location[p, nn] = xi; \ 
        Scan[\((yi = Location[p, #]; dd = DistanceSquared[xi, yi, R]; 
              If[dd < \[CapitalDelta]\[CapitalDelta], \
\[IndentingNewLine]AppendTo[yt, yi]; gi = Genotype[p, #]; 
                AppendTo[gt, gi]; \[IndentingNewLine]Density[p, #] += 
                  U[yi, xi, gi, ng]; NetMortality[p] -= Mortality[p, #]; 
                NetFecundity[p] -= 
                  Fecundity[p, #]; \ \ NetMortality[
                    p] += \((Mortality[p, #] = 
                      M[Density[p, #], yi, gi])\); \ \ NetFecundity[
                    p] += \((Fecundity[p, #] = 
                      F[Density[p, #], yi, 
                        gi])\)];)\) &, \[IndentingNewLine]nx]; \
\[IndentingNewLine]Density[p, nn] = \(dens = 
            Plus @@ MapThread[
                U[xi, #1, ng, #2] &, {yt, 
                  gt}]\); \[IndentingNewLine]NetFecundity[
            p] += \((Fecundity[p, nn] = 
              F[dens, xi, ng])\); \[IndentingNewLine]NetMortality[
            p] += \((Mortality[p, nn] = 
              M[dens, xi, ng])\); \[IndentingNewLine]AppendTo[
          ExtantIndividuals[p], 
          TotalNumber[p]]; \[IndentingNewLine]Ancestry[p, nn] = 
          Prepend[Ancestry[p, i], i]; \[IndentingNewLine]AppendTo[
          Offspring[p, i], 
          TotalNumber[p]]; \[IndentingNewLine]Offspring[p, 
            nn] = {}; \[IndentingNewLine]\(+nn\)];\)\)



\!\(\(\(Death[p_, U_, M_, F_]\)[
        R_, \[CapitalDelta]_] := \[IndentingNewLine]Module[{i, j, k, xi, yi, 
          bx, nb = 
            Quotient[
              R, \[CapitalDelta]], \[CapitalDelta]\[CapitalDelta] = \
\[CapitalDelta]\^2, nx, gi, gx}, \[IndentingNewLine]NumberOfIndividuals[p] -= 
          1; \[IndentingNewLine]k = 
          RandomListCompiled[
              1, \(Mortality[p, #] &\) /@ \
ExtantIndividuals[p]\/NetMortality[p]] // 
            First; \[IndentingNewLine]i = \(ExtantIndividuals[
              p]\)\[LeftDoubleBracket]k\[RightDoubleBracket]; 
        xi = Location[p, i]; \[IndentingNewLine]DeathTime[p, i] = 
          T[p]; \[IndentingNewLine]bx = 
          Box[xi, \[CapitalDelta]]; \[IndentingNewLine]Individuals[p, bx] = 
          DeleteCases[Individuals[p, bx], i]; \[IndentingNewLine]nx = 
          DeleteCases[Neighbours[p, bx, nb], i]; \[IndentingNewLine]gx = 
          Genotype[p, 
            i]; \[IndentingNewLine]Scan[\[IndentingNewLine]\((yi = 
                Location[p, #]; 
              dd = DistanceSquared[xi, yi, R]; \[IndentingNewLine]If[
                dd < \[CapitalDelta]\[CapitalDelta], \[IndentingNewLine]gi = 
                  Genotype[p, #]; 
                Density[p, #] -= 
                  U[yi, xi, gi, gx]; \[IndentingNewLine]NetMortality[p] -= 
                  Mortality[p, #]; 
                NetFecundity[p] -= 
                  Fecundity[p, #]; \[IndentingNewLine]NetMortality[
                    p] += \((Mortality[p, #] = 
                      M[Density[p, #], yi, 
                        gi])\); \[IndentingNewLine]NetFecundity[
                    p] += \((Fecundity[p, #] = 
                      F[Density[p, #], yi, 
                        gi])\)];)\) &, \[IndentingNewLine]nx]; \n\t
        ExtantIndividuals[p] = Delete[ExtantIndividuals[p], k]; \n\t
        NetMortality[p] -= Mortality[p, i]; 
        NetFecundity[p] -= Fecundity[p, i]; \[IndentingNewLine]\(-i\)];\)\)



ExtractExtant[f_,pop_]:=f[pop,#]&/@ExtantIndividuals[pop];
ExtractExtant[f_,pop_,t_]:=f[pop,#]&/@ExtantIndividuals[pop,t]



ExtantIndividuals[pop_,t_]:=
    
    Select[Range[TotalNumber[pop]],
      BirthTime[pop,#]\[LessEqual]t<DeathTime[pop,#]&];



FindPosition[pop_,i_Integer]:=
    Position[ExtantIndividuals[pop],i]\[LeftDoubleBracket]1,
      1\[RightDoubleBracket];



Neighbours[pop_,bx_,nb_]:=
		
    Flatten[Individuals[pop,Mod[bx+#,nb]]&/@NeighbourArray[Length[bx]]];



NeighbourArray[0]={{}};
NeighbourArray[d_Integer]:=NeighbourArray[d]=Module[{i},
			Flatten[Table[Append[#,i]&/@NeighbourArray[d-1],{i,-1,1}],1]];



SampleCovariance[p_,R_,{dm_,\[Delta]d_}] :=
		
    BinCounts[Flatten[MakeDistanceList[p,R,dm]],{0,dm,\[Delta]d}];



InitialiseCovariance[{dm_,\[Delta]d_}] :=
	Array[0&,Round[dm/\[Delta]d]];



\!\(\(CovarianceMidPoints[{Dmax_, \[Delta]D_}] := 
      Module[{z}, 
        Table[z, {z, \[Delta]D\/2, Dmax - \[Delta]D\/2, \[Delta]D}]];\)\)



SpatialCovariance::badDimensions=
    "SpatialCovariance is not defined for more than 2 dimensions";

\!\(\(SpatialCovariance[h_, nb_, R_, {dm_, \[Delta]D_}, d_] := 
      Module[{ne}, \[IndentingNewLine]ne = 
          Switch[d, \[IndentingNewLine]1, \[IndentingNewLine]\(2  h\)\/\(nb\ \
\(R\^2\) \[Delta]D\), \[IndentingNewLine]2, \[IndentingNewLine]\(\(2  
                    h\)\/\(nb\ \(R\^2\) \[Delta]D\)\) 
              1\/\(2  \[Pi]\ \[Delta]D\ CovarianceMidPoints[{dm, \
\[Delta]D}]\), \[IndentingNewLine]_, \[IndentingNewLine]Message[
              SpatialCovariance::badDimensions]]; \[IndentingNewLine]nb \((ne \
- nb)\)];\)\)





MostRecentCommonAncestor[p_,i_,j_]:=
	
    Last[Prepend[Intersection[Ancestry[p,i],Ancestry[p,j]],0]];



Ancestors[p_,i_Integer]:=Last[Ancestry[p,i]];
Ancestors[p_,s_List]:=Union[Ancestors[p,#]&/@s];



Descendants[p_,i_,s_List]:=Select[s,MemberQ[Ancestry[p,#],i]&];



Options[MakeGenealogy]={NodeFunction\[Rule]({}&)};

MakeGenealogy[p_,{i_Integer},opts___Rule]:=
	
    Module[{nf=NodeFunction/.{opts}/.Options[MakeGenealogy],
        aa=Ancestors[p,i]},
			Node [aa,nf[aa],{Node[i,nf[i,Location[p,i],Genotype[p,i]],{}]}]];

MakeGenealogy[p_,{s__Integer,i_Integer},opts___Rule]:=
	
    Module[{tr=MakeGenealogy[p,{s},opts],nodes,leaves,mrca,nn,pn,
        nf=NodeFunction/.{opts}/.Options[MakeGenealogy]},
		If[First[tr]!=Ancestors[p,i],
		tr\[LeftDoubleBracket]1\[RightDoubleBracket]=0];
		  nodes=CollapseGenealogy[tr];
		  leaves=Flatten[CollapseGenealogy[tr,Node->False]];
		  mrca=MostRecentCommonAncestor[p,i,#]&/@leaves;nn=Max[mrca];
		  If[MemberQ[Flatten[nodes],nn],
				(* add to an existing node*)
				
        AddGenealogy[tr,Node[i,nf[i,Location[p,i],Genotype[p,i]],{}],nn,
          nn,{}],
				(* insert a new bifurcating node *)
				
        pn=Extract[leaves,
              Position[mrca,nn]]\[LeftDoubleBracket]1\[RightDoubleBracket];
				AddGenealogy[tr,Node[i,nf[i,Location[p,i],Genotype[p,i]],{}],pn,nn,
          nf[nn]]]];









\!\(\(SampleIndividuals[pop_, xl_List, n_Integer, v_, 
        R_, \[CapitalDelta]_] := \n\t
      Module[{bx, i, j, inds, 
          nx, \[CapitalDelta]\[CapitalDelta] = \[CapitalDelta]\^2, 
          nb = Quotient[R, \[CapitalDelta]], 
          na = NeighbourArray[Length[First[xl]]], wl, ns, ps, 
          locs = ExtractExtant[Location, 
              pop]}, \n\t\tbx = \(Box[#, \[CapitalDelta]] &\) /@ locs; 
        inds[_] := {}; \n\t\tDo[
          AppendTo[inds[bx\[LeftDoubleBracket]i\[RightDoubleBracket]], 
            i], {i, NumberOfIndividuals[pop]}]; \n\t\tTable[\n\t\t\tnx = 
            Flatten[\(inds[
                    Mod[Box[
                          xl\[LeftDoubleBracket]
                            j\[RightDoubleBracket], \[CapitalDelta]] + #, 
                      nb]] &\) /@ 
                na]; \n\t\t\twl = \(DistanceSquared[#, 
                  xl\[LeftDoubleBracket]j\[RightDoubleBracket], R] &\) /@ 
              locs\[LeftDoubleBracket]nx\[RightDoubleBracket]; \n\t\t\tns = 
            Min[Length[wl], n]; \n\t\t\tps = 
            If[v > 0, \n\t\t\t\tRandomList[ns, Exp[\(-\(wl\/\(2  v\)\)\)], 
                Replace \[Rule] False, Compiled \[Rule] True], 
              Take[\(\(Position[wl, #]\)\[LeftDoubleBracket]1, 
                      1\[RightDoubleBracket] &\) /@ Sort[wl], 
                ns]]; \n\t\t\(ExtantIndividuals[pop]\)\[LeftDoubleBracket]
            nx\[LeftDoubleBracket]
              ps\[RightDoubleBracket]\[RightDoubleBracket], {j, 
            Length[xl]}]];\)\)



End[];
EndPackage[];