(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)

BeginPackage["Multilocus`EstimatingD`",
	{"Algebra`InequalitySolve`","Utilities`SetManipulation`",
      "Utilities`Cumulants`","Statistics`DescriptiveStatistics`",
      "Statistics`MultiDescriptiveStatistics`",
      "Statistics`ContinuousDistributions`","Statistics`DataManipulation`",
      "Graphics`Graphics`","Utilities`RandomNumbers`",
      "Multilocus`DataManipulation`"}];



Off[General::spell1,General::spell];





\!\(\(RandomMating::usage = \*"\"\<RandomMating[c] simplifies the moments c[] \
on the assumption of random mating between diploids.  For example,  c[{i,\!\(\
\(i\^*\)\),\!\(\(j\&^\^*\)\),\!\(k\&^\^\[Dagger]\)}]/.RandomMating[c] gives \
c[{i,\!\(\(i\^*\)\)}] c[{\!\(\(j\&^\^*\)\),\!\(k\&^\^\[Dagger]\)}]\>\"";\)\)



Recombined::usage=
    "Recombined[c[M],r] gives the value of c[M] after recombination; it is a \
sum over all partitions of M. Note that r[{i},{j}], r[{j},{i}] etc are \
grouped together as a single coefficient.  Recombined[c[M],r,d,i] gives the \
value of c[M] after recombination, with an additive modifier of effect d[S,i] \
at locus i.";



\!\(\(ChangeSex::usage = \*"\"\<ChangeSex[{i,\!\(\(j\^*\)\)}] returns \
{\!\(\(i\^*\)\),j}.  Obsolete.\>\"";\)\)



ShiftCentre::usage=
    "ShiftCentre[c[S],\[CapitalDelta]p] gives c[S], relative to a new centre \
at p-\[CapitalDelta]p";



\!\(\(RandomUnionObsolete::usage = \*"\"\<RandomUnionObsolete[c] simplifies \
the moments c[] on the assumption of random union of gametes.  For example,  \
c[{i, \!\(\(i\^*\)\), \!\(\(j\^*\)\), \
\!\(k\^\[Dagger]\)}]/.RandomUnionObsolete[c] gives c[{i, \!\(k\^\[Dagger]\)}] \
c[{\!\(\(i\^*\)\), \!\(\(j\^*\)\)}]\>\"";\)\)





Diploid::usage="Diploid is an option for MomentFromG. ";



\!\(\(MomentFromG::usage = \*"\"\<MomentFromG[{i,j},g,p,S] gives the moment \
c[{i,j}], relative to allele frequencies p[i], as a function of gamete \
frequencies g[]; S is the complete set of loci. \
MomentFromG[{i,\!\(\(j\^*\)\)},g,p,S,Ploidy\[Rule]Diploid] allows for diploid \
genotype frequencies.\>\"";\)\)



\!\(\(MomentReduced::usage = \*"\"\<MomentReduced[U,{cw,cb},\[Delta]p] \
returns moments in terms of the within- and between-genome associations of \
order n.  For example,  MomentReduced[{i,j,k},{cw,cb},\[Delta]p] gives cw[3]\
\[Delta]p[i]\[Delta]p[j]\[Delta]p[k]; \
MomentReduced[{i,j,k*},{cw,cb},\[Delta]p] gives cb[3]\[Delta]p[i]\[Delta]p[j]\
\[Delta]p[k].  MomentReduced[{kw,kb},{jU,jV}] returns an expression for the \
moment c[U,V*] in terms of the cumulants within- and between-genomes kw, kb. \
For example, MomentReduced[{kw,kb},{2,2}] is 2kb[2\!\(\(]\^2\)\)+kb[4]+kw[2\!\
\(\(]\^2\)\).  Stores results.  MomentReduced[n][{cw[2]..cb[2]..}] is a \
compiled version that returns the matrix of moments.\>\"";\)\)



\!\(\(CumulantReduced::usage = \*"\"\<CumulantReduced[{cw,cb},{jU,jV}] \
returns an expression for the cumulant \[Kappa][U,V*] in terms of the moments \
within- and between-genomes {cw,cb}. For example, \
CumulantReduced[{cw,cb},{2,2}] is -2cb[2\!\(\(]\^2\)\)+cb[4]-cw[2\!\(\(]\^2\)\
\).  Stores results. \>\"";\)\)



HaploidGenotypeFrequency::usage=
    "HaploidGenotypeFrequency[X,c,p,S] gives an expression for g[X] in terms \
of the moments c[] and allele frequencies p[]. \
HaploidGenotypeFrequency[nloci][p1,..pn,c[{1,2}]...] stores a compiled \
version of g[{1,1..},..], which takes as arguments the n allele frequencies \
and 2^n-n-1 moments.  HaploidGenotypeFrequency[X,c,p] uses this to find the \
frequency of genotype X; c and p must then be given as lists of numbers";



PossibleDiploidGenotypes::usage=
    "PossibleDiploidGenotypes[{0,1,0}] gives the list of actual genotypes, \
{{{0,1,0},{0,0,0}},{{{0,0,0},{0,1,0}}}, consistent with this diploid \
genotype. ";



DiploidGenotypeFrequency::usage=
    "DiploidGenotypeFrequency[{1,2,1},c,p,{i,j,k}] gives the frequency of \
diploid genotype {1,2,1} in terms of the moments and allele frequencies, c[], \
p[].  DiploidGenotypeFrequency[{1,2,1},c,p] uses the compiled version, where \
c and p are lists of numbers; c lists the moments in the same order as \
DiploidSubsets[]";



\!\(\(DiploidGenotypeFrequencyReduced::usage = \
\*"\"\<DiploidGenotypeFrequencyReduced[{0,2,0,0,1},{\!\(k\_w\),\!\(k\_b\)},\
\[Delta]p,p,S] gives the frequency of the diploid genotype using simplified \
cumulants \!\(k\_w\)[], \!\(k\_b\)[]. \>\"";\)\)



\!\(\(FullGenotypeFrequencyReduced::usage = \
\*"\"\<FullGenotypeFrequencyReduced[{X,\!\(\(X\^*\)\)},{\!\(k\_w\),\!\(k\_b\)}\
,\[Delta]p,p,S] gives the frequency of the full diploid genotype {X, \
\!\(\(X\^*\)\)}in terms of the reduced set of cumulants \
{\!\(k\_w\),\!\(k\_b\)}. FullGenotypeFrequencyReduced[X,k,\[Delta]p,p,S] \
gives haploid genotype freqiuencies.\>\"";\)\)



DiploidGenotypeFrequencyArguments::usage=
    "DiploidGenotypeFrequencyArguments[nloci][p1,..,q1,..,cw[2],..cb[2]..] \
gives an array listing all the arguments that must be supplied to \
FullGenotypeFrequencyTable[nloci,1&][] to give the genotype frequencies.";



\!\(\(FullGenotypeFrequencyTable::usage = \
\*"\"\<FullGenotypeFrequencyTable[{{0,1,0},{1,0,1}},{\!\(k\_w\), \!\(k\_b\)},\
\[Delta]p,p,{i,j,k}] gives the diploid genotype frequency in terms of \
cumulants \!\(k\_w\)[2].., \!\(k\_b\)[2]..  Fast method which works by \
storing the general expression for {{1,1,1},{1,1,1}} in terms of $p, \
$\[Delta]p, and then permuting it. FullGenotypeFrequencyTable[,{\!\(k\_w\), \
\!\(k\_b\)},{i,j,k}] stores the generic solution, and \
FullGenotypeFrequencyTable[nloci] the compiled version; this is called as \
FullGenotypeFrequencyTable[nl][p1,...,p1*...,\[Delta]p1,..,\[Delta]p1*..,cw2..\
.,cb2...], with 7nl-2 arguments.  FullGenotypeFrequencyTable[nloci,Symmetric\
\[Rule]True] assumes p=p* and \[Delta]p=1 .  \
FullGenotypeFrequencyTable[{{0,1,0},{1,0,1}},{\!\(k\_w\), \
\!\(k\_b\)},\[Delta]p,p] calls the compiled version \
FullGenotypeFrequencyTable[3]. FullGenotypeFrequencyTable[{{0,1,0},{1,0,1}}] \
is itself compiled; assumes \[Delta]p=1, and takes arguments p,q,,\!\(k\_w\), \
\!\(k\_b\).  FullGenotypeFrequencyTable[nloci,1&] takes arguments [{p1,..},{\
\[Delta]p1..},{c..}] but is slower. FullGenotypeFrequencyTable[nloci,Integer\
\[Rule]True] is fastest: assumes \[Delta]p integer. \>\"";\)\)



\!\(\(DiploidGenotypeFrequencyTable::usage = \
\*"\"\<DiploidGenotypeFrequencyTable[{0,2,0},{\!\(k\_w\),\!\(k\_b\)},\[Delta]\
p,p,S] gives the diploid genotype frequency in terms of cumulants \
\!\(k\_w\)[2].., \!\(k\_b\)[2]..  Uses FullGenotypeFrequencyTable[].  Also \
can use DiploidGenotypeFrequencyTable[{0,2,0},{\!\(k\_w\),\!\(k\_b\)},\[Delta]\
p,p], which uses the compiled version.  \
DiploidGenotypeFrequencyTable[{0,2,0},\[Delta]p][p[1]..,\!\(k\_w\)[2].., \
\!\(k\_b\)[2]...] is fully compiled.  DiploidGenotypeFrequencyTable[nloci,\
\[Delta]p][p[1]..,\!\(k\_w\)[2].., \!\(k\_b\)[2]...] is fully compiled; \
returns the complete vector of genotype frequencies. \>\"";\)\)



GenotypeFrequencyFast::usage=
    "GenotypeFrequencyFast[3][{{0,1,0},{1,1,1}},{p1..},{\[Delta]p1..},\
MomentReduced[3][cl]] is a compiled function which calculates a specific \
genotype frequency using the matrix method.  Surprisingly, no faster than \
FullGenotypeFrequencyTable[3,int].  ";



GenotypeFrequencyFastVector::usage=
    "GenotypeFrequencyFastVector[nloci][{p1..},{\[Delta]p1,..},{cw[1]..cb[1]....\
}] is a compiled function which calculates the 16 by 16 array of genotype \
frequencies as \
Matrix\[CapitalGamma][n][p,\[Delta]p].MomentReduced[n][cl].Matrix\
\[CapitalGamma][n][p,\[Delta]p].  \
GenotypeFrequencyFastVector[{p1..},{\[Delta]p1,..},{cw[1]..cb[1]....},nloci] \
is not compiled";



SignMask::usage=
    "SignMask[X] stores the signs associated with the moments of this \
genotype";



\!\(\(Moment::usage = \((Moment::usage)\) <> \*"\"\<  \
Moment[\[Kappa],{jU,jV}] returns an expression for the moment c[U,V*] in \
terms of the cumulants within- and between-genomes \!\(\[Kappa]\_\(j, \\\\\\\ \
\(\(\\\\\\\\\)\(\\\\\\\ \)\(k\)\)\)\). For example, Moment[\[Kappa],{2,2}] is \
2\[Kappa][1,1\!\(\(]\^2\)\)+\[Kappa][2,2]+\[Kappa][0,2\!\(\(]\^2\)\).  Stores \
results.  Moment[n][{{\!\(\[Kappa]\_\(0, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \
\)\(0\)\)\)\),\[Ellipsis]},\[Ellipsis]}] is a compiled version that returns \
the matrix of moments.  Moment[U,c,\[Delta]p] returns moments in terms of the \
matrix of within- and between-genome associations, \!\(c\_\(j, \\\\\\\ \(\(\\\
\\\\\\\)\(\\\\\\\ \)\(k\)\)\)\).  For example,  Moment[{i,j,k},c,\[Delta]p] \
gives c[3,0]\[Delta]p[i]\[Delta]p[j]\[Delta]p[k]; \
Moment[{i,j,k*},c,\[Delta]p] gives c[2,1]\[Delta]p[i]\[Delta]p[j]\[Delta]p[\!\
\(\(k\^*\)\)]. \>\"";\)\)



\!\(\(Cumulant::usage = \((Cumulant::usage)\) <> \*"\"\<  Cumulant[c,{jU,jV}] \
returns an expression for the cumulant \[Kappa][U,V*] in terms of the within- \
and between-genome moments.   For example, Cumulant[c,{2,2}] is \
-2c[1,1\!\(\(]\^2\)\)+c[2,2]-cw[0,2\!\(\(]\^2\)\).  Stores results.  \
Cumulant[n][{{\!\(c\_\(0, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(0\)\)\)\),\
\[Ellipsis]},\[Ellipsis]}] is a compiled version that returns the matrix of \
cumulants.  Cumulant[U,\[Kappa],\[Delta]p] returns cumulants in terms of the \
matrix of within- and between-genome associations, \!\(\[Kappa]\_\(j, \\\\\\\ \
\(\(\\\\\\\\\)\(\\\\\\\ \)\(k\)\)\)\).  For example,  Cumulant[{i,j,k},\
\[Kappa],\[Delta]p] gives \[Kappa][3,0]\[Delta]p[i]\[Delta]p[j]\[Delta]p[k]; \
Cumulant[{i,j,k*},\[Kappa],\[Delta]p] gives \
\[Kappa][2,1]\[Delta]p[i]\[Delta]p[j]\[Delta]p[\!\(\(k\^*\)\)].\>\"";\)\)



AlleleFrequencyPermutations::usage=
    "AlleleFrequencyPermutations[{p1..},n] gives the matrix of permuted p's & \
q's for all genotypes: {{q..q},..{p..p}}. \
AlleleFrequencyPermutations[n][{p1..}] is a compiled version.";



\[Delta]AlleleFrequencyPermutations::usage=
    "\[Delta]AlleleFrequencyPermutations[\[Delta]p,n] gives the matrix of \
permuted \[Delta]p's for all genotypes: {{-\[Delta]p\[Ellipsis]},..{\[Delta]p\
\[Ellipsis]}}.  \[Delta]AlleleFrequencyPermutations[n][{\[Delta]p1..}] is a \
compiled version.";



\!\(\(Matrix\[CapitalGamma]::usage = \*"\"\< \
Matrix\[CapitalGamma][{\!\(p\_1\)\[Ellipsis]},{\!\(\[Delta]p\_1\),\[Ellipsis]}\
,n] gives the matrix of coefficients, constructed from \
AlleleFrequencyPermutations[], \[Delta]AlleleFrequencyPermutations[].  Matrix\
\[CapitalGamma][{p1\[Ellipsis]},n] gives the matrix of coefficients, with \
\[Delta]p assumed 1.  Matrix\[CapitalGamma][n][{\!\(p\_1\)\[Ellipsis]},{\!\(\
\[Delta]p\_1\),\[Ellipsis]}] is a compiled version.\>\"";\)\)



PloidyWeightList::usage=
    "PloidyWeightList[n] lists the factor which weights each diploid \
frequency: 1 for homozygotes, 2 otherwise.";



PositionsList::usage=
    "PositionsList[n] gives the positions in the matrix of genotype \
frequencies of the elements needed to give the diploid frequencies.";



\!\(\(PositionsMatrix::usage = \*"\"\<PositionsMatrix[n] constructs a \
\!\(3\^n\)\[Times]\!\(2\^\(2\\\\\\\\\\\\\\\ \\\\\\\\\\\\\\\ n\)\) matrix of \
0, 1, 2\[Ellipsis]'s that corresponds to PositionsList[n].  Only feasible for \
n\[LessEqual]6. Includes the weighting defined by PloidyWeightList[n], so \
that PositionsMatrix[n].Flatten[g] gives the observed diploid \
frequencies.\>\"";\)\)



\!\(\(GenotypeFrequencyConvert::usage = \*"\"\<GenotypeFrequencyConvert[gM,n] \
converts the \!\(2\^n\) by \!\(2\^n\) matrix of genotype frequencies to the \
\!\(3\^n\) vector of observed diploid frequencies.  \>\"";\)\)



\!\(\(StandardSet::usage = \*"\"\<StandardSet[nloci] gives a standard set of \
dummy variables {{cw$1..},{cb$1..}} to replace cw[], cb[]; there are nloci-1 \
variables cw[], and 2nloci-1 variables cb[].  StandardSet[nloci,f] gives n \
variables of the form {f$1..}.  StandardSet[nloci,f,All] gives \
\!\(2\^nloci\)-nloci-1 variables of the form {f$1..}.\>\"";\)\)



\!\(\(DiploidGenotypeFrequencyList::usage = \
\*"\"\<DiploidGenotypeFrequencyList[{\!\(p\_1\),\[Ellipsis],\!\(p\_n\)},{{\!\(\
c\_\(0, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(0\)\)\)\),\!\(c\_\(1, \\\\\\\ \
\(\(\\\\\\\\\)\(\\\\\\\ \)\(0\)\)\)\),\[Ellipsis]},\[Ellipsis]}] calculates \
the matrix of \!\(2\^n\)\[Times]\!\(2\^n\) diploid genotype frequencies from \
the allele frequencies and matrix of moments; assumes \[Delta]p=1.  \
DiploidGenotypeFrequencyList[{\!\(p\_1\),\[Ellipsis],\!\(p\_n\)},{\!\(\[Delta]\
p\_1\),\[Ellipsis]},{{\!\(c\_\(0, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(0\)\)\)\
\),\!\(c\_\(1, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(0\)\)\)\),\[Ellipsis]},\
\[Ellipsis]}] allows divergence \[Delta]p to vary across loci. \
DiploidGenotypeFrequencyList[{{\!\(p\_1\),\[Ellipsis],\!\(p\_n\)},{\!\(\(p\_1\
\%*\)\),\[Ellipsis]}},{{\!\(\[Delta]p\_1\),\[Ellipsis]},{\!\(\(\[Delta]p\_1\%*\
\)\),\[Ellipsis]}},{{\!\(c\_\(0, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \
\)\(0\)\)\)\),\!\(c\_\(1, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(0\)\)\)\),\
\[Ellipsis]},\[Ellipsis]},Symmetric\[Rule]False] allows the male and female \
gamete pools to differ. DiploidGenotypeFrequencyList[n][{\!\(p\_1\),\
\[Ellipsis],\!\(p\_n\)},{\!\(\[Delta]p\_1\),\[Ellipsis]},{{\!\(c\_\(0, \\\\\\\
\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(0\)\)\)\),\!\(c\_\(1, \\\\\\\ \
\(\(\\\\\\\\\)\(\\\\\\\ \)\(0\)\)\)\),\[Ellipsis]},\[Ellipsis]}], \
DiploidGenotypeFrequencyList[n,Symmetric\[Rule]False][{{\!\(p\_1\),\[Ellipsis]\
,\!\(p\_n\)},{\!\(\(p\_1\%*\)\),\[Ellipsis]}},{{\!\(\[Delta]p\_1\),\[Ellipsis]\
},{\!\(\(\[Delta]p\_1\%*\)\),\[Ellipsis]}},{{\!\(c\_\(0, \\\\\\\ \(\(\\\\\\\\\
\)\(\\\\\\\ \)\(0\)\)\)\),\!\(c\_\(1, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(0\)\
\)\)\),\[Ellipsis]},\[Ellipsis]}] are compiled versions. \>\"";\)\)



\!\(\(EstimateMoments::usage = \*"\"\<EstimateMoments[g,{\!\(p\_1\),\
\[Ellipsis]},{\[Delta]p,\[Ellipsis]}] estimates the matrix of moments from \
the \!\(3\^n\) diploid genotype frequencies, assuming allele frequencies \
\!\(p\_i\) and divergences \!\(\[Delta]p\_i\).  If the {\!\(\[Delta]p\_i\),\
\[Ellipsis]} are omitted, they are assumed to be 1.\>\"";\)\)



\!\(\(MVariables::usage = \*"\"\<MVariables[n] lists all the coefficients \
\!\(m\_\(S, \\\\\\\ H\)\) needed to describe an n locus diploid genotype. \
MVariables[j,n] lists those of order j\[LessEqual]2n. MVariables[n, Family\
\[Rule]True] lists all the coefficients \!\(m\_\(S, \\\\\\\ H, \\\\\\\ SS, \\\
\\\\\ SH, \\\\\\\ HH\)\) needed for a pair of n locus  diploid genotypes. \
MVariables[j,n, Family\[Rule]True] lists those of order j\[LessEqual]4n. \
\>\"";\)\)



MFromC::usage=
    "MFromC[c,{S,H}] gives the expression for M[S,H] in terms of c[i,j].  \
MFromC[c,{S,H,SS,SH,SS}] gives the expression for M[S,H,SS,SH,SS] in terms of \
c[i,j,k,l].";



MToCEquations::usage=
    "MToCEquations[m,c,n] gives the equations relating the coefficients \
m[S,H] to the c[j,k], for n loci.  MToCEquations[m,c,j,n] gives only the j'th \
order equations. MToCEquations[m,c,n,Family\[Rule]True] gives the equations \
relating the coefficients m[S,H,SS,SH,HH] to the c[i,j,k,l]";



Family::usage=
    "Family\[Rule]True is an option for MToC[] which indicates that a family \
is involved";



\!\(\(MToC::usage = \*"\"\<MToC[m,c,n] is a rule which gives the moments, \
c[i,j], in terms of the m[S,H]=<(\[Zeta]+\!\(\(\[Zeta]\^*\)\)\!\(\()\^S\)\)\
\[Zeta]\[VeryThinSpace]\!\(\(\[Zeta]\^*\)\^H\)>, where {\[Zeta],\!\(\(\[Zeta]\
\^*\)\)} is the diploid genotype.  MToC[m,c,j,n] gives only the j'th order \
terms.  MToC[m,c,n,Family\[Rule]True] gives the moments, c[i,j,k,l], in terms \
of the m[S,H,SS,SH,HH]=<(\[Zeta]+\!\(\(\[Zeta]\^*\)\)+\!\(\(\[Zeta]\^'\)\)+\!\
\(\[Zeta]\^\(\('\)\(*\)\)\)\!\(\()\^S\)\)(\[Zeta]\[VeryThinSpace]\!\(\(\[Zeta]\
\^*\)\)+\!\(\(\[Zeta]\^'\)\)\!\(\[Zeta]\^\(\('\)\(*\)\)\)\!\(\()\^H\)\)((\
\[Zeta]+\!\(\(\[Zeta]\^*\)\))(\!\(\(\[Zeta]\^'\)\)+\!\(\[Zeta]\^\(\('\)\(*\)\)\
\))\!\(\()\^SS\)\)((\[Zeta]+\!\(\(\[Zeta]\^*\)\))(\!\(\(\[Zeta]\^'\)\)\!\(\
\[Zeta]\^\(\('\)\(*\)\)\))+(\[Zeta]\[VeryThinSpace]\!\(\(\[Zeta]\^*\)\))(\!\(\
\(\[Zeta]\^'\)\)+\!\(\[Zeta]\^\(\('\)\(*\)\)\))\!\(\()\^SH\)\)(\[Zeta]\
\[VeryThinSpace]\!\(\(\[Zeta]\^*\)\)\!\(\(\[Zeta]\^'\)\)\!\(\[Zeta]\^\(\('\)\(\
*\)\)\)\!\(\()\^HH\)\)>.  Here, {\[Zeta],\!\(\(\[Zeta]\^*\)\)}, \
{\!\(\(\[Zeta]\^'\)\),\!\(\[Zeta]\^\(\('\)\(*\)\)\)}are the diploid genotypes \
of the two parents of a family.\>\"";\)\)



\!\(\(MToCOld::usage = \*"\"\<MToC[m,n] gives the matrix of moments, \
\!\(c\_\(j, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(\\\\\\\\\)\(\\\\\\\ \)\(k\)\)\
\)\) in terms of m[j,k], where m[j,k]=<\!\(z\^j\)\!\(\[Phi]\^k\)>.\>\"";\)\)



\!\(\(FamilyM::usage = \
\*"\"\<FamilyM[families,{\!\(i\_S\),\!\(i\_H\),\!\(i\_SS\),\!\(i\_SH\),\!\(i\_\
HH\)},{\!\(p\_1\)\[Ellipsis]}] gives the average of \!\(M\_\(i\_S, \\\\\\\ \(\
\(\\\\\\\\\)\(\\\\\\\ \)\(i\_H\)\), \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(i\_SS\
\)\), \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(i\_SH\)\), \\\\\\\ \(\(\\\\\\\\\)\(\
\\\\\\\ \)\(i\_HH\)\)\)\), measured relative to allele frequencies \
{\!\(p\_1\)\[Ellipsis]}. InferParentalGenotypes\[Rule]True infers parental \
genotypes rather than making estimates from moments of the offspring.\>\"";\)\
\)



FamilyEffects::usage="FamilyEffects[family, {\!\(p\_1\),\[Ellipsis]}] gives a \
list {S,H,SS,SH,HH}, which estimates \
(\!\(\[Zeta]\_i\)+\!\(\(\[Zeta]\_i\%*\)\)+\!\(TraditionalForm\`\(\[Zeta]\_i\%'\
\)\\\\\\\ \\\ \(+\\\ \(\(\\\\\)\(\\\ \)\(\\\\\)\(\\\ \
\)\(\[Zeta]\_i\%\(\('\)\(*\)\)\)\)\)\)),(\!\(\[Zeta]\_i\)\!\(\(\[Zeta]\_i\%*\)\
\)+\!\(\(\[Zeta]\_i\%'\)\)\!\(\[Zeta]\_i\%\(\('\)\(*\)\)\)),(\!\(\[Zeta]\_i\)+\
\!\(\(\[Zeta]\_i\%*\)\))(\!\(TraditionalForm\`\(\[Zeta]\_i\%'\)\\\\\\\ \\\ \
\(+\\\ \(\(\\\\\)\(\\\ \)\(\\\\\)\(\\\ \
\)\(\[Zeta]\_i\%\(\('\)\(*\)\)\)\)\)\)), \
((\!\(TraditionalForm\`\(\[Zeta]\_i\%'\)\\\\\\\ \\\ \(+\\\ \(\(\\\\\)\(\\\ \)\
\(\\\\\)\(\\\ \)\(\[Zeta]\_i\%\(\('\)\(*\)\)\)\)\)\))\!\(\[Zeta]\_i\)\!\(\(\
\[Zeta]\_i\%*\)\)+(\!\(\[Zeta]\_i\)+\!\(\(\[Zeta]\_i\%*\)\))\!\(\(\[Zeta]\_i\%\
'\)\)\!\(\[Zeta]\_i\%\(\('\)\(*\)\)\)), \!\(\[Zeta]\_i\)\!\(\(\[Zeta]\_i\%*\)\
\)\!\(\(\[Zeta]\_i\%'\)\)\!\(\[Zeta]\_i\%\(\('\)\(*\)\)\).  Here, \
{\!\(\[Zeta]\_i\),\!\(\(\[Zeta]\_i\%*\)\)} are the contributions from the \
mother, and {\!\(\(\[Zeta]\_i\%'\)\), \!\(\[Zeta]\_i\%\(\('\)\(*\)\)\)} from \
the father.  {\!\(p\_1\),\[Ellipsis]} is a list of allele frequencies.  \
Stores results.InferParentalGenotypes\[Rule]True infers parental genotypes \
rather than making estimates from moments of the offspring.";



InferParentalGenotypes::usage=
    "InferParentalGenotypes\[Rule]True is an option for FamilyEffects, \
FamilyM and EstimateFamilyMoments which specifies that the joint parental \
genotypes are inferred from the class of segregation rather than from the \
moments of the offspring genotypes.";



\!\(\(FamilyAlleleFrequencyEstimate::usage = \
\*"\"\<FamilyAlleleFrequencyEstimate[{\!\(family\_1\),\[Ellipsis]}] gives the \
average allele frequency, weighting each family equally.\>\"";\)\)



\!\(\(EstimateFamilyMoments::usage = \*"\"\<EstimateFamilyMoments[{\!\(family\
\_1\),\[Ellipsis]},c[i,j,k,l],{\!\(p\_1\),\[Ellipsis]}] gives an estimate of \
the moment c[{i,j,k,l], based on the family data. InferParentalGenotypes\
\[Rule]True infers parental genotypes rather than making estimates from \
moments of the offspring.\>\"";\)\)





\!\(\(MakeOneWayTable::usage = \*"\"\<MakeOneWayTable[site] generates a table \
of estimates of p and F, for each locus in Data[site].  The table consists of \
a list of {p,\!\(F\&^\),L}, where L is the log likelihood ratio comparing F=0 \
with F=\!\(F\&^\). In the general moment notation, Fpq=\!\(c\_\(1, \\\\\\\ \(\
\(\\\\\\\\\)\(\\\\\\\ \)\(1\)\)\)\). Generates subsets of the data which are \
labelled {s,{j}}.\>\"";\)\)



PresentOneWayTable::usage=
    "PresentOneWayTable[site] presents a table of allele frequency, F, and \
log(L) for each locus.";



\!\(\(MakePairwiseTable::usage = \*"\"\<MakePairwiseTable[site] generates a \
table of estimates of F, D and correlations between them, for each pair of \
loci in Data[site].  For each pair, the table contains a list of \
{L,{Fpq,D,cov[Fpq,D],cov[\!\(Fpq\_1\),\!\(Fpq\_2\)]}}, for the hypotheses \
that all F, D=0; that F\[NotEqual]0; that D\[NotEqual]0; that F\[NotEqual]0 \
and heterozygosities are correlated across loci (cov[\!\(F\_1\),\!\(F\_2\)]\
\[NotEqual]0); and that all associations are non-zero. The associated # of \
degreees of freedom are {0,1,1,2,4}.  In the general moment notation, \
Fpq=\!\(c\_\(1, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(\\\\\\\\\\\\\\\\ \(\(\\\\\
\\\\\)\(\\\\\\\ \)\) 1\)\)\)\),D=\!\(c\_\(0, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \
\)\(2\)\)\)\),cov[Fpq,D]=\!\(c\_\(2, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(\\\\\
\\\\\)\(\\\\\\\ \)\(1\)\)\)\),cov[\!\(Fpq\_1\),\!\(Fpq\_2\)]=\!\(c\_\(2, \\\\\
\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(2\)\)\)\).  Generates subsets of the data \
which are labelled {s,{j,k}}.\>\"";\)\)



\!\(\(PresentPairwiseTable::usage = \*"\"\<PresentPairwiseTable[site] \
presents a table of associations among loci.  PresentPairwiseTable[table, \
locusnames] works from the table generated by MakePairwiseTable[site].  \
PresentPairwiseTable[table, locusnames,c] adds the overall estimates, held in \
c = EstimateMoments[gf,{\!\(p\_1\),\[Ellipsis]}], where gf are the \!\(3\^n\) \
genotype frequencies.\>\"";\)\)





\!\(\(LogLikelihoodDisequilibriumReduced::usage = \
\*"\"\<LogLikelihoodDisequilibriumReduced[site,{\!\(k\_w\),\!\(k\_b\)},\
\[Delta]p,p,{i,j,k,l}] gives an expression for the log likelihood of the \
reduced cumulants {\!\(k\_w\),\!\(k\_b\)}. \
LogLikelihoodDisequilibriumReduced[site,{\!\(k\_w\),\!\(k\_b\)},\[Delta]p,p,{\
i,j,k,l},gdt] stores the definition of DiploidGenotypeFrequencyTable[X,..] in \
gdt[X].   LogLikelihoodDisequilibriumReduced[site,{\!\(k\_w\),\!\(k\_b\)},\
\[Delta]p,p] uses the fully compiled version. \
LogLikelihoodDisequilibriumReduced[site{\!\(k\_w\),\!\(k\_b\)},p] is the \
fastest method if \[Delta]p=1\>\"";\)\)



\!\(\(LogLikelihoodDisequilibrium::usage = \
\*"\"\<LogLikelihoodDisequilibrium[site,p,\[Delta]p,c] gives the log \
likelihood of the matrix of moments, \!\(c\_\(j, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\
\\\ \)\(k\)\)\)\).    LogLikelihoodDisequilibrium[site,p,\[Delta]p,c,Compiled\
\[Rule]True] is a compiled version. LogLikelihoodDisequilibrium[p,c,Compiled\
\[Rule]True] is the fastest method if \[Delta]p=1. \
LogLikelihoodDisequilibrium[{p,\!\(\(p\^*\)\)},{\[Delta]p,\!\(\(\[Delta]p\^*\)\
\)},c,Compiled\[Rule]True,Symmetric\[Rule]False] allows for different \
frequencies in the male & female gamete pools. \>\"";\)\)



MLEDisequilibrium::usage=
    "MLEDisequilibrium[site,cw[k],{cw,cb},{{cw[2],..},{cb[2]..}},\[Delta]p,p,\
S] gives the MLE for cw[k], with the remaining c's given numerically by the \
lists {{cw[2],..},{cb[2]..}}. ";



MetropolisDisequilibrium::usage="MetropolisDisequilibrium[site,T,{ntries,\
nprint},{Log[L],{{{p[1],..}},{{{\[Delta]p[1],..}},{{c[0,0],...}},{{pstep0},{\
\[Delta]pstep0},cstep0}] applies the Metropolis algorithm, using temperature \
T and  a matrix of moments.   step0 gives the initial step size; to fix some \
variables, set entries to 0. It is essential that the top left corner of \
cstep0 is zero.  Returns a list of the same form as its argument. \
\!\(TextForm\`The\\\\\\\ option\\\\\\\ Cumulant\\\\\\\ \\\  \[Rule] \\\ \
\(\(\\\\\)\(\\\ \)\(False\)\(\\\\\)\(\\\ \)\(fits\)\(\\\\\)\(\\\ \
\)\(a\)\(\\\\\)\(\\\ \)\(matrix\)\(\\\\\)\(\\\ \)\(of\)\(\\\\\)\(\\\ \
\)\(moments\)\(\\\\\)\(\\\ \)\(rather\)\(\\\\\)\(\\\ \)\(than\)\(\\\\\)\(\\\ \
\)\(cumulants \(\(\\\\\)\(\\\ \)\) . \(\(\\\\\)\(\\\ \)\)\)\)\)";



MetropolisDisequilibriumReduced::usage=
    "MetropolisDisequilibriumReduced[site,T,{ntries,nprint},{Log[L],{{p[1],..}\
,{cw[2],..,cb[2]..}},step0}] applies the Metropolis algorithm, using \
temperature T.  Assumes \[Delta]p=1.  step0 gives the initial step size; to \
fix some variables, set entries to 0.  Returns \
{log(L),{{p1,..},{cw[2],..,cb[2]..}},step}..";



$MetropolisAdjustment::usage=
    "$MetropolisAdjustment determines how the step size is adjusted in the \
Metropolis alhgorithm; by default, 0.95";



InitialStepReduced::usage=
    "InitialStepReduced[{cw,cb},cl,\[Delta]p,p,S] sets a sensible initial \
step size for cw,cb.  ";



InitialStep::usage=
    "InitialStep[p,\[Delta]p,cl] sets a sensible initial step size for c's. \
May fail if the cl is incompatible with the allele frequencies. ";





HaploidConstraints::usage=
    "HaploidConstraints[k,\[Delta]p,p,S] gives a list of the constraints on \
gametic frequencies in terms of the reduced set of cumulants.  Stores \
results";



\!\(\(DiploidConstraints::usage = \*"\"\<DiploidConstraints[{\!\(k\_w\),\!\(k\
\_b\)},\[Delta]p,p,S] gives a list of the constraints on diploid genotype \
frequencies in terms of the reduced set of cumulants.  DiploidConstraints[{\!\
\(k\_w\),\!\(k\_b\)},\[Delta]p,p,S,gft] stores the definition of \
DiploidGenotypeFrequencyReduced[X,..] in gft[X].  \>\"";\)\)



MomentLimitsReduced::usage=
    "MomentLimitsReduced[c[k],{c[2],c[3],..},\[Delta]p,p,S] gives the bounds \
on the values of c[k], based on constraints on gamete frequencies, and \
expressed in terms of c[].  The c's are given numerically by the list \
{c[2],c[3],..}.  MomentLimitsReduced[c[k],{c[2],c[3],..},cs] uses \
pre-calculated constraints.";



MomentLimits::usage=
    "MomentLimits[{j,k},p,\[Delta]p,c] gives the bounds on the values of \
c[j,k], based on constraints on gamete frequencies, and expressed in terms of \
c[].  The c's are given numerically. If the constraints cannot be satisfied \
at all, returns {0,0}.";



ConstrainedIntervals::usage=
    "ConstrainedIntervals[expr>0,x] gives a list of the possible intervals in \
which x can lie.";



IntervalCombine::usage=
    "IntervalCombine[{{x1,y1},{x2,y2},..},{{X1,Y1},{X2,Y2},..},..] combines \
the lists of intervals";



IntervalPosition::usage=
    "IntervalPosition[{{x1,y1},{x2,y2},..},z] returns -k if z is just after \
the k'th interval and +k if it is in the k'th interval .";



MomentLimitsDiploid::usage=
    "MomentLimitsDiploid[cb[k],{cw,cb},{{cw[2],cw[3],..},{cb[2]..}},\[Delta]p,\
p,S] gives the bounds on the values of cb[k], based on constraints on diploid \
genotype frequencies, and expressed in terms of {cw[],cb[]}.  The cw's are \
given numerically by the lists {{cw[2],cw[3],..},{cb[2]..}}. \
MomentLimitsDiploid[cb[k],{cw,cb},{{cw[2],cw[3],..},{cb[2]..}},cs] takes \
precalculated constraints.";





\!\(\(MomentAfterMigration::usage = \*"\"\<MomentAfterMigration[U,c[i],{{j,\!\
\(m\_j\)}}] gives the moment after migration at a rate \!\(m\_j\) from deme j \
into deme i.  MomentAfterMigration[U,c[i],{{j,\!\(m\_j\)}\[Ellipsis]}] allows \
for several sources of immigrants.  Expressed as a linear mixture of c[j][U].\
\>\"";\)\)



MomentAfterRecombination::usage=
    "MomentAfterRecombination[U,c,r] gives the moment after recombination and \
random mating, in terms of r[S,T].  ";



MomentSimple::usage=
    "MomentSimple[i][U,c,pb,\[Delta]p] simplifies c[i][U] by supposing that \
deme 0 is in HW, and that the source demes are in linkage equilibrium and HW. \
 MomentSimple[i][U,c,pb,\[Delta]pl,\[Delta]ps] allows for two migration rates \
from demes {-2,-1,0,1,2}, with the neighbouring demes {-1,1} now with the \
same c[]'s as deme 0.";



MomentNew::usage=
    "MomentNew[U,c,m,pb,r,\[Delta]p] gives the overall moment, measured after \
short-range migration.  MomentNew[i][U,c,ml,ms,pb,r,\[Delta]pl,\[Delta]ps] \
allows for two migration rates.";



MomentEquilibrium::usage=
    "MomentEquilibrium[U,c,m,pb,r,\[Delta]p] gives the equilibrium moment in \
deme 0, measured after short-range migration.  Stores results. \
MomentEquilibrium[U,c,ml,ms,pb,r,\[Delta]pl,\[Delta]ps] allows for two \
migration rates. ";



CumulantEquilibrium::usage=
    "CumulantEquilibrium[U,c,m,pb,r,\[Delta]p] gives the equilibrium cumulant \
in deme 0, measured after short-range migration.  Stores results. \
CumulantEquilibrium[U,c,ml,ms,pb,r,\[Delta]pl,\[Delta]ps] allows for two \
migration rates. Gets slow for 8 way cumulants: 443s";



AdmixtureFrequency::usage=
    "AdmixtureFrequency[X,c,ml,ms,pb,p,\[Delta]pl,\[Delta]ps,S] gives the \
frequency of genotype X under an admixture model.  Uses \
DiploidGenotypeFrequency[] and moments MomentEquilibrium[].  \
AdmixtureFrequency[X,c,ml,ms,pb,p,\[Delta]pl,\[Delta]ps,S,Symmetric\[Rule]\
True] assumes loci are equivalent. Stores results.Very slow: better to use \
the compiled version of PossibleDiploidGenotypes[] if possible.";





\[Delta]pEst::usage=
    "\[Delta]pEst[netCV[site]/\[Alpha],\[Delta]pSum] gives the list of \
\[Delta]p's ";



\!\(\(\[Delta]pMax::usage = \*"\"\<\[Delta]pMax[site] gives the maximum \!\(\
\[Delta]p\_i\)allowed for each locus\>\"";\)\)



\[Delta]pSoln::usage=
    "\[Delta]pSoln[\[Delta]pS,\[Alpha],netCV[site]] gives the solution for \
\[Delta]pS, given \[Alpha].";



\[Alpha]\[Delta]pSoln::usage=
    "\[Alpha]\[Delta]pSoln[\[Delta]pS,\[Alpha],site,{\[Alpha]0,\[Alpha]0'] \
gives the solution for \[Alpha] and \[Delta]pS";





DrawSamples::usage=
    "DrawSamples[s,gF,nloci,{nt,ninds}] sets up nt datasets, stored as \
data[s[1]]..data[s[nt]], sampled from a population with genotype frequencies \
in the list gF, which can be generated by AdmixtureFrequency[].  \
DrawSamples[s,gF,nloci,{{k1,k2},ninds}] sets up data[s[k1]]..data[s[k2]] ";



\!\(\(FindMLE::usage = \
\*"\"\<FindMLE[s,{Log[L],{{pl},{\[Delta]p},\[Kappa]l},step0},metList] returns \
the MLE for Data[s], found using the Metropolis algorithm, in the form \
{log(L),{{\!\(p\_1\)..},{{\!\(\[Delta]p\_1\),\[Ellipsis]}},{{\!\(\[Kappa]\_\(\
0, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \
\)\(0\)\)\)\),\[Ellipsis]}\[Ellipsis]}},step0}}. step0 has the form {{{\!\(\
\[CapitalDelta]p\_1\)..}},{{\!\(\[CapitalDelta]\[Delta]p\_1\),\[Ellipsis]}},{{\
\!\(\[Kappa]\_\(0, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(0\)\)\)\),\[Ellipsis]}\
\[Ellipsis]}} and determines which parameters are varied. metList is a list \
of the form {{T,{ntries,nprint}},..} which determines the annealing schedule. \
Calls MetropolisDisequilibrium[]. FindMLE[s,p,\[Delta]p,\[Kappa]] returns the \
MLE for some actual matrix of cumulants listed in c; calls \
LogLikelihoodDisequilibrium[].   FindMLE[s,p] gives the HWLE estimates.  \
Cumulant\[Rule]False fits moments rather than cumulants.\>\"";\)\)



MakeRandomWalk::usage=
    "MakeRandomWalk[s,{Log[L],{{pl},{\[Delta]p},\[Kappa]l},step0},{T,{ntries,\
nprint}}, nvalues] generates a random walk at temperature T; with T=1, this \
follows the likelihood surface.  Each element of the output list has the same \
form as the second argument.  Output is generated every ntries cycles; the \
total number of elements is nvalues.";



SetData::usage=
    "SetData[site,p,\[Delta]p,\[Delta]pV] sets up functions p, \[Delta]p,\
\[Delta]pV which are based on the sampled allele frequency.  SetData[site,p,\
\[Delta]p] doesn't bother with \[Delta]pV.";



CumulantEquilibriumList::usage=
    "CumulantEquilibriumList[m,p,nloci] gives a list of the equilibrium \
cumulants under long range migration.  Slow for 4 loci, because it requires \
calculation of an 8-way cumulant.";



\!\(\(DoReplicates::usage = \
\*"\"\<DoReplicates[m,\!\(p\&_\),nloci,{nreps,ninds},metK,r,MethodP->Fit,\
MethodC->Fit] performs various tests on replicate samples, fitting cumulants \
\!\(c\_\(j, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(k\)\)\)\). Replicate samples \
are stored in files named r[m,p], where m \!\(p\&_\), m \!\(q\&_\) are the \
rates of long-range immigration.  Results are (in order): HWLE; {optional \
set}; true model (with true p). MethodP->Fit fits allele frequencies; Sample \
uses the estimated P; True uses the actual P;  All uses all these (default). \
MethodC->Fit fits all moments; TrueC2 fixes \!\(c\_\(1, \\\\\\\ \
\(\(\\\\\\\\\)\(\\\\\\\ \)\(1\)\)\)\), \!\(c\_\(0, \\\\\\\ \(\(\\\\\\\\\)\(\\\
\\\\\ \)\(2\)\)\)\); True uses the actual C's;  Both uses True and Fit; All \
uses all these (default).  Cumulant\[Rule]False fits moments instead of \
cumulants.\>\"";\)\)



MethodP::usage=
    "MethodP is an option for DoReplicates[] which determines how allele \
frequencies are to be fitted.";



Sample::usage=
    "Sample is a setting for the options MethodP, MethodC which ensures that \
DoReplicates[] uses the sampled allele frequencies or cumulants.";



\!\(\(RandomUnionMethod::usage = \*"\"\<RandomUnionMethod is a setting for \
the option MethodC which ensures that DoReplicates[] fits cumulants \
appropriate for random union of gametes (i.e., \!\(\[Kappa]\_\(j, \\\\\\\ \
\(\(\\\\\\\\\)\(\\\\\\\ \)\(\\\\\\\\\\\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\) k\)\
\)\)\)\[NotEqual]0 only if j or k is zero).\>\"";\)\)



\!\(\(LinkageEquilibrium::usage = \*"\"\<LinkageEquilibrium is a setting for \
the option MethodC which ensures that DoReplicates[] fits cumulants \
appropriate for linkage equilibrium (i.e., only \!\(\[Kappa]\_\(0, \\\\\\\ \(\
\(\\\\\\\\\)\(\\\\\\\ \)\(0\)\)\)\), \!\(\[Kappa]\_\(1, \\\\\\\ \
\(\(\\\\\\\\\)\(\\\\\\\ \)\(1\)\)\)\)\[NotEqual]0).\>\"";\)\)



\!\(\(HWLE::usage = \*"\"\<HWLE is a setting for the option MethodC which \
ensures that DoReplicates[] fits cumulants appropriate for Hardy-Weinberg and \
linkage equilibrium (i.e., all \!\(\[Kappa]\_\(j, \\\\\\\ \
\(\(\\\\\\\\\)\(\\\\\\\ \)\(k\)\)\)\)=0 except \!\(\[Kappa]\_\(0, \\\\\\\ \
\(\(\\\\\\\\\)\(\\\\\\\ \)\(0\)\)\)\)).\>\"";\)\)



MethodC::usage=
    "MethodC is an option for DoReplicates[] which determines how the matrix \
of moments is to be fitted.";



\!\(\(TrueC2::usage = \*"\"\<TrueC2 is a setting for the option MethodC which \
ensures that DoReplicates[] fixes \!\(c\_\(1, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \
\)\(1\)\)\)\) and \!\(c\_\(0, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(2\)\)\)\) \
at their true values, but fits the other moments.\>\"";\)\)



DoReplicatesReduced::usage=
    "DoReplicatesReduced[m,p,nloci,{nreps,ninds},metK,r] performs various \
tests on replicate samples. Results are (in order): HWLE; MLE ; actual model \
(fitting p); true model (with true p). All except the last fit allele \
frequencies by MLE.";



MakeSets::usage=
    "MakeSets[nloci] gives an approriate set of loci for generating the \
expected between-genome cumulants.  Works for 2-4 loci.";



\!\(\(PresentResults::usage = \*"\"\<PresentResults[results,{m,p}] gives a \
table which presents the mean and standard deviation of log(L) and \!\(\
\[Kappa]\_\(0, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(2\)\)\)\), \
\!\(\[Kappa]\_\(1, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(1\)\)\)\), \
\!\(\[Kappa]\_\(1, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(2\)\)\)\), \
\!\(\[Kappa]\_\(2, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(2\)\)\)\).  The same \
set of options should be given as for the run of DoReplicates[] which \
generated the results.\>\"";\)\)



\!\(\(CompareLogL::usage = \*"\"\<CompareLogL[results,{i,j}] compares the \
likelihood of \!\(method\_i\) with that of \!\(method\_j\), using a set of \
results generated by DoReplicates[].   Returns a list of the differences in \
log(likelihood).\>\"";\)\)



\!\(\(PresentLogL::usage = \*"\"\<PresentLogL[results,{{j,k},\[Ellipsis]},{\!\
\(df\_\(j, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \
\)\(k\)\)\)\),\[Ellipsis]},{\!\(name\_\(j, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\
\(k\)\)\)\),\[Ellipsis]},P] presents a table summarising a list of \
comparisons based on results produced by DoReplicates[].  {{j,k},\[Ellipsis]} \
is a list of comparisons between method j and method k in results. \
{\!\(df\_\(j, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(k\)\)\)\),\[Ellipsis]} \
gives the corresponding degrees of freedom, and {\!\(name\_\(j, \\\\\\\ \
\(\(\\\\\\\\\)\(\\\\\\\ \)\(k\)\)\)\)\[Ellipsis]} the corresponding names.  P \
gives the significance level.  The table lists the number of valid log(L); \
the mean and variance of the valid log(L); the number of negative \
\[CapitalDelta]log(L); and the number of cases in which the hypothesis was \
rejected at significance level P, based on the asymptotic 1/2\!\(\[Chi]\^2\) \
distribution.\>\"";\)\)



\!\(\(PlotLogL::usage = \*"\"\<PlotLogL[results,{{j,k},\[Ellipsis]},{\!\(df\_\
\(j, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(k\)\)\)\)\[Ellipsis]}] plots the \
cumulative distributions of \[CapitalDelta]log(L), and the asymptotic 1/2\!\(\
\[Chi]\^2\) distribution. Uses results produced by DoReplicates[].  {{j,k},\
\[Ellipsis]} is a list of comparisons between method j and method k in \
results; each gives a graph.  {\!\(df\_\(j, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \
\)\(k\)\)\)\),\[Ellipsis]} gives the corresponding degrees of \
freedom.\>\"";\)\)



Begin["Multilocus`EstimatingD`Private`"];



<<Statistics`ContinuousDistributions`;<<Graphics`Graphics`;





RandomMating[c_]:={c[U_]:>(Module[{uu=(U/.Separate)},If[Depth[uu]==4,
						c[uu[[1]]/.Combine]*c[uu[[2]]/.Combine],c[U]]]/.{c[{}]:>1})}



\!\(\(Recombined[\(c_[x_]\)[M_List], r_] := 
      Module[{cc}, Recombined[cc[M], r] /. {cc[U_] -> \(c[x]\)[U]}];\)\n
  \(Recombined[c_[M_List], r_] := 
      Module[{s, t, 
          mm = \((M /. Separate)\) /. {a_List, b_List} -> {a, 
                  b, {}}}, \((\(\(AddUp[
                    AddUp[r[s, TakeAway[mm[\([1]\)], s]] 
                        r[t, TakeAway[mm[\([2]\)], t]] 
                        c[{{s, TakeAway[mm[\([1]\)], s], mm[\([3]\)]}, {t, 
                              TakeAway[mm[\([2]\)], t], {}}}], s, 
                      Subsets[mm[\([1]\)]]], t, Subsets[mm[\([2]\)]]] /. 
                  r[U_List, V_List] \[RuleDelayed] 
                    1\/2\ r @@ Sort[{Union[U], Union[V]}]\) /. {r[{}, {}] -> 
                    1, r[{}, {_}] -> 1}\) /. c[U_List] :> c[U /. Combine])\) 
          If[mm[\([1]\)] === {}, 2, 1] If[mm[\([2]\)] === {}, 2, 1]];\)\)



ChangeSex[U_List]:=Module[{t=U/.Separate},{t[[2]],t[[1]]}/.Combine];



ShiftCentre[c_[U_List],\[CapitalDelta]p_]:=
    Apply[Plus,
        Map[(c[TakeAway[U,#]]Apply[Times,Map[\[CapitalDelta]p[{#}]&,#]])&,
          Subsets[U]]]/.{c[{}]->1};



RandomUnionObsolete[c_]:={c[U_]:>(Module[{uu=(U/.Separate)},
					If[Depth[uu]==3,
					If[Length[uu]==2,c[{uu[[1]],{}}/.Combine]*c[{{},uu[[2]]}/.Combine],
						c[{uu[[1]],{},uu[[3]]}/.Combine]*c[{{},uu[[2]],{}}/.Combine]],
              c[U]]]/.{c[{}]:>1})}





Options[MomentFromG]={Diploid\[Rule]False};

MomentFromG[U_List,g_,p_,S_,opts___Rule]:=
    If[Diploid/.{opts}/.Options[MomentFromG],
		Module[{n=Length[S]},
		   MomentFromG[U,g,p,Join[S,ChangeSex[S]]]/.g[x_List]:>g[Partition[x,n]]],
		Module[{gt=HaploidTypes[Length[S]],pp=Map[p,S],ss=Locations[S,U]},
		Apply[Plus,Map[g[#]Apply[Times,Extract[(#-pp),ss]]&,gt]]]];



\!\(\(HaploidGenotypeFrequency[X_List, cc_, p_, 
        S_] := \(HaploidGenotypeFrequency[X, cc, p, S] = 
        Module[{ii, ll, pql, n = Length[S], n0 = Count[X, 0]}, \n\t\tpql = 
            Table[If[X[\([ii]\)] == 1, p[S[\([ii]\)]], 
                1 - p[S[\([ii]\)]]], {ii, n}]; \((Times @@ 
                pql)\) + \(\((\(-1\))\)\^n0\) \((Plus @@ 
                  Map[\((ll = 
                          Locations[S, 
                            TakeAway[
                              S, #]]; \n\t\t\t\t\t\t\t\t\((\((\((\(-1\))\)^
                                Count[Extract[X, ll], 0])\)*\((Times @@ 
                                Extract[pql, ll])\) cc[#])\))\) &, 
                    HaploidSubsets[S]])\)]\);\)\)

\!\(\(HaploidGenotypeFrequency[nl_] := \(HaploidGenotypeFrequency[nl] = 
        Module[{cc, pp, gx, vars, rl, tv}, \n\t\tvars = 
            cc /@ Subsets[Range[nl], 2, nl]; \n\ \ \ \ rl[
              xx_List] := \(({vars, Flatten[xx]} // Transpose)\) /. {x_, 
                  y_} :> \((x -> y)\); \n\t\tgx = \(HaploidGenotypeFrequency[
                  Table[1, {nl}], cc, pp, Range[nl]] /. 
                pp[j_] :> \(StandardSet[nl, pp]\)[\([j]\)]\) /. 
              rl[StandardSet[nl, cc, All]]; \n\t\t\ttv = 
            Transpose[{{StandardSet[nl, pp], StandardSet[nl, cc, All]} // 
                  Flatten, Table[_Real, {2\^nl - 1}]}]; \n\t\t\tCompile[
            tv // Evaluate, gx // Evaluate]]\);\)\)

HaploidGenotypeFrequency[X_List,cl_List,pl_List]:=
	
    Module[{nl=Length[X],vars,pp},
		pp=((1-X)+(2X-1)pl);
	HaploidGenotypeFrequency[nl]@@Flatten[{pp,Flatten[cl]*SignMask[X]}]];



PossibleDiploidGenotypes[{a___,0}]:=
    PossibleDiploidGenotypes[{a},{{{0},{0}}}];
PossibleDiploidGenotypes[{a___,1}]:=
    PossibleDiploidGenotypes[{a},{{{0},{1}},{{1},{0}}}];
PossibleDiploidGenotypes[{a___,2}]:=
    PossibleDiploidGenotypes[{a},{{{1},{1}}}];
PossibleDiploidGenotypes[{},a_List]:=a;

PossibleDiploidGenotypes[{y___,0},x_List]:=
    PossibleDiploidGenotypes[{y},
      Map[(#/.{{a___},{b___}}->{{0,a},{0,b}})&,x]];
PossibleDiploidGenotypes[{y___,1},x_List]:=
  PossibleDiploidGenotypes[{y},
    Flatten[Map[(#/.{{a___},{b___}}->{{{1,a},{0,b}},{{0,a},{1,b}}})&,x],1]];
PossibleDiploidGenotypes[{y___,2},x_List]:=
  PossibleDiploidGenotypes[{y},Map[(#/.{{a___},{b___}}->{{1,a},{1,b}})&,x]];



DiploidGenotypeFrequency[U_,c_,p_,S_]:=
  Plus@@((HaploidGenotypeFrequency[Flatten[#],c,p,
                Join[S,ChangeSex[S]]]/.Symmetrise[c])&/@
        PossibleDiploidGenotypes[U])

DiploidGenotypeFrequency[U_List,c_List,p_List]:=
    Plus@@(HaploidGenotypeFrequency[Flatten[#],c,Join[p,p]]&/@
          PossibleDiploidGenotypes[U]);



Options[DiploidGenotypeFrequencyList]={Symmetric\[Rule]True};

DiploidGenotypeFrequencyList[pl_List,ce_List,opts___Rule]:=
	Module[{M1,M2},
     If[Symmetric/.{opts}/.Options[DiploidGenotypeFrequencyList],
			 M1=M2=Matrix\[CapitalGamma][pl,Length[pl]],
			 M1=Matrix\[CapitalGamma][pl\[LeftDoubleBracket]1\[RightDoubleBracket],
            Length[pl\[LeftDoubleBracket]1\[RightDoubleBracket]]]; 
        M2=Matrix\[CapitalGamma][pl\[LeftDoubleBracket]2\[RightDoubleBracket],
            Length[pl\[LeftDoubleBracket]2\[RightDoubleBracket]]]];
	  M1.ce.Transpose[M2]];

DiploidGenotypeFrequencyList[pl_List,\[Delta]pl_List,ce_List,opts___Rule]:=
	
    Module[{M1,M2},
		If[Symmetric/.{opts}/.Options[DiploidGenotypeFrequencyList],
			 M1=M2=Matrix\[CapitalGamma][pl,\[Delta]pl,Length[pl]],
			 M1=Matrix\[CapitalGamma][
            pl\[LeftDoubleBracket]1\[RightDoubleBracket],\[Delta]pl\
\[LeftDoubleBracket]1\[RightDoubleBracket],
            Length[pl\[LeftDoubleBracket]1\[RightDoubleBracket]]]; 
        M2=Matrix\[CapitalGamma][
            pl\[LeftDoubleBracket]2\[RightDoubleBracket],\[Delta]pl\
\[LeftDoubleBracket]2\[RightDoubleBracket],
            Length[pl\[LeftDoubleBracket]2\[RightDoubleBracket]]]];
	  M1.ce.Transpose[M2]];

DiploidGenotypeFrequencyList[n_,opts___Rule]:=
	Module[{M1,M2},
     If[Symmetric/.{opts}/.Options[DiploidGenotypeFrequencyList],
			 M1=M2=Matrix\[CapitalGamma][n][#1,#2],
			 M1=Matrix\[CapitalGamma][
                n][#1\[LeftDoubleBracket]1\[RightDoubleBracket],#2\
\[LeftDoubleBracket]1\[RightDoubleBracket]]; 
          M2=Matrix\[CapitalGamma][
                n][#1\[LeftDoubleBracket]2\[RightDoubleBracket],#2\
\[LeftDoubleBracket]2\[RightDoubleBracket]]];
	  M1.#3.Transpose[M2]]&;



SignMask[X_List]:=
    SignMask[X]=(Times@@((2X-1)\[LeftDoubleBracket]#\[RightDoubleBracket]&/@#)\
)&/@HaploidSubsets[Range[Length[X]]];



DiploidGenotypeFrequencyReduced[XY_List,{cw_,cb_},\[Delta]p_,p_,S_]:=
    DiploidGenotypeFrequencyReduced[XY,{cw,cb},\[Delta]p,p,S]=
      Plus@@(FullGenotypeFrequencyReduced[#,{cw,cb},\[Delta]p,p,S]&/@
            PossibleDiploidGenotypes[XY]);





















\!\(\(FullGenotypeFrequencyReduced[X : {__Integer}, c_, \[Delta]p_, p_, 
        S_List] := 
      Module[{jj, pt, tpt, sx = Sign[X - 1\/2], n = Length[S], 
          rn}, \n\t\trn = Range[2, n]; \t\n\t\tpt = 1 - X + sx \((p /@ S)\); 
        tpt = Times @@ pt; \n\t\tTogether[
          tpt*\((1 + \((\(Moment[c, #, Centred \[Rule] True] &\) /@ 
                      rn)\) . \((\(ProductSum[\((sx*Map[\[Delta]p, S])\)/
                            pt, #] &\) /@ rn)\))\)]];\)\)

\!\(\(FullGenotypeFrequencyReduced[{X : {__Integer}, Y : {__Integer}}, {cw_, 
          cb_}, \[Delta]p_, p_, S_List] := 
      Module[{j1, j2, ptx, pty, \[Delta]ptx, \[Delta]pty, sx = Sign[X - 1/2], 
          sy = Sign[Y - 1/2], n = Length[S], rn, rn1, mv, a, b, c}, \n\t
        rn = Range[2, n]; 
        rn1 = Range[n]; \n\t\tmv = \(Moment[cw, #, Centred -> True] &\) /@ 
            rn; \n\t\tptx = 1 - X + sx*Map[p, S]; \t
        pty = 1 - Y + 
            sy*Map[p[\(#\^*\)] &, 
                S]; \n\t\[Delta]ptx = \(Map[\[Delta]p, S]\ sx\)\/ptx; \
\[Delta]pty = \(Map[\[Delta]p[\(#\^*\)] &, S]\ sy\)\/pty; \n\ \ \ \ \ a = 
          mv . \((\(ProductSum[\[Delta]ptx, #] &\) /@ rn)\); \n\t\tb = 
          mv . \((\(ProductSum[\[Delta]pty, #] &\) /@ rn)\); \n\t\ \ \ c = 
          Flatten[Outer[\ MomentReduced[{cw, cb}, {#1, #2}] &, rn1, 
                rn1]] . \n\t\t\t\t\t\tFlatten[
              Outer[ProductSum[\[Delta]ptx, \[Delta]pty, #1, #2] &, rn1, 
                rn1]]; \n\t\ \ Together[\((Times @@ ptx)\) \((Times @@ 
                pty)\) \((1 + a + b + c)\)]];\)\)





MomentReduced[{kw_,kb_},{jU_,jV_}] :=MomentReduced[{kw,kb},{jU,jV}] =
		Module[{k,u,v,V,x,y},
        Moment[k,{Array[u&,jU],Array[v&,jV]}/.Combine,
            Centred->True]/.{k[U_List]:>(V=U/.Separate;
                k@@Sort[Map[Length,V]]/.k[0,x_]:>kw[x]/.k[x_,y_]:>kb[x+y])}];

MomentReduced[n_Integer]:=MomentReduced[n]=Module[{cw,cb,cl},
			Compile[{{cl,_Real,1}},
				(Table[MomentReduced[{cw,cb},{j1,j2}],{j1,0,n},{j2,0,n}])/.{cw[j_]:>
                  cl\[LeftDoubleBracket]j-1\[RightDoubleBracket],
                cb[j_]:>cl\[LeftDoubleBracket]j+n-2\[RightDoubleBracket]}//
            Evaluate,
			{{MomentReduced[_,_],_Real}}]];

\!\(\(MomentReduced[U_List, {cw_, cb_}, \[Delta]p_] := \n\t
      Module[{ns = Count[U, \(_\^*\)], n = Length[U]}, 
        Apply[Times, Map[\[Delta]p, U /. \(x_\^*\) :> x]] 
          If[\((n == ns)\) || \((ns == 0)\), cw[n], cb[n]]];\)\)



CumulantReduced[{cw_,cb_},{jU_,jV_}] :=CumulantReduced[{cw,cb},{jU,jV}] =
		Module[{c,u,v,V,x,y},
        Cumulant[c,{Array[u&,jU],Array[v&,jV]}/.Combine,
            Centred->True]/.{c[U_List]:>(V=U/.Separate;
                c@@Sort[Map[Length,V]]/.c[0,x_]:>cw[x]/.c[x_,y_]:>cb[x+y])}];



Options[Moment]=Union[Append[Options[Moment],Symmetric\[Rule]False]];

Moment[k_,{jU_Integer,jV_Integer},opts___Rule] :=Moment[k,{jU,jV},opts] =
		  Module[{u,v,V,m},
			m=Moment[
              k,{Array[u&,jU],Array[v&,jV]}/.Combine]/.{k[
                  U_List]:>(V=U/.Separate;k@@Map[Length,V])};
		If[Centred/.{opts}/.Options[Moment],
			m=m/.{k[0,1]\[Rule]0,k[1,0]\[Rule]0}];
		If[Symmetric/.{opts}/.Options[Moment],
			m=m/.{k[x_,y_]\[RuleDelayed]k@@Sort[{x,y}]}];
		m];

Moment[n_Integer,opts___Rule]:=Moment[n,opts]=
		Module[{k,cl,cc},
			Off[Part::partd];cc=Compile[{{cl,_Real,2}},
				(Table[Moment[k,{j1,j2},opts],{j1,0,n},{j2,0,n}])/.{k[j_,l_]:>
                    cl\[LeftDoubleBracket]j+1,l+1\[RightDoubleBracket]}//
              Evaluate,
			{{Moment[_,__],_Real}}];
			On[Part::partd];cc];

\!\(\(Moment[U_List, c_, \[Delta]p_] := \n\t
      Module[{ns = Count[U, \(_\^*\)], n = Length[U], m}, \n\t\tm = 
          Apply[Times, Map[\[Delta]p, U]] c[n - ns, ns]; \n\t
        If[\(Centred /. {opts}\) /. Options[Moment], \n\t\t\tm = 
            m /. {c[0, 1] \[Rule] 0, 
                c[1, 0] \[Rule] 0}]; \n\t\tIf[\(Symmetric /. {opts}\) /. 
            Options[Moment], \n\t\t\tm = 
            m /. {c[x_, y_] \[RuleDelayed] c @@ Sort[{x, y}]}]; \n\t\tm];\)\)



Options[Cumulant]=Union[Append[Options[Cumulant],Symmetric\[Rule]False]];

Cumulant[c_,{jU_Integer,jV_Integer},opts___Rule] :=Cumulant[c,{jU,jV},opts] =
		  Module[{u,v,V,m},
			m=Cumulant[
              c,{Array[u&,jU],Array[v&,jV]}/.Combine]/.{c[
                  U_List]:>(V=U/.Separate;c@@Map[Length,V])};
		If[Centred/.{opts}/.Options[Cumulant],
			m=m/.{c[0,1]\[Rule]0,c[1,0]\[Rule]0}];
		If[Symmetric/.{opts}/.Options[Cumulant],
			m=m/.{c[x_,y_]\[RuleDelayed]c@@Sort[{x,y}]}];
		m];

Cumulant[n_Integer,opts___Rule]:=Cumulant[n,opts]=
		Module[{c,cl,cc},
			Off[Part::partd];
			cc=Compile[{{cl,_Real,2}},
				(Table[Cumulant[c,{j1,j2},opts],{j1,0,n},{j2,0,n}])/.{c[j_,l_]:>
                    cl\[LeftDoubleBracket]j+1,l+1\[RightDoubleBracket]}//
              Evaluate,
			{{Cumulant[_,__],_Real}}];
			On[Part::partd];cc];

\!\(\(Cumulant[U_List, k_, \[Delta]p_, opts___Rule] := \n\t
      Module[{ns = Count[U, \(_\^*\)], n = Length[U], 
          m}, \n\t\tm = \((Times @@ \((\[Delta]p /@ U)\))\) 
            k[n - ns, ns]; \n\t
        If[\(Centred /. {opts}\) /. Options[Cumulant], \n\t\t\tm = 
            m /. {k[0, 1] \[Rule] 0, 
                k[1, 0] \[Rule] 0}]; \n\t\tIf[\(Symmetric /. {opts}\) /. 
            Options[Cumulant], \n\t\t\tm = 
            m /. {c[x_, y_] \[RuleDelayed] c @@ Sort[{x, y}]}]; \n\t\tm];\)\)

































FullGenotypeFrequencyTable[{cw_,cb_},S_List]:=
    FullGenotypeFrequencyTable[{cw,cb},S]=
		Module[{ones=Array[1&,Length[S]]},
        FullGenotypeFrequencyReduced[{ones,ones},{cw,cb},$\[Delta]p,$p,S]];

\!\(\(FullGenotypeFrequencyTable[{X_List, Y_List}, {cw_, cb_}, \[Delta]p_, 
        p_, S_List] := 
      Module[{rpx, rpy, r\[Delta]px, r\[Delta]py, 
          n = Length[S], $i}, \n\t\trpx = 
          Table[$p[S\[LeftDoubleBracket]$i\[RightDoubleBracket]] -> 
              If[X\[LeftDoubleBracket]$i\[RightDoubleBracket] == 1, 
                p[S\[LeftDoubleBracket]$i\[RightDoubleBracket]], 
                1 - p[S\[LeftDoubleBracket]$i\[RightDoubleBracket]]], {$i, 
              n}]; \n\t\trpy = 
          Table[$p[\(S\[LeftDoubleBracket]$i\[RightDoubleBracket]\^*\)] -> 
              If[Y\[LeftDoubleBracket]$i\[RightDoubleBracket] == 1, 
                p[S\[LeftDoubleBracket]$i\[RightDoubleBracket]], 
                1 - p[S\[LeftDoubleBracket]$i\[RightDoubleBracket]]], {$i, 
              n}]; \n\t\tr\[Delta]px = 
          Table[$\[Delta]p[S\[LeftDoubleBracket]$i\[RightDoubleBracket]] -> 
              If[X\[LeftDoubleBracket]$i\[RightDoubleBracket] == 1, \[Delta]p[
                  S\[LeftDoubleBracket]$i\[RightDoubleBracket]], \(-\[Delta]p[
                    S\[LeftDoubleBracket]$i\[RightDoubleBracket]]\)], {$i, 
              n}]; \n\t\tr\[Delta]py = 
          Table[$\[Delta]p[\(S\[LeftDoubleBracket]$i\[RightDoubleBracket]\^*\)\
] -> If[Y\[LeftDoubleBracket]$i\[RightDoubleBracket] == 1, \[Delta]p[
                  S\[LeftDoubleBracket]$i\[RightDoubleBracket]], \(-\[Delta]p[
                    S\[LeftDoubleBracket]$i\[RightDoubleBracket]]\)], {$i, 
              n}]; \n\t\tFullGenotypeFrequencyTable[{cw, cb}, S] /. 
          Join[rpx, rpy, r\[Delta]px, r\[Delta]py]];\)\)

\!\(\(FullGenotypeFrequencyTable[
        nl_Integer] := \(FullGenotypeFrequencyTable[nl] = 
        Module[{S = Range[nl], j, vars, gtx, tv, p, \[Delta]p, 
            p2, \[Delta]p2}, \n\ \ vars = 
            Join[Table[cw[j], {j, 2, nl}], Table[cb[j], {j, 2, 2  nl}]]; \n
          rl[xx_List] := \(({vars, Flatten[xx]} // Transpose)\) /. {x_, 
                  y_} :> \((x -> y)\); 
          gtx = \(FullGenotypeFrequencyTable[{cw, cb}, 
                  S] /. {$\[Delta]p[\(x_\^*\)] :> \(StandardSet[
                        nl, \[Delta]p2]\)\[LeftDoubleBracket]
                      x\[RightDoubleBracket], $\[Delta]p[
                      x_] :> \(StandardSet[
                        nl, \[Delta]p]\)\[LeftDoubleBracket]
                      x\[RightDoubleBracket], $p[\(x_\^*\)] :> \(StandardSet[
                        nl, p2]\)\[LeftDoubleBracket]
                      x\[RightDoubleBracket], $p[
                      x_] :> \(StandardSet[nl, p]\)\[LeftDoubleBracket]
                      x\[RightDoubleBracket]}\) /. 
              rl[StandardSet[nl]]; \n\t\ttv = 
            Transpose[{{StandardSet[nl, p], StandardSet[nl, p2], 
                    StandardSet[nl, \[Delta]p], StandardSet[nl, \[Delta]p2], 
                    StandardSet[nl]} // Flatten, 
                Table[_Real, {7  nl - 2}]}]; \n\t\tCompile[tv // Evaluate, 
            gtx // Evaluate]]\);\)\)

\!\(\(FullGenotypeFrequencyTable[nl_Integer, 
        Integer \[Rule] True] := \(FullGenotypeFrequencyTable[nl, 
          Integer \[Rule] True] = 
        Module[{j, vars, gtx, tv, p, \[Delta]p, p2, \[Delta]p2}, \n\ \ vars = 
            Join[Table[cw[j], {j, 2, nl}], Table[cb[j], {j, 2, 2  nl}]]; \n
          rl[xx_List] := \(({vars, Flatten[xx]} // Transpose)\) /. {x_, 
                  y_} :> \((x -> y)\); 
          gtx = \(FullGenotypeFrequencyTable[{cw, cb}, 
                  Range[nl]] /. {$\[Delta]p[\(x_\^*\)] :> \(StandardSet[
                        nl, \[Delta]p2]\)\[LeftDoubleBracket]
                      x\[RightDoubleBracket], $\[Delta]p[
                      x_] :> \(StandardSet[
                        nl, \[Delta]p]\)\[LeftDoubleBracket]
                      x\[RightDoubleBracket], $p[\(x_\^*\)] :> \(StandardSet[
                        nl, p2]\)\[LeftDoubleBracket]
                      x\[RightDoubleBracket], $p[
                      x_] :> \(StandardSet[nl, p]\)\[LeftDoubleBracket]
                      x\[RightDoubleBracket]}\) /. 
              rl[StandardSet[nl]]; \n\t\ttv = 
            Transpose[{{StandardSet[nl, p], StandardSet[nl, p2], 
                    StandardSet[nl, \[Delta]p], StandardSet[nl, \[Delta]p2], 
                    StandardSet[nl]} // Flatten, 
                Join[Table[_Real, {2  nl}], Table[_Integer, {2  nl}], 
                  Table[_Real, {3  nl - 2}]]}]; \n\t\tCompile[tv // Evaluate, 
            gtx // Evaluate]]\);\)\)

FullGenotypeFrequencyTable[{X_List,Y_List},cl_,\[Delta]p_,p_]:=
	
    Module[{nl=Length[X],S},
		S=Range[nl];
		FullGenotypeFrequencyTable[nl]@@
        Flatten[{((1-X)+(2X-1)(p/@S)),((1-Y)+(2Y-1)(p/@S)),(2X-1)(\[Delta]p/@
                  S),(2Y-1)(\[Delta]p/@S),cl}]];

\!\(\(FullGenotypeFrequencyTable[{X_List, 
          Y_List}] := \(FullGenotypeFrequencyTable[{X, Y}] = \n\t
        Module[{nl = Length[X], pl, cl, pp1, pp2, gtx, rl, vars, 
            j}, \n\t\t\ \ pp1 = \((\((1 - X)\) ql + 
                X\ pl)\); \n\t\t\tpp2 = \((\((1 - Y)\) ql + 
                Y\ pl)\); \n\t\t\tvars = 
            Join[Table[cw[j], {j, 2, nl}], Table[cb[j], {j, 2, 2  nl}]]; \n
          rl[xx_List] := \(({vars, Flatten[xx]} // Transpose)\) /. {x_, 
                  y_} :> \((x -> y)\); 
          gtx = \((\(FullGenotypeFrequencyTable[{cw, cb}, 
                    Range[nl]] /. {$\[Delta]p[\(x_\^*\)] :> 
                      1, $\[Delta]p[x_] :> 1, $p[\(x_\^*\)] :> 
                      pp2\[LeftDoubleBracket]x\[RightDoubleBracket], $p[x_] :> 
                      pp1\[LeftDoubleBracket]x\[RightDoubleBracket]}\) /. 
                rl[StandardSet[nl]])\); \n\t
          Compile[{{pl, _Real, 1}, {ql, _Real, 1}, {cl, _Real, 1}}, 
            gtx // Evaluate]]\);\)\)



























DiploidGenotypeFrequencyTable[X_,{cw_,cb_},\[Delta]p_,p_,S_List]:=
    Module[{gL,gg},
		gL[Y_]:=gL[Y]=FullGenotypeFrequencyTable[Y,{cw,cb},\[Delta]p,p,S];
		gg=Plus@@(gL[Sort[#]]&/@PossibleDiploidGenotypes[X]);
	Clear[gL];gg];

DiploidGenotypeFrequencyTable[X_,cl_,\[Delta]p_,p_]:=Module[{gL,gg},
			gL[Y_]:=gL[Y]=FullGenotypeFrequencyTable[Y,cl,\[Delta]p,p];
		gg=Plus@@(gL[Sort[#]]&/@PossibleDiploidGenotypes[X]);
	Clear[gL];gg];

DiploidGenotypeFrequencyTable[X_List,\[Delta]p_]:=
    DiploidGenotypeFrequencyTable[X,\[Delta]p]=
		Module[{nl=Length[X],pp,vars,sv,tv,j,rl},
			sv=Join[StandardSet[nl,ppp],StandardSet[nl]]//Flatten;
      vars=
          Join[Table[pp[j],{j,nl}],Table[cw[j],{j,2,nl}],
            Table[cb[j],{j,2,2nl}]];
		rl[xx_List]:=({vars,Flatten[xx]}//Transpose)/.{x_,y_}:>(x->y);	
	tv=Transpose[{sv,Table[_Real,{4nl-2}]}];
		Compile[tv//Evaluate, 
          DiploidGenotypeFrequencyTable[X,{cw,cb},\[Delta]p,pp,Range[nl]]/.rl[
                sv]//Evaluate]];

DiploidGenotypeFrequencyTable[nl_Integer,\[Delta]p_]:=
    DiploidGenotypeFrequencyTable[nl,\[Delta]p]=
		Module[{pp,ppp,vars,sv,tv,j,rl,
          dt=DiploidTypes[nl]/.{{a_Integer,b_Integer}:>a+b}},
			sv=Join[StandardSet[nl,ppp],StandardSet[nl]]//Flatten;
      vars=
          Join[Table[pp[j],{j,nl}],Table[cw[j],{j,2,nl}],
            Table[cb[j],{j,2,2nl}]];
		rl[xx_List]:=({vars,Flatten[xx]}//Transpose)/.{x_,y_}:>(x->y);	
	tv=Transpose[{sv,Table[_Real,{4nl-2}]}];
		Compile[
          tv//Evaluate, ((DiploidGenotypeFrequencyTable[#,{cw,cb},\[Delta]p,
                        pp,Range[nl]]/.rl[sv])&/@dt)//Evaluate]];



DiploidGenotypeFrequencyArguments[nl_]:=
    DiploidGenotypeFrequencyArguments[nl]=
      Module[{al,tv,pl=StandardSet[nl,p],ql=StandardSet[nl,q],
          cl=StandardSet[nl],pl2,ql2},
		pl2=Join[pl,pl];ql2=Join[ql,ql];
			al=Flatten[{pl2*#+ql2(1-# ),2#-1,cl}]&/@HaploidTypes[2nl];
		tv=Transpose[{Flatten[{pl,ql,cl}],Table[_Real,{5nl-2}]}];
		Compile[tv//Evaluate,al//Evaluate]];



GenotypeFrequencyFast[n_Integer]:=
    GenotypeFrequencyFast[n]=
      Module[{ptx,pty,sx,sy,\[Delta]ptx,\[Delta]pty,psx,psy,j},
	Compile[{{XY, _Integer,2}, {p, _Real, 1}, {\[Delta]p, _Real, 1}, {mm, _Real, 
              2}}, sx = 2XY\[LeftDoubleBracket]1\[RightDoubleBracket] - 1; 
          sy = 2XY\[LeftDoubleBracket]2\[RightDoubleBracket] - 1; 
          ptx = 1 -XY\[LeftDoubleBracket]1\[RightDoubleBracket] + sx*p; 
          pty = 1 -XY\[LeftDoubleBracket]2\[RightDoubleBracket] + 
              sy*p; \[Delta]ptx = (\[Delta]p*sx)/
              ptx; \[Delta]pty = (\[Delta]p*sy)/pty; 
          psx = Table[ProductSum[j][\[Delta]ptx], {j, 0, n}]; 
          psy = Table[ProductSum[j][\[Delta]pty], {j, 0, n}];
				 Times @@ ptx*Times @@ pty*
            psx . mm . psy, {{ProductSum[_][_], _Real}, {sx, _Integer, 
              1}, {sy, _Integer, 1}, {ptx, _Real, 1}, {pty, _Real, 
              1}, {psx, _Real, 1}, {psy, _Real, 1}, {\[Delta]ptx, _Real, 
              1}, {\[Delta]pty, _Real, 1}, {j, _Integer}}]];



GenotypeFrequencyFastVector[n_Integer]:=
    GenotypeFrequencyFastVector[n]=Module[{tt},
	Compile[{ {p, _Real, 1}, {\[Delta]p, _Real, 1}, {cl, _Real, 1}},
				tt=Matrix\[CapitalGamma][n][p,\[Delta]p];
			tt.MomentReduced[n][cl].Transpose[tt], {{MomentReduced[_][_],_Real,
              2},{tt,_Real,2},{Matrix\[CapitalGamma][_][_],_Real,1}}]];

GenotypeFrequencyFastVector[p_List,\[Delta]p_List,cl_List,n_Integer]:=
    Module[{tt=Matrix\[CapitalGamma][p,\[Delta]p,n]},
tt.MomentReduced[cl,n].Transpose[tt]];



AlleleFrequencyPermutations[p_List,n_Integer]:=((1 -#) + (2#-1)p)&/@
      HaploidTypes[n];

AlleleFrequencyPermutations[n_Integer]:=AlleleFrequencyPermutations[n]=
	Compile[{{p,_Real,1}},
			((1 -#) + (2#-1)p)&/@HaploidTypes[n],{{HaploidTypes[_],_Integer,2}}];



\[Delta]AlleleFrequencyPermutations[
      n_Integer]:=\[Delta]AlleleFrequencyPermutations[n]=
		Compile[{{\[Delta]p,_Real,1}},
		((2#-1)\[Delta]p)&/@HaploidTypes[n],
			{{HaploidTypes[_],_Integer,2}}];

\[Delta]AlleleFrequencyPermutations[\[Delta]p_List,
      n_Integer]:=\[Delta]AlleleFrequencyPermutations[\[Delta]p,n]=
		((2#-1)\[Delta]p)&/@HaploidTypes[n];



Matrix\[CapitalGamma][p_List,\[Delta]p_List,n_Integer]:=
    Module[{pv=AlleleFrequencyPermutations[p,n]},
((Times@@#)&/@
            pv)*(Table[
                ProductSum[#,j],{j,0,
                  n}]&/@(\[Delta]AlleleFrequencyPermutations[\[Delta]p,n]/
                pv))];

Matrix\[CapitalGamma][p_List,n_Integer]:=
    Module[{pv=AlleleFrequencyPermutations[p,n]},
((Times@@#)&/@
            pv)*(Table[
                ProductSum[#,j],{j,0,
                  n}]&/@(\[Delta]AlleleFrequencyPermutations[Array[1&,{n}],n]/
                pv))];

Matrix\[CapitalGamma][n_Integer][p_List,\[Delta]p_List]:=
		
    Module[{pv=AlleleFrequencyPermutations[n][p],j},
((Times@@#)&/@
            pv)*(Table[
                ProductSum[j][#],{j,0,
                  n}]&/@(\[Delta]AlleleFrequencyPermutations[n][\[Delta]p]/
                pv))];



PloidyWeightList[n_Integer]:=
    PloidyWeightList[n]=If[Count[#,{0,1}]==0,1,2]&/@DiploidTypes[n];



PositionsList[n_Integer]:=
    PositionsList[n]=
      PositionsList[#,n]&/@(DiploidTypes[n]/.{{a_Integer,b_Integer}:>a+b});

PositionsList[j_Integer,n_Integer]:=
    PositionsList[j,n]=
      PositionsList[n]\[LeftDoubleBracket]j\[RightDoubleBracket];

PositionsList[X_List,n_Integer]:=
    PositionsList[X,
        n]=((Sort[Position[HaploidTypes[n],#][[1,1]]&/@#])&/@
          Union[Sort/@PossibleDiploidGenotypes[X]]);



GenotypeFrequencyConvert[gm_List,n_Integer]:=
    PloidyWeightList[n]*((Plus@@Extract[gm,#])&/@PositionsList[n]);















GenotypeFrequencyConvert[n_Integer]:=GenotypeFrequencyConvert[n]=
      Compile[{{gm,_Real,2}},
        PositionsMatrix[n].Flatten[gm],
        {{PositionsMatrix[_],_Integer,2}}];







\!\(\(PositionsMatrix[
        n_Integer] := \(PositionsMatrix[n] = \[IndentingNewLine]MapThread[
          Flatten[ReplacePart[
                Array[0 &, {2\^n, 2\^n}], #2, #1]] &, {PositionsList[n], 
            PloidyWeightList[n]}]\);\)\)



StandardSet[nl_,f_]:=StandardSet[nl,f]=Table[Unique[f],{nl}];

StandardSet[nl_]:=
    StandardSet[nl]={StandardSet[nl-1,cw],StandardSet[2nl-1,cb]};

\!\(\(StandardSet[nl_, c_, 
        All] := \(StandardSet[nl, c, All] = \n\t\tStandardSet[2\^nl - nl - 1, 
          c]\);\)\)



\!\(\(MVariables::usage = \*"\"\<MVariables[n] lists all the coefficients \
\!\(m\_\(S, \\\\\\\ H\)\) needed to describe an n locus diploid genotype. \
MVariables[j,n] lists those of order j\[LessEqual]2n. MVariables[n, Family\
\[Rule]True] lists all the coefficients \!\(m\_\(S, \\\\\\\ H, \\\\\\\ SS, \\\
\\\\\ SH, \\\\\\\ HH\)\) needed for a pair of n locus  diploid genotypes. \
MVariables[j,n, Family\[Rule]True] lists those of order j\[LessEqual]4n. \
\>\"";\)\)

Options[MVariables]={Family\[Rule]False};

MVariables[n_Integer,opts___Rule]:=MVariables[n,opts]=
      If[Family/.{opts}/.Options[MVariables],
        Module[{S,H,SS,SH,HH},
          
          Flatten[Table[{S,H,SS,SH,HH},{S,0,n},{H,0,n-S},{SS,0,n-S-H},{SH,0,
                n-S-H-SS},{HH,0,n-S-H-SS-SH}],4]],
        Module[{S,H},
          Flatten[Table[{S,H},{S,0,n},{H,0,n-S}],1]]];

MVariables[j_Integer,n_Integer,opts___Rule]:=MVariables[j,n,opts]=
      If[Family/.{opts}/.Options[MVariables],
        Select[MVariables[n,opts],(#.{1,2,2,3,4}\[Equal]j)&],
        Select[MVariables[n,opts],(#.{1,2}\[Equal]j)&]];



MFromC::usage=
    "MFromC[c,{S,H}] gives the expression for M[S,H] in terms of c[i,j].  \
MFromC[c,{S,H,SS,SH,SS}] gives the expression for M[S,H,SS,SH,SS] in terms of \
c[i,j,k,l].";

\!\(\(MFromC[c_, {S_, H_}] := 
      Module[{S1, 
          S2}, \[IndentingNewLine]\[Sum]\+\(S1 = 0\)\%S Binomial[S, S1] 
              c[S1 + H, S - S1 + H] /. 
          c[i_, j_] \[RuleDelayed] c @@ Sort[{i, j}]];\)\)

\!\(\(MFromC[c_, {S_, H_, SS_, SH_, HH_}] := 
      Module[{S1, S2, S3, H1, SS1, SS2, SS3, SH1, SH2, 
          SH3}, \[IndentingNewLine]\[Sum]\+\(S1 = 0\)\%S\(\[Sum]\+\(S2 = \
0\)\%\(S - S1\)\(\[Sum]\+\(S3 = 0\)\%\(S - S1 - S2\)\(\[Sum]\+\(H1 = 0\)\%H\(\
\[Sum]\+\(SS1 = 0\)\%SS\(\[Sum]\+\(SS2 = 0\)\%\(SS - SS1\)\(\[Sum]\+\(SS3 = 0\
\)\%\(SS - SS1 - SS2\)\(\[Sum]\+\(SH1 = 0\)\%SH\(\[Sum]\+\(SH2 = 0\)\%\(SH - \
SH1\)\(\[Sum]\+\(SH3 = 0\)\%\(SH - SH1 - SH2\)Multinomial[S1, S2, S3, 
                                  S - S1 - S2 - S3\ ] Binomial[H, H1] 
                                Multinomial[SS1, SS2, SS3, 
                                  SS - SS1 - SS2 - SS3\ ] 
                                Multinomial[SH1, SH2, SH3, 
                                  SH - SH1 - SH2 - SH3\ ] 
                                c[S1 + H1 + SS1 + SS3 + SH1 + SH2 + SH3 + HH, 
                                  S2 + H1 + SS - SS1 - SS3 + SH - SH3 + HH, 
                                  S3 + H - H1 + SS1 + SS2 + SH - SH2 + HH, 
                                  S - S1 - S2 - S3 + H - H1 + SS - SS1 - 
                                    SS2 + SH - SH1 + HH]\)\)\)\)\)\)\)\)\) /. 
          c[i_, j_, k_, l_] \[RuleDelayed] 
            c @@ Flatten[Sort[{Sort[{i, j}], Sort[{k, l}]}]]];\)\)



MToCEquations::usage=
    "MToCEquations[m,c,n] gives the equations relating the coefficients \
m[S,H] to the c[j,k], for n loci.  MToCEquations[m,c,j,n] gives only the j'th \
order equations. MToCEquations[m,c,n,Family\[Rule]True] gives the equations \
relating the coefficients m[S,H,SS,SH,HH] to the c[i,j,k,l]";

MToCEquations[m_,c_,jn__Integer,opts___Rule]:=MToCEquations[m,c,jn,opts]=
      ((m@@#)==MFromC[c,#])&/@MVariables[jn,opts];



Family::usage=
    "Family\[Rule]True is an option for MToC[] which indicates that a family \
is involved";



MToC[m_,c_,jn__Integer,opts___Rule]:=MToC[m,c,jn,opts]=
      Module[{eqns=MToCEquations[m,c,jn,opts],ne,nv,vars},
        vars=Union[Extract[eqns,Position[eqns,c[__]]]];
        nv=Length[vars];ne=Length[eqns];
        If[ne>nv,
          Print["WARNING: more equations than variables for {j,n}=",{jn}];
          Print[TableForm[Eliminate[eqns,vars]]];{},
          Solve[eqns,vars]\[LeftDoubleBracket]1\[RightDoubleBracket]]];



MToCOld[m_,n_]:=Module[{a,b,j,eqns,vars,mat,c},
				eqns=(Table[
              m[a,b]==Sum[Binomial[a,j]c[j+b,a-j+b],{j,0,a}],{a,0,n},{b,0,
                n-a}]//Flatten)/.c[i_,j_]:>c@@Sort[{i,j}];
	eqns=DeleteCases[DeleteCases[eqns,m[0,0]==_],m[1,0]==_] ;
mat=Table[c[j,k],{j,0,n},{k,0,n}]/.c[i_,j_]:>c@@Sort[{i,j}];
vars=Union[mat//Flatten];
vars=DeleteCases[DeleteCases[vars,c[0,0]],c[0,1]];
mat/.Solve[eqns,vars]\[LeftDoubleBracket]1\[RightDoubleBracket]/.{c[0,
            0]\[Rule]1,c[0,1]\[Rule]0}]



EstimateMoments[g_List,p_List]:=EstimateMoments[g,p,Array[1&,Length[p]]];

\!\(\(EstimateMoments[g_List, p_List, \[Delta]p_List] := 
      Module[{nl = Length[p], z, \[Phi], dt, f, m, c}, \n\t
        dt = DiploidTypes[nl] /. {{a_Integer, b_Integer} :> a + b}; \n\t
        z = \(\((\((# - 2  p)\)/\[Delta]p)\) &\) /@ 
            dt; \n\t\[Phi] = \(\((\((Expand /@ \((p\^2 - # \((p + 
                                1\/2)\) + #\^2\/2)\))\)/\[Delta]p\^2)\) &\) /@ 
            dt; \nf[a_, b_] := \(f[a, b] = 
            g . Table[
                  ProductSum[{z\[LeftDoubleBracket]
                        j\[RightDoubleBracket], \[Phi]\[LeftDoubleBracket]
                        j\[RightDoubleBracket]}, {a, b}], {j, 
                    Length[dt]}]/\((\(nl!\)\/\(\(a!\) \(b!\) \(\((nl - a - b)\
\)!\)\))\)\); \n\t\(\(Array[c, {nl + 1, nl + 1}, 0] /. 
              c[i_, j_] \[RuleDelayed] c @@ Sort[{i, j}]\) /. 
            MToC[m, c, nl]\) /. m \[Rule] f];\)\)



\!\(\(FamilyM[ff_List, j_List, p_List, 
        opts___Rule] := \(FamilyM[ff, j, p, 
          opts] = \[IndentingNewLine]Mean[\(ProductSum[FamilyEffects[#, p, \
opts], j]\/Multinomial @@ Append[j, Length[p] - \((Plus @@ j)\)] &\) /@ 
            ff]\);\)\)



Options[FamilyEffects]={InferParentalGenotypes\[Rule]False};

\!\(\(FamilyEffects[f_, pp_, opts___Rule] := \(FamilyEffects[f, pp, opts] = 
        Module[{z, y, mz, vz, czy, dz, dy, my, vy, n = Length[f], jpg, 
            ipg = \(InferParentalGenotypes /. {opts}\) /. 
                Options[FamilyEffects]}, \[IndentingNewLine]If[
            ipg, \[IndentingNewLine]jpg = 
              ParentalGenotypes[f] /. {0 \[Rule] {0, 0}, 1 \[Rule] {0, 1}, 
                  2 \[Rule] {1, 1}}; \[IndentingNewLine]Transpose[
              Replace[\((\((Flatten /@ jpg)\) - 
                    pp)\), {\[Zeta]11_, \[Zeta]12_, \[Zeta]21_, \[Zeta]22_} \
\[Rule] {\[Zeta]11 + \[Zeta]12 + \[Zeta]21 + \[Zeta]22, \[Zeta]11\ \[Zeta]12 \
+ \[Zeta]21\ \[Zeta]22, \((\[Zeta]11 + \[Zeta]12)\) \((\[Zeta]21 + \[Zeta]22)\
\), \((\[Zeta]11 + \[Zeta]12)\) \[Zeta]21\ \[Zeta]22 + \[Zeta]11\ \[Zeta]12 \
\((\[Zeta]21 + \ \[Zeta]22)\), \[Zeta]11\ \[Zeta]12\ \[Zeta]21\ \[Zeta]22}, \
\(-1\)]], \[IndentingNewLine]z = 
              Replace[\((\(\((# - 2  pp)\) &\) /@ 
                    f)\), {_?\((\((\(! FreeQ[#, \[EmptySet]]\))\) &)\) \
\[RuleDelayed] \[EmptySet]}, {2}]; \[IndentingNewLine]y = 
              Replace[\((\(\((#\^2 - # \((1 + 2  pp)\) + 2  pp\^2)\) &\) /@ 
                    f)\), {_?\((\((\(! FreeQ[#, \[EmptySet]]\))\) &)\) \
\[RuleDelayed] \[EmptySet]}, {2}]; \[IndentingNewLine]dz = 
              DeleteCases[Transpose[z], \[EmptySet], 
                2]; \[IndentingNewLine]dy = 
              DeleteCases[Transpose[y], \[EmptySet], 2]/
                2; \[IndentingNewLine]mz = Mean /@ dz; 
            vz = VarianceMLE /@ dz; \[IndentingNewLine]my = Mean /@ dy; 
            vy = VarianceMLE /@ dy; \[IndentingNewLine]czy = 
              MapThread[
                CovarianceMLE[#1, #2] &, {dz, dy}]; \[IndentingNewLine]{2  
                mz, \[IndentingNewLine]mz\^2 - 
                2  my - \((\(n + 1\)\/\(n - 1\))\) vz, \[IndentingNewLine]4  
                my, \[IndentingNewLine]2  mz\ my - 
                2 \((\(n + 1\)\/\(n - 1\))\) czy, \[IndentingNewLine]vy + 
                my\^2 + 2 \( n\/\(n - 1\)\) \((my\ vz - mz\ czy)\)}]]\);\)\)



FamilyAlleleFrequencyEstimate[f_]:=
    Mean[(Mean/@DeleteCases[Transpose[#],\[EmptySet],2]/2)&/@f];



EstimateFamilyMoments[families_,c_[i_,j_,k_,l_],pp_,opts___Rule]:=Module[{m},
      (c @@Flatten[Sort[{Sort[{i,j}],Sort[{k,l}]}]])/.MToC[m,c,i+j+k+l,
            Length[pp],Family\[Rule]True]/.m[x__]\[RuleDelayed]
          FamilyM[families,{x},pp,opts]];





































































































































































































































































































































































































\!\(\*
  RowBox[{
    RowBox[{\(MakeOneWayTable[s_]\), ":=", 
      RowBox[{"Module", "[", 
        RowBox[{\({pl, j, nl = NumberOfLoci[s], lf, f}\), ",", 
          "\[IndentingNewLine]", 
          
          RowBox[{\(pl = \(\(AlleleFrequencyTable[s, nl] // N\) // 
                  Transpose\) // Last\), ";", "\[IndentingNewLine]", 
            RowBox[{\(lf[j_Integer, f_]\), ":=", 
              RowBox[{"(", 
                RowBox[{\(SelectLoci[{s, {j}}, s, {j}]\), ";", 
                  RowBox[{"-", 
                    RowBox[{"LogLikelihoodDisequilibrium", "[", 
                      
                      RowBox[{\({s, {j}}\), 
                        ",", \(pl\[LeftDoubleBracket]{j}\[RightDoubleBracket]\
\), ",", \({1}\), ",", 
                        RowBox[{"(", GridBox[{
                              {"1", "0"},
                              {"0", "f"}
                              }], ")"}], ",", \(Compiled \[Rule] True\)}], 
                      "]"}]}]}], ")"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
                RowBox[{
                  RowBox[{"fm", "=", 
                    RowBox[{"FindMinimum", "[", 
                      RowBox[{\(lf[j, f]\), ",", 
                        RowBox[{"{", 
                          RowBox[{"f", ",", 
                            RowBox[{
                              RowBox[{"MomentLimits", "[", 
                                
                                RowBox[{\({1, 1}\), 
                                  ",", \(pl\[LeftDoubleBracket]{j}\
\[RightDoubleBracket]\), ",", \({1}\), ",", 
                                  RowBox[{"(", GridBox[{
                                        {"1", "0"},
                                        {"0", "0"}
                                        }], ")"}]}], "]"}], "/", "2"}]}], 
                          "}"}]}], "]"}]}], ";", 
                  "\[IndentingNewLine]", \({pl\[LeftDoubleBracket]
                      j\[RightDoubleBracket], \(f /. fm\[LeftDoubleBracket]2\
\[RightDoubleBracket]\)\/\(pl\[LeftDoubleBracket]j\[RightDoubleBracket] \((1 \
- pl\[LeftDoubleBracket]j\[RightDoubleBracket])\)\), lf[j, 0]}\)}], 
                ",", \({j, NumberOfLoci[s]}\)}], "]"}]}]}], "]"}]}], ";"}]\)



\!\(\(PresentOneWayTable[s_] := 
      Prepend[Transpose[
          Prepend[Transpose[MakeOneWayTable[s]], 
            LocusNames[
              s]]], {"\<Locus\>", "\<p\>", \*"\"\<\!\(F\&^\)\>\"", "\<L\>"}];\
\)\)



\!\(\*
  RowBox[{
    RowBox[{\(MakePairwiseTable[s_]\), ":=", 
      RowBox[{"Module", "[", 
        RowBox[{\({pl, j, k, nl = NumberOfLoci[s], lf, fmA, fmF, fmD, fmFC, 
            mlF, mlD, mlFC, mlFD}\), ",", "\[IndentingNewLine]", 
          
          RowBox[{\(pl = \(\(AlleleFrequencyTable[s, nl] // N\) // 
                  Transpose\) // Last\), ";", 
            "\[IndentingNewLine]", \(lf[{j_Integer, k_Integer}, 
                c_] := \((SelectLoci[{s, {j, k}}, s, {j, k}]; 
                LogLikelihoodDisequilibrium[{s, {j, k}}, 
                  pl\[LeftDoubleBracket]{j, k}\[RightDoubleBracket], {1, 1}, 
                  c, Compiled \[Rule] True])\)\), ";", "\[IndentingNewLine]", 
            
            RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
                RowBox[{
                  RowBox[{"mlF", "=", 
                    RowBox[{
                      RowBox[{"MomentLimits", "[", 
                        
                        RowBox[{\({1, 1}\), 
                          ",", \(pl\[LeftDoubleBracket]{j, 
                              k}\[RightDoubleBracket]\), ",", \({1, 1}\), ",",
                           
                          RowBox[{"(", GridBox[{
                                {"1", "0", "0"},
                                {"0", "0", "0"},
                                {"0", "0", "0"}
                                }], ")"}]}], "]"}], "/", "2"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"fmF", "=", 
                    RowBox[{"FindMinimum", "[", 
                      RowBox[{
                        RowBox[{"-", 
                          RowBox[{"lf", "[", 
                            RowBox[{\({j, k}\), ",", 
                              RowBox[{"(", GridBox[{
                                    {"1", "0", "0"},
                                    {"0", "f", "0"},
                                    {"0", "0", "0"}
                                    }], ")"}]}], "]"}]}], ",", \({f, mlF}\)}],
                       "]"}]}], ";", "\[IndentingNewLine]", 
                  RowBox[{"mlFC", "=", 
                    RowBox[{
                      RowBox[{"MomentLimits", "[", 
                        
                        RowBox[{\({2, 2}\), 
                          ",", \(pl\[LeftDoubleBracket]{j, 
                              k}\[RightDoubleBracket]\), ",", \({1, 1}\), ",",
                           
                          RowBox[{"(", GridBox[{
                                {"1", "0", "0"},
                                {"0", "0", "0"},
                                {"0", "0", "0"}
                                }], ")"}]}], "]"}], "/", "2"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"fmFC", "=", 
                    RowBox[{"FindMinimum", "[", 
                      RowBox[{
                        RowBox[{"-", 
                          RowBox[{"lf", "[", 
                            RowBox[{\({j, k}\), ",", 
                              RowBox[{"(", GridBox[{
                                    {"1", "0", "0"},
                                    {"0", "f", "0"},
                                    {"0", "0", "fc"}
                                    }], ")"}]}], "]"}]}], ",", \({f, mlF}\), 
                        ",", \({fc, mlFC}\)}], "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"mlD", "=", 
                    RowBox[{
                      RowBox[{"MomentLimits", "[", 
                        
                        RowBox[{\({0, 2}\), 
                          ",", \(pl\[LeftDoubleBracket]{j, 
                              k}\[RightDoubleBracket]\), ",", \({1, 1}\), ",",
                           
                          RowBox[{"(", GridBox[{
                                {"1", "0", "0"},
                                {"0", "0", "0"},
                                {"0", "0", "0"}
                                }], ")"}]}], "]"}], "/", "2"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"fmD", "=", 
                    RowBox[{"FindMinimum", "[", 
                      RowBox[{
                        RowBox[{"-", 
                          RowBox[{"lf", "[", 
                            RowBox[{\({j, k}\), ",", 
                              RowBox[{"(", GridBox[{
                                    {"1", "0", "d"},
                                    {"0", "0", "0"},
                                    {"d", "0", \(d\^2\)}
                                    }], ")"}]}], "]"}]}], ",", \({d, mlD}\)}],
                       "]"}]}], ";", "\[IndentingNewLine]", 
                  "\[IndentingNewLine]", 
                  RowBox[{"mlFD", "=", 
                    RowBox[{
                      RowBox[{"MomentLimits", "[", 
                        
                        RowBox[{\({1, 2}\), 
                          ",", \(pl\[LeftDoubleBracket]{j, 
                              k}\[RightDoubleBracket]\), ",", \({1, 1}\), ",",
                           
                          RowBox[{"(", GridBox[{
                                {"1", "0", "0"},
                                {"0", "0", "0"},
                                {"0", "0", "0"}
                                }], ")"}]}], "]"}], "/", "2"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"fmA", "=", 
                    RowBox[{"FindMinimum", "[", 
                      RowBox[{
                        RowBox[{"-", 
                          RowBox[{"lf", "[", 
                            RowBox[{\({j, k}\), ",", 
                              RowBox[{"(", GridBox[{
                                    {"1", "0", "d"},
                                    {"0", "f", "df"},
                                    {"d", "df", "fc"}
                                    }], ")"}]}], "]"}]}], ",", \({f, mlF}\), 
                        ",", \({fc, mlFC}\), ",", \({d, mlD}\), 
                        ",", \({df, mlFD}\), 
                        ",", \(MaxIterations \[Rule] 100\)}], "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"{", 
                    RowBox[{
                      RowBox[{"{", 
                        RowBox[{
                          RowBox[{"lf", "[", 
                            RowBox[{\({j, k}\), ",", 
                              RowBox[{"(", GridBox[{
                                    {"1", "0", "0"},
                                    {"0", "0", "0"},
                                    {"0", "0", "0"}
                                    }], ")"}]}], "]"}], 
                          ",", \({0, 0, 0, 0}\)}], "}"}], ",", 
                      "\[IndentingNewLine]", \({\(-fmF\[LeftDoubleBracket]1\
\[RightDoubleBracket]\), {f, 0, 0, 0} /. 
                          fmF\[LeftDoubleBracket]2\[RightDoubleBracket]}\), 
                      ",", "\[IndentingNewLine]", \({\(-fmD\
\[LeftDoubleBracket]1\[RightDoubleBracket]\), {0, d, 0, 0} /. 
                          fmD\[LeftDoubleBracket]2\[RightDoubleBracket]}\), 
                      ",", "\[IndentingNewLine]", \({\(-fmFC\
\[LeftDoubleBracket]1\[RightDoubleBracket]\), {f, 0, 0, fc} /. 
                          fmFC\[LeftDoubleBracket]2\[RightDoubleBracket]}\), 
                      ",", "\[IndentingNewLine]", \({\(-fmA\
\[LeftDoubleBracket]1\[RightDoubleBracket]\), {f, d, df, fc} /. 
                          fmA\[LeftDoubleBracket]2\[RightDoubleBracket]}\)}], 
                    "}"}]}], ",", \({j, 2, nl}\), ",", \({k, j - 1}\)}], 
              "]"}]}]}], "]"}]}], ";"}]\)



\!\(\(PresentPairwiseTable[s_] := 
      Module[{nl = NumberOfLoci[s], rd, pl}, \[IndentingNewLine]rd = 
          ReducedData[s, 
            nl]; \[IndentingNewLine]pl = \(\(AlleleFrequencyTable[s, nl] // 
                N\) // Transpose\) // 
            Last; \[IndentingNewLine]PresentPairwiseTable[
          MakePairwiseTable[s], LocusNames[s], 
          EstimateMoments[rd\/Plus @@ rd, pl]]];\)\)

\!\(\(PresentPairwiseTable[tbl_List, 
        ln_List] := \[IndentingNewLine]Module[{j, k, 
          t}, \[IndentingNewLine]Prepend[\[IndentingNewLine]Flatten[
            Table[\[IndentingNewLine]t = 
                tbl\[LeftDoubleBracket]j - 1, k\[RightDoubleBracket]; 
              l0 = t\[LeftDoubleBracket]1, 
                  1\[RightDoubleBracket]; \[IndentingNewLine]Flatten[{ln\
\[LeftDoubleBracket]j\[RightDoubleBracket], 
                  ln\[LeftDoubleBracket]
                    k\[RightDoubleBracket], \[IndentingNewLine]t\
\[LeftDoubleBracket]2, 2, 1\[RightDoubleBracket], 
                  t\[LeftDoubleBracket]2, 1\[RightDoubleBracket] - 
                    l0, \[IndentingNewLine]t\[LeftDoubleBracket]3, 2, 
                    2\[RightDoubleBracket], 
                  t\[LeftDoubleBracket]3, 1\[RightDoubleBracket] - 
                    l0, \[IndentingNewLine]t\[LeftDoubleBracket]4, 2, 
                    1\[RightDoubleBracket], 
                  t\[LeftDoubleBracket]4, 2, 4\[RightDoubleBracket], 
                  t\[LeftDoubleBracket]4, 1\[RightDoubleBracket] - 
                    l0, \[IndentingNewLine]t\[LeftDoubleBracket]5, 
                    2\[RightDoubleBracket], 
                  t\[LeftDoubleBracket]5, 1\[RightDoubleBracket] - 
                    l0}], \[IndentingNewLine]{j, 2, Length[tbl] + 1}, {k, 
                j - 1}], 
            1], \[IndentingNewLine]{"\<Locus 1\>", "\<Locus 2\>", "\<F\>", \
"\<L\>", "\<D\>", "\<L\>", "\<F\>", \*"\"\<cov[\!\(F\_1\),\!\(F\_2\)]\>\"", "\
\<L\>", "\<F\>", "\<D\>", "\<cov[F,D]\>", \*"\"\<cov[\!\(F\_1\),\!\(F\_2\)]\>\
\"", "\<L\>"}]];\)\)

PresentPairwiseTable[tbl_List,ln_List,c_List]:=
    
    Append[PresentPairwiseTable[tbl,ln],{"All","",
        c\[LeftDoubleBracket]2,2\[RightDoubleBracket],"",
        c\[LeftDoubleBracket]1,3\[RightDoubleBracket],"",
        c\[LeftDoubleBracket]2,2\[RightDoubleBracket],
        c\[LeftDoubleBracket]3,3\[RightDoubleBracket],"",
        c\[LeftDoubleBracket]2,2\[RightDoubleBracket],
        c\[LeftDoubleBracket]1,3\[RightDoubleBracket],
        c\[LeftDoubleBracket]2,3\[RightDoubleBracket],
        c\[LeftDoubleBracket]3,3\[RightDoubleBracket],""}];





\!\(\(LogLikelihoodDisequilibriumReduced[s_, cl_, p_] := 
      Module[{M, \[CapitalGamma], gv, nl = Length[p], rd}, \n\t
        rd = ReducedData[s, nl]; \n\t\tM = \(MomentReduced[nl]\)[
            cl // Flatten]; \[CapitalGamma] = 
          Matrix\[CapitalGamma][p, nl]; \n\t\tgv = 
          GenotypeFrequencyConvert[\[CapitalGamma] . M . 
              Transpose[\[CapitalGamma]], nl]; \n\t
        If[Min[gv] \[GreaterEqual] 
            0, \(LogLikelihoodDisequilibrium[Plus @@ rd]\)[10\^\(-20\) + rd, 
            gv], \(-10\^10\)]];\)\)

\!\(\(\(\n\)\(LogLikelihoodDisequilibriumReduced[s_, cl_, \[Delta]p_, p_, 
        old] := \n\t\tModule[{nt, 
          rd = Transpose[
              Select[ReducedData[s, Length[S], 
                    Detail \[Rule] True] /. {{a_Integer, b_Integer} :> 
                      a + b}, \((#[\([1]\)] > 0)\) &]]}, \n\t\ nt = 
          Plus @@ rd\[LeftDoubleBracket]1\[RightDoubleBracket]; \n
        nt\ Log[nt] + 
          rd\[LeftDoubleBracket]1\[RightDoubleBracket] . 
            Log[\(DiploidGenotypeFrequencyTable[#, cl, \[Delta]p, p] &\) /@ \
rd\[LeftDoubleBracket]2\[RightDoubleBracket]\/rd\[LeftDoubleBracket]1\
\[RightDoubleBracket]]];\)\)\)

\!\(\(LogLikelihoodDisequilibriumReduced[s_, cl_, \[Delta]p_, 
        p_] := \n\t\tModule[{nt, nl = NumberOfLoci[s], 
          rd = Transpose[
              Select[ReducedData[s, NumberOfLoci[s], 
                    Detail \[Rule] True] /. {{a_Integer, b_Integer} :> 
                      a + b}, \((#[\([1]\)] > 0)\) &]], vv}, \n\t
        vv = Flatten[{p /@ Range[nl], cl}]; \ 
        nt = Plus @@ rd\[LeftDoubleBracket]1\[RightDoubleBracket]; \n
        nt\ Log[nt] + 
          rd\[LeftDoubleBracket]1\[RightDoubleBracket] . 
            Log[\(\((DiploidGenotypeFrequencyTable[#, \[Delta]p] @@ vv)\) &\) \
/@ rd\[LeftDoubleBracket]2\[RightDoubleBracket]\/rd\[LeftDoubleBracket]1\
\[RightDoubleBracket]]];\)\)

\!\(\(\(\n\)\(LogLikelihoodDisequilibriumReduced[s_, {cw_, cb_}, \[Delta]p_, 
        p_, S_List] := \n\t\tModule[{nt, 
          rd = Transpose[
              Select[ReducedData[s, Length[S], 
                    Detail \[Rule] True] /. {{a_Integer, b_Integer} :> 
                      a + b}, \((#[\([1]\)] > 0)\) &]]}, \n\t\ \ \ nt = 
          Plus @@ rd\[LeftDoubleBracket]1\[RightDoubleBracket]; \n\t
        nt\ Log[nt] + 
          rd\[LeftDoubleBracket]1\[RightDoubleBracket] . 
            Log[\(1\/rd\[LeftDoubleBracket]1\[RightDoubleBracket]\) \
\((\(DiploidGenotypeFrequencyTable[#, {cw, cb}, \[Delta]p, p, S] &\) /@ 
                    rd\[LeftDoubleBracket]2\[RightDoubleBracket])\)]];\)\)\)

\!\(\(\(\n\)\(LogLikelihoodDisequilibriumReduced[s_, {cw_, cb_}, \[Delta]p_, 
        p_, S_List, 
        gdt_] := \n\t\tModule[{nt, 
          rd = Transpose[
              Select[ReducedData[s, Length[S], 
                    Detail \[Rule] True] /. {{a_Integer, b_Integer} :> 
                      a + b}, \((#[\([1]\)] > 0)\) &]]}, \n\t\ \ \ gdt[
            X_] := \(gdt[X] = 
            DiploidGenotypeFrequencyTable[X, {cw, cb}, \[Delta]p, p, 
              S]\); \n\t\tnt = 
          Plus @@ rd\[LeftDoubleBracket]1\[RightDoubleBracket]; \n\t
        nt\ Log[nt] + 
          rd\[LeftDoubleBracket]1\[RightDoubleBracket] . 
            Log[gdt /@ rd\[LeftDoubleBracket]2\[RightDoubleBracket]\/rd\
\[LeftDoubleBracket]1\[RightDoubleBracket]]];\)\)\)



Options[LogLikelihoodDisequilibrium]={Symmetric\[Rule]True,
      Compiled\[Rule]False};

LogLikelihoodDisequilibrium[nt_Integer]:=LogLikelihoodDisequilibrium[nt]=
		Compile[{{o,_Real,1},{e,_Real,1}},
nt Log[nt]+o.Log[e/o]];

\!\(\(LogLikelihoodDisequilibrium[s_, p_, \[Delta]p_, cl_, 
        opts___Rule] := \n\t
      Module[{gv, rd, nl = NumberOfLoci[s], sm, nt, 
          rdgv}, \n\t\ \ \ sm = \(Symmetric /. {opts}\) /. 
            Options[LogLikelihoodDisequilibrium]; \n\t\trd = 
          ReducedData[s, nl]; nt = Plus @@ rd; 
        If[\(Compiled /. {opts}\) /. 
            Options[LogLikelihoodDisequilibrium], \n\t\t\tgv = 
            If[sm, \n\t\t\t\t\
GenotypeFrequencyConvert[\(DiploidGenotypeFrequencyList[nl, 
                    Symmetric \[Rule] True]\)[p, \[Delta]p, cl], 
                nl], \n\t\t\t\t\
GenotypeFrequencyConvert[\(DiploidGenotypeFrequencyList[nl]\)[p, \[Delta]p, 
                  cl], nl]]; \n\t\t\trdgv = 
            Transpose[
              DeleteCases[
                Transpose[{ReducedData[s, nl], gv}], {0, _}]]; \n\t\tIf[
            Min[gv] \[GreaterEqual] 0, \(LogLikelihoodDisequilibrium[nt]\)[
              rdgv\[LeftDoubleBracket]1\[RightDoubleBracket], 
              rdgv\[LeftDoubleBracket]2\[RightDoubleBracket]], \(-10\^10\)], \
\n\t\t\ gv = 
            GenotypeFrequencyConvert[
              DiploidGenotypeFrequencyList[p, \[Delta]p, cl, 
                Symmetric \[Rule] sm], nl]; \n\t\trdgv = 
            Transpose[
              DeleteCases[Transpose[{ReducedData[s, nl], gv}], {0, _}]]; \n\t
          nt\ Log[nt] + 
            rdgv\[LeftDoubleBracket]1\[RightDoubleBracket] . 
              Log[rdgv\[LeftDoubleBracket]2\[RightDoubleBracket]/
                  rdgv\[LeftDoubleBracket]1\[RightDoubleBracket]]]];\)\)













































































\!\(\(MLEDisequilibrium[s_, 
        c_[k_Integer], {cw_, cb_}, {cwl_List, cbl_List}, \[Delta]p_, p_, S_] := 
      Module[{\[Epsilon] = 0.001, lims, x, ff}, \n\t\tlims = 
          If[c === cb, \n\t\t\t\tMomentLimitsDiploid[
              k, {cw, cb}, {cwl, cbl}, \[Delta]p, p, 
              S], \n\t\t\t\tMomentLimits[k, cw, cwl, \[Delta]p, p, 
              S]]; \n\t\tff = \((LogLikelihoodDisequilibrium[
                  s, {cw, cb}, \[Delta]p, p, S] /. c[k] -> x)\) /. {cw[j_] :> 
                cwl\[LeftDoubleBracket]j - 1\[RightDoubleBracket], 
              cb[j_] :> cbl\[LeftDoubleBracket]
                  j - 1\[RightDoubleBracket]}; \n\t
        If[\((D[ff, x] /. 
                x -> lims\[LeftDoubleBracket]1\[RightDoubleBracket] \((1 - \
\[Epsilon])\) + \[Epsilon]\[VeryThinSpace]lims\[LeftDoubleBracket]2\
\[RightDoubleBracket])\) < 0, 
          lims\[LeftDoubleBracket]1\[RightDoubleBracket], \t
          If[\((D[ff, x] /. 
                  x -> lims\[LeftDoubleBracket]2\[RightDoubleBracket] \((1 - \
\[Epsilon])\) + \[Epsilon]\[VeryThinSpace]lims\[LeftDoubleBracket]1\
\[RightDoubleBracket])\) > 0, 
            lims\[LeftDoubleBracket]2\[RightDoubleBracket], \n\t\t\tx /. \
\(FindMinimum[\(-ff\), {x, \(lims\[LeftDoubleBracket]1\[RightDoubleBracket] + \
lims\[LeftDoubleBracket]2\[RightDoubleBracket]\)\/2}]\)[\([2]\)]]]];\)\)



Options[MetropolisDisequilibrium]={Cumulant\[Rule]True};

\!\(\(MetropolisDisequilibrium[s_, 
        T_, {nt_, npr_}, {_, {{p0_List}, {\[Delta]p0_List}, c0_List}, 
          st0_List}, opts___Rule] := \n\t
      Module[{nl = NumberOfLoci[s], j1, j2, j3, na = 0, nr = 0, ncl, cl = c0, 
          p = p0 // N, \[Delta]p = \[Delta]p0 // N, step = st0, ll, nll, np, 
          n\[Delta]p, \[CapitalGamma], n\[CapitalGamma], gv, 
          ngv, \n\t\trd = ReducedData[s, NumberOfLoci[s]], nz, obs, ntot, 
          newCl, newP, new\[Delta]P, accept, reject, threshold, tr}, \n\t
        If[\(Cumulant /. {opts}\) /. 
            Options[MetropolisDisequilibrium], \n\t\t\ttr[
              c_] := \(Moment[nl]\)[c], \n\t\t\ttr[m_] := 
            m\ ]; \n\t\tthreshold[d_] := 
          If[T <= 0, \((d > 0)\), Exp[d/T] > Random[]]; \n\t\tnz = 
          Position[rd, _?\((\((# > 0)\) &)\)]; \n\t\tobs = Extract[rd, nz]; \ 
        ntot = Plus @@ 
            obs; \n\t\tnewP := \((np = 
              ReplacePart[p, 
                p[\([j3]\)] + \((2  Random[] - 1)\) step[\([1, 1, j3]\)], 
                j3]; \n\t\t\t\tn\[Delta]p = \[Delta]p; 
            n\[CapitalGamma] = \(Matrix\[CapitalGamma][nl]\)[np, n\[Delta]p]; 
            ncl = cl)\); \n\t\tnew\[Delta]P := \((np = 
              p; \n\t\t\t\tn\[Delta]p = 
              ReplacePart[\[Delta]p, \[Delta]p[\([j3]\)] + \((2  Random[] - 
                        1)\) step[\([2, 1, j3]\)], 
                j3]; \n\t\t\t\tn\[Delta]p = 
              n\[Delta]p/\((Times @@ n\[Delta]p)\)\^\(1/nl\); \n\t\t\t\tn\
\[CapitalGamma] = \(Matrix\[CapitalGamma][nl]\)[np, n\[Delta]p]; 
            ncl = cl)\); \n\t\tnewCl := \ \((ncl = 
              ReplacePart[cl, 
                cl[\([j2, j3]\)] + \((2  Random[] - 1)\) 
                    step[\([j1, j2, j3]\)], {j2, 
                  j3}]; \[IndentingNewLine]ncl = 
              ReplacePart[ncl, 
                ncl[\([j2, j3]\)], {j3, 
                  j2}]; \[IndentingNewLine]n\[CapitalGamma] = \
\[CapitalGamma]; np = p; n\[Delta]p = \[Delta]p)\); \n\t
        accept := \t\((cl = ncl; ll = nll; gv = ngv; 
            p = np; \[Delta]p = n\[Delta]p; \[CapitalGamma] = 
              n\[CapitalGamma]; \n\t\t\t\tstep\[LeftDoubleBracket]j1, j2, 
                j3\[RightDoubleBracket] /= $MetropolisAdjustment; \
\(na++\))\); \n\t
        reject := \((step\[LeftDoubleBracket]j1, j2, 
                j3\[RightDoubleBracket] *= $MetropolisAdjustment; \
\(nr++\))\); \n\t\[CapitalGamma] = \(Matrix\[CapitalGamma][nl]\)[
            p, \[Delta]p]; 
        gv = \[CapitalGamma] . tr[cl] . Transpose[\[CapitalGamma]]; \n\t
        ll = If[Min[gv] \[GreaterEqual] 
              0, \(LogLikelihoodDisequilibrium[ntot]\)[obs, 
              Extract[GenotypeFrequencyConvert[gv, nl], 
                nz]], \(-10\^10\)]; \[IndentingNewLine]Do[
          Do[If[step\[LeftDoubleBracket]j1, j2, j3\[RightDoubleBracket] > 
                0, \[IndentingNewLine]\((Switch[j1, 1, newP, 2, new\[Delta]P, 
                  3, newCl]; \[IndentingNewLine]ngv = 
                  n\[CapitalGamma] . tr[ncl] . 
                    Transpose[n\[CapitalGamma]]; \[IndentingNewLine]If[
                  Min[ngv] < 0, 
                  reject, \[IndentingNewLine]\((nll = \
\(LogLikelihoodDisequilibrium[ntot]\)[obs, 
                        Extract[GenotypeFrequencyConvert[ngv, nl], nz]]; \n\t
                    If[threshold[nll - ll], accept, 
                      reject])\)])\)], \n\t\t\t\t{j1, 1, 3}, {j2, 1, 
              If[j1 < 3, 1, nl + 1]}, {j3, 1, 
              If[j1 < 3, nl, j2]}]; \[IndentingNewLine]If[
            Mod[kk, npr] \[Equal] 0, \t\n\t\t\t\tPrint[kk, Tab, "\<T=\>", T, 
              Tab, \n\t\t\t\t\t"\<log(L)=\>", ll, Tab, "\<% accepted=\>", 
              If[na + nr == 0, "\<?? none tried\>", \((na\/\(na + nr\))\) // 
                  N]]\n\t\t\t], {kk, nt}]; \n\t\ {ll, {{p}, {\[Delta]p}, cl}, 
          step}];\)\)



\!\(\(MetropolisDisequilibriumReduced[s_, 
        T_, {nt_, npr_}, {_, {pp_List, cll_List}, st0_List}] := \n\t
      Module[{nl = NumberOfLoci[s], j, na = 0, nr = 0, 
          p = Flatten[pp], \n\t\t\tcl = Flatten[cll], ncl, ll, nll, 
          np, \[CapitalGamma], M, nM, n\[CapitalGamma], gv, 
          ngv, \n\t\t\tstep = Flatten[st0], 
          rd = ReducedData[s, NumberOfLoci[s]], nz, obs, ntot}, \n\t\ \ nz = 
          Position[rd, _?\((\((# > 0)\) &)\)]; \n\t\tobs = Extract[rd, nz]; \ 
        ntot = Plus @@ obs; \n\t\ M = \(MomentReduced[nl]\)[
            cl]; \[CapitalGamma] = Matrix\[CapitalGamma][p, nl]; \n\t\tgv = 
          GenotypeFrequencyConvert[\[CapitalGamma] . M . 
              Transpose[\[CapitalGamma]], nl]; \n\t\tll = 
          If[Min[gv] \[GreaterEqual] 
              0, \n\t\t\t\t\(LogLikelihoodDisequilibrium[ntot]\)[obs, 
              Extract[gv, nz]], \n\t\t\t\t\(-10\^10\)]; \n\t
        Do[Do[If[
              step[\([j]\)] > 
                0, \n\t\t\t\t\t\((If[
                  j > nl, \n\t\t\t\t\t\t\ ncl = 
                    ReplacePart[cl, 
                      cl\[LeftDoubleBracket]j - 
                            nl\[RightDoubleBracket] + \((2  Random[] - 1)\) 
                          step\[LeftDoubleBracket]j\[RightDoubleBracket], 
                      j - nl]; \n\t\t\t\t\t\t\ \ \ \ n\[CapitalGamma] = \
\[CapitalGamma]; np = p; 
                  nM = \(MomentReduced[nl]\)[ncl], \n\t\t\t\t\t\t\t\ np = 
                    ReplacePart[p, 
                      p[\([j]\)] + \((2  Random[] - 1)\) step[\([j]\)], 
                      j]; \n\t\t\t\t\t\t\ \ n\[CapitalGamma] = 
                    Matrix\[CapitalGamma][np, nl]; nM = M; 
                  ncl = cl]; \n\t\t\t\t\t\tngv = 
                  GenotypeFrequencyConvert[
                    n\[CapitalGamma] . nM . Transpose[n\[CapitalGamma]], 
                    nl]; \nIf[
                  Min[ngv] \[GreaterEqual] 
                    0, \n\t\t\t\t\t\t\t\((nll = \(LogLikelihoodDisequilibrium[
                          ntot]\)[obs, Extract[ngv, nz]]; \n\t\tIf[
                      T <= 0, \n\t\t\t\t\t\t\t\t\tIf[
                        nll > ll, \n\t\t\t\t\t\t\t\t\t\tcl = ncl; ll = nll; 
                        gv = ngv; M = nM; 
                        p = np; \[CapitalGamma] = 
                          n\[CapitalGamma]; \n\t\t\t\t\t\t\t\t\t\tstep\
\[LeftDoubleBracket]
                            j\[RightDoubleBracket] /= $MetropolisAdjustment; \
\(na++\), \n\t\t\t\t\t\t\t\t\t\tstep\[LeftDoubleBracket]
                            j\[RightDoubleBracket] *= $MetropolisAdjustment; \
\(nr++\)], \n\t\t\t\t\t\t\t\t\ \ If[
                        Exp[\((nll - ll)\)/T] > 
                          Random[], \n\t\t\t\t\t\t\t\t\t\tcl = ncl; ll = nll; 
                        gv = ngv; M = nM; 
                        p = np; \[CapitalGamma] = 
                          n\[CapitalGamma]; \n\t\t\t\t\t\t\t\t\t\tstep\
\[LeftDoubleBracket]j\[RightDoubleBracket] /= $MetropolisAdjustment; \
\(na++\), \n\t\t\t\t\t\t\t\t\t\t\
step\[LeftDoubleBracket]
                                        j\[RightDoubleBracket] *= \
$MetropolisAdjustment; \(nr++\)]])\), \n\t\t\t\tstep\[LeftDoubleBracket]
                      j\[RightDoubleBracket] *= $MetropolisAdjustment; \(nr\
++\)])\)], {j, 1, 4  nl - 2}]; \n\t\t\t\t\t\tIf[
            Mod[kk, npr] == 0, \t\n\t\t\t\tPrint[kk, 
              Tab, \n\t\t\t\t\t"\<  log(L)=\>", ll, 
              Tab, "\<% accepted=\>", \((na\/\(na + nr\))\) // N]], {kk, 
            nt}]; \n\t\ {ll, {p, cl}, step}];\)\)



$MetropolisAdjustment=0.95;



InitialStepReduced[{cw_,cb_},cl_,\[Delta]p_,p_,S_List]:=
    InitialStepReduced[{cw,cb},cl,\[Delta]p,p,S]=
		Module[{tlims,vars,vv=Flatten[cl],st,nl=Length[S],
          cs=HaploidConstraints[cw,\[Delta]p,p,S],
          cds=DiploidConstraints[{cw,cb},\[Delta]p,p,S]},
	tlims=Transpose[
            Join[Map[MomentLimitsReduced[# ,cl[[1]],cs]&,
                Table[cw[j],{j,2,nl}]],
              Map[MomentLimitsDiploid[#,{cw,cb} ,cl,cds]&,
                Table[cb[j],{j,2,2nl}]]]];
 	st=Map[Min,{tlims\[LeftDoubleBracket]2\[RightDoubleBracket]-vv,
                vv-tlims\[LeftDoubleBracket]1\[RightDoubleBracket]}//
              Transpose];
{Take[st,nl-1],Take[st,-(2nl-1)]}];



InitialStep[p_List,\[Delta]p_List,cl_List]:=InitialStep[p,\[Delta]p,cl]=
		Module[{nl=Length[p],j,k,ff,ll},
ff[0,0]=0;ff[0,1]=0;ff[1,0]=0;
			ff[j_,k_]:=
          ff[j,k]=If[
              j<=k,(ll=
                  MomentLimits[{j,k},p,\[Delta]p,
                    cl]);(ll\[LeftDoubleBracket]2\[RightDoubleBracket]-
                    ll\[LeftDoubleBracket]1\[RightDoubleBracket])/2,ff[k,j]];
        Table[ff[j,k],{j,0,nl},{k,0,nl}]];





HaploidConstraints[c_,\[Delta]p_,p_,S_]:=
    Map[(FullGenotypeFrequencyReduced[#,c,\[Delta]p,p,S]>0)&,
      HaploidTypes[Length[S]]];



DiploidConstraints[{cw_,cb_},\[Delta]p_,p_,
      S_List]:=(DiploidGenotypeFrequencyTable[#,{cw,cb},\[Delta]p,p,S]>
            0)&/@(DiploidTypes[Length[S]]/.{{a_Integer,b_Integer}:>a+b});

DiploidConstraints[{cw_,cb_},\[Delta]p_,p_,S_,
      gdt_]:=(gdt[X_]:=
        gdt[X]=DiploidGenotypeFrequencyTable[X,{cw,cb},\[Delta]p,p,S];
(gdt[#]>0)&/@(DiploidTypes[Length[S]]/.{{a_Integer,b_Integer}:>a+b}));









MomentLimitsReduced[c_[k_Integer],cl_List,\[Delta]p_,p_,S_]:=
    MomentLimitsReduced[c[k],cl,HaploidConstraints[c,\[Delta]p,p,S]];

MomentLimitsReduced[c_[k_Integer],cl_List,ccs__]:=Module[{x,cs,ints,n},
		cs=DeleteCases[(ccs/.c[k]->x/.c[j_]:>
                  cl\[LeftDoubleBracket]j-1\[RightDoubleBracket])//Chop,
          True];
ints=IntervalCombine@@Map[ConstrainedIntervals[#,x]&,cs];
n=Length[ints];
If[n>1,Print["WARNING: genotype frequencies valid only in disjunct regions. ",
          ints]];
{ints\[LeftDoubleBracket]1,1\[RightDoubleBracket],
        ints\[LeftDoubleBracket]n,2\[RightDoubleBracket]}];



\!\(\(MomentLimits[{j_, k_}, p_List, \[Delta]p_List, c_List] := 
      Module[{nl = Length[p], ct, cs, \[CapitalGamma], x, jj, kk, cmin, 
          cmax}, \n\t\tct = 
          ReplacePart[c, x, {j + 1, k + 1}]; \n\t\t\[CapitalGamma] = 
          Matrix\[CapitalGamma][p, \[Delta]p, nl]; 
        gv = \[CapitalGamma] . ct . Transpose[\[CapitalGamma]]; \n\t\tcs = 
          Table[Expand[gv\[LeftDoubleBracket]jj, kk\[RightDoubleBracket]] > 
              0, {jj, 1, 2\^nl}, {kk, 1, jj}]; \ \n\t\tcs = 
          DeleteCases[cs // Flatten, True]; \n\t
        cmin = Check[\(ConstrainedMin[x, 
                cs, {x}]\)\[LeftDoubleBracket]1\[RightDoubleBracket], \
\(-\(ConstrainedMax[y, 
                  cs /. x -> \(-y\), {y}]\)\[LeftDoubleBracket]1\
\[RightDoubleBracket]\), ConstrainedMax::nsatt]; \n\t\tIf[cmin == 0, 
          cmin = \(-\(ConstrainedMax[y, 
                  cs /. x -> \(-y\), {y}]\)\[LeftDoubleBracket]1\
\[RightDoubleBracket]\)]; \n\t\tcmax = 
          Check[\(ConstrainedMax[x, 
                cs, {x}]\)\[LeftDoubleBracket]1\[RightDoubleBracket], \
\(-\(ConstrainedMin[y, 
                  cs /. x -> \(-y\), {y}]\)\[LeftDoubleBracket]1\
\[RightDoubleBracket]\), ConstrainedMax::nsatt]; \n\t\t\tIf[cmax == 0, 
          cmax = \(-\(ConstrainedMin[y, 
                  cs /. x -> \(-y\), {y}]\)\[LeftDoubleBracket]1\
\[RightDoubleBracket]\)]; \n
        If[\((Head[cmin] === Symbol)\) || \((Head[cmax] === Symbol)\), {0, 
            0}, {cmin, cmax}]];\)\)



ConstrainedIntervals[c_List,x_]:=Min[Map[ConstrainedIntervals[#,x]&,c]];
ConstrainedIntervals[Less[a_,b_],x_]:=ConstrainedIntervals[b>a,x];
ConstrainedIntervals[Greater[a_,b_],x_]:=ConstrainedIntervals[a-b>0,x];
ConstrainedIntervals[a_>0,x_]:=Module[{roots,f},
			If[PolynomialQ[a,x],
			 (roots=Select[x/.NSolve[a==0,x], (Chop[Im[#]]==0)&];
		      If[roots=={},
            If[(a/.x->0)>
                0,{{-\[Infinity],\[Infinity]}},{}],(If[(a/.x->(First[
                              roots]-1))>0,
                roots=Prepend[roots,-\[Infinity]]];
				If[(a/.x->(Last[roots]+1))>0,roots=Append[roots,\[Infinity]]];
					Partition[roots,2])]),
			Print["Error: constraint not polynomial in ",x]]];



IntervalCombine[a_List,b_List,c__List]:=
    IntervalCombine[IntervalCombine[a,b],c];

IntervalCombine[a_List,b_List]:=Module[{ps,aps,ll},
		Flatten[Map[(ps=Map[IntervalPosition[a,#]&,#];
				aps=Abs[ps];
			 ll=If[ps\[LeftDoubleBracket]1\[RightDoubleBracket]>0,
						ReplacePart[
                    Table[a\[LeftDoubleBracket]j\[RightDoubleBracket],{j,
                        aps\[LeftDoubleBracket]1\[RightDoubleBracket],
                        aps\[LeftDoubleBracket]2\[RightDoubleBracket]}],#\
\[LeftDoubleBracket]1\[RightDoubleBracket],{1,1}],
				    Table[
                    a\[LeftDoubleBracket]j\[RightDoubleBracket],{j,
                      aps\[LeftDoubleBracket]1\[RightDoubleBracket]+1,
                      aps\[LeftDoubleBracket]2\[RightDoubleBracket]}]];
			If[ps\[LeftDoubleBracket]2\[RightDoubleBracket]>0,	
                ReplacePart[
                  ll,#\[LeftDoubleBracket]2\[RightDoubleBracket],{Length[ll],
                    2}],ll])&,b],1]];



IntervalPosition[ints_List,z_]:=Module[{p},
		p=Position[Sort[Prepend[Flatten[ints],z],(#1<#2)&],z][[1,1]];
		If[OddQ[p],-1,1]Quotient[p,2]];





























MomentLimitsDiploid[cb_[k_Integer],{cw_,cb_},{cwl_List,cbl_List},\[Delta]p_,
      p_,S_]:=
	
    MomentLimitsDiploid[cb[k],{cw,cb},{cwl,cbl},
      DiploidConstraints[{cw,cb},\[Delta]p,p,S]];

MomentLimitsDiploid[c_[k_Integer],{cw_,cb_},{cwl_List,cbl_List},ccs_]:=
    Module[{x,cs,ints,n},
		cs=DeleteCases[(ccs/.c[k]->x/.{cw[j_]:>
                    cwl\[LeftDoubleBracket]j-1\[RightDoubleBracket],
                  cb[j_]:>cbl\[LeftDoubleBracket]j-1\[RightDoubleBracket]})//
            Chop,True];
ints=IntervalCombine@@Map[ConstrainedIntervals[#,x]&,cs];
n=Length[ints];
If[n>1,Print["WARNING: genotype frequencies valid only in disjunct regions. ",
          ints]];
{ints\[LeftDoubleBracket]1,1\[RightDoubleBracket],
        ints\[LeftDoubleBracket]n,2\[RightDoubleBracket]}];

























MomentAfterMigration[U_,c_[i_],x:{{_,_}..}]:=Module[{tx=Transpose[x]},
		Plus@@MapThread[(#2*c[#1][U])&,
            tx]+(1-Plus@@tx\[LeftDoubleBracket]2\[RightDoubleBracket])c[i][
            U]];



MomentAfterRecombination[U_,c_,r_]:=
    Module[{rr},((Recombined[c[U],rr]/.rr->r)/.RandomMating[c])/.
			
        Symmetrise[c]];



MomentSimple[x_][U_,c_,pb_,\[Delta]p_]:=MomentSimple[x][U,c,pb,\[Delta]p,0&];
MomentSimple[x_][U_,c_,pb_,\[Delta]pl_,\[Delta]ps_]:=
	(Switch[Abs[x],
			0,(c[U]/.RandomUnionObsolete[c]),
			1,ShiftCentre[c[U],If[x>0,1-pb,-pb]\[Delta]ps[#]&],
			2,Apply[Times,Map[(If[x>0,1-pb,-pb]\[Delta]pl[{#}])&,U]],
		_,Print["Error: MomentSimple[] only defined for demes -2\[Ellipsis]2; ",x ,
            " invalid"]]/.Symmetrise[c])/.{c[{}]->1,c[{_}]->0}



MomentNew[U_,c_,m_,pb_,r_,\[Delta]p_]:=MomentNew[U,c,0,m,pb,r,0,\[Delta]p];
MomentNew[U_,c_,ml_,ms_,pb_,
      r_,\[Delta]pl_,\[Delta]ps_]:=(MomentAfterMigration[U,
            c[0],{{-2,ml(1-pb)},{-1,ms(1-pb)},{1,ms pb},{2,ml pb}}]/.c[i_][
              W_]:>(MomentSimple[i][W,c,pb,\[Delta]pl,\[Delta]ps]/.c[V_]:>
                  MomentAfterRecombination[V,c,r])/.Symmetrise[c]);



MomentEquilibrium[U_,c_,m_,pb_,r_,\[Delta]p_]:=
    MomentEquilibrium[U,c,0,m,pb,r,0,\[Delta]p];

MomentEquilibrium[U_,c_,ml_,ms_,pb_,r_,\[Delta]pl_,\[Delta]ps_]:=
	
    MomentEquilibrium[U,c,ml,ms,pb,r,\[Delta]pl,\[Delta]ps]=
		Module[{cs,swap},
			swap[W_List]:=(cs=W/.Separate;
            If[cs\[LeftDoubleBracket]1\[RightDoubleBracket]==={},
              Reverse[cs]/.Combine,
              W]);((c[U]/.Solve[
                      c[U]==(MomentNew[U,c,ml,ms,pb,
                              r,\[Delta]pl,\[Delta]ps]/.c[V_]:>c[swap[V]]),
                      c[U]][[1]])/.c[V_]:>
                MomentEquilibrium[V,c,ml,ms,pb,r,\[Delta]pl,\[Delta]ps])//
          Factor];



CumulantEquilibrium[W_List,c_,pars__]:=
    CumulantEquilibrium[W,c,
        pars]=(Cumulant[c,W]/.c[U_List]:>MomentEquilibrium[U,c,pars]//Factor);



AdmixtureFrequency[X_List,c_,ml_,ms_,pb_,p_,\[Delta]pl_,\[Delta]ps_,
      S_List]:=
	
    AdmixtureFrequency[X,c,ml,ms,pb,p,\[Delta]pl,\[Delta]ps,
        S]=(DiploidGenotypeFrequency[X,c,p,S]/.c[U_]:>
              c[((U/.Separate)//Sort)/.Combine])/.c[U_]:>
          MomentEquilibrium[U,c,ml,ms,pb,
            UnlinkedRecombination,\[Delta]pl,\[Delta]ps];

AdmixtureFrequency[X_List,c_,ml_,ms_,pb_,p_,\[Delta]pl_,\[Delta]ps_,f_,
      Symmetric\[Rule]True]:=
    AdmixtureFrequency[Sort[X],c,ml,ms,pb,p,\[Delta]pl,\[Delta]ps,f];





\!\(\(\[Delta]pEst[cva_, dpS_] := 1\/2\ \((dpS - \@\(dpS\^2 - 4  cva\))\);\)\)



\!\(\(\[Delta]pMax[s_] := \(\[Delta]pMax[s] = 
        Map[Min[#\/pbar[s], \(1 - #\)\/\(1 - pbar[s]\)] &, 
          ptable[data[s]]]\);\)\)



\!\(\(\[Delta]pSoln[\[Delta]pS_, \[Alpha]_, cv_] := 
      Module[{n = Length[cv], i}, \n\t
        FindRoot[\((n - 2)\) \[Delta]pS - 
              Sum[\@\(\[Delta]pS\^2 - 4\ cv[\([i]\)]/\[Alpha]\), {i, 
                  n}], {\[Delta]pS, 2}] // Chop];\)\)



\!\(\(\[Alpha]\[Delta]pSoln[\[Delta]pS_, \[Alpha]_, 
        s_, \[Alpha]0_] := \(\[Alpha]\[Delta]pSoln[\[Delta]pS, \[Alpha], 
          s, \[Alpha]0] = 
        Module[{ff, \[Gamma], rl}, \n
          ff[\[Gamma]_] := 
            Max[Re[\(\(\[Delta]pEst[netCV[s]\/\[Gamma], \[Delta]pS]\)\(\ \)\)\
\/\[Delta]pMax[s]]] /. \[Delta]pSoln[\[Delta]pS, \[Gamma], netCV[s]]; 
          rl = FindRoot[
              ff[\[Gamma]] - 
                1, {\[Gamma], \[Alpha]0}]; \n\t\t\
Join[\[Delta]pSoln[\[Delta]pS, \[Gamma] /. rl, netCV[s]] // Chop, 
            rl /. \[Gamma] -> \[Alpha]]]\);\)\)





DrawSamples[s_,gt_,nl_,{{k1_Integer,k2_Integer},n_Integer}]:=
	
    Module[{i},
      Do[Data[s[i]]=RandomList[n,gt,DiploidTypes[nl],Compiled\[Rule]True],{i,
          k1,k2}]];

DrawSamples[s_,gt_,nl_,{k_Integer,n_}]:=DrawSamples[s,gt,nl,{{1,k},n}];



Options[MakeRandomWalk]={Cumulant\[Rule]True};

MakeRandomWalk[s_,mr_List,{T_,nn_List},nv_,opts___Rule]:=
	Module[{mrx=mr},
		Table[mrx=MetropolisDisequilibrium[s,T,nn,mrx,opts],{nv}]];



Options[FindMLE]={Cumulant\[Rule]True};

\!\(\(FindMLE[s_, pl : {__?NumberQ}, \[Delta]pl : {__?NumberQ}, 
        ce : {{__?NumberQ} .. }, opts___Rule] := 
      Module[{rd = ReducedData[s, NumberOfLoci[s]], nz, obs, ntot, gv, 
          tr}, \n\ \ \ \ If[\(Cumulant /. {opts}\) /. 
            Options[FindMLE], \n\t\t\ttr[c_] := \(Moment[NumberOfLoci[s]]\)[
              c], \n\t\t\ttr[m_] := m\ ]; \n\t\t\ gv = 
          DiploidGenotypeFrequencyList[pl, \[Delta]pl, tr[ce]]; \n\t\tnz = 
          Position[rd, _?\((\((# > 0)\) &)\)]; \n\t\tobs = Extract[rd, nz]; \ 
        ntot = Plus @@ obs; \n\t\t{If[Min[gv] <= 0, \n\t
            10\^\(-10\), \n\t\t\t\t\(LogLikelihoodDisequilibrium[ntot]\)[obs, 
              Extract[GenotypeFrequencyConvert[gv, NumberOfLoci[s]], 
                nz]]], {{pl}, {\[Delta]pl}, ce}}];\)\)

FindMLE[s_,pl:{__?NumberQ}]:=Module[{nl=Length[pl]},
		FindMLE[s,pl,Array[1&,nl],ReplacePart[Array[0&,{nl+1,nl+1}],1,{1,1}]]];

FindMLE[s_,
      mr:{_,{{{__?NumberQ}},{{__?NumberQ}},{{__?NumberQ}..}},{{{__?
                  NumberQ}},{{__?NumberQ}},{{__?NumberQ}..}}},
      metK:{{_,{_Integer,_Integer}}..},opts___Rule]:=
	
    Module[{mrx=mr,c=mr\[LeftDoubleBracket]2,3\[RightDoubleBracket],
        dc=mr\[LeftDoubleBracket]3,3\[RightDoubleBracket]},
		c\[LeftDoubleBracket]1,1\[RightDoubleBracket]=0;
		If[(Union[Flatten[c]]==={0})&&(Union[Flatten[dc]]==={0}),
			FindMLE[s,mr\[LeftDoubleBracket]2,1,1\[RightDoubleBracket]],(* HWLE *)
			
        Scan[(mrx=
                MetropolisDisequilibrium[
                  s,#\[LeftDoubleBracket]1\[RightDoubleBracket],#\
\[LeftDoubleBracket]2\[RightDoubleBracket],mrx,opts])&,metK];mrx]];















































































































\!\(\(SetData[s_, pE_, \[Delta]pE_, \[Delta]pEV_] := 
      Module[{\[Alpha], \[Delta]ps, \[Delta]pee}, \n\t
        pE[i_] := \(ptable[data[s]]\)[\([i]\)] // N; 
        pE[\(i_\^*\)] := 
          pE[i]; \n\t\t\[Delta]pE[\(i_\^*\)] := \[Delta]pE[i]; \[Delta]pE[
            i_] := 1; \n\t\t\[Delta]pEV[\(i_\^*\)] := \[Delta]pEV[
            i]; \n\t\tIf[
          nloci[data[s]] > 
            2, \n\t\t\t\t\[Delta]pee = \[Delta]pEst[
                  netCV[s]/\[Alpha], \[Delta]pS] /. \[Alpha]\[Delta]pSoln[\
\[Delta]pS, \[Alpha], s, {0.1, 0.2}] // Re; \n\t\[Delta]pEV[
              i_] := \[Delta]pee[\([i]\)], \n\t\t\t\[Delta]pEV[i_] := 
            Min[\[Delta]pMax[s]]]];\)\)

\!\(\(SetData[s_, pE_, \[Delta]pE_] := 
      Module[{}, \n\tpE[i_] := \(ptable[data[s]]\)[\([i]\)] // N; 
        pE[\(i_\^*\)] := 
          pE[i]; \n\t\t\[Delta]pE[\(i_\^*\)] := \[Delta]pE[i]; \[Delta]pE[
            i_] := 1];\)\)



CumulantEquilibriumList[m_,pp_,nl_]:=CumulantEquilibriumList[m,p,nl]=
		Module[{k},{(CumulantEquilibrium[#,c,m,0,pp,UnlinkedRecombination,1&,0&])&/@
            Table[Range[k],{k,2,
                nl}],(CumulantEquilibrium[#,c,m,0,pp,UnlinkedRecombination,1&,
                  0&])&/@MakeSets[nl]}];



Options[DoReplicates]={MethodP->{Fit,Sample,True},
      MethodC->{HWLE,Fit,Sample,TrueC2,True},Cumulant\[Rule]True,
      Print\[Rule]False};

\!\(\(DoReplicates[m_, pp_, nl_, {nr_, ni_}, metK_, r_, opts___Rule] := \n\t
      Module[{cTrue, j, k, c, tt, ccc, dt, cStep, pSample, 
          cSample, \n\t\t\tcl00, cl10, cl01, cl11, clRU, clLE, \n\t\t\ts, mm, 
          cc, h, mset, cset, rs, cum, tr, tr2, ff, mx, x0, 
          y0, \n\t\t\tpStep = Array[2 \@\(\( pp \((1 - pp)\)\)\/ni\) &, nl], 
          pStepFix = Array[0 &, nl], 
          pStepFree = Array[1 &, nl], \n\t\t\t\[Delta]p = 
            Array[1 &, nl], \[CapitalDelta]\[Delta]p = 
            Array[0 &, nl], \n\t\t\tpTrue = Array[pp &, nl], 
          pMid, \n\t\t\tpFree, cFree, def = 0.95, res, 
          pQ = \(Print /. {opts}\) /. Options[DoReplicates]}, \n\ \ \ \ \ Off[
          General::ovfl]; \n\t\tcl00 = 
          Array[0 &, {nl + 1, nl + 1}]; \n\t\tcl11 = 
          Array[1 &, {nl + 1, nl + 1}]; \n\t\tcl11\[LeftDoubleBracket]1, 
            1\[RightDoubleBracket] = 0; 
        cl11\[LeftDoubleBracket]1, 2\[RightDoubleBracket] = 0; 
        cl11\[LeftDoubleBracket]2, 1\[RightDoubleBracket] = 0; \n\t\tcl10 = 
          ReplacePart[cl00, 1, {1, 1}]; \n\t\tclLE = 
          ReplacePart[cl00, 1, {2, 2}]; \n\t\tcl01 = 
          Table[If[j + k > 2, 1, 0], {j, 0, nl}, {k, 0, nl}]; \n\t\tclRU = 
          cl11*Table[
              If[\((j == 0)\) || \((k == 0)\), 1, 0], {j, 0, nl}, {k, 0, 
                nl}]; \n\ \ \ \ \ mm = {\(MethodP /. {opts}\) /. 
                Options[DoReplicates]} // 
            Flatten; \n\t\tcc = {\(MethodC /. {opts}\) /. 
                Options[DoReplicates]} // 
            Flatten; \n\t\tcum = \(Cumulant /. {opts}\) /. 
            Options[DoReplicates]; \n\t\ \ \ If[
          cum, \n\t\t\ttr[mmm_] := \(Cumulant[nl]\)[mmm]; 
          tr2[kkk_] := \ \(Moment[nl]\)[kkk], \n\t\t\ttr[c_] := c; 
          tr2[c_] := c]; \n\t\t\ cTrue = 
          tr[Table[
              MomentEquilibrium[{Range[j], Range[k]} /. Combine, ccc, m, 0, 
                pp, UnlinkedRecombination, 1 &, 0 &], {j, 0, nl}, {k, 0, 
                nl}]]; \n\ \ \ \ \ Print["\<True C: \>", 
          cTrue // MatrixForm]; \n\t\t\ mset := 
          mm /. {Fit \[Rule] {pSample, pStepFree}, 
              Sample \[Rule] {pSample, pStepFix}, 
              True \[Rule] {pTrue, pStepFix}}; \n\t\t\ cset := 
          cc /. {HWLE \[Rule] {cl10, 
                  cl00}, \n\t\t\t\t\t\t\tLinkageEquilibrium \[Rule] {cSample*
                      clLE + cl10, 
                  clLE}, \n\t\t\t\t\t\t\tRandomUnionMethod \[Rule] {clRU*cS + 
                    cl10, clRU}, \n\t\t\t\t\t\t\tFit \[Rule] {cSample, 
                  cl11}, \n\t\t\t\t\t\t\tSample \[Rule] {cSample, 
                  cl00}, \n\t\t\t\t\t\t\tTrue \[Rule] {cTrue, 
                  cl00}, \n\t\t\t\t\t\t\tTrueC2 \[Rule] {cSample*cl01 + 
                    cTrue*\((1 - cl01)\), cl01}}; \n\ \ \ \ \ \ mx[y_] := 
          Array[If[#1 + #2 == 2, 1, y\^\(#1 + #2 - 2\)] &, {nl + 1, 
              nl + 1}]; \n\t\tff[x_, 
            y_, {ppp_, \[CapitalDelta]ppp_}, {mmm_, \[CapitalDelta]mmm_}] := 
          Min[DiploidGenotypeFrequencyList[\((1 - \[CapitalDelta]ppp)\) 
                  ppp + \[CapitalDelta]ppp \((ppp*y + pMid \((1 - y)\))\), 
              tr2[mmm \((\((1 - \[CapitalDelta]mmm)\) + \[CapitalDelta]mmm*
                        mx[x])\)]]]; 
        tt = GenotypeFrequencyConvert[
            DiploidGenotypeFrequencyList[pTrue, tr2[cTrue]], 
            nl]\ ; \n\t\tDrawSamples[r[m, pp], tt, 
          nl, {nr, ni}]; \n\t\tcStep = 
          InitialStep[pTrue, \[Delta]p, 
            tr2[cTrue]]; \n\t\th[{p0_, \[CapitalDelta]p0_}, {c0_, \
\[CapitalDelta]c0_}] := \n\t\t\t\t\t\((x0 = 1; 
            y0 = 1; \n\t\t\t\t\ \ \ \ \ \ pFree = 
              Not[\((Union[\[CapitalDelta]p0] === {0})\)]; \n\t\t\t\t\ \ \ \ \
\ cFree = Not[\((Union[
                      Flatten[\[CapitalDelta]c0]] === {0})\)]; \n\t\t\t\t\ \ \
\ \ \ pMid = Mean[pSample]*\[Delta]p; \n\t\t\t\t\t\tIf[
              ff[1, 1, {p0, \[CapitalDelta]p0}, {c0, \[CapitalDelta]c0}] < 
                0, \n\t\t\t\t\t\ \ \ If[
                cFree && \((ff[0, 
                        1, {p0, \[CapitalDelta]p0}, {c0, \[CapitalDelta]c0}] \
\[GreaterEqual] 
                      0)\), \n\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \  \
(*\(Print["\<Deflating moments\>"];\)*) \n\t\t\t\t\t\t\ \ \ \ \ \ \ While[
                  ff[x0, y0, {p0, \[CapitalDelta]p0}, {c0, \
\[CapitalDelta]c0}] < 0, x0 *= def], \n\t\t\t\t\t\t\ \ \ \ \ \ \ \ \ \ pMid = 
                  Mean[pSample]*\[Delta]p; \n\t\t\t\t\t\t\ \ \ \ \ \ \ \ \ If[
                  ff[1, 0, {p0, \[CapitalDelta]p0}, {c0, \[CapitalDelta]c0}] \
< 0, \n\t\t\t\t\t\t\t\ \ \ \ \ \ \ \ \ \ \ \ pMid = 
                    pTrue; \n\t\t\t\t\t\t\ \ \ \ \ \ \ \ \ \ \ \ \ \ If[
                    ff[1, 0, {p0, \[CapitalDelta]p0}, {c0, \
\[CapitalDelta]c0}] < 0, 
                    pMid = \((\[Delta]p + \[CapitalDelta]\[Delta]p)\)/
                        2]]; \n\t\t\t\t\t\t\ \ \ \ \ \ \ \ \ If[
                  pFree && \((ff[1, 
                          0, {p0, \[CapitalDelta]p0}, {c0, \
\[CapitalDelta]c0}] \[GreaterEqual] 
                        0)\), \n\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ \ \  (*\(Print["\<Inflating p\>"];\)*) \n\t\t\t\t\t\t\ \ \ \ \ \ \ \ \ \
\ \ \ \ \ While[ff[x0, 
                        y0, {p0, \[CapitalDelta]p0}, {c0, \[CapitalDelta]c0}] \
< 0, y0 *= 
                      def], \n\t\t\t\t\t\t\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ Print["\<Failed to find a sensible starting point\>"]]]]; \n\t\t\t\ \ \ \
If[pQ, Print["\<p, c adjusted by:\>", x0, Tab, \ 
                y0, "\<; p, \[CapitalDelta]p=\>", p0, 
                Tab, \[CapitalDelta]p0, "\<; c, \[CapitalDelta]c=\>", 
                c0 // MatrixForm, 
                Tab, \[CapitalDelta]c0 // MatrixForm]]; \n\t\t\t\t\ FindMLE[
              s, {0, {{\((1 - \[CapitalDelta]p0)\) 
                        p0 + \[CapitalDelta]p0 \((p0*y0 + 
                            pMid \((1 - 
                                  y0)\))\)}, {\[Delta]p}, \n\t\t\t\t\t\t\t\t\
c0*\((\((1 - \[CapitalDelta]c0)\) + \[CapitalDelta]c0*
                          mx[x0])\)}, {{\[CapitalDelta]p0*
                      pStep}, {\[CapitalDelta]\[Delta]p}, \[CapitalDelta]c0*
                    cStep}}, metK, opts])\); \n\t\t\ \ res = 
          Table[\((s = \(r[m, pp]\)[k]; 
              rs = ReducedData[s, 
                  nl]; \n\t\t\t\t\ \ \ pSample = \(\(AlleleFrequencyTable[s, 
                        nl] // N\) // Transpose\) // 
                  Last; \n\t\t\t\t\tcSample = 
                tr[EstimateMoments[rs\/Plus @@ rs, 
                    pSample]]; \n\t\t\t\t\ \ \ dt = 
                Flatten[Outer[h, mset, cset, 1], 
                  1]; \n\t\t\ \ \ \ \ \ \ \ Print @@ \(({k}~Join~
                    Flatten[\({Tab, #\[LeftDoubleBracket]1\
\[RightDoubleBracket]} &\) /@ dt])\); \n\t\t\t\tdt)\), {k, nr}]; \n\t
        On[General::ovfl]; \n\t\tres];\)\)









\!\(\(MakeSets[
        2] = {{1, \(1\^*\)}, {1, 2, \(1\^*\)}, {1, 
          2, \(1\^*\), \(2\^*\)}};\)\n
  \(MakeSets[
        3] = {{1, \(1\^*\)}, {1, 2, \(1\^*\)}, {1, 
          2, \(1\^*\), \(2\^*\)}, {1, 2, 3, \(1\^*\), \(2\^*\)}, {1, 2, 
          3, \(1\^*\), \(2\^*\), \(3\^*\)}};\)\n
  \(MakeSets[
        4] = {{1, \(1\^*\)}, {1, 2, \(1\^*\)}, {1, 
          2, \(1\^*\), \(2\^*\)}, {1, 2, 3, \(1\^*\), \(2\^*\)}, {1, 2, 
          3, \(1\^*\), \(2\^*\), \(3\^*\)}, {1, 2, 3, 
          4, \(1\^*\), \(2\^*\), \(3\^*\)}, {1, 2, 3, 
          4, \(1\^*\), \(2\^*\), \(3\^*\), \(4\^*\)}};\)\)



\!\(\(PresentResults[results_List, {m_, pt_}, opts___Rule] := 
      Module[{nreps = Length[results], ll, logL, pp, cc, pset, cset, np, 
          nc, \[Kappa], \[Kappa]L, nx, fm, fsd, dfp, dfc, 
          nl = Length[
              results\[LeftDoubleBracket]1, 2, 2, 1, 1\[RightDoubleBracket]], 
          sel, ccc, cTrue, \[Kappa]True, j, k}, 
        cTrue = Table[
            MomentEquilibrium[{Range[j], Range[k]} /. Combine, ccc, m, 0, pt, 
              UnlinkedRecombination, 1 &, 0 &], {j, 0, nl}, {k, 0, 
              nl}]; \[Kappa]True = \(Cumulant[nl]\)[cTrue]; 
        pp = \(MethodP /. {opts}\) /. Options[DoReplicates]; 
        cc = \(MethodC /. {opts}\) /. Options[DoReplicates]; 
        dfp = pp /. {Fit \[Rule] nl, Sample \[Rule] nl, True \[Rule] 0}; 
        dfc = cc /. {HWLE \[Rule] 0, LinkageEquilibrium \[Rule] nl - 1, 
              RandomUnionMethod \[Rule] 1, 
              Fit \[Rule] \((nl + 1)\) \((nl + 2)\)/2 - 2, 
              Sample \[Rule] \((nl + 1)\) \((nl + 2)\)/2 - 2, True \[Rule] 0, 
              TrueC2 \[Rule] \((nl + 1)\) \((nl + 2)\)/2 - 4}; 
        pset = pp /. {Fit \[Rule] \*"\"\<fit \!\(p\_i\)\>\"", 
              Sample \[Rule] \*"\"\<sample \!\(p\_i\)\>\"", 
              True \[Rule] \*"\"\<true \!\(p\_i\)\>\""}; 
        cset = cc /. {HWLE \[Rule] "\<HWLE\>", 
              LinkageEquilibrium \[Rule] "\<linkage equilibrium\>", 
              RandomUnionMethod \[Rule] "\<random union\>", 
              Fit \[Rule] \*"\"\<fit all \!\(\[Kappa]\_\(j, \\\\\\\ \
\(\(\\\\\\\\\)\(\\\\\\\ \)\(\\\\\\\\\\\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\) k\)\
\)\)\)\>\"", 
              Sample \[Rule] \*"\"\<sample \!\(\[Kappa]\_\(j, \\\\\\\ \
\(\(\\\\\\\\\)\(\\\\\\\ \)\(\\\\\\\\\\\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\) k\)\
\)\)\)\>\"", 
              True \[Rule] \*"\"\<true \!\(\[Kappa]\_\(j, \\\\\\\ \
\(\(\\\\\\\\\)\(\\\\\\\ \)\(\\\\\\\\\\\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\) k\)\
\)\)\)\>\"", 
              TrueC2 \[Rule] \*"\"\<true \!\(\[Kappa]\_\(1, \\\\\\\ \
\(\(\\\\\\\\\)\(\\\\\\\ \)\(\\\\\\\\\\\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\) 1\)\
\)\)\), \!\(\[Kappa]\_\(0, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(\\\\\\\\\\\\\\\
\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\) 2\)\)\)\)\>\""}; np = Length[pset]; 
        nc = Length[cset]; 
        dfp = Transpose[Partition[Repeat[dfp, nc], np]] // Flatten; 
        dfc = Repeat[dfc, np]; 
        pset = Transpose[Partition[Repeat[pset, nc], np]] // Flatten; 
        cset = Repeat[cset, np]; 
        ll = Transpose[\(\((# /. {{x_, _List, _List} :> x, {x_, _List} :> 
                        x})\) &\) /@ results]; 
        sel[s_] := Select[s, \((# > \(-10\^8\))\) &]; logL = sel /@ ll; 
        nx = \((Length /@ ll)\) - \((Length /@ logL)\); \n\t\t\[Kappa][i_, 
            j_] := \((#\[LeftDoubleBracket]2, 3, i + 1, 
                j + 1\[RightDoubleBracket])\) &; \[Kappa]L[i_, 
            j_] := \(\[Kappa]L[i, j] = 
            Transpose[\(\((\[Kappa][i, j] /@ #)\) &\) /@ results]\); 
        fm[x_List] := \(PaddedForm[Chop[Mean[#]], {7, 4}] &\) /@ x; 
        fsd[x_List] := \(PaddedForm[Chop[StandardDeviation[#]], {7, 4}] &\) /@ 
            x; Append[
          Prepend[{pset, 
                cset, \(PaddedForm[Mean[#], {8, 2}] &\) /@ 
                  logL, \(PaddedForm[Variance[#], {8, 2}] &\) /@ logL, 
                3\^nl - 1 - dfc - dfp, nx, fm[\[Kappa]L[0, 2]], 
                fsd[\[Kappa]L[0, 2]], fm[\[Kappa]L[1, 1]], 
                fsd[\[Kappa]L[1, 1]], fm[\[Kappa]L[1, 2]], 
                fsd[\[Kappa]L[1, 2]], fm[\[Kappa]L[2, 2]], 
                fsd[\[Kappa]L[2, 2]]} // 
              Transpose, {"\<allele\nfrequencies\>", "\<moments\>", "\<log(L)\
\nmean\>", "\<\nvariance\>", "\<d.f.\>", "\<#\ninvalid\>", \
\*"\"\<\!\(\[Kappa]\_\(0, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \
\)\(\\\\\\\\\\\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\) 2\)\)\)\)\\nmean\>\"", "\<\n\
s.d.\>", \*"\"\<\!\(\[Kappa]\_\(1, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(\\\\\\\
\\\\\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\) 1\)\)\)\)\\nmean\>\"", "\<\ns.d.\>", \
\*"\"\<\!\(\[Kappa]\_\(1, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \
\)\(\\\\\\\\\\\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\) 2\)\)\)\)\\nmean\>\"", "\<\n\
s.d.\>", \*"\"\<\!\(\[Kappa]\_\(2, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\(\\\\\\\
\\\\\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\) 2\)\)\)\)\\nmean\>\"", "\<\n\
s.d.\>"}], {"\<\>", "\<true\ncumulants\>", "\<\>", "\<\>", "\<\>", "\<\>", 
            PaddedForm[\[Kappa]True\[LeftDoubleBracket]1, 
                3\[RightDoubleBracket], {7, 
                
                4}], "\<\>", \n\t\t\t\t\t\tPaddedForm[\[Kappa]True\
\[LeftDoubleBracket]2, 2\[RightDoubleBracket], {7, 4}], "\<\>", 
            PaddedForm[\[Kappa]True\[LeftDoubleBracket]2, 
                3\[RightDoubleBracket], {7, 4}], "\<\>", 
            PaddedForm[\[Kappa]True\[LeftDoubleBracket]3, 
                3\[RightDoubleBracket], {7, 4}], "\<\>"}]];\)\)



CompareLogL[results_List,{i_Integer,j_Integer}]:=
	Module[{logL},
	   logL=Transpose[(#/.{{x_,_List,_List}:>x,{x_,_List}:>x})&/@results];
		(Sort[logL\[LeftDoubleBracket]i\[RightDoubleBracket]-
              logL\[LeftDoubleBracket]j\[RightDoubleBracket]])//Chop];



\!\(\(PresentLogL[res_, jl_List, dfl_List, names_List, P_] := 
      Module[{dc, ff, 
          cl}, \n\t\tcl = \(CompareLogL[res, #] &\) /@ jl; \n\t\tff[ll_, df_, 
            name_] := \n\t\t\t\((dc = 
              Select[ll, \((# < 10\^6)\) &]; \n\t\t\t\t{name, Length[dc], 
              Mean[dc], Variance[dc], Length[Select[dc, \((# < 0)\) &]], 
              Length[Select[
                  dc, \((# > \(1\/2\) 
                          Quantile[ChiSquareDistribution[df], 
                            1 - P])\) &]]})\); \n\t\tPrepend[
          MapThread[
            ff, {cl, dfl, 
              names}], \n\t\t{"\<\>", "\<# valid\nresults\>", "\<log(L)\nmean\
\>", "\<\nvariance\>", "\<# negative\nvalues\>", 
            StringJoin["\<# rejected\n at P=\>", ToString[P]]}]];\)\)



\!\(\(PlotLogL[res_, jl_List, dfl_List] := \n\t
      Module[{dc, bc, ff, x0, x1, dx = 0.25, jk, ll, x}, \n\t
        ff[jk_, df_] := \n\t\t\t\((ll = CompareLogL[res, jk]; \n\t\t\t\tdc = 
              Select[ll, \((# < 10\^6)\) &]; \n\t\t\t\ x0 = Floor[Min[dc]]; 
            x1 = Ceiling[Max[dc]]; \n\t\t\t\tbc = 
              BinCounts[dc, {x0, x1, dx}]; \n\t\t\tDisplayTogether[
              Plot[CDF[ChiSquareDistribution[df], 2  x], {x, 0, 
                  x1}], \n\t\t\t\t\tListPlot[
                Transpose[{Range[x0, x1, dx] + dx/2, 
                    FoldList[Plus, \ 0, \ bc]/Length[dc] // N}]]])\); \n\t
        MapThread[ff, {jl, dfl}];];\)\)



On[General::spell1,General::spell];

End[];


EndPackage[];