(* Multilocus.m :  Jason Harris,  24/5/2002       *)
(* This file is machine generated from Multilocus.nb*)
(* It is not intended to be read by humans.  *)
(* Please consult the source file Multilocus.nb. *)

BeginPackage["Multilocus`Multilocus`", {"Multilocus`DataManipulation`", "Utilities`Cumulants`", "Utilities`SetManipulation`", "Utilities`Notation`"}];

NotebookClose[NotebookObject[FrontEndObject[LinkObject["Mathematica 4", 1, 1]], 47]];

\[Zeta]::usage = "\!\(\[Zeta]\_\[DoubleStruckI]\) or AllelicDeviation[\[DoubleStruckI]] represents the deviation of gene-in-context \[DoubleStruckI] from its reference point: \!\(\[Zeta]\_\[DoubleStruckI]\)\[Congruent]\!\(X\_\[DoubleStruckI]\)-\!\(\[WeierstrassP]\_\[DoubleStruckI]\).";

AllelicDeviation::usage = "AllelicDeviation[\[DoubleStruckI]] or \!\(\[Zeta]\_\[DoubleStruckI]\) represents the deviation of gene-in-context \[DoubleStruckI] from its reference point: \!\(\[Zeta]\_\[DoubleStruckI]\)\[Congruent]\!\(X\_\[DoubleStruckI]\)-\!\(\[WeierstrassP]\_\[DoubleStruckI]\).";

X::usage = "\!\(X\_\(\[DoubleStruckI] \(\(\\\\\)\(\\ \)\)\)\)or AllelicState[\[DoubleStruckI]] indicates the allelic state of gene-in-context \[DoubleStruckI]";

AllelicState::usage = "AllelicState[\[DoubleStruckI]] or \!\(X\_\[DoubleStruckI]\) indicates the allelic state of gene-in-context \[DoubleStruckI]";

ReferencePoint::usage = "ReferencePoint[\[DoubleStruckI]] or \!\(\[WeierstrassP]\_\[DoubleStruckI]\) is the reference point for gene-in-context \[DoubleStruckI].  ";

\[WeierstrassP]::usage = "\!\(\[WeierstrassP]\_\[DoubleStruckI]\) or ReferencePoint[\[DoubleStruckI]] is the reference point for gene-in-context \[DoubleStruckI].  ";

\[GothicM]::usage = "\!\(\[GothicM]\_\[DoubleStruckI]\) or  MeanContribution[\[DoubleStruckI]] is the mean contribution of gene-in-context \[DoubleStruckI]";

MeanContribution::usage = "MeanContribution[\[DoubleStruckI]] or \!\(\[GothicM]\_\[DoubleStruckI]\) is the mean contribution of gene-in-context \[DoubleStruckI].  ";

AlleleFrequencyP::usage = "AlleleFrequencyP[\[DoubleStruckI]] or \!\(\[GothicP]\_\[DoubleStruckI]\) is the allele frequency \[LeftAngleBracket]\!\(X\_\[DoubleStruckI]\)\[RightAngleBracket] of gene-in-context \[DoubleStruckI].  ";

\[GothicP]::usage = "\!\(\[GothicP]\_\[DoubleStruckI]\)  or AlleleFrequencyP[\[DoubleStruckI]] is the allele frequency \[LeftAngleBracket]\!\(X\_\[DoubleStruckI]\)\[RightAngleBracket] of gene-in-context \[DoubleStruckI].  ";

AlleleFrequencyQ::usage = "AlleleFrequencyQ[\[DoubleStruckI]] or \!\(\[GothicQ]\_\[DoubleStruckI]\) is the allele frequency \[LeftAngleBracket]1-\!\(X\_\[DoubleStruckI]\)\[RightAngleBracket] of gene-in-context \[DoubleStruckI].  ";

\[GothicQ]::usage = "\!\(\[GothicQ]\_\[DoubleStruckI]\)  or AlleleFrequencyQ[\[DoubleStruckI]] is the allele frequency \[LeftAngleBracket]1-\!\(X\_\[DoubleStruckI]\)\[RightAngleBracket] of gene-in-context \[DoubleStruckI].  ";

AlleleFrequencyPQ::usage = "AlleleFrequencyP[\[DoubleStruckI]] or \!\(\[GothicP]\[GothicQ]\_\[DoubleStruckI]\) is the allele frequency of gene-in-context \[DoubleStruckI].  ";

\[GothicP]\[GothicQ]::usage = "\!\(\[GothicP]\[GothicQ]\_\[DoubleStruckI]\)  or AlleleFrequencyPQ[\[DoubleStruckI]] is the product of allele frequencies of gene-in-context \[DoubleStruckI].  ";

\[GothicCapitalD]::usage = "\!\(\[GothicCapitalD]\_\[DoubleStruckCapitalU]\) or Disequilibrium[\[DoubleStruckCapitalU]] is the linkage disequilibrium between the set of genes-in-context \[DoubleStruckCapitalU].";

Disequilibrium::usage = "Disequilibrium[\[DoubleStruckCapitalU]] or \!\(\[GothicCapitalD]\_\[DoubleStruckCapitalU]\) is the linkage disequilibrium between the set of genes-in-context \[DoubleStruckCapitalU].";

PopulationDisequilibrium::usage = "PopulationDisequilibrium[{{\[DoubleStruckCapitalU]},{\[DoubleStruckCapitalV]}\[Ellipsis]},{{\[DoubleStruckI]},{\[DoubleStruckJ]},\[Ellipsis]}] or \!\(\[GothicCapitalC]\_\({{\[DoubleStruckCapitalU]}, \\ \(\(\\\\\)\(\\ \)\({\[DoubleStruckCapitalV]}\)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)}, \\ {{\[DoubleStruckI]}, \\ {\[DoubleStruckJ]}, \\ \[Ellipsis]}\)\) is the expectation over a distribution of populations of \!\(\[GothicCapitalD]\_\[DoubleStruckCapitalU]\)\!\(\[GothicCapitalD]\_\[DoubleStruckCapitalV]\)\!\(\[Ellipsis]\[WeierstrassP]\_\[DoubleStruckI]\)\!\(\[WeierstrassP]\_\[DoubleStruckJ]\)\[Ellipsis]. PopulationDisequilibrium[{{\[DoubleStruckCapitalU]},{\[DoubleStruckCapitalV]}\[Ellipsis]},{{\[DoubleStruckI]},{\[DoubleStruckJ]},\[Ellipsis]},{{\[DoubleStruckCapitalA]}\[Ellipsis]},{{\[DoubleStruckCapitalB]}\[Ellipsis]}\[Ellipsis]] or \!\(\[GothicCapitalC]\_\({{\[DoubleStruckCapitalU]}, \\ \(\(\\\\\)\(\\ \)\({\[DoubleStruckCapitalV]}\)\)\\ \[Ellipsis]}, \\ {{\[DoubleStruckI]}, \\ \(\(\\\\\)\(\\ \)\({\[DoubleStruckJ]}\)\), \\ \(\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)}, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\({{\[DoubleStruckCapitalA]}\\ \[Ellipsis]}\)\), \\ {{\[DoubleStruckCapitalB]}\\\\\\ \[Ellipsis]}\\ \[Ellipsis]\)\) indicates the expectation of \!\(\[GothicCapitalD]\_\[DoubleStruckCapitalU]\)\!\(\[GothicCapitalD]\_\[DoubleStruckCapitalV]\)\!\(\[Ellipsis]\[WeierstrassP]\_\[DoubleStruckI]\)\!\(\[WeierstrassP]\_\[DoubleStruckJ]\)\[Ellipsis]f[\[DoubleStruckCapitalA]]\[Ellipsis]g[\[DoubleStruckCapitalB]]\[Ellipsis], where the arbitrary functions f, g, \[Ellipsis] are also random variables. {\!\(c\_1\),\[Ellipsis],\[DoubleStruckCapitalA]} is given instead of {\[DoubleStruckCapitalA]} denotes the function f[\!\(c\_1\),\[Ellipsis],\[DoubleStruckCapitalA]].";

\[GothicCapitalC]::usage = "\!\(\[GothicCapitalC]\_\({\[DoubleStruckCapitalU], \\ \(\(\\\\\)\(\\ \)\(\[DoubleStruckCapitalV]\[Ellipsis]\)\)}, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\({\[DoubleStruckI], \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[DoubleStruckJ]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)}\)\)\)\) or PopulationDisequilibrium[{{\[DoubleStruckCapitalU]},{\[DoubleStruckCapitalV]}\[Ellipsis]},{{\[DoubleStruckI]},{\[DoubleStruckJ]},\[Ellipsis]}] is the expectation over a distribution of populations of \!\(\[GothicCapitalD]\_\[DoubleStruckCapitalU]\)\!\(\[GothicCapitalD]\_\[DoubleStruckCapitalV]\)\!\(\[Ellipsis]\[WeierstrassP]\_\[DoubleStruckI]\)\!\(\[WeierstrassP]\_\[DoubleStruckJ]\)\[Ellipsis]. PopulationDisequilibrium[{{\[DoubleStruckCapitalU]},{\[DoubleStruckCapitalV]}\[Ellipsis]},{{\[DoubleStruckI]},{\[DoubleStruckJ]},\[Ellipsis]},{{\[DoubleStruckCapitalA]}\[Ellipsis]},{{\[DoubleStruckCapitalB]}\[Ellipsis]}\[Ellipsis]] or \!\(\[GothicCapitalC]\_\({{\[DoubleStruckCapitalU]}, \\ \(\(\\\\\)\(\\ \)\({\[DoubleStruckCapitalV]}\)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)}, \\ \(\(\\\\\)\(\\ \)\({{\[DoubleStruckI]}, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\({\[DoubleStruckJ]}\)\), \\ \(\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)}\)\), \\ \(\(\\\\\)\(\\ \)\({{\[DoubleStruckCapitalA]}\\\\\\ \[Ellipsis]}\)\), \\ \(\(\\\\\)\(\\ \)\({{\[DoubleStruckCapitalB]}\\ \[Ellipsis]}\)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)\)\) indicates the expectation of \!\(\[GothicCapitalD]\_\[DoubleStruckCapitalU]\)\!\(\[GothicCapitalD]\_\[DoubleStruckCapitalV]\)\!\(\[Ellipsis]\[WeierstrassP]\_\[DoubleStruckI]\)\!\(\[WeierstrassP]\_\[DoubleStruckJ]\)\[Ellipsis]f[\[DoubleStruckCapitalA]]\[Ellipsis]g[\[DoubleStruckCapitalB]]\[Ellipsis], where the arbitrary functions f, g, \[Ellipsis] are also random variables. {\!\(c\_1\),\[Ellipsis],\[DoubleStruckCapitalA]} is given instead of {\[DoubleStruckCapitalA]} denotes the function f[\!\(c\_1\),\[Ellipsis],\[DoubleStruckCapitalA]].";

Stage::usage = "Stage or \[Sampi] denotes the stage in the life cycle";

\[Sampi]::usage = "\[Sampi] or Stage denotes the stage in the life cycle";

ContextStructure::usage = "ContextStructure[stage] lists the components of stage.";

ContextPosition::usage = "ContextPosition[stage,component]  gives the position of component  in the context whose structure is defined by stage.  Returns 0 if the component is not defined, and 1 for the stage itself.";

ContextComponentQ::usage = "ContextComponentQ[stage, symbol] finds whether symbol is a component of stage.";

ContextStageQ::usage = "ContextStageQ[symbol] finds whether symbol is a defined stage.";

DefineContext::usage = "DefineContext[stage,{\!\(component\_1\),\[Ellipsis]}] defines a context with components in the given order";

FullContext::usage = "FullContext[{{stage,\!\(c\_1\),#1,\[Ellipsis]},\[DoubleStruckI],\[DoubleStruckJ]\[Ellipsis]}] converts the short form of a set of genes-in-context to the full form. ";

ShortContext::usage = "ShortContext[{\[DoubleStruckI],\[DoubleStruckJ],\[Ellipsis]}] converts the full form of a set of genes-in-context to the short form. ";

SelectContext::usage = "SelectContext[\[DoubleStruckCapitalU],c]  or \[DoubleStruckCapitalU]\[CircleDot]c finds those elements of \[DoubleStruckCapitalU] that are in context c.  Components of c that are replaced by _ are disregarded.  SelectContext[\[DoubleStruckCapitalU],c,x]  or \[DoubleStruckCapitalU]\!\(\[CircleDot]\_x\)c   only takes account of the components x; x may be a single component name or a list of component names.";

ExtractContexts::usage = "ExtractContexts[\[DoubleStruckCapitalU]] or \[Chi][\[DoubleStruckCapitalU]] lists all the contexts of the genes in \[DoubleStruckCapitalU]. ExtractContexts[\[DoubleStruckCapitalU],x] or \!\(\[Chi]\_x\)[\[DoubleStruckCapitalU]] extracts only components listed in x.";

\[Chi]::usage = "\[Chi][\[DoubleStruckCapitalU]] or ExtractContexts[\[DoubleStruckCapitalU]] lists all the contexts of the genes in \[DoubleStruckCapitalU]. \!\(\[Chi]\_x\)[\[DoubleStruckCapitalU]] or ExtractContexts[\[DoubleStruckCapitalU],x] extracts only components listed in x.";

ExtractContexts::usage = "ExtractContexts[\[DoubleStruckCapitalU]] or \[Chi][\[DoubleStruckCapitalU]] lists all the contexts of the genes in \[DoubleStruckCapitalU]. ExtractContexts[\[DoubleStruckCapitalU],x] or \!\(\[Chi]\_x\)[\[DoubleStruckCapitalU]] extracts only components listed in x.";

\[Chi]::usage = "\[Chi][\[DoubleStruckCapitalU]] or ExtractContexts[\[DoubleStruckCapitalU]] lists all the contexts of the genes in \[DoubleStruckCapitalU]. \!\(\[Chi]\_x\)[\[DoubleStruckCapitalU]] or ExtractContexts[\[DoubleStruckCapitalU],x] extracts only components listed in x.";

ExtractGenes::usage = "ExtractGenes[\[DoubleStruckCapitalU]] or \[Gamma][\[DoubleStruckCapitalU]] lists all the genes in \[DoubleStruckCapitalU].";

\[Gamma]::usage = "\[Gamma][\[DoubleStruckCapitalU]] or ExtractGenes[\[DoubleStruckCapitalU]] lists all the genes in \[DoubleStruckCapitalU].";

TransmissionRule::usage = "TransmissionRule[present,previous] or present\[LeftArrow]previous specifies that genes in the present context derive from those in the previous context. The present context can include pattern elements.  TransmissionRule[present,previous,A] or present  \[LeftArrow] previous restricts the rule to the set of genes A.";

ChangeContext::usage = "ChangeContext[\[DoubleStruckCapitalU],rule] or \[DoubleStruckCapitalU]\[CirclePlus]rule applies rule to the set of genes-in-context \[DoubleStruckCapitalU].  rule should be a TransmissionRule, or a list of transmission rules.  ChangeContext[\!\(\[GothicCapitalD]\_\[DoubleStruckCapitalU]\),rule] expresses the linkage disequilibrium in the present context in terms of the previous context, making allowance for the change in reference point. ChangeContext[\!\(\[GothicCapitalC]\_{\[DoubleStruckCapitalU]1, \\ \[Ellipsis]}\),rule] does the same for associations between linkage disequilibria.";

Expectation::usage = "Expectation[expr] or \[LeftAngleBracket]expr\[RightAngleBracket] gives the expectation over a polynomial expression in \!\(\[Zeta]\_\[DoubleStruckI]\) and \!\(X\_\[DoubleStruckI]\), in terms of the linkage disequilibria, \!\(\[GothicCapitalD]\_\[DoubleStruckCapitalU]\).  If expr includes \!\(X\_\[DoubleStruckI]\), then the reference points \!\(\[WeierstrassP]\_\[DoubleStruckI]\) must be defined, since \!\(\[Zeta]\_\[DoubleStruckI]\)\[Congruent]\!\(X\_\[DoubleStruckI]\)-\!\(\[WeierstrassP]\_\[DoubleStruckI]\), and \!\(\[GothicCapitalD]\_\[DoubleStruckCapitalU]\)\[Congruent]\[LeftAngleBracket]\!\(\[Product]\+\(\(\(\[DoubleStruckI]\)\(\\\\\)\)\\ \\  \[Element] \\ \(\(\\\\\)\(\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\ \)\) \[DoubleStruckCapitalU]\)\)\)\)\!\(\[Zeta]\_\[DoubleStruckI]\)\[RightAngleBracket]. ";

PopulationExpectation::usage = "PopulationExpectation[expr] or \[LeftDoubleBracketingBar]expr\[RightDoubleBracketingBar] gives the expectation over a polynomial expression in \!\(\[GothicCapitalD]\_\[DoubleStruckCapitalU]\) and \!\(\[WeierstrassP]\_\[DoubleStruckI]\), in terms of the \!\(\[GothicCapitalC]\_\({\[DoubleStruckCapitalU], \\ \(\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)}, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\({\[DoubleStruckI], \\ \[Ellipsis]}\)\)\)\).  Reference points are rewritten as \!\(m\_\[DoubleStruckI]\)=\!\(\[WeierstrassP]\_\[DoubleStruckI]\)+\!\(\[GothicCapitalD]\_{\[DoubleStruckI]}\).  PopulationExpectation[expr,f, g\[Ellipsis]] or \[LeftDoubleBracketingBar]expr\!\(\(\[RightDoubleBracketingBar]\_\(f, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(g\[Ellipsis]\)\)\)\)\) gives the expectation over \!\(\[GothicCapitalD]\_\(\[DoubleStruckCapitalU] \(\(\\\\\)\(\\ \)\)\)\)and \!\(\[WeierstrassP]\_\[DoubleStruckI]\) and also of the random variables f, g, \[Ellipsis].  ";

MakeFitnessSet::usage = "MakeFitnessSet[W] gives the set of genes-in-context on which fitness, W, depends.  If W involves sums such as \!\(\[Sum]\+\({\[Alpha], \\ \(\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)}\\\\\\ \\\\\\ \\  \[Element] \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\({S, \\ \(\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)}\)\)\)\)(\!\(\[Zeta]\_\(\[Alpha]\_{\[GothicCapitalZ], \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[GothicCapitalM]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\ \)\) \[GothicCapitalM]\)\)}\)\)\[Ellipsis]), then such sets of genes-in-context are represented as \!\(\[Zeta]\_\(S\_{\[GothicCapitalZ], \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[GothicCapitalM]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[GothicCapitalM]\)\)}\)\).";

MakeSelectionCoefficient::usage = "MakeSelectionCoefficient[\[DoubleStruckCapitalU],W] derives the \!\(W\&_\) \!\(a\_\[DoubleStruckCapitalU]\) from an expression for the relative fitness.  Can deal with expressions involving sums over arbitrary sets, \!\(\[Sum]\+\(i\\\\\\ \\\\\\ \\  \[Element] \\ \(\(\\\\\)\(\\ \)\(S\)\)\)\)";

\[GothicCapitalG]::usage = "\[GothicCapitalG] represents the haploid gamete stage in the life cycle. \!\(\(\[GothicCapitalG]\^*\)\) represents the new gamete pool";

\[GothicCapitalG]new::usage = "\[GothicCapitalG]new or \!\(\(\[GothicCapitalG]\^*\)\) represents the new gamete pool,";

\[GothicCapitalZ]::usage = "\[GothicCapitalZ] represents the diploid zygote stage in the life cycle.";

\[GothicCapitalJ]::usage = "\[GothicCapitalJ] represents the diploid juvenile stage in the life cycle.";

\[GothicCapitalH]::usage = "\[GothicCapitalH] represents a diploid hermaphrodite stage in the life cycle.";

\[GothicCapitalA]::usage = "\[GothicCapitalA] represents the diploid adult stage in the life cycle.";

Sex::usage = "Sex represents the sex of the individual; \[GothicCapitalM] or \[GothicCapitalF]";

SexOfOrigin::usage = "SexOfOrigin represents the sex of the parent from which a gene in a diploid was inherited.";

OtherSex::usage = "OtherSex[\[GothicCapitalM]] returns \[GothicCapitalF], and vice versa.";

\[GothicCapitalM]::usage = "\[GothicCapitalM] represents males.";

\[GothicCapitalF]::usage = "\[GothicCapitalF] represents females.";

UnionOfGametes::usage = "UnionOfGametes[] is a rule which derives genes at the zygote stage, \[GothicCapitalZ], from the corresponding gene in the gamete pool, \[GothicCapitalG]. UnionOfGametes[{\[GothicCapitalG],\[GothicCapitalZ]}] specifies the stages explicitly.";

Meiosis::usage = "Meiosis[A,B] is a rule which derives genes in the new gametes, \!\(\(\[GothicCapitalG]\^*\)\), from those in adult diploids, \[GothicCapitalA]. The set A of genes in the new gamete pool derive from the maternal genome in adults; the set B derives from the paternal genome. Meiosis[{\[GothicCapitalA],\!\(\(\[GothicCapitalG]\^*\)\)},A,B] defines the stages explicitly.";

Migrate::usage = "Migrate[\[Alpha],\[Beta]] is a rule which derives genes in juvenile diploids, \[GothicCapitalJ], in deme \[Alpha], from those in zygotes, \[GothicCapitalZ], in deme \[Beta].  Migrate[{\[GothicCapitalZ],\[GothicCapitalJ]},\[Alpha],\[Beta]] defines the stages explicitly.  The deme must be specified as the last component before Sex and/or SexOfOrigin: {\[GothicCapitalZ],\[Ellipsis],\[Beta],\[GothicCapitalM],\[GothicCapitalF]}.";

ReferencePointZero::usage = "ReferencePointZero[stage] sets the \!\(\[GothicCapitalD]\_{i\_{stage, \\ \(\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)}}\) to zero, and sets the reference point \!\(\[WeierstrassP]\_\[DoubleStruckI]\) to the mean, \!\(\[GothicM]\_\[DoubleStruckI]\) at that stage. ReferencePointZero[stage,p] denotes the mean by p[\[DoubleStruckI]].";

ReferencePointMean::usage = "ReferencePointMean[stage,m] sets the reference point to the mean, averaged over sexes, at that stage.  \!\(\[GothicCapitalD]\_{\[DoubleStruckI]}\) is also set appropriately, as a function of m.";

RandomUnion::usage = "RandomUnion[\[GothicCapitalG]] is a rule which sets the associations among genes in male and female gametes equal to the product of the associations in each sex separately.RandomUnion[\[GothicCapitalZ]] does the same for zygotes. RandomUnion[stage,{\!\(c\_1\),\[Ellipsis]}] is the general form, which treats contexts that differ in any of the components {\!\(c\_1\),\[Ellipsis]} as being randomly combined.";

Selfing::usage = "Selfing[] is a rule which implements self-fertilisation; sets the associations among genes a stage \[GothicCapitalA] are rewritten in terms of a sexless hermaphrodite stage \[GothicCapitalH], and a sexed outcrossing stage \[GothicCapitalJ].  Selfing[s] allows for a probability of selfing s. The general form is Selfing[{{\[GothicCapitalJ],\[GothicCapitalH]},\[GothicCapitalA]},s].";

ReferencePointSame::usage = "ReferencePointSame[\[GothicCapitalG],\[GothicCapitalZ]] is a rule which sets the reference point in zygotes to be the same as in the corresponding genes in gametes. ReferencePointSame[\[GothicCapitalG],\[GothicCapitalG]2] just equates reference points in the haploid stages \[GothicCapitalG]2 to that at stage \[GothicCapitalG]. ReferencePointSame[\[GothicCapitalG],{\[GothicCapitalG]2,\[GothicCapitalZ],\[GothicCapitalA]}] does the same for all listed stages.";

CytoplasmicLoci::usage = "CytoplasmicLoci\[Rule]{i,j\[Ellipsis]} is an option for ReferencePointMean and NonMendelian which specifies a set of cytoplasmically inherited loci; equivalent to MaternalLoci.";

MaternalLoci::usage = "MaternalLoci\[Rule]{i,j\[Ellipsis]} is an option for ReferencePointMean and NonMendelian which specifies a set of maternally inherited loci; equivalent to CytoplasmicLoci.";

PaternalLoci::usage = "PaternalLoci\[Rule]{i,j\[Ellipsis]} is an option for ReferencePointMean and NonMendelian which specifies a set of paternally inherited loci.";

XLinkedLoci::usage = "XLinkedLoci\[Rule]{i,j\[Ellipsis]} is an option for ReferencePointMean and NonMendelian which specifies a set of X-linked loci.";

YLinkedLoci::usage = "YLinkedLoci\[Rule]{i,j\[Ellipsis]} is an option for ReferencePointMean and NonMendelian which specifies a set of Y-linked loci.";

ZLinkedLoci::usage = "ZLinkedLoci\[Rule]{i,j\[Ellipsis]} is an option for ReferencePointMean and NonMendelian which specifies a set of Z-linked loci.";

WLinkedLoci::usage = "WLinkedLoci\[Rule]{i,j\[Ellipsis]} is an option for ReferencePointMean and NonMendelian which specifies a set of W-linked loci.";

NonMendelian::usage = "NonMendelian[CytoplasmicLoci->{i,j}] is a rule which simplifies recombination rates \!\(\[GothicR]\_\(A, \\ \(\(\\\\\)\(\\ \)\(B\)\)\)\)on the assumption that genes i, j are cytoplasmically inherited; also takes options MaternalLoci, PaternalLoci, XlinkedLoci, YLinkedLoci, ZLinkedLoci, and WLinkedLoci.";

Deme::usage = "Deme represents the deme a gene is in. By convention, the last component before Sex and/or SexOfOrigin";

Individual::usage = "Individual represents the individual organism a gene is in.";

FitnessSet::usage = "FitnessSet[\!\(c\_1\),\[Ellipsis]] or \!\(\[DoubleStruckCapitalW]\_\(c\_1, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)\)\) is the set of genes-in-context that may affect fitness.";

\[DoubleStruckCapitalW]::usage = "\!\(\[DoubleStruckCapitalW]\_\(c\_1, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)\)\) or FitnessSet[\!\(c\_1\),\[Ellipsis]] is the set of genes-in-context that may affect fitness.";

RecombinationSet::usage = "RecombinationSet[\!\(c\_1\),\[Ellipsis]] or \!\(\[DoubleStruckCapitalR]\_\(c\_1, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)\)\) is the set of genes-in-context that may affect recombination rates.";

\[DoubleStruckCapitalR]::usage = "\!\(\[DoubleStruckCapitalR]\_\(c\_1, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)\)\) or RecombinationSet[\!\(c\_1\),\[Ellipsis]] is the set of genes-in-context that may affect recombination rates.";

MigrationSet::usage = "MigrationSet[\!\(c\_1\),\[Ellipsis]] or \!\(\[DoubleStruckCapitalM]\_\(c\_1, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)\)\) is the set of genes-in-context that may affect migration rates.";

\[DoubleStruckCapitalM]::usage = "\!\(\[DoubleStruckCapitalM]\_\(c\_1, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)\)\) or MigrationSet[\!\(c\_1\),\[Ellipsis]] is the set of genes-in-context that may affect migration rates.";

Selection::usage = "Selection[\[DoubleStruckCapitalW]] is a rule which gives linkage disequilibria at the adult stage \[GothicCapitalA] in terms of those at the zygote stage, \[GothicCapitalZ]. Selection between zygote and adult is described by the selection coefficients \!\(\[GothicA]\_\[DoubleStruckCapitalU]\), and the set of selected genes \[DoubleStruckCapitalW]. Selection[{\[GothicCapitalZ],\[GothicCapitalA]},\[GothicA],\[DoubleStruckCapitalW]] defines the stages and coefficients explicitly.  Selection[{\[GothicCapitalZ],\[GothicCapitalA]},\[GothicA],\[DoubleStruckCapitalW],{\!\(c\_1\),\[Ellipsis]}] calls functions \!\(\[GothicA]\_\(c\_1, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[DoubleStruckCapitalU]\)\)\)\) and \!\(\[DoubleStruckCapitalW]\_\(c\_1, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)\)\) of the components of \[GothicCapitalZ].  Linkage disequilibria must only involve genes with the same values of the specified components.";

Recombination::usage = "Recombination[] is a rule which calculates \[GothicCapitalD] in the new gamete pool, \!\(\(\[GothicCapitalG]\^*\)\), as a sum over all possible recombination events amongst genes at the adult stage, \[GothicCapitalA].  Each recombination has rate \!\(\[GothicR]\_\(A, \\ \(\(\\\\\)\(\\ \)\(B\)\)\)\).  Recombination[{\[GothicCapitalA],\!\(\(\[GothicCapitalG]\^*\)\)},RecombinationRate] gives the stages and recombination rates explicitly. Recombination[{\!\(c\_1\),\[Ellipsis]}] or Recombination[{\[GothicCapitalA],\!\(\(\[GothicCapitalG]\^*\)\)},RecombinationRate,{\!\(c\_1\),\[Ellipsis]}] allows for variation in recombination rates \!\(\[GothicR]\_\(c\_1, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\ \)\) A\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\ \)\) B\)\)\)\) across components {\!\(c\_1\),\[Ellipsis]}. Recombination[\[DoubleStruckCapitalR]], Recombination[{\!\(c\_1\),\[Ellipsis]},\[DoubleStruckCapitalR]] etc allows for a dependence of recombination rate on the set of genes \[DoubleStruckCapitalR].  Recombination rates are then given in terms of \!\(\[GothicR]\_\(\[DoubleStruckCapitalV], \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(A\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\\\\  B\)\)\)\) , which is the dependence of recombination rates on the set of genes \[DoubleStruckCapitalV].";

UnlinkedRecombination::usage = "UnlinkedRecombination[A,B] gives the probability of recombination between sets A and B with no linkage; this is just \!\(2\^\(-n\)\), where there are n loci in total.";

LinkedRecombination::usage = "LinkedRecombination[A,B,{i,j,k\[Ellipsis]},c] gives the recombination rate \!\(r\_\(A, \\ B\)\) assuming the loci are in order {i,j,k\[Ellipsis]}, in terms of c[i,j], c[j,k]\[Ellipsis]  Assumes no interference or meiotic drive, and that all loci are autosomal. ";

\[GothicA]::usage = "\!\(\[GothicA]\_\[DoubleStruckCapitalU]\) or SelectionCoefficient[\[DoubleStruckCapitalU]] is the selection coefficient.  \!\(\[GothicA]\_\(c\_1, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[DoubleStruckCapitalU]\)\)\)\) or SelectionCoefficient[\!\(c\_1\),\[Ellipsis],\[DoubleStruckCapitalU]] makes the coefficient depend on components \!\(c\_1\),\[Ellipsis].";

SelectionCoefficient::usage = "SelectionCoefficient[\[DoubleStruckCapitalU]] or \!\(\[GothicA]\_\[DoubleStruckCapitalU]\) is the selection coefficient.  \!\(\[GothicA]\_\(c\_1, \\ \(\(\\\\\)\(\\ \)\(\[Ellipsis]\)\), \\ \(\(\\\\\)\(\\ \)\(\[DoubleStruckCapitalU]\)\)\)\) or SelectionCoefficient[\!\(c\_1\),\[Ellipsis],\[DoubleStruckCapitalU]] makes the coefficient depend on components \!\(c\_1\),\[Ellipsis].";

\[GothicR]::usage = "\!\(\[GothicR]\_\(A, \\ \(\(\\\\\)\(\\ \)\(B\)\)\)\) or RecombinationRate[A,B] is the probability that the set A of genes derive from the maternal genome, and set B from the paternal genome.  \!\(\[GothicA]\_\(c\_1\\ \[Ellipsis], \\ \(\(\\\\\)\(\\ \)\(A\)\), \\ \(\(\\\\\)\(\\ \)\(B\)\)\)\) or RecombinationRate[\!\(c\_1\),\[Ellipsis],A,B] makes the coefficient depend on components \!\(c\_1\),\[Ellipsis].  \!\(\[GothicR]\_\(c\_1, \\ \[Ellipsis], \\ \(\(\\\\\)\(\\ \)\(\[DoubleStruckCapitalU]\)\), \\ \(\(\\\\\)\(\\ \)\(A\)\), \\ B\)\) or RecombinationRate[\!\(c\_1\),\[Ellipsis],\[DoubleStruckCapitalU],A,B] is the dependence of the rate on the set of loci \[DoubleStruckCapitalU].";

RecombinationRate::usage = "RecombinationRate[A,B] or \!\(\[GothicR]\_\(A, \\ \(\(\\\\\)\(\\ \)\(B\)\)\)\) is the probability that the set A of genes derive from the maternal genome, and set B from the paternal genome.  \!\(\[GothicA]\_\(c\_1, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(A\)\), \\ \(\(\\\\\)\(\\ \)\(B\)\)\)\) or RecombinationRate[\!\(c\_1\),\[Ellipsis],A,B] makes the coefficient depend on components \!\(c\_1\),\[Ellipsis].  \!\(\[GothicA]\_\(c\_1, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[DoubleStruckCapitalU]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(A\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(B\)\)\)\) or RecombinationRate[\!\(c\_1\),\[Ellipsis],\[DoubleStruckCapitalU],A,B] is the dependence of the rate on the set of loci \[DoubleStruckCapitalU].";

\[CapitalMu]::usage = "\!\(\[CapitalMu]\_\(\[Alpha], \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Beta]\)\)\)\) or MigrationRate[\[Alpha],\[Beta]] is the chance that a gene in deme \[Alpha] came from deme \[Beta]. \!\(\[CapitalMu]\_\(c\_1, \\ \(\(\\\\\)\(\\ \)\(\[Ellipsis]\)\), \\ \(\(\\\\\)\(\\ \)\(\[Alpha]\)\), \\ \(\(\\\\\)\(\\ \)\(\[Beta]\)\)\)\) or MigrationRate[\!\(c\_1\),\[Ellipsis],\[Alpha],\[Beta]] makes the migration rate depend on components \!\(c\_1\),\[Ellipsis].  \!\(\[CapitalMu]\_\(c\_1, \\ \(\(\\\\\)\(\\ \)\(\[Ellipsis]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[DoubleStruckCapitalU]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Alpha]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Beta]\)\)\)\) or MigrationRate[\!\(c\_1\),\[Ellipsis],\[DoubleStruckCapitalU],\[Alpha],\[Beta]] is the dependence of the rate on the set of loci \[DoubleStruckCapitalU]. \!\(\[CapitalMu]\_\(Deme, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(c\_1\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[DoubleStruckCapitalU]\)\), \\ \(\(\\\\\)\(\\ \)\(\[Alpha]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Beta]\)\)\)\) states the relevant component explicitly. Entered as \[AliasIndicator]M\[AliasIndicator]";

MigrationRate::usage = "MigrationRate[\[Alpha],\[Beta]] or \!\(\[CapitalMu]\_\(\[Alpha], \\ \(\(\\\\\)\(\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\ \)\) \\\\\\\\ \(\(\\\\\)\(\\ \)\) \[Beta]\)\)\)\) is the chance that a gene in deme \[Alpha] came from deme \[Beta]. \!\(\[CapitalMu]\_\(c\_1, \\ \(\(\\\\\)\(\\ \)\(\[Ellipsis]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Alpha]\)\), \\ \(\(\\\\\)\(\\ \)\(\[Beta]\)\)\)\) or MigrationRate[\!\(c\_1\),\[Ellipsis],\[Alpha],\[Beta]] makes the migration rate depend on components \!\(c\_1\),\[Ellipsis].  \!\(\[CapitalMu]\_\(c\_1, \\ \(\(\\\\\)\(\\ \)\(\[Ellipsis]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[DoubleStruckCapitalU]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Alpha]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Beta]\)\)\)\) or MigrationRate[\!\(c\_1\),\[Ellipsis],\[DoubleStruckCapitalU],\[Alpha],\[Beta]] is the dependence of the rate on the set of loci \[DoubleStruckCapitalU]. \!\(\[CapitalMu]\_\(Deme, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(c\_1\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\), \\ \(\(\\\\\)\(\\ \)\(\[DoubleStruckCapitalU]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\ \)\) \[Alpha]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\ \)\) \[Beta]\)\)\)\) states the relevant component explicitly. Entered as \[AliasIndicator]M\[AliasIndicator]";

Migration::usage = "Migration[\[CapitalOmega]] is a rule which calculates \[GothicCapitalD] in the new juvenile pool, \[GothicCapitalJ], as a sum over all possible movements of genes at the zygote stage, \[GothicCapitalZ].  \[CapitalOmega][\[Alpha]] is the set of possible sources of immigrants to deme \[Alpha]; it will usually include \[Alpha] itself.  Each movement from \[Beta] to  \[Alpha] has rate \!\(\[CapitalMu]\_\(\[Alpha], \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Beta]\)\)\)\).  Migration[{\[GothicCapitalZ],\[GothicCapitalJ]},MigrationRate,\[CapitalOmega]] gives the stages and recombination rates explicitly. Migration[{\!\(c\_1\),\[Ellipsis]},\[CapitalOmega]] or Migration[{\[GothicCapitalZ],\[GothicCapitalJ]},MigrationRate,{\!\(c\_1\),\[Ellipsis]},\[CapitalOmega]] allows for variation in migration rates \!\(\[CapitalMu]\_\(c\_1, \\ \(\(\\\\\)\(\\ \)\(_\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Alpha]\)\), \\ \(\(\\\\\)\(\\ \)\(\[Beta]\)\)\)\) across components {\!\(c\_1\),\[Ellipsis]}. Migration[\[DoubleStruckCapitalM],\[CapitalOmega]], Migration[{\!\(c\_1\),\[Ellipsis]},\[DoubleStruckCapitalM],\[CapitalOmega]] etc allows for a dependence of recombination rate on the set of genes \[DoubleStruckCapitalM].  Migration rates are then given in terms of \!\(\[CapitalMu]\_\(\[DoubleStruckCapitalV], \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Alpha]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Beta]\)\)\)\), which is the dependence of recombination rates on the set of genes \[DoubleStruckCapitalV].";

SymmetricRecombination::usage = "SymmetricRecombination[] is a rule which replaces \!\(\[GothicR]\_\(c\_1, \\ \(\(\\\\\)\(\\ \)\(\[Ellipsis]\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(B\)\), \\ \(\(\\\\\)\(\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\ \)\) A\)\)\)\) by \!\(\[GothicR]\_\(c\_1, \\ \(\(\\\\\)\(\\ \)\(\[Ellipsis]\)\), \\ \(\(\\\\\)\(\\ \)\(A\)\), \\ \(\(\\\\\)\(\\ \)\(B\)\)\)\), on the assumption that reciprocal segregations are equally frequent. SymmetricRecombination[rec] applies to rec[\[Ellipsis],A,B].";

Biallelic::usage = "Biallelic[] is a rule which simplifies linkage disequilibria with repeated indices, {\[Ellipsis], \[DoubleStruckI],\[Ellipsis], \[DoubleStruckI], \[Ellipsis]}, assuming that there are two alleles at frequency \!\(\[GothicP]\_\[DoubleStruckI]\), \!\(\[GothicQ]\_\[DoubleStruckI]\), and labelled as \!\(X\_\[DoubleStruckI]\) = 0 or 1. Powers of allelic states, \!\(X\_\[DoubleStruckI]\) and allelic deviations, \!\(\[Zeta]\_\[DoubleStruckI]\), are also simplified. Biallelic[\[GothicP]] names the allele frequency explicitly as \[GothicP].  Biallelic[{i, j, \[Ellipsis]}] states which loci are biallelic. BiallelicPQ\[Rule]True names products of allele frequencies as \!\(\[GothicP]\[GothicQ]\_\[DoubleStruckI]\)= \!\(\[GothicP]\_\[DoubleStruckI]\)\!\(\[GothicQ]\_\[DoubleStruckI]\).";

BiallelicPQ::usage = "BiallelicPQ is an option for Biallelic[] which names products of allele frequencies as \!\(\[GothicP]\[GothicQ]\_\[DoubleStruckI]\)= \!\(\[GothicP]\_\[DoubleStruckI]\)\!\(\[GothicQ]\_\[DoubleStruckI]\).";

SymmetricSexes::usage = "SymmetricSexes[] is a rule which simplifies \[GothicM] and \[GothicCapitalD] on the assumption of symmetry across the sexes.  By default, \[GothicCapitalM] at Sex or SexOfOrigin is swapped for \[GothicCapitalF] if this will increase the proportion of \[GothicCapitalF].  SymmetricSexes[\[GothicCapitalM]] does the opposite.  SymmetricSexes[] may block later rules and so should be placed at the end of lists of rules.";

ToCumulants::usage = "ToCumulants[] is a rule which converts linkage disequilibria, \!\(\[GothicCapitalD]\_\[DoubleStruckCapitalU]\), to cumulants, \!\(\[GothicK]\_\[DoubleStruckCapitalU]\).  ToCumulants[mom,cum] does the same, for arbitrary symbols.";

ToMoments::usage = "ToMoments[] is a rule which converts cumulants, \!\(\[GothicK]\_\[DoubleStruckCapitalU]\), to linkage disequilibria, \!\(\[GothicCapitalD]\_\[DoubleStruckCapitalU]\).  ToMoments[cum,mom] does the same, for arbitrary symbols.";

ToBaake::usage = "ToBaake[] is a rule which converts disequilibria, \!\(\[GothicCapitalD]\_\[DoubleStruckCapitalU]\), to Baake's measures of association, \!\(\[GothicZ]\_\[DoubleStruckCapitalU]\), which decay exponentially under weak recombination.  The order of genes along the chromosome is assumed to be the same as in \[DoubleStruckCapitalU].  ToBaake[diseq,baake] does the same, for arbitrary symbols.";

FromBaake::usage = "FromBaake[] is a rule which converts Baake's measures of association, \!\(\[GothicZ]\_\[DoubleStruckCapitalU]\), to disequilibria, \!\(\[GothicCapitalD]\_\[DoubleStruckCapitalU]\).  The order of genes along the chromosome is assumed to be the same as in \[DoubleStruckCapitalU].  FromBaake[baake,diseq] does the same, for arbitrary symbols.";

CumulantDisequilibrium::usage = "CumulantDisequilibrium[\[DoubleStruckCapitalU]] or \!\(\[GothicK]\_\[DoubleStruckCapitalU]\) is a cumulant measure of the association among the set of genes \[DoubleStruckCapitalU].";

\[GothicK]::usage = "\!\(\[GothicK]\_\[DoubleStruckCapitalU]\) or CumulantDisequilibrium[\[DoubleStruckCapitalU]] is a cumulant measure of the association among the set of genes \[DoubleStruckCapitalU].";

BaakeDisequilibrium::usage = "BaakeDisequilibrium[\[DoubleStruckCapitalU]] or \!\(\[GothicZ]\_\[DoubleStruckCapitalU]\) is a measure of the association among the set of genes \[DoubleStruckCapitalU] which changes exponentially under weak recombination and mutation.";

\[GothicZ]::usage = "\!\(\[GothicZ]\_\[DoubleStruckCapitalU]\) or BaakeDisequilibrium[\[DoubleStruckCapitalU]] is a measure of the association among the set of genes \[DoubleStruckCapitalU] which changes exponentially under weak recombination and mutation.";

CumulantPopulationDisequilibrium::usage = "CumulantPopulationDisequilibrium[{{\[DoubleStruckCapitalU]},{\[DoubleStruckCapitalV]}\[Ellipsis]},{{\[DoubleStruckI]},{\[DoubleStruckJ]}},\[Ellipsis]] or \!\(\[GothicCapitalK]\_\({{\[DoubleStruckCapitalU]}, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\({\[DoubleStruckCapitalV]}\)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)}, \\ {{\[DoubleStruckI]}, \\ \(\(\\\\\)\(\\ \)\({\[DoubleStruckJ]}\)\)}, \\ \(\(\\\\\)\(\\ \)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)\)\) is a cumulant measure of the association amongst a set of random variables.";

\[GothicCapitalK]::usage = "\!\(\[GothicCapitalK]\_\({{\[DoubleStruckCapitalU]}, \\ \(\(\\\\\)\(\\ \)\({\[DoubleStruckCapitalV]}\)\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)}, \\ \(\(\\\\\)\(\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\ \)\) {{\[DoubleStruckI]}, \\ \(\(\\\\\)\(\\ \)\({\[DoubleStruckJ]}\)\)}\)\), \\ \(\(\\\\\)\(\\ \)\(\[Ellipsis]\)\)\)\) or CumulantPopulationDisequilibrium[{{\[DoubleStruckCapitalU]},{\[DoubleStruckCapitalV]}\[Ellipsis]},{{\[DoubleStruckI]},{\[DoubleStruckJ]}},\[Ellipsis]] is a cumulant measure of the association amongst a set of random variables.";

ToPopulationCumulants::usage = "ToPopulationCumulants[] is a rule which converts moments across populations, \!\(\[GothicCapitalC]\_\[DoubleStruckCapitalU]\), to cumulants, \!\(\[GothicCapitalK]\_\[DoubleStruckCapitalU]\).  ToPopulationCumulants[mom,cum] does the same, for arbitrary symbols.";

ToPopulationMoments::usage = "ToPopulationMoments[] is a rule which converts cumulants across populations, \!\(\[GothicCapitalK]\_\[DoubleStruckCapitalU]\), to momenta across populations, \!\(\[GothicCapitalC]\_\[DoubleStruckCapitalU]\).  ToPopulationMoments[cum,mom] does the same, for arbitrary symbols.";

\[GothicS]::usage = "\[GothicS] is the default symbol for a small quantity such as a selection coefficient.";

SlowChange::usage = "SlowChange[expr] approximates expr by a first-order expansion in \[GothicS]. SlowChange[expr,\[Epsilon],k] approximates by a k'th order expansion in \[Epsilon].";

WrightFisherSampling::usage = "WrightFisherSampling[2N] is a rule which expresses associations \[GothicCapitalC]  involving genes-in-context at the adult stage to those at the juvenile stage. WrightFisherSampling[{\[GothicCapitalJ],\[GothicCapitalA]},2N] gives the stages explicitly.  SlowChange\[Rule]True only calculates to first order in \!\(1\/\(2\\\\\\ N\)\).";

FromBennett::usage = "FromBennett[] is a rule which expresses Bennett's measure of disequilibrium, \!\(\[GothicB]\_U\), in terms of \!\(\[GothicCapitalD]\_U\).  The expression is written in terms of recombination rates, \!\(\[GothicR]\_\(A, \\ \(\(\\\\\)\(\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\ \)\) B\)\)\)\). FromBennett[b,d,r] does the same, for arbitrary symbols.";

ToBennett::usage = "ToBennett[] is a rule which expresses \!\(\[GothicCapitalD]\_U\) in terms of Bennett's measure of disequilibrium, \!\(\[GothicB]\_U\), which decay exponentially under recombination.  The expression is written in terms of recombination rates, \!\(\[GothicR]\_\(A, \\ B\)\). ToBennett[d,b,r] does the same, for arbitrary symbols.";

ToBennettExpression::usage = "ToBennettExpression[U] is an expression for \!\(\[GothicCapitalD]\_U\) in terms of \!\(\[GothicB]\_U\), \!\(\[GothicR]\_\(A, \\ B\)\).  ToBennettExpression[n] stores ToBennettExpression[Range[n]].";

FromBennettExpression::usage = "FromBennettExpression[U] is an expression for \!\(\[GothicB]\_U\) in terms of \!\(\[GothicCapitalD]\_U\), \!\(\[GothicR]\_\(A, \\ B\)\).  FromBennettExpression[n] stores FromBennettExpression[Range[n]].";

BennettB::usage = "BennettB[U] or \!\(\[GothicB]\_U\) denotes Bennett's measure of linkage disequilibrium, which decays exponentially under recombination. \!\(\[GothicB]\_\({U, \\ V, \\ \[Ellipsis]} \(\(\\\\\)\(\\ \)\)\)\)is interpreted as \!\(\[GothicB]\_U\)\!\(\[GothicB]\_V\)\[Ellipsis] ";

\[GothicB]::usage = "\!\(\[GothicB]\_U\) or BennettB[U] denotes Bennett's measure of linkage disequilibrium, which decays exponentially under recombination.  \!\(\[GothicB]\_\({U, \\ V, \\ \[Ellipsis]} \(\(\\\\\)\(\\ \)\)\)\)is interpreted as \!\(\[GothicB]\_U\)\!\(\[GothicB]\_V\)\[Ellipsis] ";

BennettExpansion::usage = "BennettExpansion[U] stores the expansion used to generate Bennett's coefficients; uses a dummy function bb. ";

BennettC::usage = "BennettC[P] gives the coefficient \!\(c\_P\) in an expression for Bennett's measure of disequilibrium, \!\(\[GothicB]\_U\)=\!\(\[GothicCapitalD]\_\[DoubleStruckCapitalU]\)+\!\(\[Sum]\+\(\(\(P\)\(\\\\\)\)\\ \\  \[Element] \\ \(\(\\\\\)\(\\ \)\(\[DoubleStruckCapitalP][U]\)\)\)\)\!\(c\_P\)\!\(\[GothicB]\_P\).  The expression is in terms of \!\(\[GothicR]\_\(A, \\ \(\(\\\\\)\(\\ \)\(B\)\)\)\), with \!\(\[GothicR]\_\(A, \\ \(\(\\\\\)\(\\ \)\(B\)\)\)\) assumed equal to \!\(\[GothicR]\_\(B, \\ \(\(\\\\\)\(\\ \)\(A\)\)\)\). ";

BennettCstandard::usage = "BennettCstandard[P] generates and stores the coefficient \!\(c\_P\) in an expression for Bennett's measure of disequilibrium, \!\(\[GothicB]\_U\)=\!\(\[GothicCapitalD]\_\[DoubleStruckCapitalU]\)+\!\(\[Sum]\+\(\(\(P\)\(\\\\\)\)\\ \\  \[Element] \\ \(\(\\\\\)\(\\ \)\(\[DoubleStruckCapitalP][U]\)\)\)\)\!\(c\_P\)\!\(\[GothicB]\_P\). = ";

Begin["Multilocus`Multilocus`Private`"];

<< "Utilities`SetManipulation`";

Notation[DoubleLongLeftRightArrow[NotationBoxTag["Multilocus`Multilocus`\[Sampi]"], NotationBoxTag["Multilocus`Multilocus`Stage"]]];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SubscriptBox["X", "\[DoubleStruckI]_"]], NotationBoxTag[RowBox[List["AllelicState", "[", "\[DoubleStruckI]_", "]"]]]]];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SubscriptBox["\[Zeta]", "\[DoubleStruckI]_"]], NotationBoxTag[RowBox[List["AllelicDeviation", "[", "\[DoubleStruckI]_", "]"]]]]];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SubscriptBox["\[WeierstrassP]", "\[DoubleStruckI]_"]], NotationBoxTag[RowBox[List["ReferencePoint", "[", "\[DoubleStruckI]_", "]"]]]]];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SubscriptBox["\[GothicM]", "\[DoubleStruckI]_"]], NotationBoxTag[RowBox[List["MeanContribution", "[", "\[DoubleStruckI]_", "]"]]]]];

Disequilibrium[{}] = 1;

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SubscriptBox["\[GothicCapitalD]", "\[DoubleStruckI]_"]], NotationBoxTag[RowBox[List["Multilocus`Multilocus`Disequilibrium", "[", "\[DoubleStruckI]_", "]"]]]]];

PopulationDisequilibrium[{}...] = 1;

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SubscriptBox["\[GothicCapitalC]", "\[DoubleStruckI]__"]], NotationBoxTag[RowBox[List["Multilocus`Multilocus`PopulationDisequilibrium", "[", "\[DoubleStruckI]__", "]"]]]]];

ContextPosition[s_, c_] := If[c === s, 1, If[ContextComponentQ[s, c], 1 + Position[ContextStructure[s], c][[1,1]], Message[ContextPosition::nocom, s, c]; 0]];

ContextPosition::nocom = "Components not defined for ContextPosition[`1`,`2`]";

ContextComponentQ[_, _] := False;

ContextStageQ[_] := False;

DefineContext[s_, cl_List] := Module[{}, ContextStructure[s] = cl; ContextStageQ[s] = True; Scan[(ContextComponentQ[s, #1] = True) & , ContextStructure[s]]];

FullContext[{cc_List, x:(Subscript[_, _List]...)}] := {x} /. {Subscript[i_, c_] :> Subscript[i, (cc & ) @@ c]};

ShortContext[{}] := {};
ShortContext[cc:{Subscript[_, {b_, ___}]...}] := Module[{cl = Transpose[cc /. {Subscript[_, c_] :> c}], com, subs, k = 0, ss}, subs = Transpose[{cc /. Subscript[i_, _] :> i, Transpose[DeleteCases[cl, {a_...}]]}] /. {i_, s_List} :> Subscript[i, s]; ss = Replace[cl /. {a_...} :> a, _List -> #1, 1]; com = Table[If[ss[[j]] === #1, k += 1; Slot[k], ss[[j]]], {j, Length[ss]}]; Prepend[subs, com]];

SelectContext[\[DoubleStruckCapitalU]:{Subscript[_, _List]...}, c_List] := Module[{s}, If[ContextStageQ[c[[1]]], Cases[\[DoubleStruckCapitalU], Subscript[_, c]], s = Union[\[DoubleStruckCapitalU] /. {Subscript[_, {a_, ___}] :> a}]; If[Length[s] > 1, Message[SelectContext::mxstg, \[DoubleStruckCapitalU], c], If[ContextStageQ[s[[1]]], SelectContext[\[DoubleStruckCapitalU], Prepend[c, s[[1]]]], Message[SelectContext::mxstg, \[DoubleStruckCapitalU], c]]]]];

SelectContext::mxstg = "Multiple stages specified in SelectContext[`1`,`2`]";
SelectContext::nostg = "No stage defined in SelectContext[`1`,`2`]";

SelectContext[\[DoubleStruckCapitalU]:{_List, Subscript[_, _List]...}, cx__] := SelectContext[FullContext[\[DoubleStruckCapitalU]], cx];

SelectContext[\[DoubleStruckCapitalU]:{Subscript[_, _List]...}, c_List, (x_)?( !ListQ[#1] & )] := SelectContext[\[DoubleStruckCapitalU], c, {x}];

SelectContext[\[DoubleStruckCapitalU]:{Subscript[_, {a_, ___}]...}, c_List, x_List] := SelectContext[\[DoubleStruckCapitalU], ((ps = Position[x, #1]; If[ps == {}, _, c[[ps[[1,1]]]]]) & ) /@ ContextStructure[a]];

SelectContext[{}, __] := {};

Notation[DoubleLongLeftRightArrow[NotationBoxTag[RowBox[List["U_", "\[CircleDot]", "c_"]]], NotationBoxTag[RowBox[List["Multilocus`Multilocus`SelectContext", "[", RowBox[List["U_", ",", "c_"]], "]"]]]]];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[RowBox[List["U_", SubscriptBox["\[CircleDot]", "x_"], "c_"]]], NotationBoxTag[RowBox[List["Multilocus`Multilocus`SelectContext", "[", RowBox[List["U_", ",", "c_", ",", "x_"]], "]"]]]]];

ExtractGenes[\[DoubleStruckCapitalU]:{Subscript[_, {(s_)?ContextStageQ, ___}]...}] := \[DoubleStruckCapitalU] /. {Subscript[i_, _] :> i};

ExtractGenes[\[DoubleStruckCapitalU]:{_List, Subscript[_, _List]...}] := ExtractGenes[FullContext[\[DoubleStruckCapitalU]]];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[RowBox[List["\[Gamma]", "[", "\[DoubleStruckCapitalU]_", "]"]]], NotationBoxTag[RowBox[List["ExtractGenes", "[", "\[DoubleStruckCapitalU]_", "]"]]]]];
Notation[DoubleLongLeftRightArrow[NotationBoxTag[RowBox[List[SubscriptBox["\[Gamma]", "x_"], "[", "\[DoubleStruckCapitalU]_", "]"]]], NotationBoxTag[RowBox[List["ExtractGenes", "[", RowBox[List["\[DoubleStruckCapitalU]_", ",", "x_"]], "]"]]]]];

ExtractContexts[\[DoubleStruckCapitalU]:{Subscript[_, _List]...}] := \[DoubleStruckCapitalU] /. {Subscript[_, c_List] :> c};

ExtractContexts[\[DoubleStruckCapitalU]:{Subscript[_, {a_, ___}]...}, x_List] := Module[{ps}, Transpose[((ps = ContextPosition[a, #1]; \[DoubleStruckCapitalU] /. {Subscript[_, c_] :> c[[ps]]}) & ) /@ x]];

ExtractContexts[\[DoubleStruckCapitalU]:{_List, Subscript[_, _List]...}, x___List] := ExtractContexts[FullContext[\[DoubleStruckCapitalU]], x];

ExtractContexts[\[DoubleStruckCapitalU]:{Subscript[_, _List]...}, (x_)?( !ListQ[#1] & )] := ExtractContexts[\[DoubleStruckCapitalU], {x}];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[RowBox[List["\[Chi]", "[", "\[DoubleStruckCapitalU]_", "]"]]], NotationBoxTag[RowBox[List["ExtractContexts", "[", "\[DoubleStruckCapitalU]_", "]"]]]]];
Notation[DoubleLongLeftRightArrow[NotationBoxTag[RowBox[List[SubscriptBox["\[Chi]", "x_"], "[", "\[DoubleStruckCapitalU]_", "]"]]], NotationBoxTag[RowBox[List["ExtractContexts", "[", RowBox[List["\[DoubleStruckCapitalU]_", ",", "x_"]], "]"]]]]];

TransmissionRule[pres_List, prev_List] := Subscript[i_, pres] :> Subscript[i, prev];
TransmissionRule[pres_List, prev_List, A_List] := Subscript[(i_)?(MemberQ[A, #1] & ), pres] :> Subscript[i, prev];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[RowBox[List["pres_", "\[LeftArrow]", "prev_"]]], NotationBoxTag[RowBox[List["Multilocus`Multilocus`TransmissionRule", "[", RowBox[List["pres_", ",", "prev_"]], "]"]]]]];
Notation[DoubleLongLeftRightArrow[NotationBoxTag[RowBox[List["pres_", UnderscriptBox["\[LeftArrow]", "A_"], "prev_"]]], NotationBoxTag[RowBox[List["Multilocus`Multilocus`TransmissionRule", "[", RowBox[List["pres_", ",", "prev_", ",", "A_"]], "]"]]]]];

ChangeContext[MeanContribution[\[DoubleStruckI]_], r_] := MeanContribution[First[{\[DoubleStruckI]} \[CirclePlus] r]];

ChangeContext[\[DoubleStruckCapitalU]_List, r_] := If[ListQ[r], \[DoubleStruckCapitalU] /. Flatten[r], \[DoubleStruckCapitalU] /. r];

ChangeContext[Disequilibrium[\[DoubleStruckCapitalA]_List], r_] := Module[{\[DoubleStruckCapitalB], \[DoubleStruckCapitalC], cs, rp}, \[DoubleStruckCapitalB] = If[ListQ[r], \[DoubleStruckCapitalA] /. Flatten[r], \[DoubleStruckCapitalA] /. r]; cs[sb_List] := \[DoubleStruckCapitalA][[(Position[\[DoubleStruckCapitalB], #1][[1,1]] & ) /@ sb]]; rp[x_List] := (ReferencePoint[#1] & ) /@ x; Plus @@ (Disequilibrium[TakeAway[\[DoubleStruckCapitalB], #1]]*Times @@ (rp[#1] - rp[cs[#1]]) & ) /@ Subsets[\[DoubleStruckCapitalB]]];

ChangeContext[PopulationDisequilibrium[{\[DoubleStruckCapitalA]___List}, {\[DoubleStruckCapitalE]___List}, \[DoubleStruckCapitalF]___List], r_] := Module[{\[DoubleStruckCapitalB], \[DoubleStruckCapitalA]t, \[DoubleStruckCapitalB]t, rt, ff, gg}, \[DoubleStruckCapitalB] = If[ListQ[r], \[DoubleStruckCapitalA] /. Flatten[r], \[DoubleStruckCapitalA] /. r]; \[DoubleStruckCapitalB]t = AddTag[\[DoubleStruckCapitalB], 3]; \[DoubleStruckCapitalA]t = AddTag[{\[DoubleStruckCapitalA]}, 3]; gg[\[DoubleStruckCapitalC]t_, \[DoubleStruckCapitalD]t_] := Join[TakeAway[\[DoubleStruckCapitalC]t, \[DoubleStruckCapitalD]t], \[DoubleStruckCapitalA]t[[(Position[\[DoubleStruckCapitalB]t, #1][[1,1]] & ) /@ \[DoubleStruckCapitalD]t]]] /. {Tag[x_, _] -> {x}}; ff[\[DoubleStruckCapitalC]t_] := Plus @@ (rt = RemoveTag[TakeAway[\[DoubleStruckCapitalB]t, \[DoubleStruckCapitalC]t], 3]; ((-1)^Length[#1]*PopulationDisequilibrium[rt, Join[gg[\[DoubleStruckCapitalC]t, #1], {\[DoubleStruckCapitalE]}], \[DoubleStruckCapitalF]] & ) /@ Subsets[\[DoubleStruckCapitalC]t]); Plus @@ ff /@ Subsets[\[DoubleStruckCapitalB]t]];

ChangeContext[MeanContribution[\[DoubleStruckI]_], r_] := MeanContribution[First[{\[DoubleStruckI]} \[CirclePlus] r]];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[RowBox[List["U_", "\[CirclePlus]", "r_"]]], NotationBoxTag[RowBox[List["Multilocus`Multilocus`ChangeContext", "[", RowBox[List["U_", ",", "r_"]], "]"]]]]];

ChangeContext[MeanContribution[\[DoubleStruckI]_], r_] := MeanContribution[First[ChangeContext[{\[DoubleStruckI]}, r]]];

Expectation[(f_)?(PolynomialQ[#1, Join[Cases[#1, AllelicDeviation[_], {1, Infinity}], Cases[#1, AllelicState[_], {1, Infinity}]]] & )] := Module[{d}, Expand[f /. {AllelicState[a_] :> Subscript[d, {a}] + ReferencePoint[a], AllelicDeviation[a_] :> Subscript[d, {a}]}] //. {Subscript[d, a_]*Subscript[d, b_] :> Subscript[d, Join[a, b]], Subscript[d, a_]^n_Integer :> Subscript[d, Repeat[a, n]], Subscript[d, U_] :> Subscript[d, Sort[U]]} /. Subscript[d, U_List] :> Disequilibrium[U]];

Expectation[a_] := Expectation[SimplifyAddUp[a]] /;  !SimplifyAddUpQ[a];
Expectation[a_ + b_] := Expectation[a] + Expectation[b];
Expectation[AddUp[a_, e_List, S_List, opts___Rule]] := AddUp[Evaluate[Expectation[a]], e, S, opts];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[RowBox[List["\[LeftAngleBracket]", "f_", "\[RightAngleBracket]"]]], NotationBoxTag[RowBox[List["Multilocus`Multilocus`Expectation", "[", "f_", "]"]]]]];

PopulationExpectation[e_, a___, \[GothicA], b___] := PopulationExpectation[e, a, SelectionCoefficient, b];
PopulationExpectation[e_, a___, \[CapitalMu], b___] := PopulationExpectation[e, a, MigrationRate, b];
PopulationExpectation[e_, a___, \[GothicR], b___] := PopulationExpectation[e, a, RecombinationRate, b];
PopulationExpectation[e_, a___, \[GothicCapitalD], b___] := PopulationExpectation[e, a, Disequilibrium, b];
PopulationExpectation[e_, a___, \[GothicM], b___] := PopulationExpectation[e, a, MeanContribution, b];
PopulationExpectation[e_, a___, \[WeierstrassP], b___] := PopulationExpectation[e, a, ReferencePoint, b];

PopulationExpectation[e_] := PopulationExpectation[e, Disequilibrium, MeanContribution];

PopulationExpectation[e_, ff___] := Module[{cc, rl, i, n, ffn}, n = Length[{ff}]; rl = Flatten[Table[{{ff}[[i]][x___] :> Evaluate[cc[ReplacePart[Repeat[{{}}, n], {{x}}, i]]], {ff}[[i]][x___]^k_Integer -> Evaluate[cc[ReplacePart[Repeat[{{}}, n], Repeat[{x}, k], i]]]}, {i, n}]]; Expand[e] /. rl //. {cc[a_]*cc[b_] :> cc[(Join @@ #1 & ) /@ Transpose[{a, b}]]} /. cc[U__List] :> PopulationDisequilibrium @@ Sort /@ U] /; PolynomialQ[e, Cases[e, Alternatives @@ (#1[___] & ) /@ {ff}, {1, Infinity}]];

PopulationExpectation[a_, ff___] := PopulationExpectation[SimplifyAddUp[a], ff] /;  !SimplifyAddUpQ[a];
PopulationExpectation[a_ + b_, ff___] := PopulationExpectation[a, ff] + PopulationExpectation[b, ff];
PopulationExpectation[AddUp[a_, e_List, S_List, opts___Rule], ff___] := AddUp[Evaluate[PopulationExpectation[a, ff]], e, S, opts];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[RowBox[List["\[LeftDoubleBracketingBar]", RowBox[List["\\", "f_"]], "\[RightDoubleBracketingBar]"]]], NotationBoxTag[RowBox[List["Multilocus`Multilocus`PopulationExpectation", "[", "f_", "]"]]]]];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SubscriptBox[RowBox[List["\[LeftDoubleBracketingBar]", "f_", "\[RightDoubleBracketingBar]"]], "g__"]], NotationBoxTag[RowBox[List["Multilocus`Multilocus`PopulationExpectation", "[", RowBox[List["f_", ",", "g__"]], "]"]]]]];

MakeFitnessSet[(expr_)?(FreeQ[#1, AddUp] & )] := Module[{fs, ex = expr /. AllelicState[i_] -> AllelicDeviation[i] + ReferencePoint[i]}, fs = Union[Cases[ex, AllelicDeviation[_], {1, Infinity}]]; If[ !PolynomialQ[expr, fs], Message[MakeFitnessSet::notpolynomial, expr, fs]]; Flatten[(Repeat[{#1}, Exponent[ex, #1]] & ) /@ fs] /. AllelicDeviation[i_] -> i];

MakeFitnessSet[a_] := MakeFitnessSet[SimplifyAddUp[a]] /;  !SimplifyAddUpQ[a];
MakeFitnessSet[a_ + b_] := Module[{sa = MakeFitnessSet[a], sb = MakeFitnessSet[b]}, Flatten[(Repeat[{#1}, Max[Count[sa, #1], Count[sb, #1]]] & ) /@ Union[sa, sb]]];
MakeFitnessSet[AddUp[a_, e_List, S_List, Subsets -> True]] := MakeFitnessSet[AddUp[a, e, Union[Sort /@ Subsets[S]]]];
MakeFitnessSet[AddUp[a_, e_List, S_List]] := Module[{v, k, ex = a /. AllelicState[i_] -> AllelicDeviation[i] + ReferencePoint[i]}, v = Union[Cases[ex, AllelicDeviation[_], {1, Infinity}]]; v = Union[v /. Table[e[[k]] -> S[[k]], {k, Length[e]}]]; If[ !PolynomialQ[a, v], Message[MakeFitnessSet::notpolynomial, a, v]]; Flatten[(Repeat[{#1}, Exponent[ex, #1]] & ) /@ v] /. AllelicDeviation[i_] -> i];

MakeFitnessSet::notpolynomial = "`1` is not polynomial in `2`";

MakeSelectionCoefficient[\[DoubleStruckCapitalU]_List, (Z_)?(FreeQ[#1, AddUp] & )] := Module[{fs}, fs = Union[Cases[Z /. AllelicState[i_] -> AllelicDeviation[i] + ReferencePoint[i], AllelicDeviation[_], {1, Infinity}]]; If[ !PolynomialQ[Z, fs], Message[MakeSelectionCoefficient::notpolynomial, expr, fs]; 0, If[\[DoubleStruckCapitalU] == {}, Expectation[Z], Coefficient[Z /. AllelicState[i_] -> AllelicDeviation[i] + ReferencePoint[i], Times @@ (AllelicDeviation[#1] & ) /@ \[DoubleStruckCapitalU]] /. (AllelicDeviation[#1] -> 0 & ) /@ MakeFitnessSet[Z]]]];

MakeSelectionCoefficient[\[DoubleStruckCapitalU]_List, a_] := MakeSelectionCoefficient[\[DoubleStruckCapitalU], SimplifyAddUp[a]] /;  !SimplifyAddUpQ[a];

MakeSelectionCoefficient[\[DoubleStruckCapitalU]_List, a_ + b_] := MakeSelectionCoefficient[\[DoubleStruckCapitalU], a] + MakeSelectionCoefficient[\[DoubleStruckCapitalU], b];

MakeSelectionCoefficient::notpolynomial = "`1` is not polynomial in `2`";

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SuperscriptBox["\[GothicCapitalG]", "*"]], NotationBoxTag["\[GothicCapitalG]new"]]];

UnionOfGametes[] := UnionOfGametes[{\[GothicCapitalG], \[GothicCapitalZ]}];
UnionOfGametes[{(s1_)?ContextStageQ, (s2_)?ContextStageQ}] := If[ContextComponentQ[s2, Sex], {Disequilibrium[\[DoubleStruckCapitalU]:{Subscript[_, {s2, __}]..}] :> ChangeContext[Disequilibrium[\[DoubleStruckCapitalU]], TransmissionRule[{s2, x___, sex_, soo_}, {s1, x, soo}]], MeanContribution[\[DoubleStruckI]:Subscript[_, {s2, __}]] :> MeanContribution[ChangeContext[{\[DoubleStruckI]}, TransmissionRule[{s2, x___, sex_, soo_}, {s1, x, soo}]][[1]]]}, {Disequilibrium[\[DoubleStruckCapitalU]:{Subscript[_, {s2, __}]..}] :> ChangeContext[Disequilibrium[\[DoubleStruckCapitalU]], TransmissionRule[{s2, x___, soo_}, {s1, x, soo}]], MeanContribution[\[DoubleStruckI]:Subscript[_, {s2, __}]] :> MeanContribution[ChangeContext[{\[DoubleStruckI]}, TransmissionRule[{s2, x___, soo_}, {s1, x, soo}]][[1]]]}];

Meiosis[A_List, B_List] := Meiosis[{\[GothicCapitalA], \[GothicCapitalG]new}, A, B];
Meiosis[{(s1_)?ContextStageQ, (s2_)?ContextStageQ}, A_List, B_List] := {TransmissionRule[{s2, x___, sex_}, {s1, x, sex, \[GothicCapitalF]}, A], TransmissionRule[{s2, x___, sex_}, {s1, x, sex, \[GothicCapitalM]}, B]};

Migrate[\[Alpha]_, \[Beta]_] := Migrate[{\[GothicCapitalZ], \[GothicCapitalJ]}, \[Alpha], \[Beta]];
Migrate[{(s1_)?ContextStageQ, (s2_)?ContextStageQ}, \[Alpha]_, \[Beta]_] := If[ContextComponentQ[s2, Sex] && ContextComponentQ[s2, SexOfOrigin], {TransmissionRule[{s2, x___, \[Alpha], sex:(\[GothicCapitalM] | \[GothicCapitalF]), soo:(\[GothicCapitalM] | \[GothicCapitalF])}, {s1, x, \[Beta], sex, soo}]}, {TransmissionRule[{s2, x___, \[Alpha], sex:(\[GothicCapitalM] | \[GothicCapitalF])}, {s1, x, \[Beta], sex}]}];

ReferencePointZero[(s_)?ContextStageQ] := ReferencePointZero[s, MeanContribution];
ReferencePointZero[(s_)?ContextStageQ, m_] := {ReferencePoint[Subscript[i_, {s, x___}]] :> m[Subscript[i, {s, x}]], Disequilibrium[{Subscript[_, {s, ___}]}] :> 0};

ReferencePointZero[sl:{_?ContextStageQ...}] := ReferencePointZero[sl, MeanContribution];
ReferencePointZero[sl:{_?ContextStageQ...}, m_] := Flatten[(ReferencePointZero[#1, m] & ) /@ sl];

Options[ReferencePointMean] = {CytoplasmicLoci -> {}, PaternalLoci -> {}, XLinkedLoci -> {}, YLinkedLoci -> {}, ZLinkedLoci -> {}, WLinkedLoci -> {}};

ReferencePointMean::lociOverlap = "Overlapping sets of genes specified: C: `1`, P: `2`, X: `3`, Y: `4`, Z: `5`, W: `6`";

ReferencePointMean::ZWXYmix = "Cannot specify both XY linkage and ZW linkage: `1`, `2`";

ReferencePointMean::XlinkageClash = "An X-linked gene in a male cannot derive from the father: `1`";

ReferencePointMean::YlinkageClash = "A Y-linked gene cannot be in a female gamete or derive from the mother: `1`";

ReferencePointMean::ZlinkageClash = "A Z-linked gene in a female cannot derive from the mother: `1`";

ReferencePointMean::WlinkageClash = "A W-linked gene cannot be in a male gamete or derive from the father: `1`";

ReferencePointMean::PaternalClash = "A paternally inherited gene cannot be in a female gamete or derive from the mother: `1`";

ReferencePointMean::CytoplasmicClash = "A cytoplasmically inherited gene cannot be in a male gamete or derive from the father: `1`";

ReferencePointMean::not = "Component is not \[GothicCapitalM] or \[GothicCapitalF]: `1`";

ReferencePointMean[(s_)?ContextStageQ, opts___Rule] := ReferencePointMean[s, MeanContribution, opts];
ReferencePointMean[(s_)?ContextStageQ, m_, opts___Rule] := Module[{xs = XLinkedLoci /. {opts} /. Options[ReferencePointMean], ys = YLinkedLoci /. {opts} /. Options[ReferencePointMean], zs = ZLinkedLoci /. {opts} /. Options[ReferencePointMean], ws = WLinkedLoci /. {opts} /. Options[ReferencePointMean], ps = PaternalLoci /. {opts} /. Options[ReferencePointMean], cs = CytoplasmicLoci /. {opts} /. Options[ReferencePointMean], X, Y, Z, W, C, P, A, f}, If[Join[xs, ys, cs, ps, zs, ws] == {}, {ReferencePoint[Subscript[i_, {s, x___, ss_}]] :> 1/2*(m[Subscript[i, {s, x, \[GothicCapitalF]}]] + m[Subscript[i, {s, x, \[GothicCapitalM]}]]), Disequilibrium[{Subscript[i_, {s, x___, \[GothicCapitalM]}]}] :> 1/2*(m[Subscript[i, {s, x, \[GothicCapitalM]}]] - m[Subscript[i, {s, x, \[GothicCapitalF]}]]), Disequilibrium[{Subscript[i_, {s, x___, \[GothicCapitalF]}]}] :> 1/2*(m[Subscript[i, {s, x, \[GothicCapitalF]}]] - m[Subscript[i, {s, x, \[GothicCapitalM]}]])}, If[Length[Join[xs, ys]]*Length[Join[zs, ws]] != 0, Message[ReferencePointMean::ZWXYmix, Join[xs, ys], Join[zs, ws]]; {}, If[Length[Join[xs, ys, cs, ps, zs, ws]] == Length[Union[Join[xs, ys, cs, ps, zs, ws]]], f[g_] := If[MemberQ[xs, g], X, If[MemberQ[ys, g], Y, If[MemberQ[cs, g], C, If[MemberQ[ps, g], P, If[MemberQ[zs, g], Z, If[MemberQ[ws, g], W, A]]]]]]; {ReferencePoint[Subscript[i_, {s, x___, ss_}]] :> Switch[f[i], A, 1/2*(m[Subscript[i, {s, x, \[GothicCapitalF]}]] + m[Subscript[i, {s, x, \[GothicCapitalM]}]]), X, If[ContextComponentQ[s, SexOfOrigin], Switch[Last[{x}], \[GothicCapitalM], m[Subscript[i, {s, x, \[GothicCapitalF]}]], \[GothicCapitalF], 1/2*(m[Subscript[i, {s, x, \[GothicCapitalF]}]] + m[Subscript[i, {s, x, \[GothicCapitalM]}]]), _, Message[ReferencePointMean::not, ReferencePoint[Subscript[i, {s, x, ss}]]]; ReferencePoint[Subscript[i, {s, x, ss}]]], 1/3*(2*m[Subscript[i, {s, x, \[GothicCapitalF]}]] + m[Subscript[i, {s, x, \[GothicCapitalM]}]])], Z, If[ContextComponentQ[s, SexOfOrigin], Switch[Last[{x}], \[GothicCapitalF], m[Subscript[i, {s, x, \[GothicCapitalM]}]], \[GothicCapitalM], 1/2*(m[Subscript[i, {s, x, \[GothicCapitalF]}]] + m[Subscript[i, {s, x, \[GothicCapitalM]}]]), _, Message[ReferencePointMean::not, ReferencePoint[Subscript[i, {s, x, ss}]]]; ReferencePoint[Subscript[i, {s, x, ss}]]], 1/3*(m[Subscript[i, {s, x, \[GothicCapitalF]}]] + 2*m[Subscript[i, {s, x, \[GothicCapitalM]}]])], Y, m[Subscript[i, {s, x, \[GothicCapitalM]}]], W, m[Subscript[i, {s, x, \[GothicCapitalF]}]], P, m[Subscript[i, {s, x, \[GothicCapitalM]}]], C, m[Subscript[i, {s, x, \[GothicCapitalF]}]]], Disequilibrium[{Subscript[i_, {s, x___, \[GothicCapitalM]}]}] :> Switch[f[i], A, 1/2*(m[Subscript[i, {s, x, \[GothicCapitalM]}]] - m[Subscript[i, {s, x, \[GothicCapitalF]}]]), X, If[ContextComponentQ[s, SexOfOrigin], Switch[Last[{x}], \[GothicCapitalM], Message[ReferencePointMean::XlinkageClash, Disequilibrium[{Subscript[i, {s, x, \[GothicCapitalM]}]}]]; Disequilibrium[{Subscript[i, {s, x, \[GothicCapitalM]}]}], \[GothicCapitalF], 1/2*(m[Subscript[i, {s, x, \[GothicCapitalM]}]] - m[Subscript[i, {s, x, \[GothicCapitalF]}]]), _, Message[ReferencePointMean::not, Disequilibrium[{Subscript[i, {s, x, \[GothicCapitalM]}]}]]; Disequilibrium[{Subscript[i, {s, x, \[GothicCapitalM]}]}]], 2/3*(m[Subscript[i, {s, x, \[GothicCapitalM]}]] - m[Subscript[i, {s, x, \[GothicCapitalF]}]])], Z, If[ContextComponentQ[s, SexOfOrigin], Switch[Last[{x}], \[GothicCapitalF], 0, \[GothicCapitalM], 1/2*(m[Subscript[i, {s, x, \[GothicCapitalM]}]] - m[Subscript[i, {s, x, \[GothicCapitalF]}]]), _, Message[ReferencePointMean::not, Disequilibrium[{Subscript[i, {s, x, \[GothicCapitalM]}]}]]; Disequilibrium[{Subscript[i, {s, x, \[GothicCapitalM]}]}]], 1/3*(m[Subscript[i, {s, x, \[GothicCapitalM]}]] - m[Subscript[i, {s, x, \[GothicCapitalF]}]])], Y, 0, W, Message[ReferencePointMean::WlinkageClash, Disequilibrium[{Subscript[i, {s, x, \[GothicCapitalM]}]}]]; Disequilibrium[{Subscript[i, {s, x, \[GothicCapitalM]}]}], C, Message[ReferencePointMean::CytoplasmicClash, Disequilibrium[{Subscript[i, {s, x, \[GothicCapitalM]}]}]]; Disequilibrium[{Subscript[i, {s, x, \[GothicCapitalM]}]}], P, 0], Disequilibrium[{Subscript[i_, {s, x___, \[GothicCapitalF]}]}] :> Switch[f[i], A, 1/2*(m[Subscript[i, {s, x, \[GothicCapitalF]}]] - m[Subscript[i, {s, x, \[GothicCapitalM]}]]), X, If[ContextComponentQ[s, SexOfOrigin], Switch[Last[{x}], \[GothicCapitalM], 0, \[GothicCapitalF], 1/2*(m[Subscript[i, {s, x, \[GothicCapitalF]}]] - m[Subscript[i, {s, x, \[GothicCapitalM]}]]), _, Message[ReferencePointMean::not, Disequilibrium[{Subscript[i, {s, x, \[GothicCapitalF]}]}]]; Disequilibrium[{Subscript[i, {s, x, \[GothicCapitalF]}]}]], 1/3*(m[Subscript[i, {s, x, \[GothicCapitalF]}]] - m[Subscript[i, {s, x, \[GothicCapitalM]}]])], Z, If[ContextComponentQ[s, SexOfOrigin], Switch[Last[{x}], \[GothicCapitalF], Message[ReferencePointMean::ZlinkageClash, Disequilibrium[{Subscript[i, {s, x, \[GothicCapitalF]}]}]]; Disequilibrium[{Subscript[i, {s, x, \[GothicCapitalF]}]}], \[GothicCapitalM], 1/2*(m[Subscript[i, {s, x, \[GothicCapitalF]}]] - m[Subscript[i, {s, x, \[GothicCapitalM]}]]), _, Message[ReferencePointMean::not, Disequilibrium[{Subscript[i, {s, x, \[GothicCapitalF]}]}]]; Disequilibrium[{Subscript[i, {s, x, \[GothicCapitalF]}]}]], 2/3*(m[Subscript[i, {s, x, \[GothicCapitalF]}]] - m[Subscript[i, {s, x, \[GothicCapitalM]}]])], Y, Message[ReferencePointMean::YlinkageClash, Disequilibrium[{Subscript[i, {s, x, \[GothicCapitalF]}]}]]; Disequilibrium[{Subscript[i, {s, x, \[GothicCapitalF]}]}], W, 0, C, 0, P, Message[ReferencePointMean::PaternalClash, Disequilibrium[{Subscript[i, {s, x, \[GothicCapitalF]}]}]]; Disequilibrium[{Subscript[i, {s, x, \[GothicCapitalF]}]}]]}, Message[ReferencePointMean::lociOverlap, cs, ps, xs, ys, zs, ws]; {}]]]];

ReferencePointMean[sl:{_?ContextStageQ...}, opts___Rule] := ReferencePointMean[sl, MeanContribution, opts];
ReferencePointMean[sl:{_?ContextStageQ...}, m_, opts___Rule] := Flatten[(ReferencePointMean[#1, m, opts] & ) /@ sl];

MaternalLoci = CytoplasmicLoci;

Options[NonMendelian] = {CytoplasmicLoci -> {}, PaternalLoci -> {}, XLinkedLoci -> {}, YLinkedLoci -> {}, ZLinkedLoci -> {}, WLinkedLoci -> {}};

NonMendelian::lociOverlap = "Overlapping sets of genes specified: C: `1`,P: `2`, X: `3`, Y: `4`, Z: `5`, W: `6`";

NonMendelian::ZWXYmix = "Cannot specify both XY linkage and ZW linkage: `1`, `2`";

NonMendelian::YlinkageClash = "A Y-linked gene cannot be in a female gamete or derive from the mother: `1`";

NonMendelian::WlinkageClash = "A W-linked gene cannot be in a male gamete or derive from the father: `1`";

NonMendelian::CytoplasmicClash = "A cytoplasmically inherited gene cannot be in a male gamete or derive from the father: `1`";

NonMendelian::PaternalClash = "A paternally inherited gene cannot be in a female gamete or derive from the mother: `1`";

NonMendelian::noSex = "Sex must be specified with X- or Z-linkage: `1`";

NonMendelian[XLinkedLoci, _List, 0] = 0;
NonMendelian[XLinkedLoci, {}, {c___, A_List, B_List}] = {c, A, B};
NonMendelian[XLinkedLoci, xs_List, {c___, A_List, B_List}] := If[{c} == {}, Message[NonMendelian::noSex, Subscript[\[GothicR], c, A, B]]; {c, A, B}, Switch[Last[{c}], \[GothicCapitalM], If[Intersection[B, xs] == {}, {c, Complement[A, xs], B}, 0], \[GothicCapitalF], {c, A, B}, _, Message[NonMendelian::noSex, Subscript[\[GothicR], c, A, B]]; {c, A, B}]];

NonMendelian[ZLinkedLoci, _List, 0] = 0;
NonMendelian[ZLinkedLoci, {}, {c___, A_List, B_List}] = {c, A, B};
NonMendelian[ZLinkedLoci, zs_List, {c___, A_List, B_List}] := If[{c} == {}, Message[NonMendelian::noSex, Subscript[\[GothicR], c, A, B]]; {c, A, B}, Switch[Last[{c}], \[GothicCapitalF], If[Intersection[A, zs] == {}, {c, A, Complement[B, zs]}, 0], \[GothicCapitalM], {c, A, B}, _, Message[NonMendelian::noSex, Subscript[\[GothicR], c, A, B]]; {c, A, B}]];

NonMendelian[CytoplasmicLoci, _List, 0] = 0;
NonMendelian[CytoplasmicLoci, {}, {c___, A_List, B_List}] = {c, A, B};
NonMendelian[CytoplasmicLoci, cs_List, {c___, A_List, B_List}] := (If[{c} != {}, If[Last[{c}] === \[GothicCapitalM], If[Intersection[Join[A, B], cs] != {}, Message[NonMendelian::CytoplasmicClash, 0]]]]; If[Intersection[B, cs] == {}, If[Intersection[A, cs] == {}, {c, A, B}, {c, Complement[A, cs], B}], 0]);

NonMendelian[PaternalLoci, _List, 0] = 0;
NonMendelian[PaternalLoci, {}, {c___, A_List, B_List}] = {c, A, B};
NonMendelian[PaternalLoci, cs_List, {c___, A_List, B_List}] := (If[{c} != {}, If[Last[{c}] === \[GothicCapitalF], If[Intersection[Join[A, B], cs] != {}, Message[NonMendelian::PaternalClash, 0]]]]; If[Intersection[A, cs] == {}, If[Intersection[B, cs] == {}, {c, A, B}, {c, A, Complement[B, cs]}], 0]);

NonMendelian[YLinkedLoci, _List, 0] = 0;
NonMendelian[YLinkedLoci, {}, {c___, A_List, B_List}] = {c, A, B};
NonMendelian[YLinkedLoci, ys_List, {c___, A_List, B_List}] := (If[{c} != {}, If[Last[{c}] === \[GothicCapitalF], If[Intersection[Join[A, B], ys] != {}, Message[NonMendelian::YlinkageClash, Subscript[\[GothicR], c, A, B]]]]]; If[Intersection[A, ys] == {}, If[Intersection[B, ys] == {}, {c, A, B}, {c, A, Complement[B, ys]}], 0]);

NonMendelian[WLinkedLoci, _List, 0] = 0;
NonMendelian[WLinkedLoci, {}, {c___, A_List, B_List}] = {c, A, B};
NonMendelian[WLinkedLoci, ws_List, {c___, A_List, B_List}] := (If[{c} != {}, If[Last[{c}] === \[GothicCapitalM], If[Intersection[Join[A, B], ws] != {}, Message[NonMendelian::WlinkageClash, Subscript[\[GothicR], c, A, B]]]]]; If[Intersection[B, ws] == {}, If[Intersection[A, ws] == {}, {c, A, B}, {c, Complement[A, ws], B}], 0]);

NonMendelian[opts___Rule] := NonMendelian[RecombinationRate, opts];
NonMendelian[r_, opts___Rule] := Module[{xs = XLinkedLoci /. {opts} /. Options[NonMendelian], ys = YLinkedLoci /. {opts} /. Options[NonMendelian], zs = ZLinkedLoci /. {opts} /. Options[NonMendelian], ws = WLinkedLoci /. {opts} /. Options[NonMendelian], ps = PaternalLoci /. {opts} /. Options[NonMendelian], cs = CytoplasmicLoci /. {opts} /. Options[NonMendelian]}, tt = Join[xs, ys, cs, ps, zs, ws]; If[Length[Join[xs, ys]]*Length[Join[zs, ws]] != 0, Message[NonMendelian::ZWXYmix, Join[xs, ys], Join[zs, ws]]; {}, If[ !Length[tt] == Length[Union[tt]], Message[NonMendelian::lociOverlap, cs, ps, xs, ys, zs, ws]; {}, If[tt == {}, {}, {r[c___, A_List, B_List]?(Intersection[tt, Join[#1[[-2]], #1[[-1]]]] != {} && If[Length[#1] == 2, True,  !(Intersection[Complement[Join[#1[[-2]], #1[[-1]]], xs], tt] == {} && #1[[-3]] === \[GothicCapitalF])] && If[Length[#1] == 2, True,  !(Intersection[Complement[Join[#1[[-2]], #1[[-1]]], zs], tt] == {} && #1[[-3]] === \[GothicCapitalM])] & ) :> r @@ NonMendelian[XLinkedLoci, xs, NonMendelian[ZLinkedLoci, zs, NonMendelian[YLinkedLoci, ys, NonMendelian[WLinkedLoci, ws, NonMendelian[PaternalLoci, ps, NonMendelian[CytoplasmicLoci, cs, {c, A, B}]]]]]]}]]]];

ReferencePointSame[(s1_)?ContextStageQ, (s2_)?ContextStageQ] := If[ContextComponentQ[s2, SexOfOrigin], {ReferencePoint[Subscript[i_, {s2, x___, sex_, soo_}]] :> ReferencePoint[Subscript[i, {s1, x, soo}]]}, {ReferencePoint[Subscript[i_, {s2, x___, sex_}]] :> ReferencePoint[Subscript[i, {s1, x, sex}]]}];
ReferencePointSame[(s1_)?ContextStageQ, sl:{_?ContextStageQ...}] := Flatten[(ReferencePointSame[s1, #1] & ) /@ sl];

RandomUnion[(s_)?ContextStageQ] := RandomUnion[s, {Sex}];
RandomUnion[(s_)?ContextStageQ, cl_List] := Module[{cc}, {Disequilibrium[\[DoubleStruckCapitalU]:{Subscript[_, {s, __}]...}]?(Length[Union[ExtractContexts[#1[[1]], cl]]] > 1 & ) :> (cc = ExtractContexts[\[DoubleStruckCapitalU], cl]; Times @@ (Disequilibrium[#1] & ) /@ (Extract[\[DoubleStruckCapitalU], Position[cc, #1]] & ) /@ Union[cc])}];

Selfing::badSelfingRate = "Selfing rate `1` is invalid.";

Selfing[] := Selfing[{{\[GothicCapitalJ], \[GothicCapitalH]}, \[GothicCapitalA]}, 1];
Selfing[{{(s1o_)?ContextStageQ, (s1s_)?ContextStageQ}, (s2_)?ContextStageQ}] := Selfing[{{s1o, s1s}, s2}, 1];
Selfing[(s_)?( !ListQ[#1] & )] := Selfing[{{\[GothicCapitalJ], \[GothicCapitalH]}, \[GothicCapitalA]}, s];
Selfing[{{(s1o_)?ContextStageQ, (s1s_)?ContextStageQ}, (s2_)?ContextStageQ}, s_] := Module[{cc}, If[s == 0 === True, {}, If[(s < 0 || s > 1) === True, Message[Selfing::badSelfingRate, s]; {}, {Disequilibrium[\[DoubleStruckCapitalU]:{Subscript[_, {s2, __}]...}] :> (1 - s)*ChangeContext[Disequilibrium[\[DoubleStruckCapitalU]], TransmissionRule[{s2, x___}, {s1o, x}]] + s*ChangeContext[Disequilibrium[\[DoubleStruckCapitalU]], TransmissionRule[{s2, x___, sex_, soo_}, {s1s, x, soo}]], MeanContribution[\[DoubleStruckI]:Subscript[_, {s2, __}]] :> (1 - s)*ChangeContext[MeanContribution[\[DoubleStruckI]], TransmissionRule[{s2, x___}, {s1o, x}]] + s*ChangeContext[MeanContribution[\[DoubleStruckI]], TransmissionRule[{s2, x___, sex_, soo_}, {s1s, x, soo}]]}]]];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SubscriptBox["\[DoubleStruckCapitalW]", "x___"]], NotationBoxTag[RowBox[List["FitnessSet", "[", "x___", "]"]]]]];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SubscriptBox["\[DoubleStruckCapitalR]", "x___"]], NotationBoxTag[RowBox[List["RecombinationSet", "[", "x___", "]"]]]]];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SubscriptBox["\[DoubleStruckCapitalM]", "x___"]], NotationBoxTag[RowBox[List["MigrationSet", "[", "x___", "]"]]]]];

Selection[] := Selection[{\[GothicCapitalZ], \[GothicCapitalA]}, SelectionCoefficient, \[DoubleStruckCapitalW]];

Selection[{(s1_)?ContextStageQ, (s2_)?ContextStageQ}, a_, w_] := {Disequilibrium[\[DoubleStruckCapitalU]:{Subscript[_, {s2, ___}]...}] :> Module[{\[DoubleStruckCapitalZ] = ChangeContext[\[DoubleStruckCapitalU], {TransmissionRule[{s2, x__}, {s1, x}]}], \[DoubleStruckCapitalV]}, Disequilibrium[\[DoubleStruckCapitalZ]] + AddUp[a[\[DoubleStruckCapitalV]]*(Disequilibrium[Join[\[DoubleStruckCapitalZ], \[DoubleStruckCapitalV]]] - Disequilibrium[\[DoubleStruckCapitalZ]]*Disequilibrium[\[DoubleStruckCapitalV]]), \[DoubleStruckCapitalV], w, Subsets -> True]], MeanContribution[Subscript[i_, {s2, x___}]] :> Module[{\[DoubleStruckCapitalV], ss}, ss = Union[Sort /@ Subsets[w]]; ReferencePoint[Subscript[i, {s1, x}]] + Disequilibrium[{Subscript[i, {s1, x}]}] + AddUp[a[\[DoubleStruckCapitalV]]*(Disequilibrium[Join[{Subscript[i, {s1, x}]}, \[DoubleStruckCapitalV]]] - Disequilibrium[{Subscript[i, {s1, x}]}]*Disequilibrium[\[DoubleStruckCapitalV]]), \[DoubleStruckCapitalV], ss]]};

Selection[cl_List] := Selection[{\[GothicCapitalZ], \[GothicCapitalA]}, SelectionCoefficient, FitnessSet, cl];

Selection[{(s1_)?ContextStageQ, (s2_)?ContextStageQ}, a_, w_, cl_List] := {Disequilibrium[\[DoubleStruckCapitalU]:{Subscript[_, {s2, ___}]...}] :> Module[{\[DoubleStruckCapitalZ] = ChangeContext[\[DoubleStruckCapitalU], {TransmissionRule[{s2, x__}, {s1, x}]}], \[DoubleStruckCapitalV], cc = Union[ExtractContexts[\[DoubleStruckCapitalU], cl]]}, If[Length[cc] > 1, Message[Selection::mix, \[DoubleStruckCapitalU], cl, {s1, s2}, a, w]; Disequilibrium[\[DoubleStruckCapitalU]], Disequilibrium[\[DoubleStruckCapitalZ]] + AddUp[a @@ Join[cc[[1]], {\[DoubleStruckCapitalV]}]*(Disequilibrium[Join[\[DoubleStruckCapitalZ], \[DoubleStruckCapitalV]]] - Disequilibrium[\[DoubleStruckCapitalZ]]*Disequilibrium[\[DoubleStruckCapitalV]]), \[DoubleStruckCapitalV], w @@ cc[[1]], Subsets -> True]]], MeanContribution[Subscript[i_, {s2, x___}]] :> Module[{\[DoubleStruckCapitalV], cc = Union[ExtractContexts[{Subscript[i, {s2, x}]}, cl]]}, If[Length[cc] > 1, Message[Selection::mix, {Subscript[i, {s2, x}]}, cl, {s1, s2}, a, w]; MeanContribution[Subscript[i, {s2, x}]], ss = Union[Sort /@ Subsets[w @@ cc[[1]]]]; ReferencePoint[Subscript[i, {s1, x}]] + Disequilibrium[{Subscript[i, {s1, x}]}] + AddUp[a @@ Join[cc[[1]], {\[DoubleStruckCapitalV]}]*(Disequilibrium[Join[{Subscript[i, {s1, x}]}, \[DoubleStruckCapitalV]]] - Disequilibrium[{Subscript[i, {s1, x}]}]*Disequilibrium[\[DoubleStruckCapitalV]]), \[DoubleStruckCapitalV], ss]]]};

Selection::mix = "Mixed contexts in \!\(\[GothicCapitalD]\_`1`\)/.Selection[`3`,`4`,`5`,`2`]: the relevant components `2` must be the same for all genes.";

Recombination[] := Recombination[{\[GothicCapitalA], \[GothicCapitalG]new}, RecombinationRate];
Recombination[cl_List] := Recombination[{\[GothicCapitalA], \[GothicCapitalG]new}, RecombinationRate, cl];

Recombination[{(s1_)?ContextStageQ, (s2_)?ContextStageQ}, r_] := {Disequilibrium[\[DoubleStruckCapitalU]:{Subscript[_, {s2, __}]...}] :> Module[{A\[GothicCapitalM], A\[GothicCapitalF], \[DoubleStruckCapitalU]\[GothicCapitalM] = SelectContext[\[DoubleStruckCapitalU], {\[GothicCapitalM]}, Sex], \[DoubleStruckCapitalU]\[GothicCapitalF] = SelectContext[\[DoubleStruckCapitalU], {\[GothicCapitalF]}, Sex]}, AddUp[AddUp[ChangeContext[Disequilibrium[\[DoubleStruckCapitalU]], Meiosis[{s1, s2}, Join[A\[GothicCapitalM], A\[GothicCapitalF]], Join[TakeAway[ExtractGenes[\[DoubleStruckCapitalU]\[GothicCapitalM]], A\[GothicCapitalM]], TakeAway[ExtractGenes[\[DoubleStruckCapitalU]\[GothicCapitalF]], A\[GothicCapitalF]]]]]*r[A\[GothicCapitalM], TakeAway[ExtractGenes[\[DoubleStruckCapitalU]\[GothicCapitalM]], A\[GothicCapitalM]]]*r[A\[GothicCapitalF], TakeAway[ExtractGenes[\[DoubleStruckCapitalU]\[GothicCapitalF]], A\[GothicCapitalF]]], A\[GothicCapitalF], ExtractGenes[\[DoubleStruckCapitalU]\[GothicCapitalF]], Subsets -> True], A\[GothicCapitalM], ExtractGenes[\[DoubleStruckCapitalU]\[GothicCapitalM]], Subsets -> True]], MeanContribution[Subscript[i_, {s2, x__}]] :> ChangeContext[MeanContribution[Subscript[i, {s2, x}]], Meiosis[{s1, s2}, {i}, {}]]*r[{i}, {}] + ChangeContext[MeanContribution[Subscript[i, {s2, x}]], Meiosis[{s1, s2}, {}, {i}]]*r[{}, {i}]};

Recombination[{(s1_)?ContextStageQ, (s2_)?ContextStageQ}, r_, cl_List] := {Disequilibrium[\[DoubleStruckCapitalU]:{Subscript[_, {s2, __}]...}] :> Module[{A\[GothicCapitalM], A\[GothicCapitalF], \[DoubleStruckCapitalU]\[GothicCapitalM] = SelectContext[\[DoubleStruckCapitalU], {\[GothicCapitalM]}, Sex], \[DoubleStruckCapitalU]\[GothicCapitalF] = SelectContext[\[DoubleStruckCapitalU], {\[GothicCapitalF]}, Sex], cc\[GothicCapitalM], cc\[GothicCapitalF]}, cc\[GothicCapitalM] = Union[ExtractContexts[\[DoubleStruckCapitalU]\[GothicCapitalM], cl]]; cc\[GothicCapitalF] = Union[ExtractContexts[\[DoubleStruckCapitalU]\[GothicCapitalF], cl]]; If[Length[cc\[GothicCapitalM]] > 1 || Length[cc\[GothicCapitalF]] > 1, Message[Recombination::mix, {s1, s2}, r, cl, \[DoubleStruckCapitalU]]; Disequilibrium[\[DoubleStruckCapitalU]], cc\[GothicCapitalM] = If[cc\[GothicCapitalM] === {}, {}, First[cc\[GothicCapitalM]]]; cc\[GothicCapitalF] = If[cc\[GothicCapitalF] === {}, {}, First[cc\[GothicCapitalF]]]; AddUp[AddUp[ChangeContext[Disequilibrium[\[DoubleStruckCapitalU]], Meiosis[{s1, s2}, Join[A\[GothicCapitalM], A\[GothicCapitalF]], Join[TakeAway[ExtractGenes[\[DoubleStruckCapitalU]\[GothicCapitalM]], A\[GothicCapitalM]], TakeAway[ExtractGenes[\[DoubleStruckCapitalU]\[GothicCapitalF]], A\[GothicCapitalF]]]]]*(r[##1, A\[GothicCapitalM], TakeAway[ExtractGenes[\[DoubleStruckCapitalU]\[GothicCapitalM]], A\[GothicCapitalM]]] & ) @@ cc\[GothicCapitalM]*(r[##1, A\[GothicCapitalF], TakeAway[ExtractGenes[\[DoubleStruckCapitalU]\[GothicCapitalF]], A\[GothicCapitalF]]] & ) @@ cc\[GothicCapitalF], A\[GothicCapitalF], ExtractGenes[\[DoubleStruckCapitalU]\[GothicCapitalF]], Subsets -> True], A\[GothicCapitalM], ExtractGenes[\[DoubleStruckCapitalU]\[GothicCapitalM]], Subsets -> True]]], MeanContribution[Subscript[i_, {s2, x__}]] :> Module[{cc = Union[ExtractContexts[{Subscript[i, {s2, x}]}, cl]]}, If[Length[cc] > 1, Message[Recombination::mix, {s1, s2}, r, cl, \[DoubleStruckCapitalU]]; MeanContribution[Subscript[i, {s2, x}]], ChangeContext[MeanContribution[Subscript[i, {s2, x}]], Meiosis[{s1, s2}, {i}, {}]]*(r[##1, {i}, {}] & ) @@ cc[[1]] + ChangeContext[MeanContribution[Subscript[i, {s2, x}]], Meiosis[{s1, s2}, {}, {i}]]*(r[##1, {}, {i}] & ) @@ cc[[1]]]]};

Recombination::mix = "Mixed contexts in \!\(\[GothicCapitalD]\_`4`\)/.Recombination[`1`,`2`,`3`]: the relevant components `3` must be the same for all genes.";

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SubscriptBox["\[GothicA]", "x__"]], NotationBoxTag[RowBox[List["SelectionCoefficient", "[", "x__", "]"]]]]];

UnlinkedRecombination[A_List, B_List] := 2^(-Length[A] - Length[B]);

LinkedRecombination::badLoci = "Order of the loci in \!\(\[GothicR]\_\(`1`, \\ \(\(\\\\\)\(\\ \)\(`2`\)\)\)\) is not specified by `3`";

LinkedRecombination[A_List, B_List, ord_List, c_] := Module[{oab}, If[Complement[Join[A, B], ord] === {}, oab = TakeAway[ord, Complement[ord, Join[A, B]]]; Times @@ Replace[Drop[Transpose[{oab, RotateLeft[oab]}], -1], {{i_, j_} :> If[Xor[MemberQ[A, i], MemberQ[A, j]], c[i, j], 1 - c[i, j]]}, {1}]/2, Message[LinkedRecombination::badLoci, A, B, ord]; Indeterminate]];

RecombinationRate[___, {}, {}] = 1;

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SubscriptBox["\[GothicR]", "x__"]], NotationBoxTag[RowBox[List["RecombinationRate", "[", "x__", "]"]]]]];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SubscriptBox["\[CapitalMu]", "x__"]], NotationBoxTag[RowBox[List["MigrationRate", "[", "x__", "]"]]]]];

Migration::mix = "Mixed contexts in \!\(\[GothicCapitalD]\_`4`\)/.Migration[`1`,`2`,`3`]: the relevant components `3` must be the same for all genes.";

Migration[\[CapitalOmega]_] := Migration[{\[GothicCapitalZ], \[GothicCapitalJ]}, MigrationRate, \[CapitalOmega]];
Migration[cl_List, \[CapitalOmega]_] := Migration[{\[GothicCapitalZ], \[GothicCapitalJ]}, MigrationRate, cl, \[CapitalOmega]];

Migration[{(s1_)?ContextStageQ, (s2_)?ContextStageQ}, m_, \[CapitalOmega]_] := Module[{\[Beta]}, If[ContextComponentQ[s2, SexOfOrigin] && ContextComponentQ[s2, Sex], {Disequilibrium[\[DoubleStruckCapitalU]:{Subscript[_, {s2, ___, \[Alpha]_, \[GothicCapitalM] | \[GothicCapitalF], \[GothicCapitalM] | \[GothicCapitalF]}]...}] :> AddUp[ChangeContext[Disequilibrium[\[DoubleStruckCapitalU]], Migrate[{s1, s2}, \[Alpha], \[Beta]]]*m[\[Alpha], \[Beta]], \[Beta], \[CapitalOmega][\[Alpha]]], MeanContribution[\[DoubleStruckI]:Subscript[_, {s2, ___, \[Alpha]_, \[GothicCapitalM] | \[GothicCapitalF], \[GothicCapitalM] | \[GothicCapitalF]}]] :> AddUp[ChangeContext[MeanContribution[\[DoubleStruckI]], Migrate[{s1, s2}, \[Alpha], \[Beta]]]*m[\[Alpha], \[Beta]], \[Beta], \[CapitalOmega][\[Alpha]]]}, {Disequilibrium[\[DoubleStruckCapitalU]:{Subscript[_, {s2, ___, \[Alpha]_, \[GothicCapitalM] | \[GothicCapitalF]}]...}] :> AddUp[ChangeContext[Disequilibrium[\[DoubleStruckCapitalU]], Migrate[{s1, s2}, \[Alpha], \[Beta]]]*m[\[Alpha], \[Beta]], \[Beta], \[CapitalOmega][\[Alpha]]], MeanContribution[\[DoubleStruckI]:Subscript[_, {s2, ___, \[Alpha]_, \[GothicCapitalM] | \[GothicCapitalF]}]] :> AddUp[ChangeContext[MeanContribution[\[DoubleStruckI]], Migrate[{s1, s2}, \[Alpha], \[Beta]]]*m[\[Alpha], \[Beta]], \[Beta], \[CapitalOmega][\[Alpha]]]}]];

Migration[{(s1_)?ContextStageQ, (s2_)?ContextStageQ}, m_, cl_List, \[CapitalOmega]_] := Module[{\[Beta], cc}, If[ContextComponentQ[s2, SexOfOrigin] && ContextComponentQ[s2, Sex], {Disequilibrium[\[DoubleStruckCapitalU]:{Subscript[_, {s2, ___, \[Alpha]_, \[GothicCapitalM] | \[GothicCapitalF], \[GothicCapitalM] | \[GothicCapitalF]}]...}] :> (cc = Union[ExtractContexts[\[DoubleStruckCapitalU], cl]]; If[Length[cc] > 1, Message[Migration::mix, {s1, s2}, m, cl, \[DoubleStruckCapitalU]]; Disequilibrium[\[DoubleStruckCapitalU]], cc = If[cc === {}, {}, First[cc]]; AddUp[ChangeContext[Disequilibrium[\[DoubleStruckCapitalU]], Migrate[{s1, s2}, \[Alpha], \[Beta]]]*(m[##1, \[Alpha], \[Beta]] & ) @@ cc, \[Beta], \[CapitalOmega][\[Alpha]]]]), MeanContribution[\[DoubleStruckI]:Subscript[_, {s2, ___, \[Alpha]_, \[GothicCapitalM] | \[GothicCapitalF], \[GothicCapitalM] | \[GothicCapitalF]}]] :> (cc = Union[ExtractContexts[\[DoubleStruckCapitalU], cl]]; If[Length[cc] > 1, Message[Migration::mix, {s1, s2}, m, cl, \[DoubleStruckCapitalU]]; Disequilibrium[\[DoubleStruckCapitalU]], cc = If[cc === {}, {}, First[cc]]; AddUp[ChangeContext[MeanContribution[\[DoubleStruckI]], Migrate[{s1, s2}, \[Alpha], \[Beta]]]*(m[##1, \[Alpha], \[Beta]] & ) @@ cc, \[Beta], \[CapitalOmega][\[Alpha]]]])}, {Disequilibrium[\[DoubleStruckCapitalU]:{Subscript[_, {s2, ___, \[Alpha]_, \[GothicCapitalM] | \[GothicCapitalF]}]...}] :> (cc = Union[ExtractContexts[\[DoubleStruckCapitalU], cl]]; If[Length[cc] > 1, Message[Migration::mix, {s1, s2}, m, cl, \[DoubleStruckCapitalU]]; Disequilibrium[\[DoubleStruckCapitalU]], cc = If[cc === {}, {}, First[cc]]; AddUp[ChangeContext[Disequilibrium[\[DoubleStruckCapitalU]], Migrate[{s1, s2}, \[Alpha], \[Beta]]]*(m[##1, \[Alpha], \[Beta]] & ) @@ cc, \[Beta], \[CapitalOmega][\[Alpha]]]]), MeanContribution[\[DoubleStruckI]:Subscript[_, {s2, ___, \[Alpha]_, \[GothicCapitalM] | \[GothicCapitalF]}]] :> (cc = Union[ExtractContexts[\[DoubleStruckCapitalU], cl]]; If[Length[cc] > 1, Message[Migration::mix, {s1, s2}, m, cl, \[DoubleStruckCapitalU]]; Disequilibrium[\[DoubleStruckCapitalU]], cc = If[cc === {}, {}, First[cc]]; AddUp[ChangeContext[MeanContribution[\[DoubleStruckI]], Migrate[{s1, s2}, \[Alpha], \[Beta]]]*(m[##1, \[Alpha], \[Beta]] & ) @@ cc, \[Beta], \[CapitalOmega][\[Alpha]]]])}]];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SubscriptBox["\[GothicP]", "x__"]], NotationBoxTag[RowBox[List["AlleleFrequencyP", "[", "x__", "]"]]]]];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SubscriptBox["\[GothicQ]", "x__"]], NotationBoxTag[RowBox[List["AlleleFrequencyQ", "[", "x__", "]"]]]]];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SubscriptBox["\[GothicP]\[GothicQ]", "x__"]], NotationBoxTag[RowBox[List["AlleleFrequencyPQ", "[", "x__", "]"]]]]];

SymmetricRecombination[] := SymmetricRecombination[RecombinationRate];
SymmetricRecombination[r_] := {r[x___, {}, {}] :> 1, r[x___, {_}, {}] :> 1/2, r[x___, {}, {_}] :> 1/2, r[x___, A_List, B_List]?( !(OrderedQ[#1[[-2]]] && OrderedQ[#1[[-1]]] && OrderedQ[{#1[[-2]], #1[[-1]]}]) & ) :> r[x, Sequence @@ Sort[Sort /@ {A, B}]]};

SymmetricSexes[] = SymmetricSexes[\[GothicCapitalF]];
SymmetricSexes[s_] := Module[{os = OtherSex[s]}, {MeanContribution[Subscript[i_, {(st_)?(ContextComponentQ[#1, Sex] && ContextComponentQ[#1, SexOfOrigin] & ), x___, sex_, os}]] :> MeanContribution[Subscript[i, {st, x, OtherSex[sex], s}]], MeanContribution[Subscript[i_, {(st_)?(Xor[ContextComponentQ[#1, Sex], ContextComponentQ[#1, SexOfOrigin]] & ), x___, os}]] :> MeanContribution[Subscript[i, {st, x, s}]], Disequilibrium[\[DoubleStruckCapitalU]:{Subscript[_, {(st_)?(ContextComponentQ[#1, Sex] || ContextComponentQ[#1, SexOfOrigin] & ), ___}]..}] :> Module[{nu = \[DoubleStruckCapitalU], ds, sl, cl}, cl = Join[If[ContextComponentQ[\[DoubleStruckCapitalU][[1,2,1]], Sex], {Sex}, {}], If[ContextComponentQ[\[DoubleStruckCapitalU][[1,2,1]], SexOfOrigin], {SexOfOrigin}, {}]]; sl = Flatten[ExtractContexts[\[DoubleStruckCapitalU], cl]]; If[Count[sl, os] > Count[sl, s], nu = \[DoubleStruckCapitalU] /. os -> ds /. s -> os /. ds -> s]; Disequilibrium[nu]]}];

OtherSex[\[GothicCapitalM]] = \[GothicCapitalF];
OtherSex[\[GothicCapitalF]] = \[GothicCapitalM];

Options[Biallelic] = {BiallelicPQ -> False};

Biallelic[] := Biallelic[AlleleFrequencyP];
Biallelic[BiallelicPQ -> True] := Biallelic[AlleleFrequencyP, AlleleFrequencyPQ, BiallelicPQ -> True];

Biallelic[p_] := {Disequilibrium[{a___, \[DoubleStruckI]:Subscript[_, _List], b___, \[DoubleStruckI]:Subscript[_, _List], c___}] :> Disequilibrium[{a, b, c}]*(1 - p[\[DoubleStruckI]])*p[\[DoubleStruckI]] + Disequilibrium[Join[{\[DoubleStruckI]}, {a, b, c}]]*(1 - 2*p[\[DoubleStruckI]]), AllelicDeviation[\[DoubleStruckI]_]^n_Integer :> AllelicDeviation[\[DoubleStruckI]]^(n - 2)*(1 - p[\[DoubleStruckI]])*p[\[DoubleStruckI]] + AllelicDeviation[\[DoubleStruckI]]^(n - 1)*(1 - 2*p[\[DoubleStruckI]]), AllelicState[\[DoubleStruckI]_]^n_Integer :> AllelicState[\[DoubleStruckI]]};

Biallelic[p_, pq_, BiallelicPQ -> True] := {Disequilibrium[{a___, \[DoubleStruckI]:Subscript[_, _List], b___, \[DoubleStruckI]:Subscript[_, _List], c___}] :> Disequilibrium[{a, b, c}]*pq[\[DoubleStruckI]] + Disequilibrium[Join[{\[DoubleStruckI]}, {a, b, c}]]*(1 - 2*p[\[DoubleStruckI]]), AllelicDeviation[\[DoubleStruckI]_]^n_Integer :> AllelicDeviation[\[DoubleStruckI]]^(n - 2)*pq[\[DoubleStruckI]] + AllelicDeviation[\[DoubleStruckI]]^(n - 1)*(1 - 2*p[\[DoubleStruckI]]), AllelicState[\[DoubleStruckI]_]^n_Integer :> AllelicState[\[DoubleStruckI]]};

Biallelic[ll_List] := Biallelic[ll, AlleleFrequencyP];
Biallelic[ll_List, BiallelicPQ -> True] := Biallelic[ll, AlleleFrequencyP, AlleleFrequencyPQ, BiallelicPQ -> True];

Biallelic[ll_List, (p_)?( !ListQ[#1] & )] := {Disequilibrium[{a___, Subscript[(i_)?(MemberQ[ll, #1] & ), cc_List], Subscript[(i_)?(MemberQ[ll, #1] & ), cc_List]}] :> Disequilibrium[{a}]*p[Subscript[i, cc]]*(1 - p[Subscript[i, cc]]) + Disequilibrium[Join[{Subscript[i, cc]}, {a}]]*(1 - 2*p[Subscript[i, cc]]), AllelicDeviation[Subscript[(i_)?(MemberQ[ll, #1] & ), cc_List]]^n_Integer :> AllelicDeviation[Subscript[i, cc]]^(n - 2)*(1 - p[Subscript[i, cc]])*p[Subscript[i, cc]] + AllelicDeviation[Subscript[i, cc]]^(n - 1)*(1 - 2*p[Subscript[i, cc]]), AllelicState[Subscript[(i_)?(MemberQ[ll, #1] & ), cc_List]]^n_Integer :> AllelicState[Subscript[i, cc]]};

Biallelic[ll_List, p_, pq_, BiallelicPQ -> True] := {Disequilibrium[{a___, (i_)?Subscript[(i_)?(MemberQ[ll, #1] & ), cc_List], Subscript[(i_)?(MemberQ[ll, #1] & ), cc_List]}] :> Disequilibrium[{a}]*pq[Subscript[i, cc]] + Disequilibrium[Join[{Subscript[i, cc]}, {a}]]*(1 - 2*p[Subscript[i, cc]]), AllelicDeviation[Subscript[(i_)?(MemberQ[ll, #1] & ), cc_List]]^n_Integer :> AllelicDeviation[Subscript[i, cc]]^(n - 2)*pq[Subscript[i, cc]] + AllelicDeviation[Subscript[i, cc]]^(n - 1)*(1 - 2*p[Subscript[i, cc]]), AllelicState[Subscript[(i_)?(MemberQ[ll, #1] & ), cc_List]]^n_Integer :> AllelicState[Subscript[i, cc]]};

ToCumulants[] := ToCumulants[Disequilibrium, CumulantDisequilibrium];
ToCumulants[mom_, cum_] := {mom[\[DoubleStruckCapitalU]_] :> Moment[cum, \[DoubleStruckCapitalU]]};

ToMoments[] := ToMoments[CumulantDisequilibrium, Disequilibrium];
ToMoments[cum_, mom_] := {cum[\[DoubleStruckCapitalU]_] :> Cumulant[mom, \[DoubleStruckCapitalU]]};

CumulantDisequilibrium[{}] = 1;

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SubscriptBox["\[GothicK]", "\[DoubleStruckCapitalU]_"]], NotationBoxTag[RowBox[List["CumulantDisequilibrium", "[", "\[DoubleStruckCapitalU]_", "]"]]]]];

BaakeDisequilibrium[{}] = 1;

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SubscriptBox["\[GothicZ]", "\[DoubleStruckCapitalU]_"]], NotationBoxTag[RowBox[List["BaakeDisequilibrium", "[", "\[DoubleStruckCapitalU]_", "]"]]]]];

ToBaake[] := ToBaake[Disequilibrium, BaakeDisequilibrium];
ToBaake[d_, z_] := {d[\[DoubleStruckCapitalU]_] :> Module[{n}, Sum[Plus @@ (Times @@ #1 & ) /@ Map[z, PartitionSet[\[DoubleStruckCapitalU], n, Ordered -> True], {2}], {n, Length[\[DoubleStruckCapitalU]]}]]};

FromBaake[] := FromBaake[BaakeDisequilibrium, Disequilibrium];
FromBaake[z_, d_] := {z[\[DoubleStruckCapitalU]_] :> Module[{n}, Sum[(-1)^(n - 1)*Plus @@ (Times @@ #1 & ) /@ Map[d, PartitionSet[\[DoubleStruckCapitalU], n, Ordered -> True], {2}], {n, Length[\[DoubleStruckCapitalU]]}]]};

CumulantPopulationDisequilibrium[{}...] := 1;

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SubscriptBox["\[GothicCapitalK]", "x___"]], NotationBoxTag[RowBox[List["CumulantPopulationDisequilibrium", "[", "x___", "]"]]]]];

ToPopulationCumulants[] := ToPopulationCumulants[PopulationDisequilibrium, CumulantPopulationDisequilibrium];
ToPopulationCumulants[mom_, cum_] := {cum[x__] :> Cumulant[mom, AddTag[{x}, 3]] /. {mom[z_] :> mom[RemoveTag[z, 3]]}};

ToPopulationMoments[] := ToPopulationMoments[CumulantPopulationDisequilibrium, PopulationDisequilibrium];
ToPopulationMoments[cum_, mom_] := {mom[x__] :> Moment[cum, Flatten[MapIndexed[#1[#2[[1]]] & , {x}, {2}]]] /. {cum[z_] :> cum[changeback[z, Length[{x}]]]}};

SlowChange[expr_] := SlowChange[expr, \[GothicS], 1];
SlowChange[expr_, \[Epsilon]_, k_Integer] := Normal[Series[expr, {\[Epsilon], 0, k}]];

BennettC[P:{__List}] := Module[{sp = StandardPartition[P], U, rl}, If[sp === P, BennettCstandard[P], U = Flatten[Sort[P]]; BennettCstandard[sp] /. RecombinationRate[A_, B_] :> RecombinationRate @@ Sort[Sort /@ ({A, B} /. j_Integer :> U[[j]])]]];

BennettCstandard[{{_}, {__}}] := -1;
BennettCstandard[{{_}..}] := -1;

BennettCstandard[P_List] := BennettCstandard[P] = Module[{x, U = Flatten[P], A, sU, bE, bp}, sU = Subsets[U, 1, Length[U] - 1]; bp = TimesUp[bb[x], x, P]; 1/(RecombinationRate[{}, Sort[U]] - TimesUp[RecombinationRate[{}, Sort[x]], x, P])*Coefficient[BennettExpansion[U], bp]];

BennettExpansion[U_List] := BennettExpansion[U] = Module[{x, y, A, sU, \[DoubleStruckCapitalP], P1, P2}, \[DoubleStruckCapitalP][V_] := DeleteCases[PartitionSet[V], {V}]; sU = Subsets[U, 1, Length[U] - 1]; AddUp[RecombinationRate @@ Sort[Sort /@ {A, TakeAway[U, A]}]/2*(bb[A] - AddUp[BennettC[P1]*TimesUp[bb[x], x, P1], P1, \[DoubleStruckCapitalP][A]])*(bb[TakeAway[U, A]] - AddUp[BennettC[P2]*TimesUp[bb[y], y, P2], P2, \[DoubleStruckCapitalP][TakeAway[U, A]]]), A, sU] /. RecombinationRate[{}, {_}] :> 1];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[SubscriptBox["\[GothicB]", "U_"]], NotationBoxTag[RowBox[List["BennettB", "[", "U_", "]"]]]]];

BennettB[P:{___List}] := Module[{x}, TimesUp[BennettB[x], x, P]];

FromBennettExpression[n_Integer] := FromBennettExpression[n] = Module[{x, U = Range[n], \[DoubleStruckCapitalP], P}, \[DoubleStruckCapitalP] = DeleteCases[PartitionSet[U], {U}]; Disequilibrium[U] + AddUp[BennettC[P]*TimesUp[FromBennettExpression[x], x, P], P, \[DoubleStruckCapitalP]]];

FromBennettExpression[U_List] := FromBennettExpression[Length[U]] /. a:{__Integer} :> (a /. i_Integer :> U[[i]]);

ToBennettExpression[n_Integer] := ToBennettExpression[n] = Module[{U = Range[n], \[DoubleStruckCapitalP], P}, \[DoubleStruckCapitalP] = DeleteCases[PartitionSet[U], {U}]; BennettB[U] - AddUp[BennettC[P]*BennettB[P], P, \[DoubleStruckCapitalP]]];

ToBennettExpression[U_List] := ToBennettExpression[Length[U]] /. a:{__Integer} :> (a /. i_Integer :> U[[i]]);

ToBennett[] := {Disequilibrium[U_List] :> ToBennettExpression[U]};
ToBennett[d_, b_, r_] := {d[U_List] :> (ToBennettExpression[U] /. {BennettB[V_List] :> b[V], RecombinationRate[A_List, B_List] :> r[A, B]})};

FromBennett[] := {BennettB[U_List] :> FromBennettExpression[U]};
FromBennett[b_, d_, r_] := {b[U_List] :> (FromBennettExpression[U] /. {Disequilibrium[V_List] :> d[V], RecombinationRate[A_List, B_List] :> r[A, B]})};

End[];
EndPackage[];

