(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)

BeginPackage["Utilities`Cumulants`",{"Statistics`DescriptiveStatistics`",
	     "Statistics`Common`DistributionsCommon`",
      "Statistics`DiscreteDistributions`",
      "Statistics`ContinuousDistributions`","Utilities`RandomNumbers`"}];



Cumulant::usage=
    "Cumulant[m,i] returns an algebraic expression for the i'th cumulant, in \
terms of m[1], m[2], etc. Cumulant[m,{i,j,k}] and Cumulant[m,{{i,j},{k,l}}] \
are also defined. Cumulant[distribution,i,Distribution->True] returns an \
algebraic expression for the i'th cumulant of a distribution.";

Moment::usage=
    "Moment[k,i] returns an algebraic expression for the i'th non-central \
moment, in terms of the cumulants, k[1], k[2], etc. Moment[k,{i,j,k}] is also \
defined.  Moment[k,{i,j,k},Centred->True] gives the central moment. \
Moment[distribution,i,Distribution->True] returns an algebraic expression for \
the i'th moment of a distribution.";

GeneralizedTransform::usage=
    "GeneralizedTransform[m,i,g,z0] gives the quantities defined by applying \
the function g[] to the generating function, at z0.  For example, cumulants \
are given by GeneralizedTransform[m,i,Log,1]";

Centred::usage=
    "Centred is an option for Moment[],  Cumulant[] and \
GeneralizedTransform[] that gives central moments/cumulants";

Distribution::usage=
    "Distribution is an option for Moment[] and Cumulant[] which specifies \
that a distribution is given as the first parameter.";



Begin["Utilities`Cumulants`Private`"];



Options[Cumulant]={Centred\[Rule]False,Distribution\[Rule]False};

Cumulant[m_,U_List,opts___]:=If[Distribution/.{opts}/.Options[Cumulant],
		Print["ERROR: the option Distribution\[Rule]True is not allowed for the \
cumulant of a set, ",U],
		GeneralizedTransform[m,U,Log,1,opts]];

\!\(\(Cumulant[m_, i_Integer, opts___] := 
      Module[{t}, \n\t\tIf[\(Distribution /. {opts}\) /. 
            Options[Cumulant], \n\t\t\ \(\((\(-I\))\)\^i\) 
                D[Log[CharacteristicFunction[m, t]], {t, i}] /. t -> 0 // 
            Factor, \n\t\tGeneralizedTransform[m, i, Log, 1, opts]]];\)\)



Options[Moment]={Centred\[Rule]False,Distribution\[Rule]False};

Moment[c_,U_List,opts___]:=If[Distribution/.{opts}/.Options[Moment],
		Print["ERROR: the option Distribution\[Rule]True is not allowed for the \
moment of a set, ",U],GeneralizedTransform[c,U,Exp,0,opts]];

\!\(\(Moment[c_, i_Integer, opts___] := 
      Module[{t, j, 
          zb}, \n\t\tIf[\(Distribution /. {opts}\) /. 
            Options[Moment], \n\t\tIf[\(Centred /. {opts}\) /. 
              Options[Moment], \n\t\t\t\t\tzb = Mean[c]; \n\t\t\t\t\tSum[
              Binomial[i, j] \(\((\(-I\))\)\^j\) 
                  D[CharacteristicFunction[c, t], {t, 
                      j}] \((\(-zb\))\)\^\(i - j\) /. t -> 0, {j, 0, 
                i}], \n\t\t\t\t\(\((\(-I\))\)\^i\) 
                D[CharacteristicFunction[c, t], {t, i}] /. t -> 0], 
          GeneralizedTransform[c, i, Exp, 0, opts]]];\)\)



Options[GeneralizedTransform]={Centred->False};

GeneralizedTransform[c_,i_Integer,g_,f0_,opts___]:=Module[{f,z},
		D[g[f],{z,i},NonConstants->{f}]/.{D[f,z,NonConstants\[Rule]{f}]->c[1],
              D[f,{z,j_},NonConstants\[Rule]{f}]->c[j]}/.f->f0/.If[
          Centred/.{opts}/.Options[GeneralizedTransform],{c[1]->0},{}]];

GeneralizedTransform[c_,U_List,g_,f0_,opts___]:=Module[{f,z},
		Apply[D,
                  Join[{g[f]},Map[z,U],{NonConstants->{f}}]]/.D[f,y__,
                    NonConstants\[Rule]{f}]->c[{y}]/.f->
                f0//.{a___,{z[x_],n_Integer},b___}:>
              Sort[Join[{a},Table[x,{n}],{b}]]/.z[x_]->x/.If[
          Centred/.{opts}/.Options[GeneralizedTransform],{c[{_}]->0},{}]];




End[];


EndPackage[];