(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)

BeginPackage["Utilities`Hyperlinks`"];





FindHyperlinks::usage=
    "FindHyperlinks[] finds all hyperlinks within the selected notebook, and \
lists their targets.  For each occurrence, the result is specified as \
{hyperlink name,{filename,cell tag}}.  If the cell tag is not specified, the \
last element is None.  Note that filename is represented in a form usable by \
FrontEndExecute[FrontEnd`NotebookLocate[filename]]. ";



FindIndexTag::usage=
    "FindIndexTag[filename] looks up the IndexTag defined for this file in \
the appropriate BrowserCategories.m file.  This allows conversion between \
standard hyperlinks (which refer to files by their names) and Add-ons \
hyperlinks, which refer to files by their index tags.  The file name must be \
specified in a form usable by the Front End.";



ConvertHyperlinkToAddOnsLink::usage=
    "ConvertHyperlinkToAddOnsLink[] finds all hyperlinks within the selected \
notebook, and changes them to the style AddOnsLink.  This requires that the \
target file name be converted to the IndexTag, which must be specified in \
BrowserCategories.m. The new version is created as an untitled notebook; this \
should be given a HelpBrowser style sheet.";



Begin["Utilities`Hyperlinks`Private`"];



FindHyperlinks[]:=Module[
      {nb=SelectedNotebook[],expr,ps},
      SelectionMove[nb, All, Notebook];
      expr=NotebookRead[nb];
      ps=Position[expr,ButtonStyle\[Rule]"Hyperlink"];
      (Extract[expr, 
                Drop[#,-1]]/.ButtonBox[name_,___,
                  ButtonData\[RuleDelayed]fn_,___]\[RuleDelayed]{name,fn})&/@
        ps];



FindIndexTag::noFile="No file `1` found in BrowserCategories.m";
FindIndexTag::noBrowserCategories=
    "No BrowserCategories.m found with file `1`";
FindIndexTag::manyFiles="Several files `1` found in BrowserCategories.m";
FindIndexTag::noIndexTags="No IndexTag found for `1` in BrowserCategories.m";
FindIndexTag::defectiveFileName="File name `1` is in the wrong form";

FindIndexTag[fn_]:=Module[{bfn,xx,ps,ps2,expr,nb,nb0,res,ss},
      If[Not[(Head[fn]===FrontEnd`FileName)||(Head[fn]===String)],
        Message[FindIndexTag::defectiveFileName,fn];"",
        bfn=If[Head[fn]===String,
            "BrowserCategories.m",
            
            fn/.FrontEnd`FileName[dir_,_,opts___]\[Rule]
                FrontEnd`FileName[dir,"BrowserCategories.m",opts]];
        nb0=SelectedNotebook[];
        ss=FrontEndExecute[FrontEnd`NotebookLocate[{bfn,None}]];
        nb=SelectedNotebook[];
        If[nb===nb0,
          Message[FindIndexTag::noBrowserCategories,fn];"",
          SelectionMove[nb,All,Notebook];
          expr=ToExpression[First[NotebookRead[nb]]];
          NotebookClose[nb];SetSelectedNotebook[nb0];
          ps=Position[expr,fn/.FrontEnd`FileName[_,x_,___]\[RuleDelayed]x];
          If[Length[ps]<1,
            Message[FindIndexTag::noFile,fn];"",
            If[Length[ps]>1,Message[FindIndexTag::manyFiles,fn];"",
              xx=Extract[expr,Drop[First[ps],-1]];
              If[Length[xx]\[NotEqual]4,
                Message[FindIndexTag::noIndexTags,fn];"",
                xx\[LeftDoubleBracket]3,2\[RightDoubleBracket]]]]]]];



ConvertHyperlinkToAddOnsLink[]:=Module[
      {nb=SelectedNotebook[],expr,exprNew},
      SelectionMove[nb, All, Notebook];
      expr=NotebookRead[nb];
      exprNew=
        expr/.
          {ButtonBox[name_,a___,
                ButtonData\[RuleDelayed]{fn_,ct_},b___,
                ButtonStyle\[Rule]"Hyperlink",c___]\[RuleDelayed]
              
              Check[(ButtonBox[name,a,
                    ButtonData\[RuleDelayed]Evaluate[{FindIndexTag[fn],ct}],b,
                    ButtonStyle\[Rule]"AddOnsLink",ButtonNote\[Rule]name,c]),
                
                ButtonBox[name,a,ButtonData\[RuleDelayed]{fn,ct},b,
                  ButtonStyle\[Rule]"Hyperlink",c]]};
      NotebookPut[Notebook[{exprNew}]];
      (* unclear that the {} should be included above*)
      exprNew];



End[];


EndPackage[];