(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)

BeginPackage[
    "Utilities`Matrices`",{"LinearAlgebra`MatrixManipulation`",
      "LinearAlgebra`Tridiagonal`","Utilities`SetManipulation`",
      "Statistics`DescriptiveStatistics`"}];





\!\(\(UpperOffDiagonal::usage = \
\*"\"\<UpperOffDiagonal[{\!\(a\_1\),\!\(a\_2\),\[Ellipsis]}] gives a matrix \
with the list {\!\(a\_1\),\!\(a\_2\),\[Ellipsis]} in the upper \
off-diagonal.\>\"";\)\)



\!\(\(LowerOffDiagonal::usage = \
\*"\"\<LowerOffDiagonal[{\!\(a\_1\),\!\(a\_2\),\[Ellipsis]}] gives a matrix \
with the list {\!\(a\_1\),\!\(a\_2\),\[Ellipsis]} in the lower \
off-diagonal.\>\"";\)\)



\!\(\(TridiagonalMatrix::usage = \*"\"\<TridiagonalMatrix[{\!\(a\_2\),\
\[Ellipsis],\!\(a\_n\)},{\!\(b\_1\),\[Ellipsis],\!\(b\_n\)},{\!\(c\_1\),\
\[Ellipsis],\!\(c\_\(n\\\\\\\  - \\\\\\\ 1\)\)}] gives a tridiagonal matrix \
with {\!\(a\_2\),\[Ellipsis],\!\(a\_n\)} in the upper \
off-diagonal,{\!\(b\_1\),\[Ellipsis],\!\(b\_n\)} on the diagonal, and \
{\!\(c\_1\),\[Ellipsis],\!\(c\_\(n\\\\\\\  - \\\\\\\ 1\)\)} on the lower \
off-diagonal.\>\"";\)\)



Unprotect[Flatten];

Flatten::usage=(Flatten::usage)~StringJoin~
      "  Flatten[list,{i,j}] flattens out levels i to j"; 

Protect[Flatten];



\!\(\(ExtractSubMatrix::usage = \*"\"\<ExtractSubMatrix[M,{\!\(i\_\[Alpha]\),\
\!\(i\_\[Beta]\),\[Ellipsis]},{\[Alpha],\[Beta],\[Ellipsis]}] extracts the \
submatrix of M which is defined by setting levels {\[Alpha],\[Beta],\
\[Ellipsis]} to {\!\(i\_\[Alpha]\),\!\(i\_\[Beta]\),\[Ellipsis]}.\>\"";\)\)



VarianceComponentsOld::usage=
    "VarianceComponentsOld[m] gives the variance components associated with \
the matrix m, up to order 3. ";



VarianceComponents::usage=
    "VarianceComponents[m] gives the variance components associated with the \
matrix m. ";



MarginalTable::usage=
    "MarginalTable[m,{\[Alpha],\[Beta],\[Ellipsis]}] gives a table of \
marginal values {\[Alpha],\[Beta],\[Ellipsis]}, averaging over all dimensions \
other than {\[Alpha],\[Beta],\[Ellipsis]}.  \
MarginalTable[m,{\[Alpha],\[Beta],\[Ellipsis]},Function\[Rule]f] uses the \
function f[] instead of Mean[Flatten[]] to construct the table.";



Begin["Utilities`Matrices`Private`"];



UpperOffDiagonal[a_List]:=Module[{n=Length[a]+1},
		AppendRows[ZeroMatrix[n,1],
        AppendColumns[DiagonalMatrix[a],ZeroMatrix[1,n-1]]]];



LowerOffDiagonal[a_List]:=Transpose[UpperOffDiagonal[a]];



TridiagonalMatrix[a_List,b_List,c_List]:=
    UpperOffDiagonal[a]+DiagonalMatrix[b]+LowerOffDiagonal[c];



Unprotect[Flatten];

Flatten[d_List,{i_Integer,j_Integer}]:=Map[Flatten[#,j-i]&,d,{i-1}];

Protect[Flatten];



ExtractSubMatrix[M_List,i_List,\[Alpha]_List]:=Module[{zz},
      If[\[Alpha]==={},
        M,
        zz=Array[All&,{Max[\[Alpha]]}];
        MapIndexed[(zz=ReplacePart[zz,Extract[ i,#2], #1])&, \[Alpha]];
        M\[LeftDoubleBracket]Sequence@@zz\[RightDoubleBracket]]];



\!\(\(VarianceComponentsOld[m_] := 
      Module[{d = Dimensions[m], i1, i2, i3, v1, v2, v3, v12, v13, v23, v123, 
          mm}, \[IndentingNewLine]Switch[
          TensorRank[
            m], \[IndentingNewLine]0, \((Print["\<Error: rank of \>", 
              m, "\< is 0\>"]; {})\), \[IndentingNewLine]1, {{Variance[
                m]}}, \[IndentingNewLine]2, \((v1 = Variance[Mean /@ m]; 
            v2 = Variance[
                Mean /@ Transpose[
                    m]]; \[IndentingNewLine]v12 = \
\((\((d\[LeftDoubleBracket]1\[RightDoubleBracket] 
                            d\[LeftDoubleBracket]2\[RightDoubleBracket] - 
                          1)\) Variance[Flatten[m]] - 
                    d\[LeftDoubleBracket]2\[RightDoubleBracket] \((d\
\[LeftDoubleBracket]1\[RightDoubleBracket] - 1)\) v1 - 
                    d\[LeftDoubleBracket]1\[RightDoubleBracket] \((d\
\[LeftDoubleBracket]2\[RightDoubleBracket] - 1)\) 
                      v2)\)/\((\((d\[LeftDoubleBracket]1\[RightDoubleBracket] \
- 1)\) \((d\[LeftDoubleBracket]2\[RightDoubleBracket] - 1)\))\); {{v1, 
                v2}, {v12}})\), \[IndentingNewLine]3, \[IndentingNewLine]v1 = 
            Table[Sum[m\[LeftDoubleBracket]i1, i2, i3\[RightDoubleBracket], \
{i2, d\[LeftDoubleBracket]2\[RightDoubleBracket]}, {i3, \
d\[LeftDoubleBracket]3\[RightDoubleBracket]}]\/\(d\[LeftDoubleBracket]2\
\[RightDoubleBracket] d\[LeftDoubleBracket]3\[RightDoubleBracket]\), {i1, 
                d\[LeftDoubleBracket]1\[RightDoubleBracket]}]; \
\[IndentingNewLine]v2 = 
            Table[Sum[m\[LeftDoubleBracket]i1, i2, i3\[RightDoubleBracket], \
{i1, d\[LeftDoubleBracket]1\[RightDoubleBracket]}, {i3, \
d\[LeftDoubleBracket]3\[RightDoubleBracket]}]\/\(d\[LeftDoubleBracket]1\
\[RightDoubleBracket] d\[LeftDoubleBracket]3\[RightDoubleBracket]\), {i2, 
                d\[LeftDoubleBracket]2\[RightDoubleBracket]}]; \
\[IndentingNewLine]v3 = 
            Table[Sum[m\[LeftDoubleBracket]i1, i2, i3\[RightDoubleBracket], \
{i1, d\[LeftDoubleBracket]1\[RightDoubleBracket]}, {i2, \
d\[LeftDoubleBracket]2\[RightDoubleBracket]}]\/\(d\[LeftDoubleBracket]1\
\[RightDoubleBracket] d\[LeftDoubleBracket]2\[RightDoubleBracket]\), {i3, 
                d\[LeftDoubleBracket]3\[RightDoubleBracket]}]; \
\[IndentingNewLine]v12 = 
            Table[\((Sum[m\[LeftDoubleBracket]i1, i2, \
i3\[RightDoubleBracket], {i3, \
d\[LeftDoubleBracket]3\[RightDoubleBracket]}]\/d\[LeftDoubleBracket]3\
\[RightDoubleBracket] - v1\[LeftDoubleBracket]i1\[RightDoubleBracket] - 
                  v2\[LeftDoubleBracket]i2\[RightDoubleBracket])\), {i1, 
                d\[LeftDoubleBracket]1\[RightDoubleBracket]}, {i2, 
                d\[LeftDoubleBracket]2\[RightDoubleBracket]}]; \
\[IndentingNewLine]v23 = 
            Table[\((Sum[m\[LeftDoubleBracket]i1, i2, \
i3\[RightDoubleBracket], {i1, \
d\[LeftDoubleBracket]1\[RightDoubleBracket]}]\/d\[LeftDoubleBracket]1\
\[RightDoubleBracket] - v2\[LeftDoubleBracket]i2\[RightDoubleBracket] - 
                  v3\[LeftDoubleBracket]i3\[RightDoubleBracket])\), {i2, 
                d\[LeftDoubleBracket]2\[RightDoubleBracket]}, {i3, 
                d\[LeftDoubleBracket]3\[RightDoubleBracket]}]; \
\[IndentingNewLine]v13 = 
            Table[\((Sum[m\[LeftDoubleBracket]i1, i2, \
i3\[RightDoubleBracket], {i2, \
d\[LeftDoubleBracket]2\[RightDoubleBracket]}]\/d\[LeftDoubleBracket]2\
\[RightDoubleBracket] - v1\[LeftDoubleBracket]i1\[RightDoubleBracket] - 
                  v3\[LeftDoubleBracket]i3\[RightDoubleBracket])\), {i1, 
                d\[LeftDoubleBracket]1\[RightDoubleBracket]}, {i3, 
                d\[LeftDoubleBracket]3\[RightDoubleBracket]}]; \
\[IndentingNewLine]v123 = 
            Table[\((m\[LeftDoubleBracket]i1, i2, i3\[RightDoubleBracket] - 
                  v1\[LeftDoubleBracket]i1\[RightDoubleBracket] - 
                  v2\[LeftDoubleBracket]i2\[RightDoubleBracket] - 
                  v3\[LeftDoubleBracket]i3\[RightDoubleBracket] - 
                  v23\[LeftDoubleBracket]i2, i3\[RightDoubleBracket] - 
                  v13\[LeftDoubleBracket]i1, i3\[RightDoubleBracket] - 
                  v12\[LeftDoubleBracket]i1, i2\[RightDoubleBracket])\), {i1, 
                d\[LeftDoubleBracket]1\[RightDoubleBracket]}, {i2, 
                d\[LeftDoubleBracket]2\[RightDoubleBracket]}, {i3, 
                d\[LeftDoubleBracket]3\[RightDoubleBracket]}]; \
\[IndentingNewLine]Map[
            Variance[Flatten[#]] &, {{v1, v2, v3}, {v23, v13, 
                v12}, {v123}}, {2}], \[IndentingNewLine]_, \((Print["\<Error: \
rank of \>", m, "\< is > 3\>"]; {})\)]];\)\)



Options[VarianceComponents]={Table\[Rule]False};

VarianceComponents[m_,{},{}]:=MarginalTable[m,{}];
VarianceComponents[m_,ii_,lev_]:=
    Mean[Flatten[{ExtractSubMatrix[m,ii,lev]}]]-
      Plus@@(VarianceComponents[m,
                Transpose[#]\[LeftDoubleBracket]1\[RightDoubleBracket],
                Transpose[#]\[LeftDoubleBracket]2\[RightDoubleBracket]]&/@
            Subsets[Transpose[{ii,lev}],1,Length[lev]-1])-
      VarianceComponents[m,{},{}];

VarianceComponents[m_,lev_,opts___Rule]:=
    Module[{d=Dimensions[m],j,tt},
      tt=Table[VarianceComponents[m,j/@lev,lev],
          Sequence@@(lev/.{k_Integer\[RuleDelayed]{j[k],
                        d\[LeftDoubleBracket]k\[RightDoubleBracket]}})//
            Evaluate];If[Table/.{opts}/.Options[VarianceComponents],
        tt,
        If[ListQ[tt]&&(Length[tt]>1),Variance[Flatten[tt]],0]]];

VarianceComponents[m_,opts___Rule]:=Module[{n=TensorRank[m],j},
      Table[VarianceComponents[m,#,opts]&/@Subsets[Range[n],j],{j,0,n}]];



Options[MarginalTable]={Function\[Rule](Mean[Flatten[#]]&)};

MarginalTable[m_List,lev_List,opts___Rule]:=
    Module[{d=Dimensions[m],j,f=Function/.{opts}/.Options[MarginalTable]},
      Table[f[ExtractSubMatrix[m,j/@lev,lev]],
        Sequence@@(lev/.{k_Integer\[RuleDelayed]{j[k],
                      d\[LeftDoubleBracket]k\[RightDoubleBracket]}})//
          Evaluate]];



End[];


EndPackage[];