(* SetManipulation.m :  Jason Harris,  10/12/2002       *)
(* This file is machine generated from SetManipulation.nb*)
(* It is not intended to be read by humans.  *)
(* Please consult the source file SetManipulation.nb. *)

BeginPackage["Utilities`SetManipulation`", {"Utilities`Notation`", "DiscreteMath`Combinatorica`"}];

NotebookClose[NotebookObject[FrontEndObject[LinkObject["Mathematica 4", 1, 1]], 47]];

Separate::usage = "Separate is a rule which replaces {i,j,\!\(\(i\^*\)\),\!\(k\^\[Dagger]\)} by {{i,j},{i},{k}}. Also applies to diploids: {i,j,OverHat[k],SuperDagger[OverHat[n]]} is converted to {{{i,j},{},{}},{{k},{},{n}}}.  Obsolete function.";

Combine::usage = "Combine is a rule which replaces {{i,j},{i},{k}} by  {i,j, \!\(\(i\^*\)\), \!\(k\^\[Dagger]\)}. Extends to diploids.  Obsolete function.";

ReplaceRepeatedSpecial::usage = "ReplaceRepeatedSpecial[expr,rules] or expr||.rules applies \!\(\* StyleBox[\"rules\",\nFontSlant->\"Italic\"]\) repeatedly until there is no further change.  Evaluates rules inside AddUp[] and TimesUp[]";

ReplaceAllSpecial::usage = "ReplaceAllSpecial[expr,rules] or expr|.rules applies \!\(\* StyleBox[\"rules\",\nFontSlant->\"Italic\"]\), evaluating them inside AddUp[] and TimesUp[]";

Repeat::usage = "Repeat[U,n] gives the list U, repeated n times";

ExtractRepeat::usage = "ExtractRepeat[U] gives a list of the repeated elements in U";

TakeAway::usage = "TakeAway[U,V] or U\[Backslash]V gives the set U, minus elements V. Note that this is not the same as Complement[U,V] if U contains repeated elements.  (\[Backslash] is entered as \[AliasIndicator]\\[AliasIndicator])";

ExactIntersection::usage = "ExactIntersection[U,V] or U\[Wedge]V gives those elements that appear in both U and V. (\[Wedge] is entered as \[AliasIndicator]^\[AliasIndicator]).";

Join::usage = StringJoin[Join::usage, " list1\[Vee]list2 has the same effect.  (The character \[Vee] is input as \[AliasIndicator]v\[AliasIndicator])."];

PatternFree::usage = "PatternFree is an option for FlattenList that determines whether elements may themselves contain a pattern";

FlattenList::usage = "FlattenList[list,pattern] produces a new list, containing those elements of list that match pattern.  This can be used to partly flatten a nested list.";

AddUp::usage = "AddUp[x,e,U] or \!\(\[Sum]\+\(\(e  \\\\\\\\\)\\\\\\ \\\\\\ \\  \[Element] \\ \(\(\\\\\)\(\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\ \)\) U\)\)\)\)x gives the sum of x over all e in the list U. Thus, AddUp[f[e,z],e,{i,j,k}] gives f[i,z]+f[j,z]+f[k,z]. AddUp[x,{\!\(e\_1\),\!\(e\_2\)\[Ellipsis]},{\!\(U\_1\),\!\(U\_2\),\[Ellipsis]}] is also defined - it gives the multiple sum over \!\(e\_1\),\!\(e\_2\).  All the \!\(e\_i\) must be distinct.  AddUp[x,e,U,Subsets->True] or \!\(\[Sum]\+\(\(e  \\\\\\\\\)\\\\\\ \\\\\\ \\  \[SubsetEqual] \\ \(\(\\\\\)\(\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\ \)\) U\)\)\)\)x gives the sum of x over all distinct subsets of U.";

TimesUp::usage = "TimesUp[x,e,U] or \!\(\[Product]\+\(\(\(e\)\(\\\\\)\)\\ \\  \[Element] \\ \(\(\\\\\)\(\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\ \)\) U\)\)\)\)x gives the product of x over all e in the list U. Thus, TimesUp[f[e,z],e,{i,j,k}] gives f[i,z]f[j,z]f[k,z]. TimesUp[x,{\!\(e\_1\),\!\(e\_2\)\[Ellipsis]},{\!\(U\_1\),\!\(U\_2\),\[Ellipsis]}] is also defined - it gives multiple sum over \!\(e\_1\),\!\(e\_2\).  All the \!\(e\_i\) must be distinct. TimesUp[x,e,U,Subsets->True] or \!\(\[Product]\+\(\(e  \\\\\\\\\)\\\\\\ \\\\\\ \\  \[SubsetEqual] \\ \(\(\\\\\)\(\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\ \)\) U\)\)\)\)x gives the product of x over all distinct subsets of U.";

SimplifyAddUp::usage = "SimplifyAddUp[expr] simplifies expressions involving AddUp[] or \!\(\[Sum]\+\(\(\(i\)\(\\\\\)\)\\ \\  \[Element] \\ \(\(\\\\\)\(\\ \)\(U\)\)\)\)";

SimplifyAddUpQ::usage = "SimplifyAddUpQ[expr] returns True if expr is in the standard form generated by SimplifyAddUp.";

Subsets::usage = "Subsets[U] gives a list of all subsets of U, including {} and U. Subsets[U,i] gives subsets of length i. Subsets[U,imin,imax] gives subsets of length imin to imax.";

Symmetrise::usage = "Symmetrise[f] is a rule which replaces f[U] by the standard ordering";

Locations::usage = "Locations[S,U] lists the positions of elements of U within S.";

ProductSum::usage = "ProductSum[V,n] gives the sum of all products of distinct elements of V. ProductSum[V1,V2,n1,n2] is also defined; it is just ProductSum[V1,n1]ProductSum[V2,n2].  ProductSum[n][u] is a compiled version; gets slow to calculate for the first time for n>8. ProductSum[{{\!\(\[Alpha]\_1\),\[Ellipsis]},{\!\(\[Beta]\_1\),\[Ellipsis]}},{a,b}] generates A, B of distinct elements, and the sum is over all such sets. ";

ProductSumExpression::usage = "ProductSumExpression[c,k] gives an expression for ProductSum[u,k] in terms of c[k]=\!\(\[Sum]\_i\)\!\(u\_i\%k\).  Used to set up ProductSum[n]";

ProductSumVector::usage = "ProductSumVector[n][\!\(\[Delta]p\/p\)] is a compiled routine which returns the vector of ProductSum[j], given the vector of \!\(\[Delta]p\/p\). Defined up to order 5";

SortByHead::usage = "SortByHead[{\!\(e\_1\),\[Ellipsis]}] sorts the \!\(e\_i\) such that all lists appear at the beginning. SortByHead[{\!\(e\_1\),\[Ellipsis]},h] does the same for arbitrary head.  Reverse\[Rule]True puts the lists (or whatever) at the end.";

SetPartition::usage = "SetPartition[U] lists all the ways in which the set U can be partitioned.  For example, SetPartition[{a,b,c}] gives {{{a,b,c}},{{a,b},{c}},\[Ellipsis],{{a},{b},{c}}}. SetPartition[U,m] lists all the ways of partitioning U into m parts.  The same function is now carried out by PartitionList, which is rather more general.";

NumberOfSetPartitions::usage = "NumberOfSetPartitions[n] gives the number of distinct partitions of a set of n elements.  NumberOfSetPartitions[n,m] gives the number of distinct partitions of a set of n elements into m parts. ";

SamplePartition::usage = "SamplePartition[{\!\(x\_1\),\[Ellipsis],\!\(x\_k\)}] describes the structure of a sample of k objects, by listing which of the k are equal.  For example, SamplePartition[{a,b,c,a,c}] gives {{2},{1,4},{3,5}}.";

NumberOfSamplePartitions::usage = "NumberOfSamplePartitions[P,n] gives the number of ways k objects can be sampled with replacement from a population of n objects, so as to match the structure P";

AddTag::usage = "AddTag[{{x,y},{z}}] gives a flattened list, {Tag[x,1],Tag[y,1],Tag[z,2]} with elements which are tagged so as to retain information about the original structure. AddTag[{{{x,y}},{{z}}},3] acts at a lower level.";

RemoveTag::usage = "RemoveTag[{Tag[x,1],Tag[y,2],Tag[z,1]}] gives {{x,z},{y}}. RemoveTag[{Tag[x,1],Tag[y,2],Tag[z,1]},3] gives {{{x},{z}},{{y}}}";

Tag::usage = "Tag[elem,pos] tags elements of a set with their position.";

SplitSet::usage = "SplitSet[U,{\!\(n\_1\),\!\(n\_2\),\[Ellipsis]}] splits the set U into successive lists of length \!\(n\_1\),\[Ellipsis].";

PartitionSet::usage = "PartitionSet[U] gives all partitions of the set U - possibly a very large set.  PartitionSet[U,n] gives all partititions into n sets. EmptySets\[Rule]True includes empty sets.  Permutations\[Rule]True pools permutations.  Ordered\[Rule]True specifies that partitions must respect the given order of elements.  PartitionSet[n,opts] stores the canonical form for PartitionSet[{1,2\[Ellipsis]n},opts].";

Ordered::usage = "Ordered is an option for PartitionSet which specifies that the order of the elements must be respected.";

Permutations::usage = StringJoin[Permutations::usage, ".  Permutations is an option for PartitionSet which specifies that all permutations are given."];

EmptySets::usage = "EmptySets is an option for PartitionSet which specifies that empty sets {} are included.";

\[EmptySet]::usage = "\[EmptySet] denotes an empty set,or missing data";

SetOfCombinations::usage = "SetOfCombinations[{{a1,b1},{a2,b2,c2},\[Ellipsis]}] lists all possible combinations of the sets: {{a1,a2,\[Ellipsis]},{a1,b2,\[Ellipsis]}\[Ellipsis]}.  SetOfCombinations[{{a,b,..},n}] lists all possible combinations of n elements, using a single set: {{a,a,\[Ellipsis]},{a,b,\[Ellipsis]},\[Ellipsis]}.  SetOfCombinations[n] gives the set of binary integers with n digits. Stores results.  Equivalent to HaploidTypes[].";

StandardPartitionQ::usage = "StandardPartitionQ[P] returns True if P is a partition of {1,2\[Ellipsis]n} in standard order";

StandardPartition::usage = "StandardPartition[P] returns the standard form for the partition.";

ConfigurationSet::usage = "ConfigurationSet[{n1,n2\[Ellipsis]},k] lists all distinct ways of combining the {n1,n2\[Ellipsis]} objects into k sets. ConfigurationSet[{n1,n2\[Ellipsis]}]  lists all configurations from k=1 up.  ConfigurationSet[{{a1,b1\[Ellipsis]},{a2,b2\[Ellipsis]}\[Ellipsis]},k] does the same for definite sets {a1,b1\[Ellipsis]}";

Begin["Utilities`SetManipulation`Private`"];

ReplaceAllSpecial[f_, r_] := f /. {AddUp -> au, TimesUp -> tu} /. r /. {au -> AddUp, tu -> TimesUp};

Notation[DoubleLongLeftRightArrow[NotationBoxTag[RowBox[List["e_", "|", RowBox[List[".", "r_"]]]]], NotationBoxTag[RowBox[List["Utilities`SetManipulation`ReplaceAllSpecial", "[", RowBox[List["e_", ",", "r_"]], "]"]]]]];

ReplaceRepeatedSpecial[f_, r_] := f /. {AddUp -> au, TimesUp -> tu} //. r /. {au -> AddUp, tu -> TimesUp};

Notation[DoubleLongLeftRightArrow[NotationBoxTag[RowBox[List["e_", "||", RowBox[List[".", "r_"]]]]], NotationBoxTag[RowBox[List["Utilities`SetManipulation`ReplaceRepeatedSpecial", "[", RowBox[List["e_", ",", "r_"]], "]"]]]]];

Repeat[U_List, 0] := {};
Repeat[U_List, 1] := U;
Repeat[U_List, n_Integer] := Join[Repeat[U, n - 1], U] /; n > 1;

ExtractRepeat[U_List] := DeleteCases[({#1, Count[U, #1]} & ) /@ Union[U], {_, 1}];

Attributes[AddUp] = {HoldFirst};

Options[AddUp] = {Subsets -> False};

AddUp[f_, (e_)?( !ListQ[#1] & ), U_List, opts___Rule] := Module[{sf = Evaluate[Subsets /. {opts} /. Options[AddUp]]}, If[sf, ReleaseHold[AddUp[f, e, Union[Sort /@ Subsets[U]]]], ReleaseHold[Plus @@ (Hold[f] /. e :> #1 & ) /@ U]]];
AddUp[f_, {}, {}, opts___Rule] := ReleaseHold[f];
AddUp[x_, e_List, U:{___, _List, ___}, opts___Rule] := Module[{tu = Transpose[{U, e}], Ue1, y}, Ue1 = First[Cases[tu, {{___}, _}]]; y = AddUp[x, Ue1[[2]], Ue1[[1]], opts]; ReleaseHold[AddUp[Evaluate[y], Evaluate[e \[Backslash] {Ue1[[2]]}], Evaluate[U \[Backslash] {Ue1[[1]]}], opts]]];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[RowBox[List[UnderscriptBox["\[Sum]", RowBox[List["x_", "\[Element]", "U_"]]], "f_"]]], NotationBoxTag[RowBox[List["Utilities`SetManipulation`AddUp", "[", RowBox[List["f_", ",", "x_", ",", "U_"]], "]"]]]]];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[RowBox[List[UnderscriptBox["\[Sum]", RowBox[List["x_", "\[SubsetEqual]", "U_"]]], "f_"]]], NotationBoxTag[RowBox[List["Utilities`SetManipulation`AddUp", "[", RowBox[List["f_", ",", "x_", ",", "U_", ",", RowBox[List["Subsets", "\[Rule]", "True"]]]], "]"]]]]];

Attributes[TimesUp] = {HoldFirst};

Options[TimesUp] = {Subsets -> False};

TimesUp[f_, (e_)?( !ListQ[#1] & ), U_List, opts___Rule] := Module[{sf = Evaluate[Subsets /. {opts} /. Options[TimesUp]]}, If[sf, ReleaseHold[TimesUp[f, e, Union[Sort /@ Subsets[U]]]], ReleaseHold[Times @@ (Hold[f] /. e :> #1 & ) /@ U]]];
TimesUp[f_, {}, {}, opts___Rule] := ReleaseHold[f];
TimesUp[x_, e_List, U:{___, _List, ___}, opts___Rule] := Module[{tu = Transpose[{U, e}], Ue1, y}, Ue1 = First[Cases[tu, {{___}, _}]]; y = TimesUp[x, Ue1[[2]], Ue1[[1]], opts]; ReleaseHold[TimesUp[Evaluate[y], Evaluate[e \[Backslash] {Ue1[[2]]}], Evaluate[U \[Backslash] {Ue1[[1]]}], opts]]];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[RowBox[List[UnderscriptBox["\[Product]", RowBox[List["x_", "\[Element]", "U_"]]], "f_"]]], NotationBoxTag[RowBox[List["Utilities`SetManipulation`TimesUp", "[", RowBox[List["f_", ",", "x_", ",", "U_"]], "]"]]]]];

Notation[DoubleLongLeftRightArrow[NotationBoxTag[RowBox[List[UnderscriptBox["\[Product]", RowBox[List["x_", "\[SubsetEqual]", "U_"]]], "f_"]]], NotationBoxTag[RowBox[List["Utilities`SetManipulation`TimesUp", "[", RowBox[List["f_", ",", "x_", ",", "U_", ",", RowBox[List["Subsets", "\[Rule]", "True"]]]], "]"]]]]];

SimplifyAddUp[a_ + b_] := SimplifyAddUp[a] + SimplifyAddUp[b];
SimplifyAddUp[a___*(b_ + c_)] := SimplifyAddUp[a*b + a*c];

SimplifyAddUp[(b_ + c_)^n_Integer] := SimplifyAddUp[Expand[(b + c)^n]];
SimplifyAddUp[a___*(b_ + c_)^n_Integer] := SimplifyAddUp[Expand[a*(b + c)^n]];

SimplifyAddUp[a_] := SimplifyAddUp[a /. {AddUp[x_, (i_)?( !ListQ[#1] & ), S_, opts___Rule] -> AddUp[x, {i}, {S}, opts]}] /;  !FreeQ[a, AddUp[_, _?( !ListQ[#1] & ), _, ___Rule]];

SimplifyAddUp[(a___)?(FreeQ[#1, AddUp] & )*AddUp[b_, e_List, S_, opts___Rule]] := SimplifyAddUp[AddUp[a*b, e, S, opts]];

SimplifyAddUp[AddUp[AddUp[b_, (i_)?( !ListQ[#1] & ), S2_, o2___Rule], e1_List, S1_, o1___Rule]] := SimplifyAddUp[AddUp[AddUp[b, {i}, {S2}, o2], e1, S1, o1]];
SimplifyAddUp[AddUp[AddUp[b_, e2_List, S2_, o2___Rule], e1_List, S1_, o1___Rule]] := If[Intersection[e1, e2] === {} && o1 === o2, SimplifyAddUp[AddUp[b, Evaluate[e1 \[Vee] e2], Evaluate[S1 \[Vee] S2], o1]], If[ !Intersection[e1, e2] === {}, Message[SimplifyAddUp::indexclash, Intersection[e1, e2], AddUp[AddUp[b, e2, s2, o2], e1, s1, o1]]]; If[ !o1 === o2, Message[SimplifyAddUp::optionclash, o1, o2, AddUp[AddUp[b, e2, s2, o2], e1, s1, o1]]]];

SimplifyAddUp[c___*AddUp[a_, e1_List, S1_, o1___Rule]*AddUp[b_, e2_List, S2_, o2___Rule]] := Module[{int = Intersection[e1, e2], en, rl}, en[x_] := en[x] = Unique[x]; rl = (#1 -> en[#1] & ) /@ int; If[o1 === o2, SimplifyAddUp[c*AddUp[Evaluate[(a /. rl)*b], Evaluate[(e1 /. rl) \[Vee] e2], Evaluate[S1 \[Vee] S2], o1]], Message[SimplifyAddUp::optionclash, o1, o2, AddUp[AddUp[b, e2, s2, o2], e1, s1, o1]]]];

SimplifyAddUp[c___*AddUp[a_, e_List, S_, opts___Rule]^n_Integer] := Module[{en, an, rl, k}, en = Table[Unique /@ e, {n}]; rl[j_] := Table[e[[k]] -> en[[j,k]], {k, Length[e]}]; SimplifyAddUp[c*AddUp[Evaluate[Product[a /. rl[k], {k, n}]], Evaluate[Flatten[en]], Evaluate[Repeat[S, n]], opts]]];

SimplifyAddUp[AddUp[a_, e_List, S_, opts___Rule]^n_Integer] := Module[{en, an, rl, k}, en = Table[Unique /@ e, {n}]; rl[j_] := Table[e[[k]] -> en[[j,k]], {k, Length[e]}]; SimplifyAddUp[AddUp[Evaluate[Product[a /. rl[k], {k, n}]], Evaluate[Flatten[en]], Evaluate[Repeat[S, n]], opts]]];

SimplifyAddUp[AddUp[(a_)?(FreeQ[#1, AddUp] & ), e_List, S_, opts___Rule]] := AddUp[a, e, S, opts];

SimplifyAddUp[(a_)?(FreeQ[#1, AddUp] & )] := a;

SimplifyAddUp::indexclash = "Clash of dummy indices `1` in `2`";
SimplifyAddUp::optionclash = "Clash of options `1`,`2` in `3`";

SimplifyAddUpQ[a_ + b_] := SimplifyAddUpQ[a] && SimplifyAddUpQ[b];
SimplifyAddUpQ[expr_] := FreeQ[expr, AddUp] || MatchQ[expr, AddUp[_?(FreeQ[#1, AddUp] & ), _List, _List, opts___Rule]];

Options[SortByHead] = {Reverse -> False};

SortByHead[s_List, opts___Rule] := SortByHead[s, List, opts];
SortByHead[s_List, h_, opts___Rule] := Module[{r = Reverse /. {opts} /. Options[SortByHead]}, Sort[s, If[Head[#1] === h, If[Head[#2] === List, OrderedQ[{#1, #2}],  !r], If[Head[#2] === h, r, OrderedQ[{#1, #2}]]] & ]];

ExactIntersection[{a___, x_, b___}, {c___, x_, d___}] := Prepend[ExactIntersection[{a, b}, {c, d}], x];
ExactIntersection[a_List, b_List] := If[Intersection[a, b] == {}, {}, ExactIntersection[a, b]];

InfixNotation[NotationBoxTag["\[Wedge]"], ExactIntersection];

InfixNotation[NotationBoxTag["\[Vee]"], Join];

TakeAway[U_List, {}] := U;
TakeAway[U_List, {v_}] := Drop[U, Position[U, v][[1]]] /; Complement[{v}, U] == {};
TakeAway[U_List, V_List] := TakeAway[TakeAway[U, Take[V, 1]], Drop[V, 1]] /; Complement[V, U] == {};
TakeAway[U_List, W__List, V_List] := TakeAway[TakeAway[U, W], V];

InfixNotation[NotationBoxTag["\[Backslash]"], TakeAway];

Options[FlattenList] = {PatternFree -> True};

FlattenList[l_List, p_, opts___Rule] := DeleteCases[If[PatternFree /. {opts} /. Options[FlattenList], Select[FlattenList[l, p, PatternFree -> False],  !MemberQ[#1, p] & ], (Extract[l, #1] & ) /@ Position[l, p]], {}];

Unprotect[Subsets];

Subsets[U_List, 0] := KSubsets[U, 0];
Subsets[U_List, (k_Integer)?Positive] := KSubsets[U, k];
Subsets[U_List, j_Integer, k_Integer] := Flatten[(KSubsets[U, #1] & ) /@ Range[j, k], 1];

Protect[Subsets];

Symmetrise[f_] := {f[(U_)?(ListQ[#1] &&  !OrderedQ[#1] & )] :> f[Sort[U]]};

Locations[S_List, U_List] := (Position[S, #1][[1]] & ) /@ U;

ProductSum[U_List, n_Integer] := Plus @@ (Times @@ #1 & ) /@ Subsets[U, n];

ProductSum[U1_List, U2_List, n1_Integer, n2_Integer] := Plus @@ (Times @@ #1 & ) /@ Flatten[Outer[Join, Subsets[U1, n1], Subsets[U2, n2], 1], 1];

ProductSum[{\[Alpha]_List, \[Beta]_List}, {a_Integer, b_Integer}] := Module[{n = Length[\[Alpha]], ss, i}, ss = Subsets[Range[n], a]; Sum[Times @@ \[Alpha][[ss[[i]]]]*Plus @@ (Times @@ \[Beta][[#1]] & ) /@ Subsets[Complement[Range[n], ss[[i]]], b], {i, Length[ss]}]];

ProductSum[{a_List}, {j_Integer}] := ProductSum[a, j];

ProductSum[{a_List, b__List}, {j_Integer, k__Integer}] := Module[{rn = Range[Length[a]]}, Plus @@ (Times @@ a[[#1]]*ProductSum[Transpose[Transpose[{b}][[Complement[rn, #1]]]], {k}] & ) /@ Subsets[rn, j]];

ProductSum[k_Integer] := ProductSum[k] = Module[{pr, f, u}, u = Array[f, k]; Compile[{{z, _Real, 1}}, Evaluate[pr /. Solve[Eliminate[Append[Table[Plus @@ (u^j) == ProductVector[z, j], {j, 1, k}], pr == Times @@ u], u], pr][[1]]], {{ProductVector[_, _], _Real}}]];

ProductSum[0] = 1 & ;

ProductSum[1] = Module[{u}, Compile[{{u, _Real, 1}}, Plus @@ u]];

ProductSum[2] = Module[{u}, Compile[{{u, _Real, 1}}, (Plus @@ u^2 - Plus @@ (u^2))/2]];

ProductSum[3] = Module[{u, pl}, Compile[{{u, _Real, 1}}, pl = Plus @@ u; (pl^3 - 3*pl*Plus @@ (u^2) + 2*Plus @@ (u^3))/6, {{pl, _Real}}]];

ProductSum[4] = Module[{u, pl1, pl2}, Compile[{{u, _Real, 1}}, pl1 = Plus @@ u; pl2 = Plus @@ (u^2); (pl1^4 - 6*pl1^2*pl2 + 3*pl2^2 + 8*pl1*Plus @@ (u^3) - 6*Plus @@ (u^4))/24, {{pl1, _Real}, {pl2, _Real}}]];

ProductSum[5] = Module[{u, pl1, pl2}, Compile[{{u, _Real, 1}}, pl1 = Plus @@ u; pl2 = Plus @@ (u^2); (pl1^5 - 10*pl1^3*pl2 + 15*pl1*pl2^2 + 20*(pl1^2 - pl2)*Plus @@ (u^3) - 30*pl1*Plus @@ (u^4) + 24*Plus @@ (u^5))/120, {{pl1, _Real}, {pl2, _Real}}]];

ProductSum[6] = Module[{u, pl1, pl2, pl3}, Compile[{{u, _Real, 1}}, pl1 = Plus @@ u; pl2 = Plus @@ (u^2); pl3 = Plus @@ (u^3); (pl1^6 - 15*pl1^4*pl2 + 45*pl1^2*pl2^2 - 15*pl2^3 + 40*pl1^3*pl3 - 120*pl1*pl2*pl3 + 40*pl3^2 + 90*(pl2 - pl1^2)*Plus @@ (u^4) + 144*pl1*Plus @@ (u^5) - 120*Plus @@ (u^6))/720, {{pl1, _Real}, {pl2, _Real}, {pl3, _Real}}]];

ProductSumExpression[cc_, k_] := Module[{pr, j, u, f}, u = StandardSet[k, f]; pr /. Solve[Eliminate[Append[Table[Plus @@ (u^j) == cc[j], {j, 1, k}], pr == Times @@ u], u], pr][[1]]];

ProductVectorCompiled = Compile[{{u, _Real, 1}, {k, _Integer}}, Plus @@ (u^k)];
ProductVector[u_List, k_Integer] := ProductVectorCompiled[u, k];

ProductSumVector[n_Integer] := ProductSumVector[n] = Compile[{{u, _Real, 1}}, Table[ProductSum[j][u], {j, 0, n}], {{ProductSum[_][_], _Real}}];

SetPartition[U_List] := Flatten[(SetPartition[U, #1] & ) /@ Range[1, Length[U]], 1];

SetPartition[U_List, 1] := {{U}};
SetPartition[U_List, n_Integer] := {List /@ U} /; Length[U] == n;
SetPartition[U_List, n_Integer] := {} /; n > Length[U] || n < 1;

SetPartition[U_List, n_Integer] := Module[{V = Drop[U, 1], e = U[[1]], spv, j}, spv = SetPartition[V, n]; Sort /@ Flatten[Append[(Table[ReplacePart[#1, Sort[Append[#1[[j]], e]], j], {j, n}] & ) /@ spv, (Sort[Append[#1, {e}]] & ) /@ SetPartition[V, n - 1]], 1] /; 1 < n < Length[U]];

NumberOfSetPartitions[n_Integer] := Module[{m}, Sum[NumberOfSetPartitions[n, m], {m, 1, n}]];

NumberOfSetPartitions[n_Integer, 1] := 1;
NumberOfSetPartitions[n_Integer, n_Integer] := 1;
NumberOfSetPartitions[n_Integer, m_Integer] := 0 /; m > n || m < 1;

NumberOfSetPartitions[n_Integer, m_Integer] := NumberOfSetPartitions[n - 1, m]*m + NumberOfSetPartitions[n - 1, m - 1] /; 1 < m < n;

SamplePartition[U_List] := Sort[(Sort[Flatten[Position[U, #1]]] & ) /@ Union[U]];

NumberOfSamplePartitions[P_, n_] := Module[{fp = Flatten[P], k}, k = Length[fp]; If[Sort[fp] == Range[k], Pochhammer[n - Length[P] + 1, Length[P]], Message[NumberOfSamplePartitions:notpart, P, k]; P]];

NumberOfSamplePartitions::notpart = "`1` is not a valid description of a partition of `2` objects";

AddTag[U_List] := AddTag[U, 2];
AddTag[U_List, l_] := Flatten[MapIndexed[Tag[#1, #2[[1]]] & , U, {l}]];

RemoveTag[z:{Tag[_, _]...}, l_Integer] := ({#1} & ) /@ RemoveTag[z, l - 1] /; l > 2;
RemoveTag[z:{Tag[_, _]...}] := RemoveTag[z, 2];
RemoveTag[{}, 2] := {};
RemoveTag[z:{Tag[_, _]..}, 2] := Module[{nn = Max[z /. {Tag[_, j_] -> j}], aa}, aa = Array[{} & , nn]; Scan[(aa = Insert[aa, #1[[1]], {#1[[2]], -1}]) & , z]; aa];

Separate = {U_List :> If[FreeQ[U, Global`OverHat[_]], Module[{c\[Dagger] = Cases[U, Global`SuperDagger[_]], cs = Cases[U, Global`SuperStar[_]]}, {TakeAway[U, cs, c\[Dagger]], cs /. {Global`SuperStar[x_] -> x}, c\[Dagger] /. {Global`SuperDagger[x_] -> x}}] /. {a_List, b_List, {}} -> {a, b}, Module[{ch = Cases[U, Global`OverHat[_] | Global`SuperStar[Global`OverHat[_]] | Global`SuperDagger[Global`OverHat[_]]]}, {TakeAway[U, ch] /. Separate, ch /. {Global`OverHat[x_] -> x} /. Separate} /. {{a_List, b_List, {}}, {c_List, d_List, {}}} -> {{a, b}, {c, d}}]]};

com = {{U_List, V_List} :> Join[U, (Global`SuperStar[#1] & ) /@ V], {U_List, V_List, W_List} :> Join[U, (Global`SuperStar[#1] & ) /@ V, (Global`SuperDagger[#1] & ) /@ W]};

Combine = {{U_List, V_List, W_List} :> ({U, V, W} /. com), {U_List, V_List} :> If[Depth[U] == 2, {U, V} /. com, Join[U /. com, Map[Global`OverHat[#1] & , V, {2}] /. Global`OverHat[{}] -> {} /. com //. {a___, {}, b___} -> {a, b}]]};

SplitSet::sumJ = "List of lengths `1` does not match the # of elements in `2`";

SplitSet[U_List, jl:{___Integer}] := Module[{bb}, If[Plus @@ jl != Length[U], Message[SplitSet::sumJ, jl, U]; U, bb = Drop[FoldList[Plus, 0, jl], 1]; (Take[U, #1] & ) /@ Transpose[{bb - jl + 1, bb}]]];

Options[PartitionSet] = {EmptySets -> False, Permutations -> False, Ordered -> False};

PartitionSet::negJ = "# of sets specified, `1`, must be positive.";
PartitionSet::bigJ = "# of sets specified, `1`, must not be greater than the number of elements, `2`.";

PartitionSet[U_List, j_Integer, opts___Rule] := PartitionSet[Length[U], j, opts] /. {a_Integer :> U[[a]]};

PartitionSet[n_Integer, opts___Rule] := PartitionSet[n, opts] = Flatten[(PartitionSet[n, #1, opts] & ) /@ Range[n], 1];
PartitionSet[U_List, opts___Rule] := Flatten[(PartitionSet[U, #1, opts] & ) /@ Range[Length[U]], 1];

PartitionSet[n_Integer, j_Integer, opts___Rule] := PartitionSet[n, j, opts] = Module[{pp, a, b, rn = Range[n], eQ = EmptySets /. {opts} /. Options[PartitionSet], pQ = Permutations /. {opts} /. Options[PartitionSet], oQ = Ordered /. {opts} /. Options[PartitionSet], tl}, tl = If[j <= 1, If[j < 1, Message[PartitionSet::negJ, j]]; {{rn}}, If[j >= n, If[j > n, Message[PartitionSet::bigJ, j, n]]; {List /@ Range[n]}, If[j == 2, Sort[Union[Sort /@ If[oQ, ({Take[rn, #1], Drop[rn, #1]} & ) /@ Range[n - If[eQ, 0, 1]], ({#1, TakeAway[rn, #1]} & ) /@ Subsets[rn, 0, Quotient[n, 2]]]]], pp = PartitionSet[n, j - 1, opts]; Sort[Union[Sort /@ Flatten[Table[If[Length[pp[[b,a]]] < 2, {}, (Join[Take[pp[[b]], a - 1], #1, Drop[pp[[b]], a]] & ) /@ PartitionSet[pp[[b,a]], 2, opts]], {a, j - 1}, {b, Length[pp]}], 2]]]]]]; tl = DeleteCases[tl, {}]; tl = If[eQ, tl, DeleteCases[tl, {___, {}, ___}]]; tl = If[pQ, Flatten[Permutations /@ tl, 1], tl]];

SetOfCombinations[{}, ___] := {};

SetOfCombinations[g_List] := SetOfCombinations[g] = Flatten[Outer @@ Prepend[g, List], Length[g] - 1];

SetOfCombinations[{g_List, n_Integer}] := SetOfCombinations[{g, n}] = SetOfCombinations[Table[g, {n}]];

SetOfCombinations[n_Integer] := SetOfCombinations[n] = SetOfCombinations[{{0, 1}, n}];

StandardPartitionQ[P:{__List}] := StandardPartition[P] === P;

StandardPartition[P:{___List}] := Module[{ss = Sort[Length /@ P]}, SplitSet[Range[Plus @@ ss], ss]];

ConfigurationSet[n:{_Integer...}, k_Integer] := Module[{cl}, cl = Sequence @@ (Compositions[#1, k] & ) /@ n; DeleteCases[Union[Flatten[Outer[Sort[Transpose[{##1}]] & , cl, 1], Length[n] - 1]], {___, {(0)..}, ___}]];

ConfigurationSet[s:{_List...}, k_Integer] := Module[{cl}, cl = Sequence @@ (Union[PartitionSet[Join[#1, Array[\[EmptySet] & , k]], k, Permutations -> True] /. {\[EmptySet]..} :> {} //. {{x___, \[EmptySet], y___} :> {x, y}}] & ) /@ s; DeleteCases[Union[Flatten[Outer[Sort[Transpose[{##1}]] & , cl, 1], Length[s] - 1]], {___, {{}..}, ___}]];

ConfigurationSet[s:{_List...}] := Flatten[(ConfigurationSet[s, #1] & ) /@ Range[Length[Flatten[s, 1]]], 1];

ConfigurationSet[n:{_Integer...}] := Flatten[(ConfigurationSet[n, #1] & ) /@ Range[Plus @@ n], 1];

End[];
EndPackage[];

