(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     17446,        474]*)
(*NotebookOutlinePosition[     18329,        502]*)
(*  CellTagsIndexPosition[     18285,        498]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Derivation of the Griffiths-Tavare algorithm", "SubsectionIcon"],

Cell["\<\
\tSuppose that a configuration of mutations is represented by a \
matrix:\
\>", "Text"],

Cell[BoxData[
    FormBox[
      TagBox[
        RowBox[{"(", GridBox[{
              {" ", "1", "2", "3", "4", "5", "6", "7", "8", "9"},
              {"a", "0", "0", "0", "1", "1", "0", "1", "0", "0"},
              {"b", "0", "0", "0", "1", "1", "0", "0", "1", "1"},
              {"c", "1", "1", "1", "0", "0", "1", "0", "0", "0"},
              {"d", "1", "1", "1", "0", "0", "0", "0", "0", "0"},
              {"e", "0", "0", "0", "0", "0", "0", "0", "0", "0"}
              }], ")"}],
        (MatrixForm[ #]&)], TextForm]], "Text"],

Cell["This configuration was produced by the genealogy below:", "Text"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.166667 0.166667 0.103006 0.103006 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.41667 .20601 m
.33333 .10301 L
s
.41667 .20601 m
.5 .10301 L
s
.75 .20601 m
.66667 .10301 L
s
.75 .20601 m
.83333 .10301 L
s
.58333 .30902 m
.41667 .20601 L
s
.58333 .30902 m
.75 .20601 L
s
.5 .41202 m
.16667 .10301 L
s
.5 .41202 m
.58333 .30902 L
s
.5 .51503 m
.5 .41202 L
s
[(1)] .38333 .22661 0 0 Mshowa
[(2)] .71667 .22661 0 0 Mshowa
[(3)] .55 .32962 0 0 Mshowa
[(4)] .46667 .43262 0 0 Mshowa
[(5)] .46667 .53563 0 0 Mshowa
gsave
.16667 .0824 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
63.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
gsave
.33333 .0824 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
63.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
gsave
.5 .0824 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
63.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
gsave
.66667 .0824 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
63.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(a) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
gsave
.83333 .0824 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
63.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(b) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[369]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00
ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00;goo1000:goo0`00;Goo1@00:Woo1@00
:Woo1000<7oo000^Ool00`00Oomoo`0/Ool01@00Oomoogoo0000:goo00D007ooOomoo`0002]oo`04
001oogoo000[Ool01@00Oomoogoo0000;goo000^Ool5000ZOol00`00Oomoo`0]Ool01@00Oomoogoo
0000:goo1000:goo00D007ooOomoo`0002moo`00;Woo00D007ooOomoo`0002Yoo`05001oogooOol0
000[Ool01@00Oomoogoo0000;Woo00<007ooOol0:Goo00D007ooOomoo`0002moo`00;goo0`00;7oo
1000;7oo1000;7oo0`00:goo1000<7oo002AOol00`00Oomoo`1HOol00`00Oomoo`0aOol0091oo`80
05Uoo`8003=oo`00ogoo8Goo000`Ool2000]Ool00`00Oomoo`0]Ool00`00Oomoo`0]Ool00`00Oomo
o`0/Ool00`00Oomoo`0_Ool0039oo`03001oogoo02Yoo`03001oogoo02eoo`03001oogoo02eoo`03
001oogoo02aoo`03001oogoo02moo`00<goo00<007ooOol0:Woo00<007ooOol0:goo00<007ooOol0
;goo00<007ooOol0:Woo00<007ooOol0<7oo000dOol00`00Oomoo`0ZOol00`00Oomoo`0YOol00`00
Oomoo`0aOol00`00Oomoo`0XOol00`00Oomoo`0aOol003Eoo`03001oogoo02Yoo`03001oogoo02Mo
o`03001oogoo03=oo`03001oogoo02Ioo`03001oogoo039oo`00=Woo00<007ooOol0:Woo00<007oo
Ool09Goo00<007ooOol0=Goo00<007ooOol09Goo00<007ooOol0<Woo000gOol00`00Oomoo`0YOol0
0`00Oomoo`0UOol00`00Oomoo`0eOol00`00Oomoo`0TOol00`00Oomoo`0cOol003Qoo`03001oogoo
02Uoo`03001oogoo02=oo`03001oogoo03Moo`03001oogoo029oo`03001oogoo03Aoo`00>Goo00<0
07ooOol0:Goo00<007ooOol08Goo00<007ooOol0>Goo00<007ooOol087oo00<007ooOol0=Goo000j
Ool00`00Oomoo`0YOol00`00Oomoo`0OOol00`00Oomoo`0kOol00`00Oomoo`0NOol00`00Oomoo`0f
Ool003]oo`03001oogoo02Uoo`03001oogoo01eoo`03001oogoo03eoo`03001oogoo01eoo`03001o
ogoo03Ioo`00?7oo00<007ooOol0:7oo00<007ooOol07Goo00<007ooOol0?Goo00<007ooOol077oo
00<007ooOol0=goo000mOol00`00Oomoo`0XOol00`00Oomoo`0KOol00`00Oomoo`0oOol00`00Oomo
o`0JOol00`00Oomoo`0hOol003ioo`03001oogoo02Qoo`03001oogoo01Uoo`03001oogoo045oo`03
001oogoo01Qoo`03001oogoo03Uoo`00?goo00<007ooOol0:7oo00<007ooOol05goo00<007ooOol0
@goo00<007ooOol05goo00<007ooOol0>Goo0010Ool2000YOol00`00Oomoo`0EOol00`00Oomoo`15
Ool00`00Oomoo`0EOol00`00Oomoo`0jOol0049oo`03001oogoo02Ioo`03001oogoo01Eoo`03001o
ogoo04Eoo`03001oogoo01Aoo`03001oogoo03]oo`00@goo00<007ooOol09Woo00<007ooOol04goo
00<007ooOol0Agoo00<007ooOol04Woo00<007ooOol0?7oo0014Ool00`00Oomoo`0VOol00`00Oomo
o`0AOol00`00Oomoo`19Ool00`00Oomoo`0AOol00`00Oomoo`0lOol004Eoo`03001oogoo02Ioo`03
001oogoo00moo`03001oogoo04]oo`03001oogoo00moo`03001oogoo03eoo`00AWoo00<007ooOol0
9Woo00<007ooOol03Goo00<007ooOol0CGoo00<007ooOol03Goo00<007ooOol0?Woo0017Ool00`00
Oomoo`0UOol00`00Oomoo`0=Ool00`00Oomoo`1=Ool00`00Oomoo`0<Ool00`00Oomoo`0oOol004Qo
o`03001oogoo02Eoo`03001oogoo00]oo`03001oogoo04moo`03001oogoo00]oo`03001oogoo03mo
o`00BGoo00<007ooOol09Goo00<007ooOol02Goo00<007ooOol0DGoo00<007ooOol02Goo00<007oo
Ool0@7oo001:Ool00`00Oomoo`0UOol00`00Oomoo`07Ool00`00Oomoo`1COol00`00Oomoo`07Ool0
0`00Oomoo`11Ool004]oo`03001oogoo02Eoo`03001oogoo00Eoo`03001oogoo05Eoo`03001oogoo
00Eoo`03001oogoo049oo`00C7oo00<007ooOol097oo00<007ooOol01Goo00<007ooOol0EGoo00<0
07ooOol017oo00<007ooOol0@goo001=Ool00`00Oomoo`0TOol00`00Oomoo`03Ool00`00Oomoo`1G
Ool00`00Oomoo`03Ool00`00Oomoo`13Ool004ioo`03001oogoo02Aoo`05001oogooOol0001KOol0
1@00Oomoogoo0000AWoo001?Ool00`00Oomoo`0TOol00`00Ool0001MOol00`00Ool00017Ool0051o
o`8002Eoo`8005eoo`8004Qoo`00DWoo00<007ooOol097oo00<007ooOol0FGoo00<007ooOol0B7oo
001COol00`00Oomoo`0TOol2001GOol2001;Ool005Aoo`03001oogoo01Eoo`<000eoo`8004eoo`@0
009oo`8004eoo`00EGoo00<007ooOol05Goo00<007ooOol03Woo00<007ooOol0Bgoo00D007ooOomo
o`0004moo`00EWoo00<007ooOol057oo00<007ooOol03goo0P00C7oo0`00D7oo001GOol00`00Oomo
o`0COol00`00Oomoo`0AOol20019Ool3001AOol005Qoo`03001oogoo019oo`03001oogoo01=oo`03
001oogoo04Eoo`04001oogoo001AOol005Uoo`03001oogoo011oo`8001Ioo`8004=oo`800003Ool0
0000059oo`00FWoo00<007ooOol0:Goo0P00?goo0P00Egoo001KOol00`00Oomoo`0ZOol00`00Oomo
o`0kOol00`00Oomoo`1GOol005aoo`03001oogoo02Yoo`8003Uoo`8005Yoo`00GGoo00<007ooOol0
:goo0P00=Goo0P00G7oo001NOol00`00Oomoo`0/Ool00`00Oomoo`0aOol00`00Oomoo`1LOol005mo
o`8002eoo`8002moo`8005moo`00HGoo00<007ooOol0;7oo0P00:goo0P00HGoo001ROol00`00Oomo
o`0]Ool00`00Oomoo`0WOol00`00Oomoo`1QOol006=oo`03001oogoo02eoo`8002Eoo`8006Aoo`00
I7oo00<007ooOol0;Woo0P008Goo0P00IWoo001UOol00`00Oomoo`0_Ool00`00Oomoo`0MOol00`00
Oomoo`1VOol006Ioo`03001oogoo02moo`8001]oo`8006Uoo`00Igoo00<007ooOol0<7oo0P005goo
0P00Jgoo001XOol00`00Oomoo`0aOol00`00Oomoo`0COol00`00Oomoo`1[Ool006Uoo`03001oogoo
035oo`80015oo`8006ioo`00JWoo00<007ooOol0<Woo0P003Goo0P00L7oo001[Ool00`00Oomoo`0c
Ool00`00Oomoo`09Ool00`00Oomoo`1`Ool006aoo`03001oogoo03=oo`8000Moo`8007=oo`00KGoo
00<007ooOol0=7oo0P000goo0P00MGoo001^Ool00`00Oomoo`0eOol00`00Ool0001gOol006moo`80
03Ioo`03001oogoo07Ioo`00LGoo00<007ooOol0<goo00<007ooOol0MWoo001bOol00`00Oomoo`0a
Ool00`00Oomoo`1gOol007=oo`03001oogoo02moo`03001oogoo07Qoo`00M7oo00<007ooOol097oo
0`001Woo00<007ooOol0NGoo001eOol00`00Oomoo`0VOol00`00Oomoo`02Ool00`00Oomoo`1jOol0
07Ioo`03001oogoo02Eoo`03001oogoo009oo`03001oogoo07Yoo`00Mgoo00<007ooOol08Woo0P00
17oo00<007ooOol0Ngoo001hOol00`00Oomoo`0SOol01000Oomoo`00OWoo001iOol00`00Oomoo`0O
Ool30002Ool00`00Oomoo`1mOol007Yoo`03001oogoo029oo`03001oogoo07ioo`00Ngoo00<007oo
Ool08Goo00<007ooOol0OWoo001lOol00`00Oomoo`0OOol00`00Oomoo`1oOol007eoo`03001oogoo
01eoo`03001oogoo081oo`00OWoo00<007ooOol06goo00<007ooOol0PGoo001oOol2000JOol00`00
Oomoo`22Ool0085oo`03001oogoo01Moo`03001oogoo089oo`00PWoo00<007ooOol05Goo00<007oo
Ool0Pgoo0023Ool00`00Oomoo`0COol00`00Oomoo`24Ool008Aoo`03001oogoo015oo`03001oogoo
08Eoo`00QGoo00<007ooOol03goo00<007ooOol0QWoo0026Ool00`00Oomoo`0>Ool00`00Oomoo`26
Ool008Moo`03001oogoo00aoo`03001oogoo08Moo`00R7oo00<007ooOol02Woo00<007ooOol0R7oo
0029Ool00`00Oomoo`08Ool00`00Oomoo`29Ool008Yoo`03001oogoo00Ioo`03001oogoo08Yoo`00
Rgoo00<007ooOol01Goo00<007ooOol0RWoo002<Ool00`00Oomoo`03Ool00`00Oomoo`2;Ool008eo
o`05001oogooOol0002>Ool008ioo`03001oo`0008moo`00Sgoo00<007ooOol0SWoo002?Ool00`00
Oomoo`2>Ool008moo`03001oogoo08ioo`00Q7oo0`0027oo00<007ooOol0SWoo0025Ool00`00Oomo
o`07Ool00`00Oomoo`2>Ool008=oo`@000Qoo`03001oogoo08ioo`00Pgoo00<007oo00002Goo00<0
07ooOol0SWoo0023Ool00`00Ool00009Ool00`00Oomoo`2>Ool008Aoo`8000Uoo`03001oogoo08io
o`00Sgoo00<007ooOol0SWoo002?Ool00`00Oomoo`2>Ool008moo`03001oogoo08ioo`00Sgoo00<0
07ooOol0SWoo002?Ool00`00Oomoo`2>Ool008moo`03001oogoo08ioo`00Sgoo00<007ooOol0SWoo
002?Ool00`00Oomoo`2>Ool008moo`03001oogoo08ioo`00Sgoo00<007ooOol0SWoo002?Ool00`00
Oomoo`2>Ool008moo`03001oogoo08ioo`00Sgoo00<007ooOol0SWoo002?Ool00`00Oomoo`2>Ool0
08moo`03001oogoo08ioo`00Sgoo00<007ooOol0SWoo002?Ool00`00Oomoo`2>Ool008moo`03001o
ogoo08ioo`00Sgoo00<007ooOol0SWoo002?Ool00`00Oomoo`2>Ool008moo`03001oogoo08ioo`00
ogoo8Goo003oOolQOol00?moob5oo`00Pgoo0`00VWoo0026Ool00`00Oomoo`2GOol008Ioo`03001o
ogoo09Moo`00Pgoo0`00VWoo0023Ool00`00Oomoo`2JOol008=oo`@009Uoo`00ogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00
ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.00744, -1.00003, 
  0.0209577, 0.0339103}}],

Cell[TextData[{
  "This rooted genealogy cannot be fully reconstructed, because there were no \
mutations along the branchs leading down to ",
  Cell[BoxData[
      \(TraditionalForm\`e\)]],
  " and to 3.   "
}], "Text"],

Cell[TextData[{
  "\tThe Griffiths-Tavare algorithm works back along the genealogy, until the \
most recent mutation or coalescence.  Sites can only lose a mutation if that \
mutation is represented only in one leaf; let there be J such sites.  (In the \
example above, sites 6,7,8,9 are singletons; J=4).  A pair of lineages can \
only coalesce if they carry the same set of mutations; let there be K such \
pairs.  In the example above, there are no such possibilities: K=0.  With ",
  Cell[BoxData[
      \(TraditionalForm\`n\)]],
  " lineages, the rate of events is ",
  Cell[BoxData[
      \(TraditionalForm
      \`\[Lambda]\_n = n\[VeryThinSpace]\[Theta]\/2 + \(n(n - 1)\)\/2\)]],
  "; a sum is taken over these events, with the appropriate probability, and \
expressed in terms of the probabilities of the simpler configurations \
generated by loss of a mutation or coalescence.  This sum over J+K possible \
previous configurations is wighted by the overall weight ",
  Cell[BoxData[
      \(TraditionalForm\`1\/\[Lambda]\)]],
  ":"
}], "Text"],

Cell[BoxData[
    \(TextForm
    \`P[S]\  = 
      \(\(1\/\[Lambda]\_n\) 
          \((\ \[Sum]\+\(j = 1\)\%J\( \[Theta]\/2\) P[\(S\_j\%*\)]\  + \ 
              \[Sum]\+\(k = 1\)\%K P[\(S\_k\%*\)]\ )\)\ \ where\ 
          \[Lambda]\_n = 
        n\[VeryThinSpace]\[Theta]\/2 + \(n \((n - 1)\)\)\/2\), \ 
    \(S\_j\%*\) represents\ deletion\ of\ the\ j' th\ singleton\ site\ from\ 
      S, \ and\ \(S\_k\%*\) the\ coalescence\ of\ the\ k' th\ \(pair . \)\)], 
  "NumberedEquation"],

Cell[TextData[{
  "This algorithm becomes extremely slow for large numbers of mutations and \
lineages.  A Monte Carlo estimate can be made by sampling possible paths back \
through the genealogy, with relative probability ",
  Cell[BoxData[
      \(TraditionalForm\`\[Phi]\/2\)]],
  " for possible losses of mutations, and 1 for possible coalescences:"
}], "Text"],

Cell[BoxData[
    \(TextForm
    \`P[S]\  = 
      \(\((\[Theta]\/\[Phi])\)\^m\) 
        E[\[Product]\(1\/\[Lambda]\_i\) 
              \((\(\[Phi]\/2\) \(J\_i\%*\) + \(K\_i\%*\))\)]\ \ where\ \ 
        \(J\_i\%*\) is\ the\ number\ of\ possible\ losses\ of\ mutations, \ 
    \(K\_i\%*\)\ the\ number\ of\ possible\ coalescences, \ 
    m\ the\ number\ of\ segregating\ sites, \ 
    and\ i\ the\ current\ #\ of\ lineages\)], "NumberedEquation"],

Cell[TextData[
"The parameter \[Phi] can be chosen arbitrarily: it should take a value which \
minimises the variance of the estimator.  Note that while  \[Phi]=\[Theta] \
seems natural, it does not give an optimal estimator."], "Text"]
}, Open  ]]
},
FrontEndVersion->"4.0 for Macintosh",
ScreenRectangle->{{0, 1024}, {0, 748}},
WindowSize->{520, 653},
WindowMargins->{{Automatic, -8}, {Automatic, -1}},
StyleDefinitions -> "HelpBrowser.nb",
MacintoshSystemPageSetup->"\<\
00`0001804P000000_02@?o/onh3109BI085:0?l0@00005X0FP000003[0;@001
0000I00100000@0000000BL?0040000000000000000000000000000000000?nL
ojH?50^J00P100000000000000000000\>"
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 70, 0, 36, "SubsectionIcon"],
Cell[1812, 53, 97, 3, 22, "Text"],
Cell[1912, 58, 539, 11, 101, "Text"],
Cell[2454, 71, 71, 0, 22, "Text"],
Cell[2528, 73, 12079, 331, 184, 4800, 236, "GraphicsData", "PostScript", \
"Graphics"],
Cell[14610, 406, 220, 6, 36, "Text"],
Cell[14833, 414, 1053, 20, 148, "Text"],
Cell[15889, 436, 484, 10, 83, "NumberedEquation"],
Cell[16376, 448, 365, 7, 78, "Text"],
Cell[16744, 457, 447, 9, 85, "NumberedEquation"],
Cell[17194, 468, 236, 3, 36, "Text"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

