(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    101717,       2455]*)
(*NotebookOutlinePosition[    103212,       2501]*)
(*  CellTagsIndexPosition[    103018,       2492]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Estimators of recombination rate", "SubsectionIcon"],

Cell[TextData[{
  StyleBox["B",
    FontFamily->"Geneva"],
  StyleBox["ROWN",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", C. J., E. C. G",
    FontFamily->"Geneva"],
  StyleBox["ARNER",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", A. K. D",
    FontFamily->"Geneva"],
  StyleBox["UNKER",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[" and P. J",
    FontFamily->"Geneva"],
  StyleBox["OYCE",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", 2001 The power to detect recombination using the coalescent. \
Molecular Biology and Evolution ",
    FontFamily->"Geneva"],
  StyleBox["18:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 1421-1424.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[CellGroupData[{

Cell[TextData[StyleBox["FEARNHEAD, P., and P. DONNELLY, 2001 Estimating \
recombination rates from population genetic data. Genetics 159: 1299-1318.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[{
  "Present an efficient importance sampling method, which is orders of \
magnitude more efficient than the MCMC method of Kuhner et al. (",
  ButtonBox["2000",
    ButtonData:>"Kuhner et al 2000",
    ButtonStyle->"AddOnsLink"],
  ").  The proposal distribution is an approximation to the optimal \
distribution, given some \[Rho], \[Theta].  The likelihood surface around \
some \[Rho], \[Theta] is constructed by using a proposal density calculated \
for those \[Rho], \[Theta], and then repeating for a grid of \[Rho], \
\[Theta].  (\"bridge sampling\").  "
}], "Text"]
}, Closed]],

Cell[TextData[{
  StyleBox["G",
    FontFamily->"Geneva"],
  StyleBox["RASSLY",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", N. C., and E. C. H",
    FontFamily->"Geneva"],
  StyleBox["OLMES",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", 1997 A likelihood method for the detection of selection and \
recombination using nucleotide sequences. Molecular Biology and Evolution ",
    FontFamily->"Geneva"],
  StyleBox["14:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 239-247.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[{
  StyleBox["H",
    FontFamily->"Geneva"],
  StyleBox["EY",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", J., and J. W",
    FontFamily->"Geneva"],
  StyleBox["AKELEY",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", 1997 A coalescent estimator of the population recombination \
rate. Genetics ",
    FontFamily->"Geneva"],
  StyleBox["145:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 833-846.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[{
  StyleBox["K",
    FontFamily->"Geneva"],
  StyleBox["UHNER",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", M. K., J. Y",
    FontFamily->"Geneva"],
  StyleBox["AMATO",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[" and J. F",
    FontFamily->"Geneva"],
  StyleBox["ELSENSTEIN",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", 2000 Maximum likelihood estimation of recombination rates from \
population data. Genetics ",
    FontFamily->"Geneva"],
  StyleBox["156:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 1393-401.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain",
  CellTags->"Kuhner et al 2000"],

Cell[TextData[{
  StyleBox["S",
    FontFamily->"Geneva"],
  StyleBox["TRIMMER",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", K., C. W",
    FontFamily->"Geneva"],
  StyleBox["IUF",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[" and V. M",
    FontFamily->"Geneva"],
  StyleBox["OULTON",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", 2001 Recombination analysis using directed graphical models. \
Molecular Biology and Evolution ",
    FontFamily->"Geneva"],
  StyleBox["18:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 97-99.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[{
  StyleBox["W",
    FontFamily->"Geneva"],
  StyleBox["ALL",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", J. D., 2000 A comparison of estimators of the population \
recombination rate. Molecular Biology and Evolution ",
    FontFamily->"Geneva"],
  StyleBox["17:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 156-163.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[{
  StyleBox["W",
    FontFamily->"Geneva"],
  StyleBox["IUF",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", C., T. C",
    FontFamily->"Geneva"],
  StyleBox["HRISTENSEN",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[" and J. H",
    FontFamily->"Geneva"],
  StyleBox["EIN",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", 2001 A simulation study of the reliability of recombination \
detection methods. Molecular Biology and Evolution ",
    FontFamily->"Geneva"],
  StyleBox["18:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 1929-1939.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell["Junction theory & older literature", "SubsectionIcon"],

Cell[TextData[{
  StyleBox["C",
    FontFamily->"Geneva"],
  StyleBox["LARK",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", A. G., 1999 The size distribution of homozygous segments in the \
human genome. American Journal of Human Genetics ",
    FontFamily->"Geneva"],
  StyleBox["65:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 1489-1492.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["BICKEBOLLER, H., and E. A. THOMPSON, 1996 \
Distribution of genome shared ibd by half-sibs: approximation by the Poisson \
clumping heuristic. Theoretical Population Biology 50: 66-90.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["BICKEBOLLER, H., and E. A. THOMPSON, 1996 The \
probability distribution of the amount of an individual's genome surviving to \
the following generation. Genetics 143: 1043-1049.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["COCKERHAM, C. C., and B. S. WEIR, 1983 Variance of \
Actual Inbreeding. Theoretical Population Biology 23: 85-109.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["DONNELLY, K. P., 1983 The probability that related \
individuals share some section of genome identical by descent. Theor. Pop. \
Biol. 23: 34-63.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["FISHER, R. A., 1953 A fuller theory of 'junctions' in \
inbreeding. Heredity  8: 187-198.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["FRANKLIN, I. R., 1977 The distribution of the \
proportion of the genome which is homozygous by descent in inbred \
individuals. Theor.Pop.Biol.  11: 60-80.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["KIMURA, M., 1950 The theory of the chromosome \
substitution between two different species. Cytologia  16: 281-294.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["LESLIE, J. F., 1981 Inbreeding for Isogeneity by \
Backcrossing to a Fixed Parent in Haploid and Diploid Eukaryotes. Genetical \
Research 37: 239-252.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["NAVEIRA, H., and A. BARBADILLA, 1992 The theoretical \
distribution of lengths of intact chromosome segments around a locus held \
heterozygous with backcrossing in a diploid species. Genetics  130: 205-209.",
  
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["OIKAWA, T., K. SATO and S. TAKAHASHI, 1999 Variance \
of actual inbreeding derived from the number and variance of chromosome \
segment. Journal of Animal Breeding and Genetics-Zeitschrift Fur Tierzuchtung \
Und Zuchtungsbiologie 116: 467-473.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["PLANCHET, 1972 A continuous model for the study of \
linkage in a random-mating population. Theor.Pop.Biol. 5: 251-257.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["RASMUSON, M., 1993 Variation in Genetic Identity \
within Kinships. Heredity 70: 266-268.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["ROBERTSON, A., 1977 Artificial selection with a large \
number of linked loci, pp. 307-322 in International Conference on \
Quantitative Genetics, edited by E. Pollak, O. Kempthorne and T. B. Bailey. \
Iowa State University Press, Ames, Iowa.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["ROBERTSON, A., and W. G. HILL, 1983 Population and \
quantitative genetics of many linked loci in finite populations. Proceedings \
of the Royal Society (London) B 219: 253-264.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["SCHORK, N. J., B. THIEL and P. ST JEAN, 1998 Linkage \
analysis, kinship, and the short-term evolution of chromosomes. Journal of \
Experimental Zoology 282: 133-149.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["SLATKIN, M., 1972 On treating the chromosome as the \
unit of selection. Genetics  72: 157-168.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["STAM, P., 1980 The distribution of the fraction of \
the genome identical by descent in finite random mating populations. \
Genetical Research 35: 131-155.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["STAM, P., and A. C. ZEVEN, 1981 The Theoretical \
Proportion of the Donor Genome in near-Isogenic Lines of Self-Fertilizers \
Bred by Backcrossing. Euphytica 30: 227-238.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["STEFANOV, V. T., 2000 Distribution of genome shared \
identical by descent by two individuals in grandparent-type relationship. \
Genetics 156: 1403-10.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["SVED, J. A., 1971 Linkage disequilibrium and \
homozygosity of chromosome segments in finite populations. Theor.Pop.Biol. 2: \
125-141.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell["Biparental models", "SubsectionIcon"],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["C",
    FontFamily->"Geneva"],
  StyleBox["HANG",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", J. T., 1999 Recent common ancestors of all present-day \
individuals. Advances in Applied Probability ",
    FontFamily->"Geneva"],
  StyleBox["31:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 1002-1026.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell["\<\
An interesting paper, followed by comments from \
Ewens/Donnelly/Wiuf&Hein...\
\>", "Text"],

Cell[TextData[{
  "Considers the two-parent Wright-Fisher model, and cites previous work on \
this by Mohle & Kammerle.  The key result is that there will be a common \
ancestor to all present day individuals about ",
  Cell[BoxData[
      \(TraditionalForm\`Log\_2[N]\)]],
  " generations back (which follows ratther obviously from the ",
  Cell[BoxData[
      \(TraditionalForm\`2\^t\)]],
  " inflation of # of ancestors with biparental inheritance).  Shortly before \
that (about ",
  Cell[BoxData[
      \(TraditionalForm\`1.77  Log\_2[N]\)]],
  " generations back), there will be a generation in which every individual \
is either an ancestor of no-one, or of the whole population"
}], "Text"],

Cell["\<\
Discusses the (restricted) conditions in which a 'species tree' is \
well defined.\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["D",
    FontFamily->"Geneva"],
  StyleBox["ERRIDA",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", B., S. C. M",
    FontFamily->"Geneva"],
  StyleBox["ANRUBIA",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[" and D. H. Z",
    FontFamily->"Geneva"],
  StyleBox["ANETTE",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", 1999. Statistical properties of genealogical trees. Physical \
Review Letters ",
    FontFamily->"Geneva"],
  StyleBox["82:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 1987-1990.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell["\<\
Concentrates on the distribution of the # of repetitions of an \
ancestor in the biparental genealogy - as an example, Edward III.
Consider H[r,n], the distribution of contributions of ancestors, r, n \
generations back.  We have:\
\>", "Text"],

Cell[BoxData[
    \(\[Sum]\+r H = \ 1, \ \[Sum]\+r r\ H = \ 2\^n\)], "NumberedEquation"],

Cell[BoxData[Cell[GraphicsData["PICT", "\<\
DD@0@@5h0Al2]@0A0_l<0?ooool1N000044000:e00017`000000000N00402P11
0GP17`:e09X0003oQ?@0@@5h0Al2]@0000@0000004P000180000400P00<02000
000005ZX2OPOY0110GP17`:e0441N04O0[D0000@POn1oh7oPOn1oh7oPOo:o`0@
POn1oh7oPOn1oh7oPOo:o`0QbOl2R9WMPOn1olOo0XRIgH7oPOo7o`:8VMf1oh7o
0Ooo0279o`:8ohR1oh7oaol2R?n8POn1olOo0XSoR87oPOl1ool08LWo0XSoR87o
POo7o`:8ohR1oh7oaol2R?n8POn1o`7oo`0ld_l1gHSno`JZ^lcoVHSMPOn1om3o
0Mf8o_l6Z[_<oiV8gH7oPOo@o`7MR?ko1ZZkc?nIR=f1oh7o0Ooo02oBo`O<A?oo
VJ[oEH7oPOo<o`O<A?ooVJ[oEH7oPOo<o`O<A?ooVJ[oEH7oPOoko`0_dOl7A?oo
I^koR=f1oh7oc?l7A?ooI^koR=f1oh7oc?l7A?ooI^koR=f1oh7oo?l0=M7o1dCo
odCoohRkmon108h0bOl7A?ooA?ooR;_goh40SP39o`M4oom4oon8^oOoP@2>0?Wo
0L7Ao`M4oom4oon8^oOo003`o`00mol00?[o003mo`00oOl00?ko003no`H0ool0
ool0l?l00?So003jo`00o?l00?go003no`T0ool0ool0ool0l?l00?Oo003ko`00
o?l00?go003no`<0ool0o_l20?l0l?l00?Oo003jo`00oOl00?go003no`00o_l6
0?oo0?oo0<Wo1dCoodCoohRkmol00?3o003go`00n_l00?go003mo`00o_l00?ko
1P3oo`3oo`3`o`00n?l00?[o003lo`00oOl00?ko2@3oo`3oo`3oo`3`o`00mol0
0?_o003lo`00oOl00?ko0`3oo`3no`80o`3`o`00mol00?[o003mo`00oOl00?ko
003no`H0ool0ool0bOl7A?ooA?ooR;_go`00l?l00?Oo003jo`00oOl00?go003n
o`00o_l60?oo0?oo0?3o003ho`00n_l00?co003mo`00o_l90?oo0?oo0?oo0?3o
003go`00nol00?co003mo`00o_l30?oo0?ko0P3o0?3o003go`00n_l00?go003m
o`00o_l00?ko1P3oo`3oo`3io`1LdOl6A?ooR=goEOKo0035o`00a_l00<Ko0035
o`00bOl6A?ooR=goEOKo0035o`00a_l00<Ko0035o`00bOl6A?ooR=goEOKo0035
o`00a_l00<Ko0035o`00nOl0@M;o1k/RgOoMR>j8m_l0087oT?l00<[o1k/RgOoM
R>j8m_l0087oT?l00<[o1k/RgOoMR>j8m_l0087oT?l00?Wo02o=o`7^c?Go0021
oi3o0035o`7^c?Go0021oi3o0035o`7^c?Go0021oi3o003io`0P_ol0087oT?l0
0;Oo0021oi3o002go`00POn@o`00nOl08;oo0021oi3o002go`00POn@o`00]ol0
087oT?l00?Wo022oo`00POn@o`00]ol0087oT?l00;Oo0021oi3o003io`0P_ol0
087oT?l00;Oo0021oi3o002go`00POn@o`00nOl08;oo0021oi3o002go`00POn@
o`00]ol0087oT?l00?Wo022oo`00POn@o`00]ol0087oT?l00;Oo0021oi3o003i
o`0P_ol0087oT?l00;Oo0021oi3o002go`00POn@o`00nOl08;oo0021oi3o002g
o`00POn@o`00]ol0087oT?l00?Wo022oo`00POn@o`00]ol0087oT?l00;Oo0021
oi3o003io`0P_ol0087oT?l00;Oo0021oi3o002go`00POn@o`00nOl08;oooP21
oi;o002gooh0POnBo`00]oon087oT_l00?Wo02boo`80ooon087oUOl00;Oo0P3o
ooh0POnEo`00]ol20?oooP21oiGo003io`0/_ol00?cooP21oiSo002go`00o?on
087oV?l00;Oo003looh0POnHo`00nOl0;;oo003iood0POnLo`00]ol00?Woo@21
oico002go`00nOom087oW?l00?Wo02boooh0moon087oWol00;OooP3gooh0POnO
o`00]oon0?OooP21oioo003io`0e_ol30?oo0?GooP21oj;o002go`<0ool0mOon
087oX_l00;Oo0`3oo`3eooh0POnRo`00nOl0>;oo003no`00m?on087oY?l00;Oo
003no`00m?on087oY?l00;Oo003no`00m?on087oY?l00?Wo03^oo`00oOl00?;o
0@00POnVo`00]ol00?go003bo`40087oY_l00;Oo003mo`00l_l10021ojKo003i
o`0__ooc0?So0@00POnXo`00]ooc0?So0@00POnXo`00]ooc0?So0@00POnXo`00
nOl0>;oo003ko`00o?o`087o[Ol00;Oo003ko`00o?o`087o[Ol00;Oo003ko`00
o?o`087o[Ol00?Wo04Zoo`00n_l1003bo`400?konP21okCo002go`00n_l1003b
o`400?konP21okCo002go`00n_l1003bo`400?konP21okCo003io`17_ol00?So
003ao`400?[oo021okSo002go`00n?l00?7o0@00n_ol087o^?l00;Oo003ho`00
lOl1003joo`0POnho`00nOl0Akoo003go`00l?l1003hood0POnko`00]ol00?Oo
003`o`400?Soo@21ok_o002go`00mol00?3o0@00n?om087o^ol00?Wo04Boo`00
m_l00?3o003dooh0POnno`00]ol00?Ko003`o`00m?on087o__l00;Oo003fo`00
l?l00?CooP21okko003io`14_ol00?Go003`o`00loom087o`Ol00;Oo003eo`00
l?l00??oo@21ol7o002go`00mOl00?3o003cood0POo1o`00nOl0B[oo003do`40
0?7o003`o`40087o`ol00;Oo003do`400?7o003`o`40087o`ol00;Oo003do`40
0?7o003`o`40087o`ol00?Wo04Boo`00l_l00?7o003`ooh0POo5o`00]ol00?;o
003ao`00l?on087oaOl00;Oo003bo`00lOl00?3ooP21olGo003io`17_ol00?7o
003ao`00k_l10021olOo002go`00lOl00?7o003^o`40087oaol00;Oo003ao`00
lOl00>ko0@00POo7o`00nOl0B[oo003`o`00lOl1003_o`40087ob?l00;Oo003`
o`00lOl1003_o`40087ob?l00;Oo003`o`00lOl1003_o`40087ob?l00?Wo04Zo
o`00l?l1003`o`00k_l10021ol[o002go`00l?l1003`o`00k_l10021ol[o002g
o`00l?l1003`o`00k_l10021ol[o003io`17_ol00>ko003ao`00kOl10021ol_o
002go`00k_l00?7o003]o`40087obol00;Oo003^o`00lOl00>go0@00POo;o`00
nOl0D;oo003^o`00l?l00?kol`3mo`00POo<o`00]ol00>ko003`o`00o_oc0?go
0021olco002go`00k_l00?3o003noo<0oOl0087oc?l00?Wo03Roo`00k_oZ0?Go
l`21omCo002go`00k_oZ0?Gol`21omCo002go`00k_oZ0?Gol`21omCo003io`1C
_ol00?gol03^o`00k_l1003looX0POoJo`00]ol00?gol03^o`00k_l1003looX0
POoJo`00]ol00?gol03^o`00k_l1003looX0POoJo`00nOl0Dkoon`3bo`00k_l0
0>co0@00n?om087ogOl00;Oon`3bo`00k_l00>co0@00n?om087ogOl00;Oon`3b
o`00k_l00>co0@00n?om087ogOl00?Wo06;=o`:kR:[fo`00k?l00>ko003/o`00
mOol087ohOl00<Go0[^8Z_Ko003/o`00k_l00>co003eoo`0POoQo`00aOl2^hRZ
m_l00>co003^o`00k?l00?Goo021on7o003io`1XcOl2k_nIm_l00>_o003_o`40
0>co0@00loon087ohol00<Go0^koVOKo003[o`00kol1003/o`400??ooP21on?o
0035o`;^oiWfo`00jol00>oo0@00k?l1003cooh0POoSo`00nOl0J<oo0iVIoj[e
o`400>co003]o`00k?l00?7ooP21onGo0037o`>IVOnZmOl1003/o`00kOl00>co
003aooh0POoUo`00aol3VIWoZ_Go0@00k?l00>go003/o`00lOon087oiOl00?Wo
08?Go`J8c?ooc;^Zo_l2VGNZm_l1003[o`00k_l00>_o003`ooh0POoWo`00col6
R<coolbkZ_ko0YUgZ_Ko0@00jol00>ko003[o`00l?on087oiol00<oo1XS<ooo<
^j[no`:IMj[fo`400>_o003^o`00jol00?3ooP21onOo003io`1jf?l8gGNkoomE
ojZIlOl1003Zo`00k_l00>co0@00koon087ojOl00=3o2=eg^oooEOnZVO7o0@00
j_l00>ko003/o`400>oooP21onWo003@o`SMMk_ooeGoZYWao`400>[o003^o`00
k?l1003_ooh0POoYo`00nOl0MmOo1hRkomegoomVlOl20?l0jol00>ko003[o`00
kOon087ojol00<oo1hRkomegoomVlOl20?l0jol00>ko003[o`00kOon087ojol0
0<oo1hRkomegoomVlOl20?l0jol00>ko003[o`00kOon087ojol00?Wo07OGo`N8
^onkR?ooA?7oo@3[o`00k_l00>_o0@00kOl10021onooo@3?o`N8^onkR?ooA?7o
o@3[o`00k_l00>_o0@00kOl10021onooo@3?o`N8^onkR?ooA?7oo@3[o`00k_l0
0>_o0@00kOl10021onooo@3io`1meol7R;_o^hSoodCao`<0ool0j_l00>ko003[
o`00k?l10021ongo003?o`N8^onkR?ooA?7o0`3oo`3Zo`00k_l00>_o003/o`40
087okOl00<oo1hRkok^8oom4lOl30?oo0>[o003^o`00jol00>co0@00POo]o`00
nOl0N]Oo1hRkoomVolb8lOl30?oo0>[o003^o`00j_l00>cooP21onoo003?o`N8
^oooI_o<R?7o0`3oo`3Zo`00k_l00>[o003/ooh0POo_o`00col7R;_oofKoc8Sa
o`<0ool0j_l00>ko003Zo`00k?on087okol00?Wo08?Ho`S^EHSoohS^R=gao`00
o_l00>[o003^o`00jol00>[o0@00POo`o`00d?l8kUF8oon8kXSMlOl00?ko003Z
o`00k_l00>_o003Zo`40087ol?l00=3o2>iER?ooR>j8gO7o003no`00j_l00>ko
003[o`00j_l10021oo3o003io`1Od_l1c>k`o`00o_l00>[o003^o`00j_oU087o
lol00<[o0Lc^l?l00?ko003Zo`00k_l00>[oi@21oo?o003:o`7<k_3o003no`00
j_l00>ko003ZonD0POoco`00nOl0Gkoo003no`00jOl1003_o`00nOoa0>[omP21
oo_o002go`00o_l00>Wo0@00kol00?Wol@3ZooH0POoko`00]ol00?ko003Yo`40
0>oo003ioo40j_of087onol00?Wo06Roo`00oOl00>Wo003aooD0lol00>Wo0@00
n_ok087o0Ol0]ol00?go003Yo`00lOoe0??o003Yo`400?[on`21o`7o0;Oo003m
o`00jOl00?7om@3co`00jOl1003joo/0POl1o`3io`1a_ol00?go003Yo`00oOod
00;oo`3Zo`00jOl1003food0Pol00;Oo003mo`00jOl00?gom002ool0j_l00>Wo
0@00m_om08?o002go`00oOl00>Wo003moo@00_oo0>[o003Yo`400?Koo@23o`00
nOl0IKoo003lo`00l_oc0??o003Zo`00j?l1003dood0Q_l00;Oo003lo`00l_oc
0??o003Zo`00j?l1003dood0Q_l00;Oo003lo`00l_oc0??o003Zo`00j?l1003d
ood0Q_l00?Wo06joo`00o?l20?ool`3io`00k_l00>[o003Wo`00l_on08So002g
o`00o?l20?ool`3io`00k_l00>[o003Wo`00l_on08So002go`00o?l20?ool`3i
o`00k_l00>[o003Wo`00l_on08So003io`1F_oog0>co003^o`00jOl00>So003`
ooh0R_l00;Oom`3/o`00k_l00>Wo003Xo`00l?on08[o002gooL0k?l00>ko003Y
o`00j?l00?3ooP2:o`00nOl0IKoo003ko`00jOl00>ko003Zo`00j?l1003_ooh0
S?l00;Oo003ko`00jOl00>ko003Zo`00j?l1003_ooh0S?l00;Oo003ko`00jOl0
0>ko003Zo`00j?l1003_ooh0S?l00?Wo06Foo`00nol00>Wo003^o`00jOl00>So
0@00k_on08ko002go`00nol00>Wo003^o`00jOl00>So0@00k_on08ko002go`00
nol00>Wo003^o`00jOl00>So0@00k_on08ko003io`1[_ol00?[o003Yo`00k_l0
0>[o0@00j?l1003]o`4008oo002go`00n_l00>Wo003^o`00j_l1003Xo`400>go
0@00Sol00;Oo003jo`00jOl00>ko003Zo`400>So0@00kOl1002?o`00nOl0H[oo
003jo`00jOl00>ko003Yo`00iol00>cooP2Ao`00]ol00?[o003Yo`00k_l00>Wo
003Wo`00k?on097o002go`00n_l00>Wo003^o`00jOl00>Oo003/ooh0TOl00?Wo
06Roo`00nOl00>[o003^o`00jOl00>Oo0@00jol1002Bo`00]ol00?Wo003Zo`00
k_l00>Wo003Wo`400>_o0@00T_l00;Oo003io`00j_l00>ko003Yo`00iol1003[
o`4009;o003io`1X_ol00?Wo003Yo`00k_l00>Wo003Wo`400>_o0@00Tol00;Oo
003io`00jOl00>ko003Yo`00iol1003[o`4009?o002go`00nOl00>Wo003^o`00
jOl00>Oo0@00jol1002Co`00nOl0LKoo003ho`00j_l00>ko003Yo`00i_l00?;o
003jo`4009Co002go`00n?l00>[o003^o`00jOl00>Ko003bo`00n_l1002Do`00
]ol00?So003Zo`00k_l00>Wo003Vo`00l_l00?[o0@00U?l00?Wo05Joo`00n?l0
0>Wo003^o`00jOl00>[og@2Ko`00]ol00?So003Yo`00k_l00>Wo003Zomd0Vol0
0;Oo003ho`00jOl00>ko003Yo`00j_oM09_o003io`26_ol00?So003Yo`00k_l0
0>Wo0@00n?o^0?ko003^o`800?og007o0:?o002go`00n?l00>Wo003^o`00jOl1
003honh0o_l00>ko0P00ooL00Ol0Xol00;Oo003ho`00jOl00>ko003Yo`400?So
kP3no`00k_l2003om`01o`2So`00nOl0OKoo003go`00jOl00>oo003Xo`80ooog
0?;o003Yo`400?Won`2Uo`00]ol00?Oo003Yo`00kol00>So0P3oooL0l_l00>Wo
0@00nOok0:Go002go`00mol00>Wo003_o`00j?l20?oom`3bo`00jOl1003ioo/0
YOl00?Wo07foo`00mol00>Wo003^o`00mOl3003oooD0jOl00>SooP3food0Z?l0
0;Oo003go`00jOl00>ko003eo`<00?oom@3Yo`00j?on0?Koo@2Xo`00]ol00?Oo
003Yo`00k_l00?Go0`00oooe0>Wo003Xooh0m_om0:So003io`20_ol00?Ko003Y
o`00kol00?_omP3jo`00i_l1003Xo`400?Coo02[o`00]ol00?Ko003Yo`00kol0
0?_omP3jo`00i_l1003Xo`400?Coo02[o`00]ol00?Ko003Yo`00kol00?_omP3j
o`00i_l1003Xo`400?Coo02[o`00nOl0M;oo003fo`00jOl00?Com03_o`00i_l1
003Xo`400?;oo@2]o`00]ol00?Ko003Yo`00m?od0>oo003Vo`400>So0@00l_om
0:go002go`00m_l00>Wo003doo@0kol00>Ko0@00j?l1003bood0[Ol00?Wo08Vo
o`00m_l00>Wo0P3oooD01Ooo003o0>Wo0@00i_l00>Oo0@00l?on0:oo002go`00
m_l00>Wo0P3oooD01Ooo003o0>Wo0@00i_l00>Oo0@00l?on0:oo002go`00m_l0
0>Wo0P3oooD01Ooo003o0>Wo0@00i_l00>Oo0@00l?on0:oo003io`1a_ol00?Go
003`ooL0lOl00>So003Vo`400>Oo003^ooh0/Ol00;Oo003eo`00l?og0?7o003X
o`00i_l1003Wo`00k_on0;7o002go`00mOl00?3om`3ao`00j?l00>Ko0@00iol0
0>kooP2ao`00nOl0OKoo003eo`00oOoc0?_o003^o`00jOl00>Go003Wo`400>go
oP2co`00]ol00?Go003moo<0nol00>ko003Yo`00iOl00>Oo0@00kOon0;?o002g
o`00mOl00?gol`3ko`00k_l00>Wo003Uo`00iol1003]ooh0/ol00?Wo07Noo`00
o?oe0>go003^o`00jOl1003Vo`400>Oo0@00kOom0;Go002go`00o?oe0>go003^
o`00jOl1003Vo`400>Oo0@00kOom0;Go002go`00o?oe0>go003^o`00jOl1003V
o`400>Oo0@00kOom0;Go003io`1^_ooj0?[o003Zo`00k_l00>So003Uo`00i_l0
0>_ooP2fo`00]ooj0?[o003Zo`00k_l00>So003Uo`00i_l00>_ooP2fo`00]ooj
0?[o003Zo`00k_l00>So003Uo`00i_l00>_ooP2fo`00nOl0M;oo003co`00j_l0
0>ko003Yo`00iOl1003Wo`400>_ooP2go`00]ol00??o003Zo`00k_l00>Wo003U
o`400>Oo0@00joon0;Oo002go`00lol00>[o003^o`00jOl00>Go0@00iol1003[
ooh0]ol00?Wo07Boo`00lol00>[o003^o`00jOl1003Uo`00i_l1003[ooh0^?l0
0;Oo003co`00j_l00>ko003Yo`400>Go003Vo`400>_ooP2ho`00]ol00??o003Z
o`00k_l00>Wo0@00iOl00>Ko0@00joon0;So003io`26h_l4VFI4Mk_So`00lol0
0>[o003^o`00j?l00>Go003Uo`00j_on0;Wo003Jo`BIITAg^n?o003co`00j_l0
0>ko003Xo`00iOl00>Go003Zooh0^Ol00=[o19UVA7Nkhol00??o003Zo`00k_l0
0>So003Uo`00iOl00>[ooP2io`00nOl0V>Co0^i4I_j80EEVi?l00?;o003Zo`00
k_l00>Wo003Uo`400>Ko0@00jOl1002jo`00g?l2kTAVoXP1EFKTo`00l_l00>[o
003^o`00jOl00>Go0@00i_l1003Yo`400;[o003Lo`;^A6KnR05EI^Co003bo`00
j_l00>ko003Yo`00iOl1003Vo`400>Wo0@00^_l00?Wo08cTo`2Inol1gIWUo`00
l_l00>[o003^o`00j?l00>Go003Uo`00j?l1002ko`00g?l0VO_o0MfIiOl00?;o
003Zo`00k_l00>So003Uo`00iOl00>So0@00^ol00=co09Wko`7MVNGo003bo`00
j_l00>ko003Xo`00iOl00>Go003Xo`400;_o003io`1a_ol00?7o003[o`00k_l0
0>So003Uo`00iOl1003Yooh0_?l00;Oo003ao`00jol00>ko003Xo`00iOl00>Go
0@00jOon0;co002go`00lOl00>_o003^o`00j?l00>Go003Uo`400>WooP2lo`00
nOl0RMgo0hS<R;_Wo`00lOl00>[o003_o`400>Wo003Uo`400>Go003Xooh0_Ol0
0=Go0hS<R;_Wo`00lOl00>[o003_o`400>Wo003Uo`400>Go003Xooh0_Ol00=Go
0hS<R;_Wo`00lOl00>[o003_o`400>Wo003Uo`400>Go003Xooh0_Ol00?Wo08WN
o`C<^iU4^nOo003`o`00jol00>ko003Xo`00iOl00>Go0@00j?on0;ko003Fo`C<
^iU4^nOo003`o`00jol00>ko003Xo`00iOl00>Go0@00j?on0;ko003Fo`C<^iU4
^nOo003`o`00jol00>ko003Xo`00iOl00>Go0@00j?on0;ko003io`2<g_l4kUF8
IZ[Wo`00l?l00>_o003^o`00j?l00>Go0@00iOl00>Oo0@00__l00=Ko1>iER6JZ
iol00?3o003[o`00k_l00>So003Uo`400>Go003Wo`400;ko003Fo`C^EHQVZ^Oo
003`o`00jol00>ko003Xo`00iOl1003Uo`00iol1002no`00nOl0P=ko0>kSo`00
l?l00>[o003_o`00j?l00>Co003Uo`400>Oo0@00_ol00=Ko0>kSo`00l?l00>[o
003_o`00j?l00>Co003Uo`400>Oo0@00_ol00=Ko0>kSo`00l?l00>[o003_o`00
j?l00>Co003Uo`400>Oo0@00_ol00?Wo08oRo`C<EDA4EN?o003`o`400>_o003^
o`00j?l00>Go003To`400>Oo0@00`?l00=[o1<aEA4AEhol00?3o0@00jol00>ko
003Xo`00iOl00>Co0@00iol10030o`00f_l4c5E4A5GSo`00l?l1003[o`00k_l0
0>So003Uo`00i?l1003Wo`400<3o003io`2Nh_l4EGN8R7O`o`6I^oKo003_o`00
jol1003_o`00j?l00>Go0@00iOl1003Wooh0`Ol00=[o15EgR8Qgl?l1VK_fo`00
kol00>_o0@00kol00>So003Uo`400>Go0@00ioon0<7o003Jo`AEMhR8Mo3o0IVk
m_l00>oo003[o`400>oo003Xo`00iOl1003Uo`400>OooP31o`00nOl0Vn;o19VI
^k^IlOl2gIVkm_l00>oo003Zo`00kol00>So003To`00i?l1003Wooh0`_l00=[o
19VI^k^IlOl2gIVkm_l00>oo003Zo`00kol00>So003To`00i?l1003Wooh0`_l0
0=[o19VI^k^IlOl2gIVkm_l00>oo003Zo`00kol00>So003To`00i?l1003Wooh0
`_l00?Wo0:[Ro`14oP00A??o19VIIVJ8m_l00>oo003Zo`00k_l00>Wo0@00iOl1
003Uo`400>Ko0@00`_l00=[o04Cn0014lol4VIUVIXSfo`00kol00>[o003^o`00
jOl1003Uo`400>Go0@00i_l10032o`00f_l0A?h004Cco`BIVFIVR?Ko003_o`00
j_l00>ko003Yo`400>Go0@00iOl1003Vo`400<;o003io`2ch_l0c?ko0<cko`J8
c?ooc;^ZoOl1^k_fo`00k_l00>_o003^o`00j?l00>Co003To`00i_on0<?o003J
o`3<o_l0c?_o1XS<ooo<^j[mo`6k^oKo003^o`00jol00>ko003Xo`00i?l00>Co
003Vooh0`ol00=[o0<cno`3<nol6R<coolbkZ_go0K^km_l00>ko003[o`00k_l0
0>So003To`00i?l00>KooP33o`00nOl0Z]oo0XPRZ_go2=eg^oooEOnZVO7o003^
o`00j_l00>oo003Xo`00i?l00>Co0@00i_l10033o`00eol2R2:ZoOl8gGNkoomE
ojZIlOl00>ko003Zo`00kol00>So003To`00i?l1003Vo`400<?o003Go`:88Z[m
o`SMMk_ooeGoZYWao`00k_l00>[o003_o`00j?l00>Co003To`400>Ko0@00`ol0
0?Wo0:OOo`>IVOo<oOl7R;_ogGOoofKao`00k_l00>[o003_o`00j?l00>Co003S
o`00iOl10034o`00eol3VIWoc?go1hRkomegoomVlOl00>ko003Zo`00kol00>So
003To`00hol00>Go0@00a?l00=Oo0iVIolcmo`N8^ooMMoooI_7o003^o`00j_l0
0>oo003Xo`00i?l00>?o003Uo`400<Co003io`2Zh_l1gNkho`N8^onkR?ooA?7o
o@3ao`00j_l00>oo003Xo`400>Go0@00i?l1003Vo`400<Ooo@3Jo`7Mk_So1hRk
ok^8oom4lOom0?7o003Zo`00kol00>So0@00iOl1003To`400>Ko0@00aoom0=[o
0Mg^n?l7R;_o^hSoodCaood0lOl00>[o003_o`00j?l1003Uo`400>Co0@00i_l1
0037ood0nOl0Y>;o0EFIn?l7R;_o^hSoodCao`00kOl00>[o003_o`00j?l00>Co
003To`400>Go0@00aOl00=[o0EFIn?l7R;_o^hSoodCao`00kOl00>[o003_o`00
j?l00>Co003To`400>Go0@00aOl00=[o0EFIn?l7R;_o^hSoodCao`00kOl00>[o
003_o`00j?l00>Co003To`400>Go0@00aOl00?Wo0:[Ro`BZMk^kVO_o1hRkoomV
olb8lOl00>go003Zo`00kol00>So003To`00hol00>Go0@00aOl00=[o1:Yg^k^I
nol7R;_oofKoc8Sao`00kOl00>[o003_o`00j?l00>Co003So`00iOl10035o`00
f_l4ZWNk^iWko`N8^oooI_o<R?7o003]o`00j_l00>oo003Xo`00i?l00>?o003U
o`400<Go003io`2`h_l0A?h004Clo`S^EHSoohS^R=gao`00kOl00>[o003_o`00
j?l00>Co003So`400>Go0@00a_l00=[o04Cn0014o?l8kUF8oon8kXSMlOl00>go
003Zo`00kol00>So003To`00hol1003Uo`400<Ko003Jo`14oP00A?co2>iER?oo
R>j8gO7o003]o`00j_l00>oo003Xo`00i?l00>?o0@00iOl10036o`00nOl0Y>Co
0^koc?ko0/cogOSo0Lc^l?l00>go003Zo`00kol00>So003To`400>?o003Uooh0
aol00=co0^koc?ko0/cogOSo0Lc^l?l00>go003Zo`00kol00>So003To`400>?o
003Uooh0aol00=co0^koc?ko0/cogOSo0Lc^l?l00>go003Zo`00kol00>So003T
o`400>?o003Uooh0aol00?Wo08oTo`6Ic?co0IVkiOl00>co003Zo`00kol00>So
003To`00hol00>Co0@00aol00=co0IW<o?l1VK_Uo`00k?l00>[o003_o`00j?l0
0>Co003So`00i?l10037o`00g?l1VLclo`6I^nGo003/o`00j_l00>oo003Xo`00
i?l00>?o003To`400<Oo003io`2Bhol1Mb;nA04RVNCo003/o`00j_l00>oo003X
o`00i?l1003To`400>GooP38o`00fol1Mb;nA04RVNCo003/o`00j_l00>oo003X
o`00i?l1003To`400>GooP38o`00fol1Mb;nA04RVNCo003/o`00j_l00>oo003X
o`00i?l1003To`400>GooP38o`00nOl0T^;o1=fIR:[^hol00>co003Zo`00kol1
003Yo`00i?l1003To`400>Co0@00b?l00=[o1=fIR:[^hol00>co003Zo`00kol1
003Yo`00i?l1003To`400>Co0@00b?l00=[o1=fIR:[^hol00>co003Zo`00kol1
003Yo`00i?l1003To`400>Co0@00b?l00?Wo08cTo`3Mo?l0gN?o003/o`00jOl0
0>oo003Xo`00iOl1003So`400>GooP39o`00g?l0gOco0=gSo`00k?l00>Wo003_
o`00j?l00>Go0@00hol1003Uooh0bOl00=co0=glo`3Mhol00>co003Yo`00kol0
0>So003Uo`400>?o0@00iOon0<Wo003io`29i?l0EOb807OSo`00jol00>[o003_
o`00j?l00>Co003So`400>CooP3:o`00g?l0EOb807OSo`00jol00>[o003_o`00
j?l00>Co003So`400>CooP3:o`00g?l0EOb807OSo`00jol00>[o003_o`00j?l0
0>Co003So`400>CooP3:o`00nOl0Q^Con`00A>?o003[o`00j_l00>oo003Xo`00
i?l1003So`400>GooP3:o`00g?ok0014hol00>_o003Zo`00kol00>So003To`40
0>?o0@00iOon0<[o003Loo/004CSo`00jol00>[o003_o`00j?l00>Co0@00hol1
003Uooh0b_l00?Wo09;To`JZoonkoonZhol00>_o003Zo`00kol00>So003To`40
0>?o0@00iOom0<_o003Lo`JZoonkoonZhol00>_o003Zo`00kol00>So003To`40
0>?o0@00iOom0<_o003Lo`JZoonkoonZhol00>_o003Zo`00kol00>So003To`40
0>?o0@00iOom0<_o003io`2?i?l6c?oo^oooc>?o003[o`00jOl00?3o003Wo`00
i?l00>?o0@00i?on0<_o003Lo`K<oonkooo<hol00>_o003Yo`00l?l00>Oo003T
o`00hol1003Tooh0bol00=co1/cook_oolcSo`00jol00>Wo003`o`00iol00>Co
003So`400>CooP3;o`00nOl0SnCo1R94A3=4A5GSo`00j_l00>[o003_o`00j?l0
0>Co003Ro`00hol1003;o`00g?l68TA4<dA4EN?o003Zo`00j_l00>oo003Xo`00
i?l00>;o003So`400<_o003Lo`HRA4@cA4AEhol00>[o003Zo`00kol00>So003T
o`00h_l00>?o0@00bol00?Wo08WTo`0Ro4@0EN?o003Zo`00j_l00>oo003Xo`00
hol00>?o0@00i?on0<co003Lo`0Ro4@0EN?o003Zo`00j_l00>oo003Xo`00hol0
0>?o0@00i?on0<co003Lo`0Ro4@0EN?o003Zo`00j_l00>oo003Xo`00hol00>?o
0@00i?on0<co003io`26i?l0c?co0<cSo`00j_l00>[o003_o`00j?l00>?o003S
ooh0iOon0<co003Lo`3<o?l0c>?o003Zo`00j_l00>oo003Xo`00hol00>?ooP3U
ooh0c?l00=co0<clo`3<hol00>[o003Zo`00kol00>So003So`00hoon0>GooP3<
o`00nOl0M;oo003Zo`00j_l00>oo0@00jOl1003To`00hoon0>GooP3<o`00]ol0
0>[o003Zo`00kol1003Yo`400>Co003Sooh0iOon0<co002go`00j_l00>[o003_
o`400>Wo0@00i?l00>?ooP3Uooh0c?l00?Wo07Boo`00jOl00>_o003^o`00j?l0
0>Co0@00hol1003Tooh0cOl00;Oo003Yo`00jol00>ko003Xo`00i?l1003So`40
0>CooP3=o`00]ol00>Wo003[o`00k_l00>So003To`400>?o0@00i?on0<go003i
o`1d_ol00>Wo003Zo`00kol00>So003To`400>?o0@00i?on0<go002go`00jOl0
0>[o003_o`00j?l00>Co0@00hol1003Tooh0cOl00;Oo003Yo`00j_l00>oo003X
o`00i?l1003So`400>CooP3=o`00nOl0LKoo003Yo`00j_l00>oo003Xo`00i?l1
003Sooh0iOom0<ko002go`00jOl00>[o003_o`00j?l00>Co0@00hoon0>Goo@3>
o`00]ol00>Wo003Zo`00kol00>So003To`400>?ooP3Uood0c_l00?Wo076oo`00
jOl00>[o003_o`00iol00>Co003Ro`400>CooP3>o`00]ol00>Wo003Zo`00kol0
0>Oo003To`00h_l1003Tooh0c_l00;Oo003Yo`00j_l00>oo003Wo`00i?l00>;o
0@00i?on0<ko003io`1d_ol00>So003[o`00kol00>Oo003To`00h_l1003So`40
0<ko002go`00j?l00>_o003_o`00iol00>Co003Ro`400>?o0@00c_l00;Oo003X
o`00jol00>oo003Wo`00i?l00>;o0@00hol1003>o`00nOl0M;oo003Xo`00jol0
0>oo003Wo`00i?l1003So`400>?ooP3?o`00]ol00>So003[o`00kol00>Oo003T
o`400>?o0@00hoon0<oo002go`00j?l00>_o003_o`00iol00>Co0@00hol1003S
ooh0col00?Wo076oo`00j?l00>_o003^o`00j?l00>?o003Ro`400>CooP3?o`00
]ol00>So003[o`00k_l00>So003So`00h_l1003Tooh0col00;Oo003Xo`00jol0
0>ko003Xo`00hol00>;o0@00i?on0<oo003io`1d_ol00>So003Zo`00kol00>So
0@00i?l00>;o0@00i?om0=3o002go`00j?l00>[o003_o`00j?l1003To`00h_l1
003Tood0d?l00;Oo003Xo`00j_l00>oo003Xo`400>Co003Ro`400>Coo@3@o`00
nOl0LKoo003Wo`00jol00>oo003Wo`00i?l00>;o0@00i?om0=3o002go`00iol0
0>_o003_o`00iol00>Co003Ro`400>Coo@3@o`00]ol00>Oo003[o`00kol00>Oo
003To`00h_l1003Tood0d?l00?Wo07Boo`00iol00>_o003_o`00iol00>Co0@00
hol1003Sood0dOl00;Oo003Wo`00jol00>oo003Wo`00i?l1003So`400>?oo@3A
o`00]ol00>Oo003[o`00kol00>Oo003To`400>?o0@00hoom0=7o003io`1d_ol0
0>Oo003[o`00kol00>Oo003To`400>?o0@00hoom0=7o002go`00iol00>_o003_
o`00iol00>Co0@00hol1003Sood0dOl00;Oo003Wo`00jol00>oo003Wo`00i?l1
003So`400>?oo@3Ao`00nOl0M;oo003Wo`00jol00>oo003Wo`400>Go0@00hoon
0>Coo@3Ao`00]ol00>Oo003[o`00kol00>Oo0@00iOl1003Sooh0i?om0=7o002g
o`00iol00>_o003_o`00iol1003Uo`400>?ooP3Tood0dOl00?Wo076oo`00i_l0
0>co003_ooh0jOon0>Go0@00i?om0>Goo03Bo`00]ol00>Ko003/o`00koon0>Wo
oP3Uo`400>Coo@3Uoo`0d_l00;Oo003Vo`00k?l00>oooP3Yooh0iOl1003Tood0
iOol0=;o003io`1a_ol00>Ko003[o`00k_l00>WooP3Uo`400>?ooP3Tood0d_l0
0;Oo003Vo`00jol00>ko003Yooh0iOl1003Sooh0i?om0=;o002go`00i_l00>_o
003^o`00jOon0>Go0@00hoon0>Coo@3Bo`00nOl0M;oo003Vo`00jol00>go003Y
o`400>Go0@00hoon0>Coo03Co`00]ol00>Ko003[o`00kOl00>Wo0@00iOl1003S
ooh0i?ol0=?o002go`00i_l00>_o003]o`00jOl1003Uo`400>?ooP3Too`0dol0
0?Wo07Noo`00i_l00>_o003]o`00jOl1003Uo`400>;o0@00hoom0=?o002go`00
i_l00>_o003]o`00jOl1003Uo`400>;o0@00hoom0=?o002go`00i_l00>_o003]
o`00jOl1003Uo`400>;o0@00hoom0=?o003io`1a_ol00>Go003/o`00kOl00>Wo
0@00i?l00>;ooP3Tood0dol00;Oo003Uo`00k?l00>go003Yo`400>Co003Rooh0
i?om0=?o002go`00iOl00>co003]o`00jOl1003To`00h_on0>Coo@3Co`00nOl0
K[oo003Uo`00k?l00>go003Xo`00i?l00>;ooP3Tood0dol00;Oo003Uo`00k?l0
0>go003Xo`00i?l00>;ooP3Tood0dol00;Oo003Uo`00k?l00>go003Xo`00i?l0
0>;ooP3Tood0dol00?Wo076oo`00iOl00>co0@00k_l00>So003To`00h_on0>Co
o@3Co`00]ol00>Go003/o`400>ko003Xo`00i?l00>;ooP3Tood0dol00;Oo003U
o`00k?l1003^o`00j?l00>Co003Rooh0i?om0=?o003io`1^_ol00>Go003[o`00
k_l00>So003To`00h_om0>Goo@3Co`00]ol00>Go003[o`00k_l00>So003To`00
h_om0>Goo@3Co`00]ol00>Go003[o`00k_l00>So003To`00h_om0>Goo@3Co`00
nOl0IKoo003>o`00k_l00>So0@00iOon0>Coo@3Uood0dol00;Oo003>o`00k_l0
0>So0@00iOon0>Coo@3Uood0dol00;Oo003>o`00k_l00>So0@00iOon0>Coo@3U
ood0dol00?Wo06:oo`00c_l00>go003Xo`00iOon0>Coo@3Uoo`0e?l00;Oo003>
o`00kOl00>So003Uooh0i?om0>Goo03Do`00]ol00<ko003]o`00j?l00>GooP3T
ood0iOol0=Co003io`1X_ol00<go003^o`00j?l1003Uo`400>Coo@3Tood0e?l0
0;Oo003=o`00k_l00>So0@00iOl1003Tood0i?om0=Co002go`00cOl00>ko003X
o`400>Go0@00i?om0>Coo@3Do`00nOl0N/go0^jIc?Ko003=o`00k_l00>So0@00
iOl1003Tood0i?ok0=Ko0035o`;^VLcfo`00cOl00>ko003Xo`400>Go0@00i?om
0>Con`3Fo`00aOl2kYW<m_l00<go003^o`00j?l1003Uo`400>Coo@3Too/0e_l0
0?Wo07[=o`:8VLcfo`00cOl00>ko003Xo`400>Go0@00hoon0>Con`3Fo`00aOl2
R9W<m_l00<go003^o`00j?l1003Uo`400>?ooP3Too/0e_l00<Go0XRIc?Ko003=
o`00k_l00>So0@00iOl1003Sooh0i?ok0=Ko003io`20col4VIV8ogOfo`00c?l0
0>oo003Xo`400>Go0@00hoom0>GonP3Go`00aol4VIV8ogOfo`00c?l00>oo003X
o`400>Go0@00hoom0>GonP3Go`00aol4VIV8ogOfo`00c?l00>oo003Xo`400>Go
0@00hoom0>GonP3Go`00nOl0V=Oo1XS<ooo<^j[no`:kZ[_fo`00c?l00>oo003X
o`400>Go0@00h_on0>GonP3Go`00col6R<coolbkZ_ko0[^Z^oKo003<o`00kol0
0>So0@00iOl1003Rooh0iOoj0=Oo003?o`J8c?ooc;^Zo_l2^jZkm_l00<co003_
o`00j?l1003Uo`400>;ooP3UooX0eol00?Wo08WHo`SMMk_ooeGoZYWao`00c?l0
0>oo003Xo`400>GooP3Sood0i_oj0=Oo003@o`SMMk_ooeGoZYWao`00c?l00>oo
003Xo`400>GooP3Sood0i_oj0=Oo003@o`SMMk_ooeGoZYWao`00c?l00>oo003X
o`400>GooP3Sood0i_oj0=Oo003io`29eol7R;_ogGOoofKao`00c?l00>ko003Y
o`400>Co0@00hoom0>Coo03Go`00col7R;_ogGOoofKao`00c?l00>ko003Yo`40
0>Co0@00hoom0>Coo03Go`00col7R;_ogGOoofKao`00c?l00>ko003Yo`400>Co
0@00hoom0>Coo03Go`00nOl0RMOo1hRkok^8oom4lOom0<ko003_o`00jOl1003T
o`400>?oo@3Too`0f_om0<oo1hRkok^8oom4lOom0<ko003_o`00jOl1003To`40
0>?oo@3Too`0f_om0<oo1hRkok^8oom4lOom0<ko003_o`00jOl1003To`400>?o
o@3Too`0f_om0?Wo09;Go`N8^onkR?ooA?7o003;o`00kol00>Wo0@00i?l1003S
ood00Ol0i_ok0=So003?o`N8^onkR?ooA?7o003;o`00kol00>Wo0@00i?l1003S
ood00Ol0i_ok0=So003?o`N8^onkR?ooA?7o003;o`00kol00>Wo0@00i?l1003S
ood00Ol0i_ok0=So003io`23eol7R;_oofKoc8Sao`00^?l00>So003To`400>?o
o@01o`3Voo/0f?l00<oo1hRkoomVolb8lOl00;So003Xo`00i?l1003Sood00Ol0
i_ok0=So003?o`N8^oooI_o<R?7o002ho`00j?l00>Co0@00hoom007o0>Kon`3H
o`00nOl0Q]So2>iER?ooR>j8gO7o002ho`00j?l00>Co0@00hoom007o0>Kon`3H
o`00d?l8kUF8oon8kXSMlOl00;So003Xo`00i?l1003Sood00Ol0i_ok0=So003@
o`S^EHSoohS^R=gao`00^?l00>So003To`400>?oo@01o`3Voo/0f?l00?Wo077B
o`7<k_3o002ho`00j?l00>Co0@00hoom007o0>Kon`3Ho`00b_l1c>k`o`00^?l0
0>So003To`400>?oo@01o`3Voo/0f?l00<[o0Lc^l?l00;So003Xo`00i?l1003S
ood00Ol0i_ok0=So003io`1F_ol00;SooP3Zo`00i?ol0>Kon`3VooT0f_l00;Oo
002hooh0j_l00>Coo03Voo/0i_oi0=[o002go`00^?on0>[o003Too`0i_ok0>Ko
n@3Jo`00nOl0E[oo002eo`00jol00>Coo03Voo/0i_oi0=[o002go`00]Ol00>_o
003Too`0i_ok0>Kon@3Jo`00]ol00;Go003[o`00i?ol0>Kon`3VooT0f_l00?Wo
05Joo`00]Ol00>_o003Too`0i_ok0>Kon@3Jo`00]ol00;Go003[o`00i?ol0>Ko
n`3VooT0f_l00;Oo002eo`00jol00>Coo03Voo/0i_oi0=[o003io`1F_ol00;Go
003[o`00i?ol0>Kon`3VooT0f_l00;Oo002eo`00jol00>Coo03Voo/0i_oi0=[o
002go`00]Ol00>_o003Too`0i_ok0>Kon@3Jo`00nOl0E[oo002do`00k?l00>Co
o03Voo/0i_oi0=[o002go`00]?l00>co003Too`0i_ok0>Kon@3Jo`00]ol00;Co
003/o`00i?ol0>Kon`3VooT0f_l00?Wo05Joo`00]?l00>_o003Uoo`0i_ok0>Ko
n@3Jo`00]ol00;Co003[o`00iOol0>Kon`3VooT0f_l00;Oo002do`00jol00>Go
o03Voo/0i_oi0=[o003io`1F_ol00;?o003/o`00iOol0>Kon`3VooT0f_l00;Oo
002co`00k?l00>Goo03Voo/0i_oi0=[o002go`00/ol00>co003Uoo`0i_ok0>Ko
n@3Jo`00nOl0H[oo002co`00k?l1003Vo`40oo/0jOod0>gol`3Po`00]ol00;?o
003/o`400>Ko0@3on`3Yoo@0kOoc0>3o002go`00/ol00>co0@00i_l10?ok0>Wo
m03]oo<0h?l00?Wo022oo`00POn@o`00]ol0087oT?l00;Oo0021oi3o003io`0P
_ol0087oT?l00;Oo0021oi3o002go`00POn@o`00nOl08;oo0021oi3o002go`00
POn@o`00]ol0087oT?l00?Wo022oo`00POn@o`00]ol0087oT?l00;Oo0021oi3o
003io`0P_ol0087oT?l00;Oo0021oi3o002go`00POn@o`00nOl08;oo0021oi3o
002go`00POn@o`00]ol0087oT?l00?Wo022oo`00POn@o`00]ol0087oT?l00;Oo
0021oi3o003io`0P_ol0087oT?l00;Oo0021oi3o002go`00POn@o`00nOl08;oo
0021oi3o002go`00POn@o`00]ol0087oT?l00?Wo022oo`00POn@o`00]ol0087o
T?l00;Oo0021oi3o003io`0P_ol0087oT?l00;Oo0021oi3o002go`00POn@o`00
nOl08;oo0021oi3o002go`00POn@o`00]ol0087oT?l00?Wo022oo`00POn@o`00
]ol0087oT?l00;Oo0021oi3o003io`0P_ol0087oT?l00;Oo0021oi3o002go`00
POn@o`00nOl08;oo0021oi3o002go`00POn@o`00]ol0087oT?l00?Wo022oo`00
POn@o`00]ol0087oT?l00;Oo0021oi3o003io`0P_ol0087oT?l00;Oo0021oi3o
002go`00POn@o`00nOl08;oo0021oi3o002go`00POn@o`00]ol0087oT?l00?Wo
022oo`00POn@o`00]ol0087oT?l00;Oo0021oi3o003io`0P_ol0087oT?l00;Oo
0021oi3o002go`00POn@o`00nOl08;oo0021oi3o002go`00POn@o`00]ol0087o
T?l00?Wo022oo`00POn@o`00]ol0087oT?l00;Oo0021oi3o003io`0P_ol0087o
T?l00;Oo0021oi3o002go`00POn@o`00nOl08;oo0021oi3o002go`00POn@o`00
]ol0087oT?l00?Wo022oo`00POn@o`00]ol0087oT?l00;Oo0021oi3o003io`0P
_ol0087oT?l00;Oo0021oi3o002go`00POn@o`00nOl08;oo0021oi3o002go`00
POn@o`00]ol0087oT?l00?Wo03;=o`:IZZ[fo`00POn@o`00aOl2VJZZm_l0087o
T?l00<Go0YVZZ_Ko0021oi3o003io`0bcOl2VHS<m_l0087oT?l00<Go0YV8c?Ko
0021oi3o0035o`:IR<cfo`00POn@o`00nOl0><oo19VIZYV8m_l0087oT?l00<Oo
19VIZYV8m_l0087oT?l00<Oo19VIZYV8m_l0087oT?l00?Wo053Go`J8c?ooc;^Z
o_l2Z[^Im_l0087oT?l00<oo1XS<ooo<^j[no`:Z^iWfo`00POn@o`00col6R<co
olbkZ_ko0ZZkVOKo0021oi3o003io`1Rf?l8gGNkoomEojZIlOl00<Go0036o`00
a_l00<Go003@o`SMMk_ooeGoZYWao`00aOl00<Ko0036o`00aOl00=3o2=eg^ooo
EOnZVO7o0035o`00a_l00<Ko0035o`00nOl1`MOo1hRkomegoomVlOl00?3o003g
o`00n_l00?go003mo`00o_l00?ko1P3oo`3oo`3`o`00n?l00?[o003lo`00oOl0
0?ko2@3oo`3oo`3oo`3`o`00mol00?_o003lo`00oOl00?ko0`3oo`3no`80o`3`
o`00mol00?[o003mo`00oOl00?ko003no`H0ool0ool0col7R;_ogGOoofKao`00
l?l00?Oo003jo`00oOl00?go003no`00o_l60?oo0?oo0?3o003ho`00n_l00?co
003mo`00o_l90?oo0?oo0?oo0?3o003go`00nol00?co003mo`00o_l30?oo0?ko
0P3o0?3o003go`00n_l00?go003mo`00o_l00?ko1P3oo`3oo`3?o`N8^ooMMooo
I_7o003`o`00mol00?[o003mo`00oOl00?ko003no`H0ool0ool0l?l00?So003j
o`00o?l00?go003no`T0ool0ool0ool0l?l00?Oo003ko`00o?l00?go003no`<0
ool0o_l20?l0l?l00?Oo003jo`00oOl00?go003no`00o_l60?oo0?oo0?Wo03GG
o`N8^onkR?ooA?7oP@2>0<oo1hRkok^8oom4lOn108h0col7R;_o^hSoodCaoh40
SP3io`0_eol7R;_o^hSoodB1oh7oc?l7R;_o^hSoodB1oh7oc?l7R;_o^hSoodB1
oh7om_l0MmOo1hRkoomVolb8k_l2gHRIaol1Z[_7o`:kR:[8o`;<R:[7o`7^Mm?o
1hRkoomVolb8k_l2gHRIaol1Z[_7o`:kR:[8o`;<R:[7o`7^Mm?o1hRkoomVolb8
k_l2gHRIaol1Z[_7o`:kR:[8o`;<R:[7o`7^Mogo07OHo`S^EHSoohS^R=g^o`:8
ohS7o`6k^lOo0^koVLOo0Lbkaol1^hSDo`S^EHSoohS^R=g^o`:8ohS7o`6k^lOo
0^koVLOo0Lbkaol1^hSDo`S^EHSoohS^R=g^o`:8ohS7o`6k^lOo0^koVLOo0Lbk
aol1^hSmo`1Rd_l1c>k]o`:8ohS7o`6k^lKo0:[6o`6ZR<So0jYgA=g?o`7<k^go
0XSoR<Oo0K^ka_l0Z/Ko0JZ8b?l3ZWM4gLoo0Lc^kOl2R?n8aol1^k_6o`2Za_l1
ZXS8o`>ZMdCMo_l0dLCo2XS<ooo<^j[ogIV8d?l:gHSoonjZZ^koVIW@o`7^Moko
o[/3oiUgZ]3o1hS<ooo<^j[oo[_@o`ZkVOookZZZk_ooR<3o2XS<ooo<^j[ogIV8
d?l:gHSoonjZZ^koVIW@o`7^Mokoo[/3oiUgZ]3o1hS<ooo<^j[oo[_@o`ZkVOoo
kZZZk_ooR<3o2XS<ooo<^j[ogIV8d?l:gHSoonjZZ^koVIW@o`7^Mokoo[/3oiUg
Z]3o1hS<ooo<^j[oo[_@o`ZkVOookZZZk_ooR?go0;?5o`SMMk_ooeGoZYW=o`O<
A?ooI^k^I/go2=dcoooMMomggLko2=eg^oooEOnZVLko2>jIR?ooI^k^I[ko2=eg
^oooEOnZVLgo1la4oomVk^iVcOl8gC?oomegogOMc_l8gGNkoomEojZIc_l8kYV8
oomVk^iV__l8gGNkoomEojZIcOl7c4CoofK^kVK=o`SM<ooogGOoMmg>o`SMMk_o
oeGoZYW>o`S^VHSoofK^kVKjo`2Ta?l7R;_ogGOoofK<o`I4oomEoomVc?l7A?oo
VJ[o^iW=o`N8^ooMMoooI/go1k^8oomEoomV_Ol7R;_ogGOoofK<o`I4oomEoomV
c?l7A?ooVJ[o^iW=o`N8^ooMMoooI/go1k^8oomEoomV_Ol7R;_ogGOoofK<o`I4
oomEoomVc?l7A?ooVJ[o^iW=o`N8^ooMMoooI/go1k^8oomEoomVn_l0Y<Co1hRk
ok^8oom4c?l6A?ooA?ooA<co1dCoohRkok^8cOl7R;_o^hSoodC=o`NkR?ooA?oo
A;go1hRkok^8oom4c?l6A?ooA?ooA<co1dCoohRkok^8cOl7R;_o^hSoodC=o`Nk
R?ooA?ooA;go1hRkok^8oom4c?l6A?ooA?ooA<co1dCoohRkok^8cOl7R;_o^hSo
odC=o`NkR?ooA?ooA?[o0:C4o`N8^onkR?ooA<co1TCoodCoodC<o`M4oon8^onk
R<go1hRkok^8oom4cOl7^hSoodCoodBmo`N8^onkR?ooA<co1TCoodCoodC<o`M4
oon8^onkR<go1hRkok^8oom4cOl7^hSoodCoodBmo`N8^onkR?ooA<co1TCoodCo
odC<o`M4oon8^onkR<go1hRkok^8oom4cOl7^hSoodCoodCjo`2Ta?l7R;_oofKo
c8S<o`I4oomVoomEc?l7A?oo^iWoR;_=o`N8^oooI_o<R<go1k^8oomVoomE_Ol7
R;_oofKoc8S<o`I4oomVoomEc?l7A?oo^iWoR;_=o`N8^oooI_o<R<go1k^8oomV
oomE_Ol7R;_oofKoc8S<o`I4oomVoomEc?l7A?oo^iWoR;_=o`N8^oooI_o<R<go
1k^8oomVoomEn_l0[LGo2>iER?ooR>j8gLgo1k/RgOnZ^k^ZcOl7gB:koomgogO=
o`S^EHSoohS^R=g=o`N8ENkoZ[^kZ[ko2>iER?ooR>j8gLgo1k/RgOnZ^k^ZcOl7
gB:koomgogO=o`S^EHSoohS^R=g=o`N8ENkoZ[^kZ[ko2>iER?ooR>j8gLgo1k/R
gOnZ^k^ZcOl7gB:koomgogO=o`S^EHSoohS^R=g=o`N8ENkoZ[^kZ_[o04Zoo`7<
k/Oo0MgMa_l0^lKo0Lc^aol1gMfgo`7<k/Oo0MgMa_l0^lKo0Lc^aol1gMfgo`7<
k/Oo0MgMa_l0^lKo0Lc^aol1gMgio`0@POn1oh7oPOn1oh7oPOo:o`0@POn1oh7o
POn1oh7oPOo:o`0@POn1oh7oPOn1oh7oPOo:o`0@POn1oh7oPOn1oh7oPOo:o`0@
POn1oh7oPOn1oh7oPOo:o`0@POn1oh7oPOn1oh7oPOo:o`0@POn1oh7oPOn1oh7o
POo:o`0QPOo7o`>ZR=f8POn1olSo0jZ8gHR1oh7ob?l3ZXSMR8;o0261olOo0k/0
R6J1oh7ob?l3^`28IX7oPOo8o`>k08QVP_l07H7oaol1^`21oh7oa_l1^`21oh7o
a_l1^`21o`3o01f1olOo0K/0POn1olKo0K/0POn1olKo0K/0POl0o`0NPOo7o`:8
0<b1oh7oaol2R03<POn1olOo0XP0c87o0121oh7oPOn1oh7oPOn1ol[o0121oh7o
POn1oh7oPOn1ol[o0121oh7oPOn1oh7oPOn1ol[o0121oh7oPOn1oh7oPOn1ol[o
0121oh7oPOn1oh7oPOn1ol[o0?l\>"], "Graphics",
      GeneratedCell->False,
      CellAutoOverwrite->False,
      ImageSize->{317, 222},
      ImageMargins->{{0, 0}, {0, 0}},
      ImageRegion->{{0, 1}, {0, 1}}]], "Text"],

Cell["This approaches a constant form,", "Text"],

Cell[BoxData[
    \(P[w] = \(\(2\^n\/N\) H\ \ where\ w = 
        r\ N\ 2\^\(-n\)\)\)], "NumberedEquation"],

Cell[TextData[{
  "That is, r tends to ",
  Cell[BoxData[
      \(TraditionalForm\`\(2\^n\/N\) w\)]],
  ", where w follows a static distribution.  Also consider S[n], the fraction \
n generations back which left no descendants; this converges to ~ 20% around \
some definite time ~ ",
  Cell[BoxData[
      \(TraditionalForm\`Log\_2[N]\)]],
  " generations back."
}], "Text"],

Cell[TextData[{
  "Using a generating function argument, we find ",
  Cell[BoxData[
      \(TraditionalForm\`\(\(g\_n[\[Lambda]]\)\(=\)\)\)]],
  "\[LeftAngleBracket]\[InvisibleComma]Exp[\[Lambda] w]\[RightAngleBracket] \
where:"
}], "Text"],

Cell[BoxData[{
    \(g\_0[\[Lambda]] = \(1 + \((\[ExponentialE]\^\(\[Lambda]\ N\) - 1)\)/
              N\ \ and\ g\_\(n + 1\) = \[ExponentialE]\^\(\(-2\) + 2  g\_n[\
\[Lambda]/2]\)\)\), "\[IndentingNewLine]", 
    \(g\_\[Infinity][\[Lambda]] = 
      1 + \[Lambda] + \[Lambda]\^2 + \(8\/9\) \(\[Lambda]\^3\) \
\[Ellipsis]\)}], "NumberedEquation"],

Cell[TextData[{
  "Specifically, S is the solution of ",
  Cell[BoxData[
      \(TraditionalForm\`S = \(\[ExponentialE]\^\(2 \((S - 1)\)\) = 
          0.2032  \[Ellipsis]\)\)]]
}], "Text"],

Cell[TextData[{
  "For small ",
  Cell[BoxData[
      \(TraditionalForm\`w\)]],
  ", ",
  Cell[BoxData[
      \(TraditionalForm\`P[w] = \(\(-Log\_2[S]\) = 0.299\)\)]]
}], "Text"],

Cell["\<\
Amusingly, consider other # of parents (as do Wiuf & Hein in their \
discussion of Chang)\
\>", "Text"],

Cell[TextData[{
  "Note:",
  StyleBox["  No reference between Channg & Derrida et al - seems \
independent.",
    FontWeight->"Plain"]
}], "Text",
  FontWeight->"Bold"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["D",
    FontFamily->"Geneva"],
  StyleBox["ERRIDA",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", B., S. C. M",
    FontFamily->"Geneva"],
  StyleBox["ANRUBIA",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[" and D. H. Z",
    FontFamily->"Geneva"],
  StyleBox["ANETTE",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", 2000 On the genealogy of a population of biparental \
individuals. Journal of Theoretical Biology ",
    FontFamily->"Geneva"],
  StyleBox["203:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 303-315.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell["\<\
Begins by laying out the results from Derrida et al 1999 on the \
distribution of weights of ancestors n generations back.
Considers a measure of the simlarity between two biparental genealogies
Looks then at the relation with the CwR, and use a BP argument to find the \
distribution of the contributions from diffeent ancestors.  By following only \
the fraction of material from each ancestor, we find :\
\>", "Text"],

Cell[GraphicsData["PICT", "\<\
5PP27@6>0S/2Y`0A0_l<0?ooool1SP000Qd000:W0002>`000000000N00402P8M
0Hh2>`:W09X0003oQ6@27@6>0S/2Y`0000@0000004P000180000400P00<02000
000005ZX2OPNa08M0Hh2>`:W0Qd1SP8k0ZL0000>POn1oh7oPOn1oh7o]_l03X7o
POn1oh7oPOn1okKo00j1oh7oPOn1oh7oPOnfo`0>POn1oh7oPOn1oh7o]_l03X7o
POn1oh7oPOn1okKo03SQo`3^oOl0kX7oi_l0k_go0>j?o`3^oOl0kX7oi_l0k_go
0>j?o`3^oOl0kX7oi_l0k_go0>j_o`1Lh_l1VNkmo`7^R:Wo0]dA4O^80FI4bol0
R?co0IW<TOl1VNkmo`7^R:Wo0]dA4O^80FI4bol0R?co0IW<TOl1VNkmo`7^R:Wo
0]dA4O^80FI4bol0R?co0IW</?l14n?o2K^8ooo<onkoR;_mo`2ZoOl5kYV8Z[_M
k?l5VLcook_^dol2R02Znol0VN3o0/bkR?3o28Rkooo<onkoEOgo0LcMoOl6c8R8
^k_oZ]oo2LcMok^8MmgogLc?o`VkR?ooc?o^ohRkoOl0Z_go1NjIR:ZkgNco1IW<
oonkk]?o0XP0Z__o09WPo`;<^hS`o`R8^oooc?o^oeGmo`7<gOgo1/b8R;^koj[O
o`W<gOnkR7OMomg<col9^hSoolcok_n8^ogo0:[mo`G^VHRZ^mg/o`FIc?oo^nkC
o`:80:[ko`2Ih?l2c;^8l?l8R;_oolcok_mEoOl1c=gmo`K<R8Rk^onZgol9c=go
^hQggOoMc>go0C7So`Ug^onZR6IVok]Vo_l1R>kno`J8I]go^b;Mk_l3kXP0^oko
08SBo`944Nklo`2khOl3gGOoR?3o3C?oohQVIYWoA=goomfIo_l9c5FIonigI_o<
Z^7o2mfIok^8ol`Rk_nIgM3o2GNkojZ8IVKo^fKno`68k_ko1XQVgOnk8]g^o`?^
R02ko_l0R=;o0T@Ak_co0;_Qo`?MMon8l?l=<oooR6IVVOm4gOoogIWno`W<EIWo
kWMVolbZhOl;gIWo^hSoc2;^oiWMd?l9Mk_oZXQVI_nkI_ko0HS^o_l6R6KMok/R
gNko0nj80;_no`28d_l2A17^o?l0^n7o0megohS`o`dcoon8IVJIodCMoooMVOko
2LaEVOo^MfKoc:[Qo`_MVOnkR?o<8^koVMg^o`4[hol=A;_o^olRgOnkA?oo^hSn
o`5VA?go09Who`7<VOSo0nko0;_no`7<R=?o0]dAEM_o0FK<k_l<0?o^c=dRoom4
^oooEOko0/`A^ogo19WoofK^h_l;EOooEK_ooeF8oomEd?l=A;_o^olRgOnkA?oo
^hSno`5VA?go09Who`7<VOSo0nko0;_no`7<R=?o0]dAEM_o0FK<k_l<0?o^c=dR
oom4^oooEOko0/`A^ogo19WoofK^h_l;EOooEK_ooeF8oomEd?l=A;_o^olRgOnk
A?oo^hSno`5VA?go09Who`7<VOSo0nko0;_no`7<R=?o0]dAEM_o0FK<k_l<0?o^
c=dRoom4^oooEOko0/`A^ogo19WoofK^h_l;EOooEK_ooeF8oomEk_l1HNco0>kn
oaO^onkMofJkok^IENko^fKooeFkoonk0=gmo`3^n?l1^hSfo`40^ogo017Bo`:8
0:[No`?^R03<molEk_ook_ooc?oo8_nkofJ8k_m4gOo<A?ko0DAVo?l4k_ooR8SS
o`g<A?oo0;_oohQEoom4c=[o0>knoaO^onkMofJkok^IENko^fKooeFkoonk0=gm
o`3^n?l1^hSfo`40^ogo017Bo`:80:[No`?^R03<molEk_ook_ooc?oo8_nkofJ8
k_m4gOo<A?ko0DAVo?l4k_ooR8SSo`g<A?oo0;_oohQEoom4c=[o0>knoaO^onkM
ofJkok^IENko^fKooeFkoonk0=gmo`3^n?l1^hSfo`40^ogo017Bo`:80:[No`?^
R03<molEk_ook_ooc?oo8_nkofJ8k_m4gOo<A?ko0DAVo?l4k_ooR8SSo`g<A?oo
0;_oohQEoom4c>oo0E;]oaKM8Z[ogFKo^dCo^hSoVGNZVOn8^ooo0?ko0EDcl_l1
^hSfo`40^ogo0DBkd_l2A17^gol3kXPcc?So6hPcoomVgOm4^on8c?n8R9VkoeGo
ohR8ooo<0:[io`6kA>?o3HR8oolRR?ooR4CoohR8folFgB:ZomeVok]4ok^8oiUg
ZYWoR;_oo`3no`5E<o;o0K^8m_l10;_mo`54^m;o0T@Ak]oo0nj8<lchoa^8<ooo
I]goA;_oR<coR8RI^omEoon8R?ooc02ZnOl1^dCSo`f8R?oo8XSoohQ4oon8R=_o
5]dRZ_oMI_nkA?nkR?nIMjZIohRkool0o_l1EC?bo`6kR?Ko0@2koOl1A;_Bo`94
4NkOo`?^R3?<n?lKR3?oofKModBkohS<ohR8VK_oEOooR8Sool`0Z_Wo0K]4hol=
R8Soob:8oon8A?ooR8S_o`6;k?l;R8SoMdCooj[oohS^oOl5kYWool`0o_l108Sn
o`>ZA5FknOl1^hSfo`40^ogo0DB8oOl0c?U40<cPo`;^4GONo`68Mo[o0=gno`X0
omdA^onkk_o^R?ko2mgoZ]gooeF8oon80?ko1megA8S^ok/0hol=EHSoohPRgNi4
I_ooR4CJo`^8R?mgA?ooZ_ooR>kmo`G^VOooc03no`40R?ko0jY4EK_io`6kR?Ko
0@2koOl1A8Smo`3<nD@0c>3o0^hAMmko0HQgn_l0gOko2P3ogA6kok_^onj8o_l;
gOnZgOooEHSoohP0o_l7gGM4R>ko^`3So`eER?ooR2;MkTAVoon8A=[o2hR8ogM4
oonZoon8k_go1NjIooo<0?ko0@28o_l3ZTAE^oWo0K^8m_l10;_mo`54R?go0<ci
A03<h?l2kQ5gg_l1R7Ojo`3Mo_l:0?oM4K_o^nkokXSno`_Moj[MoomER?ooR03n
o`OMMdB8k_nk0>?o3EF8oon88]g^A6KoohQ4kol1P^co1jY4gK/0omfko_l0k_go
0>kno`6k0?ko0@28oOl108Slo`3<oT@1<b;nA02In_l10;_mo`54R=7o0IU4g_l1
IYWko`7^Moko1S>kVHR8oiWno`3^o_l2I_o^o_l5A8SoohP0oOl6R17^oonk0>?o
0DB8o_l8^hRZ8YWoohQ4f_l7ZTCM^`3ogK_no`3^oOl0k_ko0K/0o_l108Smo`40
R?co0<cnA04c8_i409Wjo`40^ogo0DB8dOl1VDCNo`5VVO_o0Nigo_l6<k^IR8So
VOko0>kno`9Vonkno`E4R?ooR03mo`J84Nkook/0hol1A8Sno`RkR:XRVOooR4CJ
o`NZA=fk0?oM^oko0>kmo`3^o_l1^`3no`40R?go0@28o?l0c?i40C<RoT@0VO[o
0@2koOl1A8SAo`6IA=ko0FJInol1kWOno`Hc^iV8R?nIo_l0k_ko0VKok_ko1DB8
oon80?go1XPAk_oo^`3So`54R?ko2;^8ZR:Ioon8A>oo0Gc/o`c<A9Wo8]fIooo^
gOoMn_l1^`3no`4cI_ko0]d0^oSo0K^8m_l10;_mo`54R?go0<ciA03<gol1MmgN
o`Tcc?ooc?oMoj[^o_l9EIVkVFKM^ooogOk^0Mfko?l6A8SoojX0gOko0FI4o_l1
^`3So`54R?co0ITRo_l1R4CJo`c<A9Wo8]fIooo^gOoMn_l1^`3no`4cI_ko0]d0
^oSo0K^8m_l10;_mo`54R?go0<ciA03<gol1MmgNo`Tcc?ooc?oMoj[^o_l9EIVk
VFKM^ooogOk^0Mfko?l6A8SoojX0gOko0FI4o_l1^`3So`54R?co0ITRo_l1R4CJ
o`c<A9Wo8]fIooo^gOoMn_l1^`3no`4cI_ko0]d0^oSo0K^8m_l10;_mo`54R?go
0<ciA03<gol1MmgNo`Tcc?ooc?oMoj[^o_l9EIVkVFKM^ooogOk^0Mfko?l6A8So
ojX0gOko0FI4o_l1^`3So`54R?co0ITRo_l1R4C_o`5Hjol;0;_oA8SMoonkR?mV
n_l1kP3no`JZ4NkoojX0mol1^hSfo`40^ogo0DBkd_l1ZYWMo`H0ooo<VMeVnol5
R4Co^dBZo_l3ZYWMR?[o0GN8o_l1<hSno`4cR?ko0k]4olcUo`5gR?go0]dRc?ko
0HR8fOl;0;_oA8SMoonkR?mVn_l1kP3no`JZ4NkoojX0mol1^hSfo`40^ogo0DBk
d_l1ZYWMo`H0ooo<VMeVnol5R4Co^dBZo_l3ZYWMR?[o0GN8o_l1<hSno`4cR?ko
0k]4olcUo`5gR?go0]dRc?ko0HR8fOl;0;_oA8SMoonkR?mVn_l1kP3no`JZ4Nko
ojX0mol1^hSfo`40^ogo0DBkd_l1ZYWMo`H0ooo<VMeVnol5R4Co^dBZo_l3ZYWM
R?[o0GN8o_l1<hSno`4cR?ko0k]4olcUo`5gR?go0]dRc?ko0HR8kol1Fn_o14Co
ohRIoOl2c>jknOl1<lcno`F8<jZZEGOgo`6kR?So1=fZA8S<o_l14NkCo`7^I]go
0K]EoOl1^k_ko`F8^ooo<nkmo`:kgMgjo`6ZEOko1/`cR;^8<lcno`B8Ml`0MnKo
0JYEo_l2ZUG<oOl1EJ[Io`A4oon8VOgo0/c^^oWo0C?<o_l5R3>ZZUEgmol1^hSh
o`CMZTB8c?ko0A7^dol1kVKMo`6kEOgo0K^knol5R;_ooc?^oOl2^mgMn_l1ZUGn
o`K<<hRkR3?<o_l4R7O<07OVo`6ZEOko0ZYEc?go0EFZfOl4A?ooR9Wmo`;<k[_i
o`4cc?ko1HPcZZYEMoOo0K^8n?l4gJY4R<cno`4Ak]?o0NiVgOl1^eGmo`6k^o_o
1HRkoolck_go0[_MgO[o0JYEo_l6c3>8^hPcc?ko18Qgc01gi_l1ZUGno`:ZELcm
o`5EZ^oo0Ac[o`?^oooMnol0MoSo0IVIoOl2k[_<mOl1^hSao`7MI];o0EG^nol0
k^Co0HRIoOl1R=gko`3^o_l0gOco0K^Zn?l0A?co0/bkk_co16KMok^8iOl4A?oo
c=gko`14f?l3k_oogO_o07Oho`6IVOgo0^jkc?Go0K^8lOl1gFKBo`5Ek__o0>kT
o`68VOgo0HSMnol0k_ko0=glo`6kZ_So04Clo`;<^nklo`AVgOnkR>Go14CoolcM
nol0A=So0nkoomgko`1gn?l1VIWmo`;^^lceo`6kR?7o0MeVd_l1ENkko`3^i?l1
R9Wmo`68gO_o0>kno`3Mo?l1^j[ho`14o?l2c;_^o?l4I]go^hSUo`A4ooo<gO_o
04C^o`2lh_l1^k_go`28g?l1R>kCo`68^o[o09WVo`:IofKmo`7^R?3o08Sgo`6k
^oKo1Mf8oonZc>Go0K^knOl1Z[_?o`6k^oOo08SLo`68k]?o0HRkn_l0VNKo0YWo
I_go0Nj8l?l0R?Oo0K^km_l5gHSooj[<iOl1^k_io`6Z^loo0K^kmol0R=co0HS^
dol1R;_jo`2Ii_l2VOmVoOl1kXS`o`28mol1^k_fo`GMR?ooZ/cUo`6k^oWo0JZk
k_l0`^;o0DC^mol1kYWNo`6kc=?o0Lb8n_l1I[_Vo`9gZ^kmo`5g^o7o0Ni4m_l1
Z]ggo`B8oooMgN?o0J[Mnol1gJ[>o`54k_Oo0NjIg_l1^lcCo`7<R?[o0FJki_l2
Mj[^oOl1Mk_ao`7^A?Ko0J[Mmol4R?oogMgSo`6ZgO_o0MfZc_l1A>kgo`7^VMko
0K_<dol1c8Sjo`5V^nKo0WNZk_go0GNklOl1kTCfo`6ZgOOo18SoomgMhol1Z]gk
o`7MZ^go03kRo`3MXOl0<oP00<cOo`3Mkol0gH[o0=fQo`0cn000c=oo0=g_o`3M
R_l0gJ7o03?h003<gol0gNoo0=fYo`0NP_l0k_NkPOn1oo?o0>kg^h7oPOoco`3^
mk^1oo;o00j1oh7oPOn1oh7oPOnfo`0lUOl0gOCo0Nk^n_l0gNWo0K_^POnJo`3M
m?l1k^kjo`3MjOl1^nj1oi[o0=gdo`7^k_[o0=gYo`6kkXKo05fFo`6ZZ_[o0Nhc
oOl4R9WoI[_no`5gR>[o0WNkZX7oVol1ZZ[jo`7^<ogo18RIofJko_l1MhSZo`9g
^jZ1oi_o0JZZn_l1kS?mo`B8VOmV^oko0GN8j_l2Mk^ZQ_l0]9[o1<cogOnIo?l6
gLcoodCogOko5NkoR;_ook^IR?oogK_ook_MoooMok_ko`G<gOoM<lcmo`3Mo^j1
ojKo1<cogOnIo?l6gLcoodCogOko5NkoR;_ook^IR?oogK_ook_MoooMok_ko`G<
gOoM<lcmo`3Mo^j1ojKo1<cogOnIo?l6gLcoodCogOko5NkoR;_ook^IR?oogK_o
ok_MoooMok_ko`G<gOoM<lcmo`3Mo^j=o`2jVol3c9WMI__o8J[<R8SoA8QEZ_m4
^on8^omVc8R8ohQ4Mon8kVKMgB:ZIXSmo`EggGNIodClo`>ZVMf8POnWo`?<VMeV
nolQZ/b8R?m4R5FZodBkohRkofK<R8SoR4AgohS^I]gM8ZYVR?go1GOMMiWoA?co
0jZIgHR1ojOo0lbIgFKkob6Zc8R8odB8EJ[oA;_oR;_oI/b8R?n8A7OoR>iVgMdR
ZVJ8oOl5MmegVOm4o?l3ZYWMR8go0:jIo`6k^o_o04Cmoaa4ok^8ohRkohRkgDCo
^hSo^hSoob:k^nkoA?nkR?go1@3o^dCoA?_o0[_MgH7oYOl1^k_ko`14oOlLA?nk
R?n8^on8^me4ok^8ok^8oolR^k_^odCo^hSmo`D0ok]4odCko`:kgMf1ojGo0K^k
nol0A?go74Co^hSoR;_oR;_MA?nkR?nkR?oo8[^kk_m4ok^8oOl50?nkA?m4nol2
^mgMSOl0[YWo0HSMnolQIXS^VOm4ok^8ohRkohRkkQ7^^hSo^hSoob:8c<coA?nk
R?go1A7^gFKoA?_o0K^ZPOnTo`68gO_o8FJ8kYWoA?nkR?n8^on8^nhAk[^8ok^8
oolRR<c<odCo^hSmo`DAk]eVodCko`6kZX7oY?l1R=gkob5VR>jIodCo^hSoR;_o
R;_^4NjkR?nkR?oo8XS<c?m4ok^8oOl54NkMI_m4nol1^jZ<o`2^V_l1kXSjob7^
IVK^kUFkR7OoMhSoMiWoZVJ8R>jII_ooc6JZola4c9UgoOl6c8R8k/aEgOco08R1
ojCo0Nj8n_lQkVIVk^iE^hQgogN8ogNIojYVR8S^VFKoolaVZ_o<A<bIMogo1/b8
R>k<EMglo`28POnTo`7^R?[o8NiVI^k^EK^8MomgR?mgVOnZIXR8kYUVooo<IZ[o
c4C<VGOmo`K<R8S^c5GMo?l0R8_o003o\>"], "Graphics",
  ImageSize->{279, 29.6875},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell["where f is chosen from some distribution with mean 1/2.", "Text"],

Cell[TextData[{
  "Note:  ",
  StyleBox[" The linaear structure, and correlations between mates, are \
ignored here.",
    FontWeight->"Plain"]
}], "Text",
  FontWeight->"Bold"],

Cell["\<\
The generating function defined as <exp[\[Lambda] w]>/<exp[w]> \
follows:\
\>", "Text"],

Cell[GraphicsData["PICT", "\<\
83@20@140Sl1G`0A0_l<0?ooool0A0000P40005O0002?`000000000N00402P81
04@2?`5O09X0003oQ6`20@140Sl1G`0000@0000004P000180000400P00<02000
000005ZX2OPNa08104@2?`5O0P40A08o0El0000>POn1oh7oPOn1oh7o/?l03X7o
POn1oh7oPOn1ok3o00j1oh7oPOn1oh7oPOn`o`0>POn1oh7oPOn1oh7o/?l03X7o
POn1oh7oPOn1ok3o00j1oh7oPOn1oh7oPOn`o`0>POn1oh7oPOn1oh7o/?l0887o
XOl0k][o0>j1ohoo0>kJo`3^POn?o`3^f_l0k^oo05Jbo`00o8P0gH7on?l1VJ[J
o`7MMoco0=glR000[Ol00?b80=f1ooSo0IVZf_l1gGOlo`3Mo8P00:go003lR03M
POoho`6IZ][o0Mego?l0gOb8003lo`0n/_l0087olol1c8SHo`6kR?Oo002]o`00
POoco`7<R=So0K^8mol00:go0021oo?o0Lb8f?l1^hSgo`00o?l0K[;o0030o`?^
IP2Z^Ol1kVK_o`5gVO[o0[^ZVOCo0HRkn?l00:go0030o`?^IP2Z^Ol1kVK_o`5g
VO[o0[^ZVOCo0HRkn?l00:go0030o`?^IP2Z^Ol1kVK_o`5gVO[o0[^ZVOCo0HRk
n?l00?co076bo`00`?l3Mnh0A;Wo0HSMl?l2gLb8nol3ZYWMZ_?o06Kho`00[Ol0
0<3o0gO^04Bio`68gO3o0]g<R?_o0jZIgJ[co`1Vn?l00:go0030o`=gkP14^Ol1
R=g`o`;Mc8Sko`>ZVMfZlol0I_So003lo`1U/_l00<3o0gOoZ/bjo`7MR>go0;_k
o`0cl?l1^iWio`00[Ol00<3o0gOoZ/bjo`7MR>go0;_ko`0cl?l1^iWio`00[Ol0
0<3o0gOoZ/bjo`7MR>go0;_ko`0cl?l1^iWio`00o?l0IK;o0031o`6k^kOo0FKM
kOl0^ogo0meV<mg`o`1EnOl00:go0031o`6k^kOo0FKMkOl0^ogo0meV<mg`o`1E
nOl00:go0031o`6k^kOo0FKMkOl0^ogo0meV<mg`o`1EnOl00?co06^bo`00`Ol1
R>jho`7^ENgo0NiEoOl3gFIVgO3o0IVZn_l00:go0031o`68k[So0NiEkOl1kUGm
o`?MIVKMl?l1VJ[jo`00[Ol00<7o0HS^^?l1kUG]o`7^EOgo0meVI]g`o`6IZ_[o
003lo`1R/_l00<7o08Rgo`68VNgo0EEVo?l1EJ[_o`7MEO[o002]o`00`Ol0R;Oo
0HRIkOl1EFKlo`5EZ^oo0MeEn_l00:go0031o`28]ol1R9W]o`5EI_co0EFZkol1
gEGjo`00o?l0H[;o0031o`1V]ol1EMg^o`:ZA;_lo`4RgNko02;jo`00[Ol00<7o
06Jgo`5EgNko0ZY4^oco0B;Mk_l08_[o002]o`00`Ol0I[Oo0EGMk_l2ZTBko?l1
8]g^o`0Rn_l00?co06Rbo`00`Ol0A;So0NhAk_l3kQ7<^ogo0NhAkOl1EK_ko`00
[Ol00<7o04Bho`7^4Nko0nhAc;_mo`7^4Ngo0EFknol00:go0031o`14^?l1kQ7^
o`?^4LbkoOl1kQ7]o`5E^o_o003lo`1[/_l00<7o04Bho`6kA>ko2EF8ok_ok_oo
^dC]o`68Mo_o002]o`00`Ol0A;So0K]4k_l9EHSo^oo^oonkA>go0HQgnol00:go
0031o`14^?l1^dC^o`UER?nkonkook]4kOl1R7Oko`00o?l0o_[o0/a4c?;o2K_^
ooo<ENkogLcEo`00`Ol1A<cao`2ZnOl5ZXS<oonZn?l1c6Kjo`JkZYWoc4C<lOl1
R7O_o`ZZ<oooMgO^oon8R>go0JY4nol00?Go0/a4c?;o2K_^ooo<ENkogLcEo`00
`Ol1A<cao`2ZnOl5ZXS<oonZn?l1c6Kjo`JkZYWoc4C<lOl1R7O_o`ZZ<oooMgO^
oon8R>go0JY4nol00?Go0/a4c?;o2K_^ooo<ENkogLcEo`00`Ol1A<cao`2ZnOl5
ZXS<oonZn?l1c6Kjo`JkZYWoc4C<lOl1R7O_o`ZZ<oooMgO^oon8R>go0JY4nol0
0?co0A3io`40k_?o0J[<o_l6Z/bkoonIgMKo0031o`54^o;o0HS^n_l7Mmfkc?oo
kXSjo`;^R03ko`NZVMfZool0k_7o0FJ8kol0k_ko0NkMo_l1EMg]o`6k8__o003d
o`40k_?o0J[<o_l6Z/bkoonIgMKo0031o`54^o;o0HS^n_l7Mmfkc?ookXSjo`;^
R03ko`NZVMfZool0k_7o0FJ8kol0k_ko0NkMo_l1EMg]o`6k8__o003do`40k_?o
0J[<o_l6Z/bkoonIgMKo0031o`54^o;o0HS^n_l7Mmfkc?ookXSjo`;^R03ko`NZ
VMfZool0k_7o0FJ8kol0k_ko0NkMo_l1EMg]o`6k8__o003lo`3hn_l1c3?co`7^
I__o0;_no`1Ee_l00=co0LbIj?l14K_co`6kR?[o0MeEnol1R;_jo`6k0?_o03?m
o`7<<o3o0DBZjOl3kZ[^Mnco0K/0nol00?Go0L`clol1kVKko`2ko_l0EMKo003L
o`7<VNSo0A6klol1^hSjo`7MEO_o0HRkn_l1^`3ko`0coOl1c3?`o`54Z^Wo0njZ
kWO/o`6k0?_o003eo`7<<o?o0NiVnol0^oko05GFo`00g?l1c9WXo`4A^o?o0K^8
n_l1gEGko`68^o[o0K/0nol0<ogo0L`cl?l1A:[Yo`?^Z^igk?l1^`3ko`00o?l1
[?[o19UVomg^m_l1R8Sko`2ko_l1A<c]oa2IR<cogK^kk[^koonkgK^8gOco003]
o`O^c?oMk_o^c?So0K^8n?l7k/cogNkok/cio`40^oSo0K_^o_l1EK_ko`?<<fK^
o?l1^eGlo`>ZR9T0oOl3gFHcgOko19UVomg^lol18[_Yo`;MR:[Zo`40gOco003e
o`BII_oMk_Ko0HR8nol0^oko0DC<kOl@VHS<omfk^njk^ooo^mfkR=glo`00kOl7
k/cogNkok/cho`6kR?So1nk<omg^onk<nOl10;_ho`6kk_ko0EFknol3c3=Vk_co
0K]Eo?l3ZXRI0?go0meV<mgno`BII_oMk_?o0B:kjOl2gHRZj_l10=glo`00mOl4
VFKogNkfo`68R?_o0;_no`54c>go49V8c?oM^k_^^k_ook_M^hSMo?l00>go1nk<
omg^onk<n?l1^hSho`O^c?oMk_o^c?Wo0@2kn?l1^nkno`5E^o_o0l`cI^klo`6k
EOco0jZ8V@3mo`?MIS?Mo_l4VFKogNkco`4R^nWo0]f8Z^[o0@3Mo?l00?co0Jcj
o`AgR:YVEOKo0DBko?l1R;_no`68R>ko4WO^c16kofHcohS<ojXAMgMV0;_mo`00
k_l8gFIgZVIEc8P0n?l1^hSio`SMIWNZIUG<R03io`40VO[o1lagoeGMool0n_l3
c3>8k__o003mo`AV^omE0?go0meVI]gno`AgR:YVEO?o0@2kcol10;_lo`00mOl4
MhRZIUGfo`54^oco0HRko_l1R8S^oa9gk/`A^omV<on8c?nZ4GMgIP2koOl00>ko
2=eVMjYVELb80?So0K^8nOl8gFIgZVIEc8P0nOl109Wjo`O<MomEgOoo0?[o0l`c
R>kko`00oOl4I[_oE@3mo`?MIVKMo_l4MhRZIUGco`40^loo0@2ko?l00?Go17N8
ZVIEm_l1A;_lo`68^oko0HR8k_lBMnk<4K_oIS?oR<coZQ5gMfH0^ogo003^o`SM
IWNZIUG<R03ho`6kR?Wo2=eVMjYVELb80?Wo0@2In_l7c7OoEMgoo`3jo`?<<hS^
nol00?go16JkoeD0oOl3gFIVgOko17N8ZVIElol10;_?o`40^oco003lo`6nn_l4
<iW<^fKfo`4A^ogo0/`0gOko0HQ4oOl0c?U40<cmo`[<A8R88UGoob9gZ_ko1DBZ
oomV<ogo003]o`MER=fZIZ[o0?So0K^8n?l7EHSMZVJZo`3io`40R?_o2>hcoon8
R?o<0?Wo0A7^n_l90;_ooiUVoonk0?co0EFZoOl4<iW<^fKco`40^loo0@2ko?l0
0?Go13>Ic;]Vm_l14K_mo`;<0=gno`68A?go0<ciA03<oOl:c4B8R29EoolRMj[n
o`E4Z_ooIS?mo`00kOl7EHSMZVJZo`3ho`6kR?So1eF8gJYVZ_l0nOl108Sko`S^
<oooR8Soc03io`4Ak_[o2@2koonII_oo^`3lo`5EZ_go13>Ic;]Vlol10;_?o`40
^oco003eo`@cVLbkI_Ko0A6koOl2c03Mo_l1R4Cmo`3<nD@0c?go2/a4R8PREOoo
8WNZo_l5A:[oofHcoOl00>go1eF8gJYVZ_l0n?l1^hSho`MER=fZIZ[o0?Wo0@28
nol8kS?oohR8ol`0nOl14Nkjo`T0^oooVFKook/0o?l1EJ[mo`@cVLbkI_?o0@2k
col10;_lo`00o?l1e_[o102kohR8m_l10;_mo`4cR?go0HQ4kol1R8Sko`:k4Nkn
o`E4^ooo^`3mo`00o?l0VOU409Wlo`LAR?n8EOnkA?co0<cnA04c8_i409Wlo`LA
R?n8EOnkA?Wo0@28nol8R7OoofJ8ok/0n_l1gB;io`T0^oooEHSook/0o?l18]gm
o`@0^on8R??o0@2koOoI0?_o0@2ko?l00?Go102kohR8m_l10;_mo`4cR?go0HQ4
kol1R8Sko`:k4Nkno`E4^ooo^`3mo`00o?l0VOU409Wlo`LAR?n8EOnkA?co0<cn
A04c8_i409Wlo`LAR?n8EOnkA?Wo0@28nol8R7OoofJ8ok/0n_l1gB;io`T0^ooo
EHSook/0o?l18]gmo`@0^on8R??o0@2koOoI0?_o0@2ko?l00?Go102kohR8m_l1
0;_mo`4cR?go0HQ4kol1R8Sko`:k4Nkno`E4^ooo^`3mo`00o?l0VOU409Wlo`LA
R?n8EOnkA?co0<cnA04c8_i409Wlo`LAR?n8EOnkA?Wo0@28nol8R7OoofJ8ok/0
n_l1gB;io`T0^oooEHSook/0o?l18]gmo`@0^on8R??o0@2koOoI0?_o0@2ko?l0
0?co0L[ko`Fk8^koA;_fo`40^oko0XQE^ogo0HQ4oOl0c?U40<cmo`68EOko1Mgo
oiU4R?ko1DBkoonk8_go003^o`SM0=goA9WoR7Oho`6kR?Wo2=d0gOm4VOn8MoWo
0@28nol8EJ[ooc?<ok/0n_l1ZUGio`T0^oooA7Oook/0oOl1kQ7mo`Fk8^koA;_c
o`40^loo0@2ko?l00?Ko1K/Rk_m4^oKo0@2ko_l2R5FkoOl1R4Cmo`3<nD@0c?go
0HQEo_l5gOooVDB8o_l5A;_ook/RoOl00>ko2=d0gOm4VOn8MoSo0K^8nOl8g@3M
odBIohQgnOl108Sko`QEZ_oo<lco^`3jo`6ZEOWo2@2koom4Mooo^`3mo`7^4Ogo
1K/Rk_m4^o?o0@2kcol10;_lo`00m_l5^b;^odBkm_l10;_no`:8EK_mo`68A?go
0<ciA03<oOl1R5Gno`GMoonIA8Sno`E4^ooo^b;mo`00k_l8g@3ModBIohQgn?l1
^hSio`SM0=goA9WoR7Oio`40R?_o25FZoolcc?nk0?[o0JYEnOl90;_oodAgoonk
0?go0NhAoOl5^b;^odBklol10;_?o`40^oco003lo`7Ynol6R6Kooa7<k_go0Njk
oOl=<k_ool`Ak[_ok_ooR8S_oa?<0<cogIWogHSM0=goodBkoon8R?go003^o`VZ
EOoo4NkoIYW<nOl1^hSio`VZEOoo4NkoIYW<n_l108Sko`PA^oo<A?ookP3jo`68
R?Wo003no`F88^ko^`3mo`6kA?go1XQVoolAc>klo`6kk__o0C>kcol10>klo`00
oOl0gO_o1XQVoolAc>kmo`7^^ogo3C>kooo<4NjkonkoohR8kolCc03<omfIomf8
g@3Moom4^oooR8Smo`00k_l9ZUGooa7^ofJIc?Wo0K^8nOl9ZUGooa7^ofJIc?[o
0@28nol84K_oc4Coonh0n_l1R8Sio`00o_l5R2;^ok/0oOl1^dCmo`J8I_oo4Lc^
o?l1^nkko`4c^loo0@3^o?l00?go0=gko`J8I_oo4Lc^oOl1k[_mo`dc^oooc17^
^oo^oon8R>oo4l`0c?oMVOoMR=d0gOooA;_oohR8oOl00>ko2JYEoolAk_mVVLci
o`6kR?Wo2JYEoolAk_mVVLcjo`40R?_o216kola4ooo^0?[o0HR8nOl00?ko1HPR
k_nk0?go0K]4oOl6R6Kooa7<k_co0K_^nol1<k_?o`40k_co003mo`3M0R_ko`eE
Z_o^0:[ooiVkR5G^Z_ko3GN8oolcZ_oMEIWooeFZk_lAIP14A>kM<mg^<c?ModA4
^iUgo?l00>ko2GN8ol`coom4Mnkio`6kR?Wo2GN8ol`coom4Mnkjo`40R?co1MdA
R>igk_ko0C?<nol1A<cjo`7<<ogo1D@RR6H0R?ko0HR8oOl>EJ[okP2ZoonZ^iU4
gLcMo?l1A8S/o`5gk_Wo0[^ZVOko0GO^mol1^`3ko`00oOl08__o3EFZonh0Z_oo
VK^8ENjZo_l=MhSooc>ZomeEVOooEJ[^oa5V04A4k]dcgNhc<mgoA4BkVGOlo`00
k_l9MhSoc3?oodAgk_Wo0K^8nOl9MhSoc3?oodAgk_[o0@28o?l5gA68kWO^o_l1
<lcko`54c?[o0L`coOl5A2:8IP28o_l1R8Smo`iEZ_o^0:[oojZkVDCMc=glo`54
R>co0GO^nOl2^jZIo_l1Mnkgo`6k0?_o003mo`0Rnol=EJ[okP2ZoonI^hQEkZ[n
o`egR?oo<j[ogEFIoomEZ^ko4FH0A4C^gC?MkS<cgOm4A;^IMoco003^o`UgR?o<
<oooA7O^nOl1^hSio`UgR?o<<oooA7O^n_l108Slo`GM4HS^Mnkno`4cc?_o0DC<
n_l1c3?mo`E48XQV08Sno`68R?go3UFZonh0Z_ooZ[^IA=g<gOco0DB8k?l1Mnki
o`:kZYWno`5gk_Oo0K/0nol00?go0281]_Oo4<cook_oogNkoonkoooMI_o^oOl0
c?ko04C/o`7Mc?Oo0dBkc=gko`00iol1gNkho`6kR?;o0Mg^nOl1A8Slo`>ZELc<
o?l1VIWko`0cnOl1VIWlo`?<gNk^oOl1EMgio`3<o_l6^onZR?oo^oco0GN8kOl1
Mlcio`>ZVMfZo_l1kUGgo`6k<o_o003mo`3Mmol@c?oo^oooMk_ook_oomeVonkm
o`3<o_l0A>co0Mg<mol3A;_<gO_o003Wo`7Mk_So0K^8l_l1gNkio`54R?co0jYE
c<clo`6IVO_o03?io`6IVOco0lcMk^kmo`5EgOWo0<cno`JkojZ8oonko?l1MhS]
o`5gc?Wo0jZIgJ[no`7^EOOo0K/cnol00?go0=ggoa3<oonkoomg^ooo^ooogFKo
k_go0<cno`14k?l1gLcgo`=4^lcMnol00>Oo0Mg^n?l1^hSbo`7Mk_Wo0DB8o?l3
ZUG<c?co0IVInol0<oWo0IVIo?l3c=g^k_go0EGMnOl0c?ko1[_oZXSook_lo`5g
R>go0GO<nOl3ZYWMZ_ko0NiEmol1^c?ko`00oOl0g@4^m?l7gMg^A;_ogMgno`68
k_Wo0JZkh?l1A;_io`00`Ol1A8Slo`5gR?Wo08Sno`?<c:ZZnOl0MoKo0njZkWOd
o`JkoeFIoonko?l1R6K^o`6IVOSo03?jo`7<MoSo0HQ4nol00>oo1mgMkTBkomgM
o_l1R>kio`6Z^n3o0DBknOl00<7o0DB8o?l1MhSio`28o_l3c<bZZ_Wo07Ofo`?^
Z^igm?l6^omEVOoo^oco0HQVk_l1VIWho`0cn_l1c7Oho`68A?_o003_o`OMgNi4
^ooMgOko0HS^nOl1Z[_Po`54^oWo0031o`54R?co0GN8nOl0R?ko0lc<ZZ[io`1g
m_l3kZ[^MoCo1[_oEIWook_lo`68I^ko0IVIn?l0<o[o0Lagn?l1R4Cko`00o?l1
Co?o1MfIgK^kc?co08Sjo`7MZ^3o0k/RI]gjo`00`Ol1A9Wlo`4Rc?Wo1^jIoonZ
VK_io`6Ik_Ko0]f8Z_?o1NjZ^lbk^o_o0K]4nol7k/cogNkok/cmo`7<MoWo0meV
<mgjo`6IVOWo0HR8nol00>ko1MfIgK^kc?co08Sjo`7MZ^3o0k/RI]gjo`00`Ol1
A9Wlo`4Rc?Wo1^jIoonZVK_io`6Ik_Ko0]f8Z_?o1NjZ^lbk^o_o0K]4nol7k/co
gNkok/cmo`7<MoWo0meV<mgjo`6IVOWo0HR8nol00>ko1MfIgK^kc?co08Sjo`7M
Z^3o0k/RI]gjo`00`Ol1A9Wlo`4Rc?Wo1^jIoonZVK_io`6Ik_Ko0]f8Z_?o1NjZ
^lbk^o_o0K]4nol7k/cogNkok/cmo`7<MoWo0meV<mgjo`6IVOWo0HR8nol00?co
09^bo`00`Ol1A;^ho`0Ao?l8gFIgZVIEc8P0o_l1kUGho`?MIVKMnOl1I/cjo`54
^o_o002]o`00`Ol1A;^ho`0Ao?l8gFIgZVIEc8P0o_l1kUGho`?MIVKMnOl1I/cj
o`54^o_o002]o`00`Ol1A;^ho`0Ao?l8gFIgZVIEc8P0o_l1kUGho`?MIVKMnOl1
I/cjo`54^o_o003lo`2B/_l00<7o0DBk^?l1EMglo`MER=fZIZ[o0?ko0EG^mol1
EJ[go`54k__o02;jo`00[Ol00<7o0DBk^?l1EMglo`MER=fZIZ[o0?ko0EG^mol1
EJ[go`54k__o02;jo`00[Ol00<7o0DBk^?l1EMglo`MER=fZIZ[o0?ko0EG^mol1
EJ[go`54k__o02;jo`00o?l0T[;o0031o`5V^kSo0IVIo?l;4HSoR5Go^dCook^8
m_l18]ggo`6kR?co0LaVn_l00:go0031o`5V^kSo0IVIo?l;4HSoR5Go^dCook^8
m_l18]ggo`6kR?co0LaVn_l00:go0031o`5V^kSo0IVIo?l;4HSoR5Go^dCook^8
m_l18]ggo`6kR?co0LaVn_l00?co09Fbo`00`Ol1R;^go`1EoOl8g@3ModBIohQg
o_l1Mlcho`7^4OOo0NiEnol1Mlcjo`00[Ol00<7o0HRk]ol0EOgo2=d0gOm4VOn8
Moko0GO<n?l1kQ7go`7^EO_o0GO<n_l00:go0031o`68^kOo05Gmo`SM0=goA9Wo
R7Ono`5gc?So0NhAmol1kUGko`5gc?[o003lo`2H/_l00<7o0HS^]ol1R=gno`VZ
EOoo4NkoIYW<o_l1A>kio`6kA?Oo0EG^nol0EOWo002]o`00`Ol1R>jgo`68gOko
2JYEoolAk_mVVLcno`54k_Wo0K]4mol1ENkko`1EnOl00:go0031o`68k[Oo0HSM
o_l9ZUGooa7^ofJIc?ko0DC^nOl1^dCgo`5Ek__o05Gio`00o?l0V;;o0031o`1g
]_l1kWOno`UgR?o<<oooA7O^o_l1kUGio`68R?So0GO<nol1R;_io`00[Ol00<7o
07Nfo`7^Moko2GN8ol`coom4Mnkno`7^EOWo0HR8n?l1Mlcko`68^oWo002]o`00
`Ol0MkKo0Nigo_l9MhSoc3?oodAgk_ko0NiEnOl1R8Sho`5gc?_o0HRknOl00?co
082bo`00`Ol0MkGo0HS<n?l1gNklo`7<Mo[o0EGMnOl1VIWko`7^MoSo002]o`00
`Ol0MkGo0HS<n?l1gNklo`7<Mo[o0EGMnOl1VIWko`7^MoSo002]o`00`Ol0MkGo
0HS<n?l1gNklo`7<Mo[o0EGMnOl1VIWko`7^MoSo003lo`20/_l00<Co0gNIogNd
o`5Vk_7o0IVIo_l3kZ[^MoWo0Lagn_l1I^kho`00[Ol00<Co0gNIogNdo`5Vk_7o
0IVIo_l3kZ[^MoWo0Lagn_l1I^kho`00[Ol00<Co0gNIogNdo`5Vk_7o0IVIo_l3
kZ[^MoWo0Lagn_l1I^kho`00o?l0Mk;o0034o`<0A8SM]?l1gGO`o`JIk_oogHRZ
n?l0R?[o0HRkmol00:go0034o`<0A8SM]?l1gGO`o`JIk_oogHRZn?l0R?[o0HRk
mol00:go0034o`<0A8SM]?l1gGO`o`JIk_oogHRZn?l0R?[o0HRkmol00?co06:b
o`14o8P0gL[o0ZY4Z[;o0LbIf_l1c9Wlo`3Mo8P0A:go04ClR03Mb_l2ZTBZ/_l1
c9WJo`7<VOco0=glR014[Ol0A?b80=g:o`:ZA:Zbo`7<VM[o0LbIo?l0gOb804Cl
o`0>POn1oh7oPOn1oh7o/?l03X7oPOn1oh7oPOn1ok3o00j1oh7oPOn1oh7oPOn`
o`0>POn1oh7oPOn1oh7o/?l03X7oPOn1oh7oPOn1ok3o00j1oh7oPOn1oh7oPOn`
o`0>POn1oh7oPOn1oh7o/?l03X7oPOn1oh7oPOn1ok3o00j1oh7oPOn1oh7oPOn`
o`0>POn1oh7oPOn1oh7o/?l03X7oPOn1oh7oPOn1ok3o00j1oh7oPOn1oh7oPOn`
o`0>POn1oh7oPOn1oh7o/?l03X7oPOn1oh7oPOn1ok3o00j1oh7oPOn1oh7oPOn`
o`0>POn1oh7oPOn1oh7o/?l03X7oPOn1oh7oPOn1ok3o00j1oh7oPOn1oh7oPOn`
o`0>POn1oh7oPOn1oh7o/?l03X7oPOn1oh7oPOn1ok3o003o\>"], "Text",
  ImageSize->{283, 62},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell["\<\
where there are m=2 parents, and derives from this expressions for \
S (the chance of extinction) and \[Zeta] (the expoennt of the density P[w] \
for small w).  These expressions (10,11) depend on the distribution of \
f.\
\>", "Text"],

Cell["\<\
Draws interesting analogies with card shuffling and transmission of \
fluctuations through layers of granular material.\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["KAMMERLE,K.,1989 Looking forwards and backwards in a \
bisexual model.Journal of Applied Probability 27:880-885.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell["\<\
Gives the explicit solution for the biparental Moran model,and \
shows how it converges to a simple diffusion.  (A matter of simple \
combinatorics).  For example, the # of pairs t generations back who are \
ancestors of the current population is hypergeometric:\
\>", "Text"],

Cell[BoxData[
    FractionBox[
      RowBox[{
        RowBox[{"(", GridBox[{
              {"N"},
              {"i"}
              }], ")"}], 
        RowBox[{"(", GridBox[{
              {"N"},
              {\(i - 1\)}
              }], ")"}]}], 
      RowBox[{"(", GridBox[{
            {\(2  N\)},
            {\(N + 1\)}
            }], ")"}]]], "NumberedEquation"],

Cell[TextData[{
  "which is clustered around N/2; the mean is ",
  Cell[BoxData[
      \(TraditionalForm\`\((\(N + 1\)\/2)\)\)]],
  ", and the variance is ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          FormBox[\((\(N\^2 - 1\)\/\(4 \((2  N - 1)\)\))\),
            "TraditionalForm"], "~", \(N\/8\)}], TraditionalForm]]],
  "."
}], "Text"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.293651 0.015873 0.0147151 5.2878 [
[.18254 .00222 -6 -9 ]
[.18254 .00222 6 0 ]
[.34127 .00222 -6 -9 ]
[.34127 .00222 6 0 ]
[.5 .00222 -6 -9 ]
[.5 .00222 6 0 ]
[.65873 .00222 -6 -9 ]
[.65873 .00222 6 0 ]
[.81746 .00222 -6 -9 ]
[.81746 .00222 6 0 ]
[.97619 .00222 -6 -9 ]
[.97619 .00222 6 0 ]
[.01131 .12047 -24 -4.5 ]
[.01131 .12047 0 4.5 ]
[.01131 .22623 -24 -4.5 ]
[.01131 .22623 0 4.5 ]
[.01131 .33198 -24 -4.5 ]
[.01131 .33198 0 4.5 ]
[.01131 .43774 -24 -4.5 ]
[.01131 .43774 0 4.5 ]
[.01131 .5435 -18 -4.5 ]
[.01131 .5435 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .01472 m
.18254 .02097 L
s
[(30)] .18254 .00222 0 1 Mshowa
.34127 .01472 m
.34127 .02097 L
s
[(40)] .34127 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(50)] .5 .00222 0 1 Mshowa
.65873 .01472 m
.65873 .02097 L
s
[(60)] .65873 .00222 0 1 Mshowa
.81746 .01472 m
.81746 .02097 L
s
[(70)] .81746 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(80)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05556 .01472 m
.05556 .01847 L
s
.0873 .01472 m
.0873 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.15079 .01472 m
.15079 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.24603 .01472 m
.24603 .01847 L
s
.27778 .01472 m
.27778 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.37302 .01472 m
.37302 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.43651 .01472 m
.43651 .01847 L
s
.46825 .01472 m
.46825 .01847 L
s
.53175 .01472 m
.53175 .01847 L
s
.56349 .01472 m
.56349 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62698 .01472 m
.62698 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.72222 .01472 m
.72222 .01847 L
s
.75397 .01472 m
.75397 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.84921 .01472 m
.84921 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.9127 .01472 m
.9127 .01847 L
s
.94444 .01472 m
.94444 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .12047 m
.03006 .12047 L
s
[(0.02)] .01131 .12047 1 0 Mshowa
.02381 .22623 m
.03006 .22623 L
s
[(0.04)] .01131 .22623 1 0 Mshowa
.02381 .33198 m
.03006 .33198 L
s
[(0.06)] .01131 .33198 1 0 Mshowa
.02381 .43774 m
.03006 .43774 L
s
[(0.08)] .01131 .43774 1 0 Mshowa
.02381 .5435 m
.03006 .5435 L
s
[(0.1)] .01131 .5435 1 0 Mshowa
.125 Mabswid
.02381 .04115 m
.02756 .04115 L
s
.02381 .06759 m
.02756 .06759 L
s
.02381 .09403 m
.02756 .09403 L
s
.02381 .14691 m
.02756 .14691 L
s
.02381 .17335 m
.02756 .17335 L
s
.02381 .19979 m
.02756 .19979 L
s
.02381 .25267 m
.02756 .25267 L
s
.02381 .27911 m
.02756 .27911 L
s
.02381 .30554 m
.02756 .30554 L
s
.02381 .35842 m
.02756 .35842 L
s
.02381 .38486 m
.02756 .38486 L
s
.02381 .4113 m
.02756 .4113 L
s
.02381 .46418 m
.02756 .46418 L
s
.02381 .49062 m
.02756 .49062 L
s
.02381 .51706 m
.02756 .51706 L
s
.02381 .56993 m
.02756 .56993 L
s
.02381 .59637 m
.02756 .59637 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .01472 m
.03968 .01472 L
.05556 .01472 L
.07143 .01472 L
.0873 .01472 L
.10317 .01472 L
.11905 .01472 L
.13492 .01472 L
.15079 .01472 L
.16667 .01472 L
.18254 .01472 L
.19841 .01472 L
.21429 .01472 L
.23016 .01472 L
.24603 .01473 L
.2619 .01475 L
.27778 .01484 L
.29365 .01511 L
.30952 .01586 L
.3254 .01773 L
.34127 .02202 L
.35714 .03102 L
.37302 .04824 L
.38889 .07825 L
.40476 .12573 L
.42063 .19368 L
.43651 .281 L
.45238 .38051 L
.46825 .47877 L
.48413 .55849 L
.5 .60332 L
.51587 .60332 L
.53175 .55849 L
.54762 .47877 L
.56349 .38051 L
.57937 .281 L
.59524 .19368 L
.61111 .12573 L
.62698 .07825 L
.64286 .04824 L
.65873 .03102 L
.6746 .02202 L
.69048 .01773 L
.70635 .01586 L
.72222 .01511 L
.7381 .01484 L
.75397 .01475 L
.76984 .01473 L
.78571 .01472 L
.80159 .01472 L
Mistroke
.81746 .01472 L
.83333 .01472 L
.84921 .01472 L
.86508 .01472 L
.88095 .01472 L
.89683 .01472 L
.9127 .01472 L
.92857 .01472 L
.94444 .01472 L
.96032 .01472 L
.97619 .01472 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[6]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool00?moob5oo`00@7oo0`0017oo0P008Woo0`000goo0P008Goo0`0017oo0P008Woo0`0017oo0P00
8Woo00<007ooOol00goo0P008Goo0`0017oo0P0017oo000oOol01@00Oomoogoo00000Woo00@007oo
Ool0029oo`05001oogooOol00002Ool00`00Oomoo`0MOol01@00Oomoogoo00000Woo00@007ooOol0
021oo`05001oogooOol00002Ool01000Oomoo`008Goo00<007ooOol00Woo00@007ooOol001moo`05
001oogooOol00002Ool01000Oomoo`000goo0013Ool01000Oomoo`000Woo00<007ooOol07Goo1@00
0Woo00@007ooOol002=oo`04001oogoo0002Ool00`00Oomoo`0NOol01@00Oomoogoo00000Woo00@0
07ooOol0029oo`05001oogooOol00002Ool00`00Oomoo`0MOol01@00Oomoogoo00000Woo00@007oo
Ool000=oo`00@Goo0P000goo00@007ooOol001moo`04001oogoo0003Ool01000Oomoo`008goo00@0
07ooOol0009oo`03001oogoo01ioo`@000=oo`04001oogoo000ROol01@00Oomoogoo00000Woo00<0
07ooOol07Woo0`000goo00@007ooOol000=oo`00@goo00@007ooOol0009oo`03001oogoo01ioo`03
001oo`0000=oo`04001oogoo000OOol40003Ool01000Oomoo`0087oo00<007ooOol017oo00@007oo
Ool002=oo`04001oogoo0002Ool00`00Oomoo`0MOol01@00Oomoogoo00000Woo00@007ooOol000=o
o`00?goo00D007ooOomoo`00009oo`04001oogoo000QOol20003Ool01000Oomoo`007goo00<007oo
Ool017oo00@007ooOol0025oo`03001oogoo00=oo`04001oogoo000OOol01@00Oomoogoo00000Woo
00@007ooOol001moo`05001oogooOol00002Ool01000Oomoo`000goo0010Ool30004Ool2000SOol0
0`00Oomoo`02Ool2000POol50003Ool2000SOol20004Ool2000POol50003Ool2000QOol30004Ool2
0004Ool001]oo`03001oogoo0?moo`=oo`006goo00<007ooOol0ogoo0goo000KOol00`00Oomoo`3o
Ool3Ool001]oo`03001oogoo0?moo`=oo`0057ooo`003@00000KOol00`00Oomoo`05Ool00`00Oomo
o`06Ool00`00Oomoo`05Ool00`00Oomoo`06Ool00`00Oomoo`05Ool00`00Oomoo`05Ool00`00Oomo
o`06Ool00`00Oomoo`05Ool00`00Oomoo`06Ool00`00Oomoo`0400000goo001oo`07Ool00`00Oomo
o`05Ool00`00Oomoo`06Ool00`00Oomoo`05Ool00`00Oomoo`05Ool00`00Oomoo`06Ool00`00Oomo
o`05Ool00`00Oomoo`06Ool00`00Oomoo`05Ool00`00Oomoo`06Ool00`00Oomoo`03Ool40007Ool0
0`00Oomoo`05Ool00`00Oomoo`05Ool00`00Oomoo`06Ool00`00Oomoo`05Ool00`00Oomoo`06Ool0
0`00Oomoo`05Ool00`00Oomoo`06Ool00`00Oomoo`05Ool00`00Oomoo`05Ool001]oo`03001oogoo
02Moo`03001oogoo02Ioo`<002Qoo`03001oogoo02Qoo`03001oogoo00<002Aoo`03001oogoo02Mo
o`03001oogoo00Eoo`006goo00<007ooOol0Dgoo0P00DWoo0P00FGoo000KOol00`00Oomoo`1EOol0
0`00Oomoo`1>Ool00`00Oomoo`1IOol001]oo`03001oogoo05Ioo`03001oogoo04aoo`03001oogoo
05Yoo`006goo00<007ooOol0Egoo00<007ooOol0BWoo00<007ooOol0Fgoo000KOol2001IOol00`00
Oomoo`18Ool00`00Oomoo`1LOol001]oo`03001oogoo05Uoo`03001oogoo04Ioo`03001oogoo05eo
o`006goo00<007ooOol0FWoo00<007ooOol0A7oo00<007ooOol0GWoo000KOol00`00Oomoo`1JOol0
0`00Oomoo`14Ool00`00Oomoo`1NOol001]oo`03001oogoo05]oo`03001oogoo049oo`03001oogoo
05moo`006goo00<007ooOol0Fgoo00<007ooOol0@Woo00<007ooOol0Ggoo000KOol00`00Oomoo`1L
Ool00`00Oomoo`10Ool00`00Oomoo`1POol001]oo`8005eoo`03001oogoo041oo`03001oogoo061o
o`006goo00<007ooOol0GGoo00<007ooOol0?Woo00<007ooOol0HGoo000KOol00`00Oomoo`1MOol0
0`00Oomoo`0nOol00`00Oomoo`1QOol001]oo`03001oogoo05ioo`03001oogoo03aoo`03001oogoo
069oo`006goo00<007ooOol0GWoo00<007ooOol0?7oo00<007ooOol0HWoo000KOol00`00Oomoo`1O
Ool00`00Oomoo`0jOol00`00Oomoo`1SOol001]oo`03001oogoo05moo`03001oogoo03Yoo`03001o
ogoo06=oo`006goo0P00H7oo00<007ooOol0>Woo00<007ooOol0Hgoo000KOol00`00Oomoo`1POol0
0`00Oomoo`0hOol00`00Oomoo`1TOol001]oo`03001oogoo061oo`03001oogoo03Qoo`03001oogoo
06Aoo`006goo00<007ooOol0H7oo00<007ooOol0>7oo00<007ooOol0I7oo000KOol00`00Oomoo`1Q
Ool00`00Oomoo`0fOol00`00Oomoo`1UOol0009oo`8000Aoo`03001oogoo00=oo`80009oo`D000Ao
o`03001oogoo065oo`03001oogoo03Ioo`03001oogoo06Eoo`0000Eoo`00Oomoo`0000Qoo`04001o
ogoo0002Ool01000Oomoo`0017oo00<007ooOol0HGoo00<007ooOol0=Woo00<007ooOol0IGoo0000
1Goo001oogoo000027oo00@007ooOol000=oo`03001oogoo00Aoo`8006=oo`03001oogoo03Aoo`03
001oogoo06Ioo`0000Eoo`00Oomoo`0000Qoo`04001oogoo0004Ool00`00Oomoo`03Ool00`00Oomo
o`1ROol00`00Oomoo`0dOol00`00Oomoo`1VOol00005Ool007ooOol00008Ool01P00Oomoo`00Ool0
00=oo`03001oogoo009oo`03001oogoo069oo`03001oogoo03Aoo`03001oogoo06Ioo`0000Eoo`00
Oomoo`0000Qoo`06001oogoo001oo`000goo00<007ooOol00Woo00<007ooOol0HWoo00<007ooOol0
=7oo00<007ooOol0IWoo0002Ool2000:Ool20003Ool30005Ool00`00Oomoo`1SOol00`00Oomoo`0b
Ool00`00Oomoo`1WOol001]oo`03001oogoo06=oo`03001oogoo039oo`03001oogoo06Moo`006goo
00<007ooOol0Hgoo00<007ooOol0<Woo00<007ooOol0Igoo000KOol2001TOol00`00Oomoo`0bOol0
0`00Oomoo`1WOol001]oo`03001oogoo06=oo`03001oogoo039oo`03001oogoo06Moo`006goo00<0
07ooOol0I7oo00<007ooOol0<7oo00<007ooOol0J7oo000KOol00`00Oomoo`1TOol00`00Oomoo`0`
Ool00`00Oomoo`1XOol001]oo`03001oogoo06Aoo`03001oogoo031oo`03001oogoo06Qoo`006goo
00<007ooOol0I7oo00<007ooOol0<7oo00<007ooOol0J7oo000KOol00`00Oomoo`1TOol00`00Oomo
o`0`Ool00`00Oomoo`1XOol001]oo`8006Ioo`03001oogoo02ioo`03001oogoo06Uoo`006goo00<0
07ooOol0IGoo00<007ooOol0;Woo00<007ooOol0JGoo000KOol00`00Oomoo`1UOol00`00Oomoo`0^
Ool00`00Oomoo`1YOol001]oo`03001oogoo06Eoo`03001oogoo02ioo`03001oogoo06Uoo`006goo
00<007ooOol0IGoo00<007ooOol0;Woo00<007ooOol0JGoo000KOol00`00Oomoo`1VOol00`00Oomo
o`0/Ool00`00Oomoo`1ZOol001]oo`03001oogoo06Ioo`03001oogoo02aoo`03001oogoo06Yoo`00
6goo0P00Igoo00<007ooOol0;7oo00<007ooOol0JWoo000KOol00`00Oomoo`1VOol00`00Oomoo`0/
Ool00`00Oomoo`1ZOol001]oo`03001oogoo06Moo`03001oogoo02]oo`03001oogoo06Yoo`006goo
00<007ooOol0Igoo00<007ooOol0:Woo00<007ooOol0Jgoo000KOol00`00Oomoo`1WOol00`00Oomo
o`0ZOol00`00Oomoo`1[Ool0009oo`8000Aoo`03001oogoo00=oo`8000Aoo`<000Aoo`03001oogoo
06Moo`03001oogoo02Yoo`03001oogoo06]oo`0000Eoo`00Oomoo`0000Qoo`04001oogoo0004Ool0
0`00Oomoo`03Ool00`00Oomoo`1WOol00`00Oomoo`0ZOol00`00Oomoo`1[Ool00005Ool007ooOol0
0008Ool01@00Oomoo`00Ool01@0017oo0P00JGoo00<007ooOol0:Goo00<007ooOol0Jgoo00001Goo
001oogoo000027oo00H007ooOol007oo0002Ool00`00Oomoo`03Ool00`00Oomoo`1XOol00`00Oomo
o`0YOol00`00Oomoo`1[Ool00005Ool007ooOol00008Ool01000Oomoo`000Woo00<007oo00001Goo
00<007ooOol0J7oo00<007ooOol0:7oo00<007ooOol0K7oo00001Goo001oogoo000027oo00@007oo
Ool000=oo`8000Eoo`03001oogoo06Qoo`03001oogoo02Qoo`03001oogoo06aoo`000Woo0P002Woo
0P001Goo00<007ooOol00goo00<007ooOol0JGoo00<007ooOol09goo00<007ooOol0K7oo000KOol0
0`00Oomoo`1YOol00`00Oomoo`0WOol00`00Oomoo`1/Ool001]oo`03001oogoo06Uoo`03001oogoo
02Moo`03001oogoo06aoo`006goo0P00JWoo00<007ooOol09Woo00<007ooOol0KGoo000KOol00`00
Oomoo`1YOol00`00Oomoo`0VOol00`00Oomoo`1]Ool001]oo`03001oogoo06Yoo`03001oogoo02Eo
o`03001oogoo06eoo`006goo00<007ooOol0JWoo00<007ooOol09Goo00<007ooOol0KGoo000KOol0
0`00Oomoo`1ZOol00`00Oomoo`0UOol00`00Oomoo`1]Ool001]oo`03001oogoo06Yoo`03001oogoo
02Eoo`03001oogoo06eoo`006goo00<007ooOol0JWoo00<007ooOol097oo00<007ooOol0KWoo000K
Ool2001/Ool00`00Oomoo`0SOol00`00Oomoo`1^Ool001]oo`03001oogoo06]oo`03001oogoo02=o
o`03001oogoo06ioo`006goo00<007ooOol0Jgoo00<007ooOol08goo00<007ooOol0KWoo000KOol0
0`00Oomoo`1[Ool00`00Oomoo`0SOol00`00Oomoo`1^Ool001]oo`03001oogoo06]oo`03001oogoo
02=oo`03001oogoo06ioo`006goo00<007ooOol0K7oo00<007ooOol08Goo00<007ooOol0Kgoo000K
Ool00`00Oomoo`1/Ool00`00Oomoo`0QOol00`00Oomoo`1_Ool001]oo`8006eoo`03001oogoo025o
o`03001oogoo06moo`006goo00<007ooOol0K7oo00<007ooOol08Goo00<007ooOol0Kgoo000KOol0
0`00Oomoo`1/Ool00`00Oomoo`0QOol00`00Oomoo`1_Ool001]oo`03001oogoo06aoo`03001oogoo
021oo`03001oogoo071oo`006goo00<007ooOol0K7oo00<007ooOol087oo00<007ooOol0L7oo0002
Ool20004Ool00`00Oomoo`03Ool20003Ool30005Ool00`00Oomoo`1]Ool00`00Oomoo`0OOol00`00
Oomoo`1`Ool00005Ool007ooOol00008Ool01P00Oomoo`00Ool000=oo`03001oogoo009oo`03001o
ogoo06eoo`03001oogoo01moo`03001oogoo071oo`0000Eoo`00Oomoo`0000Qoo`06001oogoo001o
o`000goo00<007ooOol00Woo0P00KWoo00<007ooOol07goo00<007ooOol0L7oo00001Goo001oogoo
000027oo00D007ooOol007oo00@000Eoo`03001oogoo06eoo`03001oogoo01ioo`03001oogoo075o
o`0000Eoo`00Oomoo`0000Qoo`06001oogoo001oo`0027oo00<007ooOol0KGoo00<007ooOol07Woo
00<007ooOol0LGoo00001Goo001oogoo000027oo00@007ooOol0009oo`03001oogoo00Eoo`03001o
ogoo06eoo`03001oogoo01ioo`03001oogoo075oo`000Woo0P002Woo0P0017oo0P001Goo00<007oo
Ool0KWoo00<007ooOol07Goo00<007ooOol0LGoo000KOol00`00Oomoo`1^Ool00`00Oomoo`0MOol0
0`00Oomoo`1aOol001]oo`03001oogoo06ioo`03001oogoo01aoo`03001oogoo079oo`006goo0P00
Kgoo00<007ooOol077oo00<007ooOol0LWoo000KOol00`00Oomoo`1^Ool00`00Oomoo`0LOol00`00
Oomoo`1bOol001]oo`03001oogoo06ioo`03001oogoo01aoo`03001oogoo079oo`006goo00<007oo
Ool0KWoo00<007ooOol077oo00<007ooOol0LWoo000KOol00`00Oomoo`1_Ool00`00Oomoo`0JOol0
0`00Oomoo`1cOol001]oo`03001oogoo06moo`03001oogoo01Yoo`03001oogoo07=oo`006goo00<0
07ooOol0Kgoo00<007ooOol06Woo00<007ooOol0Lgoo000KOol2001`Ool00`00Oomoo`0JOol00`00
Oomoo`1cOol001]oo`03001oogoo06moo`03001oogoo01Yoo`03001oogoo07=oo`006goo00<007oo
Ool0Kgoo00<007ooOol06Woo00<007ooOol0Lgoo000KOol00`00Oomoo`1`Ool00`00Oomoo`0HOol0
0`00Oomoo`1dOol001]oo`03001oogoo071oo`03001oogoo01Qoo`03001oogoo07Aoo`006goo00<0
07ooOol0L7oo00<007ooOol067oo00<007ooOol0M7oo000KOol00`00Oomoo`1`Ool00`00Oomoo`0H
Ool00`00Oomoo`1dOol001]oo`80075oo`03001oogoo01Qoo`03001oogoo07Aoo`006goo00<007oo
Ool0L7oo00<007ooOol067oo00<007ooOol0M7oo000KOol00`00Oomoo`1`Ool00`00Oomoo`0HOol0
0`00Oomoo`1dOol001]oo`03001oogoo075oo`03001oogoo01Ioo`03001oogoo07Eoo`006goo00<0
07ooOol0LGoo00<007ooOol05Woo00<007ooOol0MGoo0002Ool20004Ool00`00Oomoo`03Ool20003
Ool30005Ool00`00Oomoo`1aOol00`00Oomoo`0FOol00`00Oomoo`1eOol00005Ool007ooOol00008
Ool01P00Oomoo`00Ool000=oo`03001oogoo009oo`03001oogoo075oo`03001oogoo01Ioo`03001o
ogoo07Eoo`0000Eoo`00Oomoo`0000Qoo`06001oogoo001oo`000goo00<007ooOol00Woo0P00LWoo
00<007ooOol05Woo00<007ooOol0MGoo00001Goo001oogoo000027oo00@007ooOol0009oo`<000Eo
o`03001oogoo075oo`03001oogoo01Ioo`03001oogoo07Eoo`0000Eoo`00Oomoo`0000Qoo`06001o
ogoo001oo`000goo00<007ooOol00Woo00<007ooOol0LWoo00<007ooOol057oo00<007ooOol0MWoo
00001Goo001oogoo000027oo00H007ooOol007oo0003Ool00`00Oomoo`02Ool00`00Oomoo`1bOol0
0`00Oomoo`0DOol00`00Oomoo`1fOol0009oo`8000Yoo`8000=oo`<000Eoo`03001oogoo079oo`03
001oogoo01Aoo`03001oogoo07Ioo`006goo00<007ooOol0LWoo00<007ooOol057oo00<007ooOol0
MWoo000KOol00`00Oomoo`1bOol00`00Oomoo`0DOol00`00Oomoo`1fOol001]oo`03001oogoo079o
o`03001oogoo01Aoo`03001oogoo07Ioo`006goo0P00Lgoo00<007ooOol057oo00<007ooOol0MWoo
000KOol00`00Oomoo`1cOol00`00Oomoo`0BOol00`00Oomoo`1gOol001]oo`03001oogoo07=oo`03
001oogoo019oo`03001oogoo07Moo`006goo00<007ooOol0Lgoo00<007ooOol04Woo00<007ooOol0
Mgoo000KOol00`00Oomoo`1cOol00`00Oomoo`0BOol00`00Oomoo`1gOol001]oo`03001oogoo07=o
o`03001oogoo019oo`03001oogoo07Moo`006goo00<007ooOol0Lgoo00<007ooOol04Woo00<007oo
Ool0Mgoo000KOol2001eOol00`00Oomoo`0@Ool00`00Oomoo`1hOol001]oo`03001oogoo07Aoo`03
001oogoo011oo`03001oogoo07Qoo`006goo00<007ooOol0M7oo00<007ooOol047oo00<007ooOol0
N7oo000KOol00`00Oomoo`1dOol00`00Oomoo`0@Ool00`00Oomoo`1hOol001]oo`03001oogoo07Ao
o`03001oogoo011oo`03001oogoo07Qoo`006goo00<007ooOol0MGoo00<007ooOol03Woo00<007oo
Ool0NGoo000KOol00`00Oomoo`1eOol00`00Oomoo`0>Ool00`00Oomoo`1iOol001]oo`8007Ioo`03
001oogoo00ioo`03001oogoo07Uoo`006goo00<007ooOol0MGoo00<007ooOol03Woo00<007ooOol0
NGoo000KOol00`00Oomoo`1eOol00`00Oomoo`0>Ool00`00Oomoo`1iOol001]oo`03001oogoo07Eo
o`03001oogoo00ioo`03001oogoo07Uoo`0027oo0P0017oo00<007ooOol00Woo0`001Goo00<007oo
Ool0MWoo00<007ooOol037oo00<007ooOol0NWoo0007Ool01000Oomoo`002Goo00<007ooOol017oo
00<007ooOol0MWoo00<007ooOol037oo00<007ooOol0NWoo0007Ool01000Oomoo`002Goo00<007oo
Ool017oo00<007ooOol0MWoo00<007ooOol037oo00<007ooOol0NWoo0007Ool01000Oomoo`002Goo
00<007ooOol017oo0P00Mgoo00<007ooOol037oo00<007ooOol0NWoo0007Ool01000Oomoo`002Goo
00<007ooOol017oo00<007ooOol0MWoo00<007ooOol037oo00<007ooOol0NWoo0007Ool01000Oomo
o`0027oo0P001Woo00<007ooOol0Mgoo00<007ooOol02Woo00<007ooOol0Ngoo0008Ool2000:Ool0
0`00Oomoo`04Ool00`00Oomoo`1gOol00`00Oomoo`0:Ool00`00Oomoo`1kOol001]oo`03001oogoo
07Moo`03001oogoo00Yoo`03001oogoo07]oo`006goo00<007ooOol0Mgoo00<007ooOol02Woo00<0
07ooOol0Ngoo000KOol00`00Oomoo`1hOol00`00Oomoo`08Ool00`00Oomoo`1lOol001]oo`8007Uo
o`03001oogoo00Qoo`03001oogoo07aoo`006goo00<007ooOol0N7oo00<007ooOol027oo00<007oo
Ool0O7oo000KOol00`00Oomoo`1iOol00`00Oomoo`06Ool00`00Oomoo`1mOol001]oo`03001oogoo
07Uoo`03001oogoo00Ioo`03001oogoo07eoo`006goo00<007ooOol0NGoo00<007ooOol01Woo00<0
07ooOol0OGoo000KOol00`00Oomoo`1jOol00`00Oomoo`04Ool00`00Oomoo`1nOol001]oo`03001o
ogoo07Yoo`03001oogoo00Aoo`03001oogoo07ioo`006goo0P00Ngoo00<007ooOol017oo00<007oo
Ool0OWoo000KOol00`00Oomoo`1kOol00`00Oomoo`02Ool00`00Oomoo`1oOol001]oo`03001oogoo
07]oo`H0085oo`006goo00<007ooOol0ogoo0goo000KOol00`00Oomoo`3oOol3Ool001]oo`03001o
ogoo0?moo`=oo`00ogoo8Goo003oOolQOol00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {13.5282, -0.010229, \
0.236837, 0.000710941}}],

Cell["\<\
In this model,all the ancestors make up about half of the ancient \
population.(Contrasts with 80% for the WF model)\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["KAMMERLE,K.,1991 The extinction probability of \
descendants in bisexual models of fixed population size.Journal of Applied \
Probability 28:489-502.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell["\<\
Shows that the extinction probability in the biparental WF model \
can be approximated by the branching process in the limit of large N.  \
\>", \
"Text"],

Cell[TextData[{
  "Note: ",
  StyleBox[" This is not all that helpful,because it is not clear how large N \
needs to be before the brannchiong process approximation applies.",
    FontWeight->"Plain"]
}], "Text",
  FontWeight->"Bold"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["MOHLE, M.,1994 Forward and backward processes in \
bisexual models with fixed population sizes. Journal of Applied Probability \
31: 309-332.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell["\<\
Extends Kammerle's previous results to allow separate sexes.  \
\
\>", "Text"]
}, Closed]],

Cell[TextData[StyleBox["MOHLE, M., 1997 Fixation in bisexual models with \
variable population sizes. Journal of Applied Probability 34: 436-448.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell["Ancestry in  the distant past", "SubsectionIcon"],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["D",
    FontFamily->"Geneva"],
  StyleBox["ERRIDA",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", B., and B. J",
    FontFamily->"Geneva"],
  StyleBox["UNG",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox["-M",
    FontFamily->"Geneva"],
  StyleBox["ULLER",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", 1999 The genealogical tree of a chromosome. Journal of \
Statistical Physics ",
    FontFamily->"Geneva"],
  StyleBox["94:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 277-298.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[{
  "A clearly presented analysis of the coalescent with recombination, \
concentrating on the first few moments, and parallel to Wiuf & Hein (",
  ButtonBox["1997",
    ButtonData:>"Wiuf & Hein 1997",
    ButtonStyle->"AddOnsLink"],
  ") (who they quote)."
}], "Text"],

Cell["\<\
Consider a configuration such as {1,1,2,2,3,1,2,3,1,4}, which \
states which parts of a genome derive from ancestors 1-4 at some time in the \
past.  Coalescence causes a random pair to merge (eg \
{1,2}\[Implies]{1,1,1,1,3,1,2,3,1,4}), and recombination causes a pair to \
change (eg in {1}\[Implies]{1,5,2,2,3,1,2,3,1,4}).  Thisis a simpler way \
topresent the algorithm than to consider the whole graph, and is adequate to \
find the steady state.t\
\>", "Text"],

Cell[TextData[{
  "Statistics are taken by analogy with spin glass problems.  Let ",
  Cell[BoxData[
      \(TraditionalForm\`n\_i\)]],
  " be the # of sites which have the same ancestor as site ",
  Cell[BoxData[
      \(TraditionalForm\`i\)]],
  ".  Then:"
}], "Text"],

Cell[BoxData[{
    \(Q = \[Sum]\+\(i = 1\)\%L 1\/n\_i\ is\ the\ #\ of\ ancestors; \ \
\[LeftAngleBracket]Q\[RightAngleBracket] = \(\[Sum]\+\(i = 1\)\%L\
\[LeftAngleBracket]1\/n\_i\ \[RightAngleBracket]\ \ \ \ var \((Q)\) = \
\[Sum]\+\(i = 1\)\%L\(\[Sum]\+\(j = 1\)\%L\((\[LeftAngleBracket]1\/\(\(n\_i\) \
n\_j\)\ \[RightAngleBracket] - \[LeftAngleBracket]1\/n\_i\ \
\[RightAngleBracket] \[LeftAngleBracket]1\/n\_j\ \
\[RightAngleBracket])\)\)\)\), "\[IndentingNewLine]", 
    \(Y = \[Sum]\+\(i = 1\)\%L n\_i\/L\^2\ is\ the\ chance\ that\ two\ random\
\ sites\ belong\ to\ the\ same\ ancestor\), "\[IndentingNewLine]", 
    \(S = \(L - \[Sum]\+\(i = 1\)\%\(L - 1\)\[Delta]\_\(\[Tau]\_i, \
\[Tau]\_\(i + 1\)\)\  = \[Sum]\+\(i = 1\)\%L 1\/l\_i\ is\ the\ #\ of\ \
segments\), \ 
    where\ l\_i\ is\ the\ length\ ofthe\ segment\ in\ which\ site\ \
i\ \ sits\), "\[IndentingNewLine]", 
    \(Z = \[Sum]\+\(i = 1\)\%L l\_i\/L\^2\ is\ the\ chance\ that\ two\ random\
\ sites\ are\ in\ the\ same\ segment\), "\[IndentingNewLine]", 
    \(\[LeftAngleBracket]n\_i\[RightAngleBracket] = \[Sum]\+\(J = 1\)\%L \
P\_\(i, j\)\ etc . \ \ \((P\_\(i, j; k, l\)\ also\ defined)\)\)}], \
"NumberedEquation"],

Cell[BoxData[
    RowBox[{
      StyleBox["Note",
        FontFamily->"Times",
        FontWeight->"Bold"], 
      StyleBox[":",
        FontFamily->"Times",
        FontWeight->"Bold"], 
      StyleBox[" ",
        FontFamily->"Times",
        FontWeight->"Bold"], 
      StyleBox[\(these\ are\ just\ classical\ IBD\ coefficients\),
        FontFamily->"Times"]}]], "Text"],

Cell[TextData[{
  "The number of configurations ",
  Cell[BoxData[
      \(TraditionalForm\`\[CapitalOmega]\_L = \(\(\[Sum]\+\(k = 
                1\)\%L\)\(\(\[Omega]\_L\) \((k)\)\)\(\ \)\)\)]],
  "where ",
  Cell[BoxData[
      \(TraditionalForm\`\[Omega]\_L\)]],
  " is the number of configurations of L sites with k colours (a Stirling # \
of the second kind); ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          FormBox[\(\[Omega]\_L = k\ \(\(\[Omega]\_\(L - 1\)\) \((k)\)\)\),
            "TraditionalForm"], 
          "+", \(\(\[Omega]\_\(L - 1\)\) \((k - 1)\)\)}], TraditionalForm]]],
  ".  One can write down a set of linear equations for the frequency of each \
configuration (cf Wiuf & Hein).  For example, ",
  Cell[BoxData[
      \(TraditionalForm\`w\_123 = 
        2 \(\( r\^2\) \((1 + 2  r)\)\)\/\(\((1 + r)\) \((1 + 2  r)\) \((3 + 2 \
 r)\)\)\)]],
  " for three sites;numericalsolutions are feasible up to 8 sites.  "
}], "Text"],

Cell[TextData[{
  "Moments can be calculated as expansions in r,and the limit of r\[Rule]0, L\
\[Rule]\[Infinity] can be taken.  For example, ",
  Cell[BoxData[
      \(TraditionalForm\`var \((S)\) = 
        R + \(1\/3\) R\^2 - \(5\/27\) \(R\^3\) \[Ellipsis]\)]]
}], "Text"],

Cell[TextData[{
  "Going beyond the series expansions, the correlation functions can be \
calculated exactly.  For example: ",
  Cell[BoxData[
      \(TraditionalForm\`P\_\(i, j\) = 1/\((1 + r | j - i | )\)\)]],
  ".  This leads in the limit to:"
}], "Text"],

Cell[BoxData[
    \(\[LeftAngleBracket]Y\[RightAngleBracket] = \(2 \(\((1 + R)\) Log[1 + R] \
- R\)\/R\^2\ \ \ \ \[LeftAngleBracket]S\[RightAngleBracket] = 
        1 + R\)\)], "NumberedEquation"],

Cell["\<\
D&JM note a discrepancy from Wiuf & Hein's approximation for \
var(S): they apply for large vs small R.\
\>", "Text"],

Cell[TextData[{
  "Consider a mean field approximation, which amounts to setting ",
  Cell[BoxData[
      \(TraditionalForm\`\[LeftAngleBracket]1\/n\_i\[RightAngleBracket] = 
        1\/\[LeftAngleBracket]n\_i\[RightAngleBracket]\)]],
  ".  We have"
}], "Text"],

Cell[TextData[{
  " ",
  Cell[BoxData[
      \(TraditionalForm\`\[LeftAngleBracket]n\_i\[RightAngleBracket] = \[Sum]\
\+\(j = 1\)\%L 1\/\(1 + r | j - i | \)\)]],
  "\[Tilde]",
  Cell[BoxData[
      \(TraditionalForm\`\(Log[1 + r\ i] + Log[1 + R \((L - i)\)]\)\/r\)]]
}], "NumberedEquation"],

Cell["\<\
leading to a meanfield approximation for \[LeftAngleBracket]Q\
\[RightAngleBracket], which turns out poorly.  Suggests using higher moments \
to get a better approximation.\
\>", "Text"],

Cell[TextData[{
  "Note: ",
  StyleBox["this amounts to just using pairwise linkage disequilibrium to \
solve the problem",
    FontWeight->"Plain"]
}], "Text",
  FontWeight->"Bold"],

Cell[TextData[{
  "A continuous limit is presented, giving the probabilities of A, B[x], \
{C[x,y],D[x,y]} etc and gives integral equations for these.  That leads to \
expansions in ",
  Cell[BoxData[
      \(TraditionalForm\`\(o \((R\^4)\)\)\ \(\(and\)\(:\)\)\)]],
  " "
}], "Text"],

Cell[TextData[Cell[BoxData[
    \(TraditionalForm\`\[LeftAngleBracket]Q\[RightAngleBracket] = 
      1 + R - R\^2\/3 + \(13\/54\) R\^3 + 
        O \((R\^4)\)\)]]], "NumberedEquation"],

Cell[TextData[{
  "Simulations are done,using typically ",
  Cell[BoxData[
      \(TraditionalForm\`10\^5\)]],
  " realisations."
}], "Text"]
}, Closed]],

Cell[TextData[{
  StyleBox["W",
    FontFamily->"Geneva"],
  StyleBox["IUF",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", C., and J. H",
    FontFamily->"Geneva"],
  StyleBox["EIN",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", 1997 On the number of ancestors to a DNA sequence. Genetics ",
    FontFamily->"Geneva"],
  StyleBox["147:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 1459-1468.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain",
  CellTags->"Wiuf & Hein 1997"]
}, Closed]],

Cell[CellGroupData[{

Cell["Coalescent with recombination", "SubsectionIcon"],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["G",
    FontFamily->"Geneva"],
  StyleBox["RIFFITHS",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", R. C., 1999 The time to the ancestor along sequences with \
recombination. Theoretical Population Biology ",
    FontFamily->"Geneva"],
  StyleBox["55:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 137-144.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell["\<\
Presents an algorithm for estimating the time to MRCA, conditional \
on the observed mutations, and allowing for recombinatiion.\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["G",
    FontFamily->"Geneva"],
  StyleBox["RIFFITHS",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", R. C., and P. M",
    FontFamily->"Geneva"],
  StyleBox["ARJORAM",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", 1996 Ancestral inference from samples of DNA sequences with \
recombination. Journal of Computational Biology ",
    FontFamily->"Geneva"],
  StyleBox["3:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 479\[Dash]502.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell["\<\
Detailed presentation of an algorithm for calculating the \
likelihood of a dataset, allowing for mutation and recombination.\
\>", "Text"]
}, Closed]],

Cell[TextData[{
  StyleBox["H",
    FontFamily->"Geneva"],
  StyleBox["UDSON",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", R. R., 1983 Properties of the neutral allele model with \
intergenic recombination. Theoretical Population Biology ",
    FontFamily->"Geneva"],
  StyleBox["23:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 183-201.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["Hudson, R.  1990.  Gene genealogies and the \
coalescent process. Oxford Surveys in Evolutionary Biology 7:1-44.",
  FontWeight->"Plain"]], "SubsubsectionIcon",
  CellTags->"Hudson 1990"],

Cell[TextData[{
  StyleBox["H",
    FontFamily->"Geneva"],
  StyleBox["UDSON",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", R. R., and N. L. K",
    FontFamily->"Geneva"],
  StyleBox["APLAN",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", 1985 Statistical Properties of the Number of Recombination \
Events in the History of a Sample of DNA-Sequences. Genetics ",
    FontFamily->"Geneva"],
  StyleBox["111:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 147-164.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["KAPLAN, N., R. R. HUDSON and M. IIZUKA, 1991 The \
coalescent process in models with selection, recombination and geographic \
subdivision. Genetical Research 57: 83-91.",
  FontFamily->"Geneva"]], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[StyleBox["NIELSEN, R., 2000 Estimation of population parameters \
and recombination rates from single nucleotide polymorphisms. Genetics 154: \
931-942.",
  FontFamily->"Geneva",
  FontWeight->"Plain"]], "SubsubsectionIcon"],

Cell[TextData[{
  StyleBox["N",
    FontFamily->"Geneva"],
  StyleBox["ORDBORG",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", M., 2000 Linkage disequilibrium, gene trees and selfing: An \
ancestral recombination graph with partial self-fertilization. Genetics ",
    FontFamily->"Geneva"],
  StyleBox["154:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 923-929.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[{
  StyleBox["S",
    FontFamily->"Geneva"],
  StyleBox["IMONSEN",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", K. L., and G. A. C",
    FontFamily->"Geneva"],
  StyleBox["HURCHILL",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", 1997 A Markov chain model of coalescence with recombination. \
Theoretical Population Biology ",
    FontFamily->"Geneva"],
  StyleBox["52:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 43-59.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[{
  StyleBox["W",
    FontFamily->"Geneva"],
  StyleBox["IUF",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", C., and J. H",
    FontFamily->"Geneva"],
  StyleBox["EIN",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", 1999 The ancestry of a sample of sequences subject to \
recombination. Genetics ",
    FontFamily->"Geneva"],
  StyleBox["151:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 1217-1228.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[{
  StyleBox["W",
    FontFamily->"Geneva"],
  StyleBox["IUF",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", C., and J. H",
    FontFamily->"Geneva"],
  StyleBox["EIN",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", 1999 Recombination as a point process along sequences. \
Theoretical Population Biology ",
    FontFamily->"Geneva"],
  StyleBox["55:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 248-259.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain",
  CellTags->"Wiuf & Hein 1999"],

Cell[TextData[{
  StyleBox["W",
    FontFamily->"Geneva"],
  StyleBox["OLLENBERG",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", K., and J. C. A",
    FontFamily->"Geneva"],
  StyleBox["VISE",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", 1998 Sampling properties of genealogical pathways underlying \
population pedigrees. Evolution ",
    FontFamily->"Geneva"],
  StyleBox["52:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 957-966.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["Z",
    FontFamily->"Geneva"],
  StyleBox["OLLNER",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", S., and A. ",
    FontFamily->"Geneva"],
  StyleBox["VON",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[" H",
    FontFamily->"Geneva"],
  StyleBox["AESELER",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", 2000 A coalescent approach to study linkage disequilibrium \
between single-nucleotide polymorphisms. American Journal of Human Genetics ",
    
    FontFamily->"Geneva"],
  StyleBox["66:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 615-628.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell["\<\
A simulation study of associations between disease and marker \
alleles.  Does not implement the full coalescent with recombination.  Rather, \
the genealogy of the disease locus is drawn, and then associated markers are \
recombined.  It is not at all clear to me that this captures the full \
process.\
\>", "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Disequilibrium across the genome", "SubsectionIcon"],

Cell[TextData[{
  StyleBox["W",
    FontFamily->"Geneva"],
  StyleBox["ALL",
    FontFamily->"Geneva",
    FontSize->9],
  StyleBox[", J. D., 2001 Insights from linked single nucleotide \
polymorphisms: what we can learn from linkage disequilibrium. Current Opinion \
in Genetics & Development ",
    FontFamily->"Geneva"],
  StyleBox["11:",
    FontFamily->"Geneva",
    FontWeight->"Bold"],
  StyleBox[" 647-651.",
    FontFamily->"Geneva"]
}], "SubsubsectionIcon",
  FontWeight->"Plain"],

Cell[TextData[{
  StyleBox["M",
    FontFamily->"Geneva",
    FontWeight->"Plain"],
  StyleBox["C",
    FontFamily->"Geneva",
    FontSize->9,
    FontWeight->"Plain"],
  StyleBox["I",
    FontFamily->"Geneva",
    FontWeight->"Plain"],
  StyleBox["NTYRE",
    FontFamily->"Geneva",
    FontSize->9,
    FontWeight->"Plain"],
  StyleBox[", L. M., E. R. M",
    FontFamily->"Geneva",
    FontWeight->"Plain"],
  StyleBox["ARTIN",
    FontFamily->"Geneva",
    FontSize->9,
    FontWeight->"Plain"],
  StyleBox[", K. L. S",
    FontFamily->"Geneva",
    FontWeight->"Plain"],
  StyleBox["IMONSEN",
    FontFamily->"Geneva",
    FontSize->9,
    FontWeight->"Plain"],
  StyleBox[" and N. L. K",
    FontFamily->"Geneva",
    FontWeight->"Plain"],
  StyleBox["APLAN",
    FontFamily->"Geneva",
    FontSize->9,
    FontWeight->"Plain"],
  StyleBox[", 2000 Circumventing multiple testing: A multilocus Monte Carlo \
approach to testing for association. Genetic Epidemiology 19: 18-29.",
    FontFamily->"Geneva",
    FontWeight->"Plain"]
}], "SubsubsectionIcon"]
}, Closed]]
},
FrontEndVersion->"4.0 for Macintosh",
ScreenRectangle->{{0, 1024}, {0, 748}},
WindowSize->{950, 635},
WindowMargins->{{Automatic, 8}, {Automatic, 27}},
StyleDefinitions -> "HelpBrowser.nb",
MacintoshSystemPageSetup->"\<\
00h0001804P000000b02<?oaonl3>@91H`85N0?N0@00005X0FP000003j0:l001
0@00I00100000@0200000BL?00400000000000000000010000000000000@0?ne
oj/@7@]500P1000000000000000001T1\>"
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Kuhner et al 2000"->{
    Cell[4562, 150, 698, 26, 42, "SubsubsectionIcon",
      CellTags->"Kuhner et al 2000"]},
  "Wiuf & Hein 1997"->{
    Cell[92493, 2106, 544, 20, 21, "SubsubsectionIcon",
      CellTags->"Wiuf & Hein 1997"]},
  "Hudson 1990"->{
    Cell[94982, 2205, 211, 3, 23, "SubsubsectionIcon",
      CellTags->"Hudson 1990"]},
  "Wiuf & Hein 1999"->{
    Cell[97857, 2305, 569, 21, 25, "SubsubsectionIcon",
      CellTags->"Wiuf & Hein 1999"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Kuhner et al 2000", 102557, 2476},
  {"Wiuf & Hein 1997", 102674, 2479},
  {"Hudson 1990", 102787, 2482},
  {"Wiuf & Hein 1999", 102899, 2485}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 58, 0, 36, "SubsectionIcon"],
Cell[1800, 53, 780, 30, 42, "SubsubsectionIcon"],

Cell[CellGroupData[{
Cell[2605, 87, 220, 3, 25, "SubsubsectionIcon"],
Cell[2828, 92, 588, 11, 51, "Text"]
}, Closed]],
Cell[3431, 106, 596, 20, 38, "SubsubsectionIcon"],
Cell[4030, 128, 529, 20, 25, "SubsubsectionIcon"],
Cell[4562, 150, 698, 26, 42, "SubsubsectionIcon",
  CellTags->"Kuhner et al 2000"],
Cell[5263, 178, 658, 25, 25, "SubsubsectionIcon"],
Cell[5924, 205, 442, 15, 25, "SubsubsectionIcon"],
Cell[6369, 222, 680, 25, 42, "SubsubsectionIcon"]
}, Closed]],

Cell[CellGroupData[{
Cell[7086, 252, 60, 0, 26, "SubsectionIcon"],
Cell[7149, 254, 449, 15, 25, "SubsubsectionIcon"],
Cell[7601, 271, 280, 4, 42, "SubsubsectionIcon"],
Cell[7884, 277, 274, 4, 42, "SubsubsectionIcon"],
Cell[8161, 283, 210, 3, 25, "SubsubsectionIcon"],
Cell[8374, 288, 242, 4, 25, "SubsubsectionIcon"],
Cell[8619, 294, 185, 3, 25, "SubsubsectionIcon"],
Cell[8807, 299, 252, 4, 42, "SubsubsectionIcon"],
Cell[9062, 305, 211, 3, 25, "SubsubsectionIcon"],
Cell[9276, 310, 246, 4, 42, "SubsubsectionIcon"],
Cell[9525, 316, 306, 5, 42, "SubsubsectionIcon"],
Cell[9834, 323, 339, 5, 42, "SubsubsectionIcon"],
Cell[10176, 330, 215, 3, 25, "SubsubsectionIcon"],
Cell[10394, 335, 185, 3, 25, "SubsubsectionIcon"],
Cell[10582, 340, 338, 5, 42, "SubsubsectionIcon"],
Cell[10923, 347, 273, 4, 42, "SubsubsectionIcon"],
Cell[11199, 353, 262, 4, 42, "SubsubsectionIcon"],
Cell[11464, 359, 191, 3, 25, "SubsubsectionIcon"],
Cell[11658, 364, 251, 4, 42, "SubsubsectionIcon"],
Cell[11912, 370, 266, 4, 42, "SubsubsectionIcon"],
Cell[12181, 376, 248, 4, 42, "SubsubsectionIcon"],
Cell[12432, 382, 231, 4, 25, "SubsubsectionIcon"]
}, Closed]],

Cell[CellGroupData[{
Cell[12700, 391, 43, 0, 26, "SubsectionIcon"],

Cell[CellGroupData[{
Cell[12768, 395, 436, 15, 25, "SubsubsectionIcon"],
Cell[13207, 412, 101, 3, 22, "Text"],
Cell[13311, 417, 698, 15, 51, "Text"],
Cell[14012, 434, 106, 3, 22, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[14155, 442, 654, 25, 21, "SubsubsectionIcon"],
Cell[14812, 469, 254, 5, 44, "Text"],
Cell[15069, 476, 88, 1, 44, "NumberedEquation"],
Cell[15160, 479, 28407, 439, 235, "Text"],
Cell[43570, 920, 48, 0, 22, "Text"],
Cell[43621, 922, 107, 2, 45, "NumberedEquation"],
Cell[43731, 926, 375, 10, 51, "Text"],
Cell[44109, 938, 240, 6, 22, "Text"],
Cell[44352, 946, 347, 6, 60, "NumberedEquation"],
Cell[44702, 954, 189, 5, 24, "Text"],
Cell[44894, 961, 178, 7, 22, "Text"],
Cell[45075, 970, 113, 3, 22, "Text"],
Cell[45191, 975, 168, 6, 24, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[45396, 986, 673, 25, 38, "SubsubsectionIcon"],
Cell[46072, 1013, 430, 7, 80, "Text"],
Cell[46505, 1022, 7781, 121, 36, 7685, 118, "GraphicsData", "PICT", \
"Graphics"],
Cell[54289, 1145, 71, 0, 22, "Text"],
Cell[54363, 1147, 177, 6, 24, "Text"],
Cell[54543, 1155, 97, 3, 22, "Text"],
Cell[54643, 1160, 11298, 175, 70, 11207, 172, "GraphicsData", "PICT", \
"Text"],
Cell[65944, 1337, 245, 5, 36, "Text"],
Cell[66192, 1344, 143, 3, 22, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[66372, 1352, 208, 3, 21, "SubsubsectionIcon"],
Cell[66583, 1357, 286, 5, 36, "Text"],
Cell[66872, 1364, 371, 14, 75, "NumberedEquation"],
Cell[67246, 1380, 352, 11, 41, "Text"],
Cell[67601, 1393, 16707, 460, 184, 4327, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[84311, 1855, 140, 3, 22, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[84488, 1863, 245, 4, 38, "SubsubsectionIcon"],
Cell[84736, 1869, 164, 4, 22, "Text"],
Cell[84903, 1875, 234, 6, 24, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[85174, 1886, 237, 4, 21, "SubsubsectionIcon"],
Cell[85414, 1892, 88, 3, 22, "Text"]
}, Closed]],
Cell[85517, 1898, 217, 3, 21, "SubsubsectionIcon"]
}, Closed]],

Cell[CellGroupData[{
Cell[85771, 1906, 55, 0, 26, "SubsectionIcon"],

Cell[CellGroupData[{
Cell[85851, 1910, 637, 25, 25, "SubsubsectionIcon"],
Cell[86491, 1937, 283, 7, 23, "Text"],
Cell[86777, 1946, 475, 8, 50, "Text"],
Cell[87255, 1956, 270, 8, 22, "Text"],
Cell[87528, 1966, 1187, 19, 213, "NumberedEquation"],
Cell[88718, 1987, 374, 12, 22, "Text"],
Cell[89095, 2001, 957, 23, 92, "Text"],
Cell[90055, 2026, 275, 6, 36, "Text"],
Cell[90333, 2034, 258, 6, 22, "Text"],
Cell[90594, 2042, 196, 3, 44, "NumberedEquation"],
Cell[90793, 2047, 127, 3, 22, "Text"],
Cell[90923, 2052, 261, 6, 38, "Text"],
Cell[91187, 2060, 290, 8, 53, "NumberedEquation"],
Cell[91480, 2070, 196, 4, 22, "Text"],
Cell[91679, 2076, 182, 6, 24, "Text"],
Cell[91864, 2084, 283, 7, 24, "Text"],
Cell[92150, 2093, 184, 3, 45, "NumberedEquation"],
Cell[92337, 2098, 141, 5, 24, "Text"]
}, Closed]],
Cell[92493, 2106, 544, 20, 21, "SubsubsectionIcon",
  CellTags->"Wiuf & Hein 1997"]
}, Closed]],

Cell[CellGroupData[{
Cell[93074, 2131, 55, 0, 26, "SubsectionIcon"],

Cell[CellGroupData[{
Cell[93154, 2135, 442, 15, 25, "SubsubsectionIcon"],
Cell[93599, 2152, 152, 3, 22, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[93788, 2160, 576, 20, 38, "SubsubsectionIcon"],
Cell[94367, 2182, 149, 3, 22, "Text"]
}, Closed]],
Cell[94531, 2188, 448, 15, 21, "SubsubsectionIcon"],
Cell[94982, 2205, 211, 3, 23, "SubsubsectionIcon",
  CellTags->"Hudson 1990"],
Cell[95196, 2210, 582, 20, 42, "SubsubsectionIcon"],
Cell[95781, 2232, 265, 4, 42, "SubsubsectionIcon"],
Cell[96049, 2238, 238, 4, 25, "SubsubsectionIcon"],
Cell[96290, 2244, 470, 15, 42, "SubsubsectionIcon"],
Cell[96763, 2261, 556, 20, 25, "SubsubsectionIcon"],
Cell[97322, 2283, 532, 20, 25, "SubsubsectionIcon"],
Cell[97857, 2305, 569, 21, 25, "SubsubsectionIcon",
  CellTags->"Wiuf & Hein 1999"],
Cell[98429, 2328, 554, 20, 25, "SubsubsectionIcon"],

Cell[CellGroupData[{
Cell[99008, 2352, 703, 26, 42, "SubsubsectionIcon"],
Cell[99714, 2380, 327, 6, 36, "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[100090, 2392, 58, 0, 26, "SubsectionIcon"],
Cell[100151, 2394, 490, 16, 42, "SubsubsectionIcon"],
Cell[100644, 2412, 1057, 40, 42, "SubsubsectionIcon"]
}, Closed]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

