(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     82450,       2549]*)
(*NotebookOutlinePosition[     84411,       2607]*)
(*  CellTagsIndexPosition[     84123,       2595]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Describing genealogies", "SubsectionIcon"],

Cell[TextData[Cell[BoxData[
    FormBox[GridBox[{
          {\(Nodes[g]\), \(lists\ all\ the\ nodes\ of\ the\ genealogy\ g, \ 
            including\ the\ \(\(leaves\)\(.\)\)\)},
          {\(Leaves[
              g]\), \(lists\ the\ terminal\ nodes\ of\ the\ genealogy\ \
\(\(g\)\(.\)\)\)},
          {\(InternalNodes[
              g]\), \(lists\ the\ internal\ nodes\ of\ the\ genealogy\ \
\(\(g\)\(.\)\)\)}
          }], TraditionalForm]]]], "DefinitionBox",
  CellTags->{"Nodes", "InternalNodes", "Leaves"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Show[PlotGenealogy[tr]]; \)\)], "Input",
  CellLabel->"In[239]:="],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.111111 0.111111 0.103006 0.103006 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.16667 .20601 m
.11111 .10301 L
s
.16667 .20601 m
.22222 .10301 L
s
.38889 .20601 m
.33333 .10301 L
s
.38889 .20601 m
.44444 .10301 L
s
.66667 .20601 m
.55556 .10301 L
s
.66667 .20601 m
.66667 .10301 L
s
.66667 .20601 m
.77778 .10301 L
s
.72222 .30902 m
.66667 .20601 L
s
.72222 .30902 m
.88889 .10301 L
s
.61111 .41202 m
.38889 .20601 L
s
.61111 .41202 m
.72222 .30902 L
s
.5 .51503 m
.16667 .20601 L
s
.5 .51503 m
.61111 .41202 L
s
gsave
.14444 .22661 -79.7812 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(a) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(b) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
90.562500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.36667 .22661 -79.7812 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
90.562500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.64444 .22661 -87.5625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
90.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
100.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(g) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
106.125000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.7 .32962 -95.3438 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
90.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
100.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(g) show
106.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
115.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
121.687500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.58889 .43262 -110.906 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
90.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
100.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
106.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
115.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
121.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
131.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(g) show
137.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
146.812500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
152.812500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.47778 .53563 -126.469 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(a) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(b) show
90.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
100.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
106.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
115.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
121.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
131.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
137.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
146.812500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
152.812500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
162.375000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(g) show
168.375000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
177.937500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
183.937500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.11111 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(a) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.22222 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(b) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.33333 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.44444 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.55556 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.66667 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.77778 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(g) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.88889 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[239]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00
ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo000KOol00`00Oomoo`06Ool00`00Oomoo`0DOol00`00Oomoo`06Ool0
0`00Oomoo`0COol00`00Oomoo`06Ool00`00Oomoo`0DOol00`00Oomoo`06Ool00`00Oomoo`0DOol0
0`00Oomoo`06Ool00`00Oomoo`0DOol00`00Oomoo`06Ool00`00Oomoo`0DOol01000Oomoogoo0`00
0Woo00<007ooOol04goo00<007ooOol01Woo00<007ooOol06goo000JOol00`00Oomoo`08Ool00`00
Oomoo`0BOol00`00Oomoo`08Ool00`00Oomoo`0AOol00`00Oomoo`08Ool00`00Oomoo`0BOol00`00
Oomoo`08Ool00`00Oomoo`0BOol00`00Oomoo`08Ool00`00Oomoo`0BOol00`00Oomoo`08Ool00`00
Oomoo`0BOol00`00Oomoo`05Ool01000Oomoo`004goo00<007ooOol027oo00<007ooOol06Woo000J
Ool01000Oomoogoo1@000Woo00<007ooOol04Woo00@007ooOomoo`@000=oo`03001oogoo015oo`03
001oogoo009oo`<000=oo`03001oogoo019oo`03001oogoo009oo`D00003Ool007oo01=oo`03001o
ogoo009oo`@0009oo`03001oogoo019oo`04001oogooOol40003Ool00`00Oomoo`0BOol00`00Oomo
o`02Ool40002Ool00`00Oomoo`0AOol01000Oomoogoo0P0000=oo`0000000Woo00<007ooOol06Woo
000JOol01@00Oomoogoo00000Woo00D007ooOomoo`0001Aoo`05001oogooOol00003Ool01000Oomo
o`004goo00D007ooOomoo`0000=oo`04001oogoo000DOol01@00Oomoogoo00000goo00@007ooOol0
01Aoo`05001oogooOol00006Ool00`00Oomoo`0BOol00`00Oomoo`02Ool00`00Oomoo`03Ool00`00
Oomoo`0BOol01@00Oomoogoo00000goo00@007ooOol001=oo`05001oogooOol00002Ool01@00Oomo
ogoo000077oo000IOol00`00Oomoo`02Ool40004Ool00`00Oomoo`0@Ool00`00Oomoo`02Ool01@00
Oomoogoo00000goo00<007ooOol03goo00<007ooOol00Woo00<007ooOol01Goo00<007ooOol047oo
00<007ooOol00Woo00D007ooOomoo`0000=oo`03001oogoo011oo`03001oogoo009oo`D000=oo`03
001oogoo011oo`03001oogoo00=oo`03001oogoo00Aoo`03001oogoo011oo`03001oogoo009oo`05
001oogooOol00003Ool00`00Oomoo`0?Ool00`00Oomoo`02Ool01000Oomoo`0017oo00<007ooOol0
6Goo000JOol00`00Oomoo`04Ool01@00Oomoogoo000057oo00D007ooOomoo`0000=oo`04001oogoo
000COol01@00Oomoogoo00000goo00@007ooOol001Aoo`05001oogooOol00003Ool01000Oomoo`00
57oo00D007ooOomoo`0000=oo`04001oogoo000DOol00`00Oomoo`02Ool00`00Oomoo`03Ool00`00
Oomoo`0BOol01@00Oomoogoo00000goo00@007ooOol001=oo`05001oogooOol00002Ool01@00Oomo
ogoo000077oo000JOol00`00Oomoo`02Ool30003Ool00`00Oomoo`0BOol01000Oomoogoo10000goo
00<007ooOol04Goo00<007ooOol00Woo10000Woo00<007ooOol04Woo00<007ooOol00Woo10000Woo
00<007ooOol04Woo00<007ooOol00Woo0`000goo00<007ooOol04Woo00@007ooOomoo`@000=oo`03
001oogoo019oo`03001oogoo009oo`D00003Ool007oo019oo`04001oogooOol40003Ool00`00Oomo
o`0JOol001]oo`03001oogoo00Ioo`03001oogoo01Aoo`04001oogoo0005Ool00`00Oomoo`0COol0
0`00Oomoo`06Ool00`00Oomoo`0DOol00`00Oomoo`04Ool00`00Ool0000FOol00`00Oomoo`06Ool0
0`00Oomoo`0DOol01@00Oomoogoo000017oo00<007ooOol057oo00<007ooOol01Woo00<007ooOol0
4goo00@007ooOol000Eoo`03001oogoo01]oo`00?Goo0P00@Goo0P00?7oo0`00>Woo0P008goo003o
OolQOol0021oo`03001oogoo01aoo`03001oogoo01eoo`03001oogoo01eoo`03001oogoo01eoo`80
01ioo`03001oogoo01aoo`8001ioo`03001oogoo01moo`0087oo00<007ooOol077oo00<007ooOol0
7Goo00<007ooOol07Goo00<007ooOol07goo00<007ooOol06goo00<007ooOol06goo00<007ooOol0
7Woo00<007ooOol07goo000QOol00`00Oomoo`0JOol00`00Oomoo`0OOol00`00Oomoo`0KOol00`00
Oomoo`0QOol00`00Oomoo`0JOol00`00Oomoo`0JOol00`00Oomoo`0NOol00`00Oomoo`0POol0025o
o`03001oogoo01Yoo`03001oogoo01moo`03001oogoo01]oo`03001oogoo029oo`03001oogoo01Uo
o`03001oogoo01Uoo`03001oogoo01ioo`03001oogoo025oo`008Woo00<007ooOol067oo00<007oo
Ool08Goo00<007ooOol06Goo00<007ooOol097oo00<007ooOol067oo00<007ooOol067oo00<007oo
Ool07Woo00<007ooOol08Woo000ROol00`00Oomoo`0HOol00`00Oomoo`0QOol00`00Oomoo`0IOol0
0`00Oomoo`0UOol00`00Oomoo`0GOol00`00Oomoo`0GOol00`00Oomoo`0NOol00`00Oomoo`0SOol0
02=oo`03001oogoo01Ioo`03001oogoo02=oo`03001oogoo01Moo`03001oogoo02Moo`03001oogoo
01Ioo`03001oogoo01Ioo`03001oogoo01moo`03001oogoo02=oo`008goo00<007ooOol05Woo00<0
07ooOol08goo00<007ooOol05goo00<007ooOol0:7oo00<007ooOol05Goo00<007ooOol05Goo00<0
07ooOol07goo00<007ooOol097oo000TOol00`00Oomoo`0DOol00`00Oomoo`0UOol00`00Oomoo`0E
Ool00`00Oomoo`0ZOol00`00Oomoo`0DOol00`00Oomoo`0DOol00`00Oomoo`0OOol00`00Oomoo`0U
Ool002Eoo`03001oogoo01=oo`03001oogoo02Ioo`03001oogoo01=oo`03001oogoo02aoo`03001o
ogoo01=oo`03001oogoo01=oo`03001oogoo01moo`03001oogoo02Ioo`009Goo00<007ooOol04Woo
00<007ooOol09goo00<007ooOol04goo00<007ooOol0;Goo00<007ooOol04Woo00<007ooOol04Woo
00<007ooOol07goo00<007ooOol09goo000VOol00`00Oomoo`0AOol00`00Oomoo`0XOol00`00Oomo
o`0AOol00`00Oomoo`0_Ool00`00Oomoo`0AOol00`00Oomoo`0AOol00`00Oomoo`0POol00`00Oomo
o`0WOol002Ioo`03001oogoo011oo`03001oogoo02Uoo`03001oogoo015oo`03001oogoo031oo`03
001oogoo011oo`03001oogoo011oo`03001oogoo021oo`03001oogoo02Qoo`009goo00<007ooOol0
3goo00<007ooOol0:Woo00<007ooOol03goo00<007ooOol0<Woo00<007ooOol03goo00<007ooOol0
3goo00<007ooOol087oo00<007ooOol0:Goo000WOol00`00Oomoo`0>Ool00`00Oomoo`0[Ool00`00
Oomoo`0?Ool00`00Oomoo`0cOol00`00Oomoo`0>Ool00`00Oomoo`0>Ool00`00Oomoo`0POol00`00
Oomoo`0ZOol002Qoo`03001oogoo00eoo`03001oogoo02aoo`03001oogoo00eoo`03001oogoo03Eo
o`8000ioo`03001oogoo00aoo`80029oo`03001oogoo02]oo`00:7oo00<007ooOol037oo00<007oo
Ool0;Goo00<007ooOol03Goo00<007ooOol0=goo00<007ooOol02goo00<007ooOol02goo00<007oo
Ool08Woo00<007ooOol0:goo000YOol00`00Oomoo`0;Ool00`00Oomoo`0^Ool00`00Oomoo`0;Ool0
0`00Oomoo`0iOol00`00Oomoo`0:Ool00`00Oomoo`0:Ool00`00Oomoo`0ROol00`00Oomoo`0/Ool0
02Uoo`03001oogoo00Yoo`03001oogoo02moo`03001oogoo00]oo`03001oogoo03Yoo`03001oogoo
00Uoo`03001oogoo00Uoo`03001oogoo029oo`03001oogoo02eoo`00:Woo00<007ooOol02Goo00<0
07ooOol0<7oo00<007ooOol02Goo00<007ooOol0?7oo00<007ooOol027oo00<007ooOol027oo00<0
07ooOol08Woo00<007ooOol0;Woo000ZOol00`00Oomoo`08Ool00`00Oomoo`0aOol00`00Oomoo`09
Ool00`00Oomoo`0mOol00`00Oomoo`07Ool00`00Oomoo`07Ool00`00Oomoo`0ROol00`00Oomoo`0_
Ool002]oo`03001oogoo00Moo`03001oogoo039oo`03001oogoo00Moo`03001oogoo03moo`03001o
ogoo00Ioo`03001oogoo00Ioo`03001oogoo02=oo`03001oogoo02moo`00:goo00<007ooOol01Woo
00<007ooOol0<goo00<007ooOol01goo00<007ooOol0@7oo00<007ooOol01Goo00<007ooOol01Goo
00<007ooOol08goo00<007ooOol0<7oo000/Ool00`00Oomoo`05Ool00`00Oomoo`0dOol00`00Oomo
o`05Ool00`00Oomoo`12Ool00`00Oomoo`04Ool00`00Oomoo`04Ool00`00Oomoo`0SOol00`00Oomo
o`0aOol002eoo`03001oogoo00=oo`03001oogoo03Ioo`03001oogoo00=oo`03001oogoo04Aoo`03
001oogoo00=oo`03001oogoo00=oo`03001oogoo02=oo`03001oogoo039oo`00;Goo00<007ooOol0
0goo00<007ooOol0=Woo00<007ooOol00goo00<007ooOol0AGoo00<007ooOol00Woo00<007ooOol0
0Woo00<007ooOol08goo00<007ooOol0<goo000^Ool01@00Oomoogoo0000>Woo00D007ooOomoo`00
04Uoo`05001oogooOol00003Ool00`00Oomoo`0TOol00`00Oomoo`0cOol002ioo`05001oogooOol0
000jOol01@00Oomoogoo0000BWoo00@007ooOol0009oo`03001oogoo02Aoo`03001oogoo03Aoo`00
;goo00<007oo0000?7oo00<007oo0000C7oo00D007oo001oo`0002Ioo`03001oogoo03Eoo`00;goo
00<007oo0000?7oo00<007oo0000CGoo0`009Woo00<007ooOol0=Woo000`Ool2000mOol2001>Ool0
0`00Oomoo`0TOol00`00Oomoo`0gOol001aoo`03001oogoo01=oo`04001oogoo000VOol00`00Oomo
o`0BOol01@00Oomoogoo0000;Woo00<007ooOol067oo00<007ooOol01Goo0`000Woo00<007ooOol0
5goo00<007ooOol0=goo000KOol00`00Oomoo`08Ool00`00Oomoo`0:Ool01000Oomoo`0097oo00<0
07ooOol027oo00<007ooOol02Goo00D007ooOomoo`0002aoo`03001oogoo00Qoo`03001oogoo00ao
o`04001oogoo0009Ool01000Oomoo`005goo00<007ooOol0>7oo000KOol01000Oomoogoo1@000Woo
00<007ooOol01Woo100000Aoo`00Ool002Aoo`03001oogoo009oo`<000=oo`03001oogoo00Moo`D0
0003Ool007oo02]oo`03001oogoo009oo`@0009oo`03001oogoo00Eoo`@000=oo`04001oogoo0006
Ool40002Ool00`00Oomoo`0DOol00`00Oomoo`0iOol001]oo`05001oogooOol00002Ool00`00Oomo
o`02Ool00`00Oomoo`05Ool01P00Oomoogoo001oo`8002Aoo`05001oogooOol00003Ool01@00Oomo
ogoo00001goo00@007ooOomoo`800003Ool007oo02]oo`05001oogooOol00007Ool00`00Oomoo`05
Ool00`00Oomoo`04Ool01000Oomoo`0017oo00D007ooOomoo`00009oo`03001oogoo01=oo`03001o
ogoo03Yoo`006Woo00<007ooOol00Woo100037oo00D007ooOomoo`00009oo`80029oo`03001oogoo
009oo`03001oogoo00eoo`09001oogooOol007oo001oo`0002Yoo`03001oogoo009oo`D000]oo`03
001oogoo00Moo`03001oogoo009oo`05001oogooOol00003Ool00`00Oomoo`0BOol00`00Oomoo`0j
Ool001]oo`03001oogoo00Aoo`03001oogoo00Yoo`05001oogooOol00002Ool2000SOol01@00Oomo
ogoo00000goo00<007ooOol02Goo00D007ooOomoo`00009oo`03001oogoo02Yoo`05001oogooOol0
0003Ool00`00Oomoo`09Ool00`00Oomoo`08Ool01@00Oomoogoo00000goo00@007ooOol001Aoo`03
001oogoo03]oo`006goo00<007ooOol00Woo0`0037oo10000goo00<007oo00008Woo00<007ooOol0
0Woo100037oo10000Woo0P00:goo00<007ooOol00Woo0`002goo10002Goo00@007ooOomoo`D00003
Ool007oo019oo`03001oogoo03aoo`0077oo00<007ooOol047oo00<007ooOol00goo00D007ooOomo
o`00029oo`03001oogoo01Aoo`03001oo`00009oo`03001oogoo02Uoo`03001oogoo011oo`03001o
ogoo00Uoo`03001oogoo00Ioo`03001oogoo015oo`03001oogoo03eoo`00;Woo0P002Woo00<007oo
Ool0=Goo0P001Goo00<007ooOol0>goo0`002Woo00<007ooOol067oo00<007ooOol0?Woo000kOol0
0`00Oomoo`0lOol00`00Oomoo`17Ool00`00Oomoo`0HOol00`00Oomoo`0nOol003aoo`03001oogoo
03aoo`03001oogoo04Moo`03001oogoo01Ioo`03001oogoo03moo`00?Goo00<007ooOol0?7oo0P00
Agoo00<007ooOol05Goo00<007ooOol0@7oo000nOol2000nOol00`00Oomoo`15Ool00`00Oomoo`0C
Ool00`00Oomoo`11Ool0041oo`03001oogoo03aoo`03001oogoo04Aoo`03001oogoo019oo`03001o
ogoo049oo`00@Goo00<007ooOol0?7oo00<007ooOol0A7oo00<007ooOol04Goo00<007ooOol0@Woo
0012Ool00`00Oomoo`0lOol00`00Oomoo`14Ool00`00Oomoo`0?Ool00`00Oomoo`13Ool004=oo`03
001oogoo03aoo`03001oogoo04=oo`03001oogoo00ioo`03001oogoo04Aoo`00A7oo00<007ooOol0
?7oo00<007ooOol0@goo00<007ooOol037oo00<007ooOol0AGoo0015Ool00`00Oomoo`0lOol00`00
Oomoo`12Ool00`00Oomoo`0;Ool00`00Oomoo`16Ool004Ioo`03001oogoo03aoo`03001oogoo049o
o`03001oogoo00Yoo`03001oogoo04Ioo`00Agoo00<007ooOol0?7oo00<007ooOol0@Goo00<007oo
Ool02Goo00<007ooOol0Agoo0018Ool00`00Oomoo`0lOol00`00Oomoo`11Ool00`00Oomoo`07Ool0
0`00Oomoo`18Ool004Uoo`03001oogoo03aoo`03001oogoo041oo`03001oogoo00Ioo`03001oogoo
04Uoo`00BWoo00<007ooOol0?7oo0P00@Goo00<007ooOol017oo00<007ooOol0BWoo001;Ool2000n
Ool00`00Oomoo`0oOol00`00Oomoo`03Ool00`00Oomoo`1:Ool004eoo`03001oogoo03aoo`03001o
ogoo03ioo`03001oogoo009oo`03001oogoo04]oo`00CWoo00<007ooOol0?7oo00<007ooOol0?Woo
00@007ooOol004ioo`00Cgoo00<007ooOol0?7oo00<007ooOol0?Goo00<007oo0000Cgoo001@Ool0
0`00Oomoo`0lOol00`00Oomoo`0lOol2001@Ool0055oo`03001oogoo03aoo`03001oogoo03Yoo`03
001oogoo051oo`00DWoo00<007ooOol0?7oo00<007ooOol067oo00<007ooOol07Goo00<007ooOol0
0`004Woo00<007ooOol0>Goo001COol00`00Oomoo`0lOol00`00Oomoo`0FOol00`00Oomoo`08Ool0
0`00Oomoo`0<Ool00`00Oomoo`03Ool00`00Oomoo`04Ool01000Oomoo`003goo00<007ooOol0>7oo
001DOol00`00Oomoo`0lOol00`00Oomoo`0EOol00`00Oomoo`02Ool40002Ool00`00Oomoo`05Ool4
0003Ool00`00Oomoo`02Ool00`00Oomoo`02Ool40002Ool00`00Oomoo`06Ool200000goo00000002
Ool00`00Oomoo`0hOol005Eoo`03001oogoo03aoo`03001oogoo01Aoo`05001oogooOol00007Ool0
0`00Oomoo`05Ool00`00Oomoo`04Ool01000Oomoo`0017oo00D007ooOomoo`0000=oo`03001oogoo
00Eoo`04001oogoo0003Ool00`00Oomoo`0hOol005Ioo`03001oogoo03aoo`8001=oo`03001oogoo
009oo`D000]oo`03001oogoo00Ioo`03001oogoo00=oo`05001oogooOol0000;Ool01000Oomoo`00
17oo00<007ooOol0=goo001GOol00`00Oomoo`0mOol00`00Oomoo`0AOol01@00Oomoogoo00000goo
00<007ooOol02Goo00<007ooOol01Goo00<007ooOol017oo00D007ooOomoo`0000]oo`04001oogoo
0003Ool00`00Oomoo`0hOol005Qoo`03001oogoo03eoo`03001oogoo011oo`03001oogoo009oo`<0
00]oo`@000Aoo`03001oogoo00Ioo`D000Yoo`@000=oo`03001oogoo03Qoo`00FGoo0P00?Woo00<0
07ooOol047oo00<007ooOol047oo00<007ooOol00goo00<007ooOol05Woo00<007ooOol00goo00<0
07ooOol0>Goo001KOol00`00Oomoo`0lOol00`00Oomoo`0ROol30002Ool00`00Oomoo`0FOol20011
Ool005aoo`03001oogoo03aoo`03001oogoo02Eoo`03001oogoo05Yoo`00GGoo00<007ooOol0?7oo
00<007ooOol08goo00<007ooOol0Fgoo001NOol00`00Oomoo`0lOol00`00Oomoo`0QOol00`00Oomo
o`1LOol005moo`03001oogoo03aoo`03001oogoo01moo`03001oogoo05eoo`00H7oo00<007ooOol0
?7oo00<007ooOol077oo0P00H7oo001QOol00`00Oomoo`0lOol00`00Oomoo`0JOol00`00Oomoo`1P
Ool0069oo`03001oogoo03aoo`03001oogoo01Qoo`03001oogoo065oo`00Hgoo00<007ooOol0?7oo
0P005goo00<007ooOol0HWoo001TOol00`00Oomoo`0mOol00`00Oomoo`0COol00`00Oomoo`1SOol0
06Eoo`03001oogoo03eoo`03001oogoo015oo`03001oogoo06Aoo`00IWoo0P00?Woo00<007ooOol0
3goo00<007ooOol0IGoo001XOol00`00Oomoo`0lOol00`00Oomoo`0=Ool00`00Oomoo`1VOol006Uo
o`03001oogoo03aoo`03001oogoo00]oo`03001oogoo06Moo`00JWoo00<007ooOol0?7oo00<007oo
Ool02Goo00<007ooOol0J7oo001[Ool00`00Oomoo`0lOol00`00Oomoo`07Ool00`00Oomoo`1YOol0
06aoo`03001oogoo03aoo`03001oogoo00Eoo`03001oogoo06Yoo`00KGoo00<007ooOol0?7oo00<0
07ooOol00goo00<007ooOol0Jgoo001^Ool00`00Oomoo`0lOol01@00Oomoogoo0000KWoo001_Ool0
0`00Oomoo`0lOol00`00Ool0001_Ool0071oo`03001oogoo03]oo`80071oo`00LGoo00<007ooOol0
2Goo00<007ooOol0;Goo00<007ooOol03goo0`004Goo00<007ooOol0BWoo001bOol00`00Oomoo`07
Ool00`00Oomoo`08Ool00`00Oomoo`0<Ool00`00Oomoo`0=Ool00`00Oomoo`03Ool00`00Oomoo`06
Ool00`00Oomoo`0:Ool01000Oomoo`003Woo00<007ooOol0BGoo001cOol00`00Oomoo`06Ool00`00
Oomoo`02Ool30003Ool00`00Oomoo`06Ool500000goo001oo`08Ool40002Ool00`00Oomoo`02Ool0
0`00Oomoo`040003Ool00`00Oomoo`07Ool40002Ool00`00Oomoo`05Ool200000goo00000002Ool0
0`00Oomoo`19Ool007Aoo`8000Ioo`05001oogooOol00003Ool01@00Oomoogoo00001Woo00D007oo
Oomoo`0000=oo`03001oogoo00Eoo`03001oogoo00Eoo`04001oogoo0004Ool00`00Oomoo`04Ool0
0`00Oomoo`05Ool01@00Oomoogoo00000goo00<007ooOol017oo00@007ooOol000=oo`03001oogoo
04Uoo`00MWoo00<007ooOol00Woo00<007ooOol00Woo00<007ooOol037oo00D007ooOomoo`0000]o
o`D000Eoo`03001oogoo00=oo`03001oogoo00aoo`05001oogooOol0000:Ool01000Oomoo`0017oo
00<007ooOol0B7oo001gOol00`00Oomoo`02Ool01@00Oomoogoo00000goo00<007ooOol027oo00D0
07ooOomoo`0000]oo`05001oogooOol00004Ool00`00Oomoo`04Ool00`00Oomoo`0<Ool01@00Oomo
ogoo00002Woo00@007ooOol000=oo`03001oogoo04Uoo`00N7oo00D007ooOomoo`0000Aoo`@000]o
o`@000aoo`<000Aoo`03001oogoo00Aoo`@000eoo`D000Uoo`@000=oo`03001oogoo04Uoo`00NGoo
00D007ooOomoo`0001Eoo`03001oogoo011oo`03001oogoo00Ioo`03001oogoo01]oo`03001oogoo
00=oo`03001oogoo04Yoo`00NWoo00<007ooOol05Goo0P004Goo00<007ooOol01goo0`006Woo0P00
DWoo001kOol00`00Oomoo`0UOol2001kOol007aoo`03001oogoo02=oo`03001oogoo07]oo`00OGoo
00<007ooOol08Goo00<007ooOol0O7oo001nOol00`00Oomoo`0OOol00`00Oomoo`1mOol007moo`03
001oogoo01eoo`03001oogoo07ioo`00P7oo00<007ooOol06goo00<007ooOol0Ogoo0021Ool2000J
Ool00`00Oomoo`20Ool008=oo`03001oogoo01Ioo`03001oogoo085oo`00Q7oo00<007ooOol057oo
00<007ooOol0PWoo0025Ool00`00Oomoo`0AOol20025Ool008Ioo`03001oogoo00moo`03001oogoo
08Eoo`00Qgoo00<007ooOol03Goo00<007ooOol0QWoo0028Ool00`00Oomoo`0;Ool00`00Oomoo`27
Ool008Uoo`03001oogoo00Uoo`03001oogoo08Qoo`00RWoo00<007ooOol01goo00<007ooOol0RGoo
002;Ool00`00Oomoo`05Ool00`00Oomoo`2:Ool008aoo`03001oogoo00=oo`03001oogoo08]oo`00
SGoo00D007ooOomoo`0008ioo`00SWoo00<007oo0000Sgoo002?Ool00`00Oomoo`2>Ool00?moob5o
o`00CGoo00<007ooOol0Ggoo0`004Goo00<007ooOol0FWoo001<Ool00`00Oomoo`08Ool00`00Oomo
o`0=Ool00`00Oomoo`0<Ool00`00Oomoo`0=Ool00`00Oomoo`0<Ool00`00Oomoo`0=Ool00`00Oomo
o`0:Ool01000Oomoo`003Woo00<007ooOol0FGoo001<Ool01000Oomoogoo1@000Woo00<007ooOol0
1Woo10000goo00<007ooOol01Woo0`000goo00<007ooOol01goo1@0000=oo`00Ool01goo10000Woo
00<007ooOol01Woo10000goo00<007ooOol01goo10000Woo00<007ooOol01Goo0P0000=oo`000000
0Woo00<007ooOol0FGoo001<Ool01@00Oomoogoo00000Woo00<007ooOol00Woo00<007ooOol01Goo
00D007ooOomoo`0000=oo`03001oogoo00Aoo`05001oogooOol00003Ool00`00Oomoo`05Ool01@00
Oomoogoo00000goo00<007ooOol017oo00<007ooOol01Goo00<007ooOol01Woo00<007ooOol017oo
00<007ooOol01Goo00D007ooOomoo`0000=oo`03001oogoo00Aoo`04001oogoo0003Ool00`00Oomo
o`1IOol004]oo`03001oogoo009oo`@000aoo`05001oogooOol0000:Ool00`00Oomoo`0=Ool01@00
Oomoogoo00002Woo1@0037oo00<007ooOol037oo00D007ooOomoo`0000Yoo`04001oogoo0004Ool0
0`00Oomoo`1HOol004aoo`03001oogoo00Aoo`03001oogoo00Yoo`05001oogooOol0000:Ool01@00
Oomoogoo00002goo00D007ooOomoo`0000Yoo`05001oogooOol0000<Ool00`00Oomoo`0<Ool01@00
Oomoogoo00002Woo00@007ooOol000=oo`03001oogoo05Uoo`00C7oo00<007ooOol00Woo0`0037oo
100037oo100037oo10002goo0`0037oo10003Goo1@002Goo10000goo00<007ooOol0FGoo001=Ool0
0`00Oomoo`0@Ool00`00Oomoo`0POol00`00Oomoo`0IOol00`00Oomoo`0KOol00`00Oomoo`03Ool0
0`00Oomoo`1JOol005moo`80025oo`8001]oo`<001Yoo`80069oo`00ogoo8Goo003oOolQOol00?mo
ob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo
003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?mo
ob5oo`00ogoo8Goo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.01116, -1.00003, 
  0.0314367, 0.0339103}}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Nodes[tr]\)], "Input",
  CellLabel->"In[234]:="],

Cell[BoxData[
    \({{a}, {b}, {a, b}, {c}, {d}, {c, d}, {e}, {f}, {g}, {e, f, g}, {h}, {e, 
        f, g, h}, {c, d, e, f, g, h}, {a, b, c, d, e, f, g, h}}\)], "Output",
  CellLabel->"Out[234]="]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Leaves[tr]\)], "Input",
  CellLabel->"In[238]:="],

Cell[BoxData[
    \({{a}, {b}, {c}, {d}, {e}, {f}, {g}, {h}}\)], "Output",
  CellLabel->"Out[238]="]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(InternalNodes[tr]\)], "Input",
  CellLabel->"In[235]:="],

Cell[BoxData[
    \({{a, b}, {c, d}, {e, f, g}, {e, f, g, h}, {c, d, e, f, g, h}, {a, b, c, 
        d, e, f, g, h}}\)], "Output",
  CellLabel->"Out[235]="]
}, Closed]],

Cell["These functions can also be applied to unrooted genealogies:", \
"MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(utr = UnrootedGenealogy[tr]; utr // TableForm\)], "Input",
  CellLabel->"In[241]:="],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(Node[{a}, {0}, {{a, b}}]\)},
          {\(Node[{b}, {0}, {{a, b}}]\)},
          {\(Node[{c}, {0}, {{c, d}}]\)},
          {\(Node[{d}, {0}, {{c, d}}]\)},
          {\(Node[{e}, {0}, {{e, f, g}}]\)},
          {\(Node[{f}, {0}, {{e, f, g}}]\)},
          {\(Node[{g}, {0}, {{e, f, g}}]\)},
          {\(Node[{h}, {0}, {{e, f, g, h}}]\)},
          {
            RowBox[{"Node", "[", 
              RowBox[{\({a, b}\), ",", 
                RowBox[{"{", 
                  StyleBox["0.4`",
                    StyleBoxAutoDelete->True,
                    PrintPrecision->1], "}"}], ",", 
                \({{a}, {b}, {a, b, c, d, e, f, g, h}}\)}], "]"}]},
          {\(Node[{c, d}, {1}, {{c}, {d}, {c, d, e, f, g, h}}]\)},
          {
            RowBox[{"Node", "[", 
              RowBox[{\({e, f, g}\), ",", 
                RowBox[{"{", 
                  StyleBox["1.5`",
                    StyleBoxAutoDelete->True,
                    PrintPrecision->2], "}"}], ",", 
                \({{e}, {f}, {g}, {e, f, g, h}}\)}], "]"}]},
          {
            RowBox[{"Node", "[", 
              RowBox[{\({e, f, g, h}\), ",", 
                RowBox[{"{", 
                  StyleBox["1.7`",
                    StyleBoxAutoDelete->True,
                    PrintPrecision->2], "}"}], ",", 
                \({{e, f, g}, {h}, {c, d, e, f, g, h}}\)}], "]"}]},
          {
            RowBox[{"Node", "[", 
              RowBox[{\({c, d, e, f, g, h}\), ",", 
                RowBox[{"{", 
                  StyleBox["1.8`",
                    StyleBoxAutoDelete->True,
                    PrintPrecision->2], "}"}], ",", 
                \({{c, d}, {e, f, g, h}, {a, b, c, d, e, f, g, h}}\)}], 
              "]"}]},
          {
            RowBox[{"Node", "[", 
              RowBox[{\({a, b, c, d, e, f, g, h}\), ",", 
                RowBox[{"{", 
                  StyleBox["2.29999999999999982`",
                    StyleBoxAutoDelete->True,
                    PrintPrecision->2], "}"}], ",", 
                \({{a, b}, {c, d, e, f, g, h}}\)}], "]"}]}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {
        Node[ {a}, {0}, {{a, b}}], 
        Node[ {b}, {0}, {{a, b}}], 
        Node[ {c}, {0}, {{c, d}}], 
        Node[ {d}, {0}, {{c, d}}], 
        Node[ {e}, {0}, {{e, f, g}}], 
        Node[ {f}, {0}, {{e, f, g}}], 
        Node[ {g}, {0}, {{e, f, g}}], 
        Node[ {h}, {0}, {{e, f, g, h}}], 
        Node[ {a, b}, {0.40000000000000002}, {{a}, {b}, {a, b, c, d, e, f, g, 
          h}}], 
        Node[ {c, d}, {1}, {{c}, {d}, {c, d, e, f, g, h}}], 
        Node[ {e, f, g}, {1.5}, {{e}, {f}, {g}, {e, f, g, h}}], 
        Node[ {e, f, g, h}, {1.7}, {{e, f, g}, {h}, {c, d, e, f, g, h}}], 
        Node[ {c, d, e, f, g, h}, {1.8}, {{c, d}, {e, f, g, h}, {a, b, c, d, 
          e, f, g, h}}], 
        Node[ {a, b, c, d, e, f, g, h}, {2.2999999999999998}, {{a, b}, {c, d, 
          e, f, g, h}}]}]]], "Output",
  CellLabel->"Out[241]//TableForm="]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Nodes[utr]\)], "Input",
  CellLabel->"In[257]:="],

Cell[BoxData[
    \({{a}, {b}, {c}, {d}, {e}, {f}, {g}, {h}, {a, b}, {c, d}, {e, f, g}, {e, 
        f, g, h}, {c, d, e, f, g, h}, {a, b, c, d, e, f, g, h}}\)], "Output",
  CellLabel->"Out[257]="]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Leaves[utr]\)], "Input",
  CellLabel->"In[258]:="],

Cell[BoxData[
    \({{a}, {b}, {c}, {d}, {e}, {f}, {g}, {h}}\)], "Output",
  CellLabel->"Out[258]="]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(InternalNodes[utr]\)], "Input",
  CellLabel->"In[259]:="],

Cell[BoxData[
    \({{a, b}, {c, d}, {e, f, g}, {e, f, g, h}, {c, d, e, f, g, h}, {a, b, c, 
        d, e, f, g, h}}\)], "Output",
  CellLabel->"Out[259]="]
}, Closed]],

Cell[TextData[Cell[BoxData[
    FormBox[GridBox[{
          {
            RowBox[{"CollapseGenealogy", "[", 
              StyleBox["genealogy",
                FontSlant->"Italic"], 
              "]"}], \(reduces\ the\ genealogy\ to\ a\ nested\ \
\(\(list\)\(.\)\)\)},
          {
            RowBox[{"CollapseGenealogy", "[", 
              RowBox[{
                StyleBox["genealogy",
                  FontSlant->"Italic"], ",", " ", \(Node \[Rule] False\)}], 
              "]"}], \(only\ lists\ the\ \(\(leaves\)\(.\)\)\)},
          {
            RowBox[{"CollapseGenealogy", "[", 
              RowBox[{
                StyleBox["genealogy",
                  FontSlant->"Italic"], ",", 
                " ", \(NodeFunction \[Rule] f\)}], "]"}], 
            RowBox[{
              
              RowBox[{\(extracts\ a\ nested\ list\ of\ the\ information\ \
associated\ with\ each\ node\), ",", " ", 
                RowBox[{
                  RowBox[{"by", " ", "applying", " ", 
                    RowBox[{"f", "[", 
                      RowBox[{"i", ",", 
                        RowBox[{"{", 
                          StyleBox["info",
                            FontSlant->"Italic"], "}"}]}], "]"}], " ", "to", 
                    " ", "the", " ", "full", " ", "set", " ", "of", " ", 
                    "information", " ", "contained", " ", "in", " ", "the", 
                    " ", \(genealogy . \ \ The\), " ", "default", " ", "is", 
                    " ", "to", " ", "return", " ", "the", " ", "node", " ", 
                    "label", " ", "using", " ", "f"}], 
                  "=", \(\(#1 &\)\(.\)\)}]}], "  "}]}
          }], TraditionalForm]]]], "DefinitionBox",
  CellTags->"CollapseGenealogy"],

Cell["\<\
This gives the structure of the genealogy in terms of nested lists \
of all the nodes.  For the example above:\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(CollapseGenealogy[tr]\)], "Input",
  CellLabel->"In[23]:="],

Cell[BoxData[
    \({{a, b, c, d, e, f, g, 
        h}, {{{a, b}, {{a}, {b}}}, {{c, d, e, f, g, 
            h}, {{{c, d}, {{c}, {d}}}, {{e, f, g, 
                h}, {{{e, f, g}, {{e}, {f}, {g}}}, {h}}}}}}}\)], "Output",
  CellLabel->"Out[23]="]
}, Closed]],

Cell["This lists the relation between the leaves of the genealogy:", \
"MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(CollapseGenealogy[tr, \ Node \[Rule] False]\)], "Input",
  CellLabel->"In[24]:="],

Cell[BoxData[
    \({{{a}, {b}}, {{{c}, {d}}, {{{e}, {f}, {g}}, {h}}}}\)], "Output",
  CellLabel->"Out[24]="]
}, Closed]],

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`NodeFunction \[Rule] f\)]],
  " applies ",
  Cell[BoxData[
      FormBox[
        RowBox[{"f", "[", 
          RowBox[{"i", ",", 
            RowBox[{"{", 
              StyleBox["info",
                FontSlant->"Italic"], "}"}]}], "]"}], TraditionalForm]]],
  " to each node, so as to extract information about it.  "
}], "Text"],

Cell["\<\
In the above example, \
f=#2\[LeftDoubleBracket]1\[RightDoubleBracket]& returns the coalescence \
times.\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(CollapseGenealogy[tr, 
      NodeFunction \[Rule] 
        \((#2\[LeftDoubleBracket]1\[RightDoubleBracket]&)\)]\)], "Input",
  CellLabel->"In[25]:="],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        StyleBox["2.29999999999999982`",
          StyleBoxAutoDelete->True,
          PrintPrecision->2], ",", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{
                StyleBox["0.4`",
                  StyleBoxAutoDelete->True,
                  PrintPrecision->1], ",", \({0, 0}\)}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                StyleBox["1.8`",
                  StyleBoxAutoDelete->True,
                  PrintPrecision->2], ",", 
                RowBox[{"{", 
                  RowBox[{\({1, {0, 0}}\), ",", 
                    RowBox[{"{", 
                      RowBox[{
                        StyleBox["1.7`",
                          StyleBoxAutoDelete->True,
                          PrintPrecision->2], ",", 
                        RowBox[{"{", 
                          RowBox[{
                            RowBox[{"{", 
                              RowBox[{
                                StyleBox["1.5`",
                                  StyleBoxAutoDelete->True,
                                  PrintPrecision->2], ",", \({0, 0, 0}\)}], 
                              "}"}], ",", "0"}], "}"}]}], "}"}]}], "}"}]}], 
              "}"}]}], "}"}]}], "}"}]], "Output",
  CellLabel->"Out[25]="]
}, Closed]],

Cell[TextData[
"BEWARE - the brackets around (#2\[LeftDoubleBracket]1\[RightDoubleBracket]&) \
are essential: otherwise, the rule is misinterpreted."], "Text"],

Cell["\<\
Nested\[Rule]False removes the nested structure, and just lists the \
nodes.  It is equivalent to Nodes[tr]:\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(CollapseGenealogy[tr, \ Nested \[Rule] False]\)], "Input",
  CellLabel->"In[31]:="],

Cell[BoxData[
    \({{a}, {b}, {a, b}, {c}, {d}, {c, d}, {e}, {f}, {g}, {e, f, g}, {h}, {e, 
        f, g, h}, {c, d, e, f, g, h}, {a, b, c, d, e, f, g, h}}\)], "Output",
  CellLabel->"Out[31]="]
}, Closed]],

Cell["This is equivalent to Leaves[tr]:", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(CollapseGenealogy[tr, \ Nested \[Rule] False, \ Node \[Rule] False]\)], 
  "Input",
  CellLabel->"In[32]:="],

Cell[BoxData[
    \({{a}, {b}, {c}, {d}, {e}, {f}, {g}, {h}}\)], "Output",
  CellLabel->"Out[32]="]
}, Closed]],

Cell["CollapseGenealogy[] can be applied to unrooted genealogies:", \
"MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(CollapseGenealogy[utr]\)], "Input",
  CellLabel->"In[272]:="],

Cell[BoxData[
    \({{a}, {b}, {c}, {d}, {e}, {f}, {g}, {h}, {a, b}, {c, d}, {e, f, g}, {e, 
        f, g, h}, {c, d, e, f, g, h}, {a, b, c, d, e, f, g, h}}\)], "Output",
  CellLabel->"Out[272]="]
}, Closed]],

Cell["This only lists the leaves of the genealogy:", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(CollapseGenealogy[utr, \ Node \[Rule] False]\)], "Input",
  CellLabel->"In[273]:="],

Cell[BoxData[
    \({{a}, {b}, {c}, {d}, {e}, {f}, {g}, {h}}\)], "Output",
  CellLabel->"Out[273]="]
}, Closed]],

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`NodeFunction \[Rule] f\)]],
  " applies ",
  Cell[BoxData[
      FormBox[
        RowBox[{"f", "[", 
          RowBox[{"i", ",", 
            RowBox[{"{", 
              StyleBox["info",
                FontSlant->"Italic"], "}"}]}], "]"}], TraditionalForm]]],
  " to each node, so as to extract information about it.  "
}], "Text"],

Cell["\<\
In the above example , f=#2\[LeftDoubleBracket]1\
\[RightDoubleBracket]& returns the coalescence times.\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(CollapseGenealogy[utr, 
      NodeFunction \[Rule] 
        \((#2\[LeftDoubleBracket]1\[RightDoubleBracket]&)\)]\)], "Input",
  CellLabel->"In[274]:="],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        "0", ",", 
        StyleBox["0.4`",
          StyleBoxAutoDelete->True,
          PrintPrecision->1], ",", "1", ",", 
        StyleBox["1.5`",
          StyleBoxAutoDelete->True,
          PrintPrecision->2], ",", 
        StyleBox["1.7`",
          StyleBoxAutoDelete->True,
          PrintPrecision->2], ",", 
        StyleBox["1.8`",
          StyleBoxAutoDelete->True,
          PrintPrecision->2], ",", 
        StyleBox["2.29999999999999982`",
          StyleBoxAutoDelete->True,
          PrintPrecision->2]}], "}"}]], "Output",
  CellLabel->"Out[274]="]
}, Closed]],

Cell[TextData[Cell[BoxData[
    FormBox[GridBox[{
          {\(ExtractInformation[g, 
              i]\), \(gives\ the\ information\ associated\ with\ node\ \
\(\(i\)\(.\)\)\)},
          {\(ExtractInformation[
              g]\), \(gives\ a\ list\ of\ the\ information\ for\ all\ the\ \(\
\(nodes\)\(.\)\)\)}
          }], TraditionalForm]]]], "DefinitionBox",
  CellTags->"ExtractInformation"],

Cell["\<\
This is the information associated with the node labelled {a,b} - \
in this case, the coalescence time.\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ExtractInformation[tr, {a, b}]\)], "Input",
  CellLabel->"In[557]:="],

Cell[BoxData[
    RowBox[{"{", 
      StyleBox["0.4`",
        StyleBoxAutoDelete->True,
        PrintPrecision->1], "}"}]], "Output",
  CellLabel->"Out[557]="]
}, Closed]],

Cell["\<\
This lists all the information, ordered in the same way as the list \
of nodes produced by CollapseGenealogy[]:\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \({CollapseGenealogy[tr, Nested \[Rule] False], 
        ExtractInformation[tr]} // TableForm\)], "Input",
  CellLabel->"In[559]:="],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {"a"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"b"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"a"},
                {"b"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"c"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"d"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"c"},
                {"d"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"e"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"f"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"g"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"e"},
                {"f"},
                {"g"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"h"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"e"},
                {"f"},
                {"g"},
                {"h"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"c"},
                {"d"},
                {"e"},
                {"f"},
                {"g"},
                {"h"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"a"},
                {"b"},
                {"c"},
                {"d"},
                {"e"},
                {"f"},
                {"g"},
                {"h"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {
                  StyleBox["0.4`",
                    StyleBoxAutoDelete->True,
                    PrintPrecision->1]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"1"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {
                  StyleBox["1.5`",
                    StyleBoxAutoDelete->True,
                    PrintPrecision->2]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {
                  StyleBox["1.7`",
                    StyleBoxAutoDelete->True,
                    PrintPrecision->2]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {
                  StyleBox["1.8`",
                    StyleBoxAutoDelete->True,
                    PrintPrecision->2]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {
                  StyleBox["2.29999999999999982`",
                    StyleBoxAutoDelete->True,
                    PrintPrecision->2]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {{{a}, {b}, {a, b}, {c}, {d}, {c, d}, {e}, {f}, {g}, {e, f, 
        g}, {h}, {e, f, g, h}, {c, d, e, f, g, h}, {a, b, c, d, e, f, g, 
        h}}, {{0}, {0}, {0.40000000000000002}, {0}, {0}, {1}, {0}, {0}, {0}, {
        1.5}, {0}, {1.7}, {1.8}, {2.2999999999999998}}}]]], "Output",
  CellLabel->"Out[559]//TableForm="]
}, Closed]],

Cell["\<\
ExtractInformation[] can also be applied to unrooted genealogies:\
\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ExtractInformation[utr, {a, b}]\)], "Input",
  CellLabel->"In[114]:="],

Cell[BoxData[
    RowBox[{"{", 
      StyleBox["0.4`",
        StyleBoxAutoDelete->True,
        PrintPrecision->1], "}"}]], "Output",
  CellLabel->"Out[114]="]
}, Closed]],

Cell["\<\
This lists all the information from the unrooted tree, ordered in \
the same way as the list of nodes produced by CollapseGenealogy[]:\
\>", \
"MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \({CollapseGenealogy[utr, Nested \[Rule] False], 
        ExtractInformation[utr]} // TableForm\)], "Input",
  CellLabel->"In[562]:="],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {"a"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"b"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"c"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"d"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"e"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"f"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"g"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"h"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"a"},
                {"b"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"c"},
                {"d"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"e"},
                {"f"},
                {"g"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"e"},
                {"f"},
                {"g"},
                {"h"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"c"},
                {"d"},
                {"e"},
                {"f"},
                {"g"},
                {"h"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"a"},
                {"b"},
                {"c"},
                {"d"},
                {"e"},
                {"f"},
                {"g"},
                {"h"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {
                  StyleBox["0.4`",
                    StyleBoxAutoDelete->True,
                    PrintPrecision->1]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"1"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {
                  StyleBox["1.5`",
                    StyleBoxAutoDelete->True,
                    PrintPrecision->2]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {
                  StyleBox["1.7`",
                    StyleBoxAutoDelete->True,
                    PrintPrecision->2]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {
                  StyleBox["1.8`",
                    StyleBoxAutoDelete->True,
                    PrintPrecision->2]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {
                  StyleBox["2.29999999999999982`",
                    StyleBoxAutoDelete->True,
                    PrintPrecision->2]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {{{a}, {b}, {c}, {d}, {e}, {f}, {g}, {h}, {a, b}, {c, d}, {
        e, f, g}, {e, f, g, h}, {c, d, e, f, g, h}, {a, b, c, d, e, f, g, 
        h}}, {{0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0.40000000000000002}, {
        1}, {1.5}, {1.7}, {1.8}, {2.2999999999999998}}}]]], "Output",
  CellLabel->"Out[562]//TableForm="]
}, Closed]],

Cell[TextData[Cell[BoxData[
    FormBox[GridBox[{
          {\(TransformInformation[g, 
              f]\), \(replaces\ the\ information\ list\ info\ by\ \(\(f[node, 
                  info]\)\(.\)\)\)}
          }], TraditionalForm]]]], "DefinitionBox",
  CellTags->"TransformInformation"],

Cell["\<\
This function doubles the first element of the information \
list:\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(tr2 = 
      TransformInformation[tr, 
        \(({2  #2\[LeftDoubleBracket]1\[RightDoubleBracket]})\)&]; 
    \n{CollapseGenealogy[tr2, Nested \[Rule] False], 
        ExtractInformation[tr2]} // TableForm\)], "Input",
  CellLabel->"In[563]:="],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {"a"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"b"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"a"},
                {"b"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"c"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"d"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"c"},
                {"d"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"e"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"f"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"g"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"e"},
                {"f"},
                {"g"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"h"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"e"},
                {"f"},
                {"g"},
                {"h"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"c"},
                {"d"},
                {"e"},
                {"f"},
                {"g"},
                {"h"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"a"},
                {"b"},
                {"c"},
                {"d"},
                {"e"},
                {"f"},
                {"g"},
                {"h"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {
                  StyleBox["0.4`",
                    StyleBoxAutoDelete->True,
                    PrintPrecision->1]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"1"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {
                  StyleBox["1.5`",
                    StyleBoxAutoDelete->True,
                    PrintPrecision->2]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {
                  StyleBox["1.7`",
                    StyleBoxAutoDelete->True,
                    PrintPrecision->2]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {
                  StyleBox["1.8`",
                    StyleBoxAutoDelete->True,
                    PrintPrecision->2]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"4.59999999999999964`"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {{{a}, {b}, {a, b}, {c}, {d}, {c, d}, {e}, {f}, {g}, {e, f, 
        g}, {h}, {e, f, g, h}, {c, d, e, f, g, h}, {a, b, c, d, e, f, g, 
        h}}, {{0}, {0}, {0.40000000000000002}, {0}, {0}, {1}, {0}, {0}, {0}, {
        1.5}, {0}, {1.7}, {1.8}, {4.5999999999999996}}}]]], "Output",
  CellLabel->"Out[563]//TableForm="]
}, Closed]],

Cell["\<\
TransformInformation[] can also be applied to a unrooted \
tree.\
\>", "Text"],

Cell[TextData[Cell[BoxData[
    FormBox[GridBox[{
          {\(NumberOfLineages[
              g]\), \(\(\ \)\(gives\ the\ total\ number\ of\ lineages\ \((i . 
                  e . , \ 
                terminal\ nodes)\)\ involved\ in\ the\ genealogy\ \
\(\(g\)\(.\)\)\)\)},
          {\(NumberOfLineages[g, 
              i]\), \(\(\ \)\(gives\ the\ total\ number\ of\ lineages\ that\ \
descend\ from\ node\ \(\(i\)\(.\)\)\)\)}
          }], TraditionalForm]]]], "DefinitionBox",
  CellTags->"NumberOfLineages"],

Cell["\<\
This example has 8 terminal nodes - that is, it gives the \
relationship amongst 8 lineages.\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(NumberOfLineages[tr]\)], "Input",
  CellLabel->"In[128]:="],

Cell[BoxData[
    \(8\)], "Output",
  CellLabel->"Out[128]="]
}, Closed]],

Cell["The node {a,b} connects two lineages", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(NumberOfLineages[tr, {a, b}]\)], "Input",
  CellLabel->"In[127]:="],

Cell[BoxData[
    \(2\)], "Output",
  CellLabel->"Out[127]="]
}, Closed]],

Cell["\<\
Again, these functions can be applied to unrooted genealogies:  \
\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \({NumberOfLineages[utr], NumberOfLineages[utr, {a, b}]}\)], "Input",
  CellLabel->"In[126]:="],

Cell[BoxData[
    \({8, 8}\)], "Output",
  CellLabel->"Out[126]="]
}, Closed]],

Cell["\<\
However, in the absence of a root, the number of terminal nodes \
that are related to any internal node is always equal to the total.\
\>", 
  "Text"]
}, Open  ]]
},
FrontEndVersion->"4.0 for Macintosh",
ScreenRectangle->{{0, 1024}, {0, 748}},
WindowSize->{509, 693},
WindowMargins->{{Automatic, -3}, {Automatic, 0}},
StyleDefinitions -> "HelpBrowser.nb",
MacintoshSystemPageSetup->"\<\
00`0001804P000000_02@?o/onh3109BI085:0?l0@00005X0FP000003[0;@001
0000I00100000@0000000BL?0040000000000000000000000000000000000?nL
ojH?50^J00P100000000000000000000\>"
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Nodes"->{
    Cell[1790, 53, 512, 11, 88, "DefinitionBox",
      CellTags->{"Nodes", "InternalNodes", "Leaves"}]},
  "InternalNodes"->{
    Cell[1790, 53, 512, 11, 88, "DefinitionBox",
      CellTags->{"Nodes", "InternalNodes", "Leaves"}]},
  "Leaves"->{
    Cell[1790, 53, 512, 11, 88, "DefinitionBox",
      CellTags->{"Nodes", "InternalNodes", "Leaves"}]},
  "CollapseGenealogy"->{
    Cell[49234, 1480, 1731, 38, 140, "DefinitionBox",
      CellTags->"CollapseGenealogy"]},
  "ExtractInformation"->{
    Cell[57020, 1731, 395, 9, 50, "DefinitionBox",
      CellTags->"ExtractInformation"]},
  "TransformInformation"->{
    Cell[73116, 2241, 290, 6, 33, "DefinitionBox",
      CellTags->"TransformInformation"]},
  "NumberOfLineages"->{
    Cell[80883, 2484, 513, 11, 84, "DefinitionBox",
      CellTags->"NumberOfLineages"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Nodes", 83278, 2570},
  {"InternalNodes", 83404, 2573},
  {"Leaves", 83523, 2576},
  {"CollapseGenealogy", 83653, 2579},
  {"ExtractInformation", 83772, 2582},
  {"TransformInformation", 83891, 2585},
  {"NumberOfLineages", 84008, 2588}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 48, 0, 36, "SubsectionIcon"],
Cell[1790, 53, 512, 11, 88, "DefinitionBox",
  CellTags->{"Nodes", "InternalNodes", "Leaves"}],

Cell[CellGroupData[{
Cell[2327, 68, 88, 2, 27, "Input"],
Cell[2418, 72, 41867, 1248, 184, 25779, 1044, "GraphicsData", "PostScript", \
"Graphics"]
}, Closed]],

Cell[CellGroupData[{
Cell[44322, 1325, 68, 2, 23, "Input"],
Cell[44393, 1329, 196, 3, 20, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[44626, 1337, 69, 2, 23, "Input"],
Cell[44698, 1341, 100, 2, 20, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[44835, 1348, 76, 2, 23, "Input"],
Cell[44914, 1352, 156, 3, 20, "Output"]
}, Closed]],
Cell[45085, 1358, 85, 1, 18, "MathCaption"],

Cell[CellGroupData[{
Cell[45195, 1363, 104, 2, 27, "Input"],
Cell[45302, 1367, 3129, 75, 238, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[48468, 1447, 69, 2, 23, "Input"],
Cell[48540, 1451, 196, 3, 20, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[48773, 1459, 70, 2, 23, "Input"],
Cell[48846, 1463, 100, 2, 20, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[48983, 1470, 77, 2, 23, "Input"],
Cell[49063, 1474, 156, 3, 20, "Output"]
}, Closed]],
Cell[49234, 1480, 1731, 38, 140, "DefinitionBox",
  CellTags->"CollapseGenealogy"],
Cell[50968, 1520, 141, 3, 42, "MathCaption"],

Cell[CellGroupData[{
Cell[51134, 1527, 79, 2, 27, "Input"],
Cell[51216, 1531, 247, 5, 35, "Output"]
}, Closed]],
Cell[51478, 1539, 85, 1, 18, "MathCaption"],

Cell[CellGroupData[{
Cell[51588, 1544, 101, 2, 27, "Input"],
Cell[51692, 1548, 109, 2, 20, "Output"]
}, Closed]],
Cell[51816, 1553, 389, 12, 18, "Text"],
Cell[52208, 1567, 135, 4, 28, "MathCaption"],

Cell[CellGroupData[{
Cell[52368, 1575, 169, 4, 27, "Input"],
Cell[52540, 1581, 1347, 34, 20, "Output"]
}, Closed]],
Cell[53902, 1618, 159, 2, 18, "Text"],
Cell[54064, 1622, 139, 3, 42, "MathCaption"],

Cell[CellGroupData[{
Cell[54228, 1629, 103, 2, 27, "Input"],
Cell[54334, 1633, 195, 3, 35, "Output"]
}, Closed]],
Cell[54544, 1639, 56, 0, 18, "MathCaption"],

Cell[CellGroupData[{
Cell[54625, 1643, 128, 3, 27, "Input"],
Cell[54756, 1648, 99, 2, 20, "Output"]
}, Closed]],
Cell[54870, 1653, 84, 1, 18, "MathCaption"],

Cell[CellGroupData[{
Cell[54979, 1658, 81, 2, 27, "Input"],
Cell[55063, 1662, 196, 3, 35, "Output"]
}, Closed]],
Cell[55274, 1668, 67, 0, 18, "MathCaption"],

Cell[CellGroupData[{
Cell[55366, 1672, 103, 2, 27, "Input"],
Cell[55472, 1676, 100, 2, 20, "Output"]
}, Closed]],
Cell[55587, 1681, 389, 12, 18, "Text"],
Cell[55979, 1695, 134, 3, 28, "MathCaption"],

Cell[CellGroupData[{
Cell[56138, 1702, 171, 4, 27, "Input"],
Cell[56312, 1708, 693, 20, 20, "Output"]
}, Closed]],
Cell[57020, 1731, 395, 9, 50, "DefinitionBox",
  CellTags->"ExtractInformation"],
Cell[57418, 1742, 134, 3, 42, "MathCaption"],

Cell[CellGroupData[{
Cell[57577, 1749, 89, 2, 27, "Input"],
Cell[57669, 1753, 160, 5, 20, "Output"]
}, Closed]],
Cell[57844, 1761, 142, 3, 32, "MathCaption"],

Cell[CellGroupData[{
Cell[58011, 1768, 150, 3, 27, "Input"],
Cell[58164, 1773, 7092, 215, 128, "Output"]
}, Closed]],
Cell[65271, 1991, 98, 3, 18, "MathCaption"],

Cell[CellGroupData[{
Cell[65394, 1998, 90, 2, 27, "Input"],
Cell[65487, 2002, 160, 5, 20, "Output"]
}, Closed]],
Cell[65662, 2010, 167, 4, 32, "MathCaption"],

Cell[CellGroupData[{
Cell[65854, 2018, 152, 3, 42, "Input"],
Cell[66009, 2023, 7092, 215, 128, "Output"]
}, Closed]],
Cell[73116, 2241, 290, 6, 33, "DefinitionBox",
  CellTags->"TransformInformation"],
Cell[73409, 2249, 97, 3, 28, "MathCaption"],

Cell[CellGroupData[{
Cell[73531, 2256, 265, 6, 57, "Input"],
Cell[73799, 2264, 6978, 212, 128, "Output"]
}, Closed]],
Cell[80792, 2479, 88, 3, 18, "Text"],
Cell[80883, 2484, 513, 11, 84, "DefinitionBox",
  CellTags->"NumberOfLineages"],
Cell[81399, 2497, 123, 3, 42, "MathCaption"],

Cell[CellGroupData[{
Cell[81547, 2504, 79, 2, 27, "Input"],
Cell[81629, 2508, 61, 2, 20, "Output"]
}, Closed]],
Cell[81705, 2513, 59, 0, 18, "MathCaption"],

Cell[CellGroupData[{
Cell[81789, 2517, 87, 2, 27, "Input"],
Cell[81879, 2521, 61, 2, 20, "Output"]
}, Closed]],
Cell[81955, 2526, 97, 3, 18, "MathCaption"],

Cell[CellGroupData[{
Cell[82077, 2533, 113, 2, 27, "Input"],
Cell[82193, 2537, 66, 2, 20, "Output"]
}, Closed]],
Cell[82274, 2542, 160, 4, 32, "Text"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

