(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      4143,        103]*)
(*NotebookOutlinePosition[      4989,        130]*)
(*  CellTagsIndexPosition[      4945,        126]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Admixture models", "SubsectionIcon"],

Cell[TextData[{
  "\tHere, we suppose that the population is subject to continuing \
immigration by adults, from two source populations with different allele \
frequencies.  Mixing of divergent populations builds up associations between \
genes inherited from the same parent, and from different parents.  In each \
generation, associations between genes inherited from different parents are \
eliminated by random mating, and then built up again by immigration.  We \
assume that continued migration does not dissipate differences between \
populations; in reality, these may decay, or may be maintained by selection.  \
However, the assumption of a short-term balance between recombination and \
migration is accurate even when allele frequencies are homogenising, or when \
selection maintains them in the face of gene flow (Barton and Gale,",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(\(\ \)\(1993\)\),
          ButtonData:>{"References", "Barton & Gale 1993"},
          ButtonStyle->"AddOnsLink"], TraditionalForm]]],
  ", Kruuk, ",
  Cell[BoxData[
      FormBox[
        ButtonBox[
          ButtonBox["1997",
            ButtonData:>{"EstimatingDReferences.nb", None},
            ButtonStyle->"Hyperlink"],
          ButtonData:>{"References", "Kruuk 1997"},
          ButtonStyle->"AddOnsLink"], TraditionalForm]]],
  "; Barton & Shpak,",
  Cell[BoxData[
      FormBox[
        ButtonBox[\(\(\ \)\(1999\)\),
          ButtonData:>{"References", "Barton & Shpak 1999"},
          ButtonStyle->"AddOnsLink"], TraditionalForm]]],
  "). "
}], "Text"],

Cell["\<\
\tIt would be possible to fit a specific model of admixture, giving \
estimates of migration rates, allele frequencies in the source populations, \
and so on.  However, the distribution of genotype frequencies depends on the \
detailed migration pattern, which is often unknown.  In particular, migration \
at a low rate from divergent populations maintains a small fraction of \
genetically distinct individuals; a higher rate of immigration from less \
divergent populations may maintain the same genetic variance, but much \
smaller higher-order associations.  We therefore aim to find a genetic \
structure which covers this range of admixture models; estimates of this \
general structure can then be compared with particular migration \
models.\
\>", "Text"]
}, Open  ]]
},
FrontEndVersion->"4.0 for Macintosh",
ScreenRectangle->{{0, 1024}, {0, 748}},
WindowSize->{520, 626},
WindowMargins->{{245, Automatic}, {Automatic, 46}},
MacintoshSystemPageSetup->"\<\
00h0001804P000000b02<?oaonl3>@91H`85N0?N0@00005X0FP000003j0:l001
0@00I00100000@0200000BL?00400000000000000000010000000000000@0?ne
oj/@7@]500P1000000000000000001T1\>"
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 42, 0, 36, "SubsectionIcon"],
Cell[1784, 53, 1566, 33, 134, "Text"],
Cell[3353, 88, 774, 12, 120, "Text"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

