(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     20478,        612]*)
(*NotebookOutlinePosition[     21487,        645]*)
(*  CellTagsIndexPosition[     21401,        639]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Finding the intervals in which a variable can lie", "SubsectionIcon"],

Cell[TextData[Cell[BoxData[
    FormBox[GridBox[{
          {
            RowBox[{"ConstrainedIntervals", "[", 
              RowBox[{
                RowBox[{
                  StyleBox["expr",
                    FontSlant->"Italic"], ">", "0"}], ",", " ", "x"}], "]"}], 
            
            RowBox[{
              RowBox[{
              "gives", " ", "a", " ", "list", " ", "of", " ", "the", " ", 
                "possible", " ", "intervals", " ", "in", " ", "which", " ", 
                "x", " ", "can", " ", 
                RowBox[{"lie", ".", "  ", 
                  StyleBox["expr",
                    FontSlant->"Italic"]}], " ", "must", " ", "be", " ", "a", 
                " ", "polynomial", " ", "in", " ", "x"}], ",", 
              " ", \(and\ must\ return\ numerical\ values\), ",", 
              " ", \(given\ \(\(x\)\(.\)\)\)}]}
          }], TraditionalForm]]]], "DefinitionBox",
  CellTags->"ConstrainedIntervals"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ff = x\^4 - 3  x\^3 + 4  x - 1; Plot[ff, {x, \(-4\), 4}]; \)], "Input",
  CellLabel->"In[109]:="],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.119048 0.109204 0.0360271 [
[.02381 .0967 -6 -9 ]
[.02381 .0967 6 0 ]
[.2619 .0967 -6 -9 ]
[.2619 .0967 6 0 ]
[.7381 .0967 -3 -9 ]
[.7381 .0967 3 0 ]
[.97619 .0967 -3 -9 ]
[.97619 .0967 3 0 ]
[.4875 .01914 -24 -4.5 ]
[.4875 .01914 0 4.5 ]
[.4875 .19927 -18 -4.5 ]
[.4875 .19927 0 4.5 ]
[.4875 .28934 -6 -4.5 ]
[.4875 .28934 0 4.5 ]
[.4875 .37941 -18 -4.5 ]
[.4875 .37941 0 4.5 ]
[.4875 .46948 -12 -4.5 ]
[.4875 .46948 0 4.5 ]
[.4875 .55954 -24 -4.5 ]
[.4875 .55954 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 .1092 m
.02381 .11545 L
s
[(-4)] .02381 .0967 0 1 Mshowa
.2619 .1092 m
.2619 .11545 L
s
[(-2)] .2619 .0967 0 1 Mshowa
.7381 .1092 m
.7381 .11545 L
s
[(2)] .7381 .0967 0 1 Mshowa
.97619 .1092 m
.97619 .11545 L
s
[(4)] .97619 .0967 0 1 Mshowa
.125 Mabswid
.08333 .1092 m
.08333 .11295 L
s
.14286 .1092 m
.14286 .11295 L
s
.20238 .1092 m
.20238 .11295 L
s
.32143 .1092 m
.32143 .11295 L
s
.38095 .1092 m
.38095 .11295 L
s
.44048 .1092 m
.44048 .11295 L
s
.55952 .1092 m
.55952 .11295 L
s
.61905 .1092 m
.61905 .11295 L
s
.67857 .1092 m
.67857 .11295 L
s
.79762 .1092 m
.79762 .11295 L
s
.85714 .1092 m
.85714 .11295 L
s
.91667 .1092 m
.91667 .11295 L
s
.25 Mabswid
0 .1092 m
1 .1092 L
s
.5 .01914 m
.50625 .01914 L
s
[(-2.5)] .4875 .01914 1 0 Mshowa
.5 .19927 m
.50625 .19927 L
s
[(2.5)] .4875 .19927 1 0 Mshowa
.5 .28934 m
.50625 .28934 L
s
[(5)] .4875 .28934 1 0 Mshowa
.5 .37941 m
.50625 .37941 L
s
[(7.5)] .4875 .37941 1 0 Mshowa
.5 .46948 m
.50625 .46948 L
s
[(10)] .4875 .46948 1 0 Mshowa
.5 .55954 m
.50625 .55954 L
s
[(12.5)] .4875 .55954 1 0 Mshowa
.125 Mabswid
.5 .03715 m
.50375 .03715 L
s
.5 .05516 m
.50375 .05516 L
s
.5 .07318 m
.50375 .07318 L
s
.5 .09119 m
.50375 .09119 L
s
.5 .12722 m
.50375 .12722 L
s
.5 .14523 m
.50375 .14523 L
s
.5 .16324 m
.50375 .16324 L
s
.5 .18126 m
.50375 .18126 L
s
.5 .21729 m
.50375 .21729 L
s
.5 .2353 m
.50375 .2353 L
s
.5 .25331 m
.50375 .25331 L
s
.5 .27133 m
.50375 .27133 L
s
.5 .30735 m
.50375 .30735 L
s
.5 .32537 m
.50375 .32537 L
s
.5 .34338 m
.50375 .34338 L
s
.5 .36139 m
.50375 .36139 L
s
.5 .39742 m
.50375 .39742 L
s
.5 .41543 m
.50375 .41543 L
s
.5 .43345 m
.50375 .43345 L
s
.5 .45146 m
.50375 .45146 L
s
.5 .48749 m
.50375 .48749 L
s
.5 .5055 m
.50375 .5055 L
s
.5 .52352 m
.50375 .52352 L
s
.5 .54153 m
.50375 .54153 L
s
.5 .00112 m
.50375 .00112 L
s
.5 .57756 m
.50375 .57756 L
s
.5 .59557 m
.50375 .59557 L
s
.5 .61358 m
.50375 .61358 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.30111 .61803 m
.30164 .61074 L
.32148 .40374 L
.33161 .31944 L
.34251 .24314 L
.35271 .18401 L
.36204 .13936 L
.3709 .10457 L
.38034 .07486 L
.39019 .05116 L
.39933 .0351 L
.40492 .0278 L
.4102 .02253 L
.41493 .01903 L
.4176 .01754 L
.42005 .01646 L
.42131 .01601 L
.42251 .01565 L
.42359 .01537 L
.42475 .01513 L
.426 .01494 L
.42716 .01481 L
.42841 .01473 L
.42912 .01472 L
.42979 .01472 L
.4309 .01476 L
.43207 .01485 L
.43307 .01496 L
.43416 .01513 L
.4366 .01565 L
.43887 .01632 L
.44411 .01845 L
.44886 .02107 L
.45954 .02892 L
.47872 .04807 L
.49952 .0726 L
.519 .09577 L
.54044 .11837 L
.55025 .12702 L
.5608 .13483 L
.57075 .14063 L
.57984 .14451 L
.58462 .14599 L
.58724 .14664 L
.58971 .14714 L
.59202 .14751 L
.59323 .14767 L
.59452 .14782 L
.5956 .14791 L
.59678 .148 L
Mistroke
.59786 .14805 L
.59886 .14809 L
.60016 .14811 L
.60088 .1481 L
.60156 .14809 L
.60279 .14806 L
.60411 .14799 L
.60528 .1479 L
.60638 .1478 L
.60888 .1475 L
.61158 .14706 L
.61404 .14655 L
.6196 .14506 L
.62436 .14341 L
.62943 .14129 L
.63856 .13661 L
.65928 .12257 L
.67923 .10641 L
.70083 .08918 L
.71096 .08237 L
.7165 .07926 L
.72167 .07683 L
.72608 .0752 L
.72835 .07453 L
.73082 .07394 L
.73222 .07368 L
.73351 .07349 L
.73475 .07334 L
.73607 .07324 L
.73724 .07319 L
.73835 .07318 L
.73956 .07321 L
.74086 .0733 L
.74211 .07343 L
.74325 .0736 L
.74457 .07385 L
.74581 .07413 L
.74802 .07479 L
.75042 .0757 L
.75586 .07861 L
.76088 .08241 L
.76575 .08721 L
.77112 .09387 L
.78197 .11222 L
.79212 .13605 L
.80139 .16425 L
.81223 .20591 L
.82228 .25397 L
.84128 .37318 L
.86201 .55277 L
Mistroke
Mfstroke
.86201 .55277 m
.86763 .61803 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[109]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00OSgoo0P00Sgoo002?
Ool00`00Oomoo`2>Ool008moo`03001oogoo08ioo`00NGoo1@000goo00<007ooOol00Woo0`001Woo
00<007ooOol0SWoo001hOol70006Ool01@00Oomoogoo00001Goo00<007ooOol0SWoo001cOol50003
Ool01@00Oomoogoo00002Goo00<007ooOol00goo0`00SWoo001eOol00`00Oomoo`04Ool01000Oomo
ogoo0P001goo00<007ooOol00goo00<007ooOol0SWoo001eOol01@00Oomoogoo00000goo00<007oo
Ool00Woo00<007ooOol010001Woo00<007ooOol0SWoo001dOol00`00Oomoo`02Ool01@00Oomoogoo
00001Goo0`002Goo00<007ooOol0SWoo001cOol00`00Oomoo`04Ool30008Ool50005Ool00`00Oomo
o`2>Ool0079oo`03001oogoo015oo`03001oogoo00Ioo`8008moo`00LWoo00<007ooOol04Woo00<0
07ooOol01Goo00<007ooOol0SWoo001aOol00`00Oomoo`0DOol00`00Oomoo`04Ool00`00Oomoo`2>
Ool0075oo`03001oogoo01Eoo`03001oogoo00=oo`03001oogoo08ioo`00L7oo00<007ooOol05Woo
00<007ooOol00goo00<007ooOol0SWoo001`Ool00`00Oomoo`0GOol00`00Oomoo`02Ool2002?Ool0
06moo`03001oogoo01Uoo`05001oogooOol0002@Ool006moo`03001oogoo01Yoo`04001oogoo002@
Ool006ioo`03001oogoo01aoo`03001oo`00091oo`002Goo0`00?goo1@007Woo00<007ooOol07Goo
0P00@7oo1@00@Goo0`001goo000:Ool00`00Oomoo`0oOol01000Oomoo`007Woo00<007ooOol07Woo
00<007ooOol0?goo00@007ooOol0049oo`03001oogoo00Ioo`0000=oo`0000000`0000=oo`000000
0`00>Goo1@000goo00<007ooOol07Goo00<007ooOol07goo0P00?Woo2@00?7oo1@001goo0007Ool0
1000Oomoo`00@goo00<007ooOol077oo00<007ooOol07goo0P00>goo0`0017oo00<007ooOol00Woo
0P00>Woo00@007ooOol000Qoo`0027oo00<007oo0000@7oo00D007ooOomoo`0001aoo`03001oogoo
021oo`03001oo`0003Qoo`8000Aoo`05001oogooOol00005Ool00`00Oomoo`0hOol00`00Ool00008
Ool000Uoo`80041oo`05001oogooOol0000LOol00`00Oomoo`0POol01000Oomoo`00=Woo00<007oo
Ool017oo00D007ooOomoo`0000Eoo`03001oogoo03Uoo`8000Qoo`002Woo00<007ooOol0?goo0`00
7Goo00<007ooOol087oo00@007ooOol003Aoo`8000Qoo`<000Moo`8003Yoo`03001oogoo00Ioo`00
Jgoo00<007ooOol08Goo0P000Woo00<007ooOol0<7oo00<007ooOol057oo00<007ooOol0@7oo001[
Ool00`00Oomoo`0QOol00`00Oomoo`02Ool2000_Ool00`00Oomoo`0EOol00`00Oomoo`10Ool006]o
o`03001oogoo025oo`03001oogoo00Aoo`03001oogoo02]oo`03001oogoo01Moo`03001oogoo03mo
o`00JWoo00<007ooOol08Woo00<007ooOol01Goo00<007ooOol0:Goo00<007ooOol067oo00<007oo
Ool0?goo001ZOol00`00Oomoo`0ROol00`00Oomoo`06Ool00`00Oomoo`0WOol00`00Oomoo`0JOol0
0`00Oomoo`0nOol00?l00200005oo`001goo00<007ooOol03Woo00<007ooOol03Woo00<007ooOol0
3Woo00<007ooOol03Woo00<007ooOol03Woo00<007ooOol02Woo00D007ooOomoo`00011oo`03001o
ogoo00ioo`03001oogoo00Qoo`03001oogoo00=oo`03001oogoo00ioo`03001oogoo00aoo`03001o
o`00011oo`03001oogoo00Yoo`05001oogooOol0000@Ool00`00Oomoo`0>Ool00`00Oomoo`0>Ool0
0`00Oomoo`06Ool000Moo`03001oogoo045oo`03001oogoo01]oo`03001oogoo02=oo`03001oogoo
00Uoo`03001oogoo025oo`03001oogoo015oo`03001oogoo00Yoo`03001oogoo03Aoo`03001oogoo
00Ioo`00JGoo00<007ooOol08goo00<007ooOol02Goo00<007ooOol087oo00<007ooOol087oo00<0
07ooOol0?7oo001YOol00`00Oomoo`0SOol00`00Oomoo`0:Ool00`00Oomoo`0MOol2000SOol00`00
Oomoo`0lOol006Uoo`03001oogoo02=oo`8000aoo`8001aoo`03001oogoo02Aoo`03001oogoo03]o
o`00J7oo00<007ooOol097oo00<007ooOol03Goo00<007ooOol05goo0P009goo00<007ooOol0>goo
001XOol00`00Oomoo`0TOol00`00Oomoo`0>Ool2000FOol00`00Oomoo`0WOol00`00Oomoo`0kOol0
06Qoo`03001oogoo02Aoo`03001oogoo011oo`03001oogoo015oo`8002]oo`03001oogoo03Yoo`00
J7oo00<007ooOol097oo00<007ooOol04Goo0`003Woo0P00;Goo00<007ooOol0>Woo001XOol00`00
Oomoo`0TOol2000EOol20009Ool3000_Ool00`00Oomoo`0jOol006Moo`03001oogoo02Eoo`03001o
ogoo01Ioo`T003=oo`03001oogoo03Uoo`00Igoo00<007ooOol09Goo00<007ooOol0DWoo00<007oo
Ool0>Goo001WOol00`00Oomoo`0UOol00`00Oomoo`1BOol00`00Oomoo`0iOol006Moo`03001oogoo
02Eoo`03001oogoo059oo`03001oogoo03Uoo`00IWoo00<007ooOol09Woo0P00E7oo00<007ooOol0
>7oo001VOol00`00Oomoo`0VOol00`00Oomoo`1COol00`00Oomoo`0hOol006Ioo`03001oogoo02Io
o`03001oogoo05=oo`03001oogoo03Qoo`00IWoo00<007ooOol09Woo00<007ooOol0Dgoo00<007oo
Ool0>7oo001VOol00`00Oomoo`0VOol00`00Oomoo`1DOol00`00Oomoo`0gOol006Eoo`03001oogoo
02Moo`8005Eoo`03001oogoo03Moo`00IGoo00<007ooOol09goo00<007ooOol0E7oo00<007ooOol0
=goo001UOol00`00Oomoo`0WOol00`00Oomoo`1DOol00`00Oomoo`0gOol006Eoo`03001oogoo015o
o`D000=oo`03001oogoo009oo`<000Ioo`03001oogoo05Eoo`03001oogoo03Ioo`00IGoo00<007oo
Ool04Woo00@007ooOol000Moo`05001oogooOol00005Ool00`00Oomoo`1EOol00`00Oomoo`0fOol0
06Aoo`03001oogoo01Aoo`03001oogoo00]oo`03001oogoo00=oo`03001oogoo05Eoo`03001oogoo
03Ioo`00I7oo00<007ooOol05Goo00<007ooOol02Woo00<007ooOol00goo0`00EGoo00<007ooOol0
=Woo001TOol00`00Oomoo`0BOol01@00Oomoogoo00001goo10001Woo00<007ooOol0EWoo00<007oo
Ool0=Goo001TOol00`00Oomoo`0BOol01@00Oomoogoo00001goo00<007ooOol01goo00<007ooOol0
EWoo00<007ooOol0=Goo001TOol00`00Oomoo`0COol30008Ool50005Ool00`00Oomoo`1FOol00`00
Oomoo`0eOol006=oo`03001oogoo02Uoo`03001oogoo05Ioo`03001oogoo03Eoo`00Hgoo00<007oo
Ool0:Goo0P00F7oo00<007ooOol0=7oo001SOol00`00Oomoo`0YOol00`00Oomoo`1GOol00`00Oomo
o`0dOol006=oo`03001oogoo02Uoo`03001oogoo05Moo`03001oogoo03Aoo`00Hgoo00<007ooOol0
:Goo00<007ooOol0Egoo00<007ooOol0=7oo001SOol00`00Oomoo`0YOol00`00Oomoo`1HOol00`00
Oomoo`0cOol0069oo`03001oogoo02Yoo`8005Uoo`03001oogoo03=oo`00HWoo00<007ooOol0:Woo
00<007ooOol0F7oo00<007ooOol0<goo001ROol00`00Oomoo`0ZOol00`00Oomoo`1HOol00`00Oomo
o`0cOol0069oo`03001oogoo02Yoo`03001oogoo05Qoo`03001oogoo03=oo`00HWoo00<007ooOol0
:Woo00<007ooOol0FGoo00<007ooOol0<Woo001ROol00`00Oomoo`0ZOol2001JOol00`00Oomoo`0b
Ool0069oo`03001oogoo02Yoo`03001oogoo05Uoo`03001oogoo039oo`00HGoo00<007ooOol0:goo
00<007ooOol0FGoo00<007ooOol0<Woo001QOol00`00Oomoo`0[Ool00`00Oomoo`1IOol00`00Oomo
o`0bOol0065oo`03001oogoo02]oo`03001oogoo05Yoo`03001oogoo035oo`00HGoo00<007ooOol0
:goo0P00Fgoo00<007ooOol0<Goo001QOol00`00Oomoo`0[Ool00`00Oomoo`1JOol00`00Oomoo`0a
Ool0065oo`03001oogoo02]oo`03001oogoo05Yoo`03001oogoo035oo`00HGoo00<007ooOol08Woo
0`001Woo00<007ooOol0FWoo00<007ooOol0<Goo001POol00`00Oomoo`0ROol01@00Oomoogoo0000
1Goo00<007ooOol0Fgoo00<007ooOol0<7oo001POol00`00Oomoo`0VOol00`00Oomoo`03Ool3001K
Ool00`00Oomoo`0`Ool0061oo`03001oogoo02Ioo`03001oogoo00=oo`03001oogoo05]oo`03001o
ogoo031oo`00H7oo00<007ooOol08Woo10001Woo00<007ooOol0Fgoo00<007ooOol0<7oo001POol0
0`00Oomoo`0ROol00`00Oomoo`07Ool00`00Oomoo`1KOol00`00Oomoo`0`Ool0061oo`03001oogoo
029oo`D000Eoo`03001oogoo05]oo`03001oogoo031oo`00H7oo00<007ooOol0;7oo00<007ooOol0
G7oo00<007ooOol0;goo001OOol00`00Oomoo`0]Ool2001MOol00`00Oomoo`0_Ool005moo`03001o
ogoo02eoo`03001oogoo05aoo`03001oogoo02moo`00Ggoo00<007ooOol0;Goo00<007ooOol0G7oo
00<007ooOol0;goo001OOol00`00Oomoo`0]Ool00`00Oomoo`1LOol00`00Oomoo`0_Ool005moo`03
001oogoo02eoo`03001oogoo05aoo`03001oogoo02moo`00Ggoo00<007ooOol0;Goo0P00GWoo00<0
07ooOol0;Woo001OOol00`00Oomoo`0]Ool00`00Oomoo`1MOol00`00Oomoo`0^Ool005moo`03001o
ogoo02eoo`03001oogoo05eoo`03001oogoo02ioo`00GWoo00<007ooOol0;Woo00<007ooOol0GGoo
00<007ooOol0;Woo001NOol00`00Oomoo`0^Ool00`00Oomoo`1MOol00`00Oomoo`0^Ool005ioo`03
001oogoo02ioo`8005moo`03001oogoo02eoo`00GWoo00<007ooOol0;Woo00<007ooOol0GWoo00<0
07ooOol0;Goo001NOol00`00Oomoo`0^Ool00`00Oomoo`1NOol00`00Oomoo`0]Ool005ioo`03001o
ogoo02ioo`03001oogoo05ioo`03001oogoo02eoo`00GWoo00<007ooOol0;Woo00<007ooOol0GWoo
00<007ooOol0;Goo001NOol00`00Oomoo`0^Ool2001OOol00`00Oomoo`0]Ool005eoo`03001oogoo
02moo`03001oogoo05moo`03001oogoo02aoo`00GGoo00<007ooOol0;goo00<007ooOol0Ggoo00<0
07ooOol0;7oo001MOol00`00Oomoo`0KOol00`00Oomoo`03Ool00`00Oomoo`02Ool30006Ool00`00
Oomoo`1OOol00`00Oomoo`0/Ool005eoo`03001oogoo01]oo`03001oogoo00Moo`05001oogooOol0
0005Ool00`00Oomoo`1OOol00`00Oomoo`0/Ool005eoo`03001oogoo01aoo`03001oogoo00Yoo`03
001oogoo00=oo`<005moo`03001oogoo02aoo`00GGoo00<007ooOol077oo00<007ooOol02Woo00<0
07ooOol00goo00<007ooOol0Ggoo00<007ooOol0;7oo001MOol00`00Oomoo`0MOol00`00Oomoo`05
Ool40006Ool00`00Oomoo`1OOol00`00Oomoo`0/Ool005eoo`03001oogoo01Uoo`05001oogooOol0
0007Ool00`00Oomoo`07Ool00`00Oomoo`1POol00`00Oomoo`0[Ool005aoo`03001oogoo01Yoo`D0
00Moo`D000Eoo`03001oogoo061oo`03001oogoo02]oo`00G7oo00<007ooOol0<7oo0P00HGoo00<0
07ooOol0:goo001LOol00`00Oomoo`0`Ool00`00Oomoo`1POol00`00Oomoo`0[Ool005aoo`03001o
ogoo031oo`03001oogoo061oo`03001oogoo02]oo`00G7oo00<007ooOol0<7oo00<007ooOol0H7oo
00<007ooOol0:goo001LOol00`00Oomoo`0`Ool00`00Oomoo`1POol00`00Oomoo`0[Ool005aoo`03
001oogoo031oo`80065oo`03001oogoo02]oo`00G7oo00<007ooOol0<7oo00<007ooOol0H7oo00<0
07ooOol0:goo001LOol00`00Oomoo`0`Ool00`00Oomoo`1QOol00`00Oomoo`0ZOol005]oo`03001o
ogoo035oo`03001oogoo065oo`03001oogoo02Yoo`00Fgoo00<007ooOol0<Goo00<007ooOol0HGoo
00<007ooOol0:Woo001KOol00`00Oomoo`0aOol00`00Oomoo`1QOol00`00Oomoo`0ZOol005]oo`03
001oogoo035oo`80069oo`03001oogoo02Yoo`00Fgoo00<007ooOol0<Goo00<007ooOol0HGoo00<0
07ooOol0:Woo001KOol00`00Oomoo`0aOol00`00Oomoo`1QOol00`00Oomoo`0ZOol005]oo`03001o
ogoo035oo`03001oogoo065oo`03001oogoo02Yoo`00Fgoo00<007ooOol0<Goo00<007ooOol0HGoo
00<007ooOol0:Woo001KOol00`00Oomoo`0aOol2001SOol00`00Oomoo`0YOol005]oo`03001oogoo
035oo`03001oogoo069oo`03001oogoo02Uoo`00FWoo00<007ooOol08goo0`0017oo0P001Woo00<0
07ooOol0HWoo00<007ooOol0:Goo001JOol00`00Oomoo`0TOol00`00Oomoo`02Ool01000Oomoo`00
1Goo00<007ooOol0HWoo00<007ooOol0:Goo001JOol00`00Oomoo`0TOol00`00Oomoo`02Ool01000
Oomoo`001Goo00<007ooOol0HWoo00<007ooOol0:Goo001JOol00`00Oomoo`0TOol00`00Oomoo`02
Ool01000Oomoo`001Goo0`00HWoo00<007ooOol0:Goo001JOol00`00Oomoo`0TOol00`00Oomoo`02
Ool01000Oomoo`001Goo00<007ooOol0HWoo00<007ooOol0:Goo001JOol00`00Oomoo`0SOol20004
Ool01000Oomoo`001Goo00<007ooOol0HWoo00<007ooOol0:Goo001JOol00`00Oomoo`0TOol00`00
Oomoo`03Ool20006Ool00`00Oomoo`1SOol00`00Oomoo`0XOol005Yoo`03001oogoo039oo`03001o
ogoo06=oo`03001oogoo02Qoo`00FWoo00<007ooOol0<Woo0P00I7oo00<007ooOol0:7oo001JOol0
0`00Oomoo`0bOol00`00Oomoo`1SOol00`00Oomoo`0XOol005Uoo`03001oogoo03=oo`03001oogoo
06=oo`03001oogoo02Qoo`00FGoo00<007ooOol0<goo00<007ooOol0Hgoo00<007ooOol0:7oo001I
Ool00`00Oomoo`0cOol00`00Oomoo`1SOol00`00Oomoo`0XOol005Uoo`03001oogoo03=oo`8006Ao
o`03001oogoo02Qoo`00FGoo00<007ooOol0<goo00<007ooOol0Hgoo00<007ooOol0:7oo001IOol0
0`00Oomoo`0cOol00`00Oomoo`1TOol00`00Oomoo`0WOol005Uoo`03001oogoo03=oo`03001oogoo
06Aoo`03001oogoo02Moo`00FGoo00<007ooOol0<goo00<007ooOol0I7oo00<007ooOol09goo001I
Ool00`00Oomoo`0cOol2001UOol00`00Oomoo`0WOol005Qoo`03001oogoo03Aoo`03001oogoo06Ao
o`03001oogoo02Moo`00F7oo00<007ooOol0=7oo00<007ooOol0I7oo00<007ooOol09goo001HOol0
0`00Oomoo`0dOol00`00Oomoo`1TOol00`00Oomoo`0WOol005Qoo`03001oogoo03Aoo`03001oogoo
06Aoo`03001oogoo02Moo`00F7oo00<007ooOol0=7oo00<007ooOol0I7oo00<007ooOol09goo001H
Ool00`00Oomoo`0dOol2001VOol00`00Oomoo`0VOol005Qoo`03001oogoo03Aoo`03001oogoo06Eo
o`03001oogoo02Ioo`00F7oo00<007ooOol06Goo0`000Woo1@000goo00<007ooOol00Woo0`001Woo
00<007ooOol0IGoo00<007ooOol09Woo001HOol00`00Oomoo`0JOol00`00Oomoo`02Ool01000Oomo
o`001goo00D007ooOomoo`0000Eoo`03001oogoo06Eoo`03001oogoo02Ioo`00F7oo00<007ooOol0
6Woo00<007ooOol00goo00<007ooOol02goo00<007ooOol00goo00<007ooOol0IGoo00<007ooOol0
9Woo001GOol00`00Oomoo`0KOol00`00Oomoo`04Ool00`00Oomoo`0:Ool00`00Oomoo`03Ool3001U
Ool00`00Oomoo`0VOol005Moo`03001oogoo01]oo`05001oogooOol00003Ool00`00Oomoo`05Ool4
0006Ool00`00Oomoo`1UOol00`00Oomoo`0VOol005Moo`03001oogoo01Yoo`8000=oo`05001oogoo
Ool00007Ool00`00Oomoo`07Ool00`00Oomoo`1UOol00`00Oomoo`0VOol005Moo`03001oogoo01]o
o`03001oogoo009oo`<000Qoo`D000Eoo`03001oogoo06Eoo`03001oogoo02Ioo`00Egoo00<007oo
Ool0=Goo00<007ooOol0IGoo00<007ooOol09Woo001GOol00`00Oomoo`0eOol2001VOol00`00Oomo
o`0VOol005Moo`03001oogoo03Eoo`03001oogoo06Eoo`03001oogoo02Ioo`00Egoo00<007ooOol0
=Goo00<007ooOol0IGoo00<007ooOol09Woo001GOol00`00Oomoo`0eOol00`00Oomoo`1VOol00`00
Oomoo`0UOol005Moo`03001oogoo03Eoo`03001oogoo06Ioo`03001oogoo02Eoo`00EWoo00<007oo
Ool0=Woo0P00Igoo00<007ooOol09Goo001FOol00`00Oomoo`0fOol00`00Oomoo`1VOol00`00Oomo
o`0UOol005Ioo`03001oogoo03Ioo`03001oogoo06Ioo`03001oogoo02Eoo`00EWoo00<007ooOol0
=Woo00<007ooOol0IWoo00<007ooOol09Goo001FOol00`00Oomoo`0fOol00`00Oomoo`1VOol00`00
Oomoo`0UOol005Ioo`03001oogoo03Ioo`8006Moo`03001oogoo02Eoo`00EWoo00<007ooOol0=Woo
00<007ooOol0IWoo00<007ooOol09Goo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-4.2104, -3.03125, \
0.0293408, 0.0969538}}]
}, Open  ]],

Cell[TextData[{
  "This gives the intervals for which ",
  Cell[BoxData[
      \(TraditionalForm\`x\)]],
  " satisfies ",
  Cell[BoxData[
      \(x\^4 - 3  x\^3 + 4  x - 1\)]],
  ">0"
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ConstrainedIntervals[ff > 0, x]\)], "Input",
  CellLabel->"In[110]:="],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"{", 
          RowBox[{
            InterpretationBox[\(-\[Infinity]\),
              DirectedInfinity[ -1]], ",", \(-1.09529398522391453`\)}], "}"}],
         ",", \({0.262359694771812623`, 1.47725999647401939`}\), ",", 
        RowBox[{"{", 
          RowBox[{"2.35567429397808236`", ",", 
            InterpretationBox["\[Infinity]",
              DirectedInfinity[ 1]]}], "}"}]}], "}"}]], "Output",
  CellLabel->"Out[110]="]
}, Open  ]],

Cell[TextData[{
  "ConstrainedIntervals[] uses the function ",
  ButtonBox["ConstrainedMax",
    ButtonData:>{"ConstrainedMax"},
    ButtonStyle->"RefGuideLink"]
}], "Text"]
}, Open  ]]
},
FrontEndVersion->"4.0 for Macintosh",
ScreenRectangle->{{0, 1024}, {0, 748}},
WindowSize->{520, 626},
WindowMargins->{{245, Automatic}, {Automatic, 46}},
MacintoshSystemPageSetup->"\<\
00h0001804P000000b02<?oaonl3>@91H`85N0?N0@00005X0FP000003j0:l001
0@00I00100000@0200000BL?00400000000000000000010000000000000@0?ne
oj/@7@]500P1000000000000000001T1\>"
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "ConstrainedIntervals"->{
    Cell[1817, 53, 945, 21, 64, "DefinitionBox",
      CellTags->"ConstrainedIntervals"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"ConstrainedIntervals", 21285, 632}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 75, 0, 36, "SubsectionIcon"],
Cell[1817, 53, 945, 21, 64, "DefinitionBox",
  CellTags->"ConstrainedIntervals"],

Cell[CellGroupData[{
Cell[2787, 78, 117, 2, 28, "Input"],
Cell[2907, 82, 16547, 488, 184, 4657, 336, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]],
Cell[19469, 573, 195, 8, 24, "Text"],

Cell[CellGroupData[{
Cell[19689, 585, 90, 2, 27, "Input"],
Cell[19782, 589, 492, 12, 20, "Output"]
}, Open  ]],
Cell[20289, 604, 173, 5, 23, "Text"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

