(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      3448,         95]*)
(*NotebookOutlinePosition[      4331,        123]*)
(*  CellTagsIndexPosition[      4287,        119]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["Natural and sexual selection on diploids", "SubsectionIcon"],

Cell["\<\
The basic notation is quite general, and can be adapted to a wide \
variety of models.  In this section, functions for the special case of \
selection on diploids are documented.  The algorithms used are given, so that \
it is easy to adapt them for similar cases.  The full code can be found in \
the package itself.\
\>", "Text"],

Cell[TextData[{
  "The evolution of a population is implemented by a series of rules, such as \
Recombination[], Selection[]...., which transform associations at one stage \
in the life cycle into those at a previous stage.  The best way to understand \
how these rules work is to try them one by one, starting with the examples in \
this documentation.  Constructing a whole list of rules to represent the ",
  ButtonBox["whole life cycle",
    ButtonData:>{"Complete life cycle", "Complete rules"},
    ButtonStyle->"AddOnsLink"],
  " should be done step-by-step, both in order to check that each step works \
as intended, and also to ensure that the mass of algebra doesn't get out of \
hand."
}], "Text"],

Cell[TextData[{
  "This loads the package; it also reads in ",
  ButtonBox["Utilities`SetManipulation`",
    ButtonData:>{"Overview of set manipulation", None},
    ButtonStyle->"AddOnsLink",
    ButtonNote->"Utilities`SetManipulation`"],
  " and ",
  ButtonBox["Utilities`Notation`",
    ButtonData:>{"Notation Documentation", None},
    ButtonStyle->"AddOnsLink"],
  ":"
}], "MathCaption"],

Cell[BoxData[
    RowBox[{
      RowBox[{"<<", 
        StyleBox["Multilocus`Multilocus`",
          "Chapter\[AGrave]"]}], 
      StyleBox[";",
        "Chapter\[AGrave]"]}]], "Input",
  CellLabel->"In[1]:="]
},
FrontEndVersion->"4.0 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 748}},
WindowSize->{858, 570},
WindowMargins->{{26, Automatic}, {Automatic, 27}},
StyleDefinitions -> "HelpBrowser.nb",
MacintoshSystemPageSetup->"\<\
00h0001804P000000b02<?oaonl3>@91H`85N0?N0@00005X0FP000003j0:l001
0@00I00100000@0200000BL?00400000000000000000010000000000000@0?ne
oj/@7@]500P1000000000000000001T1\>"
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 66, 0, 36, "SubsectionIcon"],
Cell[1786, 51, 341, 6, 36, "Text"],
Cell[2130, 59, 708, 12, 65, "Text"],
Cell[2841, 73, 391, 11, 29, "MathCaption"],
Cell[3235, 86, 209, 7, 26, "Input"]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

