(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)

BeginPackage[
    "NumericalModels`ExactModel`",{"LinearAlgebra`MatrixManipulation`",
      "Multilocus`DataManipulation`","Statistics`DiscreteDistributions`",
      "Utilities`Matrices`","Utilities`RandomNumbers`",
      "Utilities`SetManipulation`","Utilities`Miscellaneous`"}];



Off[General::spell1,General::spell];





\!\(\*
  RowBox[{
    RowBox[{
      RowBox[{
        StyleBox["MakePopulation",
          FontFamily->"Times"], "::", "usage"}], "=", 
      "\"\<MakePopulation[nloci,p] gives a haploid population at linkage \
equilibrium, with allele frequency p; this is represented as \
HaploidFrequencies[{\!\(\[Psi]\_000\)\[Ellipsis]}]. The option NumericalModel \
can be used to give other representations.  For example, \
MakePopulation[nloci,{p,u},NumericalModel->SymmetricNeutralHaploidFrequencies \
gives a haploid population at LE, with selected loci at frequency p, and a \
single neutral marker at frequency u. \
MakePopulation[nloci,p,NumericalModel->HaploidIndividuals] gives a single \
haploid individual, drawn at random. MakePopulation[nloci,p,ndeme,opts] \
allows deme size to be specified; the default is 1.  \>\""}], ";"}]\)



MakeDiploid::usage=
    "MakeDiploid[HaploidFrequencies[\[Ellipsis]]] gives the matrix of diploid \
genotype frequencies after random mating. Deme size is halved. Applies to \
vectors of class, genotype and allele frequencies;  \
MakeDiploid[HaploidIndividuals[\[Ellipsis]]] generates a population of \
diploids by sampling with replacement from the haploid population; not \
particularly useful, and added for completeness only.";



MakeHaploid::usage=
    "MakeHaploid[DiploidFrequencies[\[Ellipsis]]] gives the haploid genotype \
frequencies, averaged over maternal and paternal genomes.  Deme size is \
doubled.  Applies to vectors of class, genotype and allele frequencies.  Deme \
size is left unaltered, except for \
MakeHaploid[DiploidIndividuals[\[Ellipsis]]], for which deme size is doubled. \
 This just flattens the list: there is no sampling.";



\!\(\(MakeIndividuals::usage = \*"\"\<MakeIndividuals[\[Psi],n] generates n \
random individuals from the population \[Psi].  If \[Psi] represents a \
diploid population, the representation DiploidIndividuals[] is returned; \
similarly for haploids.  MakeIndividuals[AlleleFrequencies[p,n0],n] returns n \
haploid individuals, drawn from a population at linkage equilibrium. \
MakeIndividuals[SymmetricNeutralHaploidFrequencies[{\[Psi],u},n0],n] adds a \
neutral marker locus at the last position of the genotype.  MakeIndividuals[{\
\!\(\[Psi]\_1\)\[Ellipsis]},{\!\(n\_1\),\[Ellipsis]}] generates individuals \
across a cline.  MakeIndividuals[j,n] returns a haplotype of n genes, wih j \
randomly assigned to 1.\>\"";\)\)



MakeOptionsHaploid::usage=
    "MakeOptionsHaploid is a rule which converts options such as \
NumericalModel->DiploidFrequencies to their haploid version";



NumericalModel::usage=
    "NumericalModel is an option which determines how a population is \
represented.  Possible values are any PopulationRepresentations";



\!\(\(HaploidFrequencies::usage = \
\*"\"\<HaploidFrequencies[{\!\(\[Psi]\_000\),\[Ellipsis]},n] represents \
haploid genotype frequencies, and deme size n.  \
HaploidFrequencies[{\!\(\[Psi]\_000\),\[Ellipsis]}] is shorthand for \
HaploidFrequencies[{\!\(\[Psi]\_000\),\[Ellipsis]},1]\>\"";\)\)



\!\(\(DiploidFrequencies::usage = \
\*"\"\<DiploidFrequencies[{{\!\(\[Psi]\_\(000, \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \
\(\(\\\\\)\(\\\ \)\) 000\)\)\)\),\[Ellipsis]},\[Ellipsis]},n] represents \
diploid genotype frequencies, and deme size n.  DiploidFrequencies[{{\!\(\
\[Psi]\_\(000, \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) 000\)\)\)\),\
\[Ellipsis]},\[Ellipsis]}] is shorthand for DiploidFrequencies[{{\!\(\[Psi]\_\
\(000, \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) 000\)\)\)\),\
\[Ellipsis]},\[Ellipsis]},1]\>\"";\)\)



\!\(\(AlleleFrequencies::usage = \
\*"\"\<AlleleFrequencies[{\!\(p\_1\),\!\(p\_2\),\[Ellipsis]},n] represents \
allele frequencies, and deme size n.  \
AlleleFrequencies[{\!\(p\_1\),\!\(p\_2\),\[Ellipsis]}] is shorthand for \
AlleleFrequencies[{\!\(p\_1\),\!\(p\_2\),\[Ellipsis]},1]\>\"";\)\)



\!\(\(SymmetricHaploidFrequencies::usage = \
\*"\"\<SymmetricHaploidFrequencies[{\!\(\[Psi]\_0\),\[Ellipsis]},n] \
represents a haploid population in which genotypes with the same # of '1' \
alleles are equally frequent.  This allows a haploid population to be \
repesented by n+1 variables, rather than \!\(2\^n\). \
SymmetricHaploidFrequencies[{\!\(\[Psi]\_0\),\[Ellipsis]}] is shorthand for \
SymmetricHaploidFrequencies[{\!\(\[Psi]\_0\),\[Ellipsis]},1]\>\"";\)\)



\!\(\(SymmetricDiploidFrequencies::usage = \
\*"\"\<SymmetricDiploidFrequencies[{{\!\(\[Psi]\_\(0, \(\(\\\\\)\(\\\ \
\)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) 0\)\)\)\),\[Ellipsis]},\[Ellipsis]},n] \
represents a diploid population in which haplotypes with the same # of '1' \
alleles are equally frequent.  This allows a diploid population to be \
repesented by (n+1\!\(\()\^2\)\) variables, rather than \!\(2\^\(2  \
\\\\\\\\\\\\\\\ \\\\\\\\\\\\\\\ n\)\). SymmetricDiploidFrequencies[{{\!\(\
\[Psi]\_\(0, \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) 0\)\)\)\),\
\[Ellipsis]},\[Ellipsis]}] is shorthand for \
SymmetricDiploidFrequencies[{{\!\(\[Psi]\_\(0, \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \
\(\(\\\\\)\(\\\ \)\) 0\)\)\)\),\[Ellipsis]},\[Ellipsis]},1]\>\"";\)\)



HaploidIndividuals::usage=
    "HaploidIndividuals[{{0,0,1\[Ellipsis]},\[Ellipsis]},n] represents a \
population of n haploid individuals; n must match the length of the list, and \
is added automatically if \
HaploidIndividuals[{{0,0,1\[Ellipsis]},\[Ellipsis]}] is specified.";



DiploidIndividuals::usage=
    "DiploidIndividuals[{{{0,0,1\[Ellipsis]},{0,1,1},\[Ellipsis]}},\[Ellipsis]\
},n] represents a population of n diploid individuals; n must match the \
length of the list, and is added automatically if DiploidIndividuals[{{{0,0,1\
\[Ellipsis]},{0,1,1},\[Ellipsis]}},\[Ellipsis]}] is specified.";



\!\(\(SymmetricNeutralHaploidFrequencies::usage = \
\*"\"\<SymmetricNeutralHaploidFrequencies[{{\!\(\[Psi]\_0\),\[Ellipsis]},{\!\(\
u\_0\),\[Ellipsis]}},n] represents a population by the frequency of each \
genotypic class, \!\(\[Psi]\_i\), and the frequency of a neutral marker \
within that class, \!\(u\_i\).  SymmetricNeutralHaploidFrequencies[{{\!\(\
\[Psi]\_0\),\[Ellipsis]},{\!\(u\_0\),\[Ellipsis]}}] is shorthand for \
SymmetricNeutralHaploidFrequencies[{{\!\(\[Psi]\_0\),\[Ellipsis]},{\!\(u\_0\),\
\[Ellipsis]}},1].\>\"";\)\)



\!\(\(SymmetricNeutralDiploidFrequencies::usage = \
\*"\"\<SymmetricNeutralDiploidFrequencies[{{{\!\(\[Psi]\_\(0, \(\(\\\\\)\(\\\ \
\)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) 0\)\)\)\),\[Ellipsis]},\[Ellipsis]},{{\!\(u\
\_\(0, \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \
0\)\)\)\),\[Ellipsis]},\[Ellipsis]}},n] represents a diploid population by \
the frequency of each genotypic class, \!\(\[Psi]\_\(i, \(\(\\\\\)\(\\\ \
\)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) j\)\)\)\), and the frequency of a neutral \
marker within that class, \!\(u\_\(i, \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\
\(\\\ \)\) j\)\)\)\).  SymmetricNeutralDiploidFrequencies[{{{\!\(\[Psi]\_\(0, \
\(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) 0\)\)\)\),\[Ellipsis]},\
\[Ellipsis]},{{\!\(u\_\(0, \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \
0\)\)\)\),\[Ellipsis]},\[Ellipsis]}}] is shorthand for \
SymmetricNeutralDiploidFrequencies[{{{\!\(\[Psi]\_\(0, \(\(\\\\\)\(\\\ \)\(\\\
\\\\\\ \(\(\\\\\)\(\\\ \)\) 0\)\)\)\),\[Ellipsis]},\[Ellipsis]},{{\!\(u\_\(0, \
\(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) 0\)\)\)\),\[Ellipsis]},\
\[Ellipsis]}},1].\>\"";\)\)



PopulationRepresentations::usage=
    "PopulationRepresentations is a pattern which matches any valid \
representation of a population.";



FrequencyRepresentations::usage=
    "FrequencyRepresentations is a pattern which matches any valid \
representation of a population by allele, class or genotype frequencies.";



IndividualRepresentations::usage=
    "IndividualRepresentations is a pattern which matches any valid \
representation of a population as a list of individuals.";



HaploidRepresentations::usage=
    "HaploidRepresentations is a pattern which matches any valid \
representation of a haploid population.";



DiploidRepresentations::usage=
    "DiploidRepresentations is a pattern which matches any valid \
representation of a diploid population.";



NeutralRepresentations::usage=
    "NeutralRepresentations is a pattern which matches \
SymmetricNeutralHaploidFrequencies|SymmetricNeutralDiploidFrequencies.";



NonNeutralRepresentations::usage=
    "NonNeutralRepresentations is a pattern which matches any valid \
representation except NeutralRepresentations.";



SymmetricRepresentations::usage=
    "SymmetricRepresentations is a pattern which matches any symmetric \
representation.";



NonSymmetricRepresentations::usage=
    "NonSymmetricRepresentations is a pattern which matches any valid \
representation except SymmetricRepresentations or AlleleFrequencies.";



DiploidPhenotype::usage=
    "DiploidPhenotype[z,\[Psi]] gives the frequency of the diploid phenotype \
z, given the population representation \[Psi].  DiploidPhenotype[\[Psi]] \
lists the whole distribution.  ";



NumberOfGenes::usage=
    NumberOfGenes::usage<>
      "  NumberOfGenes[\[Psi]] gives the number of genes, where \[Psi] \
represents a population.  Also applies to a list of \[Psi]'s, representing a \
cline.  ";



\!\(\(AlleleFrequencyMean::usage = 
      AlleleFrequencyMean::usage <> \*"\"\<  AlleleFrequencyMean[\[Psi]] \
gives the average frequency of 1 alleles for the population representation \
\[Psi].  Also applies to a list of \[Psi]'s, representing a cline.  For \
representations SymmetricNeutralHaploidFrequencies or \
SymmetricNeutralDiploidFrequencies, returns {p,\!\(u\&_\)}, where \!\(u\&_\) \
is the average neutral allele frequency. \>\"";\)\)



\!\(\(AlleleFrequencyTable::usage = 
      AlleleFrequencyTable::usage <> \*"\"\<  AlleleFrequencyTable[\[Psi]] \
gives the frequency of 1 alleles for each locus.  Also applies to a list of \
\[Psi]'s, representing a cline. For representations \
SymmetricNeutralHaploidFrequencies or SymmetricNeutralDiploidFrequencies, \
returns {{p,p,\[Ellipsis]},\!\(u\&_\)}, where \!\(u\&_\) is the average \
neutral allele frequency.\>\"";\)\)



DisequilibriumMean::usage=
    "DisequilibriumMean[\[Psi]] gives the mean pairwise linkage \
disequilibrium for the population representation \[Psi].  Also applies to a \
list of \[Psi]'s, representing a cline.  For representations \
SymmetricNeutralHaploidFrequencies or SymmetricNeutralDiploidFrequencies, \
returns the mean D between selected loci, and the mean D between the neutral \
and selected loci.  ";



DisequilibriumTable::usage=
    "DisequilibriumTable[\[Psi]] gives a matrix of pairwise linkage \
disequilibrium for the population representation \[Psi].  Also applies to a \
list of \[Psi]'s, representing a cline.  For representations \
SymmetricNeutralHaploidFrequencies or SymmetricNeutralDiploidFrequencies, \
returns the D between selected loci, and the D between the neutral and \
selected loci.   ";



DemeSize::usage=
    "DemeSize[\[Psi]] gives the deme size associated with the population \
representation \[Psi]; also applies to a cline.";



\!\(\(ClineWidth::usage = \*"\"\<ClineWidth[{\!\(p\_0\),\[Ellipsis]}] gives \
the cline width, defined as the maximum gradient  in allele frequencies, \
\!\(p\_i\).  ClineWidth[\[Psi]], where \[Psi] is a list of population \
representations, lists the cline widths for each locus. For representations \
SymmetricNeutralHaploidFrequencies or SymmetricNeutralDiploidFrequencies, \
ClineWidth[\[Psi]] returns the widths of the selected and the neutral clines.\
\>\"";\)\)



\!\(\(ClineGradient::usage = \*"\"\<ClineGradient[p] gives the gradient \
(\!\(p\_i\)-\!\(p\_\(i  \\\\\\\\\\\\\\\ \\\\\\\ \(-\(\(\\\\\)\(\\\ \)\(\\\\\\\
\\ \(\(\\\\\)\(\\\ \)\) \(\\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\
\) 1\)\)\)\)\)\)) of the list of allele frequencies \
\!\(p\_1\)\!\(\[Ellipsis]p\_n\); returns the list {\!\(p\_1\)-\!\(p\_0\), \
\!\(\[Ellipsis]p\_\(n, \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \(\\\
\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) 1\)\)\)\)\)-\!\(p\_n\)}.  \
The default is to assume that \!\(p\_0\)=\!\(p\_1\), \!\(p\_\(n, \(\(\\\\\)\(\
\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) 1\)\)\)\)=\!\(p\_n\).  \
FixedEnds\[Rule]{\!\(p\_0\),\!\(p\_\(n, \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\
\)\(\\\ \)\) \(\\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) \
1\)\)\)\)\)} sets the outer demes to have allele frequencies \!\(p\_0\),\!\(p\
\_\(n, \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \(\\\\\\\\  \\\\\\\\ \
\( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) 1\)\)\)\)\)  instead.\>\"";\)\)



\!\(\(BarrierStrength::usage = \*"\"\<BarrierStrength[u] gives the barrier \
strengths \
{\[CapitalDelta]u/\!\(\[PartialD]\_x\)\!\(\(u\_-\)\),\[CapitalDelta]u/\!\(\
\[PartialD]\_x\)\!\(\(u\_+\)\)}, based on the list of allele frequencies \
\!\(u\_1\)\!\(\[Ellipsis]u\_n\).  The default is to assume that \!\(u\_0\)=\!\
\(u\_1\), \!\(u\_\(n, \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \
\(\\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) \\\\\\\\  \\\\\\\\ \( \
\\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) 1\)\)\)\)\)=\!\(u\_n\).  \
FixedEnds\[Rule]{\!\(u\_0\),\!\(u\_\(n, \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\
\)\(\\\ \)\) \(\\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) \\\\\\\\ \
 \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) 1\)\)\)\)\)} sets the outer \
demes to have allele frequencies \!\(u\_0\),\!\(u\_\(n, \(\(\\\\\)\(\\\ \
\)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \(\\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\
\(\\\ \)\)\) \\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) \
1\)\)\)\)\)  instead; sensible results are only obtained with this option \
set, since otherwise the gradients at the edges are zero. Also works with \
pairs {p,u}, as derived under SymmetricNeutralHaploidFrequencies or \
SymmetricNeutralDiploidFrequencies. \>\"";\)\)



MakeCline::usage=
    "MakeCline[ndemes,nloci,ninds] sets up a stepped cline, with ninds \
individuals per deme.  MakeCline[ndemes,nloci,ninds,dp] sets up a linear \
gradient, with net change dp<1.  NumericalModel specifies which \
representation is to be used. SymmetricNeutralModel allows for the presence \
of a neutral locus under the symmetric model; this is initially either in a \
step, or a gradient spanning dp.  ";



CountHeterozygotes::usage=
    "CountHeterozygotes[{0,1,\[Ellipsis]},{0,0,\[Ellipsis]}] returns the \
number of heterozygotes.";



DoubleCline::usage=
    "DoubleCline[\[Psi],EvenQ[ndemes]] takes the cline \[Psi] to represent \
the left half of a symmetric cline, and adds the right half.  If the total \
number of demes is even, then the second argument is set True, and the extra \
demes are a mirror image of \[Psi].  If the total number of demes is odd, the \
second argument is set False, and Last[\[Psi]] is assumed to be the central \
deme; it must contain a symmetrical set of genotype frequencies. ";



\!\(\(MeanW::usage = \*"\"\<MeanW[\[Psi],W] gives the mean fitness of \
population \[Psi]; W is the fitness function. MeanW[\[Psi],{{{\!\(W\_\(0, \
\(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \(\\\\\\\\  \\\\\\\\ \( \
\\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) \\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\
\ \)\)\) 0\)\)\), \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \
\(\\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) \\\\\\\\  \\\\\\\\ \( \
\\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) 0\)\)\)\)\),\[Ellipsis]}}}] gives the mean \
fitness, based on an appropriate table of fitnesses.\>\"";\)\)



\!\(\(SymmetricMeanW::usage = \*"\"\<SymmetricMeanW[i,j,n,W] gives the mean \
fitness of the diploid combination {i,j}, averaging over heterozygosities; \
there are n genes.  Fitness is W[i,j,h].  SymmetricMeanW[n,W] gives a table \
of diploid fitnesses.  SymmetricMeanW[n,{{{\!\(W\_\(0, \(\(\\\\\)\(\\\ \)\(\\\
\\\\\\ \(\(\\\\\)\(\\\ \)\) \(\\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \
\)\)\) \\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) 0\)\)\), \
\(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \(\\\\\\\\  \\\\\\\\ \( \
\\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) 0\)\)\)\)\),\[Ellipsis]}\[Ellipsis]}\
\[Ellipsis]}] gives the mean fitness of the diploid combination {i,j}, \
averaging over heterozygosities; there are n genes.  Fitness is tabulated in \
{{{\!\(W\_\(0, \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \(\\\\\\\\  \
\\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) \\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\
\(\\\\\)\(\\\ \)\)\) 0\)\)\), \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\
\) \(\\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) 0\)\)\)\)\),\
\[Ellipsis]}\[Ellipsis]}\[Ellipsis]}.\>\"";\)\)



\!\(\(MarginalW::usage = \*"\"\<MarginalW[\[Psi],W] lists the marginal \
fitness of each haplotype or class, in terms of the representation \[Psi], \
and the fitness function W. MarginalW[\[Psi],{{{\!\(W\_\(0, \(\(\\\\\)\(\\\ \
\)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \(\\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\
\(\\\ \)\)\) \\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) 0\)\)\), \
\(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \(\\\\\\\\  \\\\\\\\ \( \
\\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) 0\)\)\)\)\),\[Ellipsis]}}}] uses a table of \
fitnesses, which can be much faster.\>\""\ \ ;\)\)



FitnessTable::usage=
    "FitnessTable[W,n] gives a table of all possible fitnesses, using the \
fitness function W, for n loci.  NumericalModel specifies which \
representation is used.  Useful for tabulating fitness in order to speed up \
functions such as MeanW.  Note that fitnesses cannot be tabulated if \
AlleleFrequencies are used.";





StoreResults::usage=
    "StoreResults\[Rule]False is an option for GameteTable[] which prevents \
results being stored.";



\!\(\(GameteTable::usage = \*"\"\<GameteTable[n] gives the full distribution \
of \!\(2\^n\)  offspring genotypes. Linkage\[Rule]{\!\(r\_\(1, \(\(\\\\\)\(\\\
\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \(\\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\
\)\(\\\ \)\)\) \\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) \
2\)\)\)\)\),\!\(r\_\(2, \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \
\(\\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) \\\\\\\\  \\\\\\\\ \( \
\\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) 3\)\)\)\)\),\[Ellipsis]} specifies a linear \
genetic map. GameteTable[n,NumericalModel\[Rule]SymmetricHaploidFrequencies] \
stores a matrix showing the distribution of genotypes among gametes, for each \
diploid genotype, under the symmetric model. GameteTable[n,W] is also \
defined; it allows for a fitness function W.   Results are stored, which \
greatly speeds calculations.  However, if fitnesses continually change, the \
option StoreResults\[Rule]False must be used.\>\"";\)\)



\!\(\(Gametes::usage = \*"\"\<Gametes[Y,Z] gives the full distribution of \
\!\(2\^n\)offspring genotypes. Linkage\[Rule]{\!\(r\_\(1, \(\(\\\\\)\(\\\ \
\)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \(\\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\
\(\\\ \)\)\) \(\\\\\\\\  \\\\\\\\  \\\\\\\\  \\\\\\\\\\\\\\\ \(\\\\\\\\  \\\\\
\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\)\)\\\\\\\ \\\\\\\\  \\\\\\\\  \\\\\\\\ \
 \\\\\\\\\\\\\\\ \(\\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \
\)\)\)\)\\\\\\\ \\\\\\\\  \\\\\\\\  \\\\\\\\  \\\\\\\\\\\\\\\ \(\\\\\\\\  \
\\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\)\)\\\\\\\ \
2\)\)\)\)\)\),\!\(r\_\(2, \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \
\(\\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) 3\)\)\)\)\),\
\[Ellipsis]} specifies a linear genetic map. Gametes[X,Y,Z] is also defined, \
and gives the probability of a specific gamete X from diploid parent {Y,Z}. \
Gametes[i,j,n,NumericalModel\[Rule]SymmetricHaploidFrequencies] gives the \
distribution of genotypes among gametes from a parent of genotype {i,j}. \
Gametes[i,j,n,W,NumericalModel\[Rule]SymmetricHaploidFrequencies] gives the \
same, for fitness W[i,j,h]. NOT normalised by MeanW[], however.\>\"";\)\)



HeterozygoteB::usage=
    "HeterozygoteB[i,j,n] gives the distribution of the # of heterozygous \
loci among gametes from a parent of genotype {i,j}, under the symmetric \
model.  HeterozygoteB[n] stores a table of HeterozygoteB[i,j,n] for i=0\
\[Ellipsis]n, j=0\[Ellipsis]n.";



\!\(\(NewGametes::usage = \*"\"\<NewGametes[\[Psi]] gives the haploid \
population after meiosis; \[Psi] must represent a diploid population, or a \
list of diploid populations.  By default, deme size is doubled.  NewGametes[\
\[Psi],W] does the same, but assuming fitness function W.  DemeSize-> \
f[n,\!\(W\&_\)] allows for changes in deme size, to 2f[n,\!\(W\&_\)].  \
Linkage\[Rule]{\!\(r\_\(1, \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \
\(\\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) \
2\)\)\)\)\),\!\(r\_\(2, \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \
\(\\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) 3\)\)\)\)\),\
\[Ellipsis]} can be used to specify a linear genetic map, where appropriate. \
RandomDrift->True samples haploid gametes from the diploid population; does \
not apply to symmetric or individual representations. \
TruncationSelection->True applies with individual representations, and takes \
the f[n,\!\(W\&_\)] individuals with highest W as parents.  Gametes are then \
sampled randomly from these parents, so not all the chosen parents may \
actually reproduce.  Mutation->{{\[Mu],\[Nu]},\[Ellipsis]} allows for \
mutation at rate \[Mu] from allele 0 to 1, and \[Nu] from 1 to 0.\>\"";\)\)



Mutate::usage=
    "Mutate[\[Psi],{{\[Mu],\[Nu]},\[Ellipsis]}] mutates with probability \
\[Mu] from 0 to 1, and \[Nu] from 1 to 0.  Compiled->True is much faster. \
When applied to FrequencyRepresentations, uses MutationMatrix[] to store the \
transformation matrix. For the symmetric \
model,Mutate[SymmetricHaploidFrequencies[],{\[Mu],\[Nu]}] should be used, \
because mutation rates must be the same across loci.";



\!\(\(MutateCompiled::usage = \
\*"\"\<MutateCompiled[HaploidFrequencies][{\!\(p\_{0, \(\(\\\\\)\(\\\ \
\)\(\\\\\)\(\\\ \
\)\(\[Ellipsis]\)\)}\),\[Ellipsis]},{{\[Mu],\[Nu]},\[Ellipsis]}] alters \
haploid genotype frequencies to allow for mutation.  \
MutateCompiled[SymmetricHaploidFrequencies][{\!\(p\_0\),\[Ellipsis]},{\[Mu],\
\[Nu]}] applies to the symmetric model; similarly for \
SymmetricNeutralFrequencies. These versions use ConstructMutateMatrix[] to \
store a large matrix.  MutateCompiled[AlleleFrequencies][{\!\(p\_1\),\
\[Ellipsis]},{{\[Mu],\[Nu]},\[Ellipsis]}] applies to allele frequencies.  \
MutateCompiled[HaploidIndividuals][{0,1,\[Ellipsis]},{{\[Mu],\[Nu]},\
\[Ellipsis]}] mutates a genotype {0,1,\[Ellipsis]} with probability \[Mu] \
from 0 to 1, and \[Nu] from 1 to 0.  For short genomes, MutateCompiled[] is \
faster than using Mutate[\[Ellipsis],Compiled->True], because there is no \
need to check options.\>\"";\)\)



ConstructMutateList::usage=
    "ConstructMutateList[{{\[Mu]}}] converts shorthand versions of a list of \
mutation rates into the full form, {{\[Mu],\[Mu]},\[Ellipsis]}";



ConstructMutateMatrix::usage=
    "ConstructMutateMatrix[{{\[Mu],\[Nu]},\[Ellipsis]},ngenes,\
NumericalModel->HaploidFrequencies] generates the matrix which determines the \
effects of mutation on haploid genotype frequencies. \
NumericalModel->SymmetricFrequencies or SymmetricNeutralFrequencies can be \
used.  Compiled->True is faster for numerical values.";



ConstructMutateMatrixCompiled::usage=
    "ConstructMutateMatrixCompiled[HaploidFrequencies][{{\[Mu],\[Nu]},\
\[Ellipsis]},{{0,\[Ellipsis]},\[Ellipsis]}] gives the mutation matrix; called \
by ConstructMutateMatrix[\[Ellipsis],Compiled->True].  \
ConstructMutateMatrixCompiled[SymmetricHaploidFrequencies][{\[Mu],\[Nu]},\
ngenes] is also defined, as is \
ConstructMutateMatrixCompiled[SymmetricHaploidFrequencies][{\[Mu],\[Nu]},\
ngenes].";



Mutation::usage=
    "Mutation->{{\[Mu],\[Nu]},\[Ellipsis]} is an option for NewGametes which \
specifies mutation at rate \[Mu] from 0 to 1, and \[Nu] from 1 to 0.  \
Mutation->{{\[Mu]},\[Ellipsis]} is shorthand for a rate \[Mu] in each \
direction.  Mutation->{\[Mu],\[Nu]} or {\[Mu]} specifies the same rates at \
all loci.";



\!\(\(SelectionExact::usage = \*"\"\<SelectionExact[\[Psi],W] gives the \
population after selection, assuming a fitness function W[\[Ellipsis]].  By \
default, deme size stays the same. SelectionExact[\[Psi],W,f] specifies that \
deme size becomes f[n,\!\(W\&_\)]. SelectionExact[\[Psi],{{W\[Ellipsis]}\
\[Ellipsis]},f] specifies fitness as a list.  If HaploidIndividuals or \
DiploidIndividuals are specified, then the fitnesses give the probability of \
survival, and the new deme size is a consequence of this viability: f has no \
effect.  When individuals are specified, TruncationSelection->True preserves \
the f[n,\!\(W\&_\)] individuals with highest W; \
f[n,\!\(W\&_\)]\[LessEqual]n\>\"";\)\)



\!\(\(TruncationSelection::usage = \*"\"\<TruncationSelection->True is an \
option for SelectionExact and NewGametes which applies when individuals are \
selected.  Those individuals with highest 'fitness', W, survive; if f[n,\!\(W\
\&_\)] is larger than deme size, or if no f[] is specified, then all \
individuals survive.  If TruncationSelection->False (the default), then \
survival or reproduction occurs independently with probability W.\>\"";\)\)



RandomDrift::usage=
    "RandomDrift[\[Psi],n] gives the random frequencies generated by sampling \
n individuals from the genotype or allele frequencies \[Psi].  Compiled->True \
uses compiled code. Deme size is changed to n.  \
RandomDrift[\[Psi],\[Infinity]] makes no change. ";



\!\(\(IterateExact::usage = \*"\"\<IterateExact[\[Psi],W,0] gives gamete \
frequencies after one generation of selection; \[Psi] may represent a single \
deme, or an array of demes, but must represent a haploid population. \
IterateExact[\[Psi],W,m] allows for migration.  If \[Psi] contains only a \
single population, then it iterates that deme, with immigration from a source \
of the same size, fixed for {1,1\[Ellipsis]}; FixedEnds->{\!\(\[Psi]\_s\)} \
specifies an arbitrary source population.  The fitness is represented by a \
function W[i,j,h] in the symmetrical model, W[X,Y] if all \!\(2\^n\) \
genotypes are iterated, or W[p]={\!\(W\&_\),{\!\(s\_1\),\[Ellipsis]}} if only \
AlleleFrequencies are supplied.  If \[Psi] consists of a list of demes, \
migration is at a rate m/2 to each neighbour.  The fitness is then \
represented by a function W[deme][i,j,h] in the symmetrical model, or \
W[deme][X,Y] if all \!\(2\^n\) genotypes are iterated. Compiled->True uses \
compiled code. The default order is random \
union\[Rule]migration\[Rule]selection\[Rule]meiosis, which is represented by \
MigrationOrder\[Rule]UMS. MigrationOrder\[Rule]MUS represents \
migration\[Rule]random union\[Rule]selection\[Rule]meiosis.  MigrationOrder\
\[Rule]USM represents random \
union\[Rule]selection\[Rule]migration\[Rule]meiosis.  For a cline, FixedEnds\
\[Rule]{\[Psi]0,\[Psi]1} fixes genotype frequencies at \[Psi]0, \[Psi]1 at \
either end. For SymmetricNeutralHaploidFrequencies, \
IterateExact[{\[Psi],u},W,{m,\!\(\(u\^*\)\)}] includes the frequency of the \
neutral marker after one generation of selection followed by immigration from \
a source population with frequency \!\(\(u\^*\)\).  DemeSize->F allows deme \
size to change to some function F[n,\!\(W\&_\)], where n is the number before \
selection.  Compiled code can only use a limited set of F: either \
\!\(\(n\^*\)\)&, where \!\(\(n\^*\)\) is a fixed number; or ExponentialF[r,\
\[Beta],\[Lambda]], which represents \
r\[VeryThinSpace]n\[VeryThinSpace]\!\(W\&_\^\[Beta]\)Exp[-\[Lambda]\
\[VeryThinSpace]n]; or PowerF[r,\[Beta],\[Gamma]], which represents r\
\[VeryThinSpace]\!\(n\^\(1  \\\\\\\\  \\\\\\\\  \\\\\\\\\\\\\\\ \\\\\\\\  \
\\\\\\\\  \\\\\\\\\\\\\\\ \\\\\\\\\\\\\\\ \(-\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \
\(\\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) \\\\\\\\  \\\\\\\\ \( \
\\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) \[Gamma]\)\)\)\)\)\[VeryThinSpace]\!\(W\&_\^\
\[Beta]\). RandomDrift->True includes random sampling of a number of haploid \
gametes equal to the deme size after selection.\>\"";\)\)



\!\(\(ExponentialF::usage = \
\*"\"\<ExponentialF[r,\[Beta],\[Lambda]][n,\!\(W\&_\)] is the function r\
\[VeryThinSpace]n\[VeryThinSpace]\!\(W\&_\^\[Beta]\)Exp[-\[Lambda]\
\[VeryThinSpace]n]. DemeSize->ExponentialF[r,\[Beta],\[Lambda]] can be passed \
to compiled versions of IterateExact and StoreExact. ExponentialF[r,\[Beta],\
\[Gamma],\[Lambda]][n,\!\(W\&_\)] represents the generalised form r\
\[VeryThinSpace]\!\(n\^\(1  \\\\\\\\  \\\\\\\\  \\\\\\\\\\\\\\\ \\\\\\\\  \
\\\\\\\\  \\\\\\\\\\\\\\\ \\\\\\\\\\\\\\\ \(-\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \
\(\\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) \\\\\\\\  \\\\\\\\ \( \
\\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) \[Gamma]\)\)\)\)\)\[VeryThinSpace]\!\(W\&_\^\
\[Beta]\)Exp[-\[Lambda]\[VeryThinSpace]n].  \
ExponentialF[r\[Ellipsis]][j][n,\!\(W\&_\)] is the same as ExponentialF[r\
\[Ellipsis]][n,\!\(W\&_\)].\>\"";\)\)



\!\(\(PowerF::usage = \*"\"\<PowerF[r,\[Beta],\[Gamma]][n,\!\(W\&_\)] is the \
function r\[VeryThinSpace]\!\(n\^\(1  \\\\\\\\  \\\\\\\\  \\\\\\\\\\\\\\\ \
\\\\\\\\  \\\\\\\\  \\\\\\\\\\\\\\\ \\\\\\\\\\\\\\\ \(-\(\\\\\\\\ \
\(\(\\\\\)\(\\\ \)\) \(\\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) \
\\\\\\\\  \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) \[Gamma]\)\)\)\)\)\
\[VeryThinSpace]\!\(W\&_\^\[Beta]\). DemeSize->PowerF[r,\[Beta],\[Gamma]] can \
be passed to compiled versions of IterateExact and StoreExact.  \
PowerF[\!\(\(n\^*\)\),0,1][n,\!\(W\&_\)] represents a fixed number \!\(\(n\^*\
\)\).  PowerF[r,\[Beta],\[Gamma],\[Lambda]][n,\!\(W\&_\)] represents the \
generalised form r\[VeryThinSpace]\!\(n\^\(1  \\\\\\\\  \\\\\\\\  \
\\\\\\\\\\\\\\\ \\\\\\\\\\\\\\\ \(-\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) \(\\\\\\\\ \
 \\\\\\\\ \( \\\\\\\\ \(\(\\\\\)\(\\\ \)\)\) \[Gamma]\)\)\)\)\)\
\[VeryThinSpace]\!\(W\&_\^\[Beta]\)Exp[-\[Lambda]\[VeryThinSpace]n].  \
PowerF[r\[Ellipsis]][j][n,\!\(W\&_\)] is the same as \
PowerF[r\[Ellipsis]][n,\!\(W\&_\)].\>\"";\)\)



MigrationOrder::usage=
    "MigrationOrder is a option for IterateExact which determines the order \
of the life cycle.  Can take values UMS, MUS, or USM,";



UMS::usage=
    "UMS is a setting for MigrationOrder, which represents the order random \
union\[Rule]migration\[Rule]selection\[Rule]meiosis in IterateExact.";



MUS::usage=
    "MUS is a setting for MigrationOrder, which represents the order \
migration\[Rule]random union\[Rule]selection\[Rule]meiosis in IterateExact.";



USM::usage=
    "USM is a setting for MigrationOrder, which represents the order random \
union\[Rule]selection\[Rule]migration\[Rule]meiosis in IterateExact.";



SymmetricCline::usage=
    "SymmetricCline is an option for StoreExact[] which allows a symmetrical \
cline to be simulated more efficiently.";



\!\(\(MigrateExact::usage = \*"\"\<MigrateExact[\[Psi],\!\(\[Psi]\_s\),m] \
implements migration from a source population \!\(\[Psi]\_s\); \[Psi] can be \
any valid representation of a population.  MigrateExact[{\!\(\[Psi]\_1\),\
\[Ellipsis]},m] implements migration along a linear cline. The option \
FixedEnds\[Rule]{\[Psi]0, \[Psi]1} allows fixed endpoints.  Where individuals \
are involved, each has an independent probability of migrating; for a single \
population, the parameter m is now the number of individuals immigrating from \
the source population, and must be an integer no greater than the population \
size.  FixedEnds must now specify a source with given HaploidFrequencies[] or \
DiploidFrequencies[].\>\"";\)\)



StoreExact::usage=
    "StoreExact[\[Psi],\[Psi]0,W,m,{t,dt}] stores results at intervals dt in \
\[Psi][t], starting with \[Psi]0.  \[Psi]0 can represent a single population \
or a cline.  The options Compiled, FixedEnds, DemeSize, RandomDrift and \
MigrationOrder can be used, as for IterateExact. NumericalModel specifies the \
representation. SymmetricCline\[Rule]True simulates a symmetric cline more \
efficiently.";



\!\(\(MidParent::usage = \*"\"\<MidParent[u] gives the matrix of mid-parental \
frequencies, (\!\(u\_i\)+\!\(u\_j\))/2\>\"";\)\)



FixedEnds::usage=
    "FixedEnds is an option for MigrateExact and related functions which \
specifies that endpoints should be fixed.  FixedEnds\[Rule]{\[Psi]} specifies \
a source population that provides migrants into a single deme.  FixedEnds\
\[Rule]{\[Psi]0,\[Psi]1} fixes genotype frequencies at \[Psi]0, \[Psi]1 at \
either end of a cline.";



\!\(\(ClassToGenotypes::usage = \
\*"\"\<ClassToGenotypes[SymmetricHaploidFrequencies[\[Psi],n]] converts class \
frequencies to genotype frequencies, of the form HaploidFrequencies[\!\(\(\
\[Psi]\^*\)\),n].  Defined in a similar way for SymmetricDiploidFrequencies; \
does nopt apply when a neutral marker is included.  Also applies to a \
cline.\>\"";\)\)



GenotypePosition::usage=
    "GenotypePosition[X] gives the position of genotype X in the list of \
haplotypes.  The option SortByClass can be used to define the ordering; \
default is SortByClass\[Rule]False.";





StabilityMatrix::usage=
    "StabilityMatrix[a,n] constructs the stability matrix for n loci, with \
elements a[i,j,h]. ";



\!\(\(StabilityK::usage = \*"\"\<StabilityK[k,i,h,g,W] calculates the \
elements of the stability matrix for the given fitness scheme. Omits the \
factor \!\(2\/W\&_\). StabilityK[k,i,h,g,g',W] gives the more general element \
for demic models.  StabilityK[k,i,h,g,W,m] generates an \
\!\(n\_d\)\[Times]\!\(n\_d\) matrix which gives the stability for a stepping \
stone model.  g must now be an array \!\(n\_d\)\[Times](\!\(n\_g\)+1).  \
Includes the factor \!\(2\/W\&_\), since this now varies across demes.  \
Assumes equilibrium and uniform W.   \>\"";\)\)



\!\(\(StabilityKTable::usage = \*"\"\<StabilityKTable[k,i,h,g,{{{\!\(W\_\(0, \
\(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) 0\)\), \(\(\\\\\)\(\\\ \)\(\
\\\\\\\\ \(\(\\\\\)\(\\\ \)\) 0\)\)\)\),\[Ellipsis]},\[Ellipsis]}}] \
calculates the elements of the stability matrix, using a table of fitnesses, \
\!\(W\_\(i, \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) j\)\), \(\(\\\\\
\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) h\)\)\)\). Omits the factor \
\!\(2\/W\&_\). StabilityKTable[k,i,h,g,g',{{{\!\(W\_\(0, \(\(\\\\\)\(\\\ \)\(\
\\\\\\\\ \(\(\\\\\)\(\\\ \)\) 0\)\), \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \
\(\(\\\\\)\(\\\ \)\) 0\)\)\)\),\[Ellipsis]},\[Ellipsis]}}] gives the more \
general element for demic models.  StabilityK[k,i,h,g,{{{\!\(W\_\(0, \(\(\\\\\
\)\(\\\ \)\(\\\\\\\\ \(\(\\\\\)\(\\\ \)\) 0\)\), \(\(\\\\\)\(\\\ \)\(\\\\\\\\ \
\(\(\\\\\)\(\\\ \)\) 0\)\)\)\),\[Ellipsis]},\[Ellipsis]}},m] generates an \
\!\(n\_d\)\[Times]\!\(n\_d\) matrix which gives the stability for a stepping \
stone model.  g must now be an array \!\(n\_d\)\[Times](\!\(n\_g\)+1).  \
Includes the factor \!\(2\/W\&_\), since this now varies across demes.  \
Assumes equilibrium and uniform W.  This is much faster than StabilityK[], \
since the fitness values are only calculated once. \>\"";\)\)



SigmaMatrix::usage=
    "SigmaMatrix[a,i,j,p,n] gives the elements of the p matrix for n loci. \
SigmaMatrix[a,p,n] stores the p matrix itself.  BlockMatrix[] must be applied \
for a structured population.";



ExactEigenvalues::usage=
    "ExactEigenvalues[a,n] finds all the eigenvalues for the stability \
matrix. a[i,j,h] must be a function which gives numerical values for the \
derivatives.";



\!\(\(StabilityDirect::usage = \*"\"\<StabilityDirect[\[Psi],W,m] gives a \
stability matrix, which is the derivative of the new variables with respect \
to the original variables; this is obtained by direct differentiation of an \
expression derived from IterateExact[].  The variables are either haploid \
genotype frequencies or allele frequencies, plus deme size.  Can take all the \
options of IterateExact[], except Compiled\[Rule]True and RandomDrift->True.  \
Does NOT apply to the symmetric model or individual representations.  For  a \
stepping-stone model, each element is an array \
\!\(n\_d\)\[Times]\!\(n\_d\).\>\"";\)\)





\!\(\(logLikNm::usage = \
\*"\"\<logLikNm[{\!\(p\_1\),\!\(\[Ellipsis]p\_n\)},{\!\(k\_1\),\[Ellipsis]},\
Nm] gives the log likelihood of Nm, given allele frequencies sampled from n \
demes, with \!\(k\_1\)\[Ellipsis] genes sampled.  logLikNm[p,k,\!\(p\&_\),Nm] \
gives the log likelihood for a single deme.  logLikNm[{\!\(p\_1\),\!\(\
\[Ellipsis]p\_n\)},k,Nm] assumes the same sample size throughout. \>\"";\)\)



\!\(\(NmMLE::usage = \
\*"\"\<NmMLE[{\!\(p\_1\),\!\(\[Ellipsis]p\_n\)},{\!\(k\_1\),\[Ellipsis]},Nm] \
gives the MLE of Nm, given allele frequencies sampled from n demes, with \
\!\(k\_1\)\[Ellipsis] genes sampled.  \
NmMLE[{\!\(p\_1\),\!\(\[Ellipsis]p\_n\)},k,Nm] assumes the same sample size \
throughout. \>\"";\)\)



Begin["NumericalModels`ExactModel`Private`"];



<<Statistics`ContinuousDistributions`;





NumericalModel::badSetting="Invalid setting `1` for NumericalModel";



HaploidFrequencies[\[Psi]_List]:=
    HaploidFrequencies[\[Psi],1];



DiploidFrequencies[\[Psi]_List]:=
    DiploidFrequencies[\[Psi],1];



AlleleFrequencies[\[Psi]_List]:=AlleleFrequencies[\[Psi],1];



SymmetricHaploidFrequencies[\[Psi]_List]:=
    SymmetricHaploidFrequencies[\[Psi],1];



SymmetricDiploidFrequencies[\[Psi]_List]:=
    SymmetricDiploidFrequencies[\[Psi],1];



SymmetricNeutralHaploidFrequencies[\[Psi]_List]:=
    SymmetricNeutralHaploidFrequencies[\[Psi],1];



SymmetricNeutralDiploidFrequencies[\[Psi]_List]:=
    SymmetricNeutralDiploidFrequencies[\[Psi],1];



HaploidIndividuals[\[Psi]_List]:=HaploidIndividuals[\[Psi],Length[\[Psi]]];



DiploidIndividuals[\[Psi]_List]:=DiploidIndividuals[\[Psi],Length[\[Psi]]];



PopulationRepresentations=
    HaploidFrequencies|DiploidFrequencies|AlleleFrequencies|
      SymmetricHaploidFrequencies|SymmetricDiploidFrequencies|
      SymmetricNeutralHaploidFrequencies|SymmetricNeutralDiploidFrequencies|
      HaploidIndividuals|DiploidIndividuals;



FrequencyRepresentations=
    HaploidFrequencies|DiploidFrequencies|AlleleFrequencies|
      SymmetricHaploidFrequencies|SymmetricDiploidFrequencies|
      SymmetricNeutralHaploidFrequencies|SymmetricNeutralDiploidFrequencies;



IndividualRepresentations=HaploidIndividuals|DiploidIndividuals;



HaploidRepresentations=
    HaploidFrequencies|AlleleFrequencies|SymmetricHaploidFrequencies|
      SymmetricNeutralHaploidFrequencies|HaploidIndividuals;



DiploidRepresentations=
    DiploidFrequencies|AlleleFrequencies|SymmetricDiploidFrequencies|
      SymmetricNeutralDiploidFrequencies|DiploidIndividuals;



NeutralRepresentations=
    SymmetricNeutralHaploidFrequencies|SymmetricNeutralDiploidFrequencies;



NonNeutralRepresentations=
    HaploidFrequencies|DiploidFrequencies|AlleleFrequencies|
      SymmetricHaploidFrequencies|SymmetricDiploidFrequencies|
      HaploidIndividuals|DiploidIndividuals;



SymmetricRepresentations=
    SymmetricHaploidFrequencies|SymmetricDiploidFrequencies|
      SymmetricNeutralHaploidFrequencies|SymmetricNeutralDiploidFrequencies;



NonSymmetricRepresentations=
    HaploidFrequencies|DiploidFrequencies|HaploidIndividuals|
      DiploidIndividuals;



Options[MakePopulation]={NumericalModel\[Rule]HaploidFrequencies,
      SortByClass\[Rule]False};

MakePopulation[nloci_Integer,p_,opts___Rule]:=
    
    MakePopulation[nloci,p,1,opts];

\!\(\(MakePopulation[n_Integer, p_, ninds_, 
        opts___Rule] := \[IndentingNewLine]Module[{i, 
          nm = \(NumericalModel /. {opts}\) /. 
              Options[MakePopulation]}, \[IndentingNewLine]Switch[
          nm, \[IndentingNewLine]HaploidRepresentations, \[IndentingNewLine]\ \
\ Switch[nm, \[IndentingNewLine]\ 
            HaploidFrequencies, \[IndentingNewLine]\ \ \ \ \
HaploidFrequencies[\[IndentingNewLine]\ \ \ \ HaploidTypes[n, 
                  opts] /. {{a___Integer} :> 
                    Times @@ \(({a} \((2  p - 1)\) + 1 - p)\)}, 
              ninds], \[IndentingNewLine]\ 
            SymmetricHaploidFrequencies, \[IndentingNewLine]\ \ \ \
SymmetricHaploidFrequencies[\[IndentingNewLine]\ \ \ If[
                p == 0, \[IndentingNewLine]\ \ \ \ ReplacePart[
                  Array[0 &, n + 1], 1, 1], \n\t\ \ \ \ \ \ \ \ \ \ \ \ \ If[
                  p == 1, \[IndentingNewLine]\ \ ReplacePart[
                    Array[0 &, n + 1], 
                    1, \(-1\)], \n\t\t\ \ \ \ \ \ \ \ Table[
                    Binomial[n, i] \(p\^i\) \((1 - p)\)\^\(n - i\), {i, 0, 
                      n}]]], ninds], \
\[IndentingNewLine]SymmetricNeutralHaploidFrequencies, \[IndentingNewLine]\ \ \
SymmetricNeutralHaploidFrequencies[\[IndentingNewLine]\ \ \ {\(MakePopulation[
                    n, p\[LeftDoubleBracket]1\[RightDoubleBracket], 
                    NumericalModel \[Rule] 
                      SymmetricHaploidFrequencies]\)\[LeftDoubleBracket]1\
\[RightDoubleBracket], 
                Array[p\[LeftDoubleBracket]2\[RightDoubleBracket] &, n + 1]}, 
              ninds], \[IndentingNewLine]AlleleFrequencies, \
\[IndentingNewLine]\ \ \ \ AlleleFrequencies[Array[1 &, n] p, 
              ninds], \[IndentingNewLine]HaploidIndividuals, \
\[IndentingNewLine]\ \ MakeIndividuals[\ 
              AlleleFrequencies[Array[1 &, n] p, 1], 
              ninds]], \[IndentingNewLine]DiploidRepresentations, \
\[IndentingNewLine]\ \ \ \ Switch[
            nm, \[IndentingNewLine]DiploidIndividuals, \[IndentingNewLine]\ \ \
DiploidIndividuals[
              Transpose[{\[IndentingNewLine]\(MakePopulation[n, p, ninds, 
                      NumericalModel \[Rule] 
                        HaploidIndividuals]\)\[LeftDoubleBracket]1\
\[RightDoubleBracket], \(MakePopulation[n, p, ninds, 
                      NumericalModel \[Rule] 
                        HaploidIndividuals]\)\[LeftDoubleBracket]1\
\[RightDoubleBracket]}], 
              ninds], \[IndentingNewLine]\ \ _, \[IndentingNewLine]\ \ \ \ \ \
\ MakeDiploid[\(MakePopulation[n, p, ninds, ##] &\) @@ \(({opts} /. 
                    MakeOptionsHaploid)\)]], \[IndentingNewLine]_, \
\[IndentingNewLine]\((Message[NumericalModel::badSetting, nm]; {})\)]];\)\)



MakeOptionsHaploid={(NumericalModel\[Rule]
            DiploidFrequencies)->(NumericalModel\[Rule]HaploidFrequencies),
      (NumericalModel\[Rule]
            SymmetricDiploidFrequencies)->(NumericalModel\[Rule]
            SymmetricHaploidFrequencies),
      (NumericalModel\[Rule]
            SymmetricNeutralDiploidFrequencies)->(NumericalModel\[Rule]
            SymmetricNeutralHaploidFrequencies),
      (NumericalModel\[Rule]DiploidIndividuals)->(NumericalModel\[Rule]
            HaploidIndividuals)};



MakeDiploid::odd=
    "MakeDiploid[HaploidIndividuals[\[Psi],n] only applies when n is even.  \
Deme size `1` has been reduced by 1.";

MakeDiploid[\[Psi]:{PopulationRepresentations[_,_]...}]:=MakeDiploid/@\[Psi];
MakeDiploid[\[Psi]:DiploidRepresentations[_,_]]:=\[Psi];
MakeDiploid[HaploidFrequencies[\[Psi]_,n_]]:=
    DiploidFrequencies[Outer[Times,\[Psi],\[Psi]],n/2];
MakeDiploid[SymmetricHaploidFrequencies[\[Psi]_,n_]]:=
    SymmetricDiploidFrequencies[Outer[Times,\[Psi],\[Psi]],n/2];
MakeDiploid[SymmetricNeutralHaploidFrequencies[{\[Psi]_,u_},n_]]:=
    SymmetricNeutralDiploidFrequencies[{Outer[Times,\[Psi],\[Psi]],
        MidParent[u]},n/2];
MakeDiploid[
    HaploidIndividuals[\[Psi]_,n_?OddQ]]:=
  (Message[MakeDiploid::odd,n];
    DiploidIndividuals[Partition[Drop[\[Psi],-1],2],(n-1)/2]);
MakeDiploid[HaploidIndividuals[\[Psi]_,n_?EvenQ]]:=
  DiploidIndividuals[Partition[\[Psi],2],n/2];



MakeHaploid[\[Psi]:{DiploidRepresentations[_,_]...}]:=MakeHaploid/@\[Psi];
MakeHaploid[DiploidFrequencies[\[Psi]_,n_]]:=
    
    HaploidFrequencies[(Plus@@\[Psi]+Plus@@Transpose[\[Psi]])/2,2n];
MakeHaploid[AlleleFrequencies[p_,n_]]:=AlleleFrequencies[p,2n];
MakeHaploid[SymmetricDiploidFrequencies[\[Psi]_,n_]]:=
    SymmetricHaploidFrequencies[(Plus@@\[Psi]+Plus@@Transpose[\[Psi]])/2,2n];
MakeHaploid[SymmetricNeutralDiploidFrequencies[{\[Psi]_,u_},n_]]:=
    Module[{\[Psi]m=(Plus@@\[Psi]+Plus@@Transpose[\[Psi]])/2,\[Psi]u=\[Psi]*
            u},
      SymmetricNeutralHaploidFrequencies[{\[Psi]m,(Plus@@\[Psi]u+
                Plus@@Transpose[\[Psi]u])/(2\[Psi]m)},2n]];
MakeHaploid[DiploidIndividuals[\[Psi]_,n_]]:=
    HaploidIndividuals[Flatten[\[Psi],1],2n];



MakeIndividuals[\[Psi]:{FrequencyRepresentations[_,_]...},n_List,opts___Rule]:=

        MapThread[MakeIndividuals[#1,#2,opts]&,{\[Psi],n}];

MakeIndividuals[AlleleFrequencies[p_,_],n_,opts___Rule]:=
    
    HaploidIndividuals[Table[If[Random[]<#,1,0]&/@p,{n}],n];
MakeIndividuals[HaploidFrequencies[\[Psi]_,_],n_,opts___Rule]:=
    
    HaploidIndividuals[
      RandomList[n,\[Psi],HaploidTypes[Log[2,Length[\[Psi]]],opts]],n];
MakeIndividuals[DiploidFrequencies[\[Psi]_,_],n_,opts___Rule]:=
    
    Module[{ht=HaploidTypes[Log[2,Length[\[Psi]]],opts]},
      DiploidIndividuals[
        RandomList[n,Flatten[\[Psi]],Flatten[Outer[List,ht,ht,1],1]],n]];
MakeIndividuals[SymmetricHaploidFrequencies[\[Psi]_,_],n_,opts___Rule]:=
    
    Module[{ng=Length[\[Psi]]-1},
      HaploidIndividuals[
        MakeIndividuals[#,ng]&/@RandomList[n,\[Psi],Range[0,ng]],n]];
MakeIndividuals[SymmetricDiploidFrequencies[\[Psi]_,_],n_,opts___Rule]:=
    
    Module[{ng=Length[\[Psi]]-1},
      DiploidIndividuals[
        Map[MakeIndividuals[#,ng]&,{Quotient[#-1,ng+1],Mod[#-1,ng+1]}&/@
            RandomList[n,Flatten[\[Psi]]],{2}],n]];
MakeIndividuals[SymmetricNeutralHaploidFrequencies[{\[Psi]_,u_},n0_],n_,
      opts___Rule]:=
    Module[{ng=Length[\[Psi]]-1},
      HaploidIndividuals[
        Append[MakeIndividuals[#,ng], 
              If[Random[]<u\[LeftDoubleBracket]#+1\[RightDoubleBracket],1,
                0]]&/@RandomList[n,\[Psi],Range[0,ng]],n]];
MakeIndividuals[SymmetricNeutralDiploidFrequencies[{\[Psi]_,u_},n0_],n_,
      opts___Rule]:=
    Module[{ng=Length[\[Psi]]-1,fu=Flatten[u]},
      DiploidIndividuals[{
              
              Append[MakeIndividuals[#\[LeftDoubleBracket]1\
\[RightDoubleBracket],ng], 
                If[Random[]<
                    fu\[LeftDoubleBracket]#\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket],1,0]],
              Append[MakeIndividuals[#\[LeftDoubleBracket]2\
\[RightDoubleBracket],ng], 
                If[Random[]<
                    fu\[LeftDoubleBracket]#\[LeftDoubleBracket]3\
\[RightDoubleBracket]\[RightDoubleBracket],1,0]]}&/@({Quotient[#-1,ng+1],
                  Mod[#-1,ng+1],
                  fu\[LeftDoubleBracket]#\[RightDoubleBracket]}&/@
              RandomList[n,Flatten[\[Psi]]]),n]];

 MakeIndividuals[j_Integer,n_Integer]:=
    Muddle[Join[Array[1&,j],Array[0&,n-j]]];



\!\(\(DiploidPhenotype[z_, g_] := 
      Module[{i, 
          n = Length[g] - 
              1}, \[Sum]\+\(i = Max[0, z - n]\)\%\(Min[z, n]\)g\
\[LeftDoubleBracket]i + 1\[RightDoubleBracket] 
            g\[LeftDoubleBracket]z - i + 1\[RightDoubleBracket]];\)\)

DiploidPhenotype[g_]:=
    
    Module[{z,n=Length[g]-1},Table[DiploidPhenotype[z,g],{z,0,2n}]];



NumberOfGenes::noIndividuals="No individuals in this population";

NumberOfGenes[{(pr:PopulationRepresentations)[\[Psi]_,n_],___}]:=
    NumberOfGenes[pr[\[Psi],n]];

NumberOfGenes[(pr:PopulationRepresentations)[\[Psi]_,_]]:=
    Switch[pr,
      HaploidFrequencies|DiploidFrequencies,
      Log[2,Length[\[Psi]]],
      AlleleFrequencies,
      Length[\[Psi]],
      SymmetricHaploidFrequencies|SymmetricDiploidFrequencies,
      Length[\[Psi]]-1,
      SymmetricNeutralHaploidFrequencies|SymmetricNeutralDiploidFrequencies,
      Length[\[Psi]\[LeftDoubleBracket]1\[RightDoubleBracket]]-1,
      HaploidIndividuals,
      If[\[Psi]\[Equal]{},Message[NumberOfGenes::noIndividuals],
        Length[\[Psi]\[LeftDoubleBracket]1\[RightDoubleBracket]]],
      DiploidIndividuals,
      If[\[Psi]\[Equal]{},Message[NumberOfGenes::noIndividuals],
        Length[\[Psi]\[LeftDoubleBracket]1,1\[RightDoubleBracket]]]];



AlleleFrequencyMean[\[Psi]:{PopulationRepresentations[_,_]...},opts___Rule]:=

        AlleleFrequencyMean[#,opts]&/@\[Psi];
AlleleFrequencyMean[z:PopulationRepresentations[_,_],opts___Rule]:=
    AlleleFrequencyTable[z,opts]/.{{x_List,y_}\[RuleDelayed]{Mean[x],y},
        x_List\[RuleDelayed]Mean[x]};



AlleleFrequencyTable[\[Psi]:{PopulationRepresentations[_,_]...},opts___Rule]:=

        AlleleFrequencyTable[#,opts]&/@\[Psi];
AlleleFrequencyTable[AlleleFrequencies[p_,_],___Rule]:=p;
AlleleFrequencyTable[\[Psi]:DiploidRepresentations[_,_],opts___Rule]:=
    
    AlleleFrequencyTable[MakeHaploid[\[Psi]],opts];
AlleleFrequencyTable[HaploidFrequencies[\[Psi]_,_],opts___Rule]:=
    
    Plus@@(HaploidTypes[Log[2,Length[\[Psi]]],opts]\[Psi]);
AlleleFrequencyTable[SymmetricHaploidFrequencies[\[Psi]_,_],opts___Rule]:=
   
     Module[{n=Length[\[Psi]]-1,p},
      If[n\[Equal]0,Indeterminate,p=\[Psi].Range[0,1,1/n];Table[p,{n}]]];
AlleleFrequencyTable[SymmetricNeutralHaploidFrequencies[{\[Psi]_,u_},_],
    opts___Rule]:=
  Module[{n=Length[\[Psi]]-1,pb,ub},
    If[n==0,{Indeterminate,Indeterminate},
      pb=\[Psi].Range[0,1,1/n];ub=\[Psi].u;{Table[pb,{n}],ub}]];
AlleleFrequencyTable[HaploidIndividuals[\[Psi]_,n_],
    opts___Rule]:=
  (Plus@@\[Psi])/n;



\!\(\(DisequilibriumMean[\[Psi] : {PopulationRepresentations[_, _] ... }, 
        opts___Rule] := \[IndentingNewLine]\(DisequilibriumMean[#, 
            opts] &\) /@ \[Psi];\)\[IndentingNewLine]
  DisequilibriumMean[pr : NonNeutralRepresentations[_, _], 
      opts___Rule] := \[IndentingNewLine]Module[{n, 
        dt = DisequilibriumTable[pr, opts]}, \[IndentingNewLine]n = 
        Length[dt]; \[IndentingNewLine]Plus @@ \(Plus @@ \((\((Array[
                      1 &, {n, n}] - IdentityMatrix[n])\) dt)\)\) 
        1\/\(n \((n - 1)\)\)]; 
  DisequilibriumMean[pr : NeutralRepresentations[_, _], 
      opts___Rule] := \[IndentingNewLine]Module[{n, 
        dt = DisequilibriumTable[pr, opts]}, \[IndentingNewLine]n = 
        Length[dt\[LeftDoubleBracket]1\[RightDoubleBracket]]; \
\[IndentingNewLine]{Plus @@ \(Plus @@ \((\((Array[1 &, {n, n}] - 
                      IdentityMatrix[n])\) 
                  dt\[LeftDoubleBracket]1\[RightDoubleBracket])\)\) 
          1\/\(n \((n - 1)\)\), 
        Mean[dt\[LeftDoubleBracket]2\[RightDoubleBracket]]}];\)



\!\(\(DisequilibriumTable[\[Psi] : {PopulationRepresentations[_, _] ... }, 
        opts___Rule] := \[IndentingNewLine]\(DisequilibriumTable[#, 
            opts] &\) /@ \[Psi];\)\[IndentingNewLine]
  \(DisequilibriumTable[
        AlleleFrequencies[
          p_, _], ___Rule] := \[IndentingNewLine]DiagonalMatrix[
        p \((1 - p)\)];\)\[IndentingNewLine]
  \(DisequilibriumTable[\[Psi] : DiploidRepresentations[_, _], 
        opts___Rule] := \[IndentingNewLine]DisequilibriumTable[
        MakeHaploid[\[Psi]], opts];\)\[IndentingNewLine]
  \(DisequilibriumTable[HaploidFrequencies[\[Psi]_, _], 
        opts___Rule] := \[IndentingNewLine]Module[{n = 
            Log[2, Length[\[Psi]]], 
          p = AlleleFrequencyTable[HaploidFrequencies[\[Psi]], opts], 
          dk}, \n\tdk = \(\((# - p)\) &\) /@ 
            HaploidTypes[n, opts]; \n\t\[Psi] . \((\(Outer[Times, #, #] &\) /@ 
              dk)\)];\)\[IndentingNewLine]
  \(DisequilibriumTable[SymmetricHaploidFrequencies[\[Psi]_, nd_], 
        opts___Rule] := \[IndentingNewLine]Module[{n = Length[\[Psi]] - 1, 
          p = AlleleFrequencyMean[SymmetricHaploidFrequencies[\[Psi], nd], 
              opts], d, 
          du}, \[IndentingNewLine]d = \(\[Psi] . \((Range[0, n] - n\ p)\)\^2 \
- n\ p \((1 - p)\)\)\/\(n \((n - 1)\)\); \[IndentingNewLine]IdentityMatrix[
              n] \((p \((1 - p)\) - d)\) + 
          Array[d &, {n, n}]];\)\[IndentingNewLine]
  \(DisequilibriumTable[
        SymmetricNeutralHaploidFrequencies[{\[Psi]_, u_}, nd_], 
        opts___Rule] := \[IndentingNewLine]Module[{n = Length[\[Psi]] - 1, 
          pu = AlleleFrequencyTable[
              SymmetricNeutralHaploidFrequencies[{\[Psi], u}, nd], opts], p, 
          ub, d, du}, \[IndentingNewLine]p = 
          pu\[LeftDoubleBracket]1, 1\[RightDoubleBracket]; 
        ub = pu\[LeftDoubleBracket]2\[RightDoubleBracket]; \
\[IndentingNewLine]d = \(n\ \[Psi] . \((Range[0, 1, 1\/n] - \ p)\)\^2 - \ p \
\((1 - p)\)\)\/\((n - 1)\); \[IndentingNewLine]du = \((\((Range[0, 1, 
                      1\/n] - \ p)\) \[Psi])\) . \((u - 
                ub)\); {IdentityMatrix[n] \((p \((1 - p)\) - d)\) + 
            Array[d &, {n, n}], \[IndentingNewLine]Array[
            du &, {n}]}];\)\[IndentingNewLine]
  \(DisequilibriumTable[HaploidIndividuals[\[Psi]_, nd_], 
        opts___Rule] := \[IndentingNewLine]Module[{nl = 
            Length[\[Psi]\[LeftDoubleBracket]1\[RightDoubleBracket]], 
          p = AlleleFrequencyTable[HaploidIndividuals[\[Psi], nd]]}, \n\t
        If[nd < 2, Array[Indeterminate &, {nl, nl}], 
          Plus @@ \((\(Outer[Times, # - p, # - p] &\) /@ \[Psi])\)/\((nd - 
                1)\)]];\)\)



DemeSize[PopulationRepresentations[_,n_]]:=n;
DemeSize[\[Psi]:{PopulationRepresentations[_,_]...}]:=DemeSize/@\[Psi];



ClineWidth::badDepth="The cline `1` does not have an appropriate structure.";

ClineWidthRaw[p_List]:=1/Max[Drop[p-RotateRight[p],1]];
ClineWidth[\[Psi]:{PopulationRepresentations[_,_]...},opts___]:=
    
    Module[{p=AlleleFrequencyTable[\[Psi],opts]},
            If[Length[p]<2,Indeterminate,
        Switch[TensorRank[p],
          2,ClineWidthRaw/@Transpose[p],
             
          3,{ClineWidthRaw/@Transpose[First/@p],
            ClineWidthRaw/@Transpose[Last/@p]},
              _,Message[ClineWidth::badDepth,\[Psi]];Indeterminate]]];



Options[ClineGradient]={FixedEnds\[Rule]{{},{}}};

ClineGradient[p_,opts___]:=
    
    Module[{pp,fe=FixedEnds/.{opts}/.Options[ClineGradient]},
      		pp=If[(fe//Flatten//Length)==0,
          				Prepend[Append[p,Last[p]],First[p]],
          				Prepend[Append[p,Last[fe]],First[fe]]];
      		Drop[RotateLeft[pp]-pp,-1]];



Options[BarrierStrength]={FixedEnds\[Rule]{{},{}}};

BarrierStrength[u_,opts___]:=
	Module[{uu=u,gr=ClineGradient[u,opts],du,ps},
	If[TensorRank[gr]==2,
			uu=Transpose[uu]//Last;
			gr=Transpose[gr]//Last];
ps=Position[gr,Max[gr]]\[LeftDoubleBracket]1,1\[RightDoubleBracket]-0.5;
du=(Last[uu]-Last[gr](Length[uu]-ps))-(First[uu]+First[gr](ps-1));
du/{First[gr],Last[gr]}];



Options[MakeCline]={NumericalModel\[Rule]HaploidFrequencies};

\!\(\(MakeCline[nd_, ng_, ni_, opts___Rule] := \n\ 
      Module[{nm = \(NumericalModel /. {opts}\) /. Options[MakeCline], 
          pp = Array[\(1\/2\) \((1 + Sign[# - \(nd + 1\)\/2])\) &, 
              nd]}, \[IndentingNewLine]\ \(MakePopulation[ng, #, ni, 
              opts] &\) /@ \[IndentingNewLine]Switch[
            nm, \[IndentingNewLine]NonNeutralRepresentations, 
            pp, \[IndentingNewLine]NeutralRepresentations, 
            Transpose[{pp, pp}], \[IndentingNewLine]_, 
            Message[NumericalModel::badSetting, nm]; {}]];\)\)

\!\(\(MakeCline[nd_, ng_, ni_, dp_, opts___Rule] := \n\ 
      Module[{nm = \(NumericalModel /. {opts}\) /. 
              Options[MakeCline], \[IndentingNewLine]pp = 
            Range[\(1 - dp\)\/2, \(1 + dp\)\/2, 
              dp\/\(nd - 1\)]}, \[IndentingNewLine]\ \(MakePopulation[ng, #, 
              ni, opts] &\) /@ \[IndentingNewLine]Switch[
            nm, \[IndentingNewLine]NonNeutralRepresentations, 
            pp, \[IndentingNewLine]NeutralRepresentations, 
            Transpose[{pp, pp}], \[IndentingNewLine]_, 
            Message[NumericalModel::badSetting, nm]; {}]];\)\)



CountHeterozygotes[x_List,y_List]:=(Plus@@(x+y))-2(Plus@@(x y));



DoubleCline[\[Psi]:{(IndividualRepresentations|AlleleFrequencies)[_,_]...},
      eQ_]:=Join[\[Psi],
      Reverse[If[eQ,\[Psi],
            Drop[\[Psi],-1]]/.(pr:PopulationRepresentations)[f_,n_]:>
            pr[1-f,n]]];

DoubleCline[\[Psi]:{(HaploidFrequencies|DiploidFrequencies|
                  SymmetricHaploidFrequencies|
                  SymmetricDiploidFrequencies)[_,_]...},eQ_]:=
    Join[\[Psi],
      Reverse[If[eQ,\[Psi],
            Drop[\[Psi],-1]]/.(pr:PopulationRepresentations)[f_,n_]:>
            pr[Reverse[f],n]]];

DoubleCline[\[Psi]:{NeutralRepresentations[_,_]...},eQ_]:=
    Join[\[Psi],
      Reverse[If[eQ,\[Psi],
            Drop[\[Psi],-1]]/.(pr:NeutralRepresentations)[{f_,u_},n_]:>
            pr[{Reverse[f],1-Reverse[u]},n]]];



\!\(\(AlleleFrequencies::badW = \*"\"\<W[p]=`1` does not have the form {\!\(W\
\&_\),{\!\(s\_1\)\[Ellipsis]}}\>\"";\)\)

MeanW[\[Psi]:{PopulationRepresentations[_,_]...},W_?(Not[ListQ[#]]&),
      opts___Rule]:=
    MapIndexed[MeanW[#1,W[First[#2]],opts]&,\[Psi]];
MeanW[\[Psi]:{PopulationRepresentations[_,_]...},W_List,opts___Rule]:=
    
    MapIndexed[
      MeanW[#1,W\[LeftDoubleBracket]First[#2]\[RightDoubleBracket],
          opts]&,\[Psi]];

MeanW[SymmetricNeutralHaploidFrequencies[{\[Psi]_,u_},n_],W_,opts___Rule]:=
  
      MeanW[SymmetricHaploidFrequencies[\[Psi],n],W,opts];
MeanW[SymmetricNeutralDiploidFrequencies[{\[Psi]_,u_},_],W_,opts___Rule]:=
   
     MeanW[SymmetricDiploidFrequencies[\[Psi],n],W,opts];

MeanW[AlleleFrequencies[p_,_],W_?(Not[ListQ[#]]&),opts___Rule]:=
    
    Module[{wl=W[p]},
      If[MatchQ[wl,{_,_List}],
        First[wl],
        Message[AlleleFrequencies::badW,wl];Indeterminate]];
MeanW[(fr:FrequencyRepresentations)[\[Psi]_,_],W_?(Not[ListQ[#]]&),
      opts___Rule]:=
    Module[{n=Switch[fr,
            SymmetricRepresentations,Length[\[Psi]]-1,
            _,Log[2,Length[\[Psi]]]]},
      Plus@@Plus@@(\[Psi]*FitnessTable[W,n,NumericalModel\[Rule]fr,opts])];
MeanW[HaploidIndividuals[\[Psi]_,_],W_?(Not[ListQ[#]]&),opts___Rule]:=
    
    Mean[W/@\[Psi]];
MeanW[DiploidIndividuals[\[Psi]_,_],W_?(Not[ListQ[#]]&),opts___Rule]:=
    
    Mean[W@@#&/@\[Psi]];

MeanW[AlleleFrequencies[p_,_],W_List,
      opts___Rule]:=
    (Message[FitnessTable::badOption];1);
MeanW[FrequencyRepresentations[\[Psi]_,_],W_List,opts___Rule]:=
    
    Plus@@Plus@@(\[Psi]*W);
MeanW[HaploidIndividuals[\[Psi]_,_],W_List,opts___Rule]:=
    Module[{ht},
      If[Length[\[Psi]]==0,
        Indeterminate,
        ht=HaploidTypes[Length[First[\[Psi]]],opts];
        Mean[Extract[W,#]&/@(First[Position[ht,#]]&/@\[Psi])]]];
MeanW[DiploidIndividuals[\[Psi]_,_],W_List,opts___Rule]:=
    Module[{ht},
      If[Length[\[Psi]]==0,
        Indeterminate,
        ht=
          HaploidTypes[
            Length[\[Psi]\[LeftDoubleBracket]1,1\[RightDoubleBracket]],opts];
        Mean[
          Extract[W,#]&/@(Flatten[{Position[
                        ht,#\[LeftDoubleBracket]1\[RightDoubleBracket]],
                      Position[
                        ht,#\[LeftDoubleBracket]2\[RightDoubleBracket]]}]&/@\
\[Psi])]]];



MarginalW::badOption=
    "Marginal fitnesses cannot be calculated for a set of individuals.";

hreps=HaploidFrequencies|SymmetricHaploidFrequencies;
dreps=DiploidFrequencies|SymmetricDiploidFrequencies;
freps=HaploidFrequencies|SymmetricHaploidFrequencies|DiploidFrequencies|
      SymmetricDiploidFrequencies;

MarginalW[\[Psi]:{PopulationRepresentations[_,_]...},W_?(Not[ListQ[#]]&),
      opts___Rule]:=
    MapIndexed[MarginalW[#1,W[First[#2]],opts]&,\[Psi]];
MarginalW[\[Psi]:{PopulationRepresentations[_,_]...},W_List,opts___Rule]:=
   
     MapIndexed[
      MarginalW[#1,W\[LeftDoubleBracket]First[#2]\[RightDoubleBracket],
          opts]&,\[Psi]];

MarginalW[AlleleFrequencies[p_,_],W_List,
      opts___Rule]:=
    (Message[FitnessTable::badOption];Indeterminate);
MarginalW[AlleleFrequencies[p_,_],W_?(Not[ListQ[#]]&),opts___Rule]:=
    Last[W[p]];

\!\(\(MarginalW[hreps[\[Psi]_, _], W_List, opts___Rule] := W;\)\n
  \(MarginalW[dreps[\[Psi]_, n_], W_List, opts___Rule] := 
      Plus @@ \((\[Psi]*W)\)\/Plus @@ \[Psi];\)\n
  \(MarginalW[\((pr : freps)\)[\[Psi]_, n_], W_?\((Not[ListQ[#]] &)\), 
        opts___Rule] := \[IndentingNewLine]MarginalW[pr[\[Psi], n], 
        FitnessTable[W, NumberOfGenes[pr[\[Psi], n]], 
          NumericalModel \[Rule] pr, opts]];\)\)

MarginalW[SymmetricNeutralHaploidFrequencies[{\[Psi]_,u_},nd_],W_,
      opts___Rule]:=
    
    MarginalW[SymmetricHaploidFrequencies[\[Psi],nd],W,opts];
MarginalW[SymmetricNeutralDiploidFrequencies[{\[Psi]_,u_},_],W_,opts___Rule]:=

        MarginalW[SymmetricDiploidFrequencies[\[Psi],nd],W,opts];
MarginalW[IndividualRepresentations[\[Psi]_,_],W_,
      opts___Rule]:=
    (Message[MarginalW::badOption];{});



SymmetricMeanW[n_Integer,wt_List]:=Apply[Plus,wt*HeterozygoteB[n],{2}]

SymmetricMeanW[i_Integer,j_Integer,n_Integer,wt_List]:=
	
    HeterozygoteB[i,j,n].wt\[LeftDoubleBracket]i+1,j+1\[RightDoubleBracket];

SymmetricMeanW[i_Integer,j_Integer,n_Integer,W_?(Not[ListQ[#]]&)]:=
    Module[{l,hh=HeterozygoteB[i,j,n]},
			Sum[hh\[LeftDoubleBracket]i+j-2l+1\[RightDoubleBracket]W[i,j,i+j-2l],{l,
          Max[0,i+j-n],Min[i,j]}]];

SymmetricMeanW[n_Integer,W_?(Not[ListQ[#]]&),opts___Rule]:=
  
  Module[{i,j},Table[SymmetricMeanW[i,j,n,W],{i,0,n},{j,0,n}]]



Options[FitnessTable]={NumericalModel\[Rule]HaploidFrequencies};

FitnessTable::badOption=
    "Fitness cannot be tabulated for AlleleFrequencies.  A function which \
supplies the mean fitness and the selection coefficients as a function of \
allele frequencies must be used.";

FitnessTable[W_,n_Integer,opts___Rule]:=
    
    Module[{i,j,h,ht,nm=NumericalModel/.{opts}/.Options[FitnessTable]},
      		Switch[nm,
        HaploidFrequencies|HaploidIndividuals,
            W/@HaploidTypes[n,opts],
        DiploidFrequencies|DiploidIndividuals,
            ht=HaploidTypes[n,opts];Outer[W,ht,ht,1],
        SymmetricHaploidFrequencies|SymmetricNeutralHaploidFrequencies,
            Table[W[i],{i,0,n}],
        SymmetricDiploidFrequencies|SymmetricNeutralDiploidFrequencies,
            Table[SymmetricMeanW[i,j,n,W],{i,0,n},{j,0,n}],
        AlleleFrequencies,
           Message[FitnessTable::badOption];{},
        _,
            Message[NumericalModel::badSetting,nm];{}]];





Options[GameteTable]={Linkage\[Rule]False,StoreResults\[Rule]True,
      NumericalModel\[Rule]HaploidFrequencies};

GameteTable::badOpts="`1` is not a valid option for GameteTable";

GameteTable[n_Integer,opts___Rule]:=GameteTable[n,1&,opts];

GameteTable[n_Integer,ww_,opts___Rule]:=
    Module[
      {i,j,ht,
        	nm=NumericalModel/.{opts}/.Options[GameteTable],
        	srQ=StoreResults/.{opts}/.Options[GameteTable]},
              If[srQ,
        		
        GameteTable[n,ww,opts]=
          GameteTable[n,ww,StoreResults\[Rule]False,opts],
        	Switch[nm,
          SymmetricRepresentations,
          Table[Gametes[i,j,n,ww],{i,0,n},{j,0,n}],
          NonSymmetricRepresentations,
          ht=HaploidTypes[n,opts];
          		  Outer[Gametes[#1,#2,ww,opts]&,ht,ht,1],
          _,
          Message[GameteTable::badOpts,nm]]]];



Options[Gametes]={Linkage\[Rule]False};

Gametes[i_Integer,j_Integer,n_Integer]:=Gametes[i,j,n,1&];
Gametes[Y_List,Z_List,opts___Rule]:=Gametes[Y,Z,1&,opts];

\!\(\(Gametes[i_Integer, j_Integer, n_Integer, 
        W_] := \[IndentingNewLine]Module[{l, 
          k}, \n\t\(2\^\(-\((i + j)\)\)\/Binomial[n, j]\) 
          Sum[\(2\^\(2  l\)\) Table[Binomial[i + j - 2  l, k - l], {k, 0, n}] 
              Binomial[i, l] Binomial[n - i, j - l] 
              W[i, j, i + j - 2  l], {l, Max[0, i + j - n], Min[i, j]}]];\)\)

Gametes[Y_List,Z_List,W_,
      opts___Rule]:=(GametesRaw[#,Y,Z,opts]&/@HaploidTypes[Length[Z],opts])W[
        Y,Z];

GametesRaw[X_List,Y_List,Z_List,opts___Rule]:=
	Module[{ph,rr,rQ,
			r=Linkage/.{opts}/.Options[Gametes],
			h=Y+Z-2Y Z,(*heterozygous loci*)
			
        p=(1-X-Y+2X Y)},	(*Is the offspring in the smae state as parent Y?*)
	\
     ph=Flatten[Position[h,1]];(* positions of heterozygous loci*)
       
      If[Times@@(h+(1-h)p)==0,
			  0,(* an impossible offspring*)
		  	If[(r===False)||ph=={},
		      	Times@@(1-h/2),(* no linkage*)
		       
          rr=Prepend[
              NetRecombination/@(* 
                  recombination rate with previous heterozygous locus*)
			 		\
	(Take[r,#]&/@Drop[Transpose[{ph,RotateLeft[ph-1]}],-1]),1/2];
		       rQ=p\[LeftDoubleBracket]#\[RightDoubleBracket]&/@ph;
				   rQ=Abs[rQ-RotateRight[rQ]];(* 
            Is each heterozygous loci cis or trans wrt the last? *)
		        
          Times@@((1-rr)+rQ(2rr-1))]]];



HeterozygoteB[i_,j_,n_]:=HeterozygoteB[i,j,n]=
      Module[{l,pp=Array[0&,n+1]},
        			
        Do[pp\[LeftDoubleBracket]i+j-2l+1\[RightDoubleBracket]=
            Binomial[i,l]Binomial[n-i,j-l ],{l,Max[0,i+j-n],Min[i,j]}];
        pp/Binomial[n,j]];

HeterozygoteB[n_]:=HeterozygoteB[n]=
		Module[{i,j},Table[HeterozygoteB[i,j,n],{i,0,n},{j,0,n}]];



Options[NewGametes]={Linkage\[Rule]False,Mutation\[Rule]None,
      DemeSize\[Rule](#1&),RandomDrift\[Rule]False,
      TruncationSelection\[Rule]False};

NewGametes::badN="New deme size `1` is greater than original size `2`";

NewGametes[AlleleFrequencies[p_,n_],opts___Rule]:=
    
    NewGametes[AlleleFrequencies[p,n],{1,Array[0&,Length[p]]}&,opts];
NewGametes[(pr:DiploidRepresentations)[\[Psi]_,n_],opts___Rule]:=
    NewGametes[pr[\[Psi],n],1&,opts];

\!\(\(NewGametes[AlleleFrequencies[p_, n_], W_, 
        opts___Rule] := \[IndentingNewLine]Module[{f = \(DemeSize /. {opts}\) \
/. Options[NewGametes], ww = W[p], 
          rd = \(RandomDrift /. {opts}\) /. Options[NewGametes], 
          pn, \[IndentingNewLine]mut = \(Mutation /. {opts}\) /. 
              Options[NewGametes]}, \[IndentingNewLine]f = 
          f /. {r_, \[Beta]_, \[Gamma]_, \[Lambda]_} \[Rule] 
              ExponentialF[
                r, \[Beta], \[Gamma], \[Lambda]]; \[IndentingNewLine]pn = 
          AlleleFrequencies[
            p \((1 + \((1 - 
                        p)\) \(\(\ \)\(ww\[LeftDoubleBracket]2\
\[RightDoubleBracket]\)\)\/ww\[LeftDoubleBracket]1\[RightDoubleBracket])\), 
            2  f[n, ww\[LeftDoubleBracket]1\[RightDoubleBracket]]]; \
\[IndentingNewLine]If[rd, 
          pn = RandomDrift[pn, 
              pn\[LeftDoubleBracket]2\[RightDoubleBracket]]]; \
\[IndentingNewLine]If[
          mut === None, \[IndentingNewLine]pn, \[IndentingNewLine]Mutate[pn, 
            ConstructMutateList[mut, Length[pn]], opts]]];\)\)

NewGametes[DiploidFrequencies[\[Phi]_,n_],W_,opts___Rule]:=
    
    Module[{f=DemeSize/.{opts}/.Options[NewGametes],
        wb=MeanW[DiploidFrequencies[\[Phi],n],W,opts],
        rd=RandomDrift/.{opts}/.Options[NewGametes],hn,
        mut=Mutation/.{opts}/.Options[NewGametes]},
      f=f/.{r_,\[Beta]_,\[Gamma]_,\[Lambda]_}\[Rule]
            ExponentialF[r,\[Beta],\[Gamma],\[Lambda]];
      hn=HaploidFrequencies[If[Length[\[Phi]]==0,{},
            If[\[Phi]\[LeftDoubleBracket]1\[RightDoubleBracket]==={},
              {},
              
              Plus@@Plus@@(GameteTable[Log[2,Length[\[Phi]]],W,opts]*\[Phi])/ 
                wb]],
          2f[n,wb]];
      If[rd,hn=RandomDrift[hn,hn\[LeftDoubleBracket]2\[RightDoubleBracket]]];
      If[mut===None,
        hn,
        Mutate[hn,ConstructMutateList[mut,Log[2,Length[\[Phi]]]],opts]]];

NewGametes[SymmetricDiploidFrequencies[\[Phi]_,n_],W_,opts___Rule]:=
    
    Module[{f=DemeSize/.{opts}/.Options[NewGametes],
        wb=MeanW[SymmetricDiploidFrequencies[\[Phi],n],W,opts],
        mut=Mutation/.{opts}/.Options[NewGametes],
        ng,nn},
      f=f/.{r_,\[Beta]_,\[Gamma]_,\[Lambda]_}\[Rule]
            ExponentialF[r,\[Beta],\[Gamma],\[Lambda]];
      nn=2f[n,wb];
      If[Length[\[Phi]]==0,
        SymmetricHaploidFrequencies[{},nn],
        If[\[Phi]\[LeftDoubleBracket]1\[RightDoubleBracket]==={},
          SymmetricHaploidFrequencies[{},nn],
          
          ng=SymmetricHaploidFrequencies[
              Plus@@Plus@@(GameteTable[Length[\[Phi]]-1,W,
                          NumericalModel\[Rule]
                            SymmetricDiploidFrequencies]*\[Phi])/wb,nn];
          If[mut===None,
            ng,
            Mutate[ng,mut/.{\[Mu]_}\[Rule]{\[Mu],\[Mu]},opts]]]]];

\!\(\(NewGametes[SymmetricNeutralDiploidFrequencies[{\[Phi]_, u_}, n_], W_, 
        opts___Rule] := \[IndentingNewLine]Module[{f = \(DemeSize /. {opts}\) \
/. Options[NewGametes], \[IndentingNewLine]wb = 
            MeanW[SymmetricNeutralDiploidFrequencies[\[Phi], n], W, 
              opts], \[IndentingNewLine]gt, n\[Psi], 
          n\[Psi]u}, \[IndentingNewLine]f = 
          f /. {r_, \[Beta]_, \[Gamma]_, \[Lambda]_} \[Rule] 
              ExponentialF[
                r, \[Beta], \[Gamma], \[Lambda]]; \
\[IndentingNewLine]SymmetricNeutralHaploidFrequencies[
          If[Length[\[Phi]] == 
              0, {}, \[IndentingNewLine]If[\[Phi]\[LeftDoubleBracket]1\
\[RightDoubleBracket] === {}, \[IndentingNewLine]{}, \[IndentingNewLine]gt = 
                GameteTable[Length[\[Phi]] - 1, W, 
                  NumericalModel \[Rule] 
                    SymmetricNeutralDiploidFrequencies]; \[IndentingNewLine]n\
\[Psi] = Plus @@ \(Plus @@ \((gt*\[Phi])\)\); \[IndentingNewLine]n\[Psi]u = 
                Plus @@ \(Plus @@ \((gt*\[Phi]*
                        u)\)\); \[IndentingNewLine]{n\[Psi]\/wb, 
                DivideZero[n\[Psi]u, n\[Psi]]}]], \[IndentingNewLine]2 
             f[n, wb]]];\)\)

\!\(\(NewGametes[\[Phi] : DiploidIndividuals[\[Psi]_, n_], W_, 
        opts___Rule] := \[IndentingNewLine]Module[{f = \(DemeSize /. {opts}\) \
/. Options[NewGametes], \[IndentingNewLine]wb = MeanW[\[Phi], W, opts], wl, 
          newN, rl, ht, tp, np, 
          ss, \[IndentingNewLine]ts = \(TruncationSelection /. {opts}\) /. 
              Options[NewGametes], \[IndentingNewLine]mut = \(Mutation /. \
{opts}\) /. Options[NewGametes]}, \[IndentingNewLine]wl = 
          If[ListQ[W], \[IndentingNewLine]ht = 
              HaploidTypes[
                Length[\[Psi]\[LeftDoubleBracket]1, 1\[RightDoubleBracket]], 
                opts]; \[IndentingNewLine]\((\(Extract[
                    W, #] &\) /@ \((\(Flatten[{Position[
                            ht, #\[LeftDoubleBracket]1\[RightDoubleBracket]], 
                          Position[
                            ht, #\[LeftDoubleBracket]2\[RightDoubleBracket]]}]\
 &\) /@ \[Psi])\))\), \[IndentingNewLine]\(W @@ # &\) /@ \[Psi]]; \
\[IndentingNewLine]f = 
          f /. {r_, \[Beta]_, \[Gamma]_, \[Lambda]_} \[Rule] 
              ExponentialF[
                r, \[Beta], \[Gamma], \[Lambda]]; \[IndentingNewLine]newN = 
          2  Round[f[n, wb]]; \[IndentingNewLine]rl = 
          If[ts, \[IndentingNewLine]If[
              newN > n, \[IndentingNewLine]Message[NewGametes::badN, newN, 
                n]; newN = n]; \[IndentingNewLine]ss = 
              Transpose[{wl, Range[n]}]; \[IndentingNewLine]tp = \(Sort[
                  wl]\)\[LeftDoubleBracket]\(-newN\)\[RightDoubleBracket]; 
            np = Select[
                ss, \((#\[LeftDoubleBracket]1\[RightDoubleBracket] > 
                      tp)\) &]; \[IndentingNewLine]np = 
              Join[np, 
                RandomSet[newN - Length[np], 
                  Select[ss, \((#\[LeftDoubleBracket]1\[RightDoubleBracket] == 
                          tp)\) &]]]; \[IndentingNewLine]Muddle[
              Last /@ np], \[IndentingNewLine]RandomList[newN, 
              wl\/Plus @@ wl]]; \[IndentingNewLine]If[
          mut === None, \[IndentingNewLine]HaploidIndividuals[\(RandomFamily[\
\[Psi]\[LeftDoubleBracket]#\[RightDoubleBracket], opts] &\) /@ rl, 
            newN], \[IndentingNewLine]HaploidIndividuals[\(\(MutateCompiled[
                    HaploidIndividuals]\)[
                  RandomFamily[\[Psi]\[LeftDoubleBracket]#\
\[RightDoubleBracket], opts], 
                  ConstructMutateList[mut, 
                    Length[\[Psi]\[LeftDoubleBracket]1, 
                        1\[RightDoubleBracket]]]] &\) /@ rl, newN]]];\)\)



ConstructMutateList[ml_,n_Integer]:=Module[{mut},
    mut=ml/.{\[Mu]_?(Not[ListQ[#]]&)}\[Rule]{\[Mu],\[Mu]};
    If[Depth[mut]\[Equal]2,Array[mut&,n],mut]];



Options[Mutate]={Compiled\[Rule]False};

Mutate[g_List,mr_List,opts___Rule]:=
    
    If[Compiled/.{opts}/.Options[Mutate],
      MutateCompiled[HaploidIndividuals][g,mr],
      MapThread[
        If[Random[]<#2\[LeftDoubleBracket]#1+1\[RightDoubleBracket],
            1-#1,#1]&,{g,mr}]];

Mutate[HaploidIndividuals[\[Psi]_,n_],mr_List,opts___Rule]:=
    
    HaploidIndividuals[Mutate[#,mr,opts]&/@\[Psi],n];

Mutate[AlleleFrequencies[p_,n_],mr_List,opts___Rule]:=
    AlleleFrequencies[
      If[Compiled/.{opts}/.Options[Mutate],
        MutateCompiled[AlleleFrequencies][p,mr],
        Module[{tmr=Transpose[mr]},
          
          p(1-tmr\[LeftDoubleBracket]1\[RightDoubleBracket]-
                  tmr\[LeftDoubleBracket]2\[RightDoubleBracket])+
            tmr\[LeftDoubleBracket]1\[RightDoubleBracket]]],n];

Mutate[HaploidFrequencies[\[Psi]_,n_],mr_List,opts___Rule]:=
    
    HaploidFrequencies[
      ConstructMutateMatrix[mr,Log[2,Length[\[Psi]]],opts].\[Psi],n];

Mutate[SymmetricHaploidFrequencies[\[Psi]_,n_],mr_List,opts___Rule]:=
    
    SymmetricHaploidFrequencies[
      ConstructMutateMatrix[mr,Length[\[Psi]]-1,opts,
          NumericalModel\[Rule]SymmetricHaploidFrequencies].\[Psi],n];

Mutate[SymmetricNeutralHaploidFrequencies[\[Psi]_,n_],mr_List,opts___Rule]:=0;



Options[ConstructMutateMatrix]={Compiled\[Rule]False,
      NumericalModel\[Rule]HaploidFrequencies};

ConstructMutateMatrix::badModel=
    "`1` is not a valid setting for NumericalModel in ConstructMutateMatrix";

\!\(\(ConstructMutateMatrix[mr_List, n_Integer, 
        opts___Rule] := \(ConstructMutateMatrix[mr, n, 
          opts] = \[IndentingNewLine]Module[{nm = \(NumericalModel /. \
{opts}\) /. Options[
                  ConstructMutateMatrix], \[IndentingNewLine]tmr, \[Mu], \
\[Nu], ht, i, j, 
            a}, \[IndentingNewLine]If[\(Compiled /. {opts}\) /. 
              Options[ConstructMutateMatrix], \[IndentingNewLine]Switch[
              nm, \[IndentingNewLine]HaploidFrequencies, \
\[IndentingNewLine]\(ConstructMutateMatrixCompiled[nm]\)[mr, 
                HaploidTypes[n, 
                  opts]], \[IndentingNewLine]SymmetricHaploidFrequencies | 
                SymmetricNeutralHaploidFrequencies, \
\[IndentingNewLine]\(ConstructMutateMatrixCompiled[nm]\)[mr, 
                n], \[IndentingNewLine]_, \[IndentingNewLine]\(Message[
                  ConstructMutateMatrix::badModel, 
                  nm];\)], \[IndentingNewLine]Switch[
              nm, \[IndentingNewLine]HaploidFrequencies, \
\[IndentingNewLine]tmr = Transpose[mr]; 
              ht = HaploidTypes[n, opts]; \[IndentingNewLine]\[Mu] = 
                tmr\[LeftDoubleBracket]1\[RightDoubleBracket]; \[Nu] = 
                tmr\[LeftDoubleBracket]2\[RightDoubleBracket]; \
\[IndentingNewLine]Outer[
                Times @@ \((\((1 - \[Mu])\) - #1 \((1 - 
                              2  \[Mu])\) - #2 \((1 - 
                              2  #1)\) \((1 - \[Mu] - \[Nu])\))\) &, ht, ht, 
                1], \[IndentingNewLine]SymmetricHaploidFrequencies, \
\[IndentingNewLine]\[Mu] = 
                mr\[LeftDoubleBracket]1\[RightDoubleBracket]; \[Nu] = 
                mr\[LeftDoubleBracket]2\[RightDoubleBracket]; 
              a = \((\(\[Mu]\/\(1 - \[Mu]\)\) \[Nu]\/\(1 - \[Nu]\))\); \
\[IndentingNewLine]Table[
                If[i > j, \[IndentingNewLine]\(\[Mu]\^\(i - 
                          j\)\) \(\((1 - \[Mu])\)\^\(n - 
                          i\)\) \(\((1 - \[Nu])\)\^j\) 
                    Binomial[n - j, n - i]\ Hypergeometric2F1[\(-j\), i - n, 
                      1 + i - j, a], \[IndentingNewLine]If[
                    i \[Equal] 
                      j, \[IndentingNewLine]\(\((1 - \[Mu])\)\^\(n - 
                            j\)\) \((1 - \[Nu])\)\^j\ \
Hypergeometric2F1[\(-j\), j - n, 1, 
                        a], \[IndentingNewLine]\(\((1 - \[Mu])\)\^\(n - 
                            j\)\) \(\((1 - \[Nu])\)\^i\) \(\[Nu]\^\(j - i\)\) 
                      Binomial[j, i]\ Hypergeometric2F1[\(-i\), j - n, 
                        1 - i + j, a]]], \[IndentingNewLine]{i, 0, n}, {j, 0, 
                  
                  n}], \[IndentingNewLine]SymmetricNeutralHaploidFrequencies, \
\[IndentingNewLine]0, \[IndentingNewLine]_, \[IndentingNewLine]\(Message[
                  ConstructMutateMatrix::badModel, nm];\)]]]\);\)\)



















ConstructMutateMatrixCompiled[HaploidFrequencies]=
    Compile[{{mr,_Real,2},{ht,_Integer,2}},
      Module[{tmr=Transpose[mr],j,k},
        Table[
          Times@@((1-tmr\[LeftDoubleBracket]1\[RightDoubleBracket])-
                ht\[LeftDoubleBracket]
                    j\[RightDoubleBracket](1-2tmr\[LeftDoubleBracket]1\
\[RightDoubleBracket])-
                ht\[LeftDoubleBracket]
                    k\[RightDoubleBracket](1-2ht\[LeftDoubleBracket]
                          j\[RightDoubleBracket])(1-
                      tmr\[LeftDoubleBracket]1\[RightDoubleBracket]-
                      tmr\[LeftDoubleBracket]2\[RightDoubleBracket])),{j,
            Length[ht]},{k,Length[ht]}]],
      {{tmr,_Real,2},{j,_Integer},{k,_Integer}}];

\!\(\(ConstructMutateMatrixCompiled[SymmetricHaploidFrequencies] = 
      Compile[{{mr, _Real, 1}, {n, _Integer}}, \[IndentingNewLine]Module[{i, 
            j, a, \[Mu], \[Nu]}, \[IndentingNewLine]\[Mu] = 
            mr\[LeftDoubleBracket]1\[RightDoubleBracket]; \[Nu] = 
            mr\[LeftDoubleBracket]2\[RightDoubleBracket]; 
          a = \((\(\[Mu]\/\(1 - \[Mu]\)\) \[Nu]\/\(1 - \[Nu]\))\); \
\[IndentingNewLine]Table[
            If[i > j, \[IndentingNewLine]\(\[Mu]\^\(i - 
                      j\)\) \(\((1 - \[Mu])\)\^\(n - 
                      i\)\) \(\((1 - \[Nu])\)\^j\) 
                Binomial[n - j, n - i]\ Hypergeometric2F1[\(-j\), i - n, 
                  1 + i - j, a], \[IndentingNewLine]If[
                j \[Equal] 
                  i, \[IndentingNewLine]\(\((1 - \[Mu])\)\^\(n - 
                        j\)\) \((1 - \[Nu])\)\^j\ Hypergeometric2F1[\(-j\), 
                    j - n, 1, a], \[IndentingNewLine]Binomial[j, 
                    i] \(\((1 - \[Mu])\)\^\(n - 
                        j\)\) \(\((1 - \[Nu])\)\^i\) \[Nu]\^\(j - i\)\ \
Hypergeometric2F1[\(-i\), j - n, 1 - i + j, a]]], \[IndentingNewLine]{i, 0, 
              n}, {j, 0, 
              n}]], \[IndentingNewLine]{{a, _Real}, {\[Mu], _Real}, {\[Nu], \
_Real}, {i, _Integer}, {j, _Integer}, {Binomial[_, _], _Real}}];\)\)



MutateCompiled[HaploidIndividuals]=Compile[{{g,_Integer,1},{mr,_Real,2}},
      Module[{j},
        Table[
          If[Random[]<
              mr\[LeftDoubleBracket]j,
                g\[LeftDoubleBracket]
                    j\[RightDoubleBracket]+1\[RightDoubleBracket],
            1-g\[LeftDoubleBracket]j\[RightDoubleBracket],
            g\[LeftDoubleBracket]j\[RightDoubleBracket]],{j,Length[g]}]],
      {{j,_Integer}}];

MutateCompiled[AlleleFrequencies]=Compile[{{p,_Real,1},{mr,_Real,2}},
      Module[{tmr=Transpose[mr]},
        p(1-tmr\[LeftDoubleBracket]1\[RightDoubleBracket]-
                tmr\[LeftDoubleBracket]2\[RightDoubleBracket])+
          tmr\[LeftDoubleBracket]1\[RightDoubleBracket]]];

MutateCompiled[HaploidFrequencies][\[Psi]_,mr_,opts___Rule]:=
    
    ConstructMutateMatrix[mr,Log[2,Length[\[Psi]]],opts,
        Compiled\[Rule]True].\[Psi];

MutateCompiled[SymmetricHaploidFrequencies][\[Psi]_,mr_]:=
    
    ConstructMutateMatrix[mr,Length[\[Psi]]-1,Compiled\[Rule]True,
        NumericalModel\[Rule]SymmetricHaploidFrequencies].\[Psi];



Options[MigrateExact]={FixedEnds\[Rule]{{},{}}};

\!\(\(MigrateExact[\((pr : NeutralRepresentations)\)[{\[Psi]_, u_}, 
          n_], \((pr : NeutralRepresentations)\)[{\[Psi]s_, us_}, ns_], m_, 
        opts___Rule] := \[IndentingNewLine]pr[{DivideZero[\((1 - 
                    m)\) \((n\ \[Psi])\) + 
              m\ \((ns\ \[Psi]s)\), \((1 - m)\) n + m\ ns], 
          DivideZero[\((1 - m)\) \((n\ u\ \[Psi])\) + 
              m\ \((ns\ us\ \[Psi]s)\), \((1 - m)\) \((n\ \[Psi])\) + 
              m\ \((ns\ \[Psi]s)\)]}, \((1 - m)\) n + 
          m\ ns];\)\[IndentingNewLine]
  \(MigrateExact[\((pr : FrequencyRepresentations)\)[\[Psi]_, 
          n_], \((pr : PopulationRepresentations)\)[\[Psi]s_, ns_], m_, 
        opts___Rule] := \[IndentingNewLine]pr[
        DivideZero[\((1 - m)\) \((n\ \[Psi])\) + 
            m \((ns\ \ \[Psi]s)\), \((1 - m)\) n + m\ ns], \((1 - m)\) n + 
          m\ ns];\)\[IndentingNewLine]
  \(MigrateExact[\((ir : IndividualRepresentations)\)[\[Psi]_, 
          n_], \((fr : FrequencyRepresentations)\)[\[Psi]s_, ns_], 
        Nm_Integer, 
        opts___Rule] := \[IndentingNewLine]Module[{nStay = 
            Random[BinomialDistribution[n, \((1 - Nm\/n)\)]], 
          np}, \[IndentingNewLine]np = 
          ir[Muddle[
              Join[\(MakeIndividuals[fr[\[Psi]s, ns], 
                    Nm]\)\ \[LeftDoubleBracket]1\[RightDoubleBracket], 
                RandomSet[nStay, \[Psi]]]], 
            nStay + Nm]; \[IndentingNewLine]If[
          MatchQ[ir, HaploidIndividuals] \[And] 
            OddQ[nStay + Nm], \[IndentingNewLine]HaploidIndividuals[
            Drop[np\[LeftDoubleBracket]1\[RightDoubleBracket], 1], 
            np\[LeftDoubleBracket]2\[RightDoubleBracket] - 1], np]];\)\)

\!\(\(MigrateExact[\[Phi] : {\((pr : NeutralRepresentations)\)[_, _] .. }, 
        m_, opts___Rule] := \[IndentingNewLine]Module[{pp, 
          os}, \n\t\tos = \(FixedEnds /. {opts}\) /. 
            Options[MigrateExact]; \n\t\tIf[
          os\[LeftDoubleBracket]\ \ 1\[RightDoubleBracket] === {} \[Or] 
            os\[LeftDoubleBracket]\ \ \ 1\[RightDoubleBracket] === {{}}, 
          os\[LeftDoubleBracket]\ \ \ 1\[RightDoubleBracket] = 
            First[\[Phi]]]; \n\t\tIf[
          os\[LeftDoubleBracket]\(-1\)\[RightDoubleBracket] === {} \[Or] 
            os\[LeftDoubleBracket]\(-1\)\[RightDoubleBracket] === {{}}, 
          os\[LeftDoubleBracket]\(-1\)\[RightDoubleBracket] = 
            Last[\[Phi]]]; \n\ \ \ \ \ \ \ \ pp = 
          Prepend[Append[\[Phi], Last[os]], 
            First[os]]; \[IndentingNewLine]pp = 
          pp /. {NeutralRepresentations[{\[Psi]_, u_}, 
                  n_] \[RuleDelayed] {n\ \[Psi], n\ \[Psi]\ u, 
                  n}}; \[IndentingNewLine]\(pr[{DivideZero[#\
\[LeftDoubleBracket]1\[RightDoubleBracket], #\[LeftDoubleBracket]3\
\[RightDoubleBracket]], 
                DivideZero[#\[LeftDoubleBracket]2\[RightDoubleBracket], #\
\[LeftDoubleBracket]1\[RightDoubleBracket]]}, #\[LeftDoubleBracket]3\
\[RightDoubleBracket]] &\) /@ \((Drop[
              Drop[\((1 - m)\) 
                    pp + \(m\/2\) \((RotateLeft[pp] + RotateRight[pp])\), 
                1], \(-1\)])\)];\)\)

\!\(\(MigrateExact[\[Phi] : {\((pr : FrequencyRepresentations)\)[_, _] .. }, 
        m_, opts___Rule] := \[IndentingNewLine]Module[{pp, 
          os}, \n\t\tos = \(FixedEnds /. {opts}\) /. 
            Options[MigrateExact]; \n\t\tIf[
          os\[LeftDoubleBracket]\ \ 1\[RightDoubleBracket] === {} \[Or] 
            os\[LeftDoubleBracket]\ \ \ 1\[RightDoubleBracket] === {{}}, 
          os\[LeftDoubleBracket]\ \ \ 1\[RightDoubleBracket] = 
            First[\[Phi]]]; \n\t\tIf[
          os\[LeftDoubleBracket]\(-1\)\[RightDoubleBracket] === {} \[Or] 
            os\[LeftDoubleBracket]\(-1\)\[RightDoubleBracket] === {{}}, 
          os\[LeftDoubleBracket]\(-1\)\[RightDoubleBracket] = 
            Last[\[Phi]]]; \n\ \ \ \ \ \ \ \ pp = 
          Prepend[Append[\[Phi], Last[os]], 
            First[os]]; \[IndentingNewLine]pp = 
          pp /. {FrequencyRepresentations[\[Psi]_, 
                  n_] \[RuleDelayed] {n\ \[Psi], n}}; \[IndentingNewLine]\(pr[
              DivideZero[#\[LeftDoubleBracket]1\[RightDoubleBracket], #\
\[LeftDoubleBracket]2\[RightDoubleBracket]], #\[LeftDoubleBracket]2\
\[RightDoubleBracket]] &\) /@ \((Drop[
              Drop[\((1 - m)\) 
                    pp + \(m\/2\) \((RotateLeft[pp] + RotateRight[pp])\), 
                1], \(-1\)])\)];\)\)

\!\(\(MigrateExact[\[Phi] : {\((ir : IndividualRepresentations)\)[_, _] .. }, 
        m_, opts___] := \[IndentingNewLine]Module[{pp, os, 
          nd = Length[\[Phi]], j, res, mig, migleft, migright, leftFree, 
          rightFree, leftImm, rightImm, npp, np, 
          hQ = MatchQ[ir, 
              HaploidIndividuals]}, \[IndentingNewLine]os = \(FixedEnds /. \
{opts}\) /. Options[
              MigrateExact]; \[IndentingNewLine]leftFree = \((os\
\[LeftDoubleBracket]\ \ 1\[RightDoubleBracket] === {} \[Or] 
              os\[LeftDoubleBracket]\ \ \ 1\[RightDoubleBracket] === {{}})\); 
        rightFree = \((os\[LeftDoubleBracket]\(-1\)\[RightDoubleBracket] === \
{} \[Or] os\[LeftDoubleBracket]\(-1\)\[RightDoubleBracket] === {{}})\); \
\[IndentingNewLine]pp = \[Phi] /. {ir[\[Psi]_, 
                  n_] \[RuleDelayed] \[Psi]}; \[IndentingNewLine]npp = 
          Table[\[IndentingNewLine]res = 
                RandomSet[
                  Random[BinomialDistribution[
                      Length[pp\[LeftDoubleBracket]
                          j\[RightDoubleBracket]], \((1 - m)\)]], 
                  pp\[LeftDoubleBracket]
                    j\[RightDoubleBracket]]; \[IndentingNewLine]mig = 
                TakeAway[pp\[LeftDoubleBracket]j\[RightDoubleBracket], 
                  res]; \[IndentingNewLine]migleft = 
                RandomSet[Random[BinomialDistribution[Length[mig], 1\/2]], 
                  mig]; \[IndentingNewLine]migright = 
                TakeAway[mig, migleft]; \[IndentingNewLine]{migleft, res, 
                migright}, {j, nd}] // 
            Transpose; \[IndentingNewLine]leftImm = 
          If[leftFree, 
            npp\[LeftDoubleBracket]1, 
              1\[RightDoubleBracket], \(MakeIndividuals[
                os\[LeftDoubleBracket]1\[RightDoubleBracket], 
                Length[npp\[LeftDoubleBracket]1, 
                    1\[RightDoubleBracket]]]\)\[LeftDoubleBracket]1\
\[RightDoubleBracket]]; \[IndentingNewLine]rightImm = 
          If[rightFree, 
            npp\[LeftDoubleBracket]3, \(-1\)\[RightDoubleBracket], \
\(MakeIndividuals[os\[LeftDoubleBracket]\(-1\)\[RightDoubleBracket], 
                Length[npp\[LeftDoubleBracket]3, \
\(-1\)\[RightDoubleBracket]]]\)\[LeftDoubleBracket]1\[RightDoubleBracket]]; \
\[IndentingNewLine]npp = 
          ReplacePart[ReplacePart[npp, \ leftImm, \ {3, \(-1\)}], 
            rightImm, {1, 1}]; \[IndentingNewLine]\(If[
              hQ \[And] OddQ[Length[#]], 
              ir[Drop[Muddle[#], 1], Length[#] - 1], 
              ir[Muddle[#], Length[#]]] &\) /@ 
          Apply[Join, \(({RotateLeft[
                    npp\[LeftDoubleBracket]1\[RightDoubleBracket]], 
                  npp\[LeftDoubleBracket]2\[RightDoubleBracket], 
                  RotateRight[
                    npp\[LeftDoubleBracket]3\[RightDoubleBracket]]} // 
                Transpose)\), {1}]];\)\)



RandomDrift::symmetric="Random drift is not allowed under the symmetric model"



RandomDrift::individuals="RandomDrift does not apply to populations of \
individuals."



RandomDrift[\[Psi]:{PopulationRepresentations[_,_]...},n_List]:=
    
    MapThread[RandomDrift[#1,#2]&,{\[Psi],n}];

RandomDrift[(pr:PopulationRepresentations)[\[Psi]_,n_],\[Infinity]]:=
    
    pr[\[Psi],n];
RandomDrift[(pr:IndividualRepresentations)[\[Psi]_,n_],_]:=
    (Message[
        RandomDrift::individuals];pr[\[Psi],n]);
RandomDrift[(pr:SymmetricRepresentations)[\[Psi]_,n_],_]:=
    (Message[
        RandomDrift::symmetric];pr[\[Psi],n]);
RandomDrift[AlleleFrequencies[p_,n_],ns_]:=
    
    Module[{nsr=Max[1,Round[ns]]},
      AlleleFrequencies[Last[RandomMultinomial[nsr,{1-#,#}]]/N[nsr]&/@p,ns]];
RandomDrift[HaploidFrequencies[\[Psi]_,n_],ns_]:=
    Module[{nsr=Max[1,Round[ns]]},
      HaploidFrequencies[RandomMultinomial[nsr,\[Psi]]/N[nsr],ns]];
RandomDrift[DiploidFrequencies[\[Psi]_,n_],ns_]:=
    
    Module[{nsr=Max[1,Round[ns]]},
      DiploidFrequencies[
        Partition[RandomMultinomial[nsr,Flatten[\[Psi]]],Length[\[Psi]]]/
          N[nsr],ns]];



Options[SelectionExact]={TruncationSelection\[Rule]False};

SelectionExact::badN="New deme size `1` is greater than original size `2`";

SelectionExact[\[Psi]:{PopulationRepresentations[_,_]...},W_?(Not[ListQ[#]]&),
      f_,opts___Rule]:=
    
    MapIndexed[SelectionExact[#1,W[First[#2]],f[First[#2]],opts]&,\[Psi]];
SelectionExact[\[Psi]:{PopulationRepresentations[_,_]...},W_List,f_,
      opts___Rule]:=
    
    MapIndexed[
      SelectionExact[#1,W\[LeftDoubleBracket]First[#2]\[RightDoubleBracket],
          f[First[#2]],opts]&,\[Psi]];

SelectionExact[(pr:FrequencyRepresentations)[\[Psi]_,n0_],W_,opts___Rule]:=
    SelectionExact[pr[\[Psi],n0],W,n0&,opts];
SelectionExact[\[Psi]:{PopulationRepresentations[_,_]...},W_?(Not[ListQ[#]]&),
      opts___Rule]:=
    
    MapIndexed[SelectionExact[#1,W[First[#2]],opts]&,\[Psi]];
SelectionExact[\[Psi]:{PopulationRepresentations[_,_]...},W_List,opts___Rule]:=

        MapIndexed[
      SelectionExact[#1,W\[LeftDoubleBracket]First[#2]\[RightDoubleBracket],
          opts]&,\[Psi]];

SelectionExact[SymmetricNeutralHaploidFrequencies[{\[Psi]_,u_},n0_],W_,n_,
      opts___Rule]:=
    
    SymmetricNeutralHaploidFrequencies[{SelectionExact[
          SymmetricHaploidFrequencies[\[Psi],n0],n],u},n];
SelectionExact[SymmetricNeutralDiploidFrequencies[{\[Psi]_,u_},n0_],W_,n_,
      opts___Rule]:=
    
    SymmetricNeutralDiploidFrequencies[{SelectionExact[
          SymmetricDiploidFrequencies[\[Psi],n0],n],u},n];

\!\(\(SelectionExact[AlleleFrequencies[p_, n0_], W_?\((Not[ListQ[#]] &)\), 
        f_, opts___Rule] := \[IndentingNewLine]Module[{wl = 
            W[p]}, \[IndentingNewLine]AlleleFrequencies[
          p \((1 + \((1 - p)\) 
                  wl\[LeftDoubleBracket]2\[RightDoubleBracket]\/wl\
\[LeftDoubleBracket]1\[RightDoubleBracket])\), 
          f[n0, wl\[LeftDoubleBracket]1\[RightDoubleBracket]]]];\)\)

\!\(\(SelectionExact[\((fr : FrequencyRepresentations)\)[\[Psi]_, n0_], 
        W_?\((Not[ListQ[#]] &)\), f_, 
        opts___Rule] := \[IndentingNewLine]Module[{nn, ng, 
          wb}, \[IndentingNewLine]ng = 
          Switch[fr, \[IndentingNewLine]SymmetricRepresentations, \
\[IndentingNewLine]Length[\[Psi]] - 1, \[IndentingNewLine]_, 
            Log[2, Length[\[Psi]]]]; \[IndentingNewLine]nn = \[Psi]*
            FitnessTable[W, ng, NumericalModel \[Rule] fr, 
              opts]; \[IndentingNewLine]wb = Plus @@ \(Plus @@ nn\); 
        fr[nn\/wb, f[n0, wb]]];\)\)

\!\(\(SelectionExact[\((fr : FrequencyRepresentations)\)[\[Psi]_, n0_], 
        W_List, f_, 
        opts___Rule] := \[IndentingNewLine]Module[{nn, 
          wb}, \[IndentingNewLine]nn = \[Psi]*W; wb = Plus @@ \(Plus @@ nn\); 
        fr[nn\/wb, f[n0, wb]]];\)\)



\!\(\(SelectionExact[HaploidIndividuals[\[Psi]_, n0_], 
        W_?\((Not[ListQ[#]] &)\), f_, 
        opts___Rule] := \[IndentingNewLine]Module[{wb = 
            MeanW[HaploidIndividuals[\[Psi], n0], W], nn, ss, tp, 
          np}, \[IndentingNewLine]nn = f[n0, wb]; \[IndentingNewLine]If[
          nn > n0, \[IndentingNewLine]Message[SelectionExact::badN, nn, n0]; 
          nn = n0]; \[IndentingNewLine]If[\(TruncationSelection /. {opts}\) /. 
            Options[SelectionExact], \[IndentingNewLine]ss = \({W[#], #} &\) /@ \
\[Psi]; tp = \(Sort[ss]\)\[LeftDoubleBracket]\(-nn\), 
              1\[RightDoubleBracket]; \[IndentingNewLine]np = 
            Select[ss, \((#\[LeftDoubleBracket]1\[RightDoubleBracket] > 
                    tp)\) &]; \[IndentingNewLine]HaploidIndividuals[
            Muddle[Last /@ \((np~Join~
                    RandomSet[nn - Length[np], 
                      Select[ss, \((#\[LeftDoubleBracket]1\
\[RightDoubleBracket] == tp)\) &]])\)], 
            nn], \[IndentingNewLine]HaploidIndividuals[
            Muddle[RandomList[nn, W /@ \[Psi]\/\(n0*wb\), \[Psi], 
                Replace \[Rule] False]], nn]]];\)\[IndentingNewLine]
  \(SelectionExact[DiploidIndividuals[\[Psi]_, n0_], 
        W_?\((Not[ListQ[#]] &)\), f_, 
        opts___Rule] := \[IndentingNewLine]Module[{wb = 
            MeanW[DiploidIndividuals[\[Psi], n0], W], nn, ss, tp, 
          np}, \[IndentingNewLine]nn = f[n0, wb]; \[IndentingNewLine]If[
          nn > n0, \[IndentingNewLine]Message[SelectionExact::badN, nn, n0]; 
          nn = n0]; \[IndentingNewLine]If[\(TruncationSelection /. {opts}\) /. 
            Options[SelectionExact], \[IndentingNewLine]ss = \({W[#], #} &\) /@ \
\[Psi]; tp = \(Sort[ss]\)\[LeftDoubleBracket]\(-nn\), 
              1\[RightDoubleBracket]; \[IndentingNewLine]np = 
            Select[ss, \((#\[LeftDoubleBracket]1\[RightDoubleBracket] > 
                    tp)\) &]; \[IndentingNewLine]DiploidIndividuals[
            Muddle[Last /@ \((np~Join~
                    RandomSet[nn - Length[np], 
                      Select[ss, \((#\[LeftDoubleBracket]1\
\[RightDoubleBracket] == tp)\) &]])\)], 
            nn], \[IndentingNewLine]DiploidIndividuals[
            Muddle[RandomList[
                nn, \(\((W @@ #)\) &\) /@ \[Psi]\/\(n0*wb\), \[Psi], 
                Replace \[Rule] False]], nn]]];\)\)

SelectionExact[HaploidIndividuals[\[Psi]_,n0_],W_?(Not[ListQ[#]]&),
      opts___Rule]:=
    Module[{n\[Psi]=Select[\[Psi],(Random[]<W[#])&]},
      HaploidIndividuals[n\[Psi],Length[n\[Psi]]]];
SelectionExact[DiploidIndividuals[\[Psi]_,_],W_?(Not[ListQ[#]]&),opts___Rule]:=

        Module[{n\[Psi]=Select[\[Psi],(Random[]<(W@@#))&]},
      DiploidIndividuals[n\[Psi],Length[n\[Psi]]]];

SelectionExact[HaploidIndividuals[\[Psi]_,_],W_List,n_,opts___Rule]:=
    
    Module[{ht,n\[Psi]},
      If[Length[\[Psi]]=0,
        HaploidIndividuals[{},0],
        ht=HaploidTypes[Length[First[\[Psi]]],opts];
        n\[Psi]=
          Select[\[Psi],
            Random[]<(Extract[W,#]&/@(First[Position[ht,#]]&))&]];
      HaploidIndividuals[n\[Psi],Length[n\[Psi]]]];
SelectionExact[DiploidIndividuals[\[Psi]_,_],W_List,n_,opts___Rule]:=
    
    Module[{ht,n\[Psi]},
      If[Length[\[Psi]]==0,
        Indeterminate,
        ht=
          HaploidTypes[
            Length[\[Psi]\[LeftDoubleBracket]1,1\[RightDoubleBracket]],opts];
        n\[Psi]=
          Select[\[Psi],
            Random[]<(Extract[
                        W,#]&/@(Flatten[{Position[
                                ht,#\[LeftDoubleBracket]1\[RightDoubleBracket]\
],Position[ht,#\[LeftDoubleBracket]2\[RightDoubleBracket]]}]&/@\[Psi]))&];
        DiploidIndividuals[n\[Psi],Length[n\[Psi]]]]];



Options[IterateExact]={Compiled\[Rule]False,MigrationOrder\[Rule]UMS,
      FixedEnds\[Rule]{{},{}},DemeSize\[Rule](#1&),RandomDrift\[Rule]False};

IterateExact::badMigrationOrder=
    "`1` is not a valid setting for MigrationOrder";



IterateExact[(pr:NonNeutralRepresentations)[\[Psi]_,nd_],ww_,m_,opts___Rule]:=
    Module[{i,gg,\[Psi]s,f,cr,gt,dt,ht,
        iQ=MatchQ[pr,HaploidIndividuals],
        cQ=Compiled/.{opts}/.Options[IterateExact],
        mo=MigrationOrder/.{opts}/.Options[IterateExact],
        fe=FixedEnds/.{opts}/.Options[IterateExact],
        rd=RandomDrift/.{opts}/.Options[IterateExact],
        ng=NumberOfGenes[pr[\[Psi],nd]],spr},
      \[Psi]s=
        If[fe\[LeftDoubleBracket]1\[RightDoubleBracket]==={}\[Or]
            fe\[LeftDoubleBracket]1\[RightDoubleBracket]==={{}},
          spr=Switch[pr,
              HaploidIndividuals,HaploidFrequencies,
              _,pr];
          MakePopulation[ng,1,nd,NumericalModel\[Rule]spr],
          fe\[LeftDoubleBracket]1\[RightDoubleBracket]];
      If[cQ,
        f=DemeSize/.{opts}/.Options[IterateExact];
        f=f/.{((nn_?NumberQ)&)\[Rule]{nn,0,1,0},(#1&)\[Rule]{1,0,0,0},
              PowerF[r_,\[Beta]_,\[Gamma]_]\[Rule]{r,\[Beta],\[Gamma],0},
              ExponentialF[r_,\[Beta]_,\[Lambda]_]\[Rule]{r,\[Beta],
                  0,\[Lambda]},
              (PowerF|ExponentialF)[
                  r_,\[Beta]_,\[Gamma]_,\[Lambda]_]\[Rule]{r,\[Beta],\[Gamma],\
\[Lambda]},ExponentialF[r_,\[Beta]_,\[Lambda]_]\[Rule]{r,\[Beta],
                  0,\[Lambda]}};
        cr=If[pr===AlleleFrequencies,
            
            IterateCompiled[ww,oneDeme,mo][\[Psi],nd,
              m,\[Psi]s\[LeftDoubleBracket]1\[RightDoubleBracket],\[Psi]s\
\[LeftDoubleBracket]2\[RightDoubleBracket],f,rd],
            gt=GameteTable[ng,ww,NumericalModel\[Rule]pr,opts];
            If[iQ,
              
              ht=HaploidTypes[
                  Log[2,Length[\[Psi]s\[LeftDoubleBracket]1\
\[RightDoubleBracket]]],opts];Flatten[Outer[List,ht,ht,1],1];
              IterateCompiled[oneDeme,ind,mo][\[Psi],nd,gt,dt,
                m,\[Psi]s\[LeftDoubleBracket]1\[RightDoubleBracket],\[Psi]s\
\[LeftDoubleBracket]2\[RightDoubleBracket],f],
              IterateCompiled[oneDeme,mo][\[Psi],nd,gt,
                m,\[Psi]s\[LeftDoubleBracket]1\[RightDoubleBracket],\[Psi]s\
\[LeftDoubleBracket]2\[RightDoubleBracket],f,rd]]];
        pr[Drop[cr,-1],Last[cr]],
         Switch[mo,
          UMS,
          
          NewGametes[
            MigrateExact[MakeDiploid[pr[\[Psi],nd]],MakeDiploid[\[Psi]s],m],
            ww,opts],
          MUS,
          
          NewGametes[MakeDiploid[MigrateExact[pr[\[Psi],nd],\[Psi]s,m]],ww,
            opts],
          USM,
          \[Psi]2=
            If[iQ\[And]OddQ[nd],MakeDiploid[pr[Drop[\[Psi],1],nd-1]],
              MakeDiploid[pr[\[Psi],nd]]];
          MigrateExact[NewGametes[\[Psi]2,ww,opts],\[Psi]s,m],
           _,Message[IterateExact::badMigrationOrder,mo];pr[\[Psi],nd]]]];



IterateExact[\[Psi]:{NonNeutralRepresentations[_,_]..},ww_,m_,opts___]:=
    Module[{i,gg,nd=Length[\[Psi]],cr,gt,\[Psi]0,\[Psi]1,n0,n1,
        pr=Head[\[Psi]\[LeftDoubleBracket]1\[RightDoubleBracket]],
        cQ=Compiled/.{opts}/.Options[IterateExact],
        mo=MigrationOrder/.{opts}/.Options[IterateExact],
        fe=FixedEnds/.{opts}/.Options[IterateExact],
        rd=RandomDrift/.{opts}/.Options[IterateExact],
        \[Phi],nl,dsrl,
        ng=NumberOfGenes[\[Psi]]},
         If[cQ,
        \[Phi]=First/@\[Psi];nl=Last/@\[Psi];
        f=DemeSize/.{opts}/.Options[IterateExact];
        f=f/.{((nn_?NumberQ)&)\[Rule]Array[{nn,0,1,0}&,nd],(#1&)\[Rule]
                Array[{1,0,0,0}&,nd],
              
              PowerF[r_,\[Beta]_,\[Gamma]_]\[Rule]
                Array[{r,\[Beta],\[Gamma],0}&,nd],
              
              ExponentialF[r_,\[Beta]_,\[Lambda]_]\[Rule]
                Array[{r,\[Beta],0,\[Lambda]}&,nd],
              (PowerF|ExponentialF)[r_,\[Beta]_,\[Gamma]_,\[Lambda]_]\[Rule]
                Array[{r,\[Beta],\[Gamma],\[Lambda]}&,nd],
              ExponentialF[r_,\[Beta]_,\[Lambda]_]\[Rule]
                Array[{r,\[Beta],0,\[Lambda]}&,nd]};
        If[fe\[LeftDoubleBracket]1\[RightDoubleBracket]==={},\[Psi]0={};
          n0=0,\[Psi]0=fe\[LeftDoubleBracket]1,1\[RightDoubleBracket];
          n0=fe\[LeftDoubleBracket]1,2\[RightDoubleBracket]];
        If[fe\[LeftDoubleBracket]-1\[RightDoubleBracket]==={},\[Psi]1={};
          n1=0,\[Psi]1=fe\[LeftDoubleBracket]-1,1\[RightDoubleBracket];
          n1=fe\[LeftDoubleBracket]-1,2\[RightDoubleBracket]];
        cr=If[pr===AlleleFrequencies,
            
            IterateCompiled[ww,cline,mo][\[Phi],nl,m,\[Psi]0,\[Psi]1,n0,n1,f,
              rd],
            
            gt=Table[
                GameteTable[ng,ww[i],
                  NumericalModel\[Rule]
                    Head[\[Psi]\[LeftDoubleBracket]1\[RightDoubleBracket]],
                  opts],{i,nd}];
            
            IterateCompiled[cline,mo][\[Phi],nl,gt,m,\[Psi]0,\[Psi]1,n0,n1,f,
              rd]];
        pr[Drop[#,-1],Last[#]]&/@cr,
        dsrl[
            j_]:={(DemeSize\[Rule]
                  f_?(Not[ListQ[#]]&))\[RuleDelayed](DemeSize\[Rule]
                  f[j]),(DemeSize\[Rule]f_List)\[RuleDelayed](DemeSize\[Rule]
                  f\[LeftDoubleBracket]j\[RightDoubleBracket])};
        Switch[mo,
          UMS,
          
          gg=MigrateExact[MakeDiploid[\[Psi]],m,
              FixedEnds\[Rule](MakeDiploid/@fe)];
          Table[NewGametes[gg\[LeftDoubleBracket]i\[RightDoubleBracket],
                  ww[i],##]&@@({opts}/.dsrl[i]),{i,nd}],
          MUS,
          gg=MakeDiploid[MigrateExact[\[Psi],m,FixedEnds\[Rule]fe]];
          Table[NewGametes[gg\[LeftDoubleBracket]i\[RightDoubleBracket],
                  ww[i],##]&@@({opts}/.dsrl[i]),{i,nd}],
          USM,
           gg=MakeDiploid[\[Psi]];
          
          MigrateExact[
            Table[NewGametes[gg\[LeftDoubleBracket]i\[RightDoubleBracket],
                    ww[i],##]&@@({opts}/.dsrl[i]),{i,nd}],m,
            FixedEnds\[Rule]fe],
          _,
          Message[IterateExact::badMigrationOrder,mo];pr[\[Psi],n]]]];



\!\(\(IterateCompiled[oneDeme, UMS] = 
      Compile[{{\[Psi], _Real, 1}, n, {gt, _Real, 3}, m, {\[Psi]s, _Real, 1}, 
          ns, {F, _Real, 1}, {rd, True | False}}, \n\t
        Module[{tt, wb, nm, rnm}, \n\tnm = m\ ns + \((1 - m)\) n; 
          tt = \((Plus @@ \(Plus @@ \((gt*\((n \((1 - m)\) 
                              Outer[Times, \[Psi], \[Psi]] + 
                            ns\ m\ Outer[Times, \[Psi]s, \[Psi]s])\))\)\))\)/
              nm; \n\twb = Plus @@ tt; \[IndentingNewLine]nm = 
            F\[LeftDoubleBracket]1\[RightDoubleBracket]\ \(nm\^\(1 - 
                    F\[LeftDoubleBracket]3\[RightDoubleBracket]\)\) \(wb\^F\
\[LeftDoubleBracket]2\[RightDoubleBracket]\) 
              Exp[\(-\ 
                    nm\)\ F\[LeftDoubleBracket]4\[RightDoubleBracket]]; \
\[IndentingNewLine]Append[
            If[rd, \[IndentingNewLine]rnm = 
                Max[1, Round[nm]]; \[IndentingNewLine]RandomMultinomial[rnm, 
                  tt\/wb]/rnm, \[IndentingNewLine]tt\/wb], 
            nm]], \n\t\t{{wb, _Real}, {nm, _Real}, {rnm, _Integer}, {tt, \
_Real, 1}, {RandomMultinomial[_, _], _Integer, 1}}];\)\)

\!\(\(IterateCompiled[oneDeme, MUS] = 
      Compile[{{\[Psi], _Real, 1}, n, {gt, _Real, 3}, m, {\[Psi]s, _Real, 1}, 
          ns, {F, _Real, 1}, {rd, 
            True | False}}, \[IndentingNewLine]Module[{tt, wb, nm, 
            rnm}, \[IndentingNewLine]nm = 
            m\ ns + \((1 - m)\) 
                n; \[IndentingNewLine]tt = \((n \((1 - m)\) \[Psi] + 
                  ns\ m\ \[Psi]s)\)/nm; \[IndentingNewLine]tt = 
            Plus @@ \(Plus @@ \((gt*
                    Outer[Times, tt, tt])\)\); \[IndentingNewLine]wb = 
            Plus @@ tt; \[IndentingNewLine]nm = 
            F\[LeftDoubleBracket]1\[RightDoubleBracket]\ \(nm\^\(1 - 
                    F\[LeftDoubleBracket]3\[RightDoubleBracket]\)\) \(wb\^F\
\[LeftDoubleBracket]2\[RightDoubleBracket]\) 
              Exp[\(-\ 
                    nm\)\ F\[LeftDoubleBracket]4\[RightDoubleBracket]]; \
\[IndentingNewLine]Append[
            If[rd, \[IndentingNewLine]rnm = 
                Max[1, Round[nm]]; \[IndentingNewLine]RandomMultinomial[rnm, 
                  tt\/wb]/rnm, \[IndentingNewLine]tt\/wb], 
            nm]], \n\t\t{{wb, _Real}, {nm, _Real}, {rnm, _Integer}, {tt, \
_Real, 1}, {RandomMultinomial[_, _], _Integer, 1}}];\)\)

\!\(\(IterateCompiled[oneDeme, USM] = 
      Compile[{{\[Psi], _Real, 1}, n, {gt, _Real, 3}, m, {\[Psi]s, _Real, 1}, 
          ns, {F, _Real, 1}, {rd, 
            True | False}}, \[IndentingNewLine]Module[{tt, wb, nn, nnn, 
            rnm}, \[IndentingNewLine]tt = 
            Plus @@ \(Plus @@ \((gt*
                    Outer[Times, \[Psi], \[Psi]])\)\); \[IndentingNewLine]wb \
= Plus @@ tt; 
          nn = F\[LeftDoubleBracket]1\[RightDoubleBracket]\ \(n\^\(1 - 
                    F\[LeftDoubleBracket]3\[RightDoubleBracket]\)\) \(wb\^F\
\[LeftDoubleBracket]2\[RightDoubleBracket]\) 
              Exp[\(-\ 
                    n\)\ F\[LeftDoubleBracket]4\[RightDoubleBracket]]; \
\[IndentingNewLine]nnn = \((1 - m)\) nn + ns\ m; \[IndentingNewLine]Append[
            If[rd, \[IndentingNewLine]rnm = 
                Max[1, Round[nnn]]; \[IndentingNewLine]RandomMultinomial[
                  rnm, \(nn \((1 - m)\) tt\/wb + ns\ m\ \[Psi]s\)\/nnn]/
                rnm, \[IndentingNewLine]\(nn \((1 - m)\) tt\/wb + ns\ m\ \
\[Psi]s\)\/nnn], 
            nnn]], \[IndentingNewLine]{{wb, _Real}, {nn, _Real}, {rnm, \
_Integer}, {nnn, _Real}, {tt, _Real, 1}, {RandomMultinomial[_, _], _Integer, 
            1}}];\)\)



\!\(\(IterateCompiled[oneDeme, ind, UMS] = 
      Compile[{{\[Psi], _Integer, 2}, {n, _Integer}, {gt, _Real, 
            3}, {dt, _Integer, 3}, {Nm, _Integer}, {\[Psi]s, _Real, 
            2}, {ns, _Integer}, {F, _Real, 1}}, \n\t
        Module[{nStay, np, nd = Quotient[n, 2], 
            migrants}, \[IndentingNewLine]If[OddQ[n], 
            Message[MakeDiploid::odd, n]]; \n\t
          np = Partition[\[Psi], 2]; \[IndentingNewLine]If[
            Nm > 0, \[IndentingNewLine]migrants = \(f\[Psi]s\
\[LeftDoubleBracket]#\[RightDoubleBracket] &\) /@ 
                RandomListCompiledReplace[Nm, 
                  Flatten[\[Psi]s]]; \[IndentingNewLine]nStay = 
              Random[BinomialDistribution[
                  n, \((1 - Nm\/n)\)]]; \[IndentingNewLine]If[
              nStay < nd, \[IndentingNewLine]np = 
                Extract[np, 
                  List /@ RandomSetCompiled[nStay, 
                      nd]]]; \[IndentingNewLine]np = 
              Sort[Join[migrants\ , np], 
                Random[] < 1\/2 &]]; \[IndentingNewLine] (*\ 
            need\ to\ implement\ a\ compiled\ version\ of\ NewGametes\ here\ \
*) ], \n\t\t{{nStay, _Integer}, {nd, _Integer}, {np, _Integer, 
            3}, {migrants, _Integer, 
            3}, {Random[
              BinomialDistribution[_, _]], _Integer}, \
{RandomListCompiledReplace[_, _], _Integer, 
            1}, {RandomSetCompiled[_, _], _Integer, 1}}];\)\)







\!\(\(IterateCompiled[ww_, oneDeme, 
        UMS] := \[IndentingNewLine]Module[{fw}, \[IndentingNewLine]fw[p_] := 
          Flatten[ww[p]]; \[IndentingNewLine]IterateCompiled[ww, oneDeme, 
            UMS] = Compile[{{p, _Real, 1}, n, m, {ps, _Real, 1}, 
              ns, {F, _Real, 1}, {rd, True | False}}, \n\t
            Module[{wv, np, wb, nm, rnm}, \[IndentingNewLine]nm = 
                m\ ns + \((1 - m)\) 
                    n; \[IndentingNewLine]np = \(n \((1 - m)\) p + ns\ \
m\ \ ps\)\/nm; \[IndentingNewLine]wv = fw[np]; 
              wb = wv\[LeftDoubleBracket]1\[RightDoubleBracket]; \
\[IndentingNewLine]np = 
                np \((1 + \((1 - np)\) 
                        Drop[wv, 1]\/wb)\); \[IndentingNewLine]nm = 
                F\[LeftDoubleBracket]1\[RightDoubleBracket]\ \(nm\^\(1 - 
                        F\[LeftDoubleBracket]3\[RightDoubleBracket]\)\) \
\(wb\^F\[LeftDoubleBracket]2\[RightDoubleBracket]\) 
                  Exp[\(-\ 
                        nm\)\ F\[LeftDoubleBracket]4\[RightDoubleBracket]]; \
\[IndentingNewLine]Append[
                If[rd, \[IndentingNewLine]rnm = 
                    Max[1, Round[
                        nm]]; \[IndentingNewLine]\((\(First[
                            RandomMultinomial[rnm, {#, 1 - #}]] &\) /@ np)\)/
                    rnm, \[IndentingNewLine]np], \[IndentingNewLine]nm]], \
\[IndentingNewLine]{{wv, _Real, 1}, {np, _Real, 
                1}, {wb, _Real}, {nm, _Real}, {rnm, _Integer}, \
{RandomMultinomial[_, _], _Integer, 1}, {fw[_], _Real, 1}}]];\)\)

IterateCompiled[ww_,oneDeme,MUS]:=IterateCompiled[ww,oneDeme,UMS];

\!\(\(IterateCompiled[ww_, oneDeme, 
        USM] := \[IndentingNewLine]Module[{fw}, \[IndentingNewLine]fw[p_] := 
          Flatten[ww[p]]; \[IndentingNewLine]IterateCompiled[ww, oneDeme, 
            USM] = Compile[{{p, _Real, 1}, n, m, {ps, _Real, 1}, 
              ns, {F, _Real, 1}, {rd, 
                True | False}}, \[IndentingNewLine]Module[{np, wb, nn, nnn, 
                rnm, wv}, \[IndentingNewLine]wv = fw[p]; 
              wb = wv\[LeftDoubleBracket]1\[RightDoubleBracket]; \
\[IndentingNewLine]np = 
                p \((1 + \((1 - p)\) 
                        Drop[wv, 1]\/wb)\); \[IndentingNewLine]nn = 
                F\[LeftDoubleBracket]1\[RightDoubleBracket]\ \(n\^\(1 - 
                        F\[LeftDoubleBracket]3\[RightDoubleBracket]\)\) \
\(wb\^F\[LeftDoubleBracket]2\[RightDoubleBracket]\) 
                  Exp[\(-\ 
                        n\)\ F\[LeftDoubleBracket]4\[RightDoubleBracket]]; \
\[IndentingNewLine]nnn = \((1 - m)\) nn + ns\ m; \[IndentingNewLine]Append[
                If[rd, \[IndentingNewLine]rnm = 
                    Max[1, Round[
                        nnn]]; \[IndentingNewLine]\((\(First[
                            RandomMultinomial[
                              rnm, {#, 1 - #}]] &\) /@ \(\(nn \((1 - m)\) 
                                np + ns\ m\ ps\)\/nnn\))\)/
                    rnm, \[IndentingNewLine]\((nn \((1 - m)\) np + 
                        ns\ m\ ps)\)/nnn], 
                nnn]], \[IndentingNewLine]{{wb, _Real}, {wv, _Real, 
                1}, {nn, _Real}, {rnm, _Integer}, {nnn, _Real}, {np, _Real, 
                1}, {RandomMultinomial[_, _], _Integer, 1}}]];\)\)



\!\(\(IterateCompiled[cline, UMS] = 
      Compile[{{\[Psi], _Real, 2}, {nl, _Real, 1}, {gt, _Real, 4}, 
          m, {fe0, _Real, 1}, {fe1, _Real, 1}, n0, 
          n1, {F, _Real, 2}, {rd, True | False}}, 
        Module[{\[Phi], n\[Phi], nn, tt, i, nm, wb, rnm, 
            nnm}, \[IndentingNewLine]\[Phi] = \(Outer[
                  Times, #, #] &\) /@ \[Psi]; \[IndentingNewLine]\[Phi] = 
            Prepend[Append[\[Phi], \[IndentingNewLine]If[Length[fe1] == 0, 
                  Last[\[Phi]], Outer[Times, fe1, fe1]]], 
              If[Length[fe0] == 0, First[\[Phi]], Outer[Times, fe0, fe0]]]; 
          nn = Prepend[
              Append[nl, \[IndentingNewLine]If[Length[fe1] == 0, Last[nl], 
                  n1]], If[Length[fe0] == 0, First[nl], n0]]; 
          n\[Phi] = nn*\[Phi]; \[IndentingNewLine]n\[Phi] = 
            Drop[Drop[\((1 - m)\) 
                    n\[Phi] + \(m\/2\) \((RotateLeft[n\[Phi]] + 
                        RotateRight[n\[Phi]])\), 
                1], \(-1\)]; \ \[IndentingNewLine]nm = 
            Drop[Drop[\((1 - m)\) 
                    nn + \(m\/2\) \((RotateLeft[nn] + RotateRight[nn])\), 
                1], \(-1\)]; 
          Table[tt = \((Plus @@ \(Plus @@ \((gt\[LeftDoubleBracket]
                            i\[RightDoubleBracket]*
                          n\[Phi]\[LeftDoubleBracket]
                            i\[RightDoubleBracket])\)\))\)/
                nm\[LeftDoubleBracket]i\[RightDoubleBracket]; 
            wb = Plus @@ tt; \[IndentingNewLine]nnm = 
              F\[LeftDoubleBracket]i, 
                  1\[RightDoubleBracket]\ \ \(nm\[LeftDoubleBracket]
                      i\[RightDoubleBracket]\^\(1 - 
                      F\[LeftDoubleBracket]i, 
                        3\[RightDoubleBracket]\)\) \(wb\^F\[LeftDoubleBracket]
                      i, 2\[RightDoubleBracket]\) 
                Exp[\(-\ 
                      nm\[LeftDoubleBracket]
                        i\[RightDoubleBracket]\)\ F\[LeftDoubleBracket]i, 
                      4\[RightDoubleBracket]]; 
            rnm = Max[1, Round[nnm]]; \[IndentingNewLine]Append[
              If[rd, RandomMultinomial[rnm, tt\/wb]/rnm, tt\/wb], nnm], {i, 
              Length[\[Psi]]}]], \n\t\t{{tt, _Real, 1}, {nm, _Real, 
            1}, {wb, _Real}, {nn, _Real, 1}, {\[Phi], _Real, 
            3}, {n\[Phi], _Real, 
            3}, {i, _Integer}, {RandomMultinomial[_, _], _Integer, 
            1}, {rnm, _Integer}, {nnm, _Real}}];\)\)

\!\(\(IterateCompiled[cline, MUS] = 
      Compile[{{\[Psi], _Real, 2}, {nl, _Real, 1}, {gt, _Real, 4}, 
          m, {fe0, _Real, 1}, {fe1, _Real, 1}, n0, 
          n1, {F, _Real, 2}, {rd, True | False}}, 
        Module[{\[Phi], y, ny, nn, nm, nnm, rnm, tt, 
            wb}, \((y = 
              Prepend[Append[\[Psi], \[IndentingNewLine]If[Length[fe1] == 0, 
                    Last[\[Psi]], fe1]], \[IndentingNewLine]If[
                  Length[fe0] == 0, First[\[Psi]], 
                  fe0]]; \[IndentingNewLine]nn = 
              Prepend[Append[
                  nl, \[IndentingNewLine]If[Length[fe1] == 0, Last[nl], 
                    n1]], \[IndentingNewLine]If[Length[fe0] == 0, First[nl], 
                  n0]]; \[IndentingNewLine]ny = nn*y; \[IndentingNewLine]ny = 
              Drop[Drop[\((1 - m)\) 
                      ny + \(m\/2\) \((RotateLeft[ny] + RotateRight[ny])\), 
                  1], \(-1\)]; \ 
            nm = Drop[
                Drop[\((1 - m)\) 
                      nn + \(m\/2\) \((RotateLeft[nn] + RotateRight[nn])\), 
                  1], \(-1\)]; \ \[Phi] = \(Outer[
                    Times, #, #] &\) /@ \((ny\/nm)\); \
\[IndentingNewLine]Table[
              tt = Plus @@ \(Plus @@ \((gt\[LeftDoubleBracket]
                          i\[RightDoubleBracket]*\[Phi]\[LeftDoubleBracket]
                          i\[RightDoubleBracket])\)\); 
              wb = Plus @@ tt; \[IndentingNewLine]nnm = 
                F\[LeftDoubleBracket]i, 
                    1\[RightDoubleBracket]\ \ \(wb\^F\[LeftDoubleBracket]i, 
                        2\[RightDoubleBracket]\) \(nm\[LeftDoubleBracket]
                        i\[RightDoubleBracket]\^\(1 - 
                        F\[LeftDoubleBracket]i, 3\[RightDoubleBracket]\)\) 
                  Exp[\(-\ 
                        nm\[LeftDoubleBracket]
                          i\[RightDoubleBracket]\)\ F\[LeftDoubleBracket]i, 
                        4\[RightDoubleBracket]]; \[IndentingNewLine]rnm = 
                Max[1, Round[nnm]]; \[IndentingNewLine]Append[
                If[rd, RandomMultinomial[rnm, tt\/wb]/rnm, tt\/wb], nnm], {i, 
                Length[\[Psi]]}])\)], {{nn, _Real, 1}, {nm, _Real, 
            1}, {wb, _Real}, {tt, _Real, 1}, {y, _Real, 2}, {ny, _Real, 
            2}, {\[Phi], _Real, 
            3}, {i, _Integer}, {RandomMultinomial[_, _], _Integer, 
            1}, {rnm, _Integer}, {nnm, _Real}}];\)\)

\!\(\(IterateCompiled[cline, USM] = 
      Compile[{{\[Psi], _Real, 2}, {nl, _Real, 1}, {gt, _Real, 4}, 
          m, {fe0, _Real, 1}, {fe1, _Real, 1}, n0, 
          n1, {F, _Real, 2}, {rd, True | False}}, 
        Module[{\[Phi], n\[Phi], nn, nm, rnm, wb, ny, y, y0, y1, tt, 
            nd = Length[\[Psi]], 
            newy}, \((\[Phi] = \(Outer[
                    Times, #, #] &\) /@ \[Psi]; \[IndentingNewLine]y = 
              Table[Plus @@ \(Plus @@ \((gt\[LeftDoubleBracket]
                          i\[RightDoubleBracket]*\[Phi]\[LeftDoubleBracket]
                          i\[RightDoubleBracket])\)\), {i, nd}]; 
            nn = Table[
                wb = Plus @@ y\[LeftDoubleBracket]i\[RightDoubleBracket]; 
                F\[LeftDoubleBracket]i, 
                    1\[RightDoubleBracket]\ \ \(nl\[LeftDoubleBracket]
                        i\[RightDoubleBracket]\^\(1 - 
                        F\[LeftDoubleBracket]i, 
                          3\[RightDoubleBracket]\)\) \(wb\^F\
\[LeftDoubleBracket]i, 2\[RightDoubleBracket]\) 
                  Exp[\(-\ 
                        nl\[LeftDoubleBracket]
                          i\[RightDoubleBracket]\)\ F\[LeftDoubleBracket]i, 
                        4\[RightDoubleBracket]], {i, 
                  nd}]; \[IndentingNewLine]y = 
              Table[If[
                  rd, \[IndentingNewLine]rnm = 
                    Max[1, Round[
                        nn\[LeftDoubleBracket]
                          i\[RightDoubleBracket]]]; \
\[IndentingNewLine]RandomMultinomial[rnm, 
                      y\[LeftDoubleBracket]i\[RightDoubleBracket]\/Plus @@ y\
\[LeftDoubleBracket]i\[RightDoubleBracket]]/
                    rnm, \[IndentingNewLine]y\[LeftDoubleBracket]i\
\[RightDoubleBracket]\/Plus @@ y\[LeftDoubleBracket]i\[RightDoubleBracket]], \
{i, nd}]; \[IndentingNewLine]newy = 
              Prepend[Append[y, If[Length[fe1] == 0, Last[y], fe1]], 
                If[Length[fe0] == 0, First[y], fe0]]; \[IndentingNewLine]nm = 
              Prepend[Append[nn, If[Length[fe1] == 0, Last[nn], n1]], 
                If[Length[fe0] == 0, First[nn], n0]]; \[IndentingNewLine]ny = 
              newy*nm; \[IndentingNewLine]nm = 
              Drop[Drop[\((1 - m)\) 
                      nm + \(m\/2\) \((RotateLeft[nm] + RotateRight[nm])\), 
                  1], \(-1\)]; \[IndentingNewLine]y = 
              Drop[Drop[\((1 - m)\) 
                        ny + \(m\/2\) \((RotateLeft[ny] + RotateRight[ny])\), 
                    1], \(-1\)]/nm; \[IndentingNewLine]Table[
              Append[y\[LeftDoubleBracket]i\[RightDoubleBracket], 
                nm\[LeftDoubleBracket]i\[RightDoubleBracket]], {i, 
                nd}])\)], \[IndentingNewLine]{{nn, _Real, 1}, {nm, _Real, 
            1}, {rnm, _Integer}, {wb, _Real}, {y, _Real, 2}, {newy, _Real, 
            2}, {ny, _Real, 2}, {tt, _Real, 1}, {\[Phi], _Real, 
            3}, {n\[Phi], _Real, 
            3}, {i, _Integer}, {RandomMultinomial[_, _], _Integer, 
            1}, {rnm, _Integer}, {nnm, _Real}}];\)\)



\!\(\(IterateCompiled[ww_, cline, UMS] := 
      Module[{fw}, \[IndentingNewLine]fw[p_, d_] := 
          Flatten[\(ww[d]\)[p]]; \[IndentingNewLine]IterateCompiled[ww, 
            cline, UMS] = 
          Compile[{{\[Psi], _Real, 2}, {nl, _Real, 1}, 
              m, {fe0, _Real, 1}, {fe1, _Real, 1}, n0, 
              n1, {F, _Real, 2}, {rd, True | False}}, 
            Module[{n\[Phi], nn, np, tt, i, nm, wb, rnm, nnm, 
                wv, \[Psi]n}, \[IndentingNewLine]\[Psi]n = 
                Prepend[
                  Append[\[Psi], \[IndentingNewLine]If[Length[fe1] == 0, 
                      Last[\[Psi]], fe1]], 
                  If[Length[fe0] == 0, First[\[Psi]], fe0]]; 
              nn = Prepend[
                  Append[nl, \[IndentingNewLine]If[Length[fe1] == 0, 
                      Last[nl], n1]], If[Length[fe0] == 0, First[nl], n0]]; 
              n\[Phi] = nn*\[Psi]n; \[IndentingNewLine]n\[Phi] = 
                Drop[Drop[\((1 - m)\) 
                        n\[Phi] + \(m\/2\) \((RotateLeft[n\[Phi]] + 
                            RotateRight[n\[Phi]])\), 
                    1], \(-1\)]; \ \[IndentingNewLine]nm = 
                Drop[Drop[\((1 - m)\) 
                        nn + \(m\/2\) \((RotateLeft[nn] + RotateRight[nn])\), 
                    1], \(-1\)]; 
              Table[np = 
                  n\[Phi]\[LeftDoubleBracket]i\[RightDoubleBracket]\/nm\
\[LeftDoubleBracket]i\[RightDoubleBracket]; wv = fw[np, i]; 
                wb = wv\[LeftDoubleBracket]1\[RightDoubleBracket]; \
\[IndentingNewLine]np = 
                  np \((1 + \((1 - np)\) 
                          Drop[wv, 1]\/wb)\); \[IndentingNewLine]nnm = 
                  F\[LeftDoubleBracket]i, 
                      1\[RightDoubleBracket]\ \ \(nm\[LeftDoubleBracket]
                          i\[RightDoubleBracket]\^\(1 - 
                          F\[LeftDoubleBracket]i, 
                            3\[RightDoubleBracket]\)\) \(wb\^F\
\[LeftDoubleBracket]i, 2\[RightDoubleBracket]\) 
                    Exp[\(-\ 
                          nm\[LeftDoubleBracket]
                            i\[RightDoubleBracket]\)\ F\[LeftDoubleBracket]i, 
                          4\[RightDoubleBracket]]; \[IndentingNewLine]Append[
                  If[rd, \[IndentingNewLine]rnm = 
                      Max[1, Round[
                          nnm]]; \[IndentingNewLine]\((\(First[
                              RandomMultinomial[rnm, {#, 1 - #}]] &\) /@ 
                          np)\)/rnm, \[IndentingNewLine]np], nnm], {i, 
                  Length[\[Psi]]}]], \n\t\t{{\[Psi]n, _Real, 2}, {wv, _Real, 
                1}, {nm, _Real, 1}, {wb, _Real}, {nn, _Real, 
                1}, {np, _Real}, {n\[Phi], _Real, 
                3}, {i, _Integer}, {RandomMultinomial[_, _], _Integer, 
                1}, {rnm, _Integer}, {nnm, _Real}, {fw[_, _], _Real, 
                1}}]];\)\)

IterateCompiled[ww_,cline,MUS]:=IterateCompiled[ww,cline,UMS];

\!\(\(IterateCompiled[ww_, cline, USM] := 
      Module[{fw}, \[IndentingNewLine]fw[p_, d_] := 
          Flatten[\(ww[d]\)[p]]; \[IndentingNewLine]IterateCompiled[ww, 
            cline, USM] = 
          Compile[{{\[Phi], _Real, 2}, {nl, _Real, 1}, 
              m, {fe0, _Real, 1}, {fe1, _Real, 1}, n0, 
              n1, {F, _Real, 2}, {rd, True | False}}, 
            Module[{n\[Phi], nn, nm, rnm, ny, y, y0, y1, tt, 
                nd = Length[\[Phi]], newy, 
                wvl}, \((wvl = 
                  Table[fw[\[Phi]\[LeftDoubleBracket]i\[RightDoubleBracket], 
                      i], {i, nd}]; \[IndentingNewLine]y = 
                  Table[\[Phi]\[LeftDoubleBracket]
                        i\[RightDoubleBracket] \((1 + \((1 - \[Phi]\
\[LeftDoubleBracket]i\[RightDoubleBracket])\) 
                            Drop[wvl\[LeftDoubleBracket]i\[RightDoubleBracket]\
, 1]\/wvl\[LeftDoubleBracket]i, 1\[RightDoubleBracket])\), {i, 
                      nd}]; \[IndentingNewLine]nn = 
                  Table[F\[LeftDoubleBracket]i, 
                        1\[RightDoubleBracket]\ \ \(nl\[LeftDoubleBracket]
                            i\[RightDoubleBracket]\^\(1 - 
                            F\[LeftDoubleBracket]i, 
                              3\[RightDoubleBracket]\)\) \(wvl\
\[LeftDoubleBracket]i, 1\[RightDoubleBracket]\^F\[LeftDoubleBracket]i, 
                            2\[RightDoubleBracket]\) 
                      Exp[\(-\ 
                            nl\[LeftDoubleBracket]
                              i\[RightDoubleBracket]\)\ F\[LeftDoubleBracket]
                            i, 4\[RightDoubleBracket]], {i, 
                      nd}]; \[IndentingNewLine]y = 
                  Table[If[
                      rd, \[IndentingNewLine]rnm = 
                        Max[1, 
                          Round[nn\[LeftDoubleBracket]
                              i\[RightDoubleBracket]]]; \
\[IndentingNewLine]\((\(First[RandomMultinomial[rnm, {#, 1 - #}]] &\) /@ 
                            y\[LeftDoubleBracket]i\[RightDoubleBracket])\)/
                        rnm, \[IndentingNewLine]y\[LeftDoubleBracket]
                        i\[RightDoubleBracket]], {i, 
                      nd}]; \[IndentingNewLine]newy = 
                  Prepend[Append[y, If[Length[fe1] == 0, Last[y], fe1]], 
                    If[Length[fe0] == 0, First[y], 
                      fe0]]; \[IndentingNewLine]nm = 
                  Prepend[Append[nn, If[Length[fe1] == 0, Last[nn], n1]], 
                    If[Length[fe0] == 0, First[nn], 
                      n0]]; \[IndentingNewLine]ny = 
                  newy*nm; \[IndentingNewLine]nm = 
                  Drop[Drop[\((1 - m)\) 
                          nm + \(m\/2\) \((RotateLeft[nm] + 
                              RotateRight[nm])\), 
                      1], \(-1\)]; \[IndentingNewLine]y = 
                  Drop[Drop[\((1 - m)\) 
                            ny + \(m\/2\) \((RotateLeft[ny] + 
                                RotateRight[ny])\), 1], \(-1\)]/
                    nm; \[IndentingNewLine]Table[
                  Append[y\[LeftDoubleBracket]i\[RightDoubleBracket], 
                    nm\[LeftDoubleBracket]i\[RightDoubleBracket]], {i, 
                    nd}])\)], \[IndentingNewLine]{{nn, _Real, 1}, {nm, _Real, 
                1}, {rnm, _Integer}, {wvl, _Real, 2}, {y, _Real, 
                2}, {newy, _Real, 2}, {ny, _Real, 2}, {tt, _Real, 
                1}, {n\[Phi], _Real, 
                3}, {i, _Integer}, {RandomMultinomial[_, _], _Integer, 
                1}, {rnm, _Integer}, {nnm, _Real}, {fw[_, _], _Real, 
                1}}]];\)\)



IterateExact[\[Phi]:SymmetricNeutralHaploidFrequencies[{\[Psi]_,u_},nd_],ww_,
      m_,opts___Rule]:=Module[{i,gg,\[Psi]s,f,cr,gt,
        cQ=Compiled/.{opts}/.Options[IterateExact],
        mo=MigrationOrder/.{opts}/.Options[IterateExact],
        fe=FixedEnds/.{opts}/.Options[IterateExact],
        ng=NumberOfGenes[\[Phi]]},
      \[Psi]s=
        If[fe\[LeftDoubleBracket]1\[RightDoubleBracket]==={}\[Or]
            fe\[LeftDoubleBracket]1\[RightDoubleBracket]==={{}},
          
          MakePopulation[ng,{1,1},nd,
            NumericalModel\[Rule]SymmetricNeutralHaploidFrequencies],
          fe\[LeftDoubleBracket]1\[RightDoubleBracket]];
      If[cQ,
        f=DemeSize/.{opts}/.Options[IterateExact];
        f=f/.{((nn_?NumberQ)&)\[Rule]{nn,0,1,0},(#1&)\[Rule]{1,0,0,0},
              PowerF[r_,\[Beta]_,\[Gamma]_]\[Rule]{r,\[Beta],\[Gamma],0},
              ExponentialF[r_,\[Beta]_,\[Lambda]_]\[Rule]{r,\[Beta],
                  0,\[Lambda]},
              (PowerF|ExponentialF)[
                  r_,\[Beta]_,\[Gamma]_,\[Lambda]_]\[Rule]{r,\[Beta],\[Gamma],\
\[Lambda]},ExponentialF[r_,\[Beta]_,\[Lambda]_]\[Rule]{r,\[Beta],
                  0,\[Lambda]}};
        gt=
          GameteTable[ng,ww,NumericalModel\[Rule]SymmetricHaploidFrequencies,
            opts];
        cr=
          IterateCompiled[neutral,oneDeme,mo][\[Psi],u,nd,gt,
            m,\[Psi]s\[LeftDoubleBracket]1,
              1\[RightDoubleBracket],\[Psi]s\[LeftDoubleBracket]1,
              2\[RightDoubleBracket],\[Psi]s\[LeftDoubleBracket]2\
\[RightDoubleBracket],f];
        SymmetricNeutralHaploidFrequencies[Partition[Drop[cr,-1],ng+1],
          Last[cr]],
         Switch[mo,
          UMS,
          NewGametes[MigrateExact[MakeDiploid[\[Phi]],MakeDiploid[\[Psi]s],m],
            ww,opts],
          MUS,
          NewGametes[MakeDiploid[MigrateExact[\[Phi],\[Psi]s,m]],ww,opts],
          USM,
          MigrateExact[NewGametes[MakeDiploid[\[Phi]],ww,opts],\[Psi]s,m],
           _,Message[IterateExact::badMigrationOrder,mo];\[Phi]]]];



\!\(\(IterateCompiled[neutral, oneDeme, UMS] = 
      Compile[{{\[Psi], _Real, 1}, {u, _Real, 1}, n, {gt, _Real, 3}, 
          m, {\[Psi]s, _Real, 1}, {us, _Real, 1}, ns, {F, _Real, 1}}, \n\t
        Module[{tt, ttu, wb, nm}, \n\t
          nm = m\ ns + \((1 - m)\) 
                n; \[IndentingNewLine]tt = \((Plus @@ \(Plus @@ \((gt*\((n \
\((1 - m)\) Outer[Times, \[Psi], \[Psi]] + 
                            ns\ m\ Outer[Times, \[Psi]s, \[Psi]s])\))\)\))\)/
              nm; \n\tttu = \((Plus @@ \(Plus @@ \((gt*\((n \((1 - m)\) 
                              Outer[Times, \[Psi], \[Psi]] 
                              Outer[Plus, u, u] + 
                            ns\ m\ Outer[Times, \[Psi]s, \[Psi]s] 
                              Outer[Plus, us, us])\))\)\))\)/\((2  nm)\); \n\t
          wb = Plus @@ tt; \[IndentingNewLine]nm = 
            F\[LeftDoubleBracket]1\[RightDoubleBracket]\ \(nm\^\(1 - 
                    F\[LeftDoubleBracket]3\[RightDoubleBracket]\)\) \(wb\^F\
\[LeftDoubleBracket]2\[RightDoubleBracket]\) 
              Exp[\(-\ 
                    nm\)\ F\[LeftDoubleBracket]4\[RightDoubleBracket]]; \
\[IndentingNewLine]Append[Join[tt\/wb, DivideZero[ttu, tt]], 
            nm]], \n\t\t{{wb, _Real}, {nm, _Real}, {tt, _Real, 
            1}, {ttu, _Real, 1}, {DivideZero[_, _], _Real, 1}}];\)\)

\!\(\(IterateCompiled[neutral, oneDeme, MUS] = 
      Compile[{{\[Psi], _Real, 1}, {u, _Real, 1}, n, {gt, _Real, 3}, 
          m, {\[Psi]s, _Real, 1}, {us, _Real, 1}, 
          ns, {F, _Real, 1}}, \[IndentingNewLine]Module[{tt, ttu, wb, nm, nu, 
            ngt}, \[IndentingNewLine]nm = 
            m\ ns + \((1 - m)\) 
                n; \[IndentingNewLine]tt = \((n \((1 - m)\) \[Psi] + 
                  ns\ m\ \[Psi]s)\)/
              nm; \[IndentingNewLine]ttu = \((n \((1 - m)\) \[Psi]\ u + 
                  ns\ m\ \[Psi]s\ us)\)/nm; \[IndentingNewLine]nu = 
            DivideZero[ttu, tt]; \[IndentingNewLine]ngt = 
            gt*Outer[Times, tt, tt]; \[IndentingNewLine]tt = 
            Plus @@ \(Plus @@ 
                ngt\); \[IndentingNewLine]ttu = \((Plus @@ \(Plus @@ \((ngt*
                        Outer[Plus, nu, nu])\)\))\)/
              2; \[IndentingNewLine]wb = Plus @@ tt; \[IndentingNewLine]nm = 
            F\[LeftDoubleBracket]1\[RightDoubleBracket]\ \(nm\^\(1 - 
                    F\[LeftDoubleBracket]3\[RightDoubleBracket]\)\) \(wb\^F\
\[LeftDoubleBracket]2\[RightDoubleBracket]\) 
              Exp[\(-\ 
                    nm\)\ F\[LeftDoubleBracket]4\[RightDoubleBracket]]; \
\[IndentingNewLine]Append[Join[tt\/wb, DivideZero[ttu, tt]], 
            nm]], \n\t\t{{wb, _Real}, {nm, _Real}, {tt, _Real, 
            1}, {ttu, _Real, 1}, {ngt, _Real, 3}, {nu, _Real, 
            1}, {DivideZero[_, _], _Real, 1}}];\)\)

\!\(\(IterateCompiled[neutral, oneDeme, USM] = 
      Compile[{{\[Psi], _Real, 1}, {u, _Real, 1}, n, {gt, _Real, 3}, 
          m, {\[Psi]s, _Real, 1}, {us, _Real, 1}, 
          ns, {F, _Real, 1}}, \[IndentingNewLine]Module[{tt, ttu, wb, nn, 
            nnn, ttn}, \[IndentingNewLine]tt = 
            Plus @@ \(Plus @@ \((gt*
                    Outer[Times, \[Psi], \[Psi]])\)\); \[IndentingNewLine]ttu \
= \((Plus @@ \(Plus @@ \((gt*Outer[Times, \[Psi], \[Psi]]*
                        Outer[Plus, u, u])\)\))\)/2; \[IndentingNewLine]wb = 
            Plus @@ tt; \[IndentingNewLine]nn = 
            F\[LeftDoubleBracket]1\[RightDoubleBracket]\ \(n\^\(1 - 
                    F\[LeftDoubleBracket]3\[RightDoubleBracket]\)\) \(wb\^F\
\[LeftDoubleBracket]2\[RightDoubleBracket]\) 
              Exp[\(-\ 
                    n\)\ F\[LeftDoubleBracket]4\[RightDoubleBracket]]; \
\[IndentingNewLine]nnn = \((1 - m)\) nn + ns\ m; \[IndentingNewLine]ttn = 
            nn \((1 - m)\) tt\/wb + ns\ m\ \[Psi]s; \[IndentingNewLine]Append[
            Join[ttn\/nnn, 
              DivideZero[nn \((1 - m)\) ttu\/wb + ns\ m\ \[Psi]s\ us, ttn]], 
            nnn]], \[IndentingNewLine]{{wb, _Real}, {nn, _Real}, {nnn, \
_Real}, {tt, _Real, 1}, {ttn, _Real, 1}, {ttu, _Real, 
            1}, {DivideZero[_, _], _Real, 1}}];\)\)



IterateExact[\[Psi]:{SymmetricNeutralHaploidFrequencies[{_,_},_]..},ww_,m_,
      opts___]:=Module[{i,gg,nd=Length[\[Psi]],cr,gt,\[Psi]0,\[Psi]1,u0,u1,n0,
        n1,cQ=Compiled/.{opts}/.Options[IterateExact],
        mo=MigrationOrder/.{opts}/.Options[IterateExact],
        fe=FixedEnds/.{opts}/.Options[IterateExact],
        \[Phi],u,nl,dsrl,
        ng=NumberOfGenes[\[Psi]]},
         If[cQ,
        \[Phi]=First/@First/@\[Psi];
        u=Last/@First/@\[Psi];
        nl=Last/@\[Psi];
        f=DemeSize/.{opts}/.Options[IterateExact];
        f=f/.{((nn_?NumberQ)&)\[Rule]Array[{nn,0,1,0}&,nd],
              (#1&)\[Rule]Array[{1,0,0,0}&,nd],
              
              PowerF[r_,\[Beta]_,\[Gamma]_]\[Rule]
                Array[{r,\[Beta],\[Gamma],0}&,nd],
              ExponentialF[r_,\[Beta]_,\[Lambda]_]\[Rule]
                Array[{r,\[Beta],0,\[Lambda]}&,nd],(PowerF|ExponentialF)[
                  r_,\[Beta]_,\[Gamma]_,\[Lambda]_]\[Rule]
                Array[{r,\[Beta],\[Gamma],\[Lambda]}&,nd],
              ExponentialF[r_,\[Beta]_,\[Lambda]_]\[Rule]
                Array[{r,\[Beta],0,\[Lambda]}&,nd]};
        If[fe\[LeftDoubleBracket]1\[RightDoubleBracket]==={},
          \[Psi]0={};u0={};n0=0,
          \[Psi]0=fe\[LeftDoubleBracket]1,1,1\[RightDoubleBracket];
          u0=fe\[LeftDoubleBracket]1,1,2\[RightDoubleBracket];
          n0=fe\[LeftDoubleBracket]1,2\[RightDoubleBracket]];
        If[fe\[LeftDoubleBracket]-1\[RightDoubleBracket]==={},
          \[Psi]1={};u1={};n1=0,
          \[Psi]1=fe\[LeftDoubleBracket]-1,1,1\[RightDoubleBracket];
          u1=fe\[LeftDoubleBracket]-1,1,2\[RightDoubleBracket];
          n1=fe\[LeftDoubleBracket]-1,2\[RightDoubleBracket]];
        gt=
          Table[GameteTable[ng,ww[i],
              NumericalModel\[Rule]SymmetricNeutralHaploidFrequencies,
              opts],{i,nd}];
        cr=
          IterateCompiled[neutral,cline,mo][\[Phi],u,nl,gt,m,\[Psi]0,\[Psi]1,
            u0,u1,n0,n1,f];
        SymmetricNeutralHaploidFrequencies[Partition[Drop[#,-1],ng+1],
              Last[#]]&/@cr,
        dsrl[
            j_]:={(DemeSize\[Rule]
                  f_?(Not[ListQ[#]]&))\[RuleDelayed](DemeSize\[Rule]
                  f[j]),(DemeSize\[Rule]f_List)\[RuleDelayed](DemeSize\[Rule]
                  f\[LeftDoubleBracket]j\[RightDoubleBracket])};
        Switch[mo,
          UMS,
          
          gg=MigrateExact[MakeDiploid[\[Psi]],m,
              FixedEnds\[Rule](MakeDiploid/@fe)];
          Table[NewGametes[gg\[LeftDoubleBracket]i\[RightDoubleBracket],
                  ww[i],##]&@@({opts}/.dsrl[i]),{i,nd}],
          MUS,
          gg=MakeDiploid[MigrateExact[\[Psi],m,FixedEnds\[Rule]fe]];
          Table[NewGametes[gg\[LeftDoubleBracket]i\[RightDoubleBracket],
                  ww[i],##]&@@({opts}/.dsrl[i]),{i,nd}],
          USM,
           gg=MakeDiploid[\[Psi]];
          
          MigrateExact[
            Table[NewGametes[gg\[LeftDoubleBracket]i\[RightDoubleBracket],
                    ww[i],##]&@@({opts}/.dsrl[i]),{i,nd}],m,
            FixedEnds\[Rule]fe],
          _,
          Message[IterateExact::badMigrationOrder,mo];
          SymmetricNeutralHaploidFrequencies[\[Psi],n]]]];



\!\(\(IterateCompiled[neutral, cline, UMS] = 
      Compile[{{\[Psi], _Real, 2}, {u, _Real, 2}, {nl, _Real, 1}, {gt, _Real, 
            4}, m, {fe0, _Real, 1}, {fe1, _Real, 1}, {feU0, _Real, 
            1}, {feU1, _Real, 1}, n0, 
          n1, {F, _Real, 2}}, \[IndentingNewLine]Module[{\[Phi], \[Phi]u, 
            n\[Phi], n\[Phi]u, nn, tt, ttu, nu, i, nm, wb, 
            nnm}, \[IndentingNewLine]\[Phi] = \(Outer[
                  Times, #, #] &\) /@ \[Psi]; \[IndentingNewLine]\[Phi]u = 
            MapThread[
                Outer[Times, #1, #1] Outer[Plus, #2, #2] &, {\[Psi], u}]/
              2; \[IndentingNewLine]\[Phi] = 
            Prepend[Append[\[Phi], \[IndentingNewLine]If[Length[fe1] == 0, 
                  Last[\[Phi]], Outer[Times, fe1, fe1]]], 
              If[Length[fe0] == 0, First[\[Phi]], 
                Outer[Times, fe0, fe0]]]; \[Phi]u = 
            Prepend[Append[\[Phi]u, \[IndentingNewLine]If[Length[fe1] == 0, 
                  Last[\[Phi]u], 
                  Outer[Times, fe1, fe1] Outer[Plus, feU1, feU1]/2]], 
              If[Length[fe0] == 0, First[\[Phi]u], 
                Outer[Times, fe0, fe0] Outer[Plus, feU0, feU0]/2]]; 
          nn = Prepend[
              Append[nl, \[IndentingNewLine]If[Length[fe1] == 0, Last[nl], 
                  n1]], \[IndentingNewLine]If[Length[fe0] == 0, First[nl], 
                n0]]; \[IndentingNewLine]n\[Phi] = nn*\[Phi]; 
          n\[Phi]u = nn*\[Phi]u; \[IndentingNewLine]n\[Phi] = 
            Drop[Drop[\((1 - m)\) 
                    n\[Phi] + \(m\/2\) \((RotateLeft[n\[Phi]] + 
                        RotateRight[n\[Phi]])\), 
                1], \(-1\)]; \ \[IndentingNewLine]n\[Phi]u = 
            Drop[Drop[\((1 - m)\) 
                    n\[Phi]u + \(m\/2\) \((RotateLeft[n\[Phi]u] + 
                        RotateRight[n\[Phi]u])\), 
                1], \(-1\)]; \ \[IndentingNewLine]nm = 
            Drop[Drop[\((1 - m)\) 
                    nn + \(m\/2\) \((RotateLeft[nn] + RotateRight[nn])\), 
                1], \(-1\)]; 
          nu = MapThread[DivideZero[#1, #2] &, {n\[Phi]u, n\[Phi]}, 
              2]; \[IndentingNewLine]Table[\[IndentingNewLine]tt = \((Plus @@ \
\(Plus @@ \((gt\[LeftDoubleBracket]i\[RightDoubleBracket]*
                          n\[Phi]\[LeftDoubleBracket]
                            i\[RightDoubleBracket])\)\))\)/
                nm\[LeftDoubleBracket]
                  i\[RightDoubleBracket]; \[IndentingNewLine]ttu = \((Plus @@ \
\(Plus @@ \((gt\[LeftDoubleBracket]i\[RightDoubleBracket]*
                          n\[Phi]\[LeftDoubleBracket]i\[RightDoubleBracket]*
                          nu\[LeftDoubleBracket]
                            i\[RightDoubleBracket])\)\))\)/
                nm\[LeftDoubleBracket]
                  i\[RightDoubleBracket]; \[IndentingNewLine]wb = 
              Plus @@ tt; \[IndentingNewLine]nnm = 
              F\[LeftDoubleBracket]i, 
                  1\[RightDoubleBracket]\ \ \(nm\[LeftDoubleBracket]i\
\[RightDoubleBracket]\^\(1 - 
                      F\[LeftDoubleBracket]i, 
                        3\[RightDoubleBracket]\)\) \
\(wb\^F\[LeftDoubleBracket]i, 2\[RightDoubleBracket]\) 
                Exp[\(-\ 
                      nm\[LeftDoubleBracket]i\[RightDoubleBracket]\)\ F\
\[LeftDoubleBracket]i, 4\[RightDoubleBracket]]; \[IndentingNewLine]Append[
              Join[tt\/wb, DivideZero[ttu, tt]], nnm], \[IndentingNewLine]{i, 
              Length[\[Psi]]}]], \n\t\t{{tt, _Real, 1}, {ttu, _Real, 
            1}, {nm, _Real, 1}, {wb, _Real}, {nn, _Real, 1}, {\[Phi], _Real, 
            3}, {\[Phi]u, _Real, 3}, {nu, _Real, 3}, {n\[Phi], _Real, 
            3}, {n\[Phi]u, _Real, 
            3}, {i, _Integer}, {nnm, _Real}, {DivideZero[_, _], _Real, 
            1}}];\)\)

\!\(\(IterateCompiled[neutral, cline, MUS] = 
      Compile[{{\[Psi], _Real, 2}, {u, _Real, 2}, {nl, _Real, 1}, {gt, _Real, 
            4}, m, {fe0, _Real, 1}, {fe1, _Real, 1}, {feU0, _Real, 
            1}, {feU1, _Real, 1}, n0, 
          n1, {F, _Real, 2}}, \[IndentingNewLine]Module[{\[Phi], \[Phi]u, y, 
            yu = \[Psi]*u, ny, nyu, nn, nm, nnm, tt, ttu, 
            wb}, \[IndentingNewLine]\((y = 
              Prepend[Append[\[Psi], \[IndentingNewLine]If[Length[fe1] == 0, 
                    Last[\[Psi]], fe1]], \[IndentingNewLine]If[
                  Length[fe0] == 0, First[\[Psi]], 
                  fe0]]; \[IndentingNewLine]yu = 
              Prepend[Append[
                  yu, \[IndentingNewLine]If[Length[fe1] == 0, Last[yu], 
                    fe1*feU1]], \[IndentingNewLine]If[Length[fe0] == 0, 
                  First[yu], fe0*feU0]]; \[IndentingNewLine]nn = 
              Prepend[Append[
                  nl, \[IndentingNewLine]If[Length[fe1] == 0, Last[nl], 
                    n1]], \[IndentingNewLine]If[Length[fe0] == 0, First[nl], 
                  n0]]; \[IndentingNewLine]ny = nn*y; 
            nyu = nn*yu; \[IndentingNewLine]ny = 
              Drop[Drop[\((1 - m)\) 
                      ny + \(m\/2\) \((RotateLeft[ny] + RotateRight[ny])\), 
                  1], \(-1\)]; \ 
            nyu = Drop[
                Drop[\((1 - m)\) 
                      nyu + \(m\/2\) \((RotateLeft[nyu] + 
                          RotateRight[nyu])\), 1], \(-1\)]; \ 
            nm = Drop[
                Drop[\((1 - m)\) 
                      nn + \(m\/2\) \((RotateLeft[nn] + RotateRight[nn])\), 
                  1], \(-1\)]; \ 
            ny = ny/nm; \[IndentingNewLine]nyu = 
              MapThread[
                DivideZero[#1, #2] &, {nyu, 
                  ny}]; \[IndentingNewLine]\[Phi] = \(Outer[Times, #, #] &\) /@ 
                ny; \[IndentingNewLine]\[Phi]u = 
              MapThread[
                Outer[Times, #1, #1] Outer[Plus, #2, #2]\/2 &, {ny, 
                  nyu}]; \[IndentingNewLine]Table[\[IndentingNewLine]tt = 
                Plus @@ \(Plus @@ \((gt\[LeftDoubleBracket]
                          i\[RightDoubleBracket]*\[Phi]\[LeftDoubleBracket]
                          i\[RightDoubleBracket])\)\); \[IndentingNewLine]ttu \
= Plus @@ \(Plus @@ \((gt\[LeftDoubleBracket]
                          i\[RightDoubleBracket]*\[Phi]u\[LeftDoubleBracket]
                          i\[RightDoubleBracket])\)\); \[IndentingNewLine]wb \
= Plus @@ tt; \[IndentingNewLine]nnm = 
                F\[LeftDoubleBracket]i, 
                    1\[RightDoubleBracket]\ \ \(wb\^F\[LeftDoubleBracket]i, 
                        2\[RightDoubleBracket]\) \(nm\[LeftDoubleBracket]
                        i\[RightDoubleBracket]\^\(1 - 
                        F\[LeftDoubleBracket]i, 3\[RightDoubleBracket]\)\) 
                  Exp[\(-\ 
                        nm\[LeftDoubleBracket]
                          i\[RightDoubleBracket]\)\ F\[LeftDoubleBracket]i, 
                        4\[RightDoubleBracket]]; \[IndentingNewLine]Append[
                Join[tt\/wb, DivideZero[ttu, tt]], nnm], {i, 
                Length[\[Psi]]}])\)], {{nn, _Real, 1}, {nm, _Real, 
            1}, {wb, _Real}, {tt, _Real, 1}, {ttu, _Real, 1}, {y, _Real, 
            2}, {yu, _Real, 2}, {ny, _Real, 2}, {nyu, _Real, 
            2}, {\[Phi], _Real, 3}, {\[Phi]u, _Real, 
            3}, {i, _Integer}, {DivideZero[_, _], _Real, 
            1}, {nnm, _Real}}];\)\)

\!\(\(IterateCompiled[neutral, cline, USM] = 
      Compile[{{\[Psi], _Real, 2}, {u, _Real, 2}, {nl, _Real, 1}, {gt, _Real, 
            4}, m, {fe0, _Real, 1}, {fe1, _Real, 1}, {feU0, _Real, 
            1}, {feU1, _Real, 1}, n0, n1, {F, _Real, 2}}, 
        Module[{\[Phi], n\[Phi], nn, nu, nm, rnm, wb, ny, y, yu, nyu, y0, y1, 
            tt, nd = Length[\[Psi]], newy, 
            newyu}, \[IndentingNewLine]\((\[Phi] = \(Outer[
                    Times, #, #] &\) /@ \[Psi]; 
            nu = \(Outer[Plus, #, #]\/2 &\) /@ u; \[IndentingNewLine]y = 
              Table[Plus @@ \(Plus @@ \((gt\[LeftDoubleBracket]
                          i\[RightDoubleBracket]*\[Phi]\[LeftDoubleBracket]
                          i\[RightDoubleBracket])\)\), {i, nd}]; 
            yu = Table[
                Plus @@ \(Plus @@ \((gt\[LeftDoubleBracket]
                          i\[RightDoubleBracket]*\[Phi]\[LeftDoubleBracket]
                          i\[RightDoubleBracket]*
                        nu\[LeftDoubleBracket]
                          i\[RightDoubleBracket])\)\), {i, 
                  nd}]; \[IndentingNewLine]yu = 
              DivideZero[yu, y]; \[IndentingNewLine]nn = 
              Table[\[IndentingNewLine]wb = 
                  Plus @@ y\[LeftDoubleBracket]
                      i\[RightDoubleBracket]; \[IndentingNewLine]F\
\[LeftDoubleBracket]i, 
                    1\[RightDoubleBracket]\ \ \(nl\[LeftDoubleBracket]
                        i\[RightDoubleBracket]\^\(1 - 
                        F\[LeftDoubleBracket]i, 
                          3\[RightDoubleBracket]\)\) \(wb\^F\
\[LeftDoubleBracket]i, 2\[RightDoubleBracket]\) 
                  Exp[\(-\ 
                        nl\[LeftDoubleBracket]
                          i\[RightDoubleBracket]\)\ F\[LeftDoubleBracket]i, 
                        4\[RightDoubleBracket]], {i, 
                  nd}]; \[IndentingNewLine]y = 
              Table[y\[LeftDoubleBracket]i\[RightDoubleBracket]\/Plus @@ y\
\[LeftDoubleBracket]i\[RightDoubleBracket], {i, 
                  nd}]; \[IndentingNewLine]newy = 
              Prepend[Append[
                  y, \[IndentingNewLine]If[Length[fe1] == 0, Last[y], 
                    fe1]], \[IndentingNewLine]If[Length[fe0] == 0, First[y], 
                  fe0]]; \[IndentingNewLine]newyu = 
              Prepend[Append[
                  yu, \[IndentingNewLine]If[Length[fe1] == 0, Last[yu], 
                    feU1]], \[IndentingNewLine]If[Length[fe0] == 0, 
                  First[yu], feU0]]; \[IndentingNewLine]nm = 
              Prepend[Append[
                  nn, \[IndentingNewLine]If[Length[fe1] == 0, Last[nn], 
                    n1]], \[IndentingNewLine]If[Length[fe0] == 0, First[nn], 
                  n0]]; \[IndentingNewLine]ny = newy*nm; 
            nyu = newy*newyu*nm; \[IndentingNewLine]nm = 
              Drop[Drop[\((1 - m)\) 
                      nm + \(m\/2\) \((RotateLeft[nm] + RotateRight[nm])\), 
                  1], \(-1\)]; \[IndentingNewLine]y = 
              Drop[Drop[\((1 - m)\) 
                      ny + \(m\/2\) \((RotateLeft[ny] + RotateRight[ny])\), 
                  1], \(-1\)]; \[IndentingNewLine]yu = 
              DivideZero[
                Drop[Drop[\((1 - m)\) 
                        nyu + \(m\/2\) \((RotateLeft[nyu] + 
                            RotateRight[nyu])\), 1], \(-1\)], 
                y]; \[IndentingNewLine]y = y/nm; \[IndentingNewLine]Table[
              Append[Join[y\[LeftDoubleBracket]i\[RightDoubleBracket], 
                  yu\[LeftDoubleBracket]i\[RightDoubleBracket]], 
                nm\[LeftDoubleBracket]i\[RightDoubleBracket]], {i, 
                nd}])\)], \[IndentingNewLine]{{nn, _Real, 1}, {nm, _Real, 
            1}, {rnm, _Integer}, {wb, _Real}, {y, _Real, 2}, {yu, _Real, 
            2}, {nyu, _Real, 2}, {newy, _Real, 2}, {newyu, _Real, 
            2}, {ny, _Real, 2}, {tt, _Real, 1}, {\[Phi], _Real, 
            3}, {nu, _Real, 3}, {n\[Phi], _Real, 
            3}, {i, _Integer}, {DivideZero[_, _], _Real, 
            2}, {rnm, _Integer}, {nnm, _Real}}];\)\)



Options[StoreExact]={SymmetricCline\[Rule]False,FixedEnds\[Rule]{{},{}}};

StoreExact::usage=
    "StoreExact[\[Psi],\[Psi]0,W,m,{t,dt}] stores results at intervals dt in \
\[Psi][t], starting with \[Psi]0.  \[Psi]0 can represent a single population \
or a cline.  The options Compiled, FixedEnds, DemeSize and MigrationOrder can \
be used, as for IterateExact. NumericalModel specifies the representation. \
SymmetricCline\[Rule]True simulates a symmetric cline more efficiently.";

StoreExact[\[Psi]_,\[Psi]0:PopulationRepresentations[_,_],ww_,m_,{t_,dt_},
      opts___Rule]:=
    
    Module[{tt=0,fe=FixedEnds/.{opts}/.Options[StoreExact]},
      \[Psi][0]=\[Psi]0;
      While[tt+dt<t,
        \[Psi][tt+dt]=Nest[IterateExact[#,ww,m,opts]&,\[Psi][tt],dt];tt+=dt];
      	\[Psi][t]=Nest[IterateExact[#,ww,m,opts]&,\[Psi][tt],t-tt]];

StoreExact[\[Psi]_,\[Psi]0:{PopulationRepresentations[_,_]..},ww_,m_,{t_,dt_},
      opts___Rule]:=Module[{\[Psi]t,ff,tt=0,nd2=Ceiling[nd/2],optsNF,
	eQ=EvenQ[Length[\[Psi]0]],
	sQ=SymmetricCline/.{opts}/.Options[StoreExact],
	fe=FixedEnds/.{opts}/.Options[StoreExact],nfe},
	optsNF=Sequence@@({opts}/.{{a___,FixedEnds\[Rule]_,b___}:>{a,b}});
	\[Psi][0]=\[Psi]0;
      If[sQ,
        nfe=
          If[eQ,\[Psi]t\[LeftDoubleBracket]-1\[RightDoubleBracket],\[Psi]t\
\[LeftDoubleBracket]-2\[RightDoubleBracket]]/.{(pr:
                      NeutralRepresentations)[{\[Phi]_List,u_List},
                  n_]\[RuleDelayed]pr[{Reverse[\[Phi]],Reverse[u]},
                  n],(pr:NonNeutralRepresentations)[\[Phi]_List,
                  n_]\[RuleDelayed]pr[Reverse[\[Phi]],n]};
        ff[g_]:=(\[Psi]t=Take[g,nd2];
            DoubleCline[
              IterateExact[\[Psi]t,ww,m,optsNF,
                FixedEnds\[Rule]{fe\[LeftDoubleBracket]1\[RightDoubleBracket],
                    nfe}],eQ]),
        	ff[g_]:=IterateExact[g,ww,m,opts]];
      	While[tt+dt<t,\[Psi][tt+dt]=Nest[ff,\[Psi][tt],dt];tt+=dt];
      	\[Psi][t]=Nest[ff,\[Psi][tt],t-tt]];
(* needs rewriting for AlleleFrequencies etc *)

StoreNeutral[\[Psi]_,ww_,m_,{t_,dt_},{nd_,ng_,dp___},opts___]:=
	
    Module[{\[Psi]t,ff,tt=0,nd2=Ceiling[(nd+1)/2],optsNF,
			eQ=EvenQ[nd],
			sQ=SymmetricCline/.{opts}/.Options[StoreExact],
			fe=FixedEnds/.{opts}/.Options[StoreExact]},
	  optsNF=opts/.{{a___,FixedEnds\[Rule]_,b___}:>{a,b}};
	   \[Psi][0]=InitialiseDemes[nd,ng,dp,opts,Neutral\[Rule]True];
		If[sQ,
			   ff[g_]:=(\[Psi]t=Take[g,nd2];
            DoubleCline[
              IterateNeutral[\[Psi]t,ww,m,optsNF,
                FixedEnds\[Rule]{fe\[LeftDoubleBracket]1\[RightDoubleBracket],
                    Reverse/@
                      If[eQ,g\[LeftDoubleBracket]-1\[RightDoubleBracket],
                        g\[LeftDoubleBracket]-2\[RightDoubleBracket]]}],eQ]),
			   ff[g_]:=IterateNeutral[g,ww,m,opts]];
	While[tt+dt<t,\[Psi][tt+dt]=Nest[ff,\[Psi][tt],dt];tt+=dt];
	\[Psi][t]=Nest[ff,\[Psi][tt],t-tt]];



MidParent[u_]:=Outer[Plus,u,u]/2;



ClassToGenotypes::badList=
    "`1` is not an appropriate argument for ClassToGenotypes";

ClassToGenotypes[SymmetricHaploidFrequencies[\[Psi]_,n_],opts___Rule]:=
    HaploidFrequencies[ClassToGenotypes[\[Psi],opts],n];
ClassToGenotypes[SymmetricDiploidFrequencies[\[Psi]_,n_],opts___Rule]:=
    DiploidFrequencies[ClassToGenotypes[\[Psi],opts],n];
ClassToGenotypes[\[Psi]:{(SymmetricHaploidFrequencies|
                  SymmetricDiploidFrequencies)[_,_]..},opts___Rule]:=
    ClassToGenotypes[#,opts]&/@\[Psi];

ClassToGenotypes[g_List,opts___Rule]:=
    Module[{n=Length[g]-1,i,j,dt,ht},
      ht=HaploidTypes[n,opts];
      Switch[TensorRank[g],
        1,
        ht/.{{a___Integer}:>(i=Plus[a];
                g\[LeftDoubleBracket]i+1\[RightDoubleBracket]/
                  Binomial[n,i])},
        2,
        dt=Outer[List,ht,ht,1];
        dt/.{{{a___Integer},{b___Integer}}:>(i=Plus[a];j=Plus[b];
                g\[LeftDoubleBracket]i+1,
                    j+1\[RightDoubleBracket]/(Binomial[n,i]Binomial[n,j]))},
        _,
        Message[ClassToGenotypes::badList,g];Indeterminate]];



GenotypePosition[X_,opts___Rule]:=
    Position[HaploidTypes[Length[X],opts],X]\[LeftDoubleBracket]1,
      1\[RightDoubleBracket];



\!\(\(\(ExponentialF[r_, \[Beta]_, \[Lambda]_]\)[n_, wb_]\  := \ 
      r\[VeryThinSpace]\ n\ \[VeryThinSpace]\(wb\^\[Beta]\) 
        Exp[\(-\[Lambda]\)\[VeryThinSpace]n];\)\[IndentingNewLine]
  \(\(ExponentialF[r_, \[Beta]_, \[Gamma]_, \[Lambda]_]\)[n_, wb_]\  := \ 
      r\[VeryThinSpace]\ n\^\(1 - \[Gamma]\)\ \[VeryThinSpace]\(wb\^\[Beta]\) 
        Exp[\(-\[Lambda]\)\[VeryThinSpace]n];\)\)

\!\(\(\(\(ExponentialF[r_, \[Beta]_, \[Lambda]_]\)[_]\)[n_, wb_]\  := \ 
      r\[VeryThinSpace]\ n\ \[VeryThinSpace]\(wb\^\[Beta]\) 
        Exp[\(-\[Lambda]\)\[VeryThinSpace]n];\)\[IndentingNewLine]
  \(\(\(ExponentialF[r_, \[Beta]_, \[Gamma]_, \[Lambda]_]\)[_]\)[n_, 
        wb_]\  := \ 
      r\[VeryThinSpace]\ n\^\(1 - \[Gamma]\)\ \[VeryThinSpace]\(wb\^\[Beta]\) 
        Exp[\(-\[Lambda]\)\[VeryThinSpace]n];\)\)



\!\(\(\(PowerF[r_, \[Beta]_, \[Gamma]_]\)[n_, wb_]\  := \ 
      r\[VeryThinSpace]\ n\^\(1 - \[Gamma]\)\ \[VeryThinSpace]wb\^\[Beta];\)\
\[IndentingNewLine]
  \(\(PowerF[r_, \[Beta]_, \[Gamma]_, \[Lambda]_]\)[n_, wb_]\  := \ 
      r\[VeryThinSpace]\ n\^\(1 - \[Gamma]\)\ \[VeryThinSpace]\(wb\^\[Beta]\) 
        Exp[\(-\[Lambda]\)\[VeryThinSpace]n];\)\)

\!\(\(\(\(PowerF[r_, \[Beta]_, \[Gamma]_]\)[_]\)[n_, wb_]\  := \ 
      r\[VeryThinSpace]\ n\^\(1 - \[Gamma]\)\ \[VeryThinSpace]wb\^\[Beta];\)\
\[IndentingNewLine]
  \(\(\(PowerF[r_, \[Beta]_, \[Gamma]_, \[Lambda]_]\)[_]\)[n_, wb_]\  := \ 
      r\[VeryThinSpace]\ n\^\(1 - \[Gamma]\)\ \[VeryThinSpace]\(wb\^\[Beta]\) 
        Exp[\(-\[Lambda]\)\[VeryThinSpace]n];\)\)





StabilityMatrix[a_,n_Integer]:=
    StabilityMatrix[a,n]=
      Outer[a[Plus@@#1,Plus@@#2,CountHeterozygotes[#1,#2]]&,
        HaploidTypes[n,SortByClass\[Rule]True],
        HaploidTypes[n,SortByClass\[Rule]True],1];



Options[StabilityK]={MigrationOrder\[Rule]UMS,FixedEnds\[Rule]{{},{}}};

StabilityK[k_,i_,h_,\[Psi]_SymmetricHaploidFrequencies,W_,opts___Rule]:=
    StabilityK[k,i,h,\[Psi],\[Psi],W,opts];

\!\(\(StabilityK[k_, i_, 
        h_, \[Psi] : SymmetricHaploidFrequencies[g_List, nd_], \[Psi]\[Psi] : 
          SymmetricHaploidFrequencies[gg_List, ndnd_], W_, 
        opts___Rule] := \[IndentingNewLine]Module[\[IndentingNewLine]{q, 
          l = Quotient[i + k - h, 2], 
          n = Length[g] - 1, \[IndentingNewLine]mW = 
            MarginalW[MakeDiploid[\[Psi]\[Psi]], W, 
              opts]}, \[IndentingNewLine]Sum[
            gg\[LeftDoubleBracket]j + 
                  1\[RightDoubleBracket] \(2\^\(\(-i\) - j\)\) 
              Sum[\(4\^q\) Binomial[l, q] 
                    Binomial[n - i - k + l, j - q - k + l] 
                    W[i, j, i + j - 2  q], {q, Max[0, i + j - n], 
                    Min[j - k + l, l]}]/Binomial[n, j], {j, k - l, 
              n - i + l}] - \(g\[LeftDoubleBracket]k + 1\[RightDoubleBracket] \
mW\[LeftDoubleBracket]i + 1\[RightDoubleBracket]\)\/Binomial[n, k]];\)\)

\!\(\(StabilityK[k_, i_, 
        h_, \[Psi] : {SymmetricHaploidFrequencies[_, _] .. }, W_, m_, 
        opts___Rule] := 
      Module[{ff, q, nd = Length[\[Psi]], mW, dm, wb, \[Psi]m, offD, trd, j, 
          l, fe = \(FixedEnds /. {opts}\) /. 
              Options[StabilityK], \[IndentingNewLine]mo = \(MigrationOrder /. \
{opts}\) /. Options[StabilityK]}, 
        offD[{g1_, g2_}, j_, {q0_, q1_}] := \[IndentingNewLine]Table[\ 
            StabilityK[k, i, h, g1\[LeftDoubleBracket]q\[RightDoubleBracket], 
                g2\[LeftDoubleBracket]q + j\[RightDoubleBracket], W[q], opts]/
              wb\[LeftDoubleBracket]q\[RightDoubleBracket], {q, q0, q1}]; \ 
        trd[gl_, kk_, rQ_] := \ 
          TridiagonalMatrix[\[IndentingNewLine]\ 
            m\ offD[gl, kk, 
                If[rQ, {1, nd - 1}, {2, nd}]], \[IndentingNewLine]dm = 
              2 \((1 - m)\) offD[gl, 0, {1, nd}]; \[IndentingNewLine]If[
              fe\[LeftDoubleBracket]1\[RightDoubleBracket] === {} || 
                fe\[LeftDoubleBracket]1\[RightDoubleBracket] === {{}}, 
              dm\[LeftDoubleBracket]1\[RightDoubleBracket] = 
                dm\[LeftDoubleBracket]1\[RightDoubleBracket] \(1 - m/2\)\/\(1 \
- m\)]; \[IndentingNewLine]If[
              fe\[LeftDoubleBracket]\(-1\)\[RightDoubleBracket] === {} || 
                fe\[LeftDoubleBracket]\(-1\)\[RightDoubleBracket] === {{}}, 
              dm\[LeftDoubleBracket]\(-1\)\[RightDoubleBracket] = 
                dm\[LeftDoubleBracket]\(-1\)\[RightDoubleBracket] \(1 - m/2\)\
\/\(1 - m\)]; \[IndentingNewLine]dm, \[IndentingNewLine]m\ offD[gl, \(-kk\), 
                If[\(! rQ\), {1, nd - 1}, {2, 
                    nd}]]\ ]; \[IndentingNewLine]Switch[
          mo, \[IndentingNewLine]UMS, \[IndentingNewLine]ff = 
            MigrateExact[MakeDiploid[\[Psi]], m, 
              opts]; \[IndentingNewLine]wb = 
            Table[MeanW[ff\[LeftDoubleBracket]q\[RightDoubleBracket], W[q], 
                opts], {q, 
                Length[ff]}]; \[IndentingNewLine]trd[{\[Psi], \[Psi]}, 1, 
            True], \[IndentingNewLine]MUS, \[IndentingNewLine]\[Psi]m = 
            MigrateExact[\[Psi], m, opts]; \[IndentingNewLine]wb = 
            Table[MeanW[gm\[LeftDoubleBracket]q\[RightDoubleBracket], W[q], 
                opts], {q, 
                Length[gm]}]; \[IndentingNewLine]trd[{\[Psi], \[Psi]m}, 0, 
            True], \n\ \ \ \ \ \ \ \ \ \ USM, \[IndentingNewLine]\ 
          ff = MakeDiploid[\[Psi]]; \[IndentingNewLine]\[Psi]m = 
            Table[NewGametes[ff\[LeftDoubleBracket]q\[RightDoubleBracket], 
                W[q], opts], {q, Length[ff]}]; 
          wb = Table[
              MeanW[\[Psi]\[LeftDoubleBracket]q\[RightDoubleBracket], W[q], 
                opts], {q, 
                Length[g]}]; \[IndentingNewLine]trd[{\[Psi]m, \[Psi]}, 0, 
            False]]];\)\)



Options[StabilityKTable]={MigrationOrder\[Rule]UMS,FixedEnds\[Rule]{{},{}}};

StabilityKTable[k_,i_,h_,\[Psi]_SymmetricHaploidFrequencies,wt_List]:=
    StabilityKTable[k,i,h,\[Psi],\[Psi],wt];

\!\(\(StabilityKTable[k_, i_, 
        h_, \[Psi] : SymmetricHaploidFrequencies[g_List, nd_], \[Psi]\[Psi] : 
          SymmetricHaploidFrequencies[gg_List, ndnd_], wt_List] := 
      Module[{q, l = Quotient[i + k - h, 2], n = Length[g] - 1, mW, m, j, 
          ii}, \[IndentingNewLine]mW = 
          MarginalW[MakeDiploid[\[Psi]\[Psi]], SymmetricMeanW[n, wt]]; 
        Sum[gg\[LeftDoubleBracket]j + 
                  1\[RightDoubleBracket] \(2\^\(\(-i\) - j\)\) 
              Sum[\(4\^q\) Binomial[l, q] 
                    Binomial[n - i - k + l, j - q - k + l] 
                    wt\[LeftDoubleBracket]i + 1, j + 1, 
                      i + j - 2  q + 1\[RightDoubleBracket], {q, 
                    Max[0, i + j - n], Min[j - k + l, l]}]/
                Binomial[n, j], {j, k - l, 
              n - i + l}] - \(g\[LeftDoubleBracket]k + 1\[RightDoubleBracket] \
mW\[LeftDoubleBracket]i + 1\[RightDoubleBracket]\)\/Binomial[n, k]];\)\)

\!\(\(StabilityKTable[k_, i_, 
        h_, \[Psi] : {SymmetricHaploidFrequencies[_, _] .. }, wt_List, m_, 
        opts___Rule] := 
      Module[{ff, q, ww, nd = Length[\[Psi]], 
          n = Length[\[Psi]\[LeftDoubleBracket]1, 1\[RightDoubleBracket]] - 
              1, mW, wth, dma, dmb, dmc, wb, \[Psi]m, offD, trd, j, 
          fe = \(FixedEnds /. {opts}\) /. Options[StabilityKTable], 
          mo = \(MigrationOrder /. {opts}\) /. Options[StabilityKTable]}, 
        offD[{g1_, g2_}, j_, {q0_, q1_}] := \[IndentingNewLine]Table[\ 
            StabilityKTable[k, i, h, 
                g1\[LeftDoubleBracket]q\[RightDoubleBracket], 
                g2\[LeftDoubleBracket]q + j\[RightDoubleBracket], 
                wt\[LeftDoubleBracket]q\[RightDoubleBracket]]/
              wb\[LeftDoubleBracket]q\[RightDoubleBracket], {q, q0, q1}]; \ 
        trd[gl_, kk_, 
            rQ_] := \[IndentingNewLine]\((dma = 
              m\ offD[gl, kk, 
                  If[rQ, {1, nd - 1}, {2, nd}]]; \[IndentingNewLine]dmc = 
              m\ offD[gl, \(-kk\), 
                  If[\(! rQ\), {1, nd - 1}, {2, 
                      nd}]]; \[IndentingNewLine]dmb = 
              2 \((1 - m)\) offD[gl, 0, {1, nd}]; \[IndentingNewLine]If[
              fe\[LeftDoubleBracket]1\[RightDoubleBracket] === {} || 
                fe\[LeftDoubleBracket]1\[RightDoubleBracket] === {{}}, 
              dmb\[LeftDoubleBracket]1\[RightDoubleBracket] = 
                dmb\[LeftDoubleBracket]1\[RightDoubleBracket] \(1 - \
m/2\)\/\(1 - m\)]; \ 
            If[fe\[LeftDoubleBracket]\(-1\)\[RightDoubleBracket] === {} || 
                fe\[LeftDoubleBracket]\(-1\)\[RightDoubleBracket] === {{}}, 
              dmb\[LeftDoubleBracket]\(-1\)\[RightDoubleBracket] = 
                dmb\[LeftDoubleBracket]\(-1\)\[RightDoubleBracket] \(1 - \
m/2\)\/\(1 - m\)]; \[IndentingNewLine]TridiagonalMatrix[dma, dmb, 
              dmc])\); \[IndentingNewLine]wth = \(SymmetricMeanW[n, #] &\) /@ 
            wt; \[IndentingNewLine]Switch[
          mo, \[IndentingNewLine]UMS, \[IndentingNewLine]ff = 
            MigrateExact[MakeDiploid[\[Psi]], m, opts]; \[IndentingNewLine]\ 
          wb = Table[
              MeanW[ff\[LeftDoubleBracket]q\[RightDoubleBracket], 
                wth\[LeftDoubleBracket]q\[RightDoubleBracket]], {q, 
                Length[ff]}]; \ \ \[IndentingNewLine]trd[{\[Psi], \[Psi]}, 1, 
            
            True], \[IndentingNewLine]MUS, \ \ \ \ \[IndentingNewLine]\[Psi]m \
= MigrateExact[\[Psi], m, opts]; \[IndentingNewLine]ff = 
            MakeDiploid[\[Psi]m]; \[IndentingNewLine]wb = 
            Table[MeanW[ff\[LeftDoubleBracket]q\[RightDoubleBracket], 
                wth\[LeftDoubleBracket]q\[RightDoubleBracket]], {q, 
                Length[ff]}]; \[IndentingNewLine]trd[{\[Psi], \[Psi]m}, 0, 
            True], \ \[IndentingNewLine]\ 
          USM, \[IndentingNewLine]ff = 
            MakeDiploid[\[Psi]]; \ \ \[IndentingNewLine]\[Psi]m = 
            Table[NewGametes[ff\[LeftDoubleBracket]q\[RightDoubleBracket], 
                wth\[LeftDoubleBracket]q\[RightDoubleBracket], opts], {q, 
                Length[ff]}]; \ 
          wb = Table[
              MeanW[\[Psi]\[LeftDoubleBracket]q\[RightDoubleBracket], 
                wth\[LeftDoubleBracket]q\[RightDoubleBracket]], {q, 
                Length[g]}]; \[IndentingNewLine]trd[{\[Psi]m, \[Psi]}, 0, 
            False]]];\)\)



SigmaMatrix[a_,p_,n_]:=
		
    Module[{i,j},Table[SigmaMatrix[a,i,j,p,n],{i,p,n-p},{j,p,n-p}]];

\!\(\(SigmaMatrix[a_, i_, j_, p_, n_] := 
      Module[{r, k}, 
        Sum[a[i, j, i + j - 2  r] 
            Sum[\(\((\(-1\))\)\^k\) Binomial[p, k] Binomial[i - p, k + r - p] 
                Binomial[n - i - p, j - k - r], {k, 0, p}], {r, 
            Max[0, i + j - n], Min[i, j]}]];\)\)



ExactEigenvalues[a_,n_]:=Module[{sm},
		Table[
			sm=SigmaMatrix[a,p,n];
			If[TensorRank[sm]==4,
				Eigenvalues[BlockMatrix[sm]],
				Eigenvalues[sm]],{p,0,Floor[n/2]}]];



StabilityDirect[(pr:HaploidFrequencies|AlleleFrequencies)[\[Psi]_,nd_],W_,m_,
      opts___Rule]:=
    Module[{pn,n=Length[\[Psi]],gt,g},
      gt=Array[g,n+1];gn=Append[\[Psi],nd];
      pn=IterateExact[
          pr[Drop[gt,-1],gt\[LeftDoubleBracket]-1\[RightDoubleBracket]],W,m,
          opts];
      pn=Append[pn\[LeftDoubleBracket]1\[RightDoubleBracket],
          pn\[LeftDoubleBracket]2\[RightDoubleBracket]];
      Outer[D[#1,#2]&,pn,gt]/.g[j_]:>
          gn\[LeftDoubleBracket]j\[RightDoubleBracket]];

StabilityDirect[\[Psi]:{(pr:HaploidFrequencies|AlleleFrequencies)[_,_]..},W_,
      m_,opts___Rule]:=
    
    Module[{nd=Length[\[Psi]],
        ng=Length[\[Psi]\[LeftDoubleBracket]1,1\[RightDoubleBracket]],gn,g,d,
        j,ppn},
      gn=Table[pr[Array[g[d,#]&,ng],g[d,ng+1]],{d,nd}];
      ppn=
        IterateExact[gn,W,m,opts]/.pr[\[Phi]_,n_]\[RuleDelayed]
            Append[\[Phi],n];
      Transpose[
        Table[
          D[ppn,g[d,j]]/.g[dd_,jj_]\[RuleDelayed]
              If[jj>ng,\[Psi]\[LeftDoubleBracket]dd,
                  2\[RightDoubleBracket],\[Psi]\[LeftDoubleBracket]dd,1,
                  jj\[RightDoubleBracket]],{d,nd},{j,ng+1}],
        {4,2,3,1}]];





\!\(\(NmMLE[p_List, k_List] := 
      Module[{lnm, NmEst}, \[IndentingNewLine]NmEst = 
          Min[Max[0.1, 
              1/\((Variance[p]\/\(Mean[p] \((1 - Mean[p])\)\) - 
                    1\/Mean[k])\)], 10]; \[IndentingNewLine]Exp[
            lnm] /. \(FindMinimum[\(-logLikNm[p, k, Exp[lnm]]\), {lnm, 
                Log[NmEst]}]\)\[LeftDoubleBracket]2\[RightDoubleBracket]];\)\
\[IndentingNewLine]
  \(NmMLE[p_List, k_Integer] := NmMLE[p, Array[k &, Length[p]]];\)\)



\!\(\(logLikNm[p_, k_Integer, pb_, Nm_] := 
      Module[{j, kp = Round[k\ p], 
          kq = Round[
              k \((1 - 
                    p)\)]}, \[IndentingNewLine]\[Sum]\+\(j = 0\)\%\(kp - \
1\)Log[4  Nm\ pb + j] + \[Sum]\+\(j = 0\)\%\(kq - 1\)Log[
              4  Nm \((1 - pb)\) + j] - \((\[Sum]\+\(j = 0\)\%\(k - 1\)Log[
                4  Nm + j])\)];\)\[IndentingNewLine]
  \(logLikNm[p_List, k_List, 
        Nm_] := \[IndentingNewLine]Module[{pb = 
            p . k\/Plus @@ k}, \[IndentingNewLine]Plus @@ 
          MapThread[
            logLikNm[#1, #2, pb, Nm] &, {p, k}]];\)\[IndentingNewLine]
  \(logLikNm[p_List, k_Integer, Nm_] := 
      logLikNm[p, Array[k &, Length[p]], Nm];\)\)



End[];
On[General::spell1,General::spell];
EndPackage[];