(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      3897,        125]*)
(*NotebookOutlinePosition[      4950,        159]*)
(*  CellTagsIndexPosition[      4862,        153]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Setting up the packages", "SubsectionIcon",
  CellTags->"Setting up the packages"],

Cell[TextData[{
  "All ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " packages (also known as ",
  StyleBox["add-ons",
    FontSlant->"Italic"],
  ") are installed within the AddOns folder.  This includes a folder \
Applications, which contains all user-defined packages, and their \
documentation."
}], "Text"],

Cell["\<\
If you have no extra packages installed, just replace the empty \
Applications folder by this Applications folder.  \
\>", "Text"],

Cell["\<\
If there are already packages within the Applications folder,  add \
to its contents; clashes are possible, however.\
\>", "Text"],

Cell["\<\
The documentation can be seen via the Help Browser if the menu \
command Rebuild Help Index... is run; this need only be done once.\
\>", \
"Text"],

Cell[TextData[{
  "More information about installing new add-ons is found ",
  ButtonBox["below",
    ButtonData:>{"How the Help Browser works", None},
    ButtonStyle->"AddOnsLink"],
  ", and in the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " help browser, under ",
  ButtonBox["Working with add-ons",
    ButtonData:>{
      FrontEnd`FileName[ {
        ParentDirectory[ 
          ParentDirectory[ 
            ParentDirectory[ 
              ParentDirectory[ 
                ParentDirectory[ ]]]]], "Documentation", "English", "AddOns"},
         "InstallingPackages.nb", CharacterEncoding -> "MacintoshRoman"], 
      None},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[CellGroupData[{

Cell["Notes", "SubsubsectionIcon"],

Cell[TextData[{
  "The packages have a special structure, which should not be altered \
wantonly.  In particular:\n\t- hyperlinks should not be ",
  ButtonBox["pasted",
    ButtonData:>{"Bugs", "Pasting hyperlinks"},
    ButtonStyle->"AddOnsLink"],
  " between documentation notebooks in different folders\n\t- packages \
containing special notation must be ",
  ButtonBox["saved",
    ButtonData:>{"Bugs", "Special notation"},
    ButtonStyle->"AddOnsLink"],
  " using PackageSaver"
}], "Text",
  FontWeight->"Plain"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.0 for Macintosh",
ScreenRectangle->{{0, 1024}, {0, 748}},
WindowSize->{691, 618},
WindowMargins->{{-1, Automatic}, {18, Automatic}},
StyleDefinitions -> "HelpBrowser.nb",
MacintoshSystemPageSetup->"\<\
00<0001804P000000]P2:?oQon82n@960dL5:0?l0080001804P000000]P2:001
0000I00000400`<300000BL?00400@0000000000000006P801T1T00000000000
00000000000000000000000000000000\>"
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Setting up the packages"->{
    Cell[1739, 51, 88, 1, 36, "SubsectionIcon",
      CellTags->"Setting up the packages"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Setting up the packages", 4744, 146}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 88, 1, 36, "SubsectionIcon",
  CellTags->"Setting up the packages"],
Cell[1830, 54, 323, 10, 38, "Text"],
Cell[2156, 66, 140, 3, 22, "Text"],
Cell[2299, 71, 140, 3, 22, "Text"],
Cell[2442, 76, 157, 4, 22, "Text"],
Cell[2602, 82, 687, 20, 24, "Text"],

Cell[CellGroupData[{
Cell[3314, 106, 34, 0, 24, "SubsubsectionIcon"],
Cell[3351, 108, 518, 13, 66, "Text"]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

